package com.bea.lsd.avitek.ordermanagement;

/**
 * APLSession
 *
 * Remote interface for APLSessionBean
 *
 * @Author Jason Lee
 * $Id:$
 */

import java.rmi.RemoteException;
import javax.ejb.EJBObject;
import java.util.Collection;
import com.bea.lsd.avitek.ordermanagement.entities.APLShippingPartner;

public interface APLSession extends EJBObject {

    /*
     * Returns a Collection ofAPLShipment entities based on a tracking id.
     *
     * @param String aTracking
     * @return Collection APLShipments
     */
    public Collection getAPLShipments(String aTrackingId)
	throws RemoteException;

    /*
     * Returns a APLShipment entitiy based on a tracking id.
     *
     * @param String aTracking
     * @return Collection APLShipments
     */
    public APLShippingPartner getAPLShipment(String aTrackingId)
	throws RemoteException;

    /*
     * Returns a APLShipment entitiy based on a tracking id.
     *
     * @param Long aPrimaryKeyId
     * @return APLShippingPartner aAPLShipments
     */
    public APLShippingPartner getAPLShipmentById(Long aPKId)
	throws RemoteException;

} // APLSession
