package com.bea.lsd.avitek.ordermanagement;

/**
 * APLSessionBean
 *
 * This bean is the (loose) facade to the the APLShippingPartner entity bean. It returns
 * multiple APL shiments and single shipments based on primary key and tracking id.
 *
 * @Author Jason Lee
 * $Id: $
 */

import java.rmi.RemoteException;
import javax.ejb.*;
import java.util.*;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;
import com.bea.lsd.avitek.ordermanagement.entities.APLShippingPartner;
import com.bea.lsd.avitek.ordermanagement.entities.APLShippingPartnerBean;
import com.bea.lsd.avitek.ordermanagement.entities.APLShippingPartnerHome
;
public class APLSessionBean implements SessionBean {
    
    private SessionContext ctx;

    /*
     * Returns a Collection ofAPLShipment entities based on a tracking id.
     *
     * @param String aTracking
     * @return Collection APLShipments
     */
    public Collection getAPLShipments(String aTrackingId) throws RemoteException{
	
	try {

	    InitialContext ctx = new InitialContext();
	    
	    APLShippingPartnerHome home = (APLShippingPartnerHome)ctx.lookup("APLShippingPartnerBean");
	    Collection APLShipments = (Collection)home.findByTrackingId(aTrackingId);
	    
	    return APLShipments;
	    
	} catch(Exception e) {
	    System.out.println("Exception in getAPLShipments: " + e.getMessage());
	}
	
	return null;
	
    } // getAPLShipments

    /*
     * Returns a APLShipment entitiy based on a tracking id.
     *
     * @param String aTracking
     * @return Collection APLShipments
     */
    public APLShippingPartner getAPLShipment(String aTrackingId) throws RemoteException{
	
	try {

	    InitialContext ctx = new InitialContext();
	    
	    APLShippingPartnerHome home = (APLShippingPartnerHome)ctx.lookup("APLShippingPartnerBean");
	    APLShippingPartner APLShipment = (APLShippingPartner)home.findByTrackingId(aTrackingId);
	    
	    return APLShipment;
	    
	} catch(Exception e) {
	    System.out.println("Exception in getAPLShipment tracking id: " + e.getMessage());
	}
	
	return null;
	
    } // getAPLShipment


    /*
     * Returns a APLShipment entitiy based on a tracking id.
     *
     * @param Long aPrimaryKeyId
     * @return APLShippingPartner aAPLShipments
     */
    public APLShippingPartner getAPLShipmentById(Long aPKId) throws RemoteException{

	try {

	    InitialContext ctx = new InitialContext();
	    
	    APLShippingPartnerHome home = (APLShippingPartnerHome)ctx.lookup("APLShippingPartnerBean");
	    APLShippingPartner APLShipment = (APLShippingPartner)home.findByPrimaryKey(aPKId);
	    
	    return APLShipment;
	    
	} catch(Exception e) {
	    System.out.println("Exception in getAPLShipment pk: " + e.getMessage());
	}
	
	return null;

    } // getAPLShipment
    
    public void ejbActivate() {}
    
    public void ejbRemove() {}
    
    public void ejbPassivate() {}
    
    public void setSessionContext(SessionContext ctx) {this.ctx = ctx;}
    
    public void ejbCreate () throws CreateException { }

} // APLSessionBean








