package com.bea.lsd.avitek.ordermanagement;

/**
 * DHLSession
 *
 * Remote interface for DHLSessionBean
 *
 * @Author Jason Lee
 * $Id:$
 */

import java.rmi.RemoteException;
import javax.ejb.EJBObject;
import java.util.Collection;
import com.bea.lsd.avitek.ordermanagement.entities.DHLShippingPartner;

public interface DHLSession extends EJBObject {

    /*
     * Returns a Collection ofDHLShipment entities based on a tracking id.
     *
     * @param String aTracking
     * @return Collection DHLShipments
     */
    public Collection getDHLShipments(String aTrackingId)
	throws RemoteException;

    /*
     * Returns a DHLShipment entitiy based on a tracking id.
     *
     * @param String aTracking
     * @return Collection DHLShipments
     */
    public DHLShippingPartner getDHLShipment(String aTrackingId)
	throws RemoteException;

    /*
     * Returns a DHLShipment entitiy based on a tracking id.
     *
     * @param Long aPrimaryKeyId
     * @return DHLShippingPartner aDHLShipments
     */
    public DHLShippingPartner getDHLShipmentById(Long aPKId)
	throws RemoteException;

} // DHLSession
