package com.bea.lsd.avitek.ordermanagement;

/**
 * DHLSessionBean
 *
 * This bean is the (loose) facade to the the DHLShippingPartner entity bean. It returns
 * multiple DHL shiments and single shipments based on primary key and tracking id.
 *
 * @Author Jason Lee
 * $Id: $
 */

import java.rmi.RemoteException;
import javax.ejb.*;
import java.util.*;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;
import com.bea.lsd.avitek.ordermanagement.entities.DHLShippingPartner;
import com.bea.lsd.avitek.ordermanagement.entities.DHLShippingPartnerBean;
import com.bea.lsd.avitek.ordermanagement.entities.DHLShippingPartnerHome
;
public class DHLSessionBean implements SessionBean {
    
    private SessionContext ctx;

    /*
     * Returns a Collection ofDHLShipment entities based on a tracking id.
     *
     * @param String aTracking
     * @return Collection DHLShipments
     */
    public Collection getDHLShipments(String aTrackingId) throws RemoteException{
	
	try {

	    InitialContext ctx = new InitialContext();
	    
	    DHLShippingPartnerHome home = (DHLShippingPartnerHome)ctx.lookup("DHLShippingPartnerBean");
	    Collection DHLShipments = (Collection)home.findByTrackingId(aTrackingId);
	    
	    return DHLShipments;
	    
	} catch(Exception e) {
	    System.out.println("Exception in getDHLShipments: " + e.getMessage());
	}
	
	return null;
	
    } // getDHLShipments

    /*
     * Returns a DHLShipment entitiy based on a tracking id.
     *
     * @param String aTracking
     * @return Collection DHLShipments
     */
    public DHLShippingPartner getDHLShipment(String aTrackingId) throws RemoteException{
	
	try {

	    InitialContext ctx = new InitialContext();
	    
	    DHLShippingPartnerHome home = (DHLShippingPartnerHome)ctx.lookup("DHLShippingPartnerBean");
	    DHLShippingPartner DHLShipment = (DHLShippingPartner)home.findByTrackingId(aTrackingId);
	    
	    return DHLShipment;
	    
	} catch(Exception e) {
	    System.out.println("Exception in getDHLShipment tracking id: " + e.getMessage());
	}
	
	return null;
	
    } // getDHLShipment


    /*
     * Returns a DHLShipment entitiy based on a tracking id.
     *
     * @param Long aPrimaryKeyId
     * @return DHLShippingPartner aDHLShipments
     */
    public DHLShippingPartner getDHLShipmentById(Long aPKId) throws RemoteException{

	try {

	    InitialContext ctx = new InitialContext();
	    
	    DHLShippingPartnerHome home = (DHLShippingPartnerHome)ctx.lookup("DHLShippingPartnerBean");
	    DHLShippingPartner DHLShipment = (DHLShippingPartner)home.findByPrimaryKey(aPKId);
	    
	    return DHLShipment;
	    
	} catch(Exception e) {
	    System.out.println("Exception in getDHLShipment pk: " + e.getMessage());
	}
	
	return null;

    } // getDHLShipment
    
    public void ejbActivate() {}
    
    public void ejbRemove() {}
    
    public void ejbPassivate() {}
    
    public void setSessionContext(SessionContext ctx) {this.ctx = ctx;}
    
    public void ejbCreate () throws CreateException { }

} // DHLSessionBean








