package com.bea.lsd.avitek.ordermanagement;

/**
 * FedexSession
 *
 * Remote interface for FedexSessionBean
 *
 * @Author Jason Lee
 * $Id:$
 */

import java.rmi.RemoteException;
import javax.ejb.EJBObject;
import java.util.Collection;
import com.bea.lsd.avitek.ordermanagement.entities.FedexShippingPartner;

public interface FedexSession extends EJBObject {

    /*
     * Returns a Collection ofFedexShipment entities based on a tracking id.
     *
     * @param String aTracking
     * @return Collection fedexShipments
     */
    public Collection getFedexShipments(String aTrackingId)
	throws RemoteException;

    /*
     * Returns a FedexShipment entitiy based on a tracking id.
     *
     * @param String aTracking
     * @return Collection fedexShipments
     */
    public FedexShippingPartner getFedexShipment(String aTrackingId)
	throws RemoteException;

    /*
     * Returns a FedexShipment entitiy based on a tracking id.
     *
     * @param Long aPrimaryKeyId
     * @return FedexShippingPartner aFedexShipments
     */
    public FedexShippingPartner getFedexShipmentById(Long aPKId)
	throws RemoteException;

} // FedexSession
