package com.bea.lsd.avitek.ordermanagement;

/**
 * MrpSessionBean
 *
 * This bean is the (loose) facade to the the Mrp entity bean. It returns
 * multiple Mrp items and single items based on primary key.
 *
 * @Author Jason Lee
 * $Id: $
 */

import java.rmi.RemoteException;
import javax.ejb.*;
import java.util.*;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;
import com.bea.lsd.avitek.ordermanagement.entities.Mrp;
import com.bea.lsd.avitek.ordermanagement.entities.MrpBean;
import com.bea.lsd.avitek.ordermanagement.entities.MrpHome;

public class MrpSessionBean implements SessionBean {
    
    private SessionContext ctx;

    /*
     * Returns a Collection of Mrp entities.
     *
     * @return Collection of Mrp entities
     */
    public Collection getMrpAll() throws RemoteException {
	
	try {

	    InitialContext ctx = new InitialContext();
	    
	    MrpHome home = (MrpHome)ctx.lookup("MrpBean");
	    Collection mrps = (Collection)home.findAll();
	    
	    return mrps;
	    
	} catch(Exception e) {
	    System.out.println("Exception in getMrpAll: " + e.getMessage());
	}
	
	return null;
	
    } // getMrpAll


    /*
     * Returns a Mrp entitiy based on a primary key id.
     *
     * @param Long aPrimaryKeyId
     * @return Mrp aMrp
     */
    public Mrp getMrpByPKId(Long aPKId) throws RemoteException {

	try {

	    InitialContext ctx = new InitialContext();
	    
	    MrpHome home = (MrpHome)ctx.lookup("MrpBean");
	    Mrp mrp = (Mrp)home.findByPrimaryKey(aPKId);
	    
	    return mrp;
	    
	} catch(Exception e) {
	    System.out.println("Exception in getMrpByPKId: " + e.getMessage());
	}
	
	return null;
	
    } // getMrpShipment

    public void ejbActivate() {}
    
    public void ejbRemove() {}
    
    public void ejbPassivate() {}
    
    public void setSessionContext(SessionContext ctx) {this.ctx = ctx;}
    
    public void ejbCreate () throws CreateException { }

} // MrpSessionBean








