package com.bea.lsd.avitek.ordermanagement;

/**
 * OrderSession
 *
 * Remote interface for OrderSessionBean
 *
 * @Author Jason Lee
 * $Id:$
 */

import java.rmi.RemoteException;
import javax.ejb.EJBObject;
import java.util.Collection;
import com.bea.lsd.avitek.ordermanagement.entities.Order;

public interface OrderSession extends EJBObject {

    /*
     * Returns a Collection of Order entities.
     *
     * @return Collection of Order entities
     */
    public Collection getOrderAll()
	throws RemoteException;

    /*
     * Returns a Order entitiy based on a primary key id.
     *
     * @param Long aPrimaryKeyId
     * @return Order aOrder
     */
    public Order getOrderByPKId(Long aPKId)
	throws RemoteException;

    /*
     * Returns a Order entitiy based on a sku.
     *
     * @param String aSku
     * @return Order aOrder
     */
    public Order getOrderBySku(String aSku)
	throws RemoteException;

    /*
     * Returns a Order entity based on a carrier id.
     *
     * @param String aCarrier (APL, DHL, FEDEX, UPS, USPS)
     * @return Order aOrder
     */
    public Order getOrderByCarrier(String aCarrier)
	throws RemoteException;

    /*
     * Returns a Collection of Order entities based on a tracking id.
     *
     * @param String aTrackingId
     * @return Order aOrder
     */
    public Order getOrderByTrackingId(String aTrackingId)
	throws RemoteException;

} // OrderSession
