package com.bea.lsd.avitek.ordermanagement;

/**
 * ProductInventorySession
 *
 * Remote interface for ProductInventorySessionBean
 *
 * @Author Jason Lee
 * $Id:$
 */

import java.rmi.RemoteException;
import javax.ejb.EJBObject;
import java.util.Collection;
import com.bea.lsd.avitek.ordermanagement.entities.ProductInventory;

public interface ProductInventorySession extends EJBObject {

    /*
     * Returns a Collection of ProductInventory entities.
     *
     * @return Collection of ProductInventory entities
     */
    public Collection getProductInventoryAll()
	throws RemoteException;

    /*
     * Returns a ProductInventory entitiy based on a primary key id.
     *
     * @param Long aPrimaryKeyId
     * @return ProductInventory aProductInventory
     */
    public ProductInventory getProductInventoryByPKId(Long aPKId)
	throws RemoteException;

    /*
     * Returns a ProductInventory entitiy based on a primary key id.
     *
     * @param String aSku
     * @return ProductInventory aProductInventory
     */
    public ProductInventory getProductInventoryBySku(String aSku)
	throws RemoteException;

} // MRPSession
