package com.bea.lsd.avitek.ordermanagement;

/**
 * ProductInventorySessionBean
 *
 * This bean is the (loose) facade to the the ProductInventory entity bean. It returns
 * multiple ProductInventory items and single items based on primary key.
 *
 * @Author Jason Lee
 * $Id: $
 */

import java.rmi.RemoteException;
import javax.ejb.*;
import java.util.*;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;
import com.bea.lsd.avitek.ordermanagement.entities.ProductInventory;
import com.bea.lsd.avitek.ordermanagement.entities.ProductInventoryBean;
import com.bea.lsd.avitek.ordermanagement.entities.ProductInventoryHome;

public class ProductInventorySessionBean implements SessionBean {
    
    private SessionContext ctx;

    /*
     * Returns a Collection of ProductInventory entities.
     *
     * @return Collection of ProductInventory entities
     */
    public Collection getProductInventoryAll() throws RemoteException {
	
	try {

	    InitialContext ctx = new InitialContext();
	    
	    ProductInventoryHome home = (ProductInventoryHome)ctx.lookup("ProductInventoryBean");
	    Collection ProductInventories = (Collection)home.findAll();
	    
	    return ProductInventories;
	    
	} catch(Exception e) {
	    System.out.println("Exception in getProductInventoryAll: " + e.getMessage());
	}
	
	return null;
	
    } // getProductInventoryAll


    /*
     * Returns a ProductInventory entitiy based on a primary key id.
     *
     * @param Long aPrimaryKeyId
     * @return ProductInventory aProductInventory
     */
    public ProductInventory getProductInventoryByPKId(Long aPKId) throws RemoteException {

	try {

	    InitialContext ctx = new InitialContext();
	    
	    ProductInventoryHome home = (ProductInventoryHome)ctx.lookup("ProductInventoryBean");
	    ProductInventory productInventory = (ProductInventory)home.findByPrimaryKey(aPKId);
	    
	    return productInventory;
	    
	} catch(Exception e) {
	    System.out.println("Exception in getProductInventoryByPKId: " + e.getMessage());
	}
	
	return null;
	
    } // getProductInventoryShipment

    /*
     * Returns a ProductInventory entitiy based on a primary key id.
     *
     * @param String aSku
     * @return ProductInventory aProductInventory
     */
    public ProductInventory getProductInventoryBySku(String aSku) throws RemoteException {

	try {

	    InitialContext ctx = new InitialContext();
	    
	    ProductInventoryHome home = (ProductInventoryHome)ctx.lookup("ProductInventoryBean");
	    ProductInventory productInventory = (ProductInventory)home.findBySku(aSku);
	    
	    return productInventory;
	    
	} catch(Exception e) {
	    System.out.println("Exception in getProductInventoryBySku: " + e.getMessage());
	}
	
	return null;
	
    } // getProductInventoryBySku

    public void ejbActivate() {}
    
    public void ejbRemove() {}
    
    public void ejbPassivate() {}
    
    public void setSessionContext(SessionContext ctx) {this.ctx = ctx;}
    
    public void ejbCreate () throws CreateException { }

} // ProductInventorySessionBean








