package com.bea.lsd.avitek.ordermanagement;

/**
 * ShippingHistorySession
 *
 * Remote interface for ShippingHistorySessionBean
 *
 * @Author Jason Lee
 * $Id:$
 */

import java.rmi.RemoteException;
import javax.ejb.EJBObject;
import java.util.Collection;
import com.bea.lsd.avitek.ordermanagement.entities.ShippingHistory;

public interface ShippingHistorySession extends EJBObject {

    /*
     * Returns a Collection of ShippingHistory entities.
     *
     * @return Collection of ShippingHistory entities
     */
    public Collection getShippingHistoryAll()
	throws RemoteException;

    /*
     * Returns a Collection of ShippingHistory entities based on carrierId.
     *
     * @return Collection of ShippingHistory entities
     */
    public Collection getShippingHistoryByCarrierId(String aCarrierId)
	throws RemoteException;

    /*
     * Returns a ShippingHistory entitiy based on a primary key id.
     *
     * @param Long aPrimaryKeyId
     * @return ShippingHistory aShippingHistory
     */
    public ShippingHistory getShippingHistoryByPKId(Long aPKId)
	throws RemoteException;

} // ShippingHistorySession
