package com.bea.lsd.avitek.ordermanagement;

/**
 * ShippingHistorySessionBean
 *
 * This bean is the (loose) facade to the the ShippingHistory entity bean. It returns
 * multiple ShippingHistory items and single items based on primary key.
 *
 * @Author Jason Lee
 * $Id: $
 */

import java.rmi.RemoteException;
import javax.ejb.*;
import java.util.*;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;
import com.bea.lsd.avitek.ordermanagement.entities.ShippingHistory;
import com.bea.lsd.avitek.ordermanagement.entities.ShippingHistoryBean;
import com.bea.lsd.avitek.ordermanagement.entities.ShippingHistoryHome;

public class ShippingHistorySessionBean implements SessionBean {
    
    private SessionContext ctx;

    /*
     * Returns a Collection of ShippingHistory entities.
     *
     * @return Collection of ShippingHistory entities
     */
    public Collection getShippingHistoryAll() throws RemoteException {
	
	try {

	    InitialContext ctx = new InitialContext();
	    
	    ShippingHistoryHome home = (ShippingHistoryHome)ctx.lookup("ShippingHistoryBean");
	    Collection histories = (Collection)home.findAll();
	    
	    return histories;
	    
	} catch(Exception e) {
	    System.out.println("Exception in getShippingHistoryAll: " + e.getMessage());
	}
	
	return null;
	
    } // getShippingHistoryAll

    /*
     * Returns a Collection of ShippingHistory entities based on carrierId.
     *
     * @return Collection of ShippingHistory entities
     */
    public Collection getShippingHistoryByCarrierId(String aCarrierId) throws RemoteException {
	
	try {

	    InitialContext ctx = new InitialContext();
	    
	    ShippingHistoryHome home = (ShippingHistoryHome)ctx.lookup("ShippingHistoryBean");
	    Collection histories = (Collection)home.findByCarrierId(aCarrierId);
	    
	    return histories;
	    
	} catch(Exception e) {
	    System.out.println("Exception in getShippingHistoryAll: " + e.getMessage());
	}
	
	return null;
	
    } // getShippingHistoryAll

    /*
     * Returns a ShippingHistory entitiy based on a primary key id.
     *
     * @param Long aPrimaryKeyId
     * @return ShippingHistory aShippingHistory
     */
    public ShippingHistory getShippingHistoryByPKId(Long aPKId) throws RemoteException {

	try {

	    InitialContext ctx = new InitialContext();
	    
	    ShippingHistoryHome home = (ShippingHistoryHome)ctx.lookup("ShippingHistoryBean");
	    ShippingHistory history = (ShippingHistory)home.findByPrimaryKey(aPKId);
	    
	    return history;
	    
	} catch(Exception e) {
	    System.out.println("Exception in getShippingHistoryByPKId: " + e.getMessage());
	}
	
	return null;
	
    } // getShippingHistoryShipment

    public void ejbActivate() {}
    
    public void ejbRemove() {}
    
    public void ejbPassivate() {}
    
    public void setSessionContext(SessionContext ctx) {this.ctx = ctx;}
    
    public void ejbCreate () throws CreateException { }

} // ShippingHistorySessionBean








