package com.bea.lsd.avitek.ordermanagement;

/**
 * ShippingLocationSessionBean
 *
 * This bean is the (loose) facade to the the ShippingLocation entity bean. It returns
 * multiple ShippingLocation items and single items based on primary key.
 *
 * @Author Jason Lee
 * $Id: $
 */

import java.rmi.RemoteException;
import javax.ejb.*;
import java.util.*;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;
import com.bea.lsd.avitek.ordermanagement.entities.ShippingLocation;
import com.bea.lsd.avitek.ordermanagement.entities.ShippingLocationBean;
import com.bea.lsd.avitek.ordermanagement.entities.ShippingLocationHome;

public class ShippingLocationSessionBean implements SessionBean {
    
    private SessionContext ctx;

    /*
     * Returns a Collection of ShippingLocation entities.
     *
     * @return Collection of ShippingLocation entities
     */
    public Collection getShippingLocationAll() throws RemoteException {
	
	try {

	    InitialContext ctx = new InitialContext();
	    
	    ShippingLocationHome home = (ShippingLocationHome)ctx.lookup("ShippingLocationBean");
	    Collection histories = (Collection)home.findAll();
	    
	    return histories;
	    
	} catch(Exception e) {
	    System.out.println("Exception in getShippingLocationAll: " + e.getMessage());
	}
	
	return null;
	
    } // getShippingLocationAll


    /*
     * Returns a ShippingLocation entitiy based on a primary key id.
     *
     * @param Long aPrimaryKeyId
     * @return ShippingLocation aShippingLocation
     */
    public ShippingLocation getShippingLocationByPKId(Long aPKId) throws RemoteException {

	try {

	    InitialContext ctx = new InitialContext();
	    
	    ShippingLocationHome home = (ShippingLocationHome)ctx.lookup("ShippingLocationBean");
	    ShippingLocation history = (ShippingLocation)home.findByPrimaryKey(aPKId);
	    
	    return history;
	    
	} catch(Exception e) {
	    System.out.println("Exception in getShippingLocationByPKId: " + e.getMessage());
	}
	
	return null;
	
    } // getShippingLocationShipment

    public void ejbActivate() {}
    
    public void ejbRemove() {}
    
    public void ejbPassivate() {}
    
    public void setSessionContext(SessionContext ctx) {this.ctx = ctx;}
    
    public void ejbCreate () throws CreateException { }

} // ShippingLocationSessionBean








