package com.bea.lsd.avitek.ordermanagement;

/**
 * UPSSession
 *
 * Remote interface for UPSSessionBean
 *
 * @Author Jason Lee
 * $Id:$
 */

import java.rmi.RemoteException;
import javax.ejb.EJBObject;
import java.util.Collection;
import com.bea.lsd.avitek.ordermanagement.entities.UPSShippingPartner;

public interface UPSSession extends EJBObject {

    /*
     * Returns a Collection ofUPSShipment entities based on a tracking id.
     *
     * @param String aTracking
     * @return Collection UPSShipments
     */
    public Collection getUPSShipments(String aTrackingId)
	throws RemoteException;

    /*
     * Returns a UPSShipment entitiy based on a tracking id.
     *
     * @param String aTracking
     * @return Collection UPSShipments
     */
    public UPSShippingPartner getUPSShipment(String aTrackingId)
	throws RemoteException;

    /*
     * Returns a UPSShipment entitiy based on a tracking id.
     *
     * @param Long aPrimaryKeyId
     * @return UPSShippingPartner aUPSShipments
     */
    public UPSShippingPartner getUPSShipmentById(Long aPKId)
	throws RemoteException;

} // UPSSession
