package com.bea.lsd.avitek.ordermanagement;

/**
 * UPSSessionBean
 *
 * This bean is the (loose) facade to the the UPSShippingPartner entity bean. It returns
 * multiple UPS shiments and single shipments based on primary key and tracking id.
 *
 * @Author Jason Lee
 * $Id: $
 */

import java.rmi.RemoteException;
import javax.ejb.*;
import java.util.*;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;
import com.bea.lsd.avitek.ordermanagement.entities.UPSShippingPartner;
import com.bea.lsd.avitek.ordermanagement.entities.UPSShippingPartnerBean;
import com.bea.lsd.avitek.ordermanagement.entities.UPSShippingPartnerHome
;
public class UPSSessionBean implements SessionBean {
    
    private SessionContext ctx;

    /*
     * Returns a Collection ofUPSShipment entities based on a tracking id.
     *
     * @param String aTracking
     * @return Collection UPSShipments
     */
    public Collection getUPSShipments(String aTrackingId) throws RemoteException{
	
	try {

	    InitialContext ctx = new InitialContext();
	    
	    UPSShippingPartnerHome home = (UPSShippingPartnerHome)ctx.lookup("UPSShippingPartnerBean");
	    Collection UPSShipments = (Collection)home.findByTrackingId(aTrackingId);
	    
	    return UPSShipments;
	    
	} catch(Exception e) {
	    System.out.println("Exception in getUPSShipments: " + e.getMessage());
	}
	
	return null;
	
    } // getUPSShipments

    /*
     * Returns a UPSShipment entitiy based on a tracking id.
     *
     * @param String aTracking
     * @return Collection UPSShipments
     */
    public UPSShippingPartner getUPSShipment(String aTrackingId) throws RemoteException{
	
	try {

	    InitialContext ctx = new InitialContext();
	    
	    UPSShippingPartnerHome home = (UPSShippingPartnerHome)ctx.lookup("UPSShippingPartnerBean");
	    UPSShippingPartner UPSShipment = (UPSShippingPartner)home.findByTrackingId(aTrackingId);
	    
	    return UPSShipment;
	    
	} catch(Exception e) {
	    System.out.println("Exception in getUPSShipment tracking id: " + e.getMessage());
	}
	
	return null;
	
    } // getUPSShipment


    /*
     * Returns a UPSShipment entitiy based on a tracking id.
     *
     * @param Long aPrimaryKeyId
     * @return UPSShippingPartner aUPSShipments
     */
    public UPSShippingPartner getUPSShipmentById(Long aPKId) throws RemoteException{

	try {

	    InitialContext ctx = new InitialContext();
	    
	    UPSShippingPartnerHome home = (UPSShippingPartnerHome)ctx.lookup("UPSShippingPartnerBean");
	    UPSShippingPartner UPSShipment = (UPSShippingPartner)home.findByPrimaryKey(aPKId);
	    
	    return UPSShipment;
	    
	} catch(Exception e) {
	    System.out.println("Exception in getUPSShipment pk: " + e.getMessage());
	}
	
	return null;

    } // getUPSShipment
    
    public void ejbActivate() {}
    
    public void ejbRemove() {}
    
    public void ejbPassivate() {}
    
    public void setSessionContext(SessionContext ctx) {this.ctx = ctx;}
    
    public void ejbCreate () throws CreateException { }

} // UPSSessionBean








