package com.bea.lsd.avitek.ordermanagement;

/**
 * USPSSession
 *
 * Remote interface for USPSSessionBean
 *
 * @Author Jason Lee
 * $Id:$
 */

import java.rmi.RemoteException;
import javax.ejb.EJBObject;
import java.util.Collection;
import com.bea.lsd.avitek.ordermanagement.entities.USPSShippingPartner;

public interface USPSSession extends EJBObject {

    /*
     * Returns a Collection ofUSPSShipment entities based on a tracking id.
     *
     * @param String aTracking
     * @return Collection USPSShipments
     */
    public Collection getUSPSShipments(String aTrackingId)
	throws RemoteException;

    /*
     * Returns a USPSShipment entitiy based on a tracking id.
     *
     * @param String aTracking
     * @return Collection USPSShipments
     */
    public USPSShippingPartner getUSPSShipment(String aTrackingId)
	throws RemoteException;

    /*
     * Returns a USPSShipment entitiy based on a tracking id.
     *
     * @param Long aPrimaryKeyId
     * @return USPSShippingPartner aUSPSShipments
     */
    public USPSShippingPartner getUSPSShipmentById(Long aPKId)
	throws RemoteException;

} // USPSSession
