package com.bea.lsd.avitek.ordermanagement;

/**
 * USPSSessionBean
 *
 * This bean is the (loose) facade to the the USPSShippingPartner entity bean. It returns
 * multiple USPS shiments and single shipments based on primary key and tracking id.
 *
 * @Author Jason Lee
 * $Id: $
 */

import java.rmi.RemoteException;
import javax.ejb.*;
import java.util.*;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;
import com.bea.lsd.avitek.ordermanagement.entities.USPSShippingPartner;
import com.bea.lsd.avitek.ordermanagement.entities.USPSShippingPartnerBean;
import com.bea.lsd.avitek.ordermanagement.entities.USPSShippingPartnerHome
;
public class USPSSessionBean implements SessionBean {
    
    private SessionContext ctx;

    /*
     * Returns a Collection ofUSPSShipment entities based on a tracking id.
     *
     * @param String aTracking
     * @return Collection USPSShipments
     */
    public Collection getUSPSShipments(String aTrackingId) throws RemoteException{
	
	try {

	    InitialContext ctx = new InitialContext();
	    
	    USPSShippingPartnerHome home = (USPSShippingPartnerHome)ctx.lookup("USPSShippingPartnerBean");
	    Collection USPSShipments = (Collection)home.findByTrackingId(aTrackingId);
	    
	    return USPSShipments;
	    
	} catch(Exception e) {
	    System.out.println("Exception in getUSPSShipments: " + e.getMessage());
	}
	
	return null;
	
    } // getUSPSShipments

    /*
     * Returns a USPSShipment entitiy based on a tracking id.
     *
     * @param String aTracking
     * @return Collection USPSShipments
     */
    public USPSShippingPartner getUSPSShipment(String aTrackingId) throws RemoteException{
	
	try {

	    InitialContext ctx = new InitialContext();
	    
	    USPSShippingPartnerHome home = (USPSShippingPartnerHome)ctx.lookup("USPSShippingPartnerBean");
	    USPSShippingPartner USPSShipment = (USPSShippingPartner)home.findByTrackingId(aTrackingId);
	    
	    return USPSShipment;
	    
	} catch(Exception e) {
	    System.out.println("Exception in getUSPSShipment tracking id: " + e.getMessage());
	}
	
	return null;
	
    } // getUSPSShipment


    /*
     * Returns a USPSShipment entitiy based on a tracking id.
     *
     * @param Long aPrimaryKeyId
     * @return USPSShippingPartner aUSPSShipments
     */
    public USPSShippingPartner getUSPSShipmentById(Long aPKId) throws RemoteException{

	try {

	    InitialContext ctx = new InitialContext();
	    
	    USPSShippingPartnerHome home = (USPSShippingPartnerHome)ctx.lookup("USPSShippingPartnerBean");
	    USPSShippingPartner USPSShipment = (USPSShippingPartner)home.findByPrimaryKey(aPKId);
	    
	    return USPSShipment;
	    
	} catch(Exception e) {
	    System.out.println("Exception in getUSPSShipment pk: " + e.getMessage());
	}
	
	return null;

    } // getUSPSShipment
    
    public void ejbActivate() {}
    
    public void ejbRemove() {}
    
    public void ejbPassivate() {}
    
    public void setSessionContext(SessionContext ctx) {this.ctx = ctx;}
    
    public void ejbCreate () throws CreateException { }

} // USPSSessionBean








