package com.bea.lsd.avitek.ordermanagement.entities;

/*
 * APLShippingPartnerHome
 *
 * Home interface for the APL shipping partner.
 *
 * @Author Jason Lee
 */

import java.util.Collection;
import java.rmi.RemoteException;
import javax.ejb.CreateException;
import javax.ejb.FinderException;
import javax.ejb.EJBHome;

public interface APLShippingPartnerHome extends EJBHome {

    /*
     * The bean create method.
     *
     */
    public APLShippingPartner create() throws CreateException, RemoteException;

    /*
     * Returns a ShippingPartner object based on a the matching primary key.
     *
     * @param Long aKey
     * @return ShippingPArtner aShippingPartner
     *
     */
    public APLShippingPartner findByPrimaryKey(Long aKey) throws FinderException, RemoteException;

    /*
     * Returns a ShippingPartner object based on a the matching TrackingId.
     *
     * @param String aTrackingId
     * @return APLShippingPartner aAPLShippingPartner
     *
     */
    public APLShippingPartner findByTrackingId(String aTrackingId) throws FinderException, RemoteException;

    /*
     * Returns all the APL shipping partner items
     *
     * @return Collection aAPLShippingPartners
     *
     */

    public Collection findAll() throws FinderException, RemoteException;    

} // APLShippingPartnerHome
