package com.bea.lsd.avitek.ordermanagement.entities;

/**
 * DHLShippingPartnerBean
 *
 * The bean implementation for the DHL shipping partner.
 *
 * @Author Jason Lee
 *
 */

import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import java.rmi.RemoteException;
import javax.ejb.FinderException;

public abstract class DHLShippingPartnerBean implements EntityBean {

    private EntityContext ctx;

    public abstract Long getId();
    public abstract void setId(Long aId) throws RemoteException;

    public abstract String getTrackingId();
    public abstract void   setTrackingId(String aTrackingId) throws RemoteException;

    public abstract String getArrivalTime();
    public abstract void   setArrivalTime(String aArrivalTime) throws RemoteException;

    public abstract int  getQuantityShipping();
    public abstract void setQuantityShipping(int aQty) throws RemoteException;

    public abstract String getShippingMethod();
    public abstract void   setShippingMethod(String aShippingMethod) throws RemoteException;
    
    public abstract String getServiceRep();
    public abstract void   setServiceRep(String aServiceRep) throws RemoteException;

    public abstract String getRepMessage ();
    public abstract void   setRepMessage (String aMessage) throws RemoteException;

    public abstract String getRepPhone();
    public abstract void   setRepPhone (String aPhone) throws RemoteException;

    /*
     * Sets the entity context
     * 
     * @param EntityContext aCtx
     */
    public void setEntityContext(EntityContext aCtx){
	ctx = aCtx;
    }

    /* Unsets the entity context */
    public void unsetEntityContext(){
	ctx = null;
    }

    public Long ejbCreate(){
	return null;
    }

    public void ejbPostCreate() {}

    public void ejbRemove(){}
    public void ejbLoad(){}
    public void ejbStore(){}
    public void ejbActivate(){}
    public void ejbPassivate(){}

} // DHLShippingPartnerBean
