package com.bea.lsd.avitek.ordermanagement.entities;

/*
 * DHLShippingPartnerHome
 *
 * Home interface for the DHL shipping partner.
 *
 * @Author Jason Lee
 */

import java.util.Collection;
import java.rmi.RemoteException;
import javax.ejb.CreateException;
import javax.ejb.FinderException;
import javax.ejb.EJBHome;

public interface DHLShippingPartnerHome extends EJBHome {

    /*
     * The bean create method.
     *
     */
    public DHLShippingPartner create() throws CreateException, RemoteException;

    /*
     * Returns a ShippingPartner object based on a the matching primary key.
     *
     * @param Long aKey
     * @return ShippingPArtner aShippingPartner
     *
     */
    public DHLShippingPartner findByPrimaryKey(Long aKey) throws FinderException, RemoteException;

    /*
     * Returns a ShippingPartner object based on a the matching TrackingId.
     *
     * @param String aTrackingId
     * @return DHLShippingPartner aDHLShippingPartner
     *
     */
    public DHLShippingPartner findByTrackingId(String aTrackingId) throws FinderException, RemoteException;

    /*
     * Returns all the DHL shipping partner items
     *
     * @return Collection aDHLShippingPartners
     *
     */

    public Collection findAll() throws FinderException, RemoteException;    

} // DHLShippingPartnerHome
