package com.bea.lsd.avitek.ordermanagement.entities;

/*
 * FedexShippingPartnerHome
 *
 * Home interface for the Fedex shipping partner.
 *
 * @Author Jason Lee
 */

import java.util.Collection;
import java.rmi.RemoteException;
import javax.ejb.CreateException;
import javax.ejb.FinderException;
import javax.ejb.EJBHome;

public interface FedexShippingPartnerHome extends EJBHome {

    /*
     * The bean create method.
     *
     */
    public FedexShippingPartner create() throws CreateException, RemoteException;

    /*
     * Returns a ShippingPartner object based on a the matching primary key.
     *
     * @param Long aKey
     * @return ShippingPArtner aShippingPartner
     *
     */
    public FedexShippingPartner findByPrimaryKey(Long aKey) throws FinderException, RemoteException;

    /*
     * Returns a ShippingPartner object based on a the matching TrackingId.
     *
     * @param String aTrackingId
     * @return FedexShippingPartner aFedexShippingPartner
     *
     */
    public FedexShippingPartner findByTrackingId(String aTrackingId) throws FinderException, RemoteException;

    /*
     * Returns all the Fedex shipping partner items
     *
     * @return Collection aFedexShippingPartners
     *
     */

    public Collection findAll() throws FinderException, RemoteException;    

} // FedexShippingPartnerHome
