package com.bea.lsd.avitek.ordermanagement.entities;

/*
 * MrpBean
 *
 * Entity bean representing the Mrp table for the lsd use case 2.
 *
 * @Author Jason Lee
 * $id:$
 */

import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import java.rmi.RemoteException;
import javax.ejb.CreateException;
import javax.ejb.FinderException;

public abstract class MrpBean implements EntityBean {

    private EntityContext ctx;

    /*
     * Returns the id for object/db field
     *
     * @return Long anId
     */
    public abstract Long getId();

    /*
     * Sets the id for object/db field
     *
     * @param Long anId
     */
    public abstract void setId(Long aId) throws RemoteException;

    /*
     * Returns the lotNumber for object/db field
     *
     * @return String aLotNumber
     */
    public abstract String getLotNumber();

    /*
     * Sets the lotNumber for object/db field
     *
     * @param String aLotNumber
     */
    public abstract void setLotNumber(String aLotNumber) throws RemoteException;

    /*
     * Returns the status for object/db field
     *
     * @return String aStatus
     */
    public abstract String getStatus();

    /*
     * Sets the status for object/db field
     *
     * @param String aStatus
     */
    public abstract void setStatus(String aStatus) throws RemoteException;

    /*
     * Returns the quantity for object/db field
     *
     * @return int anQuantity
     */
    public abstract int getQuantity();

    /*
     * Sets the quantity for object/db field
     *
     * @param int anQuantity
     */
    public abstract void setQuantity(int aQuantity) throws RemoteException;


    /*
     * Sets the entity context
     * 
     * @param EntityContext aCtx
     */
    public void setEntityContext(EntityContext aCtx){
	ctx = aCtx;
    }

    /* Unsets the entity context */
    public void unsetEntityContext(){
	ctx = null;
    }

    /* 
     * Creates a bean with the corresponding db table passed in values 
     *
     * @param String aLotNumber
     * @param String aStatus
     * @param int    aQuantity
     */
    public Long ejbCreate(String aLotNumber, String aStatus, int aQuantity)
	throws RemoteException, CreateException {

	setLotNumber(aLotNumber);
	setStatus(aStatus);
	setQuantity(aQuantity);

	return null;

    }

    /* Post create method. Required. */
    public void ejbPostCreate(String aLotNumber, String aStatus, int aQuantity)
	throws RemoteException {}

    public void ejbRemove(){}
    public void ejbLoad(){}
    public void ejbStore(){}
    public void ejbActivate(){}
    public void ejbPassivate(){}

} // MrpBean
