package com.bea.lsd.avitek.ordermanagement.entities;

/*
 * MrpHome
 *
 * Home interface of the MrpBean
 *
 * @Author Jason Lee
 * $id:$
 */

import java.util.Collection;
import java.rmi.RemoteException; 
import javax.ejb.EJBHome; 
import javax.ejb.CreateException; 
import javax.ejb.FinderException; 

public interface MrpHome extends EJBHome {

    /* 
     * Creates a bean with the corresponding db table passed in values 
     *
     * @param String aLotNumber
     * @param String aStatus
     * @param int    aQty
     * @return Mrp aMrp
     */
    public Mrp create(String aLotNumber, String aStatus, int aQty)
	throws CreateException, RemoteException;

    /*
     * Returns a Mrp object based on a the primary key supplied.
     *
     * @param Long aPrimaryKey
     * @return Mrp aMrp
     *
     */
    public Mrp findByPrimaryKey(Long id) throws FinderException, RemoteException;
    
    /*
     * Returns a Collection of all Mrp objects.
     *
     * @return Collection of all Mrp objects
     *
     */
    public Collection findAll() throws FinderException, RemoteException;


} // MrpHome
