package com.bea.lsd.avitek.ordermanagement.entities;

/*
 * OrderBean
 *
 * Entity bean representing the Order table for the lsd use case 2.
 *
 * @Author Jason Lee
 * $id:$
 */

import java.util.Collection;
import java.rmi.RemoteException;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.CreateException;
import javax.ejb.FinderException;

public abstract class OrderBean implements EntityBean {

    private EntityContext ctx;

    /*
     * Returns the id for object/db field
     *
     * @return Long anId
     */
    public abstract Long getId();

    /*
     * Sets the id for object/db field
     *
     * @param Long anId
     */
    public abstract void setId(Long aId) throws RemoteException;

    /*
     * Returns the lotId for object/db field
     *
     * @return String aLotId
     */
    public abstract String getLotId();

    /*
     * Sets the lotId for object/db field
     *
     * @param String aLotId
     */
    public abstract void setLotId(String aLotId) throws RemoteException;

    /*
     * Returns the sku for object/db field
     *
     * @return String aSku
     */
    public abstract String getSku();

    /*
     * Sets the sku for object/db field
     *
     * @param String aSku
     */
    public abstract void setSku(String aSku) throws RemoteException;

    /*
     * Returns the carrierId for object/db field
     *
     * @return String aCarrierId
     */
    public abstract String getCarrierId();

    /*
     * Sets the carrierId for object/db field
     *
     * @param String aCarrierId
     */
    public abstract void setCarrierId(String aCarrierId) throws RemoteException;

    /*
     * Returns the trackingId for object/db field
     *
     * @return String aTrackingId
     */
    public abstract String getTrackingId();

    /*
     * Sets the TrackingId for object/db field
     *
     * @param String aTrackingId
     */
    public abstract void setTrackingId(String aTrackingId) throws RemoteException;

    /*
     * Returns the createDate for object/db field
     *
     * @return String aCreateDate
     */
    public abstract String getCreateDate();

    /*
     * Sets the createDate for object/db field
     *
     * @param String aCreateDate
     */
    public abstract void setCreateDate(String aCreateDate) throws RemoteException;

    /*
     * Returns the quantityOrdered for object/db field
     *
     * @return int aQuantityOrdered
     */
    public abstract int getQuantityOrdered();

    /*
     * Sets the quantityOrdered for object/db field
     *
     * @param int aQuantityOrdered
     */
    public abstract void setQuantityOrdered(int aQuantityOrdered) throws RemoteException;

    /*
     * Returns the status for object/db field
     *
     * @return String aStatus
     */
    public abstract String getStatus();

    /*
     * Sets the status for object/db field
     *
     * @param String aStatus
     */
    public abstract void setStatus(String aStatus) throws RemoteException;

    /*
     * Sets the entity context
     * 
     * @param EntityContext aCtx
     */
    public void setEntityContext(EntityContext aCtx){
	ctx = aCtx;
    }

    /* Unsets the entity context */
    public void unsetEntityContext(){
	ctx = null;
    }

    /* 
     * Creates a bean with the corresponding db table passed in values 
     *
     * @param String aSku
     * @param String aCarrierId
     * @param String aTrackingId
     * @param String aCreateDate
     * @param int    aQuantity
     * @param String aStatus
     */
    public Long ejbCreate(String aLotId, String aSku, String aCarrierId, String aTrackingId,
			  String aCreateDate, int aQuantityOrdered, String aStatus)
	throws RemoteException, CreateException {

	setLotId(aLotId);
	setSku(aSku);
	setCarrierId(aCarrierId);
	setTrackingId(aTrackingId);
	setCreateDate(aCreateDate);
	setQuantityOrdered(aQuantityOrdered);
	setStatus(aStatus);

	return null;

    }

    /* Post create method. Required. */
    public void ejbPostCreate(String aLotId, String aSku, String aCarrierId, String aTrackingId,
			      String aCreateDate, int aQuantityOrdered, String aStatus)
	throws RemoteException {}

    public void ejbRemove(){}
    public void ejbLoad(){}
    public void ejbStore(){}
    public void ejbActivate(){}
    public void ejbPassivate(){}

} // OrderBean
