package com.bea.lsd.avitek.ordermanagement.entities;

/*
 * ProductInventoryBean
 *
 * Entity bean representing the ProductInventory table for the lsd use case 2.
 *
 * @Author Jason Lee
 * $id:$
 */

import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import java.rmi.RemoteException;
import javax.ejb.FinderException;

public abstract class ProductInventoryBean implements EntityBean {

    private EntityContext ctx;

    /*
     * Returns the id for object/db field
     *
     * @return Long anId
     */
    public abstract Long getId();

    /*
     * Sets the id for object/db field
     *
     * @param Long anId
     */
    public abstract void setId(Long aId) throws RemoteException;

    /*
     * Returns the sku for object/db field
     *
     * @return String aSku
     */
    public abstract String getSku();

    /*
     * Sets the sku for object/db field
     *
     * @param String aSku
     */
    public abstract void setSku(String aSku) throws RemoteException;

    /*
     * Returns the numAvail for object/db field
     *
     * @return String aNumAvail
     */
    public abstract int getNumAvail();

    /*
     * Sets the numAvail for object/db field
     *
     * @param String aNumAvail
     */
    public abstract void setNumAvail(int aNumAvail) throws RemoteException;

    /*
     * Returns the description for object/db field
     *
     * @return int aDescription
     */
    public abstract String getDescription();

    /*
     * Sets the description for object/db field
     *
     * @param int aDescription
     */
    public abstract void setDescription(String aDescription) throws RemoteException;

    /*
     * Returns the minUnits for object/db field
     *
     * @return int aMinUnits
     */
    public abstract int getMinUnits();

    /*
     * Sets the minUnits for object/db field
     *
     * @param int aMinUnits
     */
    public abstract void setMinUnits(int aMinUnits) throws RemoteException;

    /*
     * Returns the maxUnits for object/db field
     *
     * @return int aMaxUnits
     */
    public abstract int getMaxUnits();

    /*
     * Sets the maxUnits for object/db field
     *
     * @param int aMaxUnits
     */
    public abstract void setMaxUnits(int aMaxUnits) throws RemoteException;

    /*
     * Sets the entity context
     * 
     * @param EntityContext aCtx
     */
    public void setEntityContext(EntityContext aCtx){
	ctx = aCtx;
    }

    /* Unsets the entity context */
    public void unsetEntityContext(){
	ctx = null;
    }

    /* 
     * Creates a bean with the corresponding db table passed in values 
     *
     * @param String aSku
     * @param String aNumAvail
     * @param String aDescription
     * @param int    aMinUnits
     * @param int    aMaxUnits
     */
    public Long ejbCreate(String aSku, int aNumAvail, String aDescription, 
			  int aMinUnits, int aMaxUnits)
	throws RemoteException {

	setSku(aSku);
	setNumAvail(aNumAvail);
	setDescription(aDescription);
	setMinUnits(aMinUnits);
	setMaxUnits(aMaxUnits);

	return null;

    }

    /* Post create method. Required. */
    public void ejbPostCreate(String aSku, int aNumAvail, String aDescription, 
			      int aMinUnits, int aMaxUnits)
	throws RemoteException {}

    public void ejbRemove(){}
    public void ejbLoad(){}
    public void ejbStore(){}
    public void ejbActivate(){}
    public void ejbPassivate(){}

} // ProductInventoryBean
