package com.bea.lsd.avitek.ordermanagement.entities;

/*
 * ProductInventoryHome
 *
 * Home interface of the ProductInventoryBean
 *
 * @Author Jason Lee
 * $id:$
 */

import java.util.Collection;
import javax.ejb.EJBHome; 
import java.rmi.RemoteException; 
import javax.ejb.CreateException; 
import javax.ejb.FinderException; 

public interface ProductInventoryHome extends EJBHome {

    /* 
     * Creates a bean with the corresponding db table passed in values 
     *
     * @param String aSku
     * @param String aNumAvail
     * @param String aDescription
     * @param int    aMinUnits
     * @param int    aMaxUnits
     * @return ProductInventory aProductInventory
     */
    public ProductInventory create(String aSku, int aNumAvail, String aDescription, 
				   int aMinUnits, int aMaxUnits)
	throws CreateException, RemoteException;

    /*
     * Returns a ProductInventory object based on a the primary key supplied.
     *
     * @param Long aPrimaryKey
     * @return ProductInventory aProductInventory
     *
     */
    public ProductInventory findByPrimaryKey(Long id) throws FinderException, RemoteException;

    /*
     * Returns a ProductInventory object based on a the primary key supplied.
     *
     * @param String aSku
     * @return ProductInventory aProductInventory
     *
     */
    public ProductInventory findBySku(String aSku) throws FinderException, RemoteException;
    
    /*
     * Returns a Collection of all ProductInventory objects.
     *
     * @return Collection of all ProductInventory objects
     *
     */
    public Collection findAll() throws FinderException, RemoteException;


} // ProductInventoryHome
