package com.bea.lsd.avitek.ordermanagement.entities;

/*
 * ShippingHistoryBean
 *
 * Entity bean representing the ShippingHistory table for the lsd use case 2.
 *
 * @Author Jason Lee
 * $id:$
 */

import java.util.Collection;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.CreateException;
import java.rmi.RemoteException;
import javax.ejb.FinderException;

public abstract class ShippingHistoryBean implements EntityBean {

    private EntityContext ctx;

    /*
     * Returns the id for object/db field
     *
     * @return Long anId
     */
    public abstract Long getId();

    /*
     * Sets the id for object/db field
     *
     * @param Long anId
     */
    public abstract void setId(Long aId) throws RemoteException;

    /*
     * Returns the carrierId for object/db field
     *
     * @return String aCarrierId
     */
    public abstract String getCarrierId();

    /*
     * Sets the carrierId for object/db field
     *
     * @param String aCarrierId
     */
    public abstract void setCarrierId(String aCarrierId) throws RemoteException;

    /*
     * Returns the trackingId for object/db field
     *
     * @return String aShipmentId
     */
    public abstract String getShipmentId();

    /*
     * Sets the ShipmentId for object/db field
     *
     * @param String aShipmentId
     */
    public abstract void setShipmentId(String aShipmentId) throws RemoteException;

    /*
     * Returns the locationId for object/db field
     *
     * @return Long aLocationId
     */
    public abstract Long getLocationId();

    /*
     * Sets the locationId for object/db field
     *
     * @param Long aLocationId
     */
    public abstract void setLocationId(Long aLocationId) throws RemoteException;

    /*
     * Sets the entity context
     * 
     * @param EntityContext aCtx
     */
    public void setEntityContext(EntityContext aCtx){
	ctx = aCtx;
    }

    /* Unsets the entity context */
    public void unsetEntityContext(){
	ctx = null;
    }

    /* 
     * Creates a bean with the corresponding db table passed in values 
     *
     * @param String aCarrierId
     * @param String aShipmentId
     * @param Long   aLocationId
     */
    public Long ejbCreate(String aCarrierId, String aShipmentId, Long aLocationId)
	throws RemoteException, CreateException {

	setCarrierId(aCarrierId);
	setShipmentId(aShipmentId);
	setLocationId(aLocationId);

	return null;

    }

    /* Post create method. Required. */
    public void ejbPostCreate(String aCarrierId, String aShipmentId, Long aLocationId)
	throws RemoteException, CreateException {}

    public void ejbRemove(){}
    public void ejbLoad(){}
    public void ejbStore(){}
    public void ejbActivate(){}
    public void ejbPassivate(){}

} // ShippingHistoryBean
