package com.bea.lsd.avitek.ordermanagement.entities;

/*
 * ShippingLocationBean
 *
 * Entity bean representing the ShippingLocation table for the lsd use case 2.
 *
 * @Author Jason Lee
 * $id:$
 */

import java.util.Collection;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import java.rmi.RemoteException;
import javax.ejb.CreateException;
import javax.ejb.FinderException;

public abstract class ShippingLocationBean implements EntityBean {

    private EntityContext ctx;

    /*
     * Returns the id for object/db field
     *
     * @return Long anId
     */
    public abstract Long getId();

    /*
     * Sets the id for object/db field
     *
     * @param Long anId
     */
    public abstract void setId(Long aId) throws RemoteException;

    /*
     * Returns the name for object/db field
     *
     * @return String aName
     */
    public abstract String getName();

    /*
     * Sets the name for object/db field
     *
     * @param String aName
     */
    public abstract void setName(String aName) throws RemoteException;

    /*
     * Returns the address for object/db field
     *
     * @return String aAddress
     */
    public abstract String getAddress();

    /*
     * Sets the address for object/db field
     *
     * @param String aAddress
     */
    public abstract void setAddress(String aAddress) throws RemoteException;

    /*
     * Returns the city for object/db field
     *
     * @return String aCity
     */
    public abstract String getCity();

    /*
     * Sets the city for object/db field
     *
     * @param String aCity
     */
    public abstract void setCity(String aCity) throws RemoteException;

    /*
     * Returns the state for object/db field
     *
     * @return String aState
     */
    public abstract String getState();

    /*
     * Sets the state for object/db field
     *
     * @param String aState
     */
    public abstract void setState(String aState) throws RemoteException;

    /*
     * Returns the country for object/db field
     *
     * @return String aCountry
     */
    public abstract String getCountry();

    /*
     * Sets the country for object/db field
     *
     * @param String aCountry
     */
    public abstract void setCountry(String aCountry) throws RemoteException;

    /*
     * Returns the zip for object/db field
     *
     * @return String aZip
     */
    public abstract String getZip();

    /*
     * Sets the zip for object/db field
     *
     * @param String aZip
     */
    public abstract void setZip(String aZip) throws RemoteException;

    /*
     * Returns the date for object/db field
     *
     * @return String aDate
     */
    public abstract String getDate();

    /*
     * Sets the date for object/db field
     *
     * @param String aDate
     */
    public abstract void setDate(String aDate) throws RemoteException;

    /*
     * Sets the entity context
     * 
     * @param EntityContext aCtx
     */
    public void setEntityContext(EntityContext aCtx){
	ctx = aCtx;
    }

    /* Unsets the entity context */
    public void unsetEntityContext(){
	ctx = null;
    }

    /* 
     * Creates a bean with the corresponding db table passed in values 
     *
     * @param String aName
     * @param String aAddress
     * @param String aCity
     * @param String aState
     * @param String aCountry
     * @param String aZip
     * @param String aDate
     */
    public Long ejbCreate(String aName, String aAddress, String aCity, String aState,
			  String aCountry, String aZip, String aDate)
	throws RemoteException, CreateException {

	setName(aName);
	setAddress(aAddress);
	setCity(aCity);
	setState(aState);
	setCountry(aCountry);
	setZip(aZip);
	setDate(aDate);

	return null;

    }

    /* Post create method. Required. */
    public void ejbPostCreate(String aName, String aAddress, String aCity, String aState,
			      String aCountry, String aZip, String aDate)
	throws RemoteException {}

    public void ejbRemove(){}
    public void ejbLoad(){}
    public void ejbStore(){}
    public void ejbActivate(){}
    public void ejbPassivate(){}

} // ShippingLocationBean
