package com.bea.lsd.avitek.ordermanagement.entities;

/*
 * ShippingLocationHome
 *
 * Home interface of the ShippingLocationBean
 *
 * @Author Jason Lee
 * $id:$
 */

import java.util.Collection;
import javax.ejb.EJBHome; 
import java.rmi.RemoteException; 
import javax.ejb.CreateException; 
import javax.ejb.FinderException; 

public interface ShippingLocationHome extends EJBHome {

    /* 
     * Creates a bean with the corresponding db table passed in values 
     *
     * @param String aName
     * @param String aAddress
     * @param String aCity
     * @param String aState
     * @param String aCountry
     * @param String aZip
     * @param String aDate
     * @return ShippingLocation aShippingLocation
     */
    public ShippingLocation create(String aName, String aAddress, String aCity, String aState,
				   String aCountry, String aZip, String aDate)
	throws RemoteException, CreateException;

    /*
     * Returns a StoreLocation object based on a the primary key supplied.
     *
     * @param Long aPrimaryKey
     * @return ShippingLocation aShippingLocation
     *
     */
    public ShippingLocation findByPrimaryKey(Long id) throws FinderException, RemoteException;
    
    /*
     * Returns a Collection of all ShippingLocation objects.
     *
     * @return Collection of all ShippingLocation objects
     *
     */
    public Collection findAll() throws FinderException, RemoteException;


} // ShippingLocationHome
