package com.bea.lsd.avitek.ordermanagement.entities;

/*
 * UPSShippingPartnerHome
 *
 * Home interface for the UPS shipping partner.
 *
 * @Author Jason Lee
 */

import java.util.Collection;
import java.rmi.RemoteException;
import javax.ejb.CreateException;
import javax.ejb.FinderException;
import javax.ejb.EJBHome;

public interface UPSShippingPartnerHome extends EJBHome {

    /*
     * The bean create method.
     *
     */
    public UPSShippingPartner create() throws CreateException, RemoteException;

    /*
     * Returns a ShippingPartner object based on a the matching primary key.
     *
     * @param Long aKey
     * @return ShippingPArtner aShippingPartner
     *
     */
    public UPSShippingPartner findByPrimaryKey(Long aKey) throws FinderException, RemoteException;

    /*
     * Returns a ShippingPartner object based on a the matching TrackingId.
     *
     * @param String aTrackingId
     * @return UPSShippingPartner aUPSShippingPartner
     *
     */
    public UPSShippingPartner findByTrackingId(String aTrackingId) throws FinderException, RemoteException;

    /*
     * Returns all the UPS shipping partner items
     *
     * @return Collection aUPSShippingPartners
     *
     */

    public Collection findAll() throws FinderException, RemoteException;    

} // UPSShippingPartnerHome
