package com.bea.lsd.avitek.ordermanagement.entities;

/*
 * USPSShippingPartnerHome
 *
 * Home interface for the USPS shipping partner.
 *
 * @Author Jason Lee
 */

import java.util.Collection;
import java.rmi.RemoteException;
import javax.ejb.CreateException;
import javax.ejb.FinderException;
import javax.ejb.EJBHome;

public interface USPSShippingPartnerHome extends EJBHome {

    /*
     * The bean create method.
     *
     */
    public USPSShippingPartner create() throws CreateException, RemoteException;

    /*
     * Returns a ShippingPartner object based on a the matching primary key.
     *
     * @param Long aKey
     * @return ShippingPArtner aShippingPartner
     *
     */
    public USPSShippingPartner findByPrimaryKey(Long aKey) throws FinderException, RemoteException;

    /*
     * Returns a ShippingPartner object based on a the matching TrackingId.
     *
     * @param String aTrackingId
     * @return USPSShippingPartner aUSPSShippingPartner
     *
     */
    public USPSShippingPartner findByTrackingId(String aTrackingId) throws FinderException, RemoteException;

    /*
     * Returns all the USPS shipping partner items
     *
     * @return Collection aUSPSShippingPartners
     *
     */

    public Collection findAll() throws FinderException, RemoteException;    

} // USPSShippingPartnerHome
