
/*                 
 * B E A   S Y S T E M S   
 *
 * C O M M E R C E   C O M P O N E N T S
 *                        
 * Copyright (c) 2000-2002  BEA Systems, Inc.  
 *
 * All Rights Reserved. Unpublished rights reserved under the copyright laws 
 * of the United States. The software contained on this media is proprietary 
 * to and embodies the confidential technology of BEA Systems, Inc. The 
 * possession or receipt of this information does not convey any right to disclose 
 * its contents, reproduce it, or use,  or license the use, for manufacture or 
 * sale, the information or anything described therein. Any use, disclosure, or
 * reproduction without BEA System's prior written permission is strictly prohibited.
 *
 */

package examples.e2e.b2b;

import java.io.Serializable;
import java.util.Map;
import java.util.HashMap;


public final class B2BPortalPage implements Serializable {

    private int intValue;
    private String name;

    public static final int SIZE = 3;
    // set the size to prevent rehashing
    private static final Map stringToObject =
            new HashMap( (int)( SIZE / 0.75f ) + 1 );

    public static final int I_INVENTORY = 0;
    public static final B2BPortalPage INVENTORY =
            new B2BPortalPage( I_INVENTORY, JspConstants.INVENTORY_PAGE_ID );

    public static final int I_PURCHASING = 1;
    public static final B2BPortalPage PURCHASING =
            new B2BPortalPage( I_PURCHASING, JspConstants.PURCHASING_PAGE_ID );
                              
    public static final int I_ORDER_HISTORY = 2;
    public static final B2BPortalPage ORDER_HISTORY =
            new B2BPortalPage( I_ORDER_HISTORY, JspConstants.PO_PAGE_ID );


    static {

        stringToObject.put( INVENTORY.getString(), INVENTORY );
        stringToObject.put( PURCHASING.getString(), PURCHASING );
        stringToObject.put( ORDER_HISTORY.getString(), ORDER_HISTORY );
    }

    /**
     */
    private B2BPortalPage( int intValue, String name ) {

        this.intValue = intValue;
        this.name = name;
    }

    public String toString() {

        return getString();
    }

    public String getString() {

        return name;
    }

    public int getInt() {

        return intValue;
    }

    public static B2BPortalPage getObject( String token ) {

        return(B2BPortalPage) stringToObject.get( token );
    }

    public boolean equals( Object object ) {
        if ( this == object ) {
            return true;
        }
        else if ( object == null || getClass() != object.getClass() ) {
            return false;
        }

        B2BPortalPage other = (B2BPortalPage) object;
        return this.intValue == other.intValue;
    }

    private int hashCode;
    private boolean hashCodeValid = false;
    private static final int HASHCODE_SEED = 1000003;

    public int hashCode() {

        if ( hashCodeValid == true ) {
            return hashCode;
        }

        computeHashCode();
        return hashCode;
    }
    private void computeHashCode() {

        hashCode = intValue * HASHCODE_SEED;
        hashCodeValid = true;
    }

}
