

/*                 
 * B E A   S Y S T E M S   
 *
 * C O M M E R C E   C O M P O N E N T S
 *                        
 * Copyright (c) 2000-2002  BEA Systems, Inc.  
 *
 * All Rights Reserved. Unpublished rights reserved under the copyright laws 
 * of the United States. The software contained on this media is proprietary 
 * to and embodies the confidential technology of BEA Systems, Inc. The 
 * possession or receipt of this information does not convey any right to disclose 
 * its contents, reproduce it, or use,  or license the use, for manufacture or 
 * sale, the information or anything described therein. Any use, disclosure, or
 * reproduction without BEA System's prior written permission is strictly prohibited.
 *
 * $Header: /cvsroot/site/bea-lsd/deploy/e2eDomain/beaApps/e2eApp/b2bPortal/WEB-INF/src/examples/e2e/b2b/JspBase.java,v 1.2 2002/05/02 00:22:09 toneill Exp $
 */

package examples.e2e.b2b;

import examples.e2e.b2b.Helper;
import examples.e2e.b2b.Constants;
import examples.e2e.b2b.RequestState;
import examples.e2e.b2b.SessionState;

import com.bea.p13n.appflow.common.PipelineSession;
import com.bea.p13n.appflow.exception.ProcessingException;
import com.bea.p13n.appflow.webflow.WebflowJSPHelper;
import com.bea.p13n.util.debug.Debug;

import java.io.IOException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.ServletException;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.JspException;


// built-in init parameters:
// boolean             _verbose -- wants debugging

// Well-known variables:
// JspWriter out                  -- to write to the browser
// HttpServletRequest  request    -- the request object.
// HttpServletResponse response   -- the response object.
// PageContext pageContext        -- the page context for this JSP
// HttpSession session            -- the session object for the client (if any)
// ServletContext application     -- The servlet (application) context
// ServletConfig config           -- The ServletConfig for this JSP
// Object page                    -- the instance of this page's implementation class (i.e., 'this')


public abstract class JspBase extends weblogic.servlet.jsp.JspBase
        implements JspConstants, Constants {

    private static Debug debug =
            Debug.getInstance( JspBase.class );


    protected JspBase() {

        if ( debug.ON ) {
            debug.out( "constructor" );
        }
    } 


    protected PipelineSession getPipelineSession( HttpServletRequest request ) {

        return Helper.getPipelineSession( request );
    }

    protected Object getWebflowContext( HttpServletRequest request ) {

        return Helper.getWebflowContext( request );
    }

    protected RequestState getRequestState( ServletRequest request )
    throws JspException {

        return getRequestState( (HttpServletRequest) request );
    }
    protected RequestState getRequestState( HttpServletRequest request )
    throws JspException {

        try {
            return Helper.getRequestState( getPipelineSession( request ),
                    getWebflowContext( request ) );
        }
        catch ( ProcessingException pe ) {
            throw new JspException( "unable to obtain session state" );
        }
    }

    protected SessionState getSessionState( ServletRequest request )
    throws JspException {

        return getSessionState( (HttpServletRequest) request );
    }
    protected SessionState getSessionState( HttpServletRequest request )
    throws JspException {

        try {
            return Helper.getSessionState( getPipelineSession( request ) );
        }
        catch ( ProcessingException pe ) {
            throw new JspException( "unable to obtain session state" );
        }

    }

    protected String getStaticUrl( PageContext pageContext,
                                   String resource,
                                   boolean encode ) throws JspException {

        String url = WebflowJSPHelper.createStaticResourceURL(
            pageContext, resource, encode );

        if ( debug.ON ) {
            debug.out( "url(" + url + ")" );
        }
        
        return url;
    }
}
