
/*
 * B E A   S Y S T E M S
 *
 * C O M M E R C E   C O M P O N E N T S
 *
 * Copyright (c) 2000-2002  BEA Systems, Inc.
 *
 * All Rights Reserved. Unpublished rights reserved under the copyright laws
 * of the United States. The software contained on this media is proprietary
 * to and embodies the confidential technology of BEA Systems, Inc. The
 * possession or receipt of this information does not convey any right to disclose
 * its contents, reproduce it, or use,  or license the use, for manufacture or
 * sale, the information or anything described therein. Any use, disclosure, or
 * reproduction without BEA System's prior written permission is strictly prohibited.
 *
 */

package examples.e2e.b2b;

import java.text.SimpleDateFormat;


public interface JspConstants extends Constants {

    // Webflow events seen by portlets
    // PortalAppflowConstants.PORTLET_WEBFLOW_EVENT_PARAMETER
    public static final String EVENT_PRODUCT = "selectProduct";
    public static final String EVENT_PART = "selectPart";
    public static final String EVENT_QPA = "submitQPA";
    public static final String EVENT_QUOTE = "selectQuote";
    public static final String EVENT_PO = "submitPO";

    // used by product inventory portlet to begin a new purchasing process
    public static final String EVENT_RESET = "reset";

    // extra http request params used by portlets
    public static final String PRODUCT_PARAMETER = "product";
    public static final String PART_PARAMETER = "part";
    // QPA form fields
    public static final String QTY_PARAMETER = "quantity";
    public static final String UNIT_PRICE_PARAMETER = "unitPrice";

    public static final String MONTH_PARAM = "month";
    public static final String DAY_PARAM = "day";

    public static final String QUOTE_PARAM = "quote";

    public static final String PRODUCT_PARAM_EQUALS = PRODUCT_PARAMETER + "=";
    public static final String PART_PARAM_EQUALS = PART_PARAMETER + "=";

    // CSS style definitions
    public static final String CSS_INV_BELOW_MIN = "inventoryerrorPortlet";
    public static final String CSS_PRODUCT_ROW = "inventory2Portlet";
    public static final String CSS_PART_ROW = "inventory4Portlet";

    // CSS styles for PO data rows, dependent on PO Status
    public static final String CSS_PO_PENDING = "orderhistory1";
    public static final String CSS_PO_PENDING_STATUS = "orderhistory2";
    public static final String CSS_PO_PENDING_GIF_1 = "bgf8e3e3";
    public static final String CSS_PO_PENDING_GIF_2 = "bgefdbd1";
    public static final String CSS_PO_ACK = "orderhistory3";
    public static final String CSS_PO_ACK_STATUS = "orderhistory4";
    public static final String CSS_PO_SHIPPED = "orderhistory5";
    public static final String CSS_PO_SHIPPED_STATUS = "orderhistory6";
    public static final String CSS_PO_REC_1 = "orderhistory7";
    public static final String CSS_PO_REC_1_STATUS = "orderhistory8";
    public static final String CSS_PO_REC_1_GIF_1 = "bgf4f3f3";
    public static final String CSS_PO_REC_1_GIF_2 = "bge5e5d5";
    public static final String CSS_PO_REC_2 = "orderhistory9";
    public static final String CSS_PO_REC_2_STATUS = "orderhistory10";
    public static final String CSS_PO_REC_2_GIF_1 = "bge6e6e6";

    // spacer image
    public static final String MIN_ICON = "purch_process_minimize.gif";
    public static final String MAX_ICON = "purch_process_maximize.gif";

    public static final String INVENTORY_PAGE_ID = "Inventory";
    public static final String PURCHASING_PAGE_ID = "Purchasing";
    // public static final String PO_PAGE_ID = "Order History";
    public static final String PO_PAGE_ID = "Order Status";

    public static final String PRODUCT_PORTLET_ID = "productinventory";
    public static final String PART_PORTLET_ID = "partinventory";
    public static final String QPA_PORTLET_ID = "pricequery";
    public static final String QUOTE_PORTLET_ID = "pricequote";
    public static final String PO_REVIEW_PORTLET_ID = "purchaseorderreview";
    public static final String PO_STATUS_ID = "purchaseorderhistory";

    public static final String TG_STATE_DEFAULT = "default";
    public static final String TG_STATE_PRODUCT_INVENTORY = "product-inventory";
    public static final String TG_STATE_PART_INVENTORY = "part-inventory";
    public static final String TG_STATE_QPA = "query-pa";
    public static final String TG_STATE_QUOTES = "quotes-pa";
    public static final String TG_STATE_PURCHASING = "purchasing-start";
    public static final String TG_STATE_ORDER_HISTORY = "order-history";

    public static final String TG_FILE_DEFAULT =
        "/portlets/tourguide/minimized.jsp";
    public static final String TG_FILE_SUMMARY =
        "/portlets/inventorysummary/content2.jsp";
    public static final String TG_FILE_PO_STATUS_NORMAL =
        "/portlets/purchaseorderhistory/content.jsp";
    public static final String TG_FILE_PRODUCT_INVENTORY =
        "/portlets/productinventory/content.jsp";
    public static final String TG_FILE_PART_INVENTORY =
        "/portlets/partinventory/content2.jsp";
    public static final String TG_FILE_QPA =
        "/portlets/pricequery/content3.jsp";

    public static final SimpleDateFormat monthFormat =
            new SimpleDateFormat( "MMM" );

    public static final SimpleDateFormat monthDayYear =
            new SimpleDateFormat( "MMM dd yy" );

    public static final SimpleDateFormat longFormat =
        new SimpleDateFormat( "MMM dd',' yyyy '-' EEEEEEEEEE" );

    public static final SimpleDateFormat monthDayLongYear =
        new SimpleDateFormat( "MMM dd',' yyyy" );

    public static final SimpleDateFormat titlebarFormat =
            new SimpleDateFormat( "MM/dd/yy h:mm a zzz" );


    public static final String localizedPropertiesFile = "b2b";
}
