
/*                 
 * B E A   S Y S T E M S   
 *
 * C O M M E R C E   C O M P O N E N T S
 *                        
 * Copyright (c) 2000-2002  BEA Systems, Inc.  
 *
 * All Rights Reserved. Unpublished rights reserved under the copyright laws 
 * of the United States. The software contained on this media is proprietary 
 * to and embodies the confidential technology of BEA Systems, Inc. The 
 * possession or receipt of this information does not convey any right to disclose 
 * its contents, reproduce it, or use,  or license the use, for manufacture or 
 * sale, the information or anything described therein. Any use, disclosure, or
 * reproduction without BEA System's prior written permission is strictly prohibited.
 *
 * $Header: /cvsroot/site/bea-lsd/deploy/e2eDomain/beaApps/e2eApp/b2bPortal/WEB-INF/src/examples/e2e/b2b/LongMinMaxExpression.java,v 1.2 2002/05/02 00:22:09 toneill Exp $
 */

package examples.e2e.b2b;

import com.bea.p13n.util.debug.Debug;


public class LongMinMaxExpression {

    private static Debug debug =
            Debug.getInstance( LongMinMaxExpression.class );

    private long min = Long.MIN_VALUE;
    private long max = Long.MAX_VALUE;
    private boolean required = true;


    public LongMinMaxExpression( long min, long max ) {
        
        this( min, max, true );
    }

    public LongMinMaxExpression( long min, boolean required ) {
        
        this( min, Long.MAX_VALUE, true );
    }

    public LongMinMaxExpression( long min, long max, boolean required ) {
        
        this.min = min;
        this.max = max;
        this.required = required;
    }

    public LongMinMaxExpression() {
    }

    public long min() {

        return min;
    }

    public long max() {

        return max;
    }

    public void setMin( long min ) {

        this.min = min;
    }

    public void setMax( long max ) {
        
        this.max = max;
    }
    
    public void setRequired( boolean required ) {
        
        this.required = required;
    }

    public LongMinMaxExpression set( long min, long max ) {
        
        return set( min, max, true );
    }
    
    public LongMinMaxExpression set( long min, boolean required ) {
        
        return set( min, Long.MAX_VALUE, true );
    }

    public LongMinMaxExpression set( long min, long max, boolean required ) {
        
        setMin( min );
        setMax( max );
        setRequired( required );

        return this;
    }

}
