

/*                 
 * B E A   S Y S T E M S   
 *
 * C O M M E R C E   C O M P O N E N T S
 *                        
 * Copyright (c) 2000-2002  BEA Systems, Inc.  
 *
 * All Rights Reserved. Unpublished rights reserved under the copyright laws 
 * of the United States. The software contained on this media is proprietary 
 * to and embodies the confidential technology of BEA Systems, Inc. The 
 * possession or receipt of this information does not convey any right to disclose 
 * its contents, reproduce it, or use,  or license the use, for manufacture or 
 * sale, the information or anything described therein. Any use, disclosure, or
 * reproduction without BEA System's prior written permission is strictly prohibited.
 *
 * $Header: /cvsroot/site/bea-lsd/deploy/e2eDomain/beaApps/e2eApp/b2bPortal/WEB-INF/src/examples/e2e/b2b/Util.java,v 1.2 2002/05/02 00:22:09 toneill Exp $
 */

package examples.e2e.b2b;

import com.bea.p13n.util.debug.Debug;

import java.util.Properties;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.List;


public class Util {

    private static Debug debug =
            Debug.getInstance( Util.class );

    public static final String EMPTY = "[empty]";
    public static final String NULL = "[null]";


    private Util() {
    } 


    public static String getString( Properties props ) {


        if ( props == null ) {
            return NULL;
        }

        Enumeration enum = props.keys();
        StringBuffer sb = new StringBuffer( 32 * props.size() );

        String key = null;
        String val = null;
        
        int i = 0;
        for ( ; enum.hasMoreElements(); i++ ) {
            
            key = (String) enum.nextElement();
            val = props.getProperty( key );
            
            if ( i == 0 ) {
                sb.append( "[ size( " + props.size() + " ): " );
                sb.append( "( key( " + key + " ), val( " + val + " ) )" );

            }
            else {
                sb.append( ", ( key( " + key + " ), val( " + val + " ) )" );
            }
        }

        if ( i == 0 ) {
            sb.append( EMPTY );
        }

        return sb.toString();
    }

    public static String getString( List list ) {

        if ( list == null ) {
            return NULL;
        }

        Iterator it = list.iterator();
        int size = list.size();

        return getString( it, size );
    }


    public static String getString( Iterator it, int size ) {

        if ( it == null ) {
            return NULL;
        }

        StringBuffer sb = new StringBuffer( 32 * size );

        Object val = null;
        
        int i = 0;
        for ( ; it.hasNext(); i++ ) {
            
            val = it.next();
            
            if ( i == 0 ) {
                sb.append( "[ size( " + size + " ): " );
                sb.append( "( val(" + i + ")( " + val + " ) )" );

            }
            else {
                sb.append( ", ( val(" + i + ")( " + val + " ) )" );
            }
        }

        if ( i == 0 ) {
            sb.append( EMPTY );
        }

        return sb.toString();
    }

}
