

/*                 
 * B E A   S Y S T E M S   
 *
 * C O M M E R C E   C O M P O N E N T S
 *                        
 * Copyright (c) 2000-2002  BEA Systems, Inc.  
 *
 * All Rights Reserved. Unpublished rights reserved under the copyright laws 
 * of the United States. The software contained on this media is proprietary 
 * to and embodies the confidential technology of BEA Systems, Inc. The 
 * possession or receipt of this information does not convey any right to disclose 
 * its contents, reproduce it, or use,  or license the use, for manufacture or 
 * sale, the information or anything described therein. Any use, disclosure, or
 * reproduction without BEA System's prior written permission is strictly prohibited.
 *
 * $Header: /cvsroot/site/bea-lsd/deploy/e2eDomain/beaApps/e2eApp/b2bPortal/WEB-INF/src/examples/e2e/b2b/processors/E2eB2bPreProcessor.java,v 1.2 2002/05/02 00:22:09 toneill Exp $
 */

package examples.e2e.b2b.processors;

import examples.e2e.b2b.Helper;
import examples.e2e.b2b.RequestState;
import examples.e2e.common.BuyerFactory;

import com.bea.portal.appflow.processor.PreProcessor;
import com.bea.portal.appflow.PortalRequest;
import com.bea.portal.appflow.PortalAppflowConstants;

import com.bea.p13n.appflow.exception.ProcessingException;
import com.bea.p13n.appflow.common.PipelineSession;
import com.bea.p13n.util.debug.Debug;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;


public class E2eB2bPreProcessor extends PreProcessor {

    private static Debug debug =
            Debug.getInstance( E2eB2bPreProcessor.class );

    private static final String EMPTY_STRING = "";

    // Testing only
    private static final String DELETE_PROP =
            "samples.e2e.b2b.doNotDelete";
    private static boolean doNotDelete;

    static {
        try {
            doNotDelete = Boolean.getBoolean( DELETE_PROP );

        }
        catch ( Exception e ) {
            debug.out( "unable to get system property( " +
                    DELETE_PROP + " )" );
        }
    }


    public E2eB2bPreProcessor() {
    } 


    public Object process( HttpServletRequest request,
            HttpServletResponse response,
            PortalRequest portalRequest,
            Object requestContext )
    throws ProcessingException {

        if ( debug.ON ) {
            debug.out( EMPTY_STRING );
            debug.out( "doNotDelete( " + doNotDelete + " )" );
        }

        PipelineSession session = Helper.getPipelineSession( request );
        RequestState rState = Helper.getRequestState( session, requestContext );

        // initialize the Calendar for this request.
        rState.calendar();

        // delete XML and .data files
        if ( ! doNotDelete ) {

            HttpSession httpSession = request.getSession();

            if ( debug.ON ) {
                debug.out( "httpSession.isNew( " + httpSession.isNew() + " )" );
            }

            if ( httpSession.isNew() ) {
                if ( debug.ON ) {
                    debug.out( "deleting XML files" );
                }

                BuyerFactory.deleteXML();
            }
        }

        // do the normal stuff
        Object rtnVal = super.process( request, response,
                portalRequest, requestContext );

        if ( debug.ON ) {
            debug.out( "rtnVal(" + rtnVal + ")" );
        }

        return rtnVal;
    }
}
