
/*                 
 * B E A   S Y S T E M S   
 *
 * C O M M E R C E   C O M P O N E N T S
 *                        
 * Copyright (c) 2000-2002  BEA Systems, Inc.  
 *
 * All Rights Reserved. Unpublished rights reserved under the copyright laws 
 * of the United States. The software contained on this media is proprietary 
 * to and embodies the confidential technology of BEA Systems, Inc. The 
 * possession or receipt of this information does not convey any right to disclose 
 * its contents, reproduce it, or use,  or license the use, for manufacture or 
 * sale, the information or anything described therein. Any use, disclosure, or
 * reproduction without BEA System's prior written permission is strictly prohibited.
 *
 * $Header: /cvsroot/site/bea-lsd/deploy/e2eDomain/beaApps/e2eApp/b2bPortal/WEB-INF/src/examples/e2e/b2b/processors/POProcessor.java,v 1.2 2002/05/02 00:22:09 toneill Exp $
 */

package examples.e2e.b2b.processors;

import examples.e2e.b2b.Helper;
import examples.e2e.b2b.Util;
import examples.e2e.b2b.Constants;
import examples.e2e.b2b.RequestState;
import examples.e2e.b2b.SessionState;
import examples.e2e.b2b.StateValue;

import examples.e2e.common.PurchaseQuote;
import examples.e2e.common.BuyerFactory;

import com.bea.p13n.util.debug.Debug;
import com.bea.p13n.appflow.webflow.InputProcessorSupport;
import com.bea.p13n.appflow.common.PipelineSession;
import com.bea.p13n.appflow.exception.ProcessingException;
import com.bea.p13n.appflow.common.internal.AppflowConstants;
import com.bea.commerce.ebusiness.price.quote.ImmutableMoney;
import com.bea.commerce.ebusiness.price.quote.Money;

import com.bea.portal.appflow.PortalRequest;
import com.bea.portal.appflow.PortalAppflowEvent;
import com.bea.portal.appflow.PortalAppflowConstants;

import java.util.List;
import java.util.Calendar;
import java.util.ArrayList;
import java.util.Properties;
import java.util.Iterator;
import java.rmi.server.UID;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.xml.sax.InputSource;


public class POProcessor extends AbstractProcessor {

    private static Debug debug =
            Debug.getInstance( POProcessor.class );


    public POProcessor() {
    } 


    /**
     * Processors extending this class must provide an implementation. This method
     * will be called if the processor is session insensitive or the session has not
     * timed-out.
     */
    public Object process(HttpServletRequest request,
            HttpServletResponse response,
            PortalRequest portalRequest,
            Object requestContext,
            PipelineSession session,
            RequestState rState,
            SessionState sState )
    throws ProcessingException {

        String rtnVal = null;

        if ( debug.ON ) {
            debug.out( EMPTY_STRING );
        }

        // actual event for this portlet
        // one of "bea.portal.framework.internal.refresh" or "null"
        String event = getPortletEvent( request );

        StateValue state = sState.getState();

        if ( StateValue.START.equals( state ) ||
                StateValue.PRODUCT_SELECTED.equals( state ) ||
                StateValue.PART_SELECTED.equals( state ) || 
                StateValue.QPA_SENT.equals( state ) ) {

            rtnVal = NOT_SELECTED;
        }
        else if ( StateValue.CREATE_PO.equals( state ) ) {

            rtnVal = DISPLAY;
        }
        else {

            rtnVal = READ_ONLY;
        }


        if ( debug.ON ) {
            debug.out( "rtnVal(" + rtnVal + ")" );
        }

        return rtnVal;
    }
}

