<!-- start /portlets/outstandingProduct/content.jsp -->
<%@ page import="com.bea.portal.appflow.PortalAppflowConstants" %>
<%@ page import="org.openuri.www.x2002.x04.soap.conversation.*" %>
<%@ page import="org.openuri.www.*" %>
<%@ page import="weblogic.jws.proxies.*" %>
<%@ page import="java.util.*" %>
<%@ include file="/framework/resourceURL.inc" %>

<%@ taglib uri="webflow.tld" prefix="webflow" %>
<%@ taglib uri="portlet.tld" prefix="portlet" %>
<%@ taglib uri="portal.tld" prefix="portal" %>

<%
/////////////////////////////////////////
// Instantiate the client side soap proxy
AvitekPortalClient proxy = (AvitekPortalClient) new AvitekPortalClient_Impl();
AvitekPortalClientSoap soapProxy = proxy.getAvitekPortalClientSoap();

///////////////////////////////////////
// General Session attribute variables
String PRODUCT_CONV 		= "productConversation";
String OUTSTANDING_ORDERS	= "outStandingOrders";

//////////////////////////////////////
// General request parameter variables
String UPDATE_ORDERS		= "updateOrders";

////////////////////////////////////////////////////
// Get the product conversationId from the session
String conversationId 		= (String)session.getAttribute(PRODUCT_CONV);

///////////////////////
// General declarations
OutstandingOrder[] orders = null;
ArrayList orderList = null;

////////////////////////////////////////////////////
// If the tracking conversationId is null,
// then the conversation is not in progress
// therfore create a new conversation id and start
// a new conversation
if(conversationId == null)
{
	////////////////////////////////////////////////////////////////////////////////
	// The conversationId is a cumulation of the session id and the tracking id
	// this ensures that the conversation is unique to the session/client as well as
	// the specific request for this order transit details
	conversationId = session.getId()+PRODUCT_CONV;

	//////////////////////////////////////////////////////////////////////////////
	// Create a conversation id and header for the conversational method
	// The callback URL for this is NULL since the client cannot accept callbacks
	StartHeader startHeader = new StartHeader(conversationId, "");

	try
	{
		orders = soapProxy.getOutstandingOrders(startHeader);
		// Add the outstanding orders and conversation id to the session
		if(orders != null) session.setAttribute(OUTSTANDING_ORDERS, orders);
		if(conversationId != null) session.setAttribute(PRODUCT_CONV, conversationId);
	}
	catch (Exception e)
	{
		e.printStackTrace(System.err);
		// This is a duplicate id therefore get the orders from the session
		orders = (OutstandingOrder[])session.getAttribute(OUTSTANDING_ORDERS);
	}
}
// Else the conversation has already started
else
{
	// If the update orders button was pressed
	if(request.getParameter(UPDATE_ORDERS) != null)
	{
		// Create a continue header which can be used to continue the conversation
		ContinueHeader contHeader = new ContinueHeader(conversationId);

		// Get the updated orders from the webservice
		orders = soapProxy.updateOutstandingOrders(contHeader);

		// Add the updated orders to the session
		if(orders != null) session.setAttribute(OUTSTANDING_ORDERS, orders);
	}

	// Get the orderList from the session
	orders = (OutstandingOrder[])session.getAttribute(OUTSTANDING_ORDERS);

}
%>

<table cellpadding="0" cellspacing="0" border="0"><tr>
	  <td><img src="framework/images/dot.gif" width="10" height="1" alt="" border="0"></td>
	  <td>
	<table cellpadding="0" cellspacing="0" border="0"><tr class="bg666666">
		<td colspan="2"><img src="<webflow:createResourceURL resource='<%=imagesPath + "out_lot_no.gif"%>'/>" width="93" height="18" alt="" border="0"></td>
		<td colspan="2"><img src="<webflow:createResourceURL resource='<%=imagesPath + "out_created.gif"%>'/>" width="104" height="18" alt="" border="0"></td>
		<td colspan="2"><img src="<webflow:createResourceURL resource='<%=imagesPath + "out_model.gif"%>'/>" width="181" height="18" alt="" border="0"></td>
		<td colspan="2"><img src="<webflow:createResourceURL resource='<%=imagesPath + "out_qty.gif"%>'/>" width="58" height="18" alt="" border="0"></td>
		<td colspan="4"><img src="<webflow:createResourceURL resource='<%=imagesPath + "out_status.gif"%>'/>" width="111" height="18" alt="" border="0"></td>
	</tr><tr class="bgf4f3f3">
		<td><img src="framework/images/dot.gif" width="11" height="1" alt="" border="0"></td>
	    <td><img src="framework/images/dot.gif" width="82" height="1" alt="" border="0"></td>
	    <td><img src="framework/images/dot.gif" width="11" height="1" alt="" border="0"></td>
	    <td><img src="framework/images/dot.gif" width="93" height="1" alt="" border="0"></td>
	    <td><img src="framework/images/dot.gif" width="11" height="1" alt="" border="0"></td>
	    <td><img src="framework/images/dot.gif" width="170" height="1" alt="" border="0"></td>
	    <td><img src="framework/images/dot.gif" width="9" height="1" alt="" border="0"></td>
	    <td><img src="framework/images/dot.gif" width="49" height="1" alt="" border="0"></td>
	    <td><img src="framework/images/dot.gif" width="11" height="1" alt="" border="0"></td>
	    <td><img src="framework/images/dot.gif" width="18" height="1" alt="" border="0"></td>
	    <td><img src="framework/images/dot.gif" width="8" height="1" alt="" border="0"></td>
	    <td><img src="framework/images/dot.gif" width="74" height="1" alt="" border="0"></td>
	</tr>

<%
for (int i = 0; orders != null && i < orders.length; i++)
{
%>


	<tr class="bgf4f3f3">
		<td><img src="framework/images/dot.gif" width="11" height="32" alt="" border="0"></td>
       <td class="inventory2Portlet"><%= orders[i].getLotNumber() %></td>
	     <td><img src="framework/images/dot.gif" width="1" height="1" alt="" border="0"></td>
       <td class="inventory2Portlet"><%= orders[i].getCompletedDate() %></td>
	     <td><img src="framework/images/dot.gif" width="1" height="1" alt="" border="0"></td>
       <td class="inventory2Portlet"><%= orders[i].getProdDesc() %></td>
	     <td><img src="framework/images/dot.gif" width="1" height="1" alt="" border="0"></td>
       <td class="inventory2Portlet"><%= orders[i].getQuantity() %></td>
	     <td class="bgffffcc"><img src="framework/images/dot.gif" width="1" height="1" alt="" border="0"></td>
       <td class="outstandingProduct1" colspan="3"><%= orders[i].getStatus() %></td>
	</tr><tr class="bgcccccc">
		<td colspan="12"><img src="framework/images/dot.gif" width="11" height="1" alt="" border="0"></td>

			</tr>

<%
}
%>
	<tr class="bgf4f3f3">
		<td colspan="3">
			<a href="<portal:createWebflowURL event='<%=PortalAppflowConstants.PORTAL_REFRESH%>' extraParams='<%=UPDATE_ORDERS+"=true"%>' />">
				<img src="<webflow:createResourceURL resource='<%=imagesPath + "refresh.gif"%>'/>" width="55" height="16" alt="" border="0">
			</a>
		</td>
		<td  colspan="9" class="tourMaxPortlet3">
			<b>NOTE:</b> It may take some time for the product status to update.<br>
			To refresh the status of the products click on the button to the left.
		</td>
	</tr>

</table>
	  </td>
	  <td><img src="framework/images/dot.gif" width="4" height="1" alt="" border="0"></td>
</tr></table>
<!-- end /portlets/outstandingProduct/content.jsp -->
