<!-- start /b2bPortal/portlets/productInTransit/detail.inc -->
<%@ taglib uri="webflow.tld" prefix="webflow" %>
<%@ include file="/framework/resourceURL.inc"%>

<script language="JavaScript" src="<webflow:createResourceURL resource='<%=jsFile+"prepopulate.js"%>'/>"></script>

<%

//////////////////////////////////////////////////////////
// Declare the constants for the request params being used
String SEND_MESSAGE 	= "sendMessage";
String GET_REPLY 		= "getReply";
String UPDATE_DETAIL	= "updateDetail";

///////////////////////////////////////////////////////////
// Declare unique keys for the session and tracking request
String TRACKING_CONV 	= "trackingConversation"+trackingId;
String SHIPMENT 		= "shipmentSession"+trackingId;
String TXT_AREA_MESSAGE = "textAreaMessage"+trackingId;

////////////////////////
// General declarations
ProductTransitDetail shipment = null;
ShippingHistoryLocation[] locations = null;

// Pre-populate the text area with the message that needs to be sent to the service rep
String textAreaMessage = "";

///////////////////////////////////////////////////////////////////////////
// presence of trackingId param causes detail view to be displayed
// (trackingId symbol is declared by content.jsp, which includes this file)
String extraParams = "trackingId=" + trackingId;

////////////////////////////////////////////////////
// Get the tracking conversationId from the session
String conversationId = (String)session.getAttribute(TRACKING_CONV);

////////////////////////////////////////////////////
// If the tracking conversationId is null,
// then the conversation is not in progress
// therfore create a new conversation id and start
// a new conversation
if(conversationId == null)
{
	////////////////////////////////////////////////////////////////////////////////
	// The conversationId is a cumulation of the session id and the tracking id
	// this ensures that the conversation is unique to the session/client as well as
	// the specific request for this order transit details
	conversationId = session.getId()+trackingId;

	//////////////////////////////////////////////////////////////////////////////
	// Create a conversation id and header for the conversational method
	// The callback URL for this is NULL since the client cannot accept callbacks
	StartHeader startHeader = new StartHeader(conversationId, "");

	try
	{
		// Get the transit details and start a conversation
		shipment = soapProxy.getInTransitDetail(trackingId, startHeader);

		// Add the conversation ID and Shipment ID to the session
		session.setAttribute(TRACKING_CONV, conversationId);
		session.setAttribute(SHIPMENT, shipment);
		// System.out.println("STARTING A NEW CONVERSATION");
	}
	catch (Exception e)
	{
		e.printStackTrace(System.err);
		// This is a duplicate id therefore get the shipment from teh session
		shipment = (ProductTransitDetail)session.getAttribute(SHIPMENT);
	}

}
/////////////////////////////////////////////////////////////
// Else if the conversation already exists,
// then we have the conversation id from the session
// now we can asses other methods to continue the conversation
else
{
	// System.out.println("CONTINUING THE CONVERSATION");
	// Since the conversation already exists, get the shipment from the session
	shipment = (ProductTransitDetail)session.getAttribute(SHIPMENT);

	// Create a continue header which can be used to continue the conversation
	ContinueHeader contHeader = new ContinueHeader(conversationId);

	// If the send button was pressed, then send the message to the service rep
	if(request.getParameter(SEND_MESSAGE) != null)
	{
		// Send the message to the service rep, this is synchronous requiring no return value
		soapProxy.alertServiceRep(textAreaMessage, contHeader);
		// Set the appropriate text message
		textAreaMessage = "Your message has been sent.";
	}

	// If the "Refresh" button was pressed, then get the service rep reply
	if(request.getParameter(GET_REPLY) != null)
	{
		// Get the reply from the service rep
		textAreaMessage = soapProxy.getServiceRepResponse(contHeader);
		if(textAreaMessage == null) textAreaMessage = "";
	}

	/////////////////////////////////////////////////////////////////////////////
	// If the update detail button was pressed (assuming the conversation exists)
	// then get the latest shipment details and also cleanup since this method
	// ends the conversation.
	if(request.getParameter(UPDATE_DETAIL) != null)
	{
		// Get the latest shipment information
		shipment = (ProductTransitDetail)soapProxy.updateInTransitDetail(contHeader);
		// This ends the conversation, so cleanup the session
		session.removeAttribute(TRACKING_CONV);
		session.removeAttribute(SHIPMENT);
		textAreaMessage = "";
		// System.out.println("ENDED THE CONVERSATION");
	}

}


///////////////////////////////////////////
// Extract the locations from the shipment
locations = shipment.getShippingLocations();


%>
<table cellpadding="0" cellspacing="0" border="0"><tr>
	<td colspan="3"><img src="<webflow:createResourceURL resource='<%=imagesPath + "dotted_line_561.gif"%>'/>" width="561" height="11" alt="" border="0"></td>
</tr><tr>
	<td><img src="framework/images/dot.gif" width="10" height="1" alt="" border="0"></td>
	<td valign="top">
		  <table cellpadding="0" cellspacing="0" border="0"><tr class="bg666666">
			<td><img src="<webflow:createResourceURL resource='<%=imagesPath + "transit_header.gif"%>'/>" width="198" height="20" alt="" border="0"></td>
			<td class="inventorySummary"><%=new Date().toString()%></td>
		</tr><tr>
			<td><img src="framework/images/dot.gif" width="198" height="1" alt="" border="0"></td>
			<td><img src="framework/images/dot.gif" width="349" height="1" alt="" border="0"></td>
		</tr>
		</table>

	<table cellpadding="0" cellspacing="0" border="0">
	<tr>
		<td><img src="framework/images/dot.gif" width="9" height="1" alt="" border="0"></td>
	    <td><img src="framework/images/dot.gif" width="393" height="1" alt="" border="0"></td>
	</tr><tr class="bgf4f3f3">
		<td colspan="2" align="right"><img src="framework/images/dot.gif" width="10" height="10" alt="" border="0"></td>
	</tr><tr class="bgf4f3f3">
		<td colspan="2" align="right"><a href="<portlet:createPortletUnminimizeURL portletName='outstandingProductWS'/>"><img src="<webflow:createResourceURL resource='<%=imagesPath + "return_to_overview.gif"%>'/>" width="82" height="13" alt="" border="0"></a><img src="framework/images/dot.gif" width="10" height="1" alt="" border="0"></td>
	</tr><tr>
		<td colspan="2"><img src="<webflow:createResourceURL resource='<%=imagesPath + "order_summary.gif"%>'/>" width="547" height="24" alt="" border="0"></td>
	</tr></table>

	<table cellpadding="0" cellspacing="0" border="0"><tr class="bg666666">
		<td colspan="2"><img src="<webflow:createResourceURL resource='<%=imagesPath + "detail_lot_no.gif"%>'/>" width="86" height="18" alt="" border="0"></td>
		<td><img src="<webflow:createResourceURL resource='<%=imagesPath + "detail_model.gif"%>'/>" width="122" height="18" alt="" border="0"></td>
		<td><img src="<webflow:createResourceURL resource='<%=imagesPath + "detail_qty.gif"%>'/>" width="49" height="18" alt="" border="0"></td>
		<td><img src="<webflow:createResourceURL resource='<%=imagesPath + "detail_carrier.gif"%>'/>" width="66" height="18" alt="" border="0"></td>
		<td><img src="<webflow:createResourceURL resource='<%=imagesPath + "detail_est_arrival.gif"%>'/>" width="128" height="18" alt="" border="0"></td>
		<td><img src="<webflow:createResourceURL resource='<%=imagesPath + "detail_tracking.gif"%>'/>" width="96" height="18" alt="" border="0"></td>
	</tr><tr class="bgf4f3f3">
	    <td><img src="framework/images/dot.gif" width="10" height="30" alt="" border="0"></td>
  <td width="76" class="tourMaxPortlet3"><%=shipment.getLotNumber()%></td>
  <td class="tourMaxPortlet3"><%=shipment.getProdDesc()%></td>
  <td class="tourMaxPortlet3"><%=shipment.getQty()%></td>
  <td class="tourMaxPortlet3"><%=shipment.getCarrierId()%></td>
  <td class="tourMaxPortlet3"><%=shipment.getEstArrival()%></td>
  <td class="tourMaxPortlet3"><%=shipment.getTrackingId()%></td>
  </tr><tr class="bgcccccc">
	    <td colspan="7"><img src="framework/images/dot.gif" width="10" height="1" alt="" border="0"></td>

	<tr></table>

<!-- Shipping History Table -->
<%
//
// Create the map image name here
//
String mapImage = new String();
for(int m=0; m < locations.length; m++){
  mapImage += locations[m].getZip() + "_";
}
// remove the trailing _
mapImage = mapImage.substring(0, (mapImage.length() -1)) + ".gif";
mapImage = "portlets/productInTransit/maps/" + mapImage;

%>

<table cellpadding="0" cellspacing="0" border="0"><tr>
<td colspan="5"><img src="<webflow:createResourceURL resource='<%=imagesPath + "shipping_history.gif"%>'/>" width="547" height="38" alt="" border="0"></td>

<tr class="bgd5d5bb">
	<td><img src="framework/images/dot.gif" width="10" height="1" alt="" border="0"></td>
	<td><img src="<webflow:createResourceURL resource='<%=imagesPath + "ship_date.gif"%>'/>" width="133" height="18" alt="" border="0"></td>
	<td><img src="<webflow:createResourceURL resource='<%=imagesPath + "ship_location.gif"%>'/>" width="176" height="18" alt="" border="0"></td>
	<td><img src="<webflow:createResourceURL resource='<%=imagesPath + "ship_method.gif"%>'/>" width="47" height="18" alt="" border="0"></td>
	<td width="181" class="tourMaxPortlet3"><b><%=shipment.getShippingMethod()%></b></td>
</tr>


<%
for(int j=0; j< locations.length; j++)
{
    %>
    <tr class="bgf4f3f3">
	<td valign="top"><img src="framework/images/dot.gif" width="10" height="1" alt="" border="0"></td>
    <td class="tourMaxPortlet3" valign="top"><%=locations[j].getLocDate()%></td>
    <td class="tourMaxPortlet3" valign="top"><b><%=locations[j].getName()%></b><br><%=locations[j].getAddress()%><br><%=locations[j].getCity()%>, <%=locations[j].getState()%> <%=locations[j].getZip()%><br></td>
    <%
    if(j == 0)
    {
        %>
        <!-- This provides the row span for the 3rd column based on total results returned -->
        <td colspan ="2" rowspan=<%=locations.length + 2%> valign="top">
        	<img src="<%=mapImage%>" border="0">
        </td>
        <%
    }
    %>
    </tr>

<%
}
%>

<tr class="bgf4f3f3">
	<td colspan="5"><img src="framework/images/dot.gif" width="10" height="10" alt="" border="0"></td>
</tr>
<tr class="bgf4f3f3">
	<td colspan="2">
		<a href="<portal:createWebflowURL event='<%=PortalAppflowConstants.PORTAL_REFRESH%>' extraParams='<%=extraParams+"&"+UPDATE_DETAIL+"=true"%>'/>">
			<img src="<webflow:createResourceURL resource='<%=imagesPath + "refresh.gif"%>'/>" width="55" height="16" alt="" border="0">
		</a>
	</td>
	<td  colspan="3" class="tourMaxPortlet3">
		<b>NOTE:</b> It may take some time for the shipping status to update.<br>
		To check on the status of a product click on the button to the left.
	</td>
</tr>
<tr class="bgcccccc">
	<td colspan="5"><img src="framework/images/dot.gif" width="10" height="1" alt="" border="0"></td>
</tr>

</table>


<!-- IM Table -->
<%
//
// Create the svc rep image here
//
String svcRepImage = "portlets/productInTransit/reps/" + shipment.getServiceRep();
svcRepImage = svcRepImage.replace(' ', '_');
svcRepImage += ".jpg";
%>

<form name="messageWindow">
<table cellpadding="0" cellspacing="0" border="0"><tr class="bgf4f3f3">
<td><img src="<webflow:createResourceURL resource='<%=imagesPath + "have_a_question.gif"%>'/>" width="147" height="40" alt="" border="0"></td>
<td width="400" class="tourMaxPortlet5"> &nbsp;<b>Contact your <%=shipment.getCarrierId()%> service representative:</b></td>
</tr></table>


<table cellpadding="0" cellspacing="0" border="0"><tr class="bgd5d5bb">
<td><img src="framework/images/dot.gif" width="10" height="1" alt="" border="0"></td>
<td><img src="<webflow:createResourceURL resource='<%=imagesPath + "rep_your.gif"%>'/>" width="160" height="18" alt="" border="0"></td>
<td><img src="<webflow:createResourceURL resource='<%=imagesPath + "rep_im.gif"%>'/>" width="213" height="18" alt="" border="0"></td>
<td><img src="<webflow:createResourceURL resource='<%=imagesPath + "rep_call.gif"%>'/>" width="164" height="18" alt="" border="0"></td>
</tr><tr class="bgf4f3f3">
	<td colspan="4"><img src="framework/images/dot.gif" width="10" height="10" alt="" border="0"></td>
</tr><tr class="bgf4f3f3">
	<td><img src="framework/images/dot.gif" width="10" height="10" alt="" border="0"></td>
	<td class="tourMaxPortlet3" valign="top">
		<b><%=shipment.getServiceRep()%></b><br>
		<i><%=shipment.getServiceRepTitle()%></i><br>
		<br>
		<img src="<%=svcRepImage%>" border="0"></td>

	<!-- TEXT AREA FOR AVITEK IM -->
	<td class="tourMaxPortlet3" valign="top">
		<b>Status</b>: Available<br>

	 	<textarea cols="33" class="tourMaxPortlet3" rows="5" name="myMessage"><%=textAreaMessage%></textarea><br>

		<img src="<webflow:createResourceURL resource='<%=imagesPath + "dot.gif"%>'/>" width="200" height="5" alt="" border="0"><br>

		<a href="javascript:prePopulateMessageWindow()"><img src="<webflow:createResourceURL resource='<%=imagesPath + "demo_only.gif"%>' />" width="60" height="15" border="0" alt=""></a>
		<a href="<portal:createWebflowURL event='<%=PortalAppflowConstants.PORTAL_REFRESH%>' extraParams='<%=extraParams+"&"+SEND_MESSAGE+"=true"%>'/>"><img src="<webflow:createResourceURL resource='<%=imagesPath + "send.gif"%>'/>" width="31" height="13" alt="" border="0"></a>

	</td>


	<td valign="top"><img src="<webflow:createResourceURL resource='<%=imagesPath + "number.gif"%>'/>" width="164" height="30" alt="" border="0"></td>
</tr>

<tr class="bgf4f3f3">
	<td colspan="4"><img src="framework/images/dot.gif" width="10" height="5" alt="" border="0"></td>
</tr>
<tr class="bgf4f3f3">
	<td><img src="framework/images/dot.gif" width="10" height="1" alt="" border="0"></td>
	<td>
		<a href="<portal:createWebflowURL event='<%=PortalAppflowConstants.PORTAL_REFRESH%>' extraParams='<%=extraParams+"&"+GET_REPLY+"=true"%>'/>">
			<img src="<webflow:createResourceURL resource='<%=imagesPath + "refresh.gif"%>'/>" width="55" height="16" alt="" border="0">
		</a>
	</td>
	<td  colspan="2" class="tourMaxPortlet3">
		<b>NOTE:</b> It may take some time to get a reply from your <%=shipment.getCarrierId()%> service rep.<br>
		To see if your service rep has replied click on the button to the left.
	</td>
</tr>

<tr class="bgcccccc">
	<td colspan="4"><img src="framework/images/dot.gif" width="10" height="1" alt="" border="0"></td>
</tr><tr class="bgf4f3f3">
	<td colspan="4" align="right"><img src="framework/images/dot.gif" width="10" height="10" alt="" border="0"></td>
</tr><tr class="bgf4f3f3">
	<td colspan="4" align="right"><a href="<portlet:createPortletUnminimizeURL portletName='outstandingProductWS'/>"><img src="<webflow:createResourceURL resource='<%=imagesPath + "return_to_overview.gif"%>'/>" width="82" height="13" alt="" border="0"></a><img src="framework/images/dot.gif" width="10" height="1" alt="" border="0"></td>
</tr><tr class="bgf4f3f3">
	<td colspan="4" align="right"><img src="framework/images/dot.gif" width="10" height="10" alt="" border="0"></td>
</tr><tr>
	<td colspan="4" align="right"><img src="framework/images/dot.gif" width="10" height="10" alt="" border="0"></td>
</tr></table>

</form>

	</td>
	<td><img src="framework/images/dot.gif" width="4" height="1" alt="" border="0"></td>
</tr></table>
<!-- end /b2bPortal/portlets/productInTransit/detail.inc -->
