<%-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. --%>

<%@ taglib uri="i18n.tld" prefix="i18n" %>
<%@ taglib uri="portlet.tld" prefix="portlet" %>
<%@ taglib uri="webflow.tld" prefix="webflow" %>

<%@ page import="com.bea.portal.render.servlets.jsp.PortalRenderHelper" %>

<%@ page import="examples.e2e.common.tourguide.TourGuide" %>
<%@ page import="examples.e2e.common.tourguide.TourGuideData" %>

<%@ include file="/framework/resourceURL.inc" %>

<%-- Constants for the maximized view of the Tour Guide --%>

<%!
    /* Set up extra HTTP parameters for the navigation links */

    /** Technical Details parameters */
    protected static final String techParams = 
        TourGuide.OPTION_PARAM + "=" + TourGuide.TECH_DETAILS_VALUE; 

    /** View Code parameters */
    protected static final String codeParams =
        TourGuide.OPTION_PARAM + "=" + TourGuide.VIEW_CODE_VALUE; 

    /** Read eDocs parameters */
    protected static final String edocsParams =
        TourGuide.OPTION_PARAM + "=" + TourGuide.EDOCS_VALUE;
%>

<%-- Get the Tour Guide from the pipeline session --%>

<webflow:getProperty
    id="tourGuide"
    type="examples.e2e.common.tourguide.TourGuide"
    property="<%= TourGuide.PIPELINE_ATTR %>"
    scope="session"
    namespace="portal" />

<%-- Get page title strings --%>

<i18n:getMessage
    id="techDetailsTitle"
    messageName="tourGuide.max.pageTitle.techDetails"
    bundleName="../b2b" />

<i18n:getMessage
    id="viewCodeTitle"
    messageName="tourGuide.max.pageTitle.viewCode"
    bundleName="../b2b" />

<i18n:getMessage
    id="eDocsTitle"
    messageName="tourGuide.max.pageTitle.eDocs"
    bundleName="../b2b" />

<%
   /* Call the Tour Guide to determine the current state of the system */

   TourGuideData tgData = tourGuide.determineState( request );
   String state = tgData.getState();

   /* Get the current page name */

   String currentPage =
       PortalRenderHelper.getPageIdentifier( request ).getName();

   /* Get the navigation link the user selected */

   String option = 
       (String) request.getParameter( TourGuide.OPTION_PARAM );

   /*
    * The portlet is maxmized so we have to determine which link the user
    * selected and display the appropriate title and content.
    */
   
   String pageTitle = null;
   String icon = null;
   String mainContent = null;

   if ( option == null )
   {
       /*
        * There is no request parameter -- the portlet was probably
        * refreshed so get the last option stored in the tour guide
        * instance data.
        */

       option = tgData.getLastOption();
   }

   if ( option.equals( TourGuide.TECH_DETAILS_VALUE ) )
   {
       pageTitle = techDetailsTitle;
       icon = imagesPath + TourGuide.TECH_DETAILS_MAX_ICON;
       mainContent = TourGuide.DOCUMENT_URI + 
                     TourGuide.TECH_DETAILS_DOC_PREFIX + 
                     state + ".jsp";
       tgData.setLastOption( option );
   }
   else if ( option.equals( TourGuide.VIEW_CODE_VALUE ) )
   {
       pageTitle = viewCodeTitle;
       icon = imagesPath + TourGuide.VIEW_CODE_MAX_ICON;
       mainContent = TourGuide.CODE_VIEWER_URI;
       tgData.setLastOption( option );
   }
   else if ( option.equals( TourGuide.EDOCS_VALUE ) )
   {
       pageTitle = eDocsTitle;
       icon = imagesPath + TourGuide.EDOCS_MAX_ICON;
       mainContent = TourGuide.DOCUMENT_URI + 
                     TourGuide.EDOCS_DOC_PREFIX + 
                     state + ".jsp";
       tgData.setLastOption( option );
   }
   else
   {
       /* An unknown option was provided -- just go to tech details */

       pageTitle = techDetailsTitle;
       icon = imagesPath + TourGuide.TECH_DETAILS_MAX_ICON;
       mainContent = TourGuide.DOCUMENT_URI + 
                     TourGuide.TECH_DETAILS_DOC_PREFIX + 
                     state + ".jsp";
       tgData.setLastOption( TourGuide.TECH_DETAILS_VALUE );
   }
%>

<table cellpadding="0" cellspacing="0" border="0" width="772"><tr>
	<td><img src="<webflow:createResourceURL resource='<%=imagesPath + "tour_max_header.gif" %>'/>" width="772" height="43" alt="" border="0"></td>
</tr></table>

<table cellpadding="0" cellspacing="0" border="0" width="772"><tr class="bge6e6e6">
	<td rowspan="3"><img src="<webflow:createResourceURL resource='<%=icon%>'/>" width="45" height="49" alt="" border="0"></td>
	<td><img src="framework/images/dot.gif" width="271" height="19" alt="" border="0"></td>
	<td><img src="framework/images/dot.gif" width="19" height="19" alt="" border="0"></td>
	<td><img src="framework/images/dot.gif" width="122" height="19" alt="" border="0"></td>
	<td><img src="framework/images/dot.gif" width="19" height="19" alt="" border="0"></td>
	<td><img src="framework/images/dot.gif" width="75" height="19" alt="" border="0"></td>
	<td><img src="framework/images/dot.gif" width="19" height="19" alt="" border="0"></td>
	<td><img src="framework/images/dot.gif" width="77" height="19" alt="" border="0"></td>
	<td><img src="framework/images/dot.gif" width="120" height="19" alt="" border="0"></td>
	<td rowspan="3" class="bgcccccc"><img src="framework/images/dot.gif" width="1" height="49" alt="" border="0"></td>
	<td rowspan="3" class="bgffffff"><img src="framework/images/dot.gif" width="4" height="49" alt="" border="0"></td>
</tr><tr class="bge6e6e6">
	<td width="271" class="tourMaxPortlet1"><%=pageTitle%></td>	
	<td><img src="<webflow:createResourceURL resource='<%=imagesPath + "tour_icon1.gif"%>'/>" width="19" height="16" alt="" border="0"></td>
	<td width="122"><a href="<portlet:createPortletMaximizeURL extraParams="<%=techParams%>" />"><span class="tourlinkPortlet">Get Technical Details</span></a></td>
	<td><img src="<webflow:createResourceURL resource='<%=imagesPath + "tour_icon2.gif"%>'/>" width="19" height="14" alt="" border="0"></td>
	<td width="75"><a href="<portlet:createPortletMaximizeURL extraParams="<%=codeParams%>" />"><span class="tourlinkPortlet">View Code</span></a></td>
	<td><img src="<webflow:createResourceURL resource='<%=imagesPath + "tour_icon3.gif"%>'/>" width="19" height="13" alt="" border="0"></td>
	<td width="77"><a href="<portlet:createPortletMaximizeURL extraParams="<%=edocsParams%>" />"><span class="tourlinkPortlet">Read eDocs</span></a></td>
	<td width="120"><a href="<portlet:createPortletUnmaximizeURL/>"><img src="<webflow:createResourceURL resource='<%=imagesPath + "tour_max_backtosample.gif"%>'/>" width="98" height="20" alt="" border="0"></a></td>	
</tr><tr class="bge6e6e6">
	<td colspan="8"><img src="framework/images/dot.gif" width="1" height="10" alt="" border="0"></td>		
</tr><tr class="bge6e6e6">
	<td colspan="11"><img src="<webflow:createResourceURL resource='<%=imagesPath + "tour_max_dottedline.gif"%>'/>" width="772" height="1" alt="" border="0"></td>	
</tr></table>

<table cellpadding="0" cellspacing="0" border="0" width="772"><tr>
	<td class="bgf4f4f3" rowspan="2"><img src="framework/images/dot.gif" width="45" height="20" alt="" border="0"></td>
	<td class="bgf4f4f3"><img src="framework/images/dot.gif" width="149" height="20" alt="" border="0"></td>
	<td rowspan="2" class="bgf4f4f3"><img src="framework/images/dot.gif" width="27" height="1" alt="" border="0"></td>
	<td class="bgf4f4f3"><img src="framework/images/dot.gif" width="546" height="1" alt="" border="0"></td>
	<td class="bgcccccc" rowspan="4"><img src="framework/images/dot.gif" width="1" height="49" alt="" border="0"></td>
	<td class="bgffffff" rowspan="4"><img src="framework/images/dot.gif" width="4" height="49" alt="" border="0"></td>
</tr><tr class="bgf4f4f3">

<%-- Include content for the main area of the portlet --%>

	<td valign="top" colspan="3">
<jsp:include page="<%=mainContent%>" flush="true" />
    </td>

	</tr><tr class="bgf4f4f3">
		<td colspan="4" align="left"><a href="<portlet:createPortletUnmaximizeURL/>"><img src="<webflow:createResourceURL resource='<%=imagesPath + "tour_max_backtosample.gif"%>'/>" width="98" height="20" alt="" border="0"></a><img src="framework/images/dot.gif" width="20" height="20" alt="" border="0"></td>
	</tr><tr class="bgf4f4f3">
		<td colspan="4"><img src="framework/images/dot.gif" width="1" height="11" alt="" border="0"></td>	
	</tr><tr>
	<td colspan="10"><img src="<webflow:createResourceURL resource='<%=imagesPath + "tour_max_footer.gif"%>'/>" width="772" height="14" alt="" border="0"></td>	
</tr></table>
