<%-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. --%>

<%@ taglib uri="i18n.tld" prefix="i18n" %>
<%@ taglib uri="webflow.tld" prefix="webflow" %>
<%@ taglib uri="portlet.tld" prefix="portlet" %>

<%@ page import="examples.e2e.common.tourguide.TourGuide" %>

<%@ include file="/framework/resourceURL.inc" %>

<%!
    /* Set up extra params for the minimized portlet's navigation links */

    /** Technical Details parameters */
    protected static final String techParams = 
        TourGuide.OPTION_PARAM + "=" + TourGuide.TECH_DETAILS_VALUE;

    /** View Code parameters */
    protected static final String codeParams = 
        TourGuide.OPTION_PARAM + "=" + TourGuide.VIEW_CODE_VALUE;

    /** Read eDocs parameters */
    protected static final String edocsParams = 
        TourGuide.OPTION_PARAM + "=" + TourGuide.EDOCS_VALUE;
%>

<%-- Retrieve the Tour Guide object from the pipeline session --%>

<webflow:getProperty
    id="tourGuide"
    type="examples.e2e.common.tourguide.TourGuide"
    property="<%= TourGuide.PIPELINE_ATTR %>"
    scope="session"
    namespace="portal" />

<%
   /* Call the Tour Guide to determine the current state of the system */

   String state = tourGuide.determineState( request ).getState();

   /* Use the state to construct the include file names */

   String wnContent = TourGuide.DOCUMENT_URI + 
                      TourGuide.WHATS_NEW_DOC_PREFIX + 
                      state + ".jsp";
   String nsContent = TourGuide.DOCUMENT_URI + 
                      TourGuide.NEXT_STEPS_DOC_PREFIX + 
                      state + ".jsp";
%>

<img src="<webflow:createResourceURL resource='<%=imagesPath + "tour_header.gif"%>'/>" width="211" height="41" alt="" border="0">

<%-- This table contains the "What's New" section --%>

<table cellpadding="0" cellspacing="0" border="0" width="211">

<tr>
	<td colspan="2"><img src="<webflow:createResourceURL resource='<%=imagesPath + "tour_what.gif"%>'/>" width="211" height="27" alt="" border="0"></td>
</tr>

<tr>
<td colspan="2" class="bgeeeeee"><img src="framework/images/dot.gif" width="1" height="8" alt="" border="0"></td>
</tr>

<tr>
	<td class="bgeeeeee"><img src="framework/images/dot.gif" width="9" height="1" alt="" border="0"></td>

	<td class="tourPortlet">
<jsp:include page="<%= wnContent %>" flush="true" />
	</td>

</tr>

<tr>
<td colspan="2" class="bgeeeeee"><img src="framework/images/dot.gif" width="1" height="12" alt="" border="0"></td>
</tr>

</table>

<%-- This table contains the "How it works" section --%>

<table cellpadding="0" cellspacing="0" border="0">

<tr>
	<td colspan="4"><img src="<webflow:createResourceURL resource='<%=imagesPath + "tour_how.gif"%>'/>" width="211" height="26" alt="" border="0"></td>
</tr>

<tr>
	<td colspan="4" class="bgeeeeee"><img src="framework/images/dot.gif" width="1" height="10" alt="" border="0"></td>
</tr>

<tr>
	<td class="bgeeeeee"><img src="framework/images/dot.gif" width="9" height="1" alt="" border="0"></td>
	<td colspan="2" class="tourPortlet" width="192"><i18n:getMessage messageName="tourGuide.normal.howItWorksText" bundleName="../b2b" /></td>
	<td class="bgeeeeee"><img src="framework/images/dot.gif" width="10" height="8" alt="" border="0"></td>	
</tr>

<tr>
	<td colspan="4" class="bgeeeeee"><img src="framework/images/dot.gif" width="1" height="5" alt="" border="0"></td>
</tr>

<tr>
	<td class="bgeeeeee"><img src="framework/images/dot.gif" width="9" height="1" alt="" border="0"></td>
	<td class="bgeeeeee"><img src="<webflow:createResourceURL resource='<%=imagesPath + "tour_icon1.gif"%>'/>" width="19" height="16" alt="" border="0"></td>
	<td class="bgeeeeee" width="173">&nbsp; <a href="<portlet:createPortletMaximizeURL extraParams="<%=techParams%>" />"><span class="tourlinkPortlet">Get Technical Details</span></a></td>
	<td class="bgeeeeee"><img src="framework/images/dot.gif" width="10" height="8" alt="" border="0"></td>
</tr>

<tr>
	<td colspan="4" class="bgeeeeee"><img src="framework/images/dot.gif" width="1" height="7" alt="" border="0"></td>
</tr>

<tr>
	<td class="bgeeeeee"><img src="framework/images/dot.gif" width="9" height="1" alt="" border="0"></td>
	<td class="bgeeeeee"><img src="<webflow:createResourceURL resource='<%=imagesPath + "tour_icon2.gif"%>'/>" width="19" height="16" alt="" border="0"></td>
	<td class="bgeeeeee" width="173">&nbsp; <a href="<portlet:createPortletMaximizeURL extraParams="<%=codeParams%>" />"><span class="tourlinkPortlet">View Code</span></a></td>
	<td class="bgeeeeee"><img src="framework/images/dot.gif" width="10" height="8" alt="" border="0"></td>
</tr>

<tr>
	<td colspan="4" class="bgeeeeee"><img src="framework/images/dot.gif" width="1" height="7" alt="" border="0"></td>
</tr>

<tr>
	<td class="bgeeeeee"><img src="framework/images/dot.gif" width="9" height="1" alt="" border="0"></td>
	<td class="bgeeeeee"><img src="<webflow:createResourceURL resource='<%=imagesPath + "tour_icon3.gif"%>'/>" width="19" height="16" alt="" border="0"></td>
	<td class="bgeeeeee" width="173">&nbsp; <a href="<portlet:createPortletMaximizeURL extraParams="<%=edocsParams%>" />"><span class="tourlinkPortlet">Read eDocs</span></a></td>
	<td class="bgeeeeee"><img src="framework/images/dot.gif" width="10" height="8" alt="" border="0"></td>
</tr>

<tr>
	<td colspan="4" class="bgeeeeee"><img src="framework/images/dot.gif" width="1" height="16" alt="" border="0"></td>
</tr>

</table>

<%-- This table contains the "Next Steps" section --%>

<table cellpadding="0" cellspacing="0" border="0">

<tr>
	<td colspan="2"><img src="<webflow:createResourceURL resource='<%=imagesPath + "tour_next.gif"%>'/>" width="211" height="26" alt="" border="0"></td>
</tr>

<tr>
	<td colspan="2" class="bgeeeeee"><img src="framework/images/dot.gif" width="1" height="10" alt="" border="0"></td>
</tr>

<tr>
	<td class="bgeeeeee" width="9"><img src="framework/images/dot.gif" width="9" height="1" alt="" border="0"></td>

	<td class="tourPortlet">
<jsp:include page="<%= nsContent %>" flush="true" />
    </td>

</tr>

<tr>
	<td colspan="2" class="bgeeeeee"><img src="framework/images/dot.gif" width="1" height="15" alt="" border="0"></td>
</tr>

</table>

<img src="<webflow:createResourceURL resource='<%=imagesPath + "tour_footer.gif"%>'/>" width="211" height="13" alt="" border="0">
