/*
 * B E A   S Y S T E M S   
 *
 * C O M M E R C E   C O M P O N E N T S
 *                        
 * Copyright (c) 2000-2002  BEA Systems, Inc.  
 *
 * All Rights Reserved. Unpublished rights reserved under the copyright laws 
 * of the United States. The software contained on this media is proprietary 
 * to and embodies the confidential technology of BEA Systems, Inc. The 
 * possession or receipt of this information does not convey any right to disclose 
 * its contents, reproduce it, or use,  or license the use, for manufacture or 
 * sale, the information or anything described therein. Any use, disclosure, or
 * reproduction without BEA System's prior written permission is strictly prohibited.
 *
 * $Header: /cvsroot/site/bea-lsd/deploy/e2eDomain/beaApps/e2eApp/b2cPortal/WEB-INF/src/examples/e2e/b2c/order/webflow/OrderHistoryIP.java,v 1.2 2002/05/02 00:22:10 toneill Exp $
 */
package examples.e2e.b2c.order.webflow;

import javax.servlet.http.HttpServletRequest;

import com.bea.p13n.appflow.exception.ProcessingException;
import com.bea.p13n.appflow.webflow.InputProcessorSupport;
import com.bea.p13n.appflow.webflow.SessionManagerFactory;
import com.bea.p13n.appflow.common.PipelineSession;
import com.bea.p13n.util.debug.Debug;

import examples.e2e.b2c.util.B2CPortalConstants;

/**
 * This <code>OrderHistoryIP</code> is used for checking if the cached order
 * history list needs to be updated or not
 *
 */
public class OrderHistoryIP extends InputProcessorSupport
{
    // Debug flag - prevents compilation of debug tracing messages
    // when false
    private static Debug debug = Debug.getInstance(OrderHistoryIP.class);
    
    /**
     * Returns "invalid" if order history cache needs to be refreshed. "valid" otherwise.
     */
    public Object process(HttpServletRequest request, Object requestContext) throws ProcessingException
    {
        PipelineSession pSession = 
             SessionManagerFactory.getSessionManager().getPipelineSession( request );
        String namespace = (String) pSession.getDefaultNamespace();
        String result = "invalid";

        Boolean orderHistoryValid = (Boolean) getSessionAttribute(B2CPortalConstants.ORDER_HISTORY_LIST_VALID,
                                                                  namespace,
                                                                  pSession);
        if (debug.ON) {
           debug.out("\nOrderHistoryIP ORDER_HISTORY_LIST_VALID flag = " + orderHistoryValid);
           }   

        if (orderHistoryValid == null) {
           setSessionAttribute( B2CPortalConstants.ORDER_HISTORY_LIST_VALID,
                                new Boolean(false),
                                namespace,
                                pSession );
        } else if (orderHistoryValid.booleanValue() == true) {
           result = "valid";
        }

        if (debug.ON) {
           debug.out("\nOrderHistoryIP return is " + result);
           }    

        return result;
    }
}
