/*
 * B E A   S Y S T E M S
 *
 * P O R T A L
 *
 * Copyright (c) 2000-2002  BEA Systems, Inc.
 *
 * All Rights Reserved. Unpublished rights reserved under the copyright laws
 * of the United States. The software contained on this media is proprietary
 * to and embodies the confidential technology of BEA Systems, Inc. The
 * possession or receipt of this information does not convey any right to disclose
 * its contents, reproduce it, or use,  or license the use, for manufacture or
 * sale, the information or anything described therein. Any use, disclosure, or
 * reproduction without BEA System's prior written permission is strictly prohibited.
 *
 * $Header: /cvsroot/site/bea-lsd/deploy/e2eDomain/beaApps/e2eApp/b2cPortal/WEB-INF/src/examples/e2e/b2c/tourguide/webflow/MoveDocLocationIP.java,v 1.2 2002/05/02 00:22:10 toneill Exp $
 */

package examples.e2e.b2c.tourguide.webflow;

import javax.servlet.http.HttpServletRequest;

import com.bea.p13n.appflow.common.PipelineSession;
import com.bea.p13n.appflow.exception.*;
import com.bea.p13n.appflow.webflow.InputProcessorSupport;
import com.bea.p13n.appflow.webflow.SessionManagerFactory;

import com.bea.p13n.util.debug.Debug;

import com.bea.portal.appflow.PortalAppflowConstants;

import examples.e2e.b2c.util.B2CPortalConstants;

/**
 *
 * @see com.bea.p13n.appflow.webflow.InputProcessor
 * @see com.beasys.commerce.webflow.PipelineSessionConstants
 * @see com.beasys.commerce.foundation.pipeline.PipelineSession
 * @see com.beasys.commerce.foundation.pipeline.PipelineSessionConstants
 */
public class MoveDocLocationIP extends InputProcessorSupport
{
    private static Debug debug =
        Debug.getInstance( MoveDocLocationIP.class );

    public Object process( HttpServletRequest request, Object requestContext )
        throws ProcessingException
    {
        if ( debug.ON )
        {
            debug.here();
        }

        PipelineSession pSession = 
            SessionManagerFactory.getSessionManager().getPipelineSession( request );
        String namespace = (String) pSession.getDefaultNamespace();

        String location =
            (String) getSessionAttribute( B2CPortalConstants.DOC_PORTLET_LOCATION,
                                          namespace,
                                          pSession );

        if ( location != null )
        {
            setSessionAttribute( B2CPortalConstants.DOC_PORTLET_MAX_LOCATION,
                                 location,
                                 namespace,
                                 pSession );

        }

        return "success";
    }
}
