/*                 
 * B E A   S Y S T E M S   
 *
 * C O M M E R C E   C O M P O N E N T S
 *                        
 * Copyright (c) 2000-2002  BEA Systems, Inc.  
 *
 * All Rights Reserved. Unpublished rights reserved under the copyright laws 
 * of the United States. The software contained on this media is proprietary 
 * to and embodies the confidential technology of BEA Systems, Inc. The 
 * possession or receipt of this information does not convey any right to disclose 
 * its contents, reproduce it, or use,  or license the use, for manufacture or 
 * sale, the information or anything described therein. Any use, disclosure, or
 * reproduction without BEA System's prior written permission is strictly prohibited.
 *
 * $Header: /cvsroot/site/bea-lsd/deploy/e2eDomain/beaApps/e2eApp/b2cPortal/WEB-INF/src/examples/e2e/b2c/webflow/CommerceInputProcessorSupport.java,v 1.2 2002/05/02 00:22:10 toneill Exp $
 */

package examples.e2e.b2c.webflow;

import com.bea.p13n.appflow.exception.ProcessingException;
import com.bea.p13n.appflow.webflow.InputProcessor;
import com.bea.p13n.appflow.webflow.InputProcessorSupport;

import com.bea.p13n.usermgmt.SessionHelper;
import com.bea.p13n.usermgmt.profile.ProfileNotFoundException;
import com.bea.p13n.usermgmt.profile.ProfileWrapper;
import com.beasys.commerce.util.Logger;
import com.beasys.commerce.util.Log;

import java.rmi.RemoteException;
import javax.servlet.*;
import javax.servlet.http.*;

/**
 * This class provides additional support over implementing
 * InputProcessor directly. 
 */
public abstract class CommerceInputProcessorSupport extends InputProcessorSupport
{
    public Object getCustomerProperty(HttpServletRequest req, String property) 
    {
        Object result = null;

        // Get the profile from the session or request
        ProfileWrapper profile = SessionHelper.getProfile( req );

        if(profile != null) {
            try {
                result = profile.getProperty("CustomerProperties", property);
            }
            catch(RemoteException e) {
                Logger.getInstance().log(Log.LOG_ERROR, "CommerceInputProcessorSupport: RemoteException message: " + e.getMessage());
            }
            catch(ProfileNotFoundException e) {
		Logger.getInstance().log(Log.LOG_ERROR,  "CommerceInputProcessorSupport: ProfileNotFoundException message: " + e.getMessage());
            }
        }
        return result;
    }
}
