<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<!-- ------------------------------------------------------------ -->
<!-- This JSP displays Catalog Category information.  This        -->
<!-- included JSP requires the following PipelineSession          -->
<!-- properties:                                                  -->
<!--                                                              -->
<!-- Property:           Description:                             -->
<!-- CATEGORY            The Category to which the item belongs.  -->
<!-- CATEGORY_ITERATOR   The subcategories of the Category.       -->
<!-- ------------------------------------------------------------ -->

<%@ taglib uri="webflow.tld" prefix="webflow" %>
<%@ taglib uri="cat.tld" prefix="catalog" %>
<%@ page import="com.beasys.commerce.ebusiness.catalog.*" %>
<%@ page import="com.beasys.commerce.webflow.HttpRequestConstants" %>
<%@ page import="com.beasys.commerce.webflow.PipelineSessionConstants" %>

<%-- Get the current category from the PipelineSession --%>
	<webflow:getProperty id="category" property="<%=PipelineSessionConstants.CATALOG_CATEGORY%>" type="com.beasys.commerce.ebusiness.catalog.Category" scope="request" namespace="sampleapp_main" />
<%-- Get the subcategories from the PipelineSession --%>	
	<webflow:getProperty id="subcategories" property="<%=PipelineSessionConstants.CATALOG_CATEGORIES%>" type="com.beasys.commerce.ebusiness.catalog.ViewIterator" scope="request" namespace="sampleapp_main" />

<%-- Declare a String containing common browse parameters --%>
<%! static final String commonParameters = HttpRequestConstants.CATALOG_SOURCE_KEY + "=" + PipelineSessionConstants.CATALOG_CATEGORIES + "&" + 
	HttpRequestConstants.CATALOG_DESTINATION_KEY + "=wlcs_siblings&"; %>

<%-- If any individual items at this level, get count for navigation here --%>

<%-- Get the items from the PipelineSession --%>
	<webflow:getProperty id="items" property="<%=PipelineSessionConstants.CATALOG_ITEMS%>" type="com.beasys.commerce.ebusiness.catalog.ViewIterator" scope="request" namespace="sampleapp_main" />
<%-- Insert the category name --%>
<table border="0" width="90%" cellpadding="3">
   <tr>
      <td align="left">
	     <p class="head1"><catalog:getProperty object="<%= category %>" propertyName="Name"/></p>
	  </td>

	<%
	// Goto the correct view within the ViewIterator
	String viewIndexString = (String)request.getParameter(HttpRequestConstants.CATALOG_VIEW_INDEX);
	if (viewIndexString == null) { viewIndexString = "0"; }
	int viewIndex = Math.min(Integer.valueOf(viewIndexString).intValue(), items.getViewCount() - 1);
	if (viewIndex > 0) { items.gotoViewAt(viewIndex); }

        String myParams = null;
	%>

	<%-- Add "Next" and "Previous" top navigation --%>
	<% if (items.size() > 0) { %>
	    <td align="right">
		<%-- Add "Previous" link --%>
		<% if (items.hasPreviousView()) { 
                    myParams = commonParameters + HttpRequestConstants.CATALOG_CATEGORY_ID + "=" + java.net.URLEncoder.encode(category.getKey().getIdentifier()) + 
                                      "&" + HttpRequestConstants.CATALOG_VIEW_INDEX + "=" + (viewIndex - 1);
                %>
		   <b><a href="<webflow:createWebflowURL event="link.browse" namespace="sampleapp_main" extraParams="<%= myParams %>" />">Previous</a> | </b>
		<% } %>
		<%-- Add current view indicies --%>
		<% if (items.size() > 1) { %>
			<b><%= items.getCurrentView().getFirstIndex() %> - <%= items.getCurrentView().getLastIndex() %></b>
		<% } %>
		<%-- Add "Next" link --%>
		<% if (items.hasNextView()) { 
                    myParams = commonParameters + HttpRequestConstants.CATALOG_CATEGORY_ID + "=" + java.net.URLEncoder.encode(category.getKey().getIdentifier()) + 
                                      "&" + HttpRequestConstants.CATALOG_VIEW_INDEX + "=" + (viewIndex + 1);
                %>
			<b> | <a href="<webflow:createWebflowURL event="link.browse" namespace="sampleapp_main"  extraParams="<%= myParams %>" />">Next</a></b></td>
		<% } %>
	<% } %>
    </tr>
</table>


<%-- Subcategory list --%>
	<%-- Iterate through all subcategories, creating a browse link for each. --%>
	<center>
	<table cellpadding="3" border="0" width="90%">
		<catalog:iterateViewIterator iterator="<%= subcategories %>" id="subcategory" 
		returnType="com.beasys.commerce.ebusiness.catalog.Category">
		<tr><td width="30%" valign="top">
			<p class="tabletext">
                        <%
                            myParams = commonParameters + HttpRequestConstants.CATALOG_CATEGORY_ID + "=" + 
                                               java.net.URLEncoder.encode(subcategory.getKey().getIdentifier());
                        %>
			<a href="<webflow:createWebflowURL event="link.browse" namespace="sampleapp_main" extraParams="<%= myParams %>" />">
			<catalog:getProperty object="<%= subcategory %>" propertyName="Name"/></a>
			</p>
		</td></tr>
	</catalog:iterateViewIterator>
	</table>
	</center>
<hr size="1" width="90%" align="left">	

<%-- If any individual items at this level, they are summarized here --%>

	<%-- Iterate through all items in the current view and display summary information about each --%>
	<catalog:iterateThroughView iterator="<%= items %>" id="item" 
	returnType="com.beasys.commerce.ebusiness.catalog.ProductItem" viewIndex="<%= viewIndex %>">	
	
		<%-- Add the required parameters for the included JSP to the request --%>
		<% request.setAttribute("product_item", item); %>
		<% request.setAttribute("details_link", "details"); %>
		
		<%-- Get the summary JSP from the current product item --%>
		<catalog:getProperty object="<%= item %>" 
			propertyName="Jsp" 
			getterArgument="<%= new Integer(ProductItem.SUMMARY_DISPLAY_JSP_INDEX) %>"
			id="summaryJsp"
			returnType="com.beasys.commerce.ebusiness.catalog.JspInfo"/>

		<%-- Include the summary JSP --%>
		<jsp:include page="<%= summaryJsp.getUrl() %>" flush="true"/>
		
	</catalog:iterateThroughView>

<%-- Add "Next" and "Previous" bottom navigation --%>
<% if (items.size() > 0) { %>
<table border="0" width="90%" cellpadding="3">
   <tr>
    <td align="left"><b>Category Items</b></td>
    <td align="right">
	<%-- Add "Previous" link --%>
	<% if (items.hasPreviousView()) { 
            myParams = commonParameters + HttpRequestConstants.CATALOG_CATEGORY_ID + "=" + java.net.URLEncoder.encode(category.getKey().getIdentifier()) + 
                       "&" + HttpRequestConstants.CATALOG_VIEW_INDEX + "=" + (viewIndex - 1);

        %>
	   <b><a href="<webflow:createWebflowURL event="link.browse" namespace="sampleapp_main" extraParams="<%= myParams %>" />">Previous</a> | </b>
	<% } %>
	<%-- Add current view indicies --%>
	<% if (items.size() > 1) { %>
		<b><%= items.getCurrentView().getFirstIndex() %> - <%= items.getCurrentView().getLastIndex() %></b>
	<% } %>
	<%-- Add "Next" link --%>
	<% if (items.hasNextView()) { 
            myParams = commonParameters + HttpRequestConstants.CATALOG_CATEGORY_ID + "=" + java.net.URLEncoder.encode(category.getKey().getIdentifier()) + 
                       "&" + HttpRequestConstants.CATALOG_VIEW_INDEX + "=" + (viewIndex + 1);

        %>
	<b> | <a href="<webflow:createWebflowURL event="link.browse" namespace="sampleapp_main" extraParams="<%= myParams %>" />">Next</a></b></td>
<% } %>
</tr>
</table>
<% } %>
