<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<!-- ------------------------------------------------------------ -->
<!-- This JSP displays detail information for a Catalog product	  -->
<!-- item.  It relies on the following request attributes to be   -->
<!-- initialized by the parent JSP:                               -->
<!--                                                              -->
<!-- Request parameter:  Description:                             -->
<!-- product_item        The item from which summary information  -->
<!--                     will be retrieved.                       -->
<!--                                                              -->
<!-- Additionally, the following PipelineSession properties must  -->
<!-- exist:                                                       -->
<!--                                                              -->
<!-- Property:           Description:                             -->
<!-- CATEGORY            The Category to which the item belongs.  -->
<!-- ------------------------------------------------------------ -->

<%@ taglib uri="webflow.tld" prefix="webflow" %>
<%@ taglib uri="cat.tld" prefix="catalog" %>
<%@ taglib uri="i18n.tld" prefix="i18n" %>

<%@ page import="com.beasys.commerce.ebusiness.catalog.*" %>
<%@ page import="com.beasys.commerce.webflow.HttpRequestConstants" %>
<%@ page import="com.beasys.commerce.webflow.PipelineSessionConstants" %>

<%@ page import="com.bea.p13n.appflow.webflow.WebflowJSPHelper" %>


<table border="0" width="90%" cellpadding="3">
<tr>

<%-- Get all required parameters from the request object --%>
<% ProductItem productItem = (ProductItem)request.getAttribute("product_item"); %>

<%-- Get the current category from the PipelineSession --%>
	<webflow:getProperty id="category" property="<%=PipelineSessionConstants.CATALOG_CATEGORY%>" type="com.beasys.commerce.ebusiness.catalog.Category" scope="request" namespace="sampleapp_main" />
<%        
        String allParams = null;
%>

<%-- Fire Behavior Tracking display event --%>

<%-- Add the small image and large image link --%>
<catalog:getProperty object="<%= productItem %>"
	propertyName="Image"
	getterArgument="<%= new Integer(ProductItem.SMALL_IMAGE_INDEX) %>"
	id="smallImage"
	returnType="com.beasys.commerce.ebusiness.catalog.ImageInfo"/>

<catalog:getProperty object="<%= productItem %>"
	propertyName="Image"
	getterArgument="<%= new Integer(ProductItem.LARGE_IMAGE_INDEX) %>"
	id="largeImage"
	returnType="com.beasys.commerce.ebusiness.catalog.ImageInfo"/>

<td align="left" valign="top">
	<% if (smallImage.getUrl() != null && smallImage.getUrl().length() > 0) { %>
		<% if (largeImage.getUrl() != null && largeImage.getUrl().length() > 0) { %>
		<a href="<webflow:createResourceURL resource="<%= largeImage.getUrl() %>" />">
		<% } %>
		<img src="<webflow:createResourceURL resource="<%= smallImage.getUrl()%>" />" hspace="5" border="0"></a>
	<% } %>

<%-- This section provides a link to view a larger version
     of the product image if a URL to one exists in the
     database. Uncomment the section following this comment
     to implement this feature.
--%>

<%--
      <% if (largeImage.getUrl() != null && largeImage.getUrl().length() > 0) { %>
		<div class="tabletext"><a href="<webflow:createResourceURL resource="<%= largeImage.getUrl() %>" />">View larger image.</a></div>
	<% } %>
--%>
</td>

<td align="left" valign="top" width="95%">

<%-- Add the item name and creator --%>
<p class="head2"><catalog:getProperty object="<%= productItem %>" propertyName="Name"/></p>
<p><catalog:getProperty object="<%= productItem %>" propertyName="Creator"/></p><br>

<%-- Add the item price --%>
<catalog:getProperty object="<%= productItem %>"
	propertyName="CurrentPrice"
	id="price"
	returnType="com.beasys.commerce.axiom.units.Money"/>
<catalog:getProperty object="<%= productItem %>"
	propertyName="Msrp"
	id="msrp"
	returnType="com.beasys.commerce.axiom.units.Money"/>
<p><b>Our price: <font color="#333399"><i18n:getMessage bundleName="/commerce/currency" messageName="<%= price.getCurrency() %>"/><%= WebflowJSPHelper.priceFormat(price.getValue()) %></font></b>
(Reg. <i18n:getMessage bundleName="/commerce/currency" messageName="<%= msrp.getCurrency() %>"/><%= WebflowJSPHelper.priceFormat(msrp.getValue()) %>)
</p>

<%-- Add inventory information --%>
<catalog:getProperty object="<%= productItem %>"
	propertyName="Availability"
	id="inventory"
	returnType="com.beasys.commerce.ebusiness.catalog.InventoryInfo"/>
<p>
<b>
<% if (inventory.getInStock()) { %>
In stock (<%= inventory.getShippingTime() %>)
<% } else { %>
Out of stock
<% } %>
</b>
</p>

<%-- Add the description --%>
<hr size="1">
<p>
<catalog:getProperty object="<%= productItem %>"
	propertyName="Description"
	getterArgument="<%= new Integer(CatalogItem.LONG_DESCRIPTION_INDEX) %>" />
</p>
</td>

<%-- Add the 'Put in Cart' link --%>
<%
    allParams = HttpRequestConstants.CATALOG_ITEM_SKU + "=" + productItem.getKey().getIdentifier();
%>

<td align="right" valign="top" width="5%"><a href="<webflow:createWebflowURL event="link.add" namespace="sampleapp_order" extraParams="<%= allParams %>" />">
	<img src="<webflow:createResourceURL resource="/commerce/images/btn_addcart.gif" />" border="0" alt="Add to Shopping Cart"></a>
</td>

</tr>
</table>
<hr size="1" width="90%" align="left">
