<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<!-- ------------------------------------------------------------ -->
<!-- This JSP displays summary information for a Catalog product  -->
<!-- item.  It relies on the following request attributes to be   -->
<!-- initialized by the parent JSP:                               -->
<!--                                                              -->
<!-- Request parameter:  Description:                             -->
<!-- product_item        The item from which summary information  -->
<!--                     will be retrieved.                       -->
<!-- details_link        The link event for details.              -->
<!--                                                              -->
<!-- Additionally, the following PipelineSession properties must  -->
<!-- exist:                                                       -->
<!--                                                              -->
<!-- Property:           Description:                             -->
<!-- CATEGORY            The Category to which the item belongs.  -->
<!-- ------------------------------------------------------------ -->

<%@ taglib uri="webflow.tld" prefix="webflow" %>
<%@ taglib uri="cat.tld" prefix="catalog" %>
<%@ taglib uri="es.tld" prefix="es" %>
<%@ taglib uri="i18n.tld" prefix="i18n" %> 

<%@ page import="java.text.NumberFormat" %>
<%@ page import="com.beasys.commerce.ebusiness.catalog.*" %>
<%@ page import="com.beasys.commerce.webflow.HttpRequestConstants" %>
<%@ page import="com.beasys.commerce.webflow.PipelineSessionConstants" %>

<%@ page import="com.bea.p13n.appflow.webflow.WebflowJSPHelper" %>

<table border="0" width="90%" cellpadding="3">
<tr>

<%-- Get all required parameters from the request object --%>
<% ProductItem productItem = (ProductItem)request.getAttribute("product_item"); %>
<% String detailsLink = (String)request.getAttribute("details_link"); %>

<%-- Get the current category from the PipelineSession --%>
	<webflow:getProperty id="category" property="<%=PipelineSessionConstants.CATALOG_CATEGORY%>" type="com.beasys.commerce.ebusiness.catalog.Category" scope="request" namespace="sampleapp_main" />

<%-- Fire Behavior Tracking display event --%>

<%-- Add the small image --%>
<catalog:getProperty object="<%= productItem %>"
	propertyName="Image"
	getterArgument="<%= new Integer(ProductItem.SMALL_IMAGE_INDEX) %>"
	id="smallImage"
	returnType="com.beasys.commerce.ebusiness.catalog.ImageInfo"/>

<td valign="top"><img src="<webflow:createResourceURL resource="<%=smallImage.getUrl()%>"/>" align="left"></td>
<td align="left" valign="top" width="90%">

<%-- Add the item name and creator --%>
<%-- Create the details link --%>
<% String detailsUrl = null; %>
<es:isNull item="<%= category %>">
<%
    detailsUrl = WebflowJSPHelper.createWebflowURL(pageContext, "sampleapp_main", "itemsummary.jsp", "link." + detailsLink, null, 
                 HttpRequestConstants.CATALOG_ITEM_SKU + "=" + productItem.getKey().getIdentifier() + "&" + HttpRequestConstants.DOCUMENT_TYPE + 
                 "=" + detailsLink, true, false);
%>
</es:isNull>
<es:notNull item="<%= category %>">
<%
    detailsUrl = WebflowJSPHelper.createWebflowURL(pageContext, "sampleapp_main", "itemsummary.jsp", "link." + detailsLink, null,
                 HttpRequestConstants.CATALOG_ITEM_SKU + "=" + productItem.getKey().getIdentifier() + "&" +
                 HttpRequestConstants.CATALOG_CATEGORY_ID + "=" + category.getKey().getIdentifier() + "&" +
                 HttpRequestConstants.DOCUMENT_TYPE + "=" + detailsLink, true, false);
%>
</es:notNull>

<div class="tabletext">
<b>

<%-- we will fire off a clickProductEvent when the user clicks on the product details to see this product --%>
<!--
<productTracking:clickProductEvent id="url" documentId="<%= productItem.getName() %>"
	                           sku="<%= productItem.getKey().getIdentifier() %>" />

<!--%detailsUrl = detailsUrl + "&" + url; %>
<a href="<%= detailsUrl %>">
-->
<catalog:getProperty object="<%= productItem %>" propertyName="Name"/>
<!--
</a>
-->
</b>,
<catalog:getProperty object="<%= productItem %>" propertyName="Creator"/>
</div>

<%-- Add the item price --%>
<div class="tabletext">
<b>

<catalog:getProperty object="<%= productItem %>"
	propertyName="CurrentPrice"
	id="price"
	returnType="com.beasys.commerce.axiom.units.Money"/>
<i18n:getMessage bundleName="/commerce/currency" messageName="<%= price.getCurrency() %>"/><%= WebflowJSPHelper.priceFormat(price.getValue()) %>
</b>, Reg.
<catalog:getProperty object="<%= productItem %>"
	propertyName="Msrp"
	id="msrp"
	returnType="com.beasys.commerce.axiom.units.Money"/>
<i18n:getMessage bundleName="/commerce/currency" messageName="<%= msrp.getCurrency() %>"/><%= WebflowJSPHelper.priceFormat(msrp.getValue()) %>
</b></div>

<%-- Add inventory information --%>
<catalog:getProperty object="<%= productItem %>"
	propertyName="Availability"
	id="inventory"
	returnType="com.beasys.commerce.ebusiness.catalog.InventoryInfo"/>
<div class="tabletext"><b>
<% if (inventory.getInStock()) { %>
In stock (<%= inventory.getShippingTime() %>)
<% } else { %>
Out of stock.
<% } %>
</b>
</div>

<%-- Add a short description of the item --%>
<br>
<div class="tabletext">
<catalog:getProperty object="<%= productItem %>"
	propertyName="Description"
	getterArgument="<%= new Integer(CatalogItem.SHORT_DESCRIPTION_INDEX) %>" />
</div>

<%-- Add the 'Add to Cart' link --%>
<div align="right">

<%
    String tmpParams = HttpRequestConstants.CATALOG_ITEM_SKU + "=" + productItem.getKey().getIdentifier();
%>

<a href="<webflow:createWebflowURL event="link.add" namespace="sampleapp_order" extraParams="<%=tmpParams%>"/>"><img src="<webflow:createResourceURL resource="/commerce/images/btn_addcart.gif"/>" alt="Add To Shopping Cart" border="0" vspace="4"></a>

</div>

</td>
</tr>
</table>
<hr size="1" width="90%" align="left">
