<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<!-- ------------------------------------------------------------ -->
<!-- This JSP displays a navigation bar that allows a user to     -->
<!-- navigate through a hierarchy of categories.  This included   -->
<!-- JSP requires the following PipelineSession properties:       -->
<!--                                                              -->
<!-- Property:           Description:                             -->
<!-- CATEGORY            The Category to which the item belongs.  -->
<!-- ANCESTORS           The ancestors of the Category.           -->
<!-- ------------------------------------------------------------ -->
<%@ taglib uri="webflow.tld" prefix="webflow" %>
<%@ taglib uri="cat.tld" prefix="catalog" %>
<%@ taglib uri="es.tld" prefix="es" %>

<%@ page import="com.beasys.commerce.ebusiness.catalog.*" %>
<%@ page import="com.beasys.commerce.webflow.HttpRequestConstants" %>
<%@ page import="com.beasys.commerce.webflow.PipelineSessionConstants" %>

<%-- Get the current category from the PipelineSession --%>
	<webflow:getProperty id="category" property="<%=PipelineSessionConstants.CATALOG_CATEGORY%>" type="com.beasys.commerce.ebusiness.catalog.Category" scope="request" namespace="sampleapp_main" />
<%
        String theParams = null;
%>

<%-- Only output the navigation bar if a current category exists in the PipelineSession --%>
<es:notNull item="<%= category %>">

<%-- Get the category's ancestors from the PipelineSession --%>
	<webflow:getProperty id="ancestors" property="<%=PipelineSessionConstants.CATALOG_ANCESTORS%>" type="com.beasys.commerce.ebusiness.catalog.Category[]" scope="request" namespace="sampleapp_main" />

<%-- Declare a String containing common browse parameters --%>
<%! static final String commonParameters = HttpRequestConstants.CATALOG_SOURCE_KEY + "=" + PipelineSessionConstants.CATALOG_CATEGORIES + "&" + 
	HttpRequestConstants.CATALOG_DESTINATION_KEY + "=wlcs_siblings&"; %>

<%-- Iterate through all the category's ancestors, creating a browse link for each --%>
<es:forEachInArray id="ancestor" type="com.beasys.commerce.ebusiness.catalog.Category" array="<%= ancestors %>" counterId="i">

	<%-- Add a link to the main catalog page in the case of the last ancestor --%>	
	<% if (i.intValue() == 0) { %>
		<p><a href="<webflow:createWebflowURL event="link.home" namespace="sampleapp_main" />">Home</a>

	<%-- Otherwise, link to the browse page for the current ancestor --%>
	<% } else { 
                theParams = commonParameters + HttpRequestConstants.CATALOG_CATEGORY_ID + "=" + java.net.URLEncoder.encode(ancestor.getKey().getIdentifier());
        %>
		<a href="<webflow:createWebflowURL event="link.browse" namespace="sampleapp_main" extraParams="<%= theParams %>" />">
		<catalog:getProperty object="<%= ancestor %>" propertyName="Name"/></a>
	<% } %>
	&nbsp;<b>&gt;</b>
</es:forEachInArray>

<%-- Insert the category link --%>
<%
    theParams = commonParameters + HttpRequestConstants.CATALOG_CATEGORY_ID + "=" + java.net.URLEncoder.encode(category.getKey().getIdentifier());
%>
<b><a href="<webflow:createWebflowURL event="link.browse" namespace="sampleapp_main" extraParams="<%= theParams %>" />">
<catalog:getProperty object="<%= category %>" propertyName="Name"/></a></b>

</es:notNull>
