<%-- Copyright (c) 2002 by BEA Systems, Inc. All Rights Reserved. --%>

<!-- start /portlets/catalog/category.jsp -->

<%@ taglib uri="cat.tld" prefix="catalog" %>
<%@ taglib uri="portlet.tld" prefix="portlet" %>
<%@ taglib uri="webflow.tld" prefix="webflow" %>
<%@ taglib uri="i18n.tld" prefix="i18n" %>

<%@ page import="com.beasys.commerce.ebusiness.catalog.CatalogItem" %>
<%@ page import="com.beasys.commerce.webflow.HttpRequestConstants" %>
<%@ page import="com.beasys.commerce.webflow.PipelineSessionConstants" %>
<%@ page import="com.bea.p13n.appflow.webflow.WebflowJSPHelper" %>

<%@ include file="/framework/resourceURL.inc" %>

<%-- Get the category from the pipeline session --%>

<webflow:getProperty
    id="category"
    type="com.beasys.commerce.ebusiness.catalog.Category"
    property="<%= PipelineSessionConstants.CATALOG_CATEGORY %>"
    scope="session"
    namespace="portal" />

<catalog:getProperty
    id="categoryKey"
    returnType="com.beasys.commerce.ebusiness.catalog.CategoryKey"
    object="<%= category %>"
    propertyName="key" />

<catalog:getProperty
    id="headerImage"
    returnType="com.beasys.commerce.ebusiness.catalog.ImageInfo"
    object="<%= category %>"
    propertyName="image"
    getterArgument="<%= new Integer( CatalogItem.SMALL_IMAGE_INDEX ) %>" />

<%-- Get the items view iterator from the pipeline session --%>

<webflow:getProperty
    id="items"
    type="com.beasys.commerce.ebusiness.catalog.ViewIterator"
    property="<%= PipelineSessionConstants.CATALOG_ITEMS %>"
    scope="session"
    namespace="portal" />

<table cellpadding="0" cellspacing="0" border="0" width="561">
    <tr valign="top">
        <td><img src="framework/images/dot.gif" width="10" height="1" alt="" border="0"></td><!-- 10px space -->
        <td width="547" valign="top">
            <table cellpadding="0" cellspacing="0" border="0" width="547">
                <tr valign="top">
                    <td colspan="3"><img src="<webflow:createResourceURL resource="<%=headerImage.getUrl()%>"/>" width="361" height="48" alt="" border="0"></td>
                </tr>
                <tr class="bgffcc33" valign="top">
                    <td colspan="3"><img src="framework/images/dot.gif" width="1" height="4" alt="" border="0"></td>
                </tr>
                <tr valign="top">    
                    <td colspan="3"><img src="framework/images/dot.gif" width="1" height="3" alt="" border="0"></td>
                </tr>
                <tr valign="top">
<%-- Iterate through the items and display each one --%>

<catalog:iterateViewIterator
    id="item"
    returnType="com.beasys.commerce.ebusiness.catalog.ProductItem"
    iterator="<%= items %>">

    <catalog:getProperty
        id="itemImage"
        returnType="com.beasys.commerce.ebusiness.catalog.ImageInfo"
        object="<%= item %>"
        propertyName="image"
        getterArgument="<%= new Integer( CatalogItem.SMALL_IMAGE_INDEX ) %>" />

    <catalog:getProperty
        id="currentPrice"
        returnType="com.beasys.commerce.axiom.units.Money"
        object="<%= item %>"
        propertyName="currentPrice" />

    <catalog:getProperty 
        id="shortDesc"
        returnType="java.lang.String"
        object="<%= item %>" 
        propertyName="description" 
        getterArgument="<%= new Integer( CatalogItem.SHORT_DESCRIPTION_INDEX ) %>" />

    <catalog:getProperty 
        id="itemKey"
        returnType="com.beasys.commerce.ebusiness.catalog.ProductItemKey"
        object="<%= item %>" 
        propertyName="key" />

<%-- Set up the HTTP request parameters for this item's detail link --%>

<% 
   String linkParams = 
       HttpRequestConstants.CATALOG_CATEGORY_ID + "=" + 
           java.net.URLEncoder.encode( categoryKey.getIdentifier() ) + "&" +
       HttpRequestConstants.CATALOG_ITEM_SKU + "=" + itemKey.getIdentifier();
%>
                <td>
                    
                <table cellpadding="0" cellspacing="0" border="0"><tr>
                    <td colspan="3"><a href="<portlet:createWebflowURL namespace="catalogportlet" event="link.item" extraParams="<%=linkParams%>" />"><img src="<webflow:createResourceURL resource="<%=itemImage.getUrl()%>"/>" width="180" height="139" alt="" border="0"></a></td>
                </tr><tr>
                    <td><img src="framework/images/dot.gif" width="7" height="1" alt="" border="0"></td>                
                    <td width="162" class="catalogPrice2"><i18n:getMessage bundleName="/commerce/currency" messageName="<%= currentPrice.getCurrency() %>"/><%=WebflowJSPHelper.priceFormat(currentPrice.getValue())%></td>
                    <td><img src="framework/images/dot.gif" width="11" height="1" alt="" border="0"></td>
                </tr>
                <tr valign="top">
                    <td colspan="3"><img src="framework/images/dot.gif" width="1" height="4" alt="" border="0"></td>
                </tr>
                <tr valign="top">
                    <td><img src="framework/images/dot.gif" width="7" height="1" alt="" border="0"></td>
                    <td class="productPortlet"><%=shortDesc%></td>
                    <td><img src="framework/images/dot.gif" width="11" height="1" alt="" border="0"></td>
                </tr>
                <tr valign="top">
                    <td colspan="3"><img src="framework/images/dot.gif" width="1" height="6" alt="" border="0"></td>
                </tr>
                <tr valign="top">    
                    <td><img src="framework/images/dot.gif" width="7" height="1" alt="" border="0"></td>                
                    <td><a href="<portlet:createWebflowURL namespace="catalogportlet" event="link.item" extraParams="<%=linkParams%>" />"><img src="<webflow:createResourceURL resource='<%=imagesPath + "prod_step2_details.gif"%>'/>" width="53" height="13" alt="" border="0"></a></td>
                    <td><img src="framework/images/dot.gif" width="11" height="20" alt="" border="0"></td>
                </tr>
                <tr valign="top">    
                    <td><img src="framework/images/dot.gif" width="7" height="1" alt="" border="0"></td>                
                    <td>
                        <!--<a href="<portlet:createWebflowURL namespace="catalogportlet" event="button.category.buy" extraParams="<%= linkParams %>" />"><img src="<webflow:createResourceURL resource='<%=imagesPath + "prod_step2_addtocart.gif"%>'/>" width="74" height="18" alt="" border="0"></a>&nbsp;<a href="<portlet:createWebflowURL namespace="catalogportlet" event="button.category.save" extraParams="<%= linkParams %>" />"><img src="<webflow:createResourceURL resource='<%=imagesPath + "prod_step2_savelater.gif"%>'/>" width="72" height="18" alt="" border="0"></a>-->
                        <a href="<portlet:createWebflowURL pageName="Shopping Cart" portletName="checkout" event="expressCheckout" extraParams="<%= linkParams %>" />"><img src="<webflow:createResourceURL resource='<%=imagesPath + "prod_step2_xcheckout.gif"%>'/>" width="105" height="18" alt="" border="0"></a>
                    </td>
                    <td><img src="framework/images/dot.gif" width="11" height="1" alt="" border="0"></td>
                </tr>
                <tr valign="top">                                    
                    <td colspan="3"><img src="framework/images/dot.gif" width="1" height="12" alt="" border="0"></td>
                </tr></table
                
                
                </td>
</catalog:iterateViewIterator>

<%-- Reset the category view iterator in case the portlet gets refreshed --%>

<% items.gotoViewAt( 0 ); %>
            </tr><tr class="bgcccccc" valign="top">
                <td colspan="3"><img src="framework/images/dot.gif" width="1" height="1" alt="" border="0"></td>
            </tr><tr>
                <td colspan="3"><img src="framework/images/dot.gif" width="1" height="10" alt="" border="0"></td>
            </tr><tr>
                <td colspan="3"><img src="<webflow:createResourceURL resource='<%=imagesPath + "banner1.jpg"%>'/>" width="547" height="72" alt="" border="0"></td>                
            </tr>
            </table>
        </td>
        <td valign="top"><img src="framework/images/dot.gif" width="4" height="1" alt="" border="0"></td><!-- 11px space -->
    </tr>
</table>

<!-- end /portlets/catalog/category.jsp -->
