<%-- Copyright (c) 2002 by BEA Systems, Inc. All Rights Reserved. --%>

<!-- start /portlets/catalog/item.jsp -->

<%@ taglib uri="cat.tld" prefix="catalog" %>
<%@ taglib uri="portlet.tld" prefix="portlet" %>
<%@ taglib uri="webflow.tld" prefix="webflow" %>
<%@ taglib uri="i18n.tld" prefix="i18n" %>
<%@ taglib uri="portal.tld" prefix="portal" %>

<%@ page import="java.util.Random" %>
<%@ page import="com.beasys.commerce.ebusiness.catalog.CatalogItem" %>
<%@ page import="com.beasys.commerce.webflow.HttpRequestConstants" %>
<%@ page import="com.beasys.commerce.webflow.PipelineSessionConstants" %>
<%@ page import="examples.e2e.b2c.util.B2CPortalConstants" %>
<%@ page import="com.bea.p13n.appflow.webflow.WebflowJSPHelper" %>
<%@ page import="com.bea.portal.appflow.PortalAppflowConstants" %>

<%@ include file="/framework/resourceURL.inc" %>

<%-- These files contain accessories that will be displayed for certain
     product categories. --%>

<%!

    protected static final String[] ACCESSORIES_JSP_INCLUDES =
        { "/portlets/catalog/item_accessories1.jsp",
          "/portlets/catalog/item_accessories2.jsp",
          "/portlets/catalog/item_accessories3.jsp" };
%>

<%-- Get the item's category from the pipeline session --%>

<webflow:getProperty
    id="category"
    type="com.beasys.commerce.ebusiness.catalog.Category"
    property="<%= PipelineSessionConstants.CATALOG_CATEGORY %>"
    scope="session"
    namespace="portal" />


<catalog:getProperty
    id="categoryName"
    returnType="java.lang.String"
    object="<%= category %>"
    propertyName="name" />


<webflow:getProperty
    id="item"
    type="com.beasys.commerce.ebusiness.catalog.ProductItem"
    property="<%= PipelineSessionConstants.CATALOG_ITEM %>"
    scope="session"
    namespace="portal" />


<catalog:getProperty
    id="itemName"
    returnType="java.lang.String"
    object="<%= item %>"
    propertyName="name" />


<%-- The product name gets displayed in two fonts so split the name
     into two parts. --%>

<%
    StringTokenizer tokenizer = new StringTokenizer( itemName, " " );

    String itemNamePart1 = tokenizer.nextToken();
    String itemNamePart2 = "";

    if ( tokenizer.hasMoreElements() )
    {
        itemNamePart2 = tokenizer.nextToken();
    }
%>

<catalog:getProperty
    id="itemImage"
    returnType="com.beasys.commerce.ebusiness.catalog.ImageInfo"
    object="<%= item %>"
    propertyName="image"
    getterArgument="<%= new Integer( CatalogItem.LARGE_IMAGE_INDEX ) %>" />

<catalog:getProperty
    id="currentPrice"
    returnType="com.beasys.commerce.axiom.units.Money"
    object="<%= item %>"
    propertyName="currentPrice" />

<catalog:getProperty
    id="longDesc"
    returnType="java.lang.String"
    object="<%= item %>"
    propertyName="description"
    getterArgument="<%= new Integer( CatalogItem.LONG_DESCRIPTION_INDEX ) %>" />

<catalog:getProperty
    id="itemKey"
    returnType="com.beasys.commerce.ebusiness.catalog.ProductItemKey"
    object="<%= item %>"
    propertyName="key" />

<%

String linkParams = HttpRequestConstants.CATALOG_ITEM_SKU + "=" + itemKey.getIdentifier();



%>

<table cellpadding="0" cellspacing="0" border="0" width="561">
    <tr valign="top">
        <td><img src="framework/images/dot.gif" width="10" height="1" alt="" border="0"></td><!-- 10px space -->
        <td width="547" valign="top">
            <table cellpadding="0" cellspacing="0" border="0" width="361">
                <tr>
                    <td valign="top" width="27"><img src="<webflow:createResourceURL resource='<%=imagesPath + "prod_step3_header_icon.gif"%>'/>" width="27" height="47" alt="" border="0"></td>
                    <td wdith="520"><img src="framework/images/dot.gif" width="520" height="10" alt="" border="0"><br><span class="catalogHeader1"><%=itemNamePart1%></span> <span class="catalogHeader2"><%=itemNamePart2%></span></td>
                </tr>
                <tr class="bgcccccc" valign="top">
                    <td colspan="2"><img src="framework/images/dot.gif" width="1" height="1" alt="" border="0"></td>
                </tr>
                <tr class="bgffcc33" valign="top">
                    <td colspan="2"><img src="framework/images/dot.gif" width="1" height="4" alt="" border="0"></td>
                </tr>
                <tr valign="top">
                    <td colspan="2"><img src="framework/images/dot.gif" width="1" height="3" alt="" border="0"></td>
                </tr></table>
            <table cellpadding="0" cellspacing="0" border="0" width="361"><tr>
                <td>
                <table cellpadding="0" cellspacing="0" border="0" width="344"><tr>
                    <td colspan="2"><img src="<webflow:createResourceURL resource="<%=itemImage.getUrl()%>"/>" width="344" height="170" alt="" border="0"></td>
                </tr><tr valign="top">
                    <td colspan="2"><img src="framework/images/dot.gif" width="1" height="8" alt="" border="0"></td>
                </tr>
                <tr>
                    <td valign="top" width="344">
                        <table cellpadding="0" cellspacing="0" border="0" width="344">
                            <tr valign="top">
                                <td rowspan="6" width="9"><img src="framework/images/dot.gif" width="9" height="1" alt="" border="0"></td>
                                <td colspan="2" width="333" class="catalogPrice1"><i18n:getMessage bundleName="/commerce/currency" messageName="<%= currentPrice.getCurrency() %>"/><%=WebflowJSPHelper.priceFormat(currentPrice.getValue())%></td>
                            </tr>
                            <tr valign="top">
                                <td colspan="2"><img src="framework/images/dot.gif" width="1" height="8" alt="" border="0"></td>
                            </tr>
                            <tr valign="top">
                                <td class="productPortlet"><%=longDesc%></td>
                                <td width="17"><img src="framework/images/dot.gif" width="17" height="1" alt="" border="0"></td>
                            </tr>
                            <tr valign="top">
                                <td colspan="2"><img src="framework/images/dot.gif" width="1" height="25" alt="" border="0"></td>
                            </tr>
                            <tr valign="top">
                                <td colspan="2">
                                  <a href="<portlet:createWebflowURL event="button.item.buy" extraParams="<%= linkParams %>" />"><img src="<webflow:createResourceURL resource='<%=imagesPath + "prod_step2_addtocart.gif"%>'/>" width="74" height="18" alt="" border="0"></a>&nbsp;
                                  <a href="<portlet:createWebflowURL pageName="Shopping Cart" portletName="checkout" event="expressCheckout" extraParams="<%= linkParams %>" />"><img src="<webflow:createResourceURL resource='<%=imagesPath + "prod_step2_xcheckout.gif"%>'/>" width="105" height="18" alt="" border="0"></a>
                                  <!-- <a href="<portlet:createWebflowURL event="button.item.save" extraParams="<%= linkParams %>" />"><img src="<webflow:createResourceURL resource='<%=imagesPath + "prod_step2_savelater.gif"%>'/>" width="72" height="18" alt="" border="0"></a> -->
                              </td>
                            </tr>
                            <tr valign="top">
                                <td colspan="2"><img src="framework/images/dot.gif" width="1" height="14" alt="" border="0"></td>
                            </tr>
                        </table>
                    </td></table>
                <td><img src="framework/images/dot.gif" width="22" height="1" alt="" border="0"></td>
                <td valign="top">
<%-- If we're in the consumer, pro, or video camera categories then display
     a random selection of accessories. There are other, better, ways of doing
     this with WLP -- the method used here was chosen to keep things simple for
     the End to End sample. --%>

<%
   if ( categoryName.equals( B2CPortalConstants.CONSUMER_CATEGORY_NAME ) ||
        categoryName.equals( B2CPortalConstants.PRO_CATEGORY_NAME ) ||
        categoryName.equals( B2CPortalConstants.VIDEO_CATEGORY_NAME ) )
   {
       Random random = new Random();

       int index = random.nextInt( 100 ) % 3;
       String accessoriesInc = ACCESSORIES_JSP_INCLUDES[index];
%>
<jsp:include page="<%=accessoriesInc%>" flush="true" />

<% } %>
        </td>
    </tr></table>
        </td>
        <td valign="top"><img src="framework/images/dot.gif" width="4" height="1" alt="" border="0"></td><!-- 11px space -->
    </tr>
</table>

<!-- end /portlets/catalog/item.jsp -->
