<!-- start /portlets/cb-catalog/item.jsp -->

<%@ taglib uri="cat.tld" prefix="catalog" %>
<%@ taglib uri="portlet.tld" prefix="portlet" %>
<%@ taglib uri="webflow.tld" prefix="webflow" %>
<%@ taglib uri="i18n.tld" prefix="i18n" %>
<%@ taglib uri="um.tld" prefix="um" %>
<%@ taglib uri="portal.tld" prefix="portal" %>

<%@ page import="java.util.Random" %>
<%@ page import="com.beasys.commerce.ebusiness.catalog.CatalogItem" %>
<%@ page import="com.beasys.commerce.webflow.HttpRequestConstants" %>
<%@ page import="com.beasys.commerce.webflow.PipelineSessionConstants" %>
<%@ page import="examples.e2e.b2c.util.B2CPortalConstants" %>
<%@ page import="com.bea.p13n.appflow.webflow.WebflowJSPHelper" %>
<%@ page import="com.bea.portal.appflow.PortalAppflowConstants" %>

<%@ include file="/framework/resourceURL.inc" %>

<%-- These files contain accessories that will be displayed for certain
     product categories. --%>

<%!

    protected static final String[] ACCESSORIES_JSP_INCLUDES =
        { "/portlets/cb-catalog/item_accessories1.jsp",
          "/portlets/cb-catalog/item_accessories2.jsp",
          "/portlets/cb-catalog/item_accessories3.jsp" };
%>

<%-- Get the item's category from the pipeline session --%>

<webflow:getProperty
    id="category"
    type="com.beasys.commerce.ebusiness.catalog.Category"
    property="<%= PipelineSessionConstants.CATALOG_CATEGORY %>"
    scope="session"
    namespace="portal" />

<catalog:getProperty
    id="categoryName"
    returnType="java.lang.String"
    object="<%= category %>"
    propertyName="name" />

<webflow:getProperty
    id="item"
    type="com.beasys.commerce.ebusiness.catalog.ProductItem"
    property="<%= PipelineSessionConstants.CATALOG_ITEM %>"
    scope="session"
    namespace="portal" />

<catalog:getProperty
    id="itemName"
    returnType="java.lang.String"
    object="<%= item %>"
    propertyName="name" />

<%-- The product name gets displayed in two fonts so split the name
     into two parts. --%>

<%
    StringTokenizer tokenizer = new StringTokenizer( itemName, " " );

    String itemNamePart1 = tokenizer.nextToken();
    String itemNamePart2 = "";

    if ( tokenizer.hasMoreElements() )
    {
        itemNamePart2 = tokenizer.nextToken();
    }
%>

<catalog:getProperty
    id="itemImage"
    returnType="com.beasys.commerce.ebusiness.catalog.ImageInfo"
    object="<%= item %>"
    propertyName="image"
    getterArgument="<%= new Integer( CatalogItem.LARGE_IMAGE_INDEX ) %>" />

<catalog:getProperty
    id="currentPrice"
    returnType="com.beasys.commerce.axiom.units.Money"
    object="<%= item %>"
    propertyName="currentPrice" />

<catalog:getProperty
    id="longDesc"
    returnType="java.lang.String"
    object="<%= item %>"
    propertyName="description"
    getterArgument="<%= new Integer( CatalogItem.LONG_DESCRIPTION_INDEX ) %>" />

<catalog:getProperty
    id="itemKey"
    returnType="com.beasys.commerce.ebusiness.catalog.ProductItemKey"
    object="<%= item %>"
    propertyName="key" />

<%

String sku = itemKey.getIdentifier();
String linkParams = HttpRequestConstants.CATALOG_ITEM_SKU + "=" + sku;

if ("false".equals(request.getParameter("uc1_ws_deploy")))
{
    session.removeAttribute("uc1_ws_deploy");
    %>The Store Locator WS has been disabled. Click <a href="<portal:createWebflowURL event='<%=PortalAppflowConstants.PORTAL_REFRESH%>'/>">here</a> to see the changes.<%
}
else if (session.getAttribute("uc1_ws_deploy") != null)
{
    %><a href="<portal:createWebflowURL event='<%=PortalAppflowConstants.PORTAL_REFRESH%>' extraParams='uc1_ws_deploy=false'/>">Undeploy WS</a><%
}

%>

<table cellpadding="0" cellspacing="0" border="0" width="561">
    <tr valign="top">
        <td><img src="framework/images/dot.gif" width="10" height="1" alt="" border="0"></td><!-- 10px space -->
        <td width="547" valign="top">
            <table cellpadding="0" cellspacing="0" border="0" width="361">
                <tr>
                    <td valign="top" width="27"><img src="<webflow:createResourceURL resource='<%=imagesPath + "prod_step3_header_icon.gif"%>'/>" width="27" height="47" alt="" border="0"></td>
                    <td wdith="520"><img src="framework/images/dot.gif" width="520" height="10" alt="" border="0"><br><span class="catalogHeader1"><%=itemNamePart1%></span> <span class="catalogHeader2"><%=itemNamePart2%></span></td>
                </tr>
                <tr class="bgcccccc" valign="top">
                    <td colspan="2"><img src="framework/images/dot.gif" width="1" height="1" alt="" border="0"></td>
                </tr>
                <tr class="bgffcc33" valign="top">
                    <td colspan="2"><img src="framework/images/dot.gif" width="1" height="4" alt="" border="0"></td>
                </tr>
                <tr valign="top">
                    <td colspan="2"><img src="framework/images/dot.gif" width="1" height="3" alt="" border="0"></td>
                </tr>
            </table>
            <table cellpadding="0" cellspacing="0" border="0" width="361"><tr>
                <td valign="top">
				<img src="<webflow:createResourceURL resource='<%=imagesPath + "click_brick_arrow.gif"%>'/>" width="344" height="29" alt="" border="0">
                <table cellpadding="0" cellspacing="0" border="0" width="344"><tr>
                    <td colspan="2"><img src="<webflow:createResourceURL resource="<%=itemImage.getUrl()%>"/>" width="344" height="170" alt="" border="0"></td>
                </tr><tr valign="top">
                    <td colspan="2"><img src="framework/images/dot.gif" width="1" height="8" alt="" border="0"></td>
                </tr>
                <tr>
                    <td valign="top" width="344">
                        <table cellpadding="0" cellspacing="0" border="0" width="344">
                            <tr valign="top">
                                <td rowspan="6" width="9"><img src="framework/images/dot.gif" width="9" height="1" alt="" border="0"></td>
                                <td colspan="2" width="333" class="catalogPrice1"><i18n:getMessage bundleName="/commerce/currency" messageName="<%= currentPrice.getCurrency() %>"/><%=WebflowJSPHelper.priceFormat(currentPrice.getValue())%></td>
                            </tr>
                            <tr valign="top">
                                <td colspan="2"><img src="framework/images/dot.gif" width="1" height="8" alt="" border="0"></td>
                            </tr>
                            <tr valign="top">
                                <td class="productPortlet"><%=longDesc%></td>
                                <td width="17"><img src="framework/images/dot.gif" width="17" height="1" alt="" border="0"></td>
                            </tr>
                            <tr valign="top">
                                <td colspan="2"><img src="framework/images/dot.gif" width="1" height="25" alt="" border="0"></td>
                            </tr>
                            <tr valign="top">
                                <td colspan="2">
                                  <a href="<portlet:createWebflowURL event="button.item.buy" extraParams="<%= linkParams %>" />"><img src="<webflow:createResourceURL resource='<%=imagesPath + "prod_step2_addtocart.gif"%>'/>" width="74" height="18" alt="" border="0"></a>&nbsp;
                                  <a href="<portlet:createWebflowURL pageName="Shopping Cart" portletName="checkout" event="expressCheckout" extraParams="<%= linkParams %>" />"><img src="<webflow:createResourceURL resource='<%=imagesPath + "prod_step2_xcheckout.gif"%>'/>" width="105" height="18" alt="" border="0"></a>
                                  <!-- <a href="<portlet:createWebflowURL event="button.item.save" extraParams="<%= linkParams %>" />"><img src="<webflow:createResourceURL resource='<%=imagesPath + "prod_step2_savelater.gif"%>'/>" width="72" height="18" alt="" border="0"></a> -->
                              </td>
                            </tr>
                            <tr valign="top">
                                <td colspan="2"><img src="framework/images/dot.gif" width="1" height="14" alt="" border="0"></td>
                            </tr>
                        </table>
                    </td></table>
                <td><img src="framework/images/dot.gif" width="22" height="1" alt="" border="0"></td>
                <td valign="top">

	<!-- start -->
	<!-- START STORE LOCATOR -->

<%@ page import="org.openuri.www.*" %>
<%@ page import="weblogic.jws.proxies.*" %>

 <table cellpadding="0" cellspacing="0" border="0"><tr>
 	<td colspan="3"><img src="<webflow:createResourceURL resource='<%=imagesPath + "click_brick_header.gif"%>'/>" width="181" height="29" alt="" border="0"></td>
</tr><tr>
 	<td><img src="framework/images/dot.gif" width="7" height="1" alt="" border="0"></td>
	<td><img src="framework/images/dot.gif" width="135" height="1" alt="" border="0"></td>
	<td><img src="framework/images/dot.gif" width="39" height="1" alt="" border="0"></td>
</tr>
<%

StoreLocations proxy = (StoreLocations) new StoreLocations_Impl();
StoreLocationsSoap storeService = proxy.getStoreLocationsSoap();

final int DEFAULT_ZIP = 94108;
int intZip = DEFAULT_ZIP;

// use the new user supplied zip, if present
// else, use zip from profile
String zip = request.getParameter("zip");
if (zip == null || zip.length() < 5)
{
    // get the zip code for the store locator web service call
    %>
    <webflow:getProperty id="customer" property="<%=PipelineSessionConstants.USER_NAME%>" type="java.lang.String" scope="session" namespace="portal" />
    <um:getProfile profileKey="<%=customer%>" profileType="WLCS_Customer" />
    <um:getProperty propertySet="CustomerProperties" propertyName="DefaultShippingAddressPostalCode" id="profileZip"/>
    <%
    zip = (String)profileZip;
}

try
{
    intZip = Integer.parseInt(zip);
}
catch (NumberFormatException e)
{
    e.printStackTrace();
    // will use default zip
}

String formParams = linkParams + "&gpskey=Products:catalog:locate.stores";
%>
<tr>
<td><img src="framework/images/dot.gif" width="1" height="1" alt="" border="0"></td>
<portlet:form pageName="Products" event="link.item" extraParams="<%= formParams %>">
<td colspan="2" class="clickbricks">1. Enter Zip Code <input name="zip" type="text" size="2" value="<%=intZip%>"/> &nbsp;<input type="image" src="<webflow:createResourceURL resource='<%=imagesPath + "go.gif"%>'/>" width="23" height="18"  align="absmiddle" value="Refresh"/></td>
</portlet:form>
</tr><tr>
	<td colspan="3"><img src="framework/images/dot.gif" width="1" height="10" alt="" border="0"></td>
</tr><tr>
	<td><img src="framework/images/dot.gif" width="1" height="1" alt="" border="0"></td>
	<td colspan="2" class="clickbricks" width="174">2. Find the Avitek retail partner<br>&nbsp; &nbsp; in your area.</td>
</tr><tr>
	<td colspan="3"><img src="framework/images/dot.gif" width="1" height="5" alt="" border="0"></td>
</tr>
<%
StoreLocationObj[] storeList = storeService.getLocations(sku, intZip);

if (storeList.length == 0)
{
    %>No stores with stock were found!<%
}
else
{
    %>

<tr>
	<td colspan="2"><img src="<webflow:createResourceURL resource='<%=imagesPath + "cb_store_location_title.gif"%>'/>" width="142" height="27" alt="" border="0"></td>
	<td><img src="<webflow:createResourceURL resource='<%=imagesPath + "cb_units_sold_title.gif"%>'/>" width="39" height="27" alt="" border="0"></td>
</tr><tr>
	<td colspan="3"><img src="framework/images/dot.gif" width="1" height="5" alt="" border="0"></td>
</tr>


    <%

    for(int i=0; i < storeList.length && storeList[i] != null; i++)
    {
        StoreLocationObj store = storeList[i];
        String street2 = store.getStreet2();
        if (street2 != null && street2.length() > 0) street2 += "<br>";
        String cbParams = linkParams + "&store_id=" + store.getId();
        %>
 <tr valign="top">
	<td><img src="framework/images/dot.gif" width="1" height="5" alt="" border="0"></td>
    <td class="productboldPortlet"><b>Store No. <%=store.getId()%></b><br>
        <%=store.getStreet1()%><br>
        <%=street2%>
        <%=store.getCity()%>, <%=store.getState()%> <%=store.getZipcode()%><br>
        <%=store.getPhone()%></td>
    <td  class="productboldPortlet" align="center"><%=store.getInstock()%></td>
</tr><tr>
	<td colspan="3"><img src="framework/images/dot.gif" width="1" height="3" alt="" border="0"></td>
</tr><tr>
    <td colspan="3" align="left"><a href="<portlet:createWebflowURL pageName="Shopping Cart" portletName="checkout" event="clicksbricksCheckout" extraParams="<%= cbParams %>" />"><img src="<webflow:createResourceURL resource='<%=imagesPath + "prod_step2_buynow.gif"%>'/>" width="63" height="18" alt="" border="0"></a>
<!--<a href="<portlet:createWebflowURL event="button.item.buy" extraParams="<%= linkParams %>" />"><img src="<webflow:createResourceURL resource='<%=imagesPath + "prod_step2_addtocart.gif"%>'/>" width="74" height="18" alt="" border="0"></a>--></td>
</tr><tr>
	<td colspan="3"><img src="framework/images/dot.gif" width="1" height="7" alt="" border="0"></td>
</tr><tr class="bgcccccc">
	<td colspan="3"><img src="framework/images/dot.gif" width="1" height="1" alt="" border="0"></td>
</tr><tr>
	<td colspan="3"><img src="framework/images/dot.gif" width="1" height="7" alt="" border="0"></td>
</tr>
        <%
    }

    %>
<tr>
	<td colspan="3"><img src="framework/images/dot.gif" width="1" height="10" alt="" border="0"></td>
</tr></table><%
}
%>









	<!-- end -->







        </td>
    </tr></table>
        </td>
        <td valign="top"><img src="framework/images/dot.gif" width="4" height="1" alt="" border="0"></td><!-- 11px space -->
    </tr>
</table>









<%-- If we're in the consumer, pro, or video camera categories then display
     a random selection of accessories. There are other, better, ways of doing
     this with WLP -- the method used here was chosen to keep things simple for
     the End to End sample. --%>

<%
   if ( categoryName.equals( B2CPortalConstants.CONSUMER_CATEGORY_NAME ) ||
        categoryName.equals( B2CPortalConstants.PRO_CATEGORY_NAME ) ||
        categoryName.equals( B2CPortalConstants.VIDEO_CATEGORY_NAME ) )
   {
       Random random = new Random();

       int index = random.nextInt( 100 ) % 3;
       String accessoriesInc = ACCESSORIES_JSP_INCLUDES[index];
%>
<jsp:include page="<%=accessoriesInc%>" flush="true" />

<% } %>

<!-- end /portlets/cb-catalog/item.jsp -->
