<!-- Content from td-myavitek.jsp -->

<p><b>Contents</b>

<ul type="square">
<li><a href="#intro">Introduction</a>
<li><a href="#first">For First Time Users of this Sample Application</a>
<li><a href="#webflow">Location in Default Webflow</a>
<li><a href="#events">Events</a>
<li><a href="#dynamic">Dynamic Data Display</a>
<li><a href="#admin">Administration Tasks</a>
</ul>

<p><b>Note to Beta Customers:</b> this documentation includes links to WebLogic Platform documents on the BEA "Edocs" Web site. However, these documents cannot be posted until the product's release. For now, please refer to the documents on the WebLogic Platform documentation CD. Thank you.

<a name="intro">&nbsp;</a>
<p><b>Introduction</b>

<p>The My Avitek portal page presents a number of portlets to give the logged-in user a personalized view of the site. This Technical Details section for the My Avitek page will cover a lot of background information for first-time users, because My Avitek is the initial page seen in the application. Our examination will include pointers to, and excerpts from, some key XML files that contain defintions for the portal and its components.

<p>The My Avitek page is one of three tabbed pages in the "b2cPortal." This Web application's name includes "b2c," an abbreviation for business-to-consumer, the type of portal application being demonstrated here. The b2cPortal is part of the "e2eApp" enterprise application. The enterprise application's name includes "e2e," an abbreviation for "end-to-end," meaning a sample that shows a full range of key features in the product.

<p>In the BEA_HOME directory where you installed WebLogic Platform, you will find the files that comprise the e2eApp in the following locations:

<p>weblogic700\samples\platform\e2eDomain\beaApps\e2eApp\...
<p>weblogic700\samples\platform\e2eDomain\beaApps\e2eApp-project\...

<p>We will discuss the "e2eDomain" domain entity in the next section, <a href="#first">"For First Time Users of This Sample Application"</a>. For now, let's focus on the My Avitek page in the b2cPortal. This page can include the following portlets:

<ul type="square">

<li>The <b>mybanner</b> portlet, which provides the top banner and the three tabs for My Avitek, Products, and Shopping Cart pages.

<li>The <b>login</b> portlet, used when an authenticated user has been logged into the application. It provides the Logout button and the name of the currently logged-in user.

<li>The <b>search</b> portlet, which provides a keyword-based search input box.

<li>The <b>myavitek</b> portlet, which provides the Feature Photo Tips graphics and text on the My Avitek page. (The content shown in this sample is static, but could be personalized for different types of users by using features in WebLogic Portal. For information about personalizing application content, see the <a href="http://edocs.bea.com/wlp/docs70/p13n/index.htm" target="new">Guide to Building Personalized Applications</a>.)

<li>The <b>summarycart</b> portlet, which provides an abbreviated list of the logged-in user's Shopping Cart.

<li>The <b>orderhistory</b> portlet, which provides an abbreviated list of the logged-in user's order history. Note that for this sample the order history is not persisted to the database. That is, the data is reset to its original state each time you log into the sample application (although other users accessing the application on a shared server might enter orders that you would see, if their http sessions are still active).

<li>The <b>tourguide</b> portlet, which provides the content you are reading now. It has two forms: the smaller version on the left side of the running application, and the current maximized version that includes Technical Details, View Code, and Edocs pointers.

</ul>

<p>All of the portlets that comprise the My Avitek page are identified in the following file:

<p>weblogic700\samples\platform\e2eDomain\beaApps\e2eApp-project<br>
&nbsp;\application-sync\webapps\b2cPortal\b2cPortal.portal

<p>For example:

<p><pre>
     &lt;page-name&gt;My Avitek&lt;/page-name&gt;
     ...
            &lt;portlet-pool&gt;
                &lt;portlet-name&gt;login&lt;/portlet-name&gt;
                &lt;portlet-name&gt;search&lt;/portlet-name&gt;
                &lt;portlet-name&gt;tourguide&lt;/portlet-name&gt;
                &lt;portlet-name&gt;subnav&lt;/portlet-name&gt;
                &lt;portlet-name&gt;summarycart&lt;/portlet-name&gt;
                &lt;portlet-name&gt;myavitek&lt;/portlet-name&gt;
                &lt;portlet-name&gt;orderhistory&lt;/portlet-name&gt;
                &lt;portlet-name&gt;mybanner&lt;/portlet-name&gt;
                &lt;portlet-name&gt;anonUser&lt;/portlet-name&gt;
            &lt;/portlet-pool&gt;
</pre>			
			
<p>During the development cycle, these portlets were added to the MyAvitek portal page by using the WebLogic Portal Administration Tools and the E-Business Control Center. For information about that process, see the <a href="http://edocs.bea.com/wlp/docs70/portal/index.htm" target="new">Guide to Building Portals with WebLogic Portal</a> on the BEA Edocs Web site.

<p>As you run this sample application, it is important to understand that as a developer you are primarily interested in the portlet JSP code before it was rendered  by the browser. That's why the code fragments in this section, and the View Code link, describe and show you the pre-rendered JSP file for a particular portlet.

<p>You can find the b2cPortal's portlet JSP files in:

<p>weblogic700\samples\platform\e2eDomain\beaApps<br>
&nbsp;\e2eApp\b2cPortal\portlets\...

<p>For this My Avitek page, the View Code link opens the source for the content.jsp file that presents the Feature Photo Tips graphics and text. This particular content.jsp resides in the "myavitek" subdirectory under the path shown above. 

<p>How do we know that the myavitek portlet (center of My Avitek page) uses the content.jsp in the "...\e2eApp\b2cPortal\portlets\myavitek" directory? This was specified in portal development tools provided by WebLogic Platform. You can slso look in the following file:

<p>weblogic700\samples\platform\e2eDomain\beaApps\e2eApp-project<br>
&nbsp;\application-sync\portlets\myavitek.portlet

<p>This XML file contains the following definition:

&lt;content-url&gt;/portlets/myavitek/content.jsp&lt;/content-url&gt;

<p>Notice how the content URL is relative to the root of the b2cPortal Web application, which by default is the following installed directory location:

<p>weblogic700\samples\platform\e2eDomain\beaApps\e2eApp\b2cPortal


<a name="first"><p>&nbsp;</p></a>
<p><b>For First Time Users of this Sample Application</b>

<p>Before we talk about the My Avitek page's webflow and use of portlets, let's take a step back and explore:

<ul type="square">

<li>A brief look at the WebLogic Platform <a href="#arch">architecture</a>.

<li>An outline of the <a href="#initproc">processing</a> that occurred when you first started this WebLogic Platform sample application.

</ul>

<p>If you already read this section, you can skip ahead to the discussion about the <a href="#webflow">default webflow</a> for the My Avitek page.

<a name="arch">&nbsp;</a>
<p><b>WebLogic Platform Architecture</b>

<p>WebLogic Platform provides an integrated set of features that include the J2EE-compliant application server, plus the development, portal, and integration frameworks that are built on top of it. The following figure shows how WebLogic Platform provides a single, highly integrated solution:

<p><img src="portlets/tourguide/docs/images/platform.gif" width=443 height=363>

<ul type="square">

<li>The application server provides the foundation, via WebLogic Server, for rapidly developing, deploying, and managing e-business applications. 

<li>The development framework delivers an integrated development and run-time environment, including support for enterprise-class Web services. This includes Web services you can program with a WebLogic Server API, or Web services you can create using WebLogic Workshop. 

<li>The portal framework delivers, via WebLogic Portal, services that enable you to efficiently build, launch, and maintain high-performance e-business sites. This framework facilitates the creation, customization, and administration of multiple portals. 

<li>The integration framework enables, via WebLogic Integration, the integration of enterprise information systems via standards-based integration technology, including enterprise resource planning (ERP), supply chain management (SCM), human resource (HR), and customer relationship management (CRM), as well as custom and legacy applications. This framework also enables collaboration between suppliers and partners, and the automation of business process workflows. 

</ul>

<p>For a detailed overview, see <a href="http://edocs.bea.com/platform/docs70/intro/index.html" target="new">Introducing BEA WebLogic Platform</a> on the BEA Edocs site.

<p><b>Beta customers:</b> please see the draft of this introduction on the WebLogic Platform Beta Documentation CD.


<a name="initproc">&nbsp;</a>
<p><b>Outline of Initial Processing </b>

<p>When you started the sample application, what happened that resulted in the server startup and then the initial display of the Introduction or "splash" page? First, there were several ways you could have invoked the sample application, such as from the WebLogic Platform Quick Start Application, or a Windows Start menu option, or directly by running a startE2E script.

<p>Regardless of which option you used, the startE2E.bat (Windows) or startE2E.sh (UNIX) script was invoked. It started a WebLogic Server instance for the application, which runs in a domain named "e2eDomain." ("e2e" is an abbreviation for "end-to-end," meaning a sample that shows a full range of key features.) The word "domain" has many meanings in the computing industry. BEA products use "domain" to mean a collection of servers, services, interfaces, machines, and associated resource managers, all defined by a single configuration file.

<p>When the startE2E script runs, it reads configuration information from the enterprise application's config.xml file. By default this configuration file resides in the following BEA_HOME installed directory:

<p>weblogic700/samples/platform/e2eApp/config

<p>The config.xml file includes the following definition, setting "splashPage" as the default Web application in the domain:

<p><pre>
&lt;WebServer
      DefaultWebApp="splashPage"
      LogFileName="./logs/access.log"
      LoggingEnabled="true"
      Name="e2eServer"
    /&gt;
</pre>

<p>With the E2Eserver running, specifying a URL such as <b>http://localhost:7501</b> in a browser results in running the "splashPage" Web application (or "webapp") in:

<p>weblogic700\samples\platform\e2eDomain\beaApps<br>
&nbsp;&nbsp;\e2eApp\splashPage

<p>The splashPage webapp's web.xml configuration file designated "index.jsp" in the &lt;Welcome-file-list&gt; definition. This web.xml resides in:

<p>BEA_HOME\weblogic700\samples\platform\e2eDomain\beaApps<br>
&nbsp;&nbsp;\e2eApp\splashPage\WEB-inf

<p>On the splash page, you clicked the "Login as Rachel Adams" button graphic to arrive on this MyAvitek page. That resulted in the splash page passing in the URL for the portal application, plus pre-defined login credentials.

<p>The splash page sets up requests that allow you to automatically log into the b2cPortal or b2bPortal. This is done to help simplify this sample application. You would not want to embed usernames and passwords in a JSP page. We used a scriplet to define the login credentials. For example:

<pre>
&lt;%!
   protected static final String B2C_USERNAME = "radams";
   protected static final String B2C_PASSWORD = "password";
   protected static final String B2C_PORTAL_NAME = "b2cPortal";
...
</pre>

<p>A form on \splashPage\index.jsp contains:

<p><pre>
&lt;form method="post" action="&lt;%=b2cUrl%&gt;"&gt;
  &lt;input type="hidden" name="namespace" value="security"&gt;
  &lt;input type="hidden" name="origin" value="login.jsp"&gt;
  &lt;input type="hidden" name="event" value="button.login"&gt;
  &lt;input type="hidden" name="redirect" value="true"&gt;
  &lt;input type="hidden" name="j_username" value="&lt;%=B2C_USERNAME%&gt;"&gt;
  &lt;input type="hidden" name="j_password" value="&lt;%=B2C_PASSWORD%&gt;"&gt;
  &lt;input type="image" src="images/button_02.gif" alt="" border="0"&gt;
&lt;/form&gt;
</pre>

<p>The form results in opening the URL constructed as:

<p><pre>
&lt;%
   String b2cUrl = "http://" +
                   request.getServerName() + ":" +
                   request.getServerPort() + "/" +
                   B2C_PORTAL_NAME + "/application"; 
...
</pre>

<p>For this WebLogic Platform sample application, we elected to automatically log-in an existing user, in order to focus the sample on the most important features.

<p><b>Note:</b> WebLogic Portal provides other samples that demonstrate login authentication code, plus techniques to gather demographic information via Web applications. For details, please refer to the <a href="http://edocs.bea.com/wlp/docs70/reguser/index.htm" target="new">WebLogic Portal Guide to Customer Services</a>.

<p>Once the URL was passed to the browser for the b2cPortal application, why was the My Avitek page the first page displayed? This property was set in the WebLogic Portal Administration Tools. In the Portal Management section of that tool, under Pages and Portlets, we set the b2cPortal's default page on the Select and Order Pages screen. This value is stored in the database, in the INDEX_NUMBER column of the PORTAL_PAGE_P13N table. For an introduction to the WebLogic Portal Administration Tools, see the Administration Tasks section below.

<!-- <p>Of course, before the development team started creating the portal framework and portlets on each page, many steps occurred in a design phase. brief description of working with graphical designers on a prototype: mock-ups, then more detailed "comps" ... then finished graphics delivered to the development team ... then create portlets ... add to portal framework ... create sample data ... config files ... deployment. -->


<p><a name="webflow">&nbsp;</a>
<p><b>Location in the Default Webflow</b>

<p>Before we start our discussion about the "default webflow" for the My Avitek page, let's define some terms.

<p><b>Webflow</b> is a BEA technology that allows developers to control the flow of a Web site, without hard-coding in the presentation JSP the URL of the next page. WebLogic Portal uses Webflow to determine which pages the application should display in a browser and which pieces of business logic it should execute. One or more Webflow namespace files allow you to configure the Webflow for a particular Web application.

<p><b>Pipeline</b> is a BEA technology that allows developers to bind a sequence of services into a single named service. You can build Pipelines to manage the processing of business data. Generally, Pipelines control the flow of business logic that is executed resulting from Webflow. Pipelines are represented as Pipeline Nodes in the <b>Webflow and Pipeline Editors</b>, available in the BEA E-Business Control Center. These editors are graphical tools designed to help you visually create, modify, and validate Webflows for your Web applications. The Webflow and Pipeline Editors generate underlying Webflow namespace and Pipeline namespace XML files, which you should not hand-edit.

<p>Each <b>Webflow namespace file</b> is an XML file that configures the Webflow for a Web application, controlling the order in which your site's Web pages are displayed and initiating the execution of the business logic that is associated with them. You edit Webflow namespace files using the Webflow and Pipeline Editors.

<p>For the b2cPortal application, the Webflow namespace files are located in the following directory:

<p>weblogic700\samples\platform\e2eDomain\beaApps\e2eApp-project<br>
&nbsp;\application-sync\webapps\bc2Portal

<p>Input Processors and Pipelines are the two different types of processor nodes that come packaged with the Webflow implementation.

<p>Input Processors are predefined, specialized Java classes that carry out more complex tasks when invoked by the Webflow mechanism. Input Processors are typically used to validate HTML form data, or to provide conditional branching within a Web page. For example, an Input Processor may contain code that verifies whether a date has been entered in the correct format, as opposed to embedding that code within the same JSP that displays the form fields. Input Processors contain logic that is specific to the Web application, and are therefore loaded by the Web application's container. 

<p>Input Processors are embedded in Web pages using specialized JSP tags, which are discussed in <a href="http://e-docs.bea.com/wlp/docs70/wflopipe/jsptags.htm" target="new">Webflow JSP Tag Library Reference</a>.  

<p>A Pipeline is also a type of processor node that may be invoked by the Webflow. Pipelines initiate the execution of specific tasks related to your business process, and can be transactional or nontransactional. For example, if a visitor attempts to move to another page on your Web site but you want to persist the visitor's information to a database first, you could use a Pipeline. Pipelines contain business logic that may apply to multiple Web applications within a larger enterprise application, and are therefore loaded by the Enterprise JavaBean (EJB) container. 

<p>For details about the Webflow and Pipeline technology and its editors, see the <a href="http://edocs.bea.com/wlp/docs70/wflopipe/index.htm" target="new">WebLogic Portal Webflow and Pipeline Guide</a>.

<p>Okay, that covers the key definitions for the Webflow technology. Now let's focus on the My Avitek page. On a page that preceded the display of the My Avitek page, you either:

<ul type="square">

<li>Clicked the "Login as Rachel Adams" button graphic on the sample's Introduction or "splash" page. This action <b>did not</b> use the webflow and pipeline feature. As explained in the previous section, the link used a form that constructed the URL value from pre-defined values and login credentials.

<li>Or clicked the My Avitek tab on a Products page or Shopping Cart page.

</ul>

<p>The previous section described what happened when you initially clicked "Login as Rachel Adams" on the splash page. The next section looks at the event that occurred when you clicked the My Avitek tab on a Products page or Shopping Cart page.


<p><a name="events">&nbsp;</a>
<p><b>Events</b>

<p>Every time a customer clicks a link or button on a JSP, it is considered an event. Events trigger particular responses in the default Webflow that allow customers to continue. While this response can be to load another JSP, it is usually the case that an Input Processor and/or Pipeline is invoked first. 

<p>When you are on a Products or Shopping Cart page and then click the My Avitek tab, you will notice a resulting URL similar to the following (shown here on several lines to improve readability).

<p>http://&lt;host&gt;/&lt;port&gt;/b2cPortal/application?<br>
origin=hnav_bar.jsp&event=bea.portal.framework.internal.refresh<br>
&pageid=My+Avitek

<p>The refresh event causes any page to be displayed again with the latest data. All the portlets on the My Avitek page that contain dynamic data (My Shopping Cart, My Order History, Tour Guide) have their data refreshed.

<p>The tabs are provided via the hnav_bar.jsp file, which resides in:

<p>weblogic700\samples\platform\e2eDomain\beaApps\e2eApp\b2cPortal\framework

<p>The hnav_bar.jsp file imports two JSP Tag libraries:

<p><pre>
&lt;%@ taglib uri="webflow.tld" prefix="wf" %&gt;
&lt;%@ taglib uri="portal.tld" prefix="ptl" %&gt;
</pre>

<p>When you clicked the My Avitek tab from another page in the application, the hnav_bar.jsp used the following JSP tag in the link for the target tab:

&lt;a href="&lt;ptl:createPortalPageChangeURL pageName='&lt;%= portalPageName %&gt;'/&gt;"&gt;&lt;%=portalPageName%&gt;&lt;/a&gt;

<p>The (portal) ptl:createPortalPageChangeURL JSP tag generates a webflow URL for a page change event.  

<p><a name="dynamic">&nbsp;</a>
<p><b>Dynamic Data Display</b>

<p>On the My Avitek page, let's look at one of the dynamic portlets, summarycart (shown as "My Shopping Cart" on the My Avitek page).

<p>The webflow namespace file for the summarycart portlet is:

<p>weblogic700\samples\platform\e2eDomain\beaApps\e2eApp-project<br>
\application-sync\webapps\b2cPortal\summarycartportlet.wf

<p>It contains:

<p><pre>
    &lt;presentation-origin node-name="step1" node-type="jsp"&gt;
        &lt;node-processor-info page-name="step1.jsp"
		page-relative-path="/portlets/summarycart"/&gt;
    &lt;/presentation-origin&gt;
</pre>	
	
<p>The step1.jsp file is located in:

<p>weblogic700\samples\platform\e2eDomain\beaApps\e2eApp\b2cPortal<br>
\portlets\summarycart\step1.jsp

<p>The step1.jsp file uses a combination of JSP tags, including webflow tags to get the current shopping cart and saved shopping cart from the pipeline session:

<p><pre>&lt;webflow:getProperty id="shoppingCart" property="&lt;%=PipelineSessionConstants.SHOPPING_CART%&gt;"<br>type="com.beasys.commerce.ebusiness.shoppingcart.ShoppingCart" scope="session" namespace="portal" /&gt;

&lt;webflow:getProperty id="savedShoppingCart" <br>property="&lt;%=PipelineSessionConstants.SAVED_SHOPPING_CART%&gt;" <br>type="com.beasys.commerce.ebusiness.shoppingcart.ShoppingCart" scope="session" namespace="portal" /&gt;
</pre>

<a name="admin">&nbsp;</a>
<p><b>Administration Tasks</b>

<p>Most of the properties discussed in this Technical Details section were not edited by hand, but were instead generated by using the Portal Management area of the WebLogic Portal Administration Tools. For example, designating that the My Avitek page was the default starting page in the b2cPortal application was done by using this tool. This section explains how to start the tool and shows a sample screen for the default page setting.

<p>In a new browser window, point to the following URL, which starts the WebLogic Portal Administration Tools:

<p>http://&lt;host&gt;:&lt;port&gt;/e2eAppTools/index.jsp

<p>These steps assume that the server for the e2eDomain is still running. You can run the e2eAppTools web application and the sample application at the same time. Both "web applications" are part of the same e2eApp enterprise application and run in the same domain.

<p>Substitute the name of your local machine (localhost) or the remote host name, and substitute the port number on which WebLogic Server is listening. For WebLogic Portal applications, the default port number is 7501. The "e2eAppTools" portion of the URL is case sensitive.

<p>You are prompted for a username and password. These values may be different for your site, but by default they are:

<p>Username: administrator<br>
Password: password

<p>The login values are case sensitive. If these credentials do not work, please check with the administrator, who may have changed these default values for the administrator account after the sample was installed.

<p>On the main Administration Tools page, click the icon in the Portal Management banner.

<p>On the Portal Management Home page, click "Default Portal (Everyone)".

<p>On the Group Portal Management Home page, click "Managed Pages and Portlets".

<p>On the Pages and Portlets page, click "Select and Order Pages".

<p>The following graphic shows a portion of the page:

<p><img src="portlets/tourguide/docs/images/default.gif" width=636 height=671>

<p>Note how the My Avitek page has been designated as the default Home Page.

<p>For more information about the WebLogic Portal Administration Tools, see the <a href="http://edocs.bea.com/wlp/docs70/portal/index.htm" target="new">Guide to Building Portals with WebLogic Portal</a> on the BEA Edocs site. To exit the Administration Tools, close the browser window.

<p>&nbsp;</p>


<!-- End content from td-myavitek.jsp -->