<%@ page contentType="text/html; charset=UTF-8" %>
<%@ page errorPage="error.jsp" import="
    com.bea.p13n.management.data.repository.DataRepository,
    com.bea.p13n.management.data.repository.DataRepositoryFactory,
    com.bea.p13n.management.data.repository.PersistenceManager,
    com.bea.p13n.management.data.tools.browser.DataRepositoryHandle
"%>

<%
    // Get the name of the DR to clear, and then get the DR
    String name = request.getParameter("dr");
    DataRepository dr = null;

    if (name == null)
    {
        dr = DataRepositoryFactory.getMasterDataRepository();
    }
    else
    {
        Map drNameMap = (Map) session.getAttribute("com.bea.p13n.management.data.tools.browser.drNameMap");
        dr = ((DataRepositoryHandle) drNameMap.get(name)).getInstance();
    }

    if (dr == null)
    {
        // This should be handled more gracefully...
        throw new IllegalStateException("No DR found for id: " + name);
    }

    PersistenceManager pm = dr.getPersistenceManager();
    long start = System.currentTimeMillis();
    pm.clear(dr);
    long end = System.currentTimeMillis();
%>

<html>

<head>
  <title>Data Repository Browser: Clear Contents</title>
  <link rel="stylesheet" href="style.css">
</head>

<body marginheight="0" marginwidth="0" topmargin="0" leftmargin="0" rightmargin="0">
  <table border="0" cellspacing="0" cellpading="6" width="100%">
    <tr>
      <td bgcolor="#ff0000" height="15"></td>
    </tr>
    <tr>
      <td bgcolor="#ff0000" class="header">
        Clear Data Repository Contents
      </td>
    </tr>
    <tr>
      <td bgcolor="#ff0000" height="3"></td>
    </tr>
    <tr>
      <td><img src="logo.gif"></td>
    </tr>
    <tr>
      <td height="9"></td>
    </tr>
    <%
        String home = (String) session.getAttribute("com.bea.p13n.management.data.tools.browser.home");

        if (home != null)
        {
    %>
    <tr>
      <td class="fullhr"></td>
    </tr>
    <tr>
      <td height="9"></td>
    </tr>
    <tr>
      <td><a href="<%= response.encodeURL(home) %>"><img src="home.gif" border="0" alt="Return to Master Browser" hspace="9" align="absmiddle">Return to Master Browser</a></td>
    </tr>
    <tr>
      <td height="9"></td>
    </tr>
    <%
        }
    %>
    <tr>
      <td class="fullhr"></td>
    </tr>
    <tr>
      <td class="subheader"><%= dr.getName() %></td>
    </tr>
    <tr>
      <td height="9"></td>
    </tr>
    <tr>
      <td class="name" colspan="2">The Data Repository has been cleared</td>
    </tr>
    <tr>
      <td class="note">(Elapsed Time: <%= (end - start) %>ms)</td>
    </tr>
    <tr>
      <td class="fullhr"></td>
    </tr>
    <tr>
      <td height="9"></td>
    </tr>
    <tr>
      <td bgcolor="#ff0000" height="3"></td>
    </tr>
    <tr>
      <td bgcolor="#ff0000" class="footer">
        &copy; BEA Systems, Inc.&nbsp; All rights reserved.
      </td>
    </tr>
    <tr>
      <td bgcolor="#ff0000" height="3"></td>
    </tr>
  </table>
</body>

</html>
