<%@ page contentType="text/html; charset=UTF-8" %>
<%@ page errorPage="error.jsp" import="
    java.net.InetAddress,
    com.bea.p13n.management.data.repository.DataRepository,
    com.bea.p13n.management.data.repository.DataRepositoryFactory,
    com.bea.p13n.management.data.tools.browser.DataRepositoryHandle,
    java.util.LinkedList,
    java.util.HashMap,
    java.util.HashSet
"%>

<%
    // Save the request URI
    session.setAttribute("com.bea.p13n.management.data.tools.browser.home", request.getRequestURI());

    // Get the application name
    String app = "(None)";

    try
    {
       app = com.bea.p13n.management.ApplicationHelper.getApplicationName();
    }
    catch (Exception e)
    {
    }

    // Initialize the DR stack
    LinkedList drStack = new LinkedList();
    DataRepository masterDr = DataRepositoryFactory.getMasterDataRepository();
    DataRepositoryHandle masterHandle = new DataRepositoryHandle(masterDr);
    session.setAttribute("com.bea.p13n.management.data.tools.browser.drStack", drStack);

    // Initialize the contextual div name stack
    LinkedList divNameStack = new LinkedList();
    session.setAttribute("com.bea.p13n.management.data.tools.browser.divNameStack", divNameStack);

    // Initialize a NEW map of dr contextual names to instance handles
    HashMap drNameMap = new HashMap();
    session.setAttribute("com.bea.p13n.management.data.tools.browser.drNameMap", drNameMap);

    // Initialize the DR display data
    Set shownLocalDrSet = (Set) session.getAttribute("com.bea.p13n.management.data.tools.browser.shownLocals");

    if (shownLocalDrSet == null)
    {
        shownLocalDrSet = new HashSet();
        session.setAttribute("com.bea.p13n.management.data.tools.browser.shownLocals", shownLocalDrSet);
    }

    Set shownProxyDrSet = (Set) session.getAttribute("com.bea.p13n.management.data.tools.browser.shownProxies");

    if (shownProxyDrSet == null)
    {
        shownProxyDrSet = new HashSet();
        session.setAttribute("com.bea.p13n.management.data.tools.browser.shownProxies", shownProxyDrSet);
    }

    // Update DR display data
    String showLocal = request.getParameter("showLocal");

    if (showLocal != null)
    {
        shownLocalDrSet.add(showLocal);
    }

    String hideLocal = request.getParameter("hideLocal");

    if (hideLocal != null)
    {
        shownLocalDrSet.remove(hideLocal);
    }

    String showProxy = request.getParameter("showProxy");

    if (showProxy != null)
    {
        shownProxyDrSet.add(showProxy);
    }

    String hideProxy = request.getParameter("hideProxy");

    if (hideProxy != null)
    {
        shownProxyDrSet.add(hideProxy);
    }
%>

<html>

<head>
  <title>Data Repository Browser</title>
  <link rel="stylesheet" href="style.css">
  <script language="JavaScript">
<!--

/*
WM_checkIn()
Takes the ID of a positioned HTML element and returns an object reference.

Source: Webmonkey Code Library
(http://www.hotwired.com/webmonkey/javascript/code_library/)

Author: Taylor
Author Email: taylor@wired.com
Author URL: http://www.taylor.org/

Usage: WM_checkIn('id')
*/

function WM_checkIn(id) {
  if (document.all) {
    return document.all[id].style;
  } else if(document.layers) {
    return document.layers[id];
  }
}

/*
WM_swapLayerBgcolor()
Changes the background color of one or more DIVs or SPANs.

Source: Webmonkey Code Library
(http://www.hotwired.com/webmonkey/javascript/code_library/)

Author: Shvatz
Author Email: shvatz@wired.com

Usage: WM_swapLayerBgcolor('layerName1','newColor1',
'layerName2','newColor2', ...);

Requires: WM_checkIn()
*/

function WM_swapLayerBgcolor() {
  // Make sure the browser supports DHTML.
  if(document.layers || document.all)
    with(WM_swapLayerBgcolor)
      // Loop through all arguments, two at a time.
      for(i = 0; i < (arguments.length - 1); i += 2)
  // Get an object reference and set the
  // bgcolor according to the DOM.
  if(document.layers)
    WM_checkIn(arguments[i]).document.bgColor = arguments[i+1];
  else if(document.all)
    WM_checkIn(arguments[i]).backgroundColor = arguments[i+1];
}

// -->
  </script>
</head>

<body marginheight="0" marginwidth="0" topmargin="0" leftmargin="0" rightmargin="0">
  <table border="0" cellspacing="0" cellpading="6" width="100%">
    <tr>
      <td bgcolor="#ff0000" height="15"></td>
    </tr>
    <tr>
      <td bgcolor="#ff0000" class="header">
        Data Repository Browser
      </td>
    </tr>
    <tr>
      <td bgcolor="#ff0000" height="3"></td>
    </tr>
    <tr>
      <td><img src="logo.gif"></td>
    </tr>
    <tr>
      <td bgcolor="#ffffff" height="9"></td>
    </tr>
    <tr>
      <td class="fullhr"></td>
    </tr>
    <tr>
      <td>
        <table border="0" cellspacing="0" cellpading="6" width="100%">
          <tr>
            <td colspan="2" class="subheader">
              General Information
            </td>
          </tr>
          <tr>
            <td class="name">Host Name</td>
            <td class="value"><%= InetAddress.getLocalHost().getHostName() %></td>
          </tr>
          <tr>
            <td class="name">Host IP</td>
            <td class="value"><%= InetAddress.getLocalHost().getHostAddress() %></td>
          </tr>
          <tr>
            <td class="name">Application</td>
            <td class="value"><%= app %></td>
          </tr>
          <tr>
            <td class="name">User</td>
            <td class="value"><%= request.getRemoteUser() %></td>
          </tr>
        </table>
      </td>
    </tr>
    <tr>
      <td class="fullhr"></td>
    </tr>

    <%
         drStack.addLast(masterHandle);
         divNameStack.addLast("master");
         drNameMap.put("master", masterHandle);
    %>

    <jsp:include page="dr_detail.jsp" flush="true">
    </jsp:include>

    <%
         divNameStack.removeLast();
         drStack.removeLast();
    %>

    <tr>
      <td class="fullhr"></td>
    </tr>
    <tr>
      <td bgcolor="#ffffff" height="9"></td>
    </tr>
    <tr>
      <td bgcolor="#ff0000" height="3"></td>
    </tr>
    <tr>
      <td bgcolor="#ff0000" class="footer">
        &copy; BEA Systems, Inc.&nbsp; All rights reserved.
      </td>
    </tr>
    <tr>
      <td bgcolor="#ff0000" height="3"></td>
    </tr>
  </table>
</body>

</html>
