<%@ page errorPage="error.jsp" import="
    com.bea.p13n.management.data.repository.DataRepository,
    com.bea.p13n.management.data.repository.DataRepositoryFactory
    com.bea.p13n.management.data.tools.browser.DataRepositoryHandle,
    com.bea.p13n.common.Version,
    java.util.LinkedList,
    java.util.List,
    java.util.Map,
    java.util.Set
"%>

<%!
    private String getContextualName(LinkedList divNameStack)
    {
        StringBuffer divNameBuf = new StringBuffer();

        for (int i = 0; i < divNameStack.size(); i++)
        {
            if (i != 0)
            {
                divNameBuf.append("_");
            }

            divNameBuf.append(divNameStack.get(i));
        }

        return divNameBuf.toString();
    }
%>

<%
    // Get some request metadata
    String requestUri = request.getRequestURI();

    // Get the current DR from the DR stack
    LinkedList drStack = (LinkedList) session.getAttribute("com.bea.p13n.management.data.tools.browser.drStack");
    // This can throw an IllegalStateException -- it should probably be handled
    // gracefully via a JSP error page...
    DataRepository dr = ((DataRepositoryHandle) drStack.getLast()).getInstance();

    // Get the drNameMap from the session
    Map drNameMap = (Map) session.getAttribute("com.bea.p13n.management.data.tools.browser.drNameMap");

    // Get the DR version
    Version version = dr.getVersion();

    // Get the list of registered Local DRs for this DR
    List registeredLocals = dr.getNotifiedDataRepositories( DataRepository.GROUP_LOCAL );

    // Get the list of registered Proxy DRs for this DR
    List registeredProxies = dr.getNotifiedDataRepositories( DataRepository.GROUP_PROXY );

    // Get the lists of displayed DRs
    Set shownLocalDrSet = (Set) session.getAttribute("com.bea.p13n.management.data.tools.browser.shownLocals");
    Set shownProxyDrSet = (Set) session.getAttribute("com.bea.p13n.management.data.tools.browser.shownProxies");

    // Get the div name stack
    LinkedList divNameStack = (LinkedList) session.getAttribute("com.bea.p13n.management.data.tools.browser.divNameStack");

    // Compute the contextual name of this DR
    String name = getContextualName(divNameStack);

    // Check whether or not this is detail for a proxy DR
    boolean isProxy = ((String) divNameStack.getLast()).startsWith("proxy");

    // Prepare tool URLs
    String view = response.encodeURL("view_dr.jsp?dr=" + name);
    String clear = response.encodeURL("clear_dr.jsp?dr=" + name);
    String refresh = response.encodeURL("refresh_dr.jsp?dr=" + name);
    String notify = response.encodeURL("notify_dr.jsp?dr=" + name);
    String dataSyncServlet = response.encodeURL("DataSyncServlet");
%>

    <tr>
      <td bgcolor="#ffffff">
        <div id="<%= name %>">
        <table border="0" width="100%">
          <tr>
            <td rowspan="12" class="actions" width="1%" onmouseover="WM_swapLayerBgcolor('<%= name %>', '#ffffee');" onmouseout="WM_swapLayerBgcolor('<%= name %>', '#ffffff');">
              <table border="0" width="1%">
                <tr>
                  <td width="1%">
                    <table border="0" cellspacing="0" cellpadding="3" width="100%">
                      <%
                          if (!isProxy)
                          {
                      %>
                      <tr>
                        <td><a href="<%= view %>"><img src="view.gif" border="0" alt="View"></a></td>
                      </tr>
                      <tr>
                        <td><a href="<%= clear %>"><img src="clear.gif" border="0" alt="Clear"></a></td>
                      </tr>
                      <tr>
                        <td><a href="<%= refresh %>"><img src="refresh.gif" border="0" alt="Refresh"></a></td>
                      </tr>
                      <tr>
                        <td><a href="<%= notify %>"><img src="refresh-and-notify.gif" border="0" alt="Refresh and Notify"></a></td>
                      </tr>

                      <%
                          if( dr == DataRepositoryFactory.getMasterDataRepository() )
                          {
                      %>
                      <tr>
                        <td><a href="<%= dataSyncServlet %>"><img src="discover-proxies.gif" border="0" alt="Discover Proxy Data Repositories"></a></td>
                      </tr>
                      <%
                          }
                      %>

                      <%
                          }
                          else
                          {
                              String remote = dr.getDescription();
                              int index = remote.lastIndexOf("/");

                              if (index >= 0)
                              {
                                  remote = remote.substring(0, index);
                                  remote += "/dr_browser.jsp";
                      %>
                      <tr>
                        <td><a href="<%= remote %>"><img src="view-remote.gif" border="0" alt="Browse Remote Data Repository"></a></td>
                      </tr>
                      <%
                              }
                              else
                              {
                      %>
                      <tr>
                        <td><img src="no-actions.gif" border="0" alt="No Actions Available"></td>
                      </tr>
                      <%
                              }
                          }
                      %>
                    </table>
                  </td>
                </tr>
              </table>
            </td>
            <%
                if (drStack.size() == 1)
                {
            %>
            <td class="subheader" colspan="2">
              <%= dr.getName() %>
            </td>
            <%
                }
            %>
          <tr>
          </tr>
            <td class="description" colspan="2">
              <%= dr.getDescription() %>
            </td>
          </tr>
          <tr>
            <td class="name">
              Author
            </td>
            <td class="value">
              <%= dr.getAuthor() %>
            </td>
          </tr>
          <%
              if (version != null)
              {
          %>
          <tr>
            <td class="name">
              Version
            </td>
            <td class="value">
              <%= version.getMajor() %>.<%= version.getMinor() %>
              <%
                  int vBuild = version.getBuildNumber();
                  if (vBuild != 0)
                  {
              %>
                (Build: <%= vBuild %>)
              <%
                  }
              %>
            </td>
          </tr>
          <tr>
            <td class="name">
              <nobr>Version Note</nobr>
            </td>
            <td class="value">
              <%
                  String vDesc = version.getDescription();
                  if (vDesc != null && vDesc.trim().length() > 0)
                  {
              %>
                <%= vDesc %>
              <%
                  }
                  else
                  {
              %>
                (No description)
              <%
                  }
              %>
            </td>
          </tr>
          <%
              }
          %>
          <tr>
            <td class="name">
              <nobr>Schema URI Filter</nobr>
            </td>
            <td class="value">
              <%
                  String sUriFilter = dr.getSchemaUriFilter();
                  if (sUriFilter != null && sUriFilter.trim().length() > 0)
                  {
              %>
                <%= sUriFilter %>
              <%
                  }
                  else
                  {
              %>
                <span class="comment">(No filter)</span>
              <%
                  }
              %>
            </td>
          </tr>
          <tr>
            <td class="name">
              <nobr>URI Filter</nobr>
            </td>
            <td class="value">
              <%
                  String uriFilter = dr.getUriFilter();
                  if (uriFilter != null && uriFilter.trim().length() > 0)
                  {
              %>
                <%= uriFilter %>
              <%
                  }
                  else
                  {
              %>
                <span class="comment">(No filter)</span>
              <%
                  }
              %>
            </td>
          </tr>
          <tr>
            <td colspan="2" height="6"></td>
          </tr>
<% /* LOCAL/PROXY sub code marked below could be refactored into a single JSP */ %>
<% /*  START LOCALS */ %>
          <%
              if (registeredLocals != null && registeredLocals.size() > 0)
              {
          %>
          <tr>
            <td colspan="2">
              <table class="drbox" cellspacing="0" width="100%">
                <tr>
                  <td class="drheader">
                    Registered Data Repositories
                  </td>
                </tr>
                <tr>
                  <td height="6"></td>
                </tr>
                <%
                    for (int count = 0; count < registeredLocals.size(); count++)
                    {
                        DataRepository nDr = (DataRepository) registeredLocals.get(count);
                %>
                <tr>
                  <td class="drentry">
                    <table border="0" cellspacing="0" cellpading="6" width="100%">
                    <%
                        divNameStack.addLast("local" + String.valueOf(count));
                        String subName = getContextualName(divNameStack);

                        if (shownLocalDrSet.contains(subName))
                        {
                            String url = response.encodeURL(requestUri + "?hideLocal=" + subName);
                    %>
                      <tr>
                        <td class="expanded">
                          <code>-</code>
                          <a href="<%= url %>"><%= nDr.getName() %></a>
                        </td>
                      </tr>
                      <%
                          DataRepositoryHandle handle = new DataRepositoryHandle(nDr);
                          drStack.addLast(handle);
                          drNameMap.put(subName, handle);
                      %>

                      <jsp:include page="dr_detail.jsp" flush="true">
                      </jsp:include>

                      <%
                          drStack.removeLast();
                      %>
                    <%
                        }
                        else
                        {
                            String url = response.encodeURL(requestUri + "?showLocal=" + subName);
                    %>
                      <tr>
                        <td class="collapsed">
                          <code>+</code>
                          <a href="<%= url %>"><%= nDr.getName() %></a>
                        </td>
                      </tr>
                    <%
                        }

                        divNameStack.removeLast();
                    %>
                    </table>
                  </td>
                </tr>
                <%
                    }
                %>
              </table>
            </td>
          </tr>
          <%
              }
          %>
<% /* END LOCALS */ %>
<% /* START PROXIES */ %>
          <%
              if (registeredProxies != null && registeredProxies.size() > 0)
              {
          %>
          <tr>
            <td colspan="2">
              <table class="drbox" cellspacing="0" width="100%">
                <tr>
                  <td class="drheader">
                    Registered Proxy Data Repositories
                  </td>
                </tr>
                <tr>
                  <td height="6"></td>
                </tr>
                <%
                    for (int count = 0; count < registeredProxies.size(); count++)
                    {
                        DataRepository nDr = (DataRepository) registeredProxies.get(count);
                %>
                <tr>
                  <td class="drentry">
                    <table border="0" cellspacing="0" cellpading="6" width="100%">
                    <%
                        divNameStack.addLast("proxy" + String.valueOf(count));
                        String subName = getContextualName(divNameStack);

                        if (shownProxyDrSet.contains(subName))
                        {
                            String url = response.encodeURL(requestUri + "?hideProxy=" + subName);
                    %>
                      <tr>
                        <td class="expanded">
                          <code>-</code>
                          <a href="<%= url %>"><%= nDr.getName() %></a>
                        </td>
                      </tr>
                      <%
                          DataRepositoryHandle handle = new DataRepositoryHandle(nDr);
                          drStack.addLast(handle);
                      %>

                      <jsp:include page="dr_detail.jsp" flush="true">
                      </jsp:include>

                      <%
                          drStack.removeLast();
                      %>
                    <%
                        }
                        else
                        {
                            String url = response.encodeURL(requestUri + "?showProxy=" + subName);
                    %>
                      <tr>
                        <td class="collapsed">
                          <code>+</code>
                          <a href="<%= url %>"><%= nDr.getName() %></a>
                        </td>
                      </tr>
                    <%
                        }

                        divNameStack.removeLast();
                    %>
                    </table>
                  </td>
                </tr>
                <%
                    }
                %>
              </table>
            </td>
          </tr>
          <%
              }
          %>
<% /* END PROXIES */ %>

          <tr>
            <td colspan="2" height="6"></td>
          </tr>
        </table>
        </div>
      </td>
    </tr>
