<%@ page contentType="text/html; charset=UTF-8" %>
<%@ page errorPage="error.jsp" import="
    com.bea.p13n.common.Version,
    com.bea.p13n.management.data.common.XmlHelper,
    com.bea.p13n.management.data.repository.DataRepository,
    com.bea.p13n.management.data.repository.DataRepositoryFactory,
    com.bea.p13n.management.data.repository.PersistenceManager,
    com.bea.p13n.management.data.repository.PersistenceManagerFactory,
    com.bea.p13n.management.data.repository.DataItemQuery,
    com.bea.p13n.management.data.repository.DataItemResultSet,
    com.bea.p13n.management.data.repository.DataItem,
    com.bea.p13n.management.data.repository.Result,
    com.bea.p13n.management.data.tools.browser.DataRepositoryHandle,
    java.util.List,
    java.util.Map,
    java.util.HashSet,
    java.util.Set
"%>

<%
    // Get some request metadata
    String requestUri = request.getRequestURI();

    // Get the name of the DR to view, and then get the DR
    String name = request.getParameter("dr");
    DataRepository dr = null;

    if (name == null)
    {
        dr = DataRepositoryFactory.getMasterDataRepository();
    }
    else
    {
        Map drNameMap = (Map) session.getAttribute("com.bea.p13n.management.data.tools.browser.drNameMap");
        dr = ((DataRepositoryHandle) drNameMap.get(name)).getInstance();
    }

    if (dr == null)
    {
        // This should be handled more gracefully...
        throw new IllegalStateException("No DR found for id: " + name);
    }

    // Get the DR's filters
    String uriFilter = dr.getUriFilter();
    String schemaUriFilter = dr.getSchemaUriFilter();

    if (uriFilter == null)
    {
        uriFilter = ".*";
    }

    if (schemaUriFilter == null)
    {
        schemaUriFilter = ".*";
    }

    // Get the DR's persistence manager and query it for its contents
    PersistenceManager pm = dr.getPersistenceManager();
    DataItemQuery query = PersistenceManagerFactory.createDataItemQuery(uriFilter, schemaUriFilter, true);
    DataItemResultSet resultSet = pm.query(dr, query);

    // Initialize the item display data
    Set shownItems = (Set) session.getAttribute("com.bea.p13n.management.data.tools.browser." + name + "_shownItems");

    if (shownItems == null)
    {
        shownItems = new HashSet();
        session.setAttribute("com.bea.p13n.management.data.tools.browser." + name + "_shownItems", shownItems);
    }

    // Update item display data
    String show = request.getParameter("show");

    if (show != null)
    {
        shownItems.add(show);
    }

    String hide = request.getParameter("hide");

    if (hide != null)
    {
        shownItems.remove(hide);
    }
%>

<html>

<head>
  <title>Data Repository Browser: View Contents</title>
  <link rel="stylesheet" href="style.css">
</head>

<body marginheight="0" marginwidth="0" topmargin="0" leftmargin="0" rightmargin="0">
  <table border="0" cellspacing="0" cellpading="6" width="100%">
    <tr>
      <td bgcolor="#ff0000" height="15"></td>
    </tr>
    <tr>
      <td bgcolor="#ff0000" class="header">
        View Data Repository Contents
      </td>
    </tr>
    <tr>
      <td bgcolor="#ff0000" height="3"></td>
    </tr>
    <tr>
      <td><img src="logo.gif"></td>
    </tr>
    <tr>
      <td height="9"></td>
    </tr>
    <%
        String home = (String) session.getAttribute("com.bea.p13n.management.data.tools.browser.home");

        if (home != null)
        {
    %>
    <tr>
      <td class="fullhr"></td>
    </tr>
    <tr>
      <td height="9"></td>
    </tr>
    <tr>
      <td><a href="<%= response.encodeURL(home) %>"><img src="home.gif" border="0" alt="Return to Master Browser" hspace="9" align="absmiddle">Return to Master Browser</a></td>
    </tr>
    <tr>
      <td height="9"></td>
    </tr>
    <%
        }
    %>
    <tr>
      <td class="fullhr"></td>
    </tr>
    <tr>
      <td class="subheader"><%= dr.getName() %></td>
    </tr>
    <tr>
      <td height="9"></td>
    </tr>
    <%
        if(resultSet.getResult().equals(Result.OK) != false)
        {
            List dataItemList = resultSet.getDataItems();
    %>
    <tr>
      <td class="drheader">Data Items</td>
    </tr>
    <tr>
      <td class="drentry">
        <table border="0" cellspacing="0" cellpading="6" width="100%">
          <tr>
            <td bgcolor="#dddddd">
              <code><b>Count:</b> <%= dataItemList.size() %></code>
            </td>
          </tr>
        </table>
      </td>
    </tr>
    <%
            for (int i = 0; i < dataItemList.size(); i++)
            {
                DataItem item = (DataItem) dataItemList.get(i);
    %>
    <tr>
      <td class="drentry">
        <table border="0" cellspacing="0" cellpading="6" width="100%">
          <%
              if (shownItems.contains(String.valueOf(i)))
              {
                  String url = response.encodeURL(requestUri + "?dr=" + name + "&hide=" + i);
          %>
          <tr>
            <td colspan="2" class="expanded">
              <code>-</code>
              <a href="<%= url %>"><%= item.getUri() %></a>
            </td>
          </tr>
          <tr>
            <td class="name">
              Schema URI
            </td>
            <td class="value">
              <code><%= item.getSchemaUri() %></code>
            </td>
          </tr>
          <tr>
            <td class="name">
              <nobr>Creation Date</nobr>
            </td>
            <td class="value">
              <code><%= item.getTime(DataItem.CREATION_DATE) %></code>
            </td>
          </tr>
          <tr>
            <td class="name">
              <nobr>Modification Date</nobr>
            </td>
            <td class="value">
              <code><%= item.getTime(DataItem.MODIFICATION_DATE) %></code>
            </td>
          </tr>
          <%
              if (item.getMetadata() != null)
              {
          %>
          <tr>
            <td class="name">
              Name
            </td>
            <td class="value">
              <code><%= item.getMetadata().getName() %></code>
            </td>
          </tr>
          <tr>
            <td class="name">
              Description
            </td>
            <td class="value">
              <code><%= item.getMetadata().getDescription() %></code>
            </td>
          </tr>
          <tr>
            <td class="name">
              Author
            </td>
            <td class="value">
              <code><%= item.getMetadata().getAuthor() %></code>
            </td>
          </tr>
          <%
                  Version version = item.getMetadata().getVersion();

                  if (version != null)
                  {
          %>
          <tr>
            <td class="name">
              Version
            </td>
            <td class="value">
              <code>
              <%= version.getMajor() %>.<%= version.getMinor() %>
              <%
                      int vBuild = version.getBuildNumber();

                      if (vBuild != 0)
                      {
              %>
              (Build: <%= vBuild %>)
              <%
                      }
              %>
              </code>
            </td>
          </tr>
          <tr>
            <td class="name">
              <nobr>Version Note</nobr>
            </td>
            <td class="value">
              <code>
              <%
                      String vDesc = version.getDescription();

                      if (vDesc != null && vDesc.trim().length() > 0)
                      {
              %>
                <%= vDesc %>
              <%
                      }
                      else
                      {
              %>
              <span class="valuenote">(No note)</span>
              <%
                      }
              %>
              </code>
            </td>
          </tr>
          <%
                  }
              }
          %>
          <tr>
            <td class="name">Data</td>
            <td class="value" bgcolor="#ffffee">
              <pre><%
                  if (item.getData() != null)
                  {
                      String dataString = item.getData().toString();
                      out.println(XmlHelper.xmlEscape(dataString));
                  }
                  else
                  {
              %>
              <span class="valuenote">(No data)</span>
              <%
                  }
              %></pre>
            </td>
          </tr>
          <%
              }
              else
              {
                  String url = response.encodeURL(requestUri + "?dr=" + name + "&show=" + i);
          %>
          <tr>
            <td colspan="2" class="collapsed">
              <code>+</code>
              <a href="<%= url %>"><%= item.getUri() %></a>
            </td>
          </tr>
          <%
              }
          %>
        </table>
      </td>
    </tr>
    <%
            }
        }
        else
        {
    %>
    <tr>
      <td class="drheader">Query Result</td>
    </tr>
    <tr>
      <td class="drentry"><code><%= resultSet.getResult().toString() %></code></td>
    </tr>
    <tr>
      <td class="drheader">Data Items</td>
    </tr>
    <tr>
      <td class="drentry"><code>Count: 0</code></td>
    </tr>
    <%
        }
    %>
    <tr>
      <td height="9"></td>
    </tr>
    <tr>
      <td class="fullhr"></td>
    </tr>
    <tr>
      <td height="9"></td>
    </tr>
    <tr>
      <td bgcolor="#ff0000" height="3"></td>
    </tr>
    <tr>
      <td bgcolor="#ff0000" class="footer">
        &copy; BEA Systems, Inc.&nbsp; All rights reserved.
      </td>
    </tr>
    <tr>
      <td bgcolor="#ff0000" height="3"></td>
    </tr>
  </table>
</body>

</html>
