/**
 *
 * Copyright (c) 2000-2002  BEA Systems, Inc.   All Rights Reserved
 *
 */

package examples.e2e.b2c.payment.pipeline;

import com.bea.p13n.appflow.exception.PipelineException;

/**
 * Signals that an authorization attempt was made with an invalid
 * credit card.  Typically this will result from an invalid credit
 * card number or associated billing address.
 */
public class AuthorizationFailureException extends PipelineException
{
    /**
     * Constructs a AuthorizationFailureException
     */
    public AuthorizationFailureException(String namespace, String messageKey)
    {
        super(namespace + ":" + messageKey);
    }

    /**
     * Constructs a AuthorizationFailureException
     */
    public AuthorizationFailureException(String namespace, String messageKey, Exception embeddedException)
    {
        super(namespace + ":" + messageKey, embeddedException);
    }

    /**
     * Constructs a AuthorizationFailureException
     */
    public AuthorizationFailureException(String namespace, String messageKey, Object[] arguments)
    {
        super(namespace + ":" + messageKey);
    }

    /**
     * Constructs a AuthorizationFailureException
     */
    public AuthorizationFailureException(String namespace, String messageKey, Object argument, 
					 Exception embeddedException)
    {
        super(namespace + ":" + messageKey, embeddedException);
    }

    /**
     * Constructs a AuthorizationFailureException
     */
    public AuthorizationFailureException(String namespace, String messageKey, Object[] arguments, 
					 Exception embeddedException)
    {
        super(namespace + ":" + messageKey, embeddedException);
    }
}

