/**
 *
 * Copyright (c) 2000-2002  BEA Systems, Inc.   All Rights Reserved
 *
 */

package examples.e2e.b2c.payment.pipeline;

import com.bea.p13n.appflow.exception.PipelineException;

/**
 * Signals that authorization with an otherwise valid credit card was
 * unsuccessful.  Typically this will result from insufficient funds.
 */
public class AuthorizationRejectedException extends PipelineException
{
    /**
     * Constructs a AuthorizationRejectedException
     */
    public AuthorizationRejectedException(String namespace, String messageKey)
    {
        super(namespace + ":" + messageKey);
    }

    /**
     * Constructs a AuthorizationRejectedException
     */
    public AuthorizationRejectedException(String namespace, String messageKey, Exception embeddedException)
    {
        super(namespace + ":" + messageKey, embeddedException);
    }

    /**
     * Constructs a AuthorizationRejectedException
     */
    public AuthorizationRejectedException(String namespace, String messageKey, Object[] arguments)
    {
        super(namespace + ":" + messageKey);
    }

    /**
     * Constructs a AuthorizationRejectedException
     */
    public AuthorizationRejectedException(String namespace, String messageKey, Object argument, 
					  Exception embeddedException)
    {
        super(namespace + ":" + messageKey, embeddedException);
    }

    /**
     * Constructs a AuthorizationRejectedException
     */
    public AuthorizationRejectedException(String namespace, String messageKey, Object[] arguments, 
					  Exception embeddedException)
    {
        super(namespace + ":" + messageKey, embeddedException);
    }
}

