/*
 * B E A   S Y S T E M S
 *
 * C O M M E R C E   C O M P O N E N T S
 *
 * Copyright (c) 2000-2002  BEA Systems, Inc.
 *
 * All Rights Reserved. Unpublished rights reserved under the copyright laws
 * of the United States. The software contained on this media is proprietary
 * to and embodies the confidential technology of BEA Systems, Inc. The
 * possession or receipt of this information does not convey any right to disclose
 * its contents, reproduce it, or use,  or license the use, for manufacture or
 * sale, the information or anything described therein. Any use, disclosure, or
 * reproduction without BEA System's prior written permission is strictly prohibited.
 *
 * $Header: /cvsroot/site/bea-lsd/deploy/e2eDomain/beaApps/e2eApp/src/examples/e2e/b2c/shoppingcart/pipeline/SaveProductItemPC.java,v 1.2 2002/05/02 00:22:11 toneill Exp $
 */

package examples.e2e.b2c.shoppingcart.pipeline;

import com.beasys.commerce.foundation.Session;

/**
 * SaveProductItemPC is a pipeline component that uses a
 * the sku of the item, creates that ProductItem, places it
 * in the savedShoppingCart, and persists the change to the database
 * Needs:
 * <code>PipelineSessionConstants.CATALOG_ITEM_SKU</code> pipeline
 * session attribute.  The
 * <code>PipelineSessionConstants.SAVED_SHOPPING_CART</code> and
 * <code>PipelineSessionConstants.SHOPPING_CART</code> pipeline
 * session attributes, and the WLCS_SAVED_ITEM_LIST table are updated
 * to reflect the change.
 *
 *
 * @see com.beasys.commerce.ebusiness.shoppingcart.pipeline.SaveProductItemPCHome
 * @see com.beasys.commerce.ebusiness.shoppingcart.pipeline.SaveProductItemPCImpl
 * @see com.bea.p13n.appflow.pipeline.PipelineComponent
 * @see com.bea.p13n.appflow.pipeline.PipelineSession
 * @see com.beasys.commerce.webflow.PipelineSessionConstants
 * @see com.beasys.commerce.ebusiness.shoppingcart.ShoppingCart
 */
public interface SaveProductItemPC extends Session, com.bea.p13n.appflow.pipeline.PipelineComponent
{

}
