

/*                 
 * B E A   S Y S T E M S   
 *
 * C O M M E R C E   C O M P O N E N T S
 *                        
 * Copyright (c) 2000-2002  BEA Systems, Inc.  
 *
 * All Rights Reserved. Unpublished rights reserved under the copyright laws 
 * of the United States. The software contained on this media is proprietary 
 * to and embodies the confidential technology of BEA Systems, Inc. The 
 * possession or receipt of this information does not convey any right to disclose 
 * its contents, reproduce it, or use,  or license the use, for manufacture or 
 * sale, the information or anything described therein. Any use, disclosure, or
 * reproduction without BEA System's prior written permission is strictly prohibited.
 *
 * Generated By BEA System's SmartGenerator:
 * At Wed Jun 07 12:45:28 EDT 2000
 *
 * $Header: /cvsroot/site/bea-lsd/deploy/e2eDomain/beaApps/e2eApp/src/examples/e2e/b2c/tax/TaxCalculator.java,v 1.2 2002/05/02 00:22:11 toneill Exp $
 */


package examples.e2e.b2c.tax;

import com.beasys.commerce.foundation.*;
import java.util.*;
import java.rmi.*;
import javax.ejb.*;

//$Import$_Begin ------------ CUSTOM CODE ---------------
// Place additional import statements here
//$Import$_End   ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

/**
 * A generic Tax Calculator. Implementations for different tax packages should subclass this class
 *
 * 
 *
 * @see com.beasys.commerce.ebusiness.tax.TaxCalculatorHome
 * @see com.beasys.commerce.ebusiness.tax.TaxCalculatorImpl
 */
public interface TaxCalculator extends Session
                       //$Implements$_Begin ------------ CUSTOM CODE ---------------
                       // Add interfaces that are implemented here
                       //$Implements$_End   ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
{

    /**
     * Calculate tax based on the parameters given.  Only sales/use taxes for Canada and the US is implemented.  
     * The basic TaxCalculator requires an override percentage.  If one of the additional modules are used, 
     * then additional functionality will be provided.  Addresses should go through getAlternateAddresses before being passed in.  
     * Otherwise accurate tax calculation can not be performed.
     *
     * @param params {@link TaxParameters} provided for tax calculation
     * @param lines {@link TaxLineList} provided for tax calculation
     * @throws com.beasys.commerce.foundation.exception.SystemException
     * @throws com.beasys.commerce.ebusiness.tax.TaxException
     */
    public com.beasys.commerce.ebusiness.tax.TaxResult calculateTax(com.beasys.commerce.ebusiness.tax.TaxParameters params, com.beasys.commerce.ebusiness.tax.TaxLineList lines) throws RemoteException ,com.beasys.commerce.foundation.exception.SystemException,com.beasys.commerce.ebusiness.tax.TaxException;
    /**
     * Given an address (with the stipulation that the Zipcode/postalcode is correct) 
     * return a set of addresses that may be the correct address (city, county combinations) 
     * 
     * @param address Address which needs to be checked.
     * @throws com.beasys.commerce.foundation.exception.SystemException
     */
    public com.beasys.commerce.axiom.contact.Address[] getAlternateAddresses(com.beasys.commerce.axiom.contact.Address address) throws RemoteException ,com.beasys.commerce.foundation.exception.SystemException,com.beasys.commerce.ebusiness.tax.TaxException;

    /**
     * This essentially creates an itemLine with no taxcode, 1 unit, 
     * and calls calculateTax with the line and parameters.
     *
     * @param params {@link TaxParameters} provided for tax calculation
     * @param total Total amount on which tax is to be calculated
     * @throws com.beasys.commerce.ebusiness.tax.TaxException
     */
    public com.beasys.commerce.axiom.units.Price calculateTotalTax(com.beasys.commerce.ebusiness.tax.TaxParameters params, com.beasys.commerce.axiom.units.Price total) throws RemoteException,com.beasys.commerce.foundation.exception.SystemException,com.beasys.commerce.ebusiness.tax.TaxException;

}







