/**
 *
 * Copyright (c) 2000-2002  BEA Systems, Inc.   All Rights Reserved
 *
 */
package examples.e2e.b2c.tax.pipeline;

/**
 * <code>TaxCalculateLineLevelPC</code> determines the taxes for the
 * shopping cart in the same way as the {@link
 * TaxCalculateAndCommitLineLevelPC} except that it will not commit
 * the result to the audit file that is used in tax reporting.  It is
 * used to calculate taxes prior so that they can be presented to the
 * user prior to checkout.
 */
public class TaxCalculateLineLevelPC extends TaxCalculateAndCommitLineLevelPC
{
    /**
     * @return true if the calculated tax is to be commited
     */    
    boolean getCommit()
    {
        return false;
    }
}



