/**
 *
 * Copyright (c) 2000-2002  BEA Systems, Inc.   All Rights Reserved
 *
 */

package examples.e2e.b2c.tax.pipeline;

import com.bea.p13n.appflow.exception.PipelineException;

/**
 * A TaxPipelineSystemException indicates a failure in the underlying
 * tax calculation service.
 *
 * @see com.beasys.commerce.util.MessageCatalog
 */
public class TaxPipelineSystemException extends PipelineException
{
   
    public TaxPipelineSystemException(String message)
    {
        super(message);
    }

    public TaxPipelineSystemException(String message,Exception e)
    {
        super(message, e);
    }

    /**
     * Constructs a TaxPipelineSystemException
     */
    public TaxPipelineSystemException(String messageKey, String argument)
    {
        super(messageKey + ":" + argument);
    }
    /**
     * Constructs a TaxPipelineSystemException
     */
    public TaxPipelineSystemException(String namespace, String messageKey, String argument)
    {
        super(namespace + ":" + messageKey + ":" + argument);
    }
    /**
     * Constructs a TaxPipelineSystemException
     */
    public TaxPipelineSystemException(String messageKey, Object[] argument)
    {
        super(messageKey);
    }
    /**
     * Constructs a TaxPipelineSystemException
     */
    public TaxPipelineSystemException(String namespace, String messageKey, Object[] argument)
    {
        super(namespace + ":" + messageKey);
    }    
    
    /**
     * Constructs a TaxPipelineSystemException
     */
    public TaxPipelineSystemException(String namespace, String messageKey, Exception embeddedException)
    {
       super(namespace + ":" + messageKey, embeddedException);
    }    
    /**
     * Constructs a TaxPipelineSystemException
     */
    public TaxPipelineSystemException(String namespace, String messageKey, String argument, Exception embeddedException)
    {
	 super(namespace + ":" + messageKey + ":" + argument,embeddedException);
        
    }
 
    /**
     * Constructs a TaxPipelineSystemException
     */
    public TaxPipelineSystemException(String messageKey, Object[] argument, Exception embeddedException)
    {
        super(messageKey, embeddedException);
        
    }
    /**
     * Constructs a TaxPipelineSystemException
     */
    public TaxPipelineSystemException(String namespace, String messageKey, Object[] argument, Exception embeddedException)
    {
        super(namespace + ":" + messageKey, embeddedException);
        
    }    
              
}
