/**
 *
 * Copyright (c) 2000-2002  BEA Systems, Inc.   All Rights Reserved
 *
 */

package examples.e2e.b2c.tax.pipeline;

import com.bea.p13n.appflow.exception.PipelineException;

/**
 * The TaxPipelineUserException indicates a condition that requires
 * resolution from the end user.  Presently the only user exceptions
 * are related to address verification and are thrown by
 * the TaxVerifyShippingAddressPC to indicate that the address 
 * specified is not sufficient for accurate tax calculation.
 */
public class TaxPipelineUserException extends PipelineException
{
   
    public TaxPipelineUserException(String message)
    {
        super(message);
    }

    public TaxPipelineUserException(String message,Exception e)
    {
        super(message,e);
    }    

    /**
     * Constructs a TaxPipelineUserException
     */
    public TaxPipelineUserException(String messageKey, String argument)
    {
        super(messageKey + ":" + argument);
    }

    /**
     * Constructs a TaxPipelineUserException
     */
    public TaxPipelineUserException(String namespace, String messageKey, String argument)
    {
        super(namespace + ":" + messageKey + ":" + argument);
    }

    /**
     * Constructs a TaxPipelineUserException
     */
    public TaxPipelineUserException(String messageKey, Object[] argument)
    {
        super(messageKey);
    }

    /**
     * Constructs a TaxPipelineUserException
     */
    public TaxPipelineUserException(String namespace, String messageKey, Object[] argument)
    {
        super(namespace + ":" + messageKey);
    }    
  
    /**
     * Constructs a TaxPipelineUserException
     */
    public TaxPipelineUserException(String namespace, String messageKey, Exception embeddedException)
    {
       super(namespace + ":" + messageKey, embeddedException);
    }    

    /**
     * Constructs a TaxPipelineUserException
     */
    public TaxPipelineUserException(String namespace, String messageKey, String argument, Exception embeddedException)
    {
	 super(namespace + ":" + messageKey + ":" + argument,embeddedException);
        
    }
 
    /**
     * Constructs a TaxPipelineUserException
     */
    public TaxPipelineUserException(String messageKey, Object[] argument, Exception embeddedException)
    {
        super(messageKey, embeddedException);
        
    }

    /**
     * Constructs a TaxPipelineUserException
     */
    public TaxPipelineUserException(String namespace, String messageKey, Object[] argument, Exception embeddedException)
    {
        super(namespace + ":" + messageKey, embeddedException);
        
    }    
              
}
