/*
 * B E A   S Y S T E M S
 *
 * P O R T A L
 *
 * Copyright (c) 2000-2002  BEA Systems, Inc.
 *
 * All Rights Reserved. Unpublished rights reserved under the copyright laws
 * of the United States. The software contained on this media is proprietary
 * to and embodies the confidential technology of BEA Systems, Inc. The
 * possession or receipt of this information does not convey any right to disclose
 * its contents, reproduce it, or use,  or license the use, for manufacture or
 * sale, the information or anything described therein. Any use, disclosure, or
 * reproduction without BEA System's prior written permission is strictly prohibited.
 *
 * $Header: /cvsroot/site/bea-lsd/deploy/e2eDomain/beaApps/e2eApp/src/examples/e2e/b2c/util/B2CPortalConstants.java,v 1.2 2002/05/02 00:22:12 toneill Exp $
 */

package examples.e2e.b2c.util;

/**
 * This class contains constants used throughout the b2cPortal
 * application.
 */
public class B2CPortalConstants
{
    /* Product category short descriptions */

    /** The consumer cameras category name */
    public static final String CONSUMER_CATEGORY_DESC =
        "Consumer Digital Cameras";

    /** The professional cameras category name */
    public static final String PRO_CATEGORY_DESC =
        "Professional Digital Cameras";

    /** The digital video cameras category name */
    public static final String VIDEO_CATEGORY_DESC =
        "Digital Video Cameras";

    /** The flashes and lenses category name */
    public static final String FLASH_CATEGORY_DESC =
        "Flashes and Lenses";

    /** The bags and cases category name */
    public static final String BAGS_CATEGORY_DESC =
        "Bags and Cases";

    /** The memory, cables, and printers category name */
    public static final String MEMORY_CATEGORY_DESC =
        "Memory / Cables / Printers";


    /* Product category names */

    /** The consumer cameras category name */
    public static final String CONSUMER_CATEGORY_NAME = "AviPix";

    /** The professional cameras category name */
    public static final String PRO_CATEGORY_NAME = "AviPro";

    /** The digital video cameras category name */
    public static final String VIDEO_CATEGORY_NAME = "AviCam";

    /** The flashes and lenses category name */
    public static final String FLASH_CATEGORY_NAME = "AviFlex";

    /** The bags and cases category name */
    public static final String BAGS_CATEGORY_NAME = "AviPack";

    /** The memory, cables, and printers category name */
    public static final String MEMORY_CATEGORY_NAME = "Accessories";


    /* Product category ids */

    /** The consumer cameras category id */
    public static final String CONSUMER_CATEGORY_ID = "0avipix";

    /** The professional cameras category id */
    public static final String PRO_CATEGORY_ID = "2avipro";

    /** The digital video cameras category id */
    public static final String VIDEO_CATEGORY_ID = "4avicam";

    /** The flashes and lenses category id */
    public static final String FLASH_CATEGORY_ID = "1aviflex";

    /** The bags and cases category id */
    public static final String BAGS_CATEGORY_ID = "3avipack";

    /** The memory, cables, and printers category id */
    public static final String MEMORY_CATEGORY_ID = "5aviconnect";


    /* Portal page names */

    /** The "Home" portal page name */
    public static final String HOME_PAGE_NAME = "Home";

    /** The "My Avitek" portal page name */
    public static final String MY_AVITEK_PAGE_NAME = "My Avitek";

    /** The "Photo Center" portal page name */
    public static final String PHOTO_CENTER_PAGE_NAME = "Photo Center";

    /** The products portal page name */
    public static final String PRODUCTS_PAGE_NAME = "Products";

    /** The shopping cart portal page name */
    public static final String SHOPPING_CART_PAGE_NAME = "Shopping Cart";


    /* Pipeline session attributes */

    /** The last catalog webflow event the client generated */
    public static final String LAST_CATALOG_EVENT_ATTRIB =
        "b2cportal_last_catalog_event";

    /** Order History portlet: true if order history list is up-to-date */
    public static final String ORDER_HISTORY_LIST_VALID = "e2e.order.history.valid";

    /** Order History portlet: cached order history list */
    public static final String ORDER_HISTORY_LIST = "e2e.order.history";

    /** The attribute used to store checkout events for the Doc Portlet  */
    public static final String DOC_PORTLET_LOCATION = "e2e_doc_location";

    /** Copy of DOC_PORTLET_LOCATION for maximized view  */
    public static final String DOC_PORTLET_MAX_LOCATION = "e2e_doc_max_location";

    /** Inventory check used by the checkout portlet, step1 */
    public static final String INVENTORY_CHECK = "INVENTORY_CHECK";

    /* Payment auth/capture/settle result */
    public static final String PAYMENT_AUTH_CAPTURE_SETTLE_RESULT = "PAYMENT_AUTH_CAPTURE_SETTLE_RESULT";

    /* Misc. portlet constants needing scoping */

    /** Product Evaluator portlet: holds indication of current catalog processing */
    public static final String PRODUCT_EVAL_ATTRIB = "e2e.b2c.productEvaluator.evalEvent";


}

