
/*                 
 * B E A   S Y S T E M S   
 *
 * C O M M E R C E   C O M P O N E N T S
 *                        
 * Copyright (c) 2000-2002  BEA Systems, Inc.  
 *
 * All Rights Reserved. Unpublished rights reserved under the copyright laws 
 * of the United States. The software contained on this media is proprietary 
 * to and embodies the confidential technology of BEA Systems, Inc. The 
 * possession or receipt of this information does not convey any right to disclose 
 * its contents, reproduce it, or use,  or license the use, for manufacture or 
 * sale, the information or anything described therein. Any use, disclosure, or
 * reproduction without BEA System's prior written permission is strictly prohibited.
 *
 */

package examples.e2e.common;

import com.bea.commerce.ebusiness.price.quote.Money;

import java.util.Calendar;
import java.io.Serializable;


/**
 * Represents a query for price and availability that is to be communicated
 * to supplier(s).
 *
 * @author Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved.
 */
public interface QPA extends Serializable {

    /**
     * Returns the identifier for this QPA.
     */
    public String requestId();
    
    /**
     * Returns the date this QPA was created.
     */
    public Calendar creationDate();

    /**
     * Returns the identifier for the product to be quoted.
     */
    public String productId();

    /**
     * Returns a description for the product to be quoted.
     */
    public String description();
    
    /**
     * Returns the quantity of the product desired by the purchaser.
     */
    public long desiredQty();
    
    /**
     * Returns the unit price desired by the purchaser.
     */
    public Money desiredUnitPrice();

    /**
     * Returns the date the purchaser desires to receive the product.
     */
    public Calendar desiredDate();
    
}
