
/*                 
 * B E A   S Y S T E M S   
 *
 * C O M M E R C E   C O M P O N E N T S
 *                        
 * Copyright (c) 2000-2002  BEA Systems, Inc.  
 *
 * All Rights Reserved. Unpublished rights reserved under the copyright laws 
 * of the United States. The software contained on this media is proprietary 
 * to and embodies the confidential technology of BEA Systems, Inc. The 
 * possession or receipt of this information does not convey any right to disclose 
 * its contents, reproduce it, or use,  or license the use, for manufacture or 
 * sale, the information or anything described therein. Any use, disclosure, or
 * reproduction without BEA System's prior written permission is strictly prohibited.
 *
 */

// TODO move to QA source tree
package examples.e2e.common;

import examples.e2e.common.Inventory;
import examples.e2e.common.InventoryImpl;

import com.bea.p13n.util.debug.Debug;

import java.util.List;
import java.util.ArrayList;


public class TestInventoryFactory {

    private static Debug debug =
            Debug.getInstance( TestInventoryFactory.class );


    private static final List PROD_LIST = new ArrayList( 3 );
    static {
        PROD_LIST.add( new InventoryImpl( "M1", 1000L, 2000L, 1500L,
                "purch_process_step1_avi1000.gif",
                "purch_process_step2_avipix1000.gif" ) );
        PROD_LIST.add( new InventoryImpl( "M2", 500L, 1000L, 300L,
                "purch_process_step1_avi3000.gif",
                "purch_process_step2_avipix3000.gif" ) );
        PROD_LIST.add( new InventoryImpl( "M3", 2000L, 3000L, 2500L,
                "purch_process_step1_avi5000.gif",
                "purch_process_step2_avipix5000.gif" ) );
    }

    private static final List PART_LIST = new ArrayList( 3 );
    static {
        PART_LIST.add( new InventoryImpl( "part1", "description for part 1",
                1000L, 2000L, 1500L ) );
        PART_LIST.add( new InventoryImpl( "part2", "description for part 2",
                500L, 1000L, 300L ) );
        PART_LIST.add( new InventoryImpl( "part3", "description for part 3",
                2000L, 3000L, 2500L ) );
        PART_LIST.add( new InventoryImpl( "part4", "description for part 4",
                2000L, 3000L, 2500L ) );
    }


    /**
     * creates a canned <code>List</code> of <code>Inventory</code>
     * objects that represent products.
     */
    public static List createProduct( List ids ) {

        return PROD_LIST;
    }

    /**
     * creates a canned <code>List</code> of <code>Inventory</code>
     * objects that represent parts.
     */
    public static List createPart( String id ) {

        return PART_LIST;
    }

}
