package examples.e2e.common;

import com.bea.eci.logging.*;
import java.io.*;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.StringTokenizer;

public class WLIUtils
    implements Serializable
{

    public WLIUtils()
    {
    }

    public static String timeStamp()
    {
        SimpleDateFormat simpledateformat = new SimpleDateFormat("yyyyMMdd'T'HHmmss'.'SSS'Z'");
        Date date = new Date();
        String s = simpledateformat.format(date);
        return s;
    }

    public static String shortTimeStamp()
    {
        SimpleDateFormat simpledateformat = new SimpleDateFormat("yyyyMMdd'Z'");
        Date date = new Date();
        String s = simpledateformat.format(date);
        return s;
    }

    public static void binaryToFile(byte abyte0[], String s)
    {
        UserLog.log("...Business operation---binary to file...begin...");
        try
        {
            FileOutputStream fileoutputstream = new FileOutputStream(setRoot(s));
            fileoutputstream.write(abyte0);
            fileoutputstream.flush();
            fileoutputstream.close();
        }
        catch(IOException ioexception)
        {
            ioexception.printStackTrace();
        }
        UserLog.log("...Business operation---binary to file...complete...");
    }

    public static byte[] fileToBinary(String s)
    {
        UserLog.log("...Business operation---file to binary...begin...");
        byte abyte0[] = null;
        try
        {
            BufferedInputStream bufferedinputstream = new BufferedInputStream(new FileInputStream(setRoot(s)));
            abyte0 = new byte[bufferedinputstream.available()];
            bufferedinputstream.read(abyte0, 0, abyte0.length);
            UserLog.log("...Business operation---file to binary...complete...");
        }
        catch(IOException ioexception)
        {
            ioexception.printStackTrace();
        }
        return abyte0;
    }

    public static void createPOAck(String s, String s1, String s2, String s3, String s4, String s5, String s6, String s7, 
            String s8)
    {
        try
        {
            File file = setRoot(s);
            FileReader filereader = new FileReader(file);
            char ac[] = new char[(int)file.length()];
            filereader.read(ac, 0, (int)file.length());
            StringTokenizer stringtokenizer = new StringTokenizer(new String(ac), ",");
            Object obj = null;
            String s10 = null;
            while(stringtokenizer.hasMoreTokens()) 
            {
                String s9 = stringtokenizer.nextToken();
                if(s9.equals("HEADER: PO"))
                    s10 = "HEADER: POAck,";
                else
                if(s9.equals(s3))
                    s10 = s10 + s9 + "," + s5 + "," + s6 + ",";
                else
                if(!s9.equals(s2))
                    if(s9.equals(s4))
                    {
                        s10 = s10 + s9 + ",|**" + s7 + "," + s8 + ",";
                    } else
                    {
                        s10 = s10 + s9;
                        if(stringtokenizer.hasMoreTokens())
                            s10 = s10 + ",";
                    }
            }
            UserLog.log("POAck data generated from PO: \n" + s10);
            FileOutputStream fileoutputstream = new FileOutputStream(setRoot(s1));
            fileoutputstream.write(s10.getBytes());
            fileoutputstream.flush();
            fileoutputstream.close();
        }
        catch(IOException ioexception)
        {
            ioexception.printStackTrace();
        }
        catch(Exception exception)
        {
            exception.printStackTrace();
        }
    }

    public static void serializeXML(String s, String s1)
        throws IOException
    {
        FileWriter filewriter = new FileWriter(setRoot(s));
        filewriter.write(s1, 0, s1.length());
        filewriter.flush();
        filewriter.close();
    }

    public static byte[] StringToByte(String s)
        throws Exception
    {
        return s.getBytes();
    }

    public static String ByteToString(byte abyte0[])
        throws Exception
    {
        return new String(abyte0);
    }

    public static File setRoot(String s)
    {
        File file = new File(s);
        if(rootDir == null || file.isAbsolute())
            return file;
        else
            return new File(rootDir, s);
    }

    static LogOutputStream log;
    static String rootPath;
    static File rootDir;

    static 
    {
        log = SystemLog.log.getOutputStream("E2E-");
        rootPath = System.getProperty("weblogic.RootDirectory");
        if(rootPath != null)
            rootDir = new File(rootPath);
    }
}
