/**
 * CheckInventoryAction.java
 *
 *
 * @author Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved.
 */

package examples.e2e.common.inventory.ref;

import com.bea.wlai.client.*;
import com.bea.document.IDocument;
import javax.naming.InitialContext;
import com.bea.document.IDocumentDefinition;
import javax.naming.Context;
import java.util.*;
import com.bea.p13n.util.debug.Debug;

public class CheckInventoryAction {
	private String sku_ = null;
    private Context ctx_;
	private static final Debug DEBUG =
		Debug.getInstance(CheckInventoryAction.class);
    
 public CheckInventoryAction(String url, String sku) {
	sku_ = sku;
	try {
		Hashtable attrs = new Hashtable();
		attrs.put(Context.PROVIDER_URL, url);
		attrs.put(Context.INITIAL_CONTEXT_FACTORY, 	"weblogic.jndi.WLInitialContextFactory");
		ctx_ = new InitialContext(attrs);
	} catch (Exception e) {
		e.printStackTrace();
	}
 }
 public Object run() {
	String numStr = "0";
	try {

    	if (DEBUG.ON) {
		    DEBUG.out("CheckInventory:in run()");
        }

		ApplicationView appView = new ApplicationView(ctx_, "E2EAppView.sav");
		// Create a request document using the definition stored for the Application View at deployment time.
		IDocumentDefinition rd = appView.getRequestDocumentDefinition("checkInventory");
		IDocument request = rd.createDefaultDocument();
		// Fill in the request with some data.  
		request.setStringInFirst("SKU", sku_);
		// Invoke the service and retrieve the response document
		IDocument response = appView.invokeService("checkInventory", request);
		appView.close();
    	if (DEBUG.ON) {
		    DEBUG.out("CheckInventory:run: resp:\n" + response.toXML() + "\n");
        }
		numStr = response.getStringFrom("/Rows/Row/QTY_IN_STOCK");

    	if (DEBUG.ON) {
		    DEBUG.out("CheckInventory:run: " + "sku:" + sku_ + " num:" +  numStr);
        }

	} catch (Exception e) {
		e.printStackTrace();
	} finally {
        return numStr;
    } 
 }
}
