package examples.e2e.common.inventory.spi;

/*
 * B E A   S Y S T E M S
 *
 * C O M M E R C E  C O M P O N E N T S
 *
 * Copyright (c) 2000-2002  BEA Systems, Inc.
 *
 * All Rights Reserved. Unpublished rights reserved under the copyright laws
 * of the United States. The software contained on this media is proprietary
 * to and embodies the confidential technology of BEA Systems, Inc. The
 * possession or receipt of this information does not convey any right to disclose
 * its contents, reproduce it, or use,  or license the use, for manufacture or
 * sale, the information or anything described therein. Any use, disclosure, or
 * reproduction without BEA System's prior written permission is strictly prohibited.
 *
 * $Header: /cvsroot/site/bea-lsd/deploy/e2eDomain/beaApps/e2eApp/src/examples/e2e/common/inventory/spi/InventoryProviderHome.java,v 1.2 2002/05/02 00:22:12 toneill Exp $
 */

/**
 * This interface is the home interface for the <code>InventoryProvider</code> EJB.
 */


// java imports
import java.rmi.RemoteException;
import javax.ejb.CreateException;
import javax.ejb.EJBHome;


public interface InventoryProviderHome extends EJBHome {

    /**
        * The EJB-REF name for this <code>EJBHome</code>.
        */
    public static final String EJB_REF_NAME = "java:comp/env/ejb/InventoryProvider";
    
   /**
    * This method corresponds to the ejbCreate method in the <code>InventoryProvider</code>
    * EJB implementation.  The parameter sets of the two methods are identical. When 
    * a client calls <code>InventoryProviderHome.create()</code>, the EJB container
    * allocates an instance of the EJB and invokes the <code>ejbCreate()</code>
    * method on the instance.
    *
    * @return                  a <code>InventoryProvider</code> instance.
    * @exception               RemoteException if there is
    *                          a communications error.
    * @exception               CreateException
    *                          if there is a problem creating the EJB.
    * @see                     InventoryProvider
    */
    InventoryProvider create() throws CreateException, RemoteException;
}
