/*
 * B E A   S Y S T E M S
 * C O M M E R C E   C O M P O N E N T S
 *
 * Copyright (c) 2000-2002  BEA Systems, Inc.
 *
 * All Rights Reserved. Unpublished rights reserved under the copyright laws
 * of the United States. The software contained on this media is proprietary
 * to and embodies the confidential technology of BEA Systems, Inc. The
 * possession or receipt of this information does not convey any right to disclose
 * its contents, reproduce it, or use,  or license the use, for manufacture or
 * sale, the information or anything described therein. Any use, disclosure, or
 * reproduction without BEA System's prior written permission is strictly prohibited.
 *
 * $Header: /cvsroot/site/bea-lsd/deploy/e2eDomain/beaApps/e2eApp/src/examples/e2e/common/purchase/ref/JMSQueueSender.java,v 1.2 2002/05/02 00:22:12 toneill Exp $
 */

package examples.e2e.common.purchase.ref;

import java.util.Hashtable;
import java.io.IOException;

import javax.jms.*;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import com.bea.p13n.util.debug.Debug;

/**
 * A JMS test utility that can publish to a pre-defined JMS queue. 
 */
public class JMSQueueSender {

	private Context ctx_;
	private static final Debug DEBUG =
		Debug.getInstance(JMSQueueSender.class);

    

public JMSQueueSender() {
}


private static Context getInitialContext(String url, String initContextFactory) throws NamingException {
	Hashtable attrs = new Hashtable();
	attrs.put(Context.PROVIDER_URL, url);
	attrs.put(Context.INITIAL_CONTEXT_FACTORY, initContextFactory);

	return new InitialContext(attrs);
}

public void send(
	String url,
	String initContextFactory,
	String connectionFactory,
	String queue,
	String textToPublish)
	throws NamingException, JMSException, IOException {

	// Lookup using an initial context.
	ctx_ = getInitialContext(url, initContextFactory);

	QueueConnectionFactory qcf =
		(QueueConnectionFactory) ctx_.lookup(connectionFactory);
	Queue sendQueue = (Queue) ctx_.lookup(queue);
	QueueConnection con = qcf.createQueueConnection();
	QueueSession session = con.createQueueSession(false, Session.AUTO_ACKNOWLEDGE);
	QueueSender sender = session.createSender(sendQueue);

	TextMessage msg = session.createTextMessage();
	msg.setText(textToPublish);
    if (DEBUG.ON) {
        DEBUG.out("Message being sent:" + textToPublish);
    }
	sender.send(msg);

	sender.close();
	session.close();
	con.stop();
}
}
