package examples.e2e.common.purchase.ref;

/*
 * B E A   S Y S T E M S
 *
 * C O M M E R C E  C O M P O N E N T S
 *
 * Copyright (c) 2000-2002  BEA Systems, Inc.
 *
 * All Rights Reserved. Unpublished rights reserved under the copyright laws
 * of the United States. The software contained on this media is proprietary
 * to and embodies the confidential technology of BEA Systems, Inc. The
 * possession or receipt of this information does not convey any right to disclose
 * its contents, reproduce it, or use,  or license the use, for manufacture or
 * sale, the information or anything described therein. Any use, disclosure, or
 * reproduction without BEA System's prior written permission is strictly prohibited.
 *
 * $Header: /cvsroot/site/bea-lsd/deploy/e2eDomain/beaApps/e2eApp/src/examples/e2e/common/purchase/ref/PurchaseManagerNoOpImpl.java,v 1.2 2002/05/02 00:22:12 toneill Exp $
 */

// java imports
import java.util.*;
import java.rmi.RemoteException;
import javax.ejb.CreateException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;

//internal imports
import com.bea.p13n.exceptions.ApplicationException;

import com.bea.p13n.util.debug.Debug;

import com.beasys.commerce.ebusiness.order.*;
import examples.e2e.common.*;

/**
 * PurchaseManagerNoOpImpl is a stateless Session Bean. This bean provides:
 * the following services:
 * <ul>
 * <li> No Operation (NoOp) implementation to clients.
 * </ul>
 *
 */

public class PurchaseManagerNoOpImpl implements SessionBean {

	/**
	  * The debug instance for this class
	  */
	private static final Debug DEBUG =
		Debug.getInstance(PurchaseManagerNoOpImpl.class);

	/**
	* License check flag.
	*/
	private static boolean checkedLicense = false;

	private SessionContext ctx;


/**
	* Create an instance of PurchaseManagerNoOpImpl.
	*/
public PurchaseManagerNoOpImpl() {
	super();

	if (!checkedLicense) {
		com.bea.p13n.license.LicenseHelper.getInstance().checkLicense(
			com.bea.p13n.common.P13nProduct.CORE);
		checkedLicense = true;
	}
}

/**
	* This method is required by the EJB Specification,
	*/
public void ejbActivate() {
	if (DEBUG.ON)
		DEBUG.out("ejbActivate called");
}
/**
	* This method corresponds to the create method in the home interface
	* @exception               javax.ejb.CreateException if there is
	*                          a communications or systems failure
	*/
public void ejbCreate() throws CreateException {
	if (DEBUG.ON) {
		DEBUG.out("ejbCreate called");
	}

}
/**
	* This method is required by the EJB Specification,
	*/
public void ejbPassivate() {
	if (DEBUG.ON)
		DEBUG.out("ejbPassivate called");
}
/**
	* This method is required by the EJB Specification,
	*/
public void ejbRemove() {
	if (DEBUG.ON)
		DEBUG.out("ejbRemove called");
}


/**
 * Sets the session context.
 *
 * @param ctx    SessionContext Context for session
 */
public void setSessionContext(SessionContext ctx) {

	if (DEBUG.ON) {
		DEBUG.out("setSessionContext called");
	}
	this.ctx = ctx;

}

/**
   * 
   *
   * @param aOrder A commerce order
   * @throws IllegalArgumentException if <code>aOrder</code> is <code>null</code> 
   * @throws ApplicationException if an exception was returned in accessing the information.
   * @throws RemoteException if a communication error occurs during the execution 
   * of a remote method call.   
  */

public void queueOrder(OrderValue aOrder)
	throws IllegalArgumentException, ApplicationException, RemoteException {

	return;
}

/**
   * 
   *
   * @param aQuote A quote originally sent by the supplier
   * @throws IllegalArgumentException if <code>aQuote</code> is <code>null</code> 
   * @throws ApplicationException if an exception was returned in accessing the information.
   * @throws RemoteException if a communication error occurs during the execution 
   * of a remote method call.   
   */

public void queuePORequest(PurchaseQuote aQuote)
	throws IllegalArgumentException, ApplicationException, RemoteException {

	return;
}

/**
   * 
   *
   * @param aQPA Query for Price and Availability from the buyer to the supplier
   * @throws IllegalArgumentException if <code>aQPARequest</code> is <code>null</code> 
   * @throws ApplicationException if an exception was returned in accessing the information.
   * @throws RemoteException if a communication error occurs during the execution 
   * of a remote method call.  
   */

public void queueQPA(QPA aQPARequest)
	throws IllegalArgumentException, ApplicationException, RemoteException {

	return;
}
}
