package examples.e2e.common.purchase.spi;

/*
 * B E A   S Y S T E M S
 *
 * C O M M E R C E  C O M P O N E N T S
 *
 * Copyright (c) 2000-2002  BEA Systems, Inc.
 *
 * All Rights Reserved. Unpublished rights reserved under the copyright laws
 * of the United States. The software contained on this media is proprietary
 * to and embodies the confidential technology of BEA Systems, Inc. The
 * possession or receipt of this information does not convey any right to disclose
 * its contents, reproduce it, or use,  or license the use, for manufacture or
 * sale, the information or anything described therein. Any use, disclosure, or
 * reproduction without BEA System's prior written permission is strictly prohibited.
 *
 * $Header: /cvsroot/site/bea-lsd/deploy/e2eDomain/beaApps/e2eApp/src/examples/e2e/common/purchase/spi/PurchaseManager.java,v 1.2 2002/05/02 00:22:12 toneill Exp $
 */

//java imports
import java.rmi.RemoteException;
import javax.ejb.EJBObject;
import java.util.List;

//internal imports
import com.bea.p13n.exceptions.ApplicationException;

import com.beasys.commerce.ebusiness.order.*;
import examples.e2e.common.*;

/**
 * This interface defines a stateless API for providing purchase related
 * functionality.  This interface is exposed as a stateless session EJB 
 * that can be created using the <code>PurchaseManagerHome</code>.
 *
 * 
 * @see examples.e2e.common.purchase.spi.PurchaseManagerHome
 */

public interface PurchaseManager extends EJBObject {




/**
   *
   * @param aOrder A commerce order
   * @throws IllegalArgumentException if <code>aOrder</code> is <code>null</code> 
   * @throws ApplicationException if an exception was returned in accessing the information. 
   * @throws RemoteException if a communication error occurs during the execution 
   * of a remote method call.   
*/

public void queueOrder(OrderValue aOrder)
	throws IllegalArgumentException, ApplicationException, RemoteException;

/**
   *
   * @param aQuote A quote originally sent by the supplier
   * @throws IllegalArgumentException if <code>aQuote</code> is <code>null</code> 
   * @throws ApplicationException if an exception was returned in accessing the information.  
   * @throws RemoteException if a communication error occurs during the execution 
   * of a remote method call.   
*/

public void queuePORequest(PurchaseQuote aQuote)
	throws IllegalArgumentException, ApplicationException, RemoteException;

/**
   *
   * @param aQPA Query for Price and Availability from the buyer to the supplier
   * @throws IllegalArgumentException if <code>aQPARequest</code> is <code>null</code> 
   * @throws ApplicationException if an exception was returned in accessing the information. 
   * @throws RemoteException if a communication error occurs during the execution 
   * of a remote method call.  
   */

public void queueQPA(QPA aQPARequest)
	throws IllegalArgumentException, ApplicationException, RemoteException;
}
