/*
 * B E A   S Y S T E M S
 *
 * P O R T A L
 *
 * Copyright (c) 2000-2002  BEA Systems, Inc.
 *
 * All Rights Reserved. Unpublished rights reserved under the copyright laws
 * of the United States. The software contained on this media is proprietary
 * to and embodies the confidential technology of BEA Systems, Inc. The
 * possession or receipt of this information does not convey any right to disclose
 * its contents, reproduce it, or use,  or license the use, for manufacture or
 * sale, the information or anything described therein. Any use, disclosure, or
 * reproduction without BEA System's prior written permission is strictly prohibited.
 *
 * $Header: /cvsroot/site/bea-lsd/deploy/e2eDomain/beaApps/e2eApp/src/examples/e2e/common/tourguide/TourGuideData.java,v 1.2 2002/05/02 00:22:12 toneill Exp $
 */

package examples.e2e.common.tourguide;

import java.io.Serializable;

import examples.e2e.common.tourguide.TourGuide;

/**
 * This class is used to store state data for a particular instance of
 * the Tour Guide portlet.
 */
public class TourGuideData implements Serializable
{
    /* Protected fields */

    /** The current JSP source which should be displayed */
    protected String codeFile;

    /** The last maximized view of the Tour Guide the user selected */
    protected String lastOption;

    /** The current "content state" that the Tour Guide should be displaying */
    protected String state;


    /* Constructors */

    public TourGuideData()
    {
        /* Set the instance data to appropriate default values */

        codeFile = "/portlets/tourguide/minimized.jsp";
        lastOption = TourGuide.TECH_DETAILS_VALUE;
        state = "default";
    }

    /** Return the current JSP source file to be displayed */
    public String getCodeFile()
    {
        return codeFile;
    }

    /** Return the last maximized view the user selected */
    public String getLastOption()
    {
        return lastOption;
    }

    /** Return the current "content state" of the Tour Guide */
    public String getState()
    {
        return state;
    }
    
    /** Set the current JSP source file to be displayed */
    public void setCodeFile( String newCodeFile )
    {
        codeFile = newCodeFile;
    }

    /** Set the last maximized view the user selected */
    public void setLastOption( String newLastOption )
    {
        lastOption = newLastOption;
    }

    /** Set the current "content state" of the Tour Guide */
    public void setState( String newState )
    {
        state = newState;
    }
}
