package examples.wlcs.sampleapp.tax;

import java.io.*;
import java.util.*;
import java.text.*;


public class TaxResponseElement
{
	private String	generalResponseCode = null;
	private String	generalResponseMessage = null;
	private String	countryResponseCode = null;
	private String	countryResponseMessage = null;
	private String	provinceResponseCode = null;
	private String	provinceResponseMessage = null;
	private String	countyResponseCode = null;
	private String	countyResponseMessage = null;
	private String	cityResponseCode = null;
	private String	cityResponseMessage = null;
	private String	systemDate = null;
	private Double	countryCalculatedTaxAmount = null;
	private Double	provinceCalculatedTaxAmount = null;
	private Double	countyCalculatedTaxAmount = null;
	private Double	cityCalculatedTaxAmount = null;


	public TaxResponseElement()
	{
	}

	/**
	 * The various response codes and messages vary depending on your service provider
	 *
	 */
	public void setGeneralResponseCode( String code )
	{
		generalResponseCode = code;
	}
	public String getGeneralResponseCode()
	{
		return( generalResponseCode );
	}
	public void setGeneralResponseMessage( String message )
	{
		generalResponseMessage = message;
	}
	public String getGeneralResponseMessage()
	{
		return( generalResponseMessage );
	}

	public void setCountryResponseCode( String code )
	{
		countryResponseCode = code;
	}
	public String getCountryResponseCode()
	{
		return( countryResponseCode );
	}
	public void setCountryResponseMessage( String message )
	{
		countryResponseMessage = message;
	}
	public String getCountryResponseMessage()
	{
		return( countryResponseMessage );
	}

	public void setProvinceResponseCode( String code )
	{
		provinceResponseCode = code;
	}
	public String getProvinceResponseCode()
	{
		return( provinceResponseCode );
	}
	public void setProvinceResponseMessage( String message )
	{
		provinceResponseMessage = message;
	}
	public String getProvinceResponseMessage()
	{
		return( provinceResponseMessage );
	}

	public void setCountyResponseCode( String code )
	{
		countyResponseCode = code;
	}
	public String getCountyResponseCode()
	{
		return( countyResponseCode );
	}
	public void setCountyResponseMessage( String message )
	{
		countyResponseMessage = message;
	}
	public String getCountyResponseMessage()
	{
		return( countyResponseMessage );
	}

	public void setCityResponseCode( String code )
	{
		cityResponseCode = code;
	}
	public String getCityResponseCode()
	{
		return( cityResponseCode );
	}
	public void setCityResponseMessage( String message )
	{
		cityResponseMessage = message;
	}
	public String getCityResponseMessage()
	{
		return( cityResponseMessage );
	}

	public void setSystemDate( String aDate )
	{
		systemDate = aDate;
	}

	public String getSystemDate()
	{
		return systemDate;
	}

	public void saveSystemDate( java.util.Date date )
	{
		SimpleDateFormat	formatter = new SimpleDateFormat( "yyyyMMdd" );


		systemDate = formatter.format( date );
	}
	public java.util.Date obtainSystemDate()
	{
		SimpleDateFormat	formatter = new SimpleDateFormat( "yyyyMMdd" );
		ParsePosition		position = new ParsePosition( 0 );


		return( formatter.parse( systemDate, position ) );
	}


	public void setCountryCalculatedTaxAmount( Double amount )
	{
		countryCalculatedTaxAmount = amount;
	}
	public Double getCountryCalculatedTaxAmount()
	{
		return( countryCalculatedTaxAmount );
	}

	public void setProvinceCalculatedTaxAmount( Double amount )
	{
		provinceCalculatedTaxAmount = amount;
	}
	public Double getProvinceCalculatedTaxAmount()
	{
		return( provinceCalculatedTaxAmount );
	}

	public void setCountyCalculatedTaxAmount( Double amount )
	{
		countyCalculatedTaxAmount = amount;
	}
	public Double getCountyCalculatedTaxAmount()
	{
		return( countyCalculatedTaxAmount );
	}

	public void setCityCalculatedTaxAmount( Double amount )
	{
		cityCalculatedTaxAmount = amount;
	}
	public Double getCityCalculatedTaxAmount()
	{
		return( cityCalculatedTaxAmount );
	}

	public String toString()
	{
		StringBuffer	outputBuffer = new StringBuffer();
		String			lineSeparator = System.getProperty( "line.separator" );


		outputBuffer.append( "TaxResponseElement contents:" + lineSeparator );
		outputBuffer.append( "\tgeneral response code: \"" + getGeneralResponseCode() + "\"" + lineSeparator );
		outputBuffer.append( "\tgeneral response message: \"" + getGeneralResponseMessage() + "\"" + lineSeparator );
		outputBuffer.append( "\tcountry response code: \"" + getCountryResponseCode() + "\"" + lineSeparator );
		outputBuffer.append( "\tcountry response message: \"" + getCountryResponseCode() + "\"" + lineSeparator );
		outputBuffer.append( "\tprovince response code: \"" + getProvinceResponseCode() + "\"" + lineSeparator );
		outputBuffer.append( "\tprovince response message: \"" + getProvinceResponseCode() + "\"" + lineSeparator );
		outputBuffer.append( "\tcounty response code: \"" + getCountyResponseCode() + "\"" + lineSeparator );
		outputBuffer.append( "\tcounty response message: \"" + getCountyResponseCode() + "\"" + lineSeparator );
		outputBuffer.append( "\tcity response code: \"" + getCityResponseCode() + "\"" + lineSeparator );
		outputBuffer.append( "\tcity response message: \"" + getCityResponseCode() + "\"" + lineSeparator );
		outputBuffer.append( "\tsystem date: \"" + getSystemDate() + "\"" + lineSeparator );
		outputBuffer.append( "\tcountry calulated tax amount: \"" + getCountryCalculatedTaxAmount() + "\"" + lineSeparator );
		outputBuffer.append( "\tprovince calulated tax amount: \"" + getProvinceCalculatedTaxAmount() + "\"" + lineSeparator );
		outputBuffer.append( "\tcounty calulated tax amount: \"" + getCountyCalculatedTaxAmount() + "\"" + lineSeparator );
		outputBuffer.append( "\tcity calulated tax amount: \"" + getCityCalculatedTaxAmount() + "\"" + lineSeparator );

		return( outputBuffer.toString() );
	}
}
