<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<%@ page extends="com.bea.jsptools.common.servlets.jsp.ToolsJspBase"%>
<%@ taglib uri="weblogic.tld" prefix="wl" %>
<%@ taglib uri="webflow.tld" prefix="wf" %>
<%@ taglib uri="es.tld" prefix="es" %>

<%@ page import="com.bea.jsptools.p13n.common.servlets.jsp.JspUtilPages" %>
<%@ page import="com.beasys.commerce.ebusiness.catalog.*" %>
<%@ page import="com.beasys.commerce.ebusiness.catalog.jsp.*" %>
<%@ page import="com.beasys.commerce.ebusiness.catalog.service.category.*" %>
<%@ page import="com.beasys.commerce.ebusiness.catalog.service.query.*" %>
<%@ page import="com.beasys.commerce.webflow.HttpRequestConstants" %>

<jsp:useBean id="categoryItemManagementBean" class="com.beasys.commerce.ebusiness.catalog.jsp.beans.CategoryItemManagementBean" scope="session" />

<% request.setAttribute(SERVICEMANAGER_CURRENT_PAGE, getJspName(pageContext));%>

<%
   CategoryTreeManagerImpl categoryTreeManager = (CategoryTreeManagerImpl)categoryItemManagementBean.getTreeManager();
   CategoryManager categoryManager = categoryTreeManager.getCategoryManager();
   CatalogQueryManager queryManager = categoryTreeManager.getCatalogQueryManager();
   String statusMsg = null;
   String identifier = request.getParameter( HttpRequestConstants.CATALOG_CATEGORY_ID ); // the category identifier
   String[] searchResultItems = null;
   String[] categoryItems = null;
   String keywordString=request.getParameter("keywordSearch");
   String queryString=request.getParameter("querySearch");
   String params = null;        // the parameters to be passed to various methods
%>

<!-- if the user pressed save, save the matching items in the category -->
<wl:process name="formSubmit" value="save">
    <% try {
	// get all the entries in the category_items list box
	String[] items = request.getParameterValues("category_items");
        categoryItemManagementBean.storeNewItems(items);

	// add the items the category by consolidating the two arrays.
	categoryItemManagementBean.consolidate(categoryTreeManager, identifier);
  
        statusMsg = "Category '"+ categoryTreeManager.getDisplayName(identifier) +"' has been updated.";
     } catch (Exception e) {
        e.printStackTrace();
     }
     %>
</wl:process>


<!-- always populate the items in the category -->
<%
	if( identifier != null ) 
	{
	     // get a viewIterator with a window size of 100 items
	     ViewIterator itemIterator = categoryManager.getItems( categoryTreeManager.getCatalogRequest(), new CategoryKey(identifier), 100 );

	     // store the items and keys in the string in the format : name ( key )
	     categoryItems = new String[itemIterator.size()];
	     int p=0;
	     while(itemIterator.hasNext()) {
	          ProductItem item = (ProductItem)itemIterator.next();
	          categoryItems[p++] = categoryItemManagementBean.getFormattedText(
	                                  item.getName(),
	                                  item.getKey().getIdentifier());
	     }

	     // add the items in the bean
	     categoryItemManagementBean.storeOriginalItems(categoryItems);
	}
	else
		statusMsg = "No current parent category identifier.";
%>


<!-- get all the items matching the search criteria  -->

<wl:process name="orphanedItemSearch">
     <%
     try
     {
          ViewIterator searchResultsIterator = categoryManager.getOrphanedItems( categoryTreeManager.getCatalogRequest(), 100 );

          // add all the items to the string array
          searchResultItems = new String[ searchResultsIterator.size() ];

          int i=0;
          while(searchResultsIterator.hasNext()) {
              ProductItem item = (ProductItem)searchResultsIterator.next();
              searchResultItems[i++] = categoryItemManagementBean.getFormattedText(
                                  item.getName(),
                                  item.getKey().getIdentifier() );
          }

          // use the bean to remove duplicate items from the searchResultItems Array by looking at the
          // categoryItems array
          searchResultItems = categoryItemManagementBean.removeDuplicates(searchResultItems, categoryItems);
     } catch(Exception e) {
          statusMsg = "Unable to perform search for uncategorized items.";
     }
     %>
</wl:process>

<wl:process name="keywordSearch">
     <%
     try
     {
          ViewIterator searchResultsIterator = categoryItemManagementBean.keywordSearch(categoryTreeManager,
                                                   (String)request.getParameter("keywordSearch"));
          // add all the items to the string array
          searchResultItems = new String[ searchResultsIterator.size() ];

          int i=0;
          while(searchResultsIterator.hasNext()) {
              ProductItem item = (ProductItem)searchResultsIterator.next();
              searchResultItems[i++] = categoryItemManagementBean.getFormattedText(
                                  item.getName(),
                                  item.getKey().getIdentifier() );
          }

          // use the bean to remove duplicate items from the searchResultItems Array by looking at the
          // categoryItems array
          searchResultItems = categoryItemManagementBean.removeDuplicates(searchResultItems, categoryItems);
     } catch(Exception e) {
          statusMsg = "Unable to perform keyword Search.";
     }
     %>
</wl:process>

<wl:process name="querySearch">
     <%
     try
     {
          ViewIterator searchResultsIterator = categoryItemManagementBean.querySearch(categoryTreeManager,
                                                   (String)request.getParameter("querySearch"));

          // add all the items to the string array
          searchResultItems = new String[ searchResultsIterator.size() ];

          int i=0;
          while(searchResultsIterator.hasNext()) {
              ProductItem item = (ProductItem)searchResultsIterator.next();
              searchResultItems[i++] = categoryItemManagementBean.getFormattedText(
                                  item.getName(),
                                  item.getKey().getIdentifier());
          }

          // use the bean to remove duplicate items from the searchResultItems Array by looking at the
          // categoryItems array
          searchResultItems = categoryItemManagementBean.removeDuplicates(searchResultItems, categoryItems);
     } catch(Exception e) {
          e.printStackTrace();
          statusMsg = "Unable to perform expression based search";
     }
     %>
</wl:process>


<html>
<head>
<title>Modify Items Assigned to Category</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">


<SCRIPT LANGUAGE="JavaScript">

function submitSearchForm(formtype) {
   if(formtype == 'keyword') {
       this.document.KeywordForm.submit();
   } else {
       this.document.QueryForm.submit();
   }
   return true;
}

function submitSaveForm() {
   // before we submit the form, we select all entries in the category_items
   // list box except the last one
   selectAllEntries(document.SaveForm.category_items);
   this.document.SaveForm.submit();
   return true;
}


// functions to move items around between the text boxes
// The items move from the first parameter select box to the
// second parameter select box
function moveUsers(leftListBox, rightListBox)
{

    // delete all the items that are selected
    var leftLength=leftListBox.length;

    // items which are to be removed from the left list box are stored in this array
    var removedUsersArray = new Array();

    // copy all the options which are to be deleted in a new option list.
    // we also store them as a string variable
    var j=0;
    for(var i=0; i<leftLength; i++) {
       if(leftListBox.options[i].selected == true && leftListBox.options[i].value != "spacer") {
           var username = leftListBox.options[i].text;
           removedUsersArray[j++]= username;
       }
    }

    if ( removedUsersArray.length == 0 )
    {
      alert( "You must select at least one user to move." );
      return;
    }

    // call a function to remove the usernames from the list
    removeUserNames(leftListBox, removedUsersArray);

    // add the items to the rightListBox if they do not exists already in it.
    addUserNames(rightListBox, removedUsersArray);
}


// function which selects all items in the list box
// except the last one, which is a spacer
function selectAllEntries(listObject)
{
  for(var i=0; i<listObject.length-1; i++)
  {
      listObject.options[i].selected = true;
  }

  // deselect the last entry
  listObject.options[listObject.length-1].selected = false;
}

// function to add usernames to the list box
function addUserNames(listObject, addUsersArray)
{
   // get the spacer which is the last entry in the list object
   var spacerOptionText = listObject.options[ listObject.options.length - 1 ].text;

   for(var i=0; i < addUsersArray.length; i++) {
       var username = addUsersArray[i];

	// add the user in place of the spacer
        listObject.options[ listObject.options.length - 1 ] = new Option(username,username,false,false);

	// add the spacer at the end
	listObject.options[ listObject.options.length ] = new Option(spacerOptionText, "spacer", false, false);
   }

   // deselect the newly added users
   for(var i=0; i<listObject.length; i++)
   {
      listObject.options[i].selected = false;
   }

}

// function to remove users form a list
function removeUserNames(listObject, userNamesString)
{
   var i=0;

   while(i < listObject.length)
   {

	if(listObject.options[i] != null) {
           var username = listObject.options[i].text;
           for ( var j=0; j<userNamesString.length; j++ )
           {
              if ( username == userNamesString[j] )
              {
                 listObject.options[i] = null;
                 i=-1;
                 break; // break the for loop
              }
           }
        }
 	i++;
   }
}

//

</SCRIPT>

<!--
<style>
 select {
   font-family: Mono;
 }
</style>
-->
</head>


<body bgcolor="#FFFFFF" topmargin="0" leftmargin="0" marginwidth="0" marginheight="0">
<!-- Header  -->
<jsp:include page="<%=JspUtilPages.JSP_UTIL_HOME_HDR%>"/>

<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td width="5%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="88%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="4%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="65" height="8"></td>
    <td width="3%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
  </tr>
  <tr>
    <td width="5%" bgcolor="#008000">
      <div align="right"><img src="<wf:createResourceURL resource="/repository/images/cms.gif"/>" width="30" height="24"></div>
    </td>
    <td width="88%" bgcolor="#008000"><font face="Verdana, Arial, Helvetica, sans-serif" size="3" color="#FFFFFF"><b>Category:
      <%= categoryTreeManager.getDisplayName(identifier) %> </b></font></td>
    <td width="4%" bgcolor="#008000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="65" height="24" border="0"></td>
    <td width="3%" bgcolor="#FFFFFF"><img src="<wf:createResourceURL resource="/repository/images/curves_cms1_1.gif"/>" width="30" height="24"></td>
  </tr>
  <tr>
    <td width="5%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="88%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="4%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="65" height="8"></td>
    <td width="3%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
  </tr>
</table>
<% if (statusMsg != null) { %> <%@ include file="/tools/catalog/status.inc" %><% } %> 
<table border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td width="2%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="20" height="8"></td>
    <td rowspan="2" width="6%"> <font face="Verdana, Arial, Helvetica, sans-serif" size="2"><img src="<wf:createResourceURL resource="/repository/images/icon_addremove.gif"/>" width="65" height="50"></font></td>
    <td bgcolor="#CCCCCC" colspan="3"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b> 
      <img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8">Modify 
      Items Assigned to Category</b></font></td>
  </tr>
  <tr>
    <td width="2%">&nbsp;</td>
    <td>&nbsp;</td>
    <td>&nbsp;</td>
    <td>&nbsp;</td>
 </tr>
  <tr>
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td colspan="3"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"> 
      Search for the item you want to add or remove from this category. There 
      are two search modes - attribute and keyword. In addition you can query 
      for items that have not been assigned a category. Search results will be 
      displayed in the lefthand text box. <br>
      The righthand text box displays the items currently assigned to the category. 
      Add or remove items to the category using the central arrow keys. 
      Note that an item can be assigned to multiple categories. 
      <br>
      You must click the Save button to commit any changes to the category before performing a new search or leaving this page. 
    </font></td>
  </tr>
  <tr>
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td colspan="3">&nbsp;</td>
  </tr>
  <tr>
    <td width="2%"></td>
    <td width="6%"></td>
    <td width="25%"> 
      <div align="center">
        <center>
        <table border="0" width="100%">
        <form method="post" action="<wf:createWebflowURL event="link.category_add_remove_items"/>" name="KeywordForm">
          <tr>
            <td width="100%" colspan="3">
                 <font face="Verdana, Arial, Helvetica, sans-serif" size="2">
                     Search for items containing <br>the following keywords
                 </font>
            </td>
          </tr>
          <tr>
            <td width="27%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000">
                <b>Keyword:</b></font>
            </td>
            <td width="20%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000">
              <input type="text" name="keywordSearch" maxlength="50" value="<%= keywordString %>" size="20">
              </font></td>
            <td>
             <a href="javascript:submitSearchForm();" onClick="submitSearchForm('keyword'); return false;">
              <img src="<wf:createResourceURL resource="/repository/images/search_cms1.gif"/>" width="65" border="0" height="40" alt="Perform Keyword Search"></a>
            </td>
          </tr>
        <input type="hidden" name="<%=DESTINATION_TAG%>" value="<%=getRequestURI(request)%>">
        <input type="hidden" name="<%=HttpRequestConstants.CATALOG_CATEGORY_ID%>" value="<%= identifier %>">
        </form>
        </table>
        </center>
      </div>
    </td>    
    <td width="25%"> 
      <div align="center">
        <center>
        <table border="0" width="100%">
        <form method="post" action="<wf:createWebflowURL event="link.category_add_remove_items"/>" name="QueryForm">
          <tr>
            <td width="100%" colspan="3">
                 <font face="Verdana, Arial, Helvetica, sans-serif" size="2">
                     Search for items matching <br>the following query
                 </font>
            </td>
          </tr>
          <tr>
            <td width="27%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000">
              <b>Query:</b></font>
            </td>
            <td width="20%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000">
              <input type="text" name="querySearch" maxlength="250" value="<%= queryString %>" size="20">
              </font></td>
            <td>
             <a href="javascript:submitSearchForm();" onClick="submitSearchForm('query'); return false;">
              <img src="<wf:createResourceURL resource="/repository/images/search_cms1.gif"/>" width="65" border="0" height="40" alt="Perform Attribute Search"></a>
            </td>
          </tr>
        <input type="hidden" name="<%=DESTINATION_TAG%>" value="<%=getRequestURI(request)%>">
        <input type="hidden" name="<%=HttpRequestConstants.CATALOG_CATEGORY_ID%>" value="<%= identifier %>">
        </form>
        </table>
        </center>
      </div>
    </td>
    
    <!-- Table to display search for uncategoriezed items -->
    
    <td width="20%"> 
<% params = HttpRequestConstants.CATALOG_CATEGORY_ID + "=" + identifier + "&orphanedItemSearch=true"; %> 
      <table border="0" width="100%">
        <tr>       
          <td>
            <font face="Verdana, Arial, Helvetica, sans-serif" size="2">Search for items which are
            <br> not assigned to any category</font>
          </td>
        </tr>
        <tr>
          <td align="right">
            <a href="<wf:createWebflowURL event="link.category_add_remove_items" extraParams="<%=params%>"/>">
            <img src="<wf:createResourceURL resource="/repository/images/search_cms1.gif"/>" width="65" border="0" height="40" alt="Uncategorized Items"></a>
          </td>
        </tr>

      </table>
    </td>
  </tr>
  <tr>
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td colspan="3">&nbsp;</td>
  </tr>
  <tr>
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td colspan="3" align="left"> 
      <form method="post" action="<wf:createWebflowURL event="link.category_add_remove_items"/>" name="SaveForm">
        <table border="0" cellspacing="4" cellpadding="0" width="4%">
          <tr>
            <td width="43%" align="left">
              <font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b>Search
                Results: </b></font>
            </td>
            <td width="10%">&nbsp;</td>
            <td width="43%" align="left" nowrap><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000">
             <b>Items Assigned to Category: </b></font></td>
          </tr>
          <tr>
            <td width="43%">
              <div align="left">
                <select name="search_items" multiple size="10">
		            <!-- all the items go here -->
                 <es:notNull item="<%= searchResultItems %>" >
                  <%
                        for(int i=0; i < searchResultItems.length; i++) {
                            out.print("<option>");
                            out.print(searchResultItems[i]);
                            out.print("</option>");
                        }
                   %>
                 
                   </es:notNull>
                  <option value="spacer">-----------------------------------------------------------------------------</option>
                </select>
              </div>
            </td>
            <td width="10%">
              <table width="100%" border="0" cellspacing="4" cellpadding="1">
                <tr>
                  <td>
                    <div align="center"><A HREF="javascript:moveUsers(document.SaveForm.search_items, document.SaveForm.category_items);" onClick="moveUsers(document.SaveForm.search_items, document.SaveForm.category_items); return false;"><img src="<wf:createResourceURL resource="/repository/images/arrow_right.gif"/>" border=0 width="24" height="24" alt="Add Item"></A></div>
                  </td>
                </tr>
                <tr>
                  <td>
                    <div align="center"><A HREF="javascript:moveUsers(document.SaveForm.category_items,document.SaveForm.search_items);" onClick="moveUsers(document.SaveForm.category_items,document.SaveForm.search_items); return false;"><img src="<wf:createResourceURL resource="/repository/images/arrow_left.gif"/>" border=0 width="24" height="24" alt="Remove Item"></a></div>
                  </td>
                </tr>
              </table>
            </td>
            <td width="43%" align="left">
              <select name="category_items" multiple size="10">
                  <es:notNull item="<%= categoryItems%>" >
                  <%
                        for(int i=0; i<categoryItems.length; i++) {
                            out.print("<option>");
                            out.print(categoryItems[i]);
                            out.print("</option>");
                        }
                   %>
                   </es:notNull>
                  <option value="spacer">-----------------------------------------------------------------------------</option>
              </select>
            </td>
          </tr>
        </table>
    </td>
  </tr>
  <tr>
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td colspan="3">&nbsp;</td>
  </tr>

  <!-- ------------------------------------------------------------ -->
  <!-- Table for Back and Save buttons                              -->
  <!-- ------------------------------------------------------------ -->

  <tr>
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td colspan="2">&nbsp;</td>	
    <td > 
      <table border="0" cellspacing="0" cellpadding="0">
        <tr> 
          <td> <% params = HttpRequestConstants.CATALOG_CATEGORY_ID + "=" + java.net.URLEncoder.encode(identifier); %> 
            <a href="<wf:createWebflowURL event="link.category_edit" extraParams="<%=params%>"/>"><img src="<wf:createResourceURL resource="/repository/images/back_cms1.gif"/>" width="65" height="40" alt="Return to the Previous Page" border="0"></a> 
            <a href="javascript:submitSaveForm();" onClick="submitSaveForm(); return false;"> 
            <img src="<wf:createResourceURL resource="/repository/images/save_cms1.gif"/>" width="65" border=0 height="40" alt="Save Changes"></a> 
          </td>
        </tr>
      </table>
    </td>
  </tr>
  <input type="hidden" name="<%=DESTINATION_TAG%>" value="<%=getRequestURI(request)%>">
  <input type="hidden" name="formSubmit" value="save">
  <input type="hidden" name="<%=HttpRequestConstants.CATALOG_CATEGORY_ID%>" value="<%= identifier %>">
  </form>

</table>

</body>

</html>



