<%@ taglib uri="weblogic.tld" prefix="wl" %>
<%@ taglib uri="webflow.tld" prefix="wf" %>

<%@ page extends="com.bea.jsptools.common.servlets.jsp.ToolsJspBase"%>
<%@ page import="
      com.beasys.commerce.webflow.HttpRequestConstants,
      com.bea.jsptools.p13n.common.servlets.jsp.JspUtilPages,
      com.beasys.commerce.ebusiness.catalog.*,
      com.beasys.commerce.ebusiness.catalog.jsp.*,
      com.beasys.commerce.ebusiness.catalog.service.item.ProductItemManager
"%>
<% request.setAttribute(SERVICEMANAGER_CURRENT_PAGE, getJspName(pageContext));%>

<%
    String statusMsg = null;
    ProductItem tempItem = null;
    CatalogManager catalogManager = CatalogJspHelper.getCatalogManager();
    CatalogRequest adminCatalogRequest = catalogManager.createAdminCatalogRequest();
    ProductItemManager productItemManager = catalogManager.getProductItemManager(adminCatalogRequest);
	   
    //Get the sku out of request
    String sku = (String)request.getParameter(HttpRequestConstants.CATALOG_ITEM_SKU );

    if (sku == null || sku.length() == 0) {
      statusMsg = "Item does not exist. Please create an item first.";
    }

    //Create the item   
    ProductItemKey key = new ProductItemKey(sku);
    
    tempItem = productItemManager.getItem(adminCatalogRequest,  key);
    MutableProductItem item = CatalogFactory.createMutableProductItem( tempItem, false );
    InventoryInfo inventory = item.getAvailability();
     
%>



<wl:process name="save" value="true">
  <%
    try {
     //Get all the parameters out of the request
     String shippingTime = request.getParameter(HttpRequestConstants.SHIPPING_TIME);
     String shippingComments = request.getParameter(HttpRequestConstants.SHIPPING_COMMENTS);
     String inStock = request.getParameter(HttpRequestConstants.IN_STOCK);
    
     //Convert String parameter to Boolean
     Boolean inStockBoolean = new Boolean(inStock);
    
     //Set parameters to their value
     inventory.setShippingTime(shippingTime);
     inventory.setSpecialNotices(shippingComments);
     inventory.setInStock(inStockBoolean.booleanValue());
     item.setAvailability( inventory );
    
     //Save item's values to the database
     productItemManager.updateItem( adminCatalogRequest, item );
     statusMsg = "Item Inventory updated successfully.";
   } catch (Exception e) {
     statusMsg = e.getLocalizedMessage();
   }
  %>
</wl:process>



<html>
<head>
<title>Item Inventory</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">

<script language="JavaScript">
<!--
function submitForm(formName, field)
{
	document.forms[formName][field].value="true";
	document.forms[formName].submit();
}
// -->
</script>

</head>
<body bgcolor="#FFFFFF" topmargin="0" leftmargin="0" marginwidth="0" marginheight="0">

<!-- Header  -->
<jsp:include page="<%=JspUtilPages.JSP_UTIL_HOME_HDR%>"/>

<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr> 
    <td width="3%" bgcolor="#000000"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></b></font></td>
    <td width="88%" bgcolor="#000000"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></b></font></td>
    <td width="6%" bgcolor="#000000"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/stopclear.gif"/>" width="65" height="8"></b></font></td>
    <td width="3%" bgcolor="#000000"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></b></font></td>
  </tr>
  <tr> 
    <td width="3%" bgcolor="#008000"><img src="<wf:createResourceURL resource="/repository/images/cms.gif"/>" width="30" height="24"></td>
    <td width="88%" bgcolor="#008000"><font face="Verdana, Arial, Helvetica, sans-serif" size="3" color="#000000"><b><font color="#FFFFFF">Items</font></b></font></td>
    <td width="6%" bgcolor="#008000"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/smiddleclear.gif"/>" width="65" height="24"></b></font></td>
    <td width="3%" bgcolor="#FFFFFF"><img src="<wf:createResourceURL resource="/repository/images/curves_cms1_1.gif"/>" width="30" height="25"></td>
  </tr>
  <tr> 
    <td width="3%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></b></font></td>
    <td width="88%"><% if (statusMsg != null) { %><%@ include file="/tools/catalog/status.inc" %><% } %></td>
    <td width="6%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/sbottomclear.gif"/>" width="65" height="8"></b></font></td>
    <td width="3%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></b></font></td>
  </tr>
</table>

<TABLE border=0 cellPadding=0 cellSpacing=0 width="100%">
  <TBODY>
  <TR>
    <TD width="2%">&nbsp;</TD>
    <TD width="6%">&nbsp;</TD>
    <TD width="76%">&nbsp;</TD>
    <TD width="16%">&nbsp;</TD></TR>
  <TR>
    <TD width="2%"><IMG height=8 src="<wf:createResourceURL resource="/repository/images/clear.gif"/>"
      width=20></TD>
    <TD rowSpan=2 width="6%"><IMG height=50 src="<wf:createResourceURL resource="/repository/images/icon_create.gif"/>" width=65></TD>
    <TD bgColor=#cccccc width="76%"><FONT color=#000000 
      face="Verdana, Arial, Helvetica, sans-serif" size=2><B><IMG height=8 
      src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width=5>Item Inventory</B></FONT></TD>
    <TD bgColor=#cccccc width="16%">&nbsp;</TD></TR>
  <TR>
    <TD width="2%">&nbsp;</TD>
    <TD width="76%"><FONT face="Verdana, Arial, Helvetica, sans-serif" 
      size=2>Enter the appropriate information then click Save.</FONT></TD>
    <TD width="16%">&nbsp;</TD></TR>
  </TABLE>


<form method="post" name="itemInventoryForm" action="<wf:createWebflowURL event="link.item_inventory"/>">

  <input type="hidden" name="<%=DESTINATION_TAG%>" value="<%=getRequestURI(request)%>">
  <input type="hidden" name="save"> 
  <input type="hidden" name="<%= HttpRequestConstants.CATALOG_ITEM_SKU %>" value = "<%= sku %>" >
  

  <table ALIGN="center" width="797" border="0" cellspacing="2" cellpadding="0">
    <tr>
      <td width="178" valign="middle">
        <div align="left"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b>Item Name: </b></font></div></td>
      <td width="375" valign="middle"> <font face="Verdana, Arial, Helvetica, sans-serif" size=2><%= item.getName() %></td>
    </tr>
    <tr>
      <td width="178" valign="middle">
        <div align="left"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b>In Stock: </b></font></div></td>
      <td width="365" valign="middle"><INPUT type="radio" name="<%=HttpRequestConstants.IN_STOCK%>" value="true" <%= inventory.getInStock() == true ? "CHECKED" : "" %> > Yes 
                                      <INPUT type="radio" name="<%=HttpRequestConstants.IN_STOCK%>" value="false" <%= inventory.getInStock() == false ? "CHECKED" : "" %> > No </td>
    </tr>
    <tr>
      <td width="178" valign="middle" align="left">
            <font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b>Shipping Time: </b></font></td>
      <td width="365" valign="middle">
          <textarea name="<%= HttpRequestConstants.SHIPPING_TIME %>" COLS="40" ROWS="4" WRAP="SOFT" ><%=inventory.getShippingTime() %></textarea></td>
    </tr>
    <tr>
      <td width="178" valign="middle" align="left">
            <font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b>Comments: </b></font></td>
      <td width="365" valign="middle">
          <textarea name="<%= HttpRequestConstants.SHIPPING_COMMENTS %>" COLS="40" ROWS="4" WRAP="SOFT" ><%=inventory.getSpecialNotices() %></textarea></td>
    </tr>
  </table>
<% String itemParams = HttpRequestConstants.CATALOG_ITEM_SKU + "=" + sku; %>
  <table ALIGN="center" width="797" >
    <tr>
      <td align="right"><a href="<wf:createWebflowURL event="link.item_edit" extraParams="<%=itemParams%>"/>"><img src="<wf:createResourceURL resource="/repository/images/back_cms1.gif"/>" width="65" height="40" alt="Return to Previous Page" border="0"></a>
         <a href="" onClick="submitForm('itemInventoryForm', 'save'); return false;"><img src="<wf:createResourceURL resource="/repository/images/save_cms1.gif"/>" width="65" height="40"  border="0" alt="Save Inventory Changes"></a>
      </td>
    </tr>
  </table> 
  
  
</form>

</html>
