<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<%@ page extends="com.bea.jsptools.common.servlets.jsp.ToolsJspBase"%>

<%@ taglib uri="weblogic.tld" prefix="wl" %>
<%@ taglib uri="webflow.tld" prefix="wf" %>
<%@ taglib uri="cat.tld" prefix="catalog" %>

<%@ page import="com.bea.jsptools.p13n.common.servlets.jsp.JspUtilPages" %>
<%@ page import="com.beasys.commerce.ebusiness.catalog.*" %>
<%@ page import="com.beasys.commerce.ebusiness.catalog.jsp.*" %>
<%@ page import="com.beasys.commerce.ebusiness.catalog.service.category.*" %>
<%@ page import="com.beasys.commerce.ebusiness.catalog.service.query.*" %>
<%@ page import="com.beasys.commerce.webflow.HttpRequestConstants" %>

<jsp:useBean id="categoryItemManagementBean" class="com.beasys.commerce.ebusiness.catalog.jsp.beans.CategoryItemManagementBean" scope="session" />

<% request.setAttribute(SERVICEMANAGER_CURRENT_PAGE, getJspName(pageContext));%>

<%
	CatalogManager catalogManager = CatalogJspHelper.getCatalogManager();
	CatalogRequest adminCatalogRequest = catalogManager.createAdminCatalogRequest();

	ProductItemJspHelper jspHelper = new ProductItemJspHelper( adminCatalogRequest );

	CatalogQueryManager queryManager = jspHelper.getCatalogQueryManager();
	String statusMsg = null;
	String keywordString=request.getParameter( "keywordSearch");
	String queryString=request.getParameter( "querySearch" );
	String orphanString=request.getParameter( "orphans" );
	String deleteString=request.getParameter( "del" );
	
	String commonParams = null;
	if (keywordString != null)
	     commonParams = "keywordSearch=" + java.net.URLEncoder.encode(keywordString);
	     
	else if (queryString != null)
	     commonParams = "querySearch=" + java.net.URLEncoder.encode(queryString);

    else if (orphanString != null)
          commonParams = "orphans=true";
  
	ViewIterator currentIterator = null; 
	final int viewSize = 10;
	int viewIndex;
	String message = "Are you sure you want to delete this Item?";
	
	//Prepare HTML tag for "delete image"
	StringBuffer xImg = new StringBuffer();

  xImg.append("<img src=\"");
  xImg.append("repository/images/x.gif");
  xImg.append("\" width=\"15\" height=\"15\" align=\"absmiddle\">");
%>

<!-- get all the items matching the search criteria  -->
<wl:process name="del" value="true">
     <%
     try
     {
        jspHelper.removeItem(request);
     }
     catch(Exception e)
     {
		    statusMsg = "Unable to delete an item. " + e.getLocalizedMessage();
		    e.printStackTrace();
		 }
     %>
</wl:process>

<wl:process name="keywordSearch">
     <%
     try
     {
        if ( keywordString == null || keywordString.equals("")){
          statusMsg = "Please enter a keyword";
        }
        
        else {
          currentIterator = jspHelper.keywordSearch( keywordString, viewSize );
        
          if (currentIterator.size() == 0){
            statusMsg = "No items with keyword '" + keywordString + "'";
          }
        }          
     }
     catch(Exception e)
     {
		    statusMsg = "No items with keyword '" + keywordString + "'";
		    e.printStackTrace();
     }
     %>
</wl:process>


<wl:process name="orphans" value="true">
     <%
     try
     {
         currentIterator = jspHelper.getCategoryManager().getOrphanedItems( jspHelper.getCatalogRequest(), viewSize );
          if (currentIterator.size() == 0){
            statusMsg = "Did not find any uncategorized items";
          }
         
     }
     catch(Exception e)
     {
		    statusMsg = "Unable to retrieve Orphaned Items.";
		    e.printStackTrace();
     }
     %>
</wl:process>

<wl:process name="querySearch">
     <%
     try
     {
        if (queryString == null || queryString.equals("")){
          statusMsg = "Please enter an expression.";
        }
        
        else{
          
         currentIterator = jspHelper.attributeSearch( queryString, viewSize );
         if(!currentIterator.hasNext()) statusMsg = " There are no items matching expression ' " + queryString + " '.";         
        }
        
     }
     catch(Exception e)
     {
         statusMsg = "Check semantic correctness of expression ' " + queryString + " '."
         + " Use single quotes to search for a string.";
         
     }
     %>
</wl:process>




<html>
<head>
<title>Item Search</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">

<script language="JavaScript">
<!--
function submitForm(formName, field)
{
  if (field == "orphans") {
    document.forms[formName][field].value="true";  
  }
  document.forms[formName].submit();
}

<!-- Assignes value to a hidden control; displays a confirm message  -->
function deleteItem(message)
{
   return confirm(message);
}

// -->
</script>

<!--
<style>
 select {
   font-family: Mono;
 }
</style>
-->
</head>


<body bgcolor="#FFFFFF" topmargin="0" leftmargin="0" marginwidth="0" marginheight="0">
<!-- Header  -->
<jsp:include page="<%=JspUtilPages.JSP_UTIL_HOME_HDR%>"/>

<!-- ------------------------------------------------------------ -->
<!-- Table for Item Search Header  -->
<!-- ------------------------------------------------------------ -->

<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td width="5%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="88%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="4%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="65" height="8"></td>
    <td width="3%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
  </tr>
  <tr>
    <td width="5%" bgcolor="#008000">
      <div align="right"><img src="<wf:createResourceURL resource="/repository/images/cms.gif"/>" width="30" height="24"></div>
    </td>
    <td width="88%" bgcolor="#008000"><font face="Verdana, Arial, Helvetica, sans-serif" size="3" color="#FFFFFF"><b>Items</b></font></td>
    <td width="4%" bgcolor="#008000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="65" height="24" border="0"></td>
    <td width="3%" bgcolor="#FFFFFF"><img src="<wf:createResourceURL resource="/repository/images/curves_cms1_1.gif"/>" width="30" height="24"></td>
  </tr>
  <tr>
    <td width="5%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="88%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="4%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="65" height="8"></td>
    <td width="3%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
  </tr>
</table>

<% if (statusMsg != null) { %> <%@ include file="/tools/catalog/status.inc" %><% } %>

<!-- ------------------------------------------------------------ -->
<!-- Table for Item Search Header  -->
<!-- ------------------------------------------------------------ -->
<table border="0" cellspacing="0" cellpadding="0" width="100%">
  <tr>
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td width="36%" colspan="2">&nbsp;</td>
    <td width="56%" colspan="2">&nbsp;</td>
  </tr>
  <tr>
    <td width="2%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="20" height="8"></td>
    <td rowspan="2" width="6%"> <font face="Verdana, Arial, Helvetica, sans-serif" size="2"><img src="<wf:createResourceURL resource="/repository/images/icon_addremove.gif"/>" width="65" height="50"></font></td>
    <td bgcolor="#CCCCCC" width="66%" colspan="2"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8">Item Search</b></font></td>
    <td width="26%" bgcolor="#CCCCCC" colspan="2">&nbsp;</td>
  </tr>
  <tr>
    <td width="2%">&nbsp;</td>
    <td width="66%" colspan="2">&nbsp;</td>
    <td width="26%" colspan="2">&nbsp;</td>
  </tr>
  <tr>
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td width="76%" colspan=4><font face="Verdana, Arial, Helvetica, sans-serif" size="2">Search for the items you would like to edit. There are two search modes - attribute based search and keyword based search. 
      In addition you can query for items that have not been assigned a category. Search results will be displayed below. 
      Click the item's name to edit it, or click <img src="<wf:createResourceURL resource="/repository/images/x.gif"/>" width="15" height="15" align="absmiddle"> 
      to delete the item.</font><DIV><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><B>Warning:</B> deleting an item is a permanent operation and cannot be undone.</font>
     </div></td>
  </tr>
  <tr>
    <td width="2%" height="23">&nbsp;</td>
    <td width="6%" height="23">&nbsp;</td>
    <td width="66%" colspan="2" height="23">&nbsp;</td>
    <td width="26%" colspan="2" height="23">&nbsp;</td>
  </tr>
</table>


<!-- ------------------------------------------------------------ -->
<!-- Table for Keyword Search, Query and Uncategories Items  -->
<!-- ------------------------------------------------------------ -->
<table>
  <tr> 
    <td width="2%"></td>
    <td width="6%"></td>
  
    <td width="30%"> 
      <table border="0" width="100%">
        <form method="post" action="<wf:createWebflowURL event="link.item_search"/>" name="KeywordForm">
          <input type="hidden" name="<%=DESTINATION_TAG%>" value="<%=getRequestURI(request)%>">
          <input type="hidden" name="keyword">
          <tr>
            <td width="100%" colspan="3"><font face="Verdana, Arial, Helvetica, sans-serif" size="2">Search for items containing <br>the following keywords</font></td>
          </tr>
          <tr>
            <td width="21%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><nobr>Keyword:</nobr></b></font></td>
            <td width="52%"><input type="text" name="keywordSearch" maxlength="50" value="<%= keywordString %>" size="20"></td>
            <td width="27%"><a href="" onClick="submitForm('KeywordForm', 'keyword'); return false;">
                <img src="<wf:createResourceURL resource="/repository/images/search_cms1.gif"/>" width="65" border="0" height="40" alt="Perform Keyword Search"></a>
            </td>
          </tr>
        </form>
      </table>
    </td>
    
    
   
    <td width="30%"> 
      <table border="0" width="100%">
        <form method="post" action="<wf:createWebflowURL event="link.item_search"/>" name="QueryForm">
          <input type="hidden" name="<%=DESTINATION_TAG%>" value="<%=getRequestURI(request)%>">
          <input type="hidden" name="query">
          <tr>
            <td width="100%" colspan="3"><font face="Verdana, Arial, Helvetica, sans-serif" size="2">Search for items matching <br> the following query</font></td>
          </tr>
          <tr>
            <td width="20%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><nobr>Query:</nobr></b></font>
            </td>
            <td width="60%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000">
              <input type="text" name="querySearch" maxlength="250" value="<%= queryString %>" size="30">
              </font></td>
            <td width="20%">
             <a href="" onClick="submitForm('QueryForm', 'query'); return false;">
              <img src="<wf:createResourceURL resource="/repository/images/search_cms1.gif"/>" width="65" border="0" height="40" alt="Perform Attribute Search"></a>
            </td>
          </tr>
        </form>
      </table>     
    </td>
   
    
    <td width="22%"> 
      <table border="0" width="100%">
	      <form method="post" action="<wf:createWebflowURL event="link.item_search"/>" name="OrphanForm">
          <input type="hidden" name="<%=DESTINATION_TAG%>" value="<%=getRequestURI(request)%>">
          <input type="hidden" name="orphans">

 	        <tr>
            <td width="100%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2">Search for items which are <br>not assigned to any category</font></td>
          </tr>        
  	      <tr>
	          <td align="right">
              <a href="" onClick="submitForm('OrphanForm', 'orphans'); return false;">
              <img src="<wf:createResourceURL resource="/repository/images/search_cms1.gif"/>" width="65" border="0" height="40" alt="Uncategorized Items"></a></td>
	        </tr>
        
        </form>
	    </table>
	   </td>
  </tr>
</table>


<!-- ------------------------------------------------------------ -->
<!-- Table for Search Result  -->
<!-- ------------------------------------------------------------ -->

<table border="0" width="100%">
  
  <tr>
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    	 	  
      <form method="post" action="<wf:createWebflowURL event="link.item_search"/>" name="SearchResultsForm">
        <input type="hidden" name="<%=DESTINATION_TAG%>" value="<%=getRequestURI(request)%>">

        <% if (currentIterator != null) { %>			         
			         
			   
	      <%-- Goto the correct view within the ViewIterator --%>
	      <% 
	        String viewIndexString = (String)request.getParameter(HttpRequestConstants.CATALOG_VIEW_INDEX); 
	        
	        if (viewIndexString == null){
		            viewIndexString = "0"; 
		      }
	 
	        viewIndex = Integer.valueOf(viewIndexString).intValue(); 
	          
	        currentIterator.gotoViewAt(viewIndex);

	        View currentView = currentIterator.getCurrentView();
	      %>
	      
        <td width="92%" colspan="2" bgcolor="#CCCCCC"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b>
                <img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8">Search Results</b>&nbsp</font>
	      
	      <!-- ------------------------------------------------------------ -->
        <!-- Display page tabs  -->
        
				 	  <% if (currentIterator.hasPreviousView()) {
				 	    
				 	      statusMsg = viewIndexString;
				 	      String params = HttpRequestConstants.CATALOG_VIEW_INDEX + "=" + (viewIndex-1);
				 	                      
				 	      if (commonParams != null)
				 	        params = params + "&" + commonParams;				 	      
				 	    %>

				 	    <a href="<wf:createWebflowURL event="link.item_search" extraParams="<%=params%>"/>">Previous</a>&nbsp; &nbsp 
				 	  <%  } 
				 	  
				 	      if (currentIterator.size() > 0) {
				 	        String paging = currentView.getFirstIndex() + "-" + currentView.getLastIndex();
				 	      
				 	        String params = HttpRequestConstants.CATALOG_VIEW_INDEX + "=" + viewIndex;
				 	      
				 	        if (commonParams != null)
                                                {
				 	          params = params + "&" + commonParams;				 	      
                                                }
              %>
            
				 	    <a href="<wf:createWebflowURL event="link.item_search" extraParams="<%=params%>"/>"><%= paging %></a>&nbsp; &nbsp
					  
					  <% } 
					  
					      if (currentIterator.hasNextView()) {
				 	    
				 	        String params = HttpRequestConstants.CATALOG_VIEW_INDEX + "=" + (viewIndex+1);
				 	      
				 	        if (commonParams != null)
				 	          params = params + "&" + commonParams;				 	      
				 	    %>
				 	  
				 	    <a href="<wf:createWebflowURL event="link.item_search" extraParams="<%=params%>"/>">Next</a>
				 	  <% } %> 	  
				 </td>
				</form></tr>
				<tr> 
				
          <td width="2%">&nbsp;</td>
          <td width="6%">&nbsp;</td>
          <td width="92%" colspan="2">
          
          <!-- ------------------------------------------------------------ -->
          <!-- Display items for each view  -->
                   
              <ol start="<%= currentView.getFirstIndex() %>" type="1">      
	            <%-- Iterate through all items in the current view and display their names --%>
	            <catalog:iterateThroughView iterator="<%= currentIterator %>" id="item" returnType="com.beasys.commerce.ebusiness.catalog.ProductItem" viewIndex="<%= viewIndex %>">	      	
				 	    
                    <% 
                      String params = HttpRequestConstants.CATALOG_ITEM_SKU + "=" + item.getKey().getIdentifier(); 	

                      if (commonParams != null)
                        params = params + "&" + commonParams;				 	      

                      String deleteParams = params + "&" + "del" + "=" + "true";

                    %>
                          <li><a href="<wf:createWebflowURL event="link.item_property_edit" extraParams="<%=params%>"/>"><%= item.getName()%></a>
                                <a href="<wf:createWebflowURL event="link.item_search" extraParams="<%=deleteParams%>"/>" 
                                        onClick="return deleteItem( ' <%= message %> ' )" >
                                        <img src="<wf:createResourceURL resource="/repository/images/x.gif"/>"  width="15" height="15" border="0" alt="Delete an Item"></a>
                    </catalog:iterateThroughView>
              </ol>
	    </td>
       <% } %>
			  
	</tr>	  
  <tr>
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td width="92%" colspan="2">&nbsp;</td>
  </tr>
  <tr>
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td align="right">
      <a href="<wf:createWebflowURL event="link.catalog_home"/>">
          <img src="<wf:createResourceURL resource="/repository/images/back_cms1.gif"/>" width="65" height="40" alt="Return to the Previous Page" border="0"></a>
    </td>
    <td width="24%">&nbsp;</td>
  </tr>
 </table>
  
 </body>
</html>



