<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<!-- ------------------------------------------------------------ -->
<!-- IMPORTS                                                      -->
<!-- ------------------------------------------------------------ -->
<%@ page extends="com.bea.jsptools.common.servlets.jsp.ToolsJspBase"%>
<%@ taglib uri="weblogic.tld" prefix="wl" %>
<%@ taglib uri="webflow.tld" prefix="wf" %>
<%@ taglib uri="es.tld" prefix="es" %>
<%@ page import="com.bea.jsptools.p13n.common.servlets.jsp.JspUtilPages" %>
<%@ page import="java.util.*" %>
<%@ page import="java.text.*" %>
<%@ page import="javax.ejb.*" %>
<%@ page import="java.rmi.*" %>
<%@ page import="com.beasys.commerce.ebusiness.payment.*" %>
<%@ page import="com.beasys.commerce.ebusiness.customer.*" %>
<%@ page import="com.beasys.commerce.ebusiness.catalog.util.*" %>
<%@ page import="com.beasys.commerce.ebusiness.order.jsp.*" %>
<%@ page import="com.beasys.commerce.ebusiness.order.*;" %>
<%@ page import="com.beasys.commerce.axiom.util.helper.*;" %>
<%@ page import="com.beasys.commerce.webflow.HttpRequestConstants" %>
<%@ page import="com.bea.jsptools.p13n.usermgmt.servlets.jsp.UserManagementJspPages" %>
<%@ page import="com.beasys.commerce.util.*" %>
<%@ page import="com.beasys.commerce.foundation.exception.*" %>
<%@ page import="com.bea.p13n.appflow.webflow.*; " %>
<%@ page import="com.bea.p13n.util.*;" %>
<%@ page import="com.bea.p13n.management.ApplicationHelper;" %>

<% request.setAttribute(SERVICEMANAGER_CURRENT_PAGE, getJspName(pageContext));%>

<!-- ------------------------------------------------------------ -->
<!-- START THIS PAGE FUNCTIONAL CODE PRESENTATION                 -->
<!-- ------------------------------------------------------------ -->
<%
   String statusMsg = null;
   String paramName = null;
   String paramValue = null;

   OrderHome orderHome = null;
   Collection orderCollection = new LinkedList();

   // get the order home
   try {
       String jndiName = "java:comp/env/ejb/Order";
       orderHome = (OrderHome) JndiHelper.lookupNarrow(jndiName, OrderHome.class);
   }  catch(Exception e)  {
       e.printStackTrace();
       statusMsg = "Unable to Load Database";
   }

%>

<wl:process name="<%= HttpRequestConstants.SEARCH_ORDER_CUSTOMER_ID %>" >
<%
   String customerIdentifier = request.getParameter(HttpRequestConstants.SEARCH_ORDER_CUSTOMER_ID);

   paramName = HttpRequestConstants.SEARCH_ORDER_CUSTOMER_ID;
   paramValue = customerIdentifier;

   if(customerIdentifier.length() == 0)
      statusMsg = "Please specify a valid customer id";
   else {

     try {
          // this will never be null as an empty vector is returned
          // for no matches
          Collection orders = orderHome.findByCustomer(customerIdentifier);
	  Iterator iterator = orders.iterator();
	  while(iterator.hasNext()) {
	     orderCollection.add( ((Order)(iterator.next())).getOrderByValue() );
	  }
	  statusMsg = "Obtained '" + orderCollection.size() + "' orders for customer " + customerIdentifier;
     } catch(FinderException fe) {
          statusMsg = MessageCatalog.getUserMessage("ebusiness-order", "order.findByCustomer.exception", new String[] {customerIdentifier});
     } catch(RemoteException re) {
          statusMsg = MessageCatalog.getUserMessage("ebusiness-order", "order.findByCustomer.exception", new String[] {customerIdentifier});
     }
   }
%>
</wl:process>

<wl:process name="<%= HttpRequestConstants.SEARCH_ORDER_ID %>" >
<%
   String orderIdentifier = request.getParameter( HttpRequestConstants.SEARCH_ORDER_ID);
   paramName =  HttpRequestConstants.SEARCH_ORDER_ID;
   paramValue = orderIdentifier;

   if(orderIdentifier.length() == 0)
      statusMsg = "Please specify a valid order id";
   else {

     try {
          // this will never be null as an empty vector is returned
          // for no matches
          Order order = orderHome.findByPrimaryKey(new OrderPk(orderIdentifier));
	  orderCollection = new LinkedList();
	  orderCollection.add(order.getOrderByValue());
	  statusMsg = "Obtained '" + orderCollection.size() + "' orders for order  " + orderIdentifier;
     } catch(FinderException fe) {
          statusMsg = MessageCatalog.getUserMessage("ebusiness-order", "order.findByOrderId.exception", new String[] {orderIdentifier});
     } catch(RemoteException re) {
          statusMsg = MessageCatalog.getUserMessage("ebusiness-order", "order.findByOrderId.exception", new String[] {orderIdentifier});
     }
   }
%>
</wl:process>

<wl:process name="searchDay" >
<%
   paramName = "searchDay";
   paramValue = request.getParameter( HttpRequestConstants.SEARCH_FROM_DAY ) + "$" +  request.getParameter( HttpRequestConstants.SEARCH_TO_DAY );
   String DATE_FORMAT = CatalogResourceManager.getString( "catalog.jsp.date.format" );
   String fromDate = request.getParameter( HttpRequestConstants.SEARCH_FROM_DAY );
   String toDate = request.getParameter( HttpRequestConstants.SEARCH_TO_DAY );

   if(fromDate.length() == 0 || toDate.length() == 0)
      statusMsg = "Please specify a valid start and end date";
   else {

     SimpleDateFormat formatter = new SimpleDateFormat( DATE_FORMAT );


     java.sql.Date date_toDate =   new java.sql.Date(formatter.parse(toDate, new ParsePosition(0)).getTime());
     java.sql.Date date_fromDate = new java.sql.Date(formatter.parse(fromDate, new ParsePosition(0)).getTime());

     try {
          Collection orders = orderHome.findByDate(date_fromDate, date_toDate);
	  Iterator iterator = orders.iterator();
	  while(iterator.hasNext()) {
	     orderCollection.add( ((Order)(iterator.next())).getOrderByValue() );
	  }
	  statusMsg = "Obtained '" + orderCollection.size() + "' orders between " + date_fromDate + " and " + date_toDate;
     } catch(FinderException fe) {
          statusMsg = MessageCatalog.getUserMessage("ebusiness-order", "order.findByDate.exception", new String[] {date_toDate.toString(), date_fromDate.toString()});
     } catch(RemoteException re) {
          statusMsg = MessageCatalog.getUserMessage("ebusiness-order", "order.findByDate.exception", new String[] {date_toDate.toString(), date_fromDate.toString()});
     }

   }

%>
</wl:process>

<html>
<head>
<title>Order Management</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<SCRIPT language="javascript">
<!--
function submitForm (formName)
{
	document.forms[formName].submit()
}
//-->
</script>
</head>
<body bgcolor="#FFFFFF" topmargin="0" leftmargin="0" marginwidth="0" marginheight="0">

<!-- ------------------------------------------------------------ -->
<!-- HEADER INCLUDE                                               -->
<!-- ------------------------------------------------------------ -->
<jsp:include page="<%=JspUtilPages.JSP_UTIL_HOME_HDR%>"/>

<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td width="3%" bgcolor="#000000"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></b></font></td>
    <td width="88%" bgcolor="#000000"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></b></font></td>
    <td width="6%" bgcolor="#000000"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/stopclear.gif"/>" width="65" height="8"></b></font></td>
    <td width="3%" bgcolor="#000000"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></b></font></td>
  </tr>
  <tr>
    <td width="3%" bgcolor="#777788"><img src="<wf:createResourceURL resource="/repository/images/om.gif"/>" width="30" height="24"></td>
    <td width="88%" bgcolor="#777788"><font face="Verdana, Arial, Helvetica, sans-serif" size="3" color="#000000"><b><font color="#FFFFFF">Order Management</font></b></font></td>
    <td width="6%" bgcolor="#777788"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/smiddleclear.gif"/>" width="65" height="24"></b></font></td>
    <td width="3%" bgcolor="#FFFFFF"><img src="<wf:createResourceURL resource="/repository/images/scurves_om_r1_c1.gif"/>" width="30" height="24"></td>
  </tr>
  <tr>
    <td width="3%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></b></font></td>
    <td width="88%"><% if(statusMsg != null) { %> <%@ include file="/tools/catalog/status.inc" %> <% } %> </td>
    <td width="6%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/sbottomclear.gif"/>" width="65" height="8"></b></font></td>
    <td width="3%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></b></font></td>
  </tr>
</table>

<!-- ------------------------------------------------------------ -->
<!-- Table for Order Search Header  -->
<!-- ------------------------------------------------------------ -->
<table border="0" cellspacing="0" cellpadding="0" width="100%">
  <tr>
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td width="36%" colspan="2">&nbsp;</td>
    <td width="56%" colspan="2">&nbsp;</td>
  </tr>
  <tr>
    <td width="2%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="20" height="8"></td>
    <td rowspan="2" width="6%"> <font face="Verdana, Arial, Helvetica, sans-serif" size="2"><img src="<wf:createResourceURL resource="/repository/images/icon_addremove.gif"/>" width="65" height="50"></font></td>
    <td bgcolor="#CCCCCC" width="66%" colspan="2"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8">Order Search</b></font></td>
    <td width="26%" bgcolor="#CCCCCC" colspan="2">&nbsp;</td>
  </tr>
  <tr>
    <td width="2%">&nbsp;</td>
    <td width="66%" colspan="2">&nbsp;</td>
    <td width="26%" colspan="2">&nbsp;</td>
  </tr>
  <tr>
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td width="76%" colspan=4><font face="Verdana, Arial, Helvetica, sans-serif" size="2">Use this page
      to search for Orders. Click on order id to edit it.</font>
     </td>
  </tr>
  <tr>
    <td width="2%" height="23">&nbsp;</td>
    <td width="6%" height="23">&nbsp;</td>
    <td width="66%" colspan="2" height="23">&nbsp;</td>
    <td width="26%" colspan="2" height="23">&nbsp;</td>
  </tr>
</table>

<!-- ------------------------------------------------------------ -->
<!-- Table for Displaying Search Criteria fields  -->
<!-- ------------------------------------------------------------ -->
<table border="0" cellspacing="1" cellpadding="5" width="100%">
  <tr>
    <td width="7%">&nbsp;</td>
    <td align="center" width="31%"><b>Search By Customer</b></td>
    <td align="center" width="31%"><b>Search By Order Identifier</b></td>
    <td align="center" width="31%"><b>Search By Date Range</b></td>
  </tr>

  <!-- the input fields -->
  <tr>
    <td width="7%">&nbsp;</td>
    <td nowrap> <!-- search by customer id -->
      <form method="post" name="CustomerSearchForm" action="<wf:createWebflowURL event="link.home_order"/>">
      <input type="hidden" name="<%=DESTINATION_TAG%>" value="<wf:createWebflowURL namespace="admin_order" event="link.calendar>"/>">
      <center>
        Customer ID :<input type="text" size="15" maxlength="50" name="<%=HttpRequestConstants.SEARCH_ORDER_CUSTOMER_ID%>"><p>
        <a href="" onClick="submitForm('CustomerSearchForm'); return false;">
        <img src="<wf:createResourceURL resource="/repository/images/search_om1.gif"/>" width="65" border="0" height="40" alt="Perform Search by Customer Id"></a>
      </center>
      </form>
    </td>

    <td nowrap> <!-- search by order id -->
      <form method="post" name="OrderSearchForm" action="<wf:createWebflowURL event="link.home_order"/>">
      <input type="hidden" name="<%=DESTINATION_TAG%>" value="<wf:createWebflowURL event="link.calendar>"/>">
      <center>
        Order ID : <input type="text" size="10" maxlength="50" name="<%=HttpRequestConstants.SEARCH_ORDER_ID %>"><p>
        <a href="" onClick="submitForm('OrderSearchForm'); return false;">
        <img src="<wf:createResourceURL resource="/repository/images/search_om1.gif"/>" width="65" border="0" height="40" alt="Perform Search by Order Id"></a>
      </center>
      </form>
    </td>

    <td nowrap> <!-- search by date range -->
      <form method="post" name="DateSearchForm" action="<wf:createWebflowURL event="link.home_order"/>">
      <input type="hidden" name="<%=DESTINATION_TAG%>" value="<wf:createWebflowURL event="link.home_order"/>">
      <input type="hidden" name="searchDay" value="searchDay">
      <center>
        From :<input type="text" size="15" name="<%=HttpRequestConstants.SEARCH_FROM_DAY%>" onFocus="this.blur(); alert('Please click the calendar icon to use the date/time editor.');" >
        <a href="#" onClick="MM_openBrWindow('<wf:createWebflowURL event="link.calendar" extraParams="elemVisible=DateSearchForm.wlcs_search_from_day&elemHidden=DateSearchForm.wlcs_search_from_day"/>','','<%= JSP_CALENDAR_FEATURES %>')"><img src="<wf:createResourceURL resource="/repository/images/calendar.gif"/>" width="30" height="30" alt="Launch the Date/Time Editor" align="absmiddle" border="0"></a>
        <br>

        To&nbsp;&nbsp&nbsp&nbsp;&nbsp;:<input type="text" size="15" name="<%=HttpRequestConstants.SEARCH_TO_DAY%>"  onFocus="this.blur(); alert('Please click the calendar icon to use the date/time editor.');" >
        <a href="#" onClick="MM_openBrWindow('<wf:createWebflowURL event="link.calendar" extraParams="elemVisible=DateSearchForm.wlcs_search_to_day&elemHidden=DateSearchForm.wlcs_search_to_day"/>','','<%= JSP_CALENDAR_FEATURES %>')"><img src="<wf:createResourceURL resource="/repository/images/calendar.gif"/>" width="30" height="30" alt="Launch the Date/Time Editor" align="absmiddle" border="0"></a>
        <br>
        <a href="" onClick="submitForm('DateSearchForm'); return false;">
        <img src="<wf:createResourceURL resource="/repository/images/search_om1.gif"/>" width="65" border="0" height="40" alt="Perform Search within a Date Range"></a>
      </center>
      </form>
    </td>
  </tr>

</table>
<p>
<hr>

<!-- include the results page if any results present -->
<% if(orderCollection.size() > 0) { %>
<div align="center">
<center>

<table halign="center" border="0" cellspacing="0" cellpadding="2" width="70%">
  <tr>
    <td align="center" bgcolor="#9B9BA0" colspan=5 width="100%"><b><center><h2>Order List</h2></center></b></td>
  </tr>

  <tr>
    <td bgcolor="#9B9BA0" width="7%">&nbsp;</td>
    <td bgcolor="#9B9BA0" width="13%"><b>Identifier</b></td>
    <td bgcolor="#9B9BA0" width="30%"><b>Create Date</b></td>
    <td bgcolor="#9B9BA0" width="25%"><b>Price</b></td>
    <td bgcolor="#9B9BA0" width="25%"><b>Customer Id</b></td>
  </tr>

  <% int inum = 1; %>
  <% try { %>
  <wl:repeat set="<%= orderCollection %>" id="order" type="OrderValue" count="100">
     <% String bgColor = (inum % 2 == 0) ? "bgcolor=\"#E3E3E6\"" : " "; %>
     <% inum++; %>
     <% Customer customer = (Customer)order.customerHandle.getEJBObject(); %>
     <% String customerId = customer.getIdentifier(); %>

<% String orderStatusParams = HttpRequestConstants.ORDER_IDENTIFIER + "=" + order.identifier + "&" + paramName + "=" + paramValue; %>
<% String userScopeParams   = UserManagementJspPages.USER_SCOPE_PROPERTY_JSP +"&userName=" + customerId + "&groupPropertySets=" + "_DEFAULT_PORTAL_SCHEMA";%>
     <tr>
       <td <%= bgColor  %> width="7%">&nbsp;</td>
       <td <%= bgColor  %>><a href="<wf:createWebflowURL event="link.order_status" extraParams="<%=orderStatusParams%>"/>"><%= order.identifier %></a></td>
       <td <%= bgColor  %>><%= order.createdDate %></td>
       <td <%= bgColor  %>>
            <%= order.price.getCurrency() %>
	        <%= WebflowJSPHelper.priceFormat(order.price.getValue() ) %>
		</td>
       <td <%= bgColor  %>><a href="<wf:createWebflowURL event="link.user_scope" extraParams="<%=userScopeParams%>"/>"><%= customerId %></a></td>
     </tr>

  </wl:repeat>

  <% } catch(Exception e) {
       e.printStackTrace();
     }
  %>

</table>
</center>
</div>
<hr>

<% } // endif orderCollection.size() > 0 %>
<center>
<a href="<wf:createWebflowURL event="link.home"/>"><img src="<wf:createResourceURL resource="/repository/images/back_om1.gif"/>" width="65" height="40" border="0" alt="Return to Catalog Management Home"></a>
</center>
</body>
</html>
