<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<!-- ------------------------------------------------------------ -->
<!-- IMPORTS                                                      -->
<!-- ------------------------------------------------------------ -->

<%@ page extends="com.bea.jsptools.common.servlets.jsp.ToolsJspBase"%>
<%@ page import="java.util.*" %>
<%@ page import="java.text.*" %>
<%@ taglib uri="es.tld" prefix="es" %>
<%@ taglib uri="weblogic.tld" prefix="wl" %>
<%@ taglib uri="webflow.tld" prefix="wf" %>
<%@ page import="com.bea.p13n.appflow.webflow.*" %>
<%@ page import="com.beasys.commerce.webflow.HttpRequestConstants" %>
<%@ page import="com.beasys.commerce.axiom.units.*" %>
<%@ page import="com.beasys.commerce.axiom.contact.*" %>
<%@ page import="com.beasys.commerce.ebusiness.order.*" %>
<%@ page import="com.beasys.commerce.ebusiness.customer.*" %>
<%@ page import="com.beasys.commerce.ebusiness.payment.*" %>
<%@ page import="com.bea.jsptools.p13n.common.servlets.jsp.JspUtilPages" %>
<%@ page import="com.beasys.commerce.ebusiness.order.jsp.*" %>
<%@ page import="com.beasys.commerce.util.*;" %>
<%@ page import="com.beasys.commerce.axiom.util.helper.*;" %>
<%@ page import="com.bea.p13n.util.*;" %>
<%@ page import="com.bea.p13n.management.ApplicationHelper;" %>

<% request.setAttribute(SERVICEMANAGER_CURRENT_PAGE, getJspName(pageContext));%>

<!-- ------------------------------------------------------------ -->
<!-- START THIS PAGE FUNCTIONAL CODE PRESENTATION                 -->
<!-- ------------------------------------------------------------ -->

<%

// create the number formatter objects
NumberFormat priceFormat = NumberFormat.getInstance();
priceFormat.setMinimumFractionDigits(2);
priceFormat.setMaximumFractionDigits(2);

NumberFormat quantityFormat = NumberFormat.getInstance();
quantityFormat.setMinimumFractionDigits(0);
quantityFormat.setMaximumFractionDigits(0);

// The stateless session bean
OrderManager orderManager = null;   

// get the ordervalue object from the database.
String orderIdentifier = request.getParameter(HttpRequestConstants.ORDER_IDENTIFIER);
OrderPk orderPk= null;
OrderValue orderValue = null;

String statusMsg = null;
CustomerValue customerValue = null;
String[] newStatuses = null;
String fDate = null;
String fromDate = "";
String toDate = "";
String searchDay = "";
String searchCustomerId = null;
String searchOrderId = null;
ArrayList  adjustmentPresentations = null;


   // Retrieve the order value AND the persisted adjustment presentations
   try {
       String omJndiName = "java:comp/env/ejb/OrderManager";
       OrderManagerHome orderManagerHome = (OrderManagerHome) JndiHelper.lookupNarrow(omJndiName, OrderManagerHome.class);
       orderManager = orderManagerHome.create();
       orderPk = new OrderPk(orderIdentifier);
       orderValue = orderManager.findByPK(orderPk);  
       orderManager.queryOrderAdjusments(orderPk, orderValue);

       // Get the customer value
       Customer customer = (Customer)orderValue.customerHandle.getEJBObject();
       customerValue = customer.getCustomerByValue();

   }  catch(Exception e)  {
       e.printStackTrace();
       statusMsg = MessageCatalog.getUserMessage("ebusiness-order", "order.findByOrderId.exception", new String[] {orderIdentifier});
   }

   // What status can be shown
   try {
       newStatuses = orderManager.getValidNewStatuses(orderPk);
       Arrays.sort(newStatuses);
   } catch (Exception e) {
       // Nothing to do if errors out when finding new statuses, already null.
   }

String params = null;     // parameters to pass to the back page
%>

<wl:process name="<%= HttpRequestConstants.SEARCH_ORDER_CUSTOMER_ID %>" >
    <% searchCustomerId = request.getParameter(HttpRequestConstants.SEARCH_ORDER_CUSTOMER_ID) ; %>
    <% params = HttpRequestConstants.SEARCH_ORDER_CUSTOMER_ID + "=" + searchCustomerId ; %>
</wl:process>

<wl:process name="<%= HttpRequestConstants.SEARCH_ORDER_ID %>" >
    <% searchOrderId = request.getParameter(HttpRequestConstants.SEARCH_ORDER_ID) ; %>
    <% params = HttpRequestConstants.SEARCH_ORDER_ID + "=" + searchOrderId; %>
</wl:process>

<wl:process name="searchDay" >
<%
    fDate = null;

    fDate = request.getParameter("searchDay");
    fromDate = fDate.substring(0,fDate.indexOf('$'));
    toDate   = fDate.substring(fDate.indexOf('$')+1);
    searchDay = fromDate + "$" + toDate;
    params = "searchDay=searchDay&" + 
          HttpRequestConstants.SEARCH_FROM_DAY+"="+fromDate + "&" +
	  HttpRequestConstants.SEARCH_TO_DAY + "="+toDate;

    
%>
</wl:process>

<wl:process name="selectedStatus" >
<%
    String newStatus = request.getParameter("selectedStatus");
	try {
        orderManager.setOrderStatus(orderPk, newStatus);

        // If it fails, we go directly to 
        // getting the good new statuses.
        // Let's not get the whole order, let's just
        // set the orderValue status and get the next valid statuses
        orderValue.orderStatus = newStatus;

    } catch (Exception e) 
    {
		statusMsg = "Changing this order status to '" + newStatus + "' is not allowed at this stage";
    }
    // What status can be shown
    try {
        newStatuses = orderManager.getValidNewStatuses(orderPk);
        Arrays.sort(newStatuses);
    } catch (Exception e) {
        // Nothing to do if errors out when finding new statuses, already null.
    }
%>
</wl:process>

<html>
<head>
<title>Order Status</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<SCRIPT language="javascript">
<!--
function submitForm (formName)
{
	document.forms[formName].submit()
}
//-->
</script>
</head>
<body bgcolor="#FFFFFF" topmargin="0" leftmargin="0" marginwidth="0" marginheight="0">

<jsp:include page="<%=JspUtilPages.JSP_UTIL_HOME_HDR%>"/>

<!-- The 'title' of the page, Order Status xxxx -->
<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td width="3%" bgcolor="#000000"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></b></font></td>
    <td width="88%" bgcolor="#000000"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></b></font></td>
    <td width="6%" bgcolor="#000000"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/stopclear.gif"/>" width="65" height="8"></b></font></td>
    <td width="3%" bgcolor="#000000"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></b></font></td>
  </tr>
  <tr>
    <td width="3%" bgcolor="#777788"><img src="<wf:createResourceURL resource="/repository/images/om.gif"/>" width="30" height="24"></td>
    <td width="88%" bgcolor="#777788"><font face="Verdana, Arial, Helvetica, sans-serif" size="3" color="#000000"><b><font color="#FFFFFF">Order Status: <%= orderValue.identifier %> </font></b></font></td>
    <td width="6%" bgcolor="#777788"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/smiddleclear.gif"/>" width="65" height="24"></b></font></td>
    <td width="3%" bgcolor="#FFFFFF"><img src="<wf:createResourceURL resource="/repository/images/scurves_om_r1_c1.gif"/>" width="30" height="24"></td>
  </tr>
  <tr>
    <td width="3%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></b></font></td>
    <td width="88%"><% if(statusMsg != null) { %> <%@ include file="/tools/catalog/status.inc" %> <% } %> </td>
    <td width="6%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/sbottomclear.gif"/>" width="65" height="8"></b></font></td>
    <td width="3%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></b></font></td>
  </tr>
</table>


<!-- Change status if necessary, if newStatus has some values to change to --> 
<% if (newStatuses != null && newStatuses.length > 0) { %>
<FORM method="post" name="changeStatus" action="<wf:createWebflowURL event="link.orderstatus_admin"/>">

     <input type="hidden" name="<%=DESTINATION_TAG%>" value="<%=getRequestURI(request)%>">

     <input type="hidden" name="<%=HttpRequestConstants.ORDER_IDENTIFIER%>" value="<%=orderValue.identifier%>" >

     <% if (searchCustomerId != null ) { %>
	 <input type="hidden" name="<%=HttpRequestConstants.SEARCH_ORDER_CUSTOMER_ID%>" value="<%=searchCustomerId%>" >
     <% } else if (searchOrderId != null) { %>
	 <input type="hidden" name="<%=HttpRequestConstants.SEARCH_ORDER_ID%>" value="<%=searchOrderId%>" >
     <% } else if (fDate != null ) { %>
	<input type="hidden" name="searchDay" value="<%=searchDay%>" >
     <% } %>

<TABLE BORDER="2">
  <TR>
      <TD width="40%">To change the status of this order, select the new status and click "OK"</TD>
      <TD WIDTH="10%"> 
            <select name=selectedStatus>
                <% for (int i=0; i< newStatuses.length; i++) { %>
                    <option><%= newStatuses[i] %></option>
                <% } %>
               </select>
      </TD>

     <TD WIDTH="5%"> <a href="" onClick="submitForm('changeStatus'); return false;"> 
          <img src="<wf:createResourceURL resource="/repository/images/ok_red.gif"/>" border="0" alt="Change Order Status"></a>
     </TD>
  </TR>
</TABLE>

</FORM>
<% } %> 

<!-- Show the order itself -->
<% if(orderValue != null) { %>
<table border="0" >
  <tr>
    <td width="3%">&nbsp;</td>
    <td width="97%">
  <table border="0">

    <tr>
      <td><b>Confirmation Number &nbsp;&nbsp;&nbsp;</b></td>
      <td><%=orderValue.identifier%></td>
      <td>&nbsp;&nbsp;</td>
      <td><b>Customer Id</b></td>
      <td>&nbsp;&nbsp;</td>
      <td><%= customerValue.identifier %></td>
    </tr>

    <tr>
      <td><b>Order Status</b></td>
      <td><%=orderValue.orderStatus%></td>
      <td>&nbsp;&nbsp;</td> 
      <td><b>Name</b></td>
      <td>&nbsp;&nbsp;</td>
      <td><%= customerValue.lastName + ", " + customerValue.firstName  %></td>
    </tr>

    <tr>
      <td><b>Date Ordered</b></td>
      <td><%=orderValue.createdDate%></td>
      <td>&nbsp;&nbsp;</td>
      <td><b>Work Phone</b></td>
      <td>&nbsp;&nbsp;</td>
      <td><%= customerValue.businessPhone  %></td>
    </tr>

    <tr>
      <td><b>Splitting Preference</b></td>
      <td><%= orderValue.splittingPreference %></td>
      <td>&nbsp;&nbsp;</td>
      <td><b>Home Phone</b></td>
      <td>&nbsp;&nbsp;</td>
      <td><%= customerValue.homePhone  %></td>
    </tr>

    <tr>
      <td><b>Special Instructions</b></td>
      <td><%= orderValue.specialInstructions %></td>
      <td>&nbsp;&nbsp;</td>
      <td><b>Email</b></td>
      <td>&nbsp;&nbsp;</td>
      <td><%= customerValue.email  %></td>
    </tr>

    <tr>
      <td><b>Shipping Address</b></td>
      <td><%=orderValue.shippingAddress.getStreet1()%></td>
      <td>&nbsp;&nbsp;</td>
      <td>&nbsp;</td>
      <td>&nbsp;&nbsp;</td>
      <td>&nbsp;</td>
    </tr>

    <% if( orderValue.shippingAddress.getStreet2().length() != 0) { %>
    <tr>
      <td>&nbsp;</td>
      <td><%=orderValue.shippingAddress.getStreet2()%></td>
    </tr>
    <% } %>

    <tr>
      <td>&nbsp;</td>
      <td><%=orderValue.shippingAddress.getCity()%></td>
    </tr>

    <%String stateZip  = orderValue.shippingAddress.getState()+ "-" + orderValue.shippingAddress.getPostalCode();%>

    <tr>
      <td>&nbsp;</td>
      <td><%=stateZip%></td>
    </tr>

    <tr>
      <td>&nbsp;</td>
      <td><%= orderValue.shippingAddress.getCountry() %></td>
    </tr>

  </table>


  <table border="0">

    <!-- use this row to set the widths on all the columns -->

    <tr>
      <td width="87">&nbsp;</td>
      <td width="117">&nbsp;</td>
      <td width="200">&nbsp;</td>
      <td width="100">&nbsp;</td>
      <td width="100">&nbsp;</td>
    </tr>

    <tr>
      <td align="center"><b>Quantity</b></td>
      <td><b>ID</b></td>
      <td><b>Description</b></td>
      <td align="right"><b>Unit Price</b></td>
      <td align="right"><b>Subtotal</b></td>
    </tr>

    <tr>
      <td colspan="5"><hr size="1"></td>
    </tr>

    <wl:repeat set="<%=orderValue.orderLines.iterator()%>" id="orderLine" type="OrderLine" count="100">
    <tr>
      <td align="center">
        <%= quantityFormat.format( orderLine.getQuantity()) %>
      </td>
      <td>
        <%= orderLine.getProductIdentifier() %>
      </td>
      <td>
        <%= orderLine.getDescription() %>
      </td>
      <td align="right">
        <%= orderLine.getUnitPrice().getCurrency() %>
        <%= priceFormat.format( orderLine.getUnitPrice().getValue() ) %>
      </td>
      <TD ALIGN="right">
        <%= orderLine.getUnitPrice().getCurrency() %>
        <%= priceFormat.format(  orderLine.getUnitPrice().getValue() * orderLine.getQuantity()) %>
      </tr>

      <!-- if ANY discount on the line, show it now. -->
    <%  
        adjustmentPresentations = orderLine.getAdjustmentPresentations();
	if (adjustmentPresentations !=null) 
	{
	    for (int i=0; i<adjustmentPresentations.size(); i++)
	    {
		OrderAdjustmentPresentation oa = (OrderAdjustmentPresentation) adjustmentPresentations.get(i);
    %>
    <TR>
	  <TD align="RIGHT" bgcolor="#CCCCCC"> <%= quantityFormat.format(oa.getQuantity()) %> </TD>
	  <TD COLSPAN=3 ALIGN="CENTER" bgcolor="#CCCCCC"> <%=oa.getComputation() %> - <%= oa.getReason() %> </TD>
	  <TD COLSPAN=3 bgcolor="#CCCCCC" ALIGN="right">
         <%= orderLine.getUnitPrice().getCurrency() %>
	     <%= priceFormat.format(oa.getDiscount().getValue() * oa.getQuantity() ) %> 
	  </TD>
	</TR>
    <%
	    }
        } %>

      
    </wl:repeat>


    <tr>
      <td colspan="5"><hr size="1"></td>
    </tr>

    <tr>
      <td colspan="5">&nbsp;</td>
    </tr>


    <!-- Show shipping and tax -->
    <tr>
      <td align="right" colspan="4"><b>Shipping & Handling</b></td>
      <td align="right">
        <% Money shipping = orderValue.getTotal(OrderConstants.LINE_SHIPPING); %>
	<%= shipping.getCurrency() %>
	<%= WebflowJSPHelper.priceFormat( shipping.getValue() ) %>
      </td>
    </tr>

    <tr>
      <td align="right" colspan="4"><b>Total Tax</b></td>
      <td align="right">
        <% Money tax = orderValue.getTotal(OrderConstants.LINE_TAX); %>
	<%= tax.getCurrency() %>
	<%= WebflowJSPHelper.priceFormat(tax.getValue()) %>
      </td>
    </tr>

      <!-- if ANY discount on the order, show it now. -->
    <%  

        adjustmentPresentations = (ArrayList) orderValue.adjustmentPresentations;
	if (adjustmentPresentations !=null) 
	{
	    for (int i=0; i<adjustmentPresentations.size(); i++)
	    {
		OrderAdjustmentPresentation oa = (OrderAdjustmentPresentation) adjustmentPresentations.get(i);
    %>
        <TR>

    <tr>
      <td colspan="5"><hr size="1"></td>
    </tr>
      <TD BGCOLOR="#CCCCCC" ALIGN="RIGHT"> Order </TD>
	  <TD COLSPAN=3 ALIGN="CENTER" bgcolor="#CCCCCC"> <%=oa.getComputation() %> - <%= oa.getReason() %> </TD>
	  <TD COLSPAN=3 bgcolor="#CCCCCC" ALIGN="right">
	    <%= tax.getCurrency() %>
	      -<%= priceFormat.format(oa.getDiscount().getValue() ) %> 
	  </TD>
	</TR>
    <%
	    }
        } %>


    <!-- Finally, show the total -->

    <tr>
      <td align="right" colspan="4"><b>Total Due</b></td>
      <td align="right">
	<%= orderValue.price.getCurrency() %>
	<%= WebflowJSPHelper.priceFormat(orderValue.price.getValue() ) %>
      </td>
    </tr>

</table>
</td></tr>
<tr><td>&nbsp;</td>
<td><a href="<wf:createWebflowURL event="link.home_order"/>"><img src="<wf:createResourceURL resource="/repository/images/back_om1.gif"/>" width="65" height="40" border="0" alt="Return to Order Management Home"></a></td>
</tr>
</table>


<% } %>


