<%-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. --%>
<%@ page extends="com.bea.jsptools.common.servlets.jsp.ToolsJspBase"%>

<%-- ------------------------------------------------------------ --%>
<%-- page imports                                                 --%>
<%-- ------------------------------------------------------------ --%>
<%@ page import="java.lang.Boolean"%>
<%@ page import="com.bea.portal.jsp.JspConstants"%>

<%@ page errorPage="error.jsp" %>

<%-- ------------------------------------------------------------ --%>
<%-- taglibs                                                      --%>
<%-- ------------------------------------------------------------ --%>
<%@ taglib uri="webflow.tld" prefix="wf" %>
<%@ taglib uri="i18n.tld" prefix="i18n" %>
<%@ taglib uri="vum.tld" prefix="vum" %>

<%-- ------------------------------------------------------------ --%>
<%-- i18n (internationalization) and skin setup                   --%>
<%-- ------------------------------------------------------------ --%>

<%@ include file="/tools/portal/i18n_setup.inc"%>

<% // Grab the html title string from the properties file %>
<i18n:getMessage messageName='pageTitle' id='pageTitle'/>


<%-- ------------------------------------------------------------ --%>
<%-- environment setup                                            --%>
<%-- ------------------------------------------------------------ --%>
<%-- ------------------------------------------------------------ --%>

<%-- DECLARE NavLocation VALUE                                   --%>
<%-- Used for the left_navbar highlighting                        --%>
<%-- ------------------------------------------------------------ --%>
  <wf:setProperty property='NavLocation' value='<%=JspConstants.USERS_NAV%>' scope='request'/>

<%
  // Make this page uncacheable so that session variables can be cleared.
  response.setHeader("Cache-Control","no-cache");  // HTTP 1.1
  response.setHeader("Pragma","no-cache");      // HTTP 1.0
  response.setDateHeader("Expires", 0);      // prevents caching at proxy
%>
  
  <!-- /* setup variables used in this page */ -->
  <wf:getProperty property='portalName' id='portalName' type='String'/>
  <wf:getProperty property='gpPortalIDCurrent' id='portalIdStr' type='String'/>
  <wf:getProperty property='groupPortalObj' id='currentGroupPortal' type='com.bea.portal.model.GroupPortal'/>

<%-- TODO: consolidate vars ------------------------------------ --%>
<%  
  //Check to see if page was load for a delete, and if so, do the user delete
  String actionUserName = request.getParameter("userName");
  String context = request.getParameter("context");
  if(context != null)
  {
    if(context.equals("remove"))
    {
%>
      <vum:removeUserFromGroup groupPortal='<%=currentGroupPortal%>' userName='<%=actionUserName%>'/>
<%
    }
    if(context.equals("add"))
    {
%>
      <vum:addUserToGroup groupPortal='<%=currentGroupPortal%>' userName='<%=actionUserName%>'/>
<%
    }
  }

  String sIndex = request.getParameter("index");
  int iIndex = 0;
  if(sIndex != null && !sIndex.equals(""))
  {
    iIndex = Integer.parseInt(sIndex.trim());
  }
  if(iIndex < 0)
  {
    iIndex = 0;
  }

  String sUserCount = request.getParameter("user_count");
  //If we're note posting to ourselves, check if there's a value in the pipeline
  if(sUserCount == null)
  {
%>
    <wf:getProperty property="user_count" id="sUserCountTemp" type="String"/>
<%
     sUserCount = sUserCountTemp;
  }

%>
  <i18n:getMessage messageName='usersDisplayed' id='usersDisplayed' bundleName='tools'/>
<%
  //In this part, we get the string from the tools.properties that is then turned into the 'Displayed
  // Per Page' drop down box.  We also need to get the number that will be the default
  usersDisplayed = usersDisplayed + ",";
  ArrayList usersDisplayedList = new ArrayList();
  String newNumber = null;
  while(usersDisplayed.length()>0)
  {
    newNumber = usersDisplayed.substring( 0, usersDisplayed.indexOf(",") );
    usersDisplayedList.add( newNumber.trim() );
    usersDisplayed = usersDisplayed.substring(usersDisplayed.indexOf(",") + 1, usersDisplayed.length());
  }
  
%>
  <i18n:getMessage messageName='usersDisplayedDefault' id='usersDisplayedDefault' bundleName='tools'/>
<%
  int iUserCount = Integer.parseInt(usersDisplayedDefault);

  if(sUserCount != null && !sUserCount.equals(""))
  {
    iUserCount = Integer.parseInt(sUserCount.trim());
%>
    <wf:setProperty property='user_count' value='<%=String.valueOf(iUserCount)%>' />
<%
  }
  String searchString = request.getParameter("SearchString");
  //Handle the case were nothing was entered, we return all
  if (searchString == null || searchString == "") 
  {
    searchString = "*";
  }
  //If something was entered for a new search, we have to return the start index to 0, since we don't 
  // know how many will be in the return set
  String newSearch = request.getParameter("newSearch");
  if (newSearch != null) 
  {
    iIndex = 0;
  }
%>
  <vum:getUsernamesForVisitorUserGroup id="userListInGroup" groupPortal='<%=currentGroupPortal%>' searchExp='<%=searchString%>'/>
  <vum:getGroupPortalEligibleVisitorUsers id="userListNotInGroup" groupPortal='<%=currentGroupPortal%>' searchExp='<%=searchString%>'/>
  
<%
  //Create out hashtable to use later to figure out if a user is in the group or not
  Hashtable userHashtable = new Hashtable();
  if(userListInGroup != null)
  {
    for(int hashCountInGroup=0;hashCountInGroup<userListInGroup.size();hashCountInGroup++)
    {
      userHashtable.put(userListInGroup.get(hashCountInGroup), new Boolean(true));
    }
  }
  if(userListNotInGroup != null)
  {
    for(int hashCountNotInGroup=0;hashCountNotInGroup<userListNotInGroup.size();hashCountNotInGroup++)
    {
      userHashtable.put(userListNotInGroup.get(hashCountNotInGroup), new Boolean(false));
    }
  }
  //Combine the two lists before we do our sort
  for(int listCount=0;listCount<userListNotInGroup.size();listCount++)
  {
    userListInGroup.add(userListNotInGroup.get(listCount));
  }
%>
  <es:notNull item='<%=userListInGroup%>'>
    <%-- Narrow list down from search params --%>
<%  //Now, get the language so we can internationalize the sort.  This info got set when we called 
    //TODO:Actually use localize tag
    //  <i18n:localize/>
    String language = (String)pageContext.findAttribute("LANGUAGE");
    //Need to pass in a language to the sort tag, so default to english
    if(language.compareTo("") == 0 || language == null)
    {
      language = "en";
    }
%>
    <vum:stringListI18nSort id='userListLargeSorted'
                            list='<%=userListInGroup%>'
                            language='<%=language%>'
    />
  </es:notNull>
<%
  //Now we need to get a smaller sublist to display
  int iMaxCount = userListLargeSorted.size();
  int toIndex = iIndex+iUserCount;
  boolean userListIsEmpty = false;
  if(iMaxCount == 0)
  {
    userListIsEmpty = true;
  }
  if(iMaxCount < toIndex)
  {
    toIndex = iMaxCount;
  }
  List userList = userListLargeSorted.subList(iIndex,toIndex);
  String sUserName = null;

  //Set up some variables to use later in the page
  String iNextAmount = null;
  String iPrevAmount = null;
  if( (iMaxCount - toIndex) < iUserCount )
  {
      iNextAmount = String.valueOf(iMaxCount - toIndex);
  }
  else
  {
      iNextAmount = String.valueOf(iUserCount);
  }
  if( iIndex < iUserCount )
  {
      iPrevAmount = "";
  }
  else
  {
      iPrevAmount = String.valueOf(iUserCount);
  }
%>
  <%-- END TODO: ------------------------------------------------- --%>

<%-- ------------------------------------------------------------ --%>
<%-- begin rendering                                              --%>
<%-- ------------------------------------------------------------ --%>
<HTML>
<HEAD>
  <TITLE><%=pageTitle%></TITLE>
  <LINK REL=StyleSheet HREF="<wf:createResourceURL resource='<%=cssFile%>'/>" TYPE="text/css" MEDIA=screen>
  
  <%-- ------------------------------------------------------------ --%>
  <%-- begin JavaScript setup                                       --%>
  <%-- ------------------------------------------------------------ --%>
   
  <SCRIPT LANGUAGE="JavaScript">
    <!-- Begin hide from old browsers
      function submit()
      {
        this.document.indexForm.submit();
      }

      function removeConfirmation(message, formNumber) 
      {
        if(confirm(message))
        {
          document.forms[formNumber].submit();
        }
      }


    // End hide from old browsers -->
  </SCRIPT>
  <%-- ------------------------------------------------------------ --%>
  <%-- end JavaScript setup                                         --%>
  <%-- ------------------------------------------------------------ --%>

</HEAD>
<BODY leftmargin="0" rightmargin="0" marginwidth="0" marginheight="0" STYLE='BACKGROUND-IMAGE:url("<wf:createResourceURL resource='<%=imagesPath + "bg_subpage.gif"%>'/>"); BACKGROUND-REPEAT: no-repeat; BACKGROUND-POSITION:left top;'>

<%@ include file="/tools/util/admin_header.inc"%>
<!-- end top nav bar -->

  <!-- This is the uber table that contains two table data cells: one for the left nav, the other for the main page layout -->
  <TABLE border="0" cellspacing="0" cellpadding="0" width="100%" height="100%">
    <TR>
      <TD width="1%" align="left" valign="top" class="sidenav">
        <!-- include  table for left nav bar -->
        <jsp:include page="left_navbar.jsp"/>
      </TD>

      <TD align="center" valign="top" width="2%">
        <!-- spacer cell -->
        &nbsp;&nbsp;
      </TD>

      <!-- begin table for main content area -->
      <TD align="left" valign="top">
        <% // Include the error message display logic %>
        <%@ include file="/tools/util/error_message.inc"%>

<%      // Creation of message arguments
        Object[] args = new Object[] { cnvrtSC(currentGroupPortal.getGroupIdentifier()) };
%>
        <SPAN class="pageheader"><i18n:getMessage messageName='templateHeadLabel' messageArgs='<%=args%>'/></SPAN>
        <BR>
        <SPAN class="instructions"><i18n:getMessage messageName='templateSubheadLabel'/></SPAN>
        <BR><BR>
<%      // number of labels in category listing header section
        int numberOfLabels = 1;

        String portalInfo = "portalName=" + portalName + "&portalID=" + portalIdStr + "&SearchString=" + searchString;
        String sPrevious = portalInfo + "&index=" + (iIndex - iUserCount) + "&user_count=" + iUserCount;
        String sNext = portalInfo + "&index=" + (iIndex + iUserCount) + "&user_count=" + iUserCount;
        String sFirst = portalInfo + "&index=0" + "&user_count=" + iUserCount;
        String sLast = portalInfo + "&index=" + (iMaxCount-iUserCount) + "&user_count=" + iUserCount;
        boolean bPrev = false;
        boolean bNext = false;
        if(iIndex != 0)
        {
          bPrev = true;
        }
        if(iIndex + iUserCount < iMaxCount)
        {
          bNext = true;
        }
%>

        <TABLE cellspacing="0" cellpadding="0" border="0" width="1%">
          <TR>
            <TD align="left" valign="top" rowspan="2">
              <!-- category listing left hand side -->
              <jsp:include page="category_list_header_lhs.jsp"/>
            </TD>

            <!-- It may seem strange to put a td width of 1000 in here, but after much trial and error this is the only way Netscape will maintain the fixed border widths along with the liquid, stretchable layout of the table -->
            <TD class="categoryHeadingBorderCell" colspan="<%=numberOfLabels%>" height="1px" width="1000"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>

            <TD align="left" valign="top" rowspan="2">
              <!-- category listing right hand side -->
              <jsp:include page="category_list_header_rhs.jsp"/>
            </TD>
          </TR>

          <TR>
            <!-- * START LABELS -->
            <TD class="categoryHeadingCell" nowrap width="100%">
              <i18n:getMessage messageName='user'/>
            </TD>
            <!-- * END LABELS -->
          </TR>

          <!-- This creates the dark green line at the bottom of the green header -->
          <TR>
            <TD class="categoryHeadingBorderCell" colspan="<%=(numberOfLabels+2)%>" height="1"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
          </TR>
          <!-- START DETAIL ROW -->
          <TR>
            <TD class="row">&nbsp;</TD>
            <TD class="row" nowrap>
              <!-- start Webflow/Pipeline enabled FORM -->
              <BR>
              <wf:form namespace="admin_portal"  event="link.refresh" origin="add_user_to_group.jsp" hide="true" method="post" name="searchForm">
                    <INPUT TYPE="TEXT" NAME="SearchString" VALUE="<%=searchString%>">
                    &nbsp;
                    <INPUT TYPE="IMAGE" SRC="<wf:createResourceURL resource='<%=imagesPath + "search.gif"%>'/>" ALT="<i18n:getMessage messageName='performUserSearch'/>" border="0">
                    <INPUT TYPE="HIDDEN" NAME="index" VALUE="<%=iIndex%>">
                    <INPUT TYPE="HIDDEN" NAME="newSearch" VALUE="true">
              </wf:form>
              <!-- start Webflow/Pipeline enabled FORM -->
              <wf:form namespace="admin_portal" event="link.refresh" origin="add_user_to_group.jsp" hide="true" method="post" name="indexForm">
<%              if(userListIsEmpty)
                {
%>                <BR><i18n:getMessage messageName='noUsers' bundleName='tools'/>
<%
                }
                else
                {
                  if((iIndex+1) == toIndex)
                  {
                    args = new Object[] { String.valueOf(toIndex), String.valueOf(iMaxCount) };
%>                  <BR><B><i18n:getMessage messageName='displayOneOfMany' messageArgs='<%=args%>' bundleName='tools'/></B>
<%
                  }
                  else
                  {
                    args = new Object[] { String.valueOf(iIndex + 1), String.valueOf(toIndex), String.valueOf(iMaxCount) };
%>                  <BR><B><i18n:getMessage messageName='displayOneThroughMany' messageArgs='<%=args%>' bundleName='tools'/></B>
<%                }
                }
%>
                &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                <i18n:getMessage messageName='displayedUsersPerPage' bundleName='tools'/>
                <SELECT SIZE="1" NAME="user_count" onChange="submit();">
<%                for(int j=0;j<usersDisplayedList.size();j++)
                  {
                    if(Integer.parseInt( (String)usersDisplayedList.get(j) ) == iUserCount)
                    {
%>                    <OPTION SELECTED><%=usersDisplayedList.get(j)%>
<%                  }
                    else
                    {
%>                    <OPTION><%=usersDisplayedList.get(j)%>
<%                  }
                  }
%>
                </SELECT>
                <INPUT TYPE="HIDDEN" NAME="index" VALUE="<%=iIndex%>">
                <INPUT TYPE="HIDDEN" NAME="SearchString" VALUE="<%=searchString%>">
              </wf:form>
              <br>&nbsp;&nbsp;&nbsp;&nbsp;
<%            if(bPrev && !bNext)
              {
%>              <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sPrevious%>'/>"><i18n:getMessage messageName='previous' bundleName='tools'/> <%=iPrevAmount%></A>&nbsp;|
                <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sFirst%>'/>"><i18n:getMessage messageName='first' bundleName='tools'/> </A><br><br>
<%            }
              else if(bNext && ! bPrev)
              {
%>              <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sNext%>'/>"><i18n:getMessage messageName='next' bundleName='tools'/> <%=iNextAmount%></A>&nbsp;|
                <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sLast%>'/>"><i18n:getMessage messageName='last' bundleName='tools'/> </A><br><br>
<%            }
              else if(bPrev && bNext)
              {
%>              <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sPrevious%>'/>"><i18n:getMessage messageName='previous' bundleName='tools'/> <%=iPrevAmount%></A>&nbsp;|
                <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sNext%>'/>"><i18n:getMessage messageName='next' bundleName='tools'/> <%=iNextAmount%></A>&nbsp;
                [ <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sFirst%>'/>"><i18n:getMessage messageName='first' bundleName='tools'/> </A>&nbsp;|
                <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sLast%>'/>"><i18n:getMessage messageName='last' bundleName='tools'/></A> ]<br><br>
<%            }
%>
              </TD>
            </TR>
            <!-- START DETAIL ROW -->
            <TR>
              <TD class="row">&nbsp;</TD>
              <TD nowrap>
                <TABLE WIDTH="75%" cellspacing="0" cellpadding="0" BORDER="0">
                  <%--  This form is a hack.  It was put in for the javascript submit form.  If there is only one form on
                        the page, the numbering won't work. This ensures there will always be two forms.
                  --%>
                  <wf:form namespace="admin_portal" event="link.refresh" origin="add_user_to_group.jsp" hide="true" method="post" name="DeleteForm">
                  </wf:form>
<%
                  //Initialize a variable we'll use for formatting purposes (if rowFormat is odd, we
                  // display the row in white, if even, display in gray).  This alternates white and gray
                  // and we don't worry about how many rows we have
                  int rowFormat = 1;
                  String classFormat = null;
                  String extraParams = null;
                  String displayMessage = null;
                  for(int i=0;i<userList.size();i++)
                  {
                    if((rowFormat%2) == 0)
                    {
                      classFormat = "row2";
                    }
                    else
                    {
                      classFormat = "row1";
                    }
                    rowFormat = rowFormat + 1;

                    sUserName = cnvrtSC((String)userList.get(i));
                    args = new Object[] { sUserName };
%>
                    <i18n:getMessage id='removeConfirmation' messageName='removeConfirmation' messageArgs='<%=args%>'/>
<%              
                    extraParams = "userName=" + sUserName + "&SearchString=" + searchString;
%>
                    <TR>
                      <!-- * START DETAIL -->
                      <TD class="<%=classFormat%>" align="left" valign="middle" WIDTH="1%" NOWRAP>
                        &nbsp;&nbsp;&nbsp;
                        <%=sUserName%>
                      </TD>
                      <TD class="<%=classFormat%>" WIDTH="1%" NOWRAP>
<%                      if( ((Boolean)(userHashtable.get(sUserName))).booleanValue() )
                        {
%>
                          &nbsp;
<%
                        }
                        else
                        {
                          extraParams = extraParams + "&context=add" + "&index=" + iIndex;
%>
                          &nbsp;&nbsp;&nbsp;<a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=extraParams%>'/>"><IMG src="<wf:createResourceURL resource='<%=imagesPath + "add_user.gif"%>'/>" border="0" align="absmiddle" vspace="4"></a>&nbsp;&nbsp;&nbsp;
<%                          
                        }
%>
                      </TD>
					            <wf:form namespace="admin_portal" event="link.refresh" origin="add_user_to_group.jsp" hide="true" method="post" name="DeleteForm">
                          <INPUT TYPE="HIDDEN" NAME="userName" VALUE="<%=sUserName%>">
                          <INPUT TYPE="HIDDEN" NAME="context" VALUE="remove">
                          <INPUT TYPE="HIDDEN" NAME="index" VALUE="<%=iIndex%>">
                          <INPUT TYPE="HIDDEN" NAME="SearchString" VALUE="<%=searchString%>">
                      </wf:form>
                      <TD class="<%=classFormat%>" WIDTH="1%" NOWRAP valign="middle">
<%
                        if( ((Boolean)(userHashtable.get(sUserName))).booleanValue() )
                        {
%>                          <a href="javascript:removeConfirmation('<%=removeConfirmation%>', <%=i+3%>)"><img src="<wf:createResourceURL resource='<%=imagesPath + "remove_user.gif"%>'/>" alt="<i18n:getMessage messageName='altForRemoveGif'/>" align="absmiddle" vspace="4" border="0"></a>&nbsp;&nbsp;&nbsp;
<%
                        }
                        else
                        {
%>
                          &nbsp;
<%                          
                        }
%>
                      </TD>
                    </TR>
<%                }
%>
                </TABLE>
              </TD>
              <!-- * END DETAIL -->
 
              <TD class="row">&nbsp;</TD>
            </TR>
            <!-- END DETAIL ROW -->

            <TR>
              <TD class="row">&nbsp;</TD>
              <TD class="row" nowrap>
                <BR>&nbsp;&nbsp;&nbsp;&nbsp;
<%              if(bPrev && !bNext)
                {
%>                <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sPrevious%>'/>"><i18n:getMessage messageName='previous' bundleName='tools'/> <%=iPrevAmount%></A>&nbsp;|
                  <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sFirst%>'/>"><i18n:getMessage messageName='first' bundleName='tools'/> </A>
<%              }
                else if(bNext && ! bPrev)
                {
%>                <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sNext%>'/>"><i18n:getMessage messageName='next' bundleName='tools'/> <%=iNextAmount%></A>&nbsp;|
                  <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sLast%>'/>"><i18n:getMessage messageName='last' bundleName='tools'/> </A>
<%              }
                else if(bPrev && bNext)
                {
%>                <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sPrevious%>'/>"><i18n:getMessage messageName='previous' bundleName='tools'/> <%=iPrevAmount%></A>&nbsp;|
                  <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sNext%>'/>"><i18n:getMessage messageName='next' bundleName='tools'/> <%=iNextAmount%></A>&nbsp;
                  [ <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sFirst%>'/>"><i18n:getMessage messageName='first' bundleName='tools'/> </A>&nbsp;|
                  <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sLast%>'/>"><i18n:getMessage messageName='last' bundleName='tools'/></A> ]
<%              }
%>
              </TD>
            </TR>

            <!-- SPACER ROW -->
            <TR>
              <TD class="spacerRow" colspan="<%=(numberOfLabels+2)%>">&nbsp;</TD>
            </TR>
            <TR>
              <TD class="spacerRow" colspan="<%=(numberOfLabels+2)%>">&nbsp;</TD>
            </TR>
    
            <!-- START DETAIL ROW -->
            <TR>
              <TD class="row">&nbsp;</TD>
              <!-- * START DETAIL -->
              <TD class="row" align="left" valign="top" colspan="3">
                <A HREF="<wf:createWebflowURL namespace='admin_portal' event='link.back'/>"><IMG src="<wf:createResourceURL resource='<%=imagesPath + "back.gif"%>'/>" border="0" align="bottom"></A>
              </TD>
              <!-- * END DETAIL -->
              <TD class="row">&nbsp;</TD>
            </TR>
            <!-- END DETAIL ROW -->

            <TR>
              <TD class="spacerRow" colspan="<%=(numberOfLabels+2)%>">&nbsp;</TD>
            </TR>
            <TR>
              <TD class="emptyRow" colspan="<%=(numberOfLabels+2)%>">&nbsp;</TD>
            </TR>
          </TABLE>

        </TD>
        <!-- end content area -->

        <TD align="center" valign="top" width="2%">
          <!-- spacer cell -->
          &nbsp;&nbsp;
        </TD>

    </TR>
  </TABLE>

</BODY>
</HTML>
