<%-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. --%>
<%@ page extends="com.bea.jsptools.common.servlets.jsp.ToolsJspBase"%>

<%-- ------------------------------------------------------------ --%>
<%-- page imports                                                 --%>
<%-- ------------------------------------------------------------ --%>
<%@ page import="com.bea.portal.manager.PortalFactory"%>
<%@ page import="com.bea.portal.model.GroupPortal"%>
<%@ page import="com.bea.portal.model.PortalIdentifier"%>
<%@ page import="java.text.Collator"%>

<%@ page errorPage="error.jsp" %>

<%-- ------------------------------------------------------------ --%>
<%-- taglibs                                                      --%>
<%-- ------------------------------------------------------------ --%>
<%@ taglib uri="webflow.tld" prefix="wf" %>
<%@ taglib uri="i18n.tld" prefix="i18n" %>
<%@ taglib uri="res.tld" prefix="res" %>

<%-- ------------------------------------------------------------ --%>
<%-- i18n (internationalization) and skin setup                   --%>
<%-- ------------------------------------------------------------ --%>

<%@ include file="/tools/portal/i18n_setup.inc"%>

<% // Grab the html title string from the properties file %>
<i18n:getMessage messageName='pageTitle' id='pageTitle'/>


<%-- ------------------------------------------------------------ --%>
<%-- environment setup                                            --%>
<%-- ------------------------------------------------------------ --%>
<%
  // Make this page uncacheable so that session variables can be cleared.
  response.setHeader("Cache-Control","no-cache");  // HTTP 1.1
  response.setHeader("Pragma","no-cache");      // HTTP 1.0
  response.setDateHeader("Expires", 0);      // prevents caching at proxy
%>

<%-- Get the Default Group Portal Display name to use on the page --%>
<i18n:getMessage id='defaultGroupPortalName' messageName='defaultGroupPortal' bundleName='tools'/>

<%-- TODO: consolidate vars ------------------------------------ --%>
<%
  // Get the checkbox values from group_portal.jsp so we can pass them back.
  String entitlementsCheckbox = request.getParameter("entitlementsCheckbox");
  String groupAdminCheckbox = request.getParameter("groupAdminCheckbox");
  String templateDisplayName = request.getParameter("templateDisplayName");
  String templateNavbarOrientation = request.getParameter("templateNavbarOrientation");
  String checkboxParams = "entitlementsCheckbox=" + entitlementsCheckbox + "&groupAdminCheckbox=" + groupAdminCheckbox + "&templateDisplayName=" + templateDisplayName + "&templateNavbarOrientation=" + templateNavbarOrientation;
  
  String sIndex = request.getParameter("index");
  int iIndex = 0;
  if(sIndex != null && !sIndex.equals(""))
  {
    iIndex = Integer.parseInt(sIndex.trim());
  }
  if(iIndex < 0)
  {
    iIndex = 0;
  }

  String sGroupPortalCount = request.getParameter("group_portal_count");
  //If we're note posting to ourselves, check if there's a value in the pipeline
  if(sGroupPortalCount == null)
  {
%>
    <wf:getProperty property="group_portal_count" id="sGroupPortalCountTemp" type="String"/>
<%
     sGroupPortalCount = sGroupPortalCountTemp;
  }
  
%>
  <i18n:getMessage messageName='groupPortalsDisplayed' id='groupPortalsDisplayed' bundleName='tools'/>
<%
  //In this part, we get the string from the tools.properties that is then turned into the 'Displayed
  // Per Page' drop down box.  We also need to get the number that will be the default
  groupPortalsDisplayed = groupPortalsDisplayed + ",";
  ArrayList groupPortalsDisplayedList = new ArrayList();
  String newNumber = null;
  while(groupPortalsDisplayed.length()>0)
  {
    newNumber = groupPortalsDisplayed.substring( 0, groupPortalsDisplayed.indexOf(",") );
    groupPortalsDisplayedList.add( newNumber.trim() );
    groupPortalsDisplayed = groupPortalsDisplayed.substring(groupPortalsDisplayed.indexOf(",") + 1, groupPortalsDisplayed.length());
  }

%>
  <i18n:getMessage messageName='groupPortalsDisplayedDefault' id='groupPortalsDisplayedDefault' bundleName='tools'/>
<%
  int iGroupPortalCount = Integer.parseInt(groupPortalsDisplayedDefault);
  
  if(sGroupPortalCount != null && !sGroupPortalCount.equals(""))
  {
    iGroupPortalCount = Integer.parseInt(sGroupPortalCount.trim());
%>
    <wf:setProperty property='group_portal_count' value='<%=String.valueOf(iGroupPortalCount)%>' />
<%
  }
%>
  <!-- /* setup variables used in this page */ -->
  <wf:getProperty property='portalName' id='portalName' type='String'/>
  <wf:getProperty property='gpPortalIDCurrent' id='portalIdStr' type='String'/>

<%  
  //PortalIdentifier portalId = PortalFactory.createPortalIdentifier(portalIdStr);
  PortalIdentifier portalId = PortalFactory.createPortalIdentifier(portalIdStr);

  //Now, we need to get the GroupPortals that are associated with this portal
%>
  <res:getGroupPortals id="groupPortalsLarge" portalIdentifier="<%=portalId%>"/>
<%      
  String defaultGroupParams = null;
  List groupPortalsModifiable = new ArrayList(groupPortalsLarge);
  //The first loop picks out the default group portal and places it at the top of the output list.
  String defaultGroupPortalDisplayName = "";
  for(int j=0;j<groupPortalsModifiable.size();j++)
  {
    if(((GroupPortal)groupPortalsModifiable.get(j)).isDefault())
    {
      defaultGroupPortalDisplayName = ((GroupPortal)groupPortalsModifiable.get(j)).getDisplayName();      
      defaultGroupParams = "userGroupID=" + ((GroupPortal)groupPortalsModifiable.get(j)).getGroupIdentifier() + "&templateName=" + defaultGroupPortalDisplayName;
      groupPortalsModifiable.remove(j);
      j=j-1;
    }
  }
%>
    
  <%-- Narrow list down from search params --%>
<%String searchString = request.getParameter("SearchString");
  //Handle the case were nothing was entered, we return all
  if (searchString == null || searchString == "") 
  {
    searchString = "*";
  }
  //If something was entered, we have to return the start index to 0, since we don't know how many will
  // be in the return set
  String newSearch = request.getParameter("newSearch");
  if (newSearch != null)
  {
    iIndex = 0;
  }
%>
  <res:groupPortalSearchList id="groupPortalsSearchNarrowed" groupPortalList="<%=groupPortalsModifiable%>" searchExp="<%=searchString%>" />
<%//Now, get the language so we can internationalize the sort.  This info got set when we called 
  //TODO:Actually use localize tag
  //  <i18n:localize/>
  String language = (String)pageContext.findAttribute("LANGUAGE");
  //Need to pass in a language to the sort tag, so default to english
  if( language == null || language.compareTo("") == 0)
  {
    language = "en";
  }
%>
  <res:groupPortalListI18nSort id="groupPortalsLargeSorted" 
                              groupPortalList="<%=groupPortalsSearchNarrowed%>" 
                              language="<%=language%>"
  />

<%
  //Now we need to get a smaller sublist to display
  int iMaxCount = groupPortalsLargeSorted.size();
  int toIndex = iIndex+iGroupPortalCount;
  boolean groupPortalListIsEmpty = false;
  if(iMaxCount == 0)
  {
    groupPortalListIsEmpty = true;
  }
  if(iMaxCount < toIndex)
  {
    toIndex = iMaxCount;
  }
  List groupPortals = groupPortalsLargeSorted.subList(iIndex,toIndex);

  String sUserGroupId = null;
  String sGroupPortalName = null;
  String groupParams = null;

  //Set up some variables to use later in the page
  String iNextAmount = null;
  String iPrevAmount = null;
  if( (iMaxCount - toIndex) < iGroupPortalCount )
  {
    iNextAmount = String.valueOf(iMaxCount - toIndex);
  }
  else
  {
    iNextAmount = String.valueOf(iGroupPortalCount);
  }
  if( iIndex < iGroupPortalCount )
  {
    iPrevAmount = "";
  }
  else
  {
    iPrevAmount = String.valueOf(iGroupPortalCount);
  }
%>
  <%-- END TODO: ------------------------------------------------- --%>


<%-- ------------------------------------------------------------ --%>
<%-- begin rendering                                              --%>
<%-- ------------------------------------------------------------ --%>
<HTML>
<HEAD>
  <TITLE><%=pageTitle%></TITLE>
  <LINK REL=StyleSheet HREF="<wf:createResourceURL resource='<%=cssFile%>'/>" TYPE="text/css" MEDIA=screen>
  
  <%-- ------------------------------------------------------------ --%>
  <%-- begin JavaScript setup                                       --%>
  <%-- ------------------------------------------------------------ --%>
   
  <SCRIPT LANGUAGE="JavaScript">
    <!-- Begin hide from old browsers
      function submit()
      {
        this.document.indexForm.submit();
      }

    // End hide from old browsers -->
  </SCRIPT>
  <%-- ------------------------------------------------------------ --%>
  <%-- end JavaScript setup                                         --%>
  <%-- ------------------------------------------------------------ --%>

</HEAD>
<BODY leftmargin="0" rightmargin="0" marginwidth="0" marginheight="0" STYLE='BACKGROUND-IMAGE:url("<wf:createResourceURL resource='<%=imagesPath + "bg_subpage.gif"%>'/>"); BACKGROUND-REPEAT: no-repeat; BACKGROUND-POSITION:left top;'>

<%@ include file="/tools/util/admin_header.inc"%>
<!-- end top nav bar -->

  <!-- This is the uber table that contains two table data cells: one for the left nav, the other for the main page layout -->
  <TABLE border="0" cellspacing="0" cellpadding="0" width="100%" height="100%">
    <TR>
      <TD width="1%" align="left" valign="top" class="sidenav">
        <!-- include  table for left nav bar -->
        <jsp:include page="left_navbar_create.jsp"/>
      </TD>

      <TD align="center" valign="top" width="2%">
        <!-- spacer cell -->
        &nbsp;&nbsp;
      </TD>

      <!-- begin table for main content area -->
      <TD align="left" valign="top">
        <% // Include the error message display logic %>
        <%@ include file="/tools/util/error_message.inc"%>

<%      // Creation of message arguments
        Object[] args = new Object[] { cnvrtSC(portalName) };
%>
        <SPAN class="pageheader"><i18n:getMessage messageName='templateHeadLabel'/></SPAN>
        <BR>
        <SPAN class="instructions"><i18n:getMessage messageName='templateSubheadLabel' messageArgs='<%=args%>'/></SPAN>
        <BR><BR>
<%      // number of labels in category listing header section
        int numberOfLabels = 1;

        //Build our parameter strings
        String portalInfo = "portalName=" + portalName + "&portalID=" + portalIdStr + "&SearchString=" + searchString + "&" + checkboxParams;
        String sPrevious = portalInfo + "&index=" + (iIndex - iGroupPortalCount) + "&group_portal_count=" + iGroupPortalCount;
        String sNext = portalInfo + "&index=" + (iIndex + iGroupPortalCount) + "&group_portal_count=" + iGroupPortalCount;
        String sFirst = portalInfo + "&index=0" + "&group_portal_count=" + iGroupPortalCount;
        String sLast = portalInfo + "&index=" + (iMaxCount-iGroupPortalCount) + "&group_portal_count=" + iGroupPortalCount;
        boolean bPrev = false;
        boolean bNext = false;
        if(iIndex != 0)
        {
          bPrev = true;
        }
        if(iIndex + iGroupPortalCount < iMaxCount)
        {
          bNext = true;
        }
%>

        <TABLE cellspacing="0" cellpadding="0" border="0" width="1%">
          <TR>
            <TD>  
              <%-- Top table that just contains the default group portal --%>
              <TABLE cellspacing="0" cellpadding="0" border="0" width="100%">
                <TR>
                  <TD align="left" valign="top" rowspan="2">
                    <!-- category listing left hand side -->
                    <jsp:include page="category_list_header_lhs.jsp"/>
                  </TD>

                  <!-- It may seem strange to put a td width of 1000 in here, but after much trial and error this is the only way Netscape will maintain the fixed border widths along with the liquid, stretchable layout of the table -->
                  <TD class="categoryHeadingBorderCell" colspan="<%=numberOfLabels%>" height="1px" width="1000"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
      
                  <TD align="left" valign="top" rowspan="2">
                    <!-- category listing right hand side -->
                    <jsp:include page="category_list_header_rhs.jsp"/>
                  </TD>
                </TR>

                <TR>
                  <!-- * START LABELS -->
                  <TD class="categoryHeadingCell" nowrap width=100%>
<%                  args = new Object[] { cnvrtSC(portalName) };
%>                  <i18n:getMessage messageName='defaultForPortal' messageArgs='<%=args%>'/>
                  </TD>
                  <!-- * END LABELS -->
                </TR>
      
                <!-- This creates the dark green line at the bottom of the green header -->
                <TR>
                  <TD class="categoryHeadingBorderCell" colspan="<%=(numberOfLabels+2)%>" height="1"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
                </TR>
                
                <TR>
                  <TD class="spacerRow" colspan="<%=(numberOfLabels+2)%>">&nbsp;</TD>
                </TR>
          
                <!-- START DETAIL ROW -->
                <TR>
                  <TD class="row">&nbsp;</TD>
      
                  <!-- * START DETAIL -->
                  <TD class="row" align="left" valign="top">
                    <!-- * Default Portal -->
                    <a href="<wf:createWebflowURL namespace='admin_portal' event='link.group_portal_post_template' extraParams='<%=(defaultGroupParams+"&"+checkboxParams)%>'/>"><%=defaultGroupPortalDisplayName%></a>
                  </TD>
                  <!-- * END DETAIL -->
      
                  <TD class="row">&nbsp;</TD>
                </TR>
                <!-- END DETAIL ROW -->
                <TR>
                  <TD class="spacerRow" colspan="<%=(numberOfLabels+2)%>">&nbsp;</TD>
                </TR>
                <TR>
                  <TD class="emptyRow" colspan="<%=(numberOfLabels+2)%>">&nbsp;</TD>
                </TR>
              </TABLE>
        
              <%-- Bottom table that contains available group portals other than the default --%>
              <TABLE cellspacing="0" cellpadding="0" border="0" width="100%">
                <TR>
                  <TD align="left" valign="top" rowspan="2">
                    <!-- category listing left hand side -->
                    <jsp:include page="category_list_header_lhs.jsp"/>
                  </TD>
      
                  <!-- It may seem strange to put a td width of 1000 in here, but after much trial and error this is the only way Netscape will maintain the fixed border widths along with the liquid, stretchable layout of the table -->
                  <TD class="categoryHeadingBorderCell" colspan="<%=numberOfLabels%>" height="1px" width="1000"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
      
                  <TD align="left" valign="top" rowspan="2">
                    <!-- category listing right hand side -->
                    <jsp:include page="category_list_header_rhs.jsp"/>
                  </TD>
                </TR>

                <TR>
                  <!-- * START LABELS -->
                  <TD class="categoryHeadingCell" nowrap width=100%>
<%                  args = new Object[] { cnvrtSC(portalName) };
%>                  <i18n:getMessage messageName='othersForPortal' messageArgs='<%=args%>'/>
                  </TD>
                  <!-- * END LABELS -->
                </TR>

                <!-- This creates the dark green line at the bottom of the green header -->
                <TR>
                  <TD class="categoryHeadingBorderCell" colspan="<%=(numberOfLabels+2)%>" height="1"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
                </TR>
                <!-- START DETAIL ROW -->
                <TR>
                  <TD class="row">&nbsp;</TD>
                  <TD class="row" nowrap>
                    <!-- start Webflow/Pipeline enabled FORM -->
                    <BR>
                    <wf:form namespace="admin_portal"  event="link.refresh" origin="choose_template.jsp" hide="true" method="post" name="searchForm">
                          <INPUT TYPE="TEXT" NAME="SearchString" VALUE="<%=searchString%>">
                          &nbsp;
                          <INPUT TYPE="IMAGE" SRC="<wf:createResourceURL resource='<%=imagesPath + "search.gif"%>'/>" ALT="<i18n:getMessage messageName='performGroupSearch'/>" border="0">
                          <INPUT TYPE="HIDDEN" NAME="index" VALUE="<%=iIndex%>">
                          <INPUT TYPE="HIDDEN" NAME="portalName" VALUE="<%=portalName%>">
                          <INPUT TYPE="HIDDEN" NAME="portalID" VALUE="<%=portalIdStr%>">
                          <INPUT TYPE="HIDDEN" NAME="entitlementsCheckbox" VALUE="<%=entitlementsCheckbox%>">
                          <INPUT TYPE="HIDDEN" NAME="groupAdminCheckbox" VALUE="<%=groupAdminCheckbox%>">
                          <INPUT TYPE="HIDDEN" NAME="templateDisplayName" VALUE="<%=templateDisplayName%>">
                          <INPUT TYPE="HIDDEN" NAME="templateNavbarOrientation" VALUE="<%=templateNavbarOrientation%>">
                          <INPUT TYPE="HIDDEN" NAME="newSearch" VALUE="true">
                    </wf:form>
                    <!-- start Webflow/Pipeline enabled FORM -->
                    <wf:form namespace="admin_portal" event="link.refresh" origin="choose_template.jsp" hide="true" method="post" name="indexForm">
<%                    if(groupPortalListIsEmpty)
                      {
%>                      <BR><i18n:getMessage messageName='noGroupPortals' bundleName='tools'/>
<%
                      }
                      else
                      {
                        if((iIndex+1) == toIndex)
                        {
                          args = new Object[] { String.valueOf(toIndex), String.valueOf(iMaxCount) };
%>                        <BR><B><i18n:getMessage messageName='displayOneOfMany' messageArgs='<%=args%>' bundleName='tools'/></B>
<%
                        }
                        else
                        {
                          args = new Object[] { String.valueOf(iIndex + 1), String.valueOf(toIndex), String.valueOf(iMaxCount) };
%>                        <BR><B><i18n:getMessage messageName='displayOneThroughMany' messageArgs='<%=args%>' bundleName='tools'/></B>
<%                      }
                      }
%>
                      &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                      <i18n:getMessage messageName='displayedPerPage' bundleName='tools'/>
                      <SELECT SIZE="1" NAME="group_portal_count" onChange="submit();">
<%                      for(int j=0;j<groupPortalsDisplayedList.size();j++)
                        {
                          if(Integer.parseInt( (String)groupPortalsDisplayedList.get(j) ) == iGroupPortalCount)
                          {
%>                          <OPTION SELECTED><%=groupPortalsDisplayedList.get(j)%>
<%                        }
                          else
                          {
%>                          <OPTION><%=groupPortalsDisplayedList.get(j)%>
<%                        }
                        }
%>
                      </SELECT>
                      <INPUT TYPE="HIDDEN" NAME="SearchString" VALUE="<%=searchString%>">
                      <INPUT TYPE="HIDDEN" NAME="index" VALUE="<%=iIndex%>">
                      <INPUT TYPE="HIDDEN" NAME="portalName" VALUE="<%=portalName%>">
                      <INPUT TYPE="HIDDEN" NAME="portalID" VALUE="<%=portalIdStr%>">
                      <INPUT TYPE="HIDDEN" NAME="entitlementsCheckbox" VALUE="<%=entitlementsCheckbox%>">
                      <INPUT TYPE="HIDDEN" NAME="groupAdminCheckbox" VALUE="<%=groupAdminCheckbox%>">
                      <INPUT TYPE="HIDDEN" NAME="templateNavbarOrientation" VALUE="<%=templateNavbarOrientation%>">
                      <INPUT TYPE="HIDDEN" NAME="templateDisplayName" VALUE="<%=templateDisplayName%>">
                    </wf:form>
                    <br>&nbsp;&nbsp;&nbsp;&nbsp;
<%                  if(bPrev && !bNext)
                    {
%>                    <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sPrevious%>'/>"><i18n:getMessage messageName='previous' bundleName='tools'/> <%=iPrevAmount%></A>&nbsp;|
                      <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sFirst%>'/>"><i18n:getMessage messageName='first' bundleName='tools'/> </A><br><br>
<%                  }
                    else if(bNext && ! bPrev)
                    {
%>                    <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sNext%>'/>"><i18n:getMessage messageName='next' bundleName='tools'/> <%=iNextAmount%></A>&nbsp;|
                      <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sLast%>'/>"><i18n:getMessage messageName='last' bundleName='tools'/> </A><br><br>
<%                  }
                    else if(bPrev && bNext)
                    {
%>                    <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sPrevious%>'/>"><i18n:getMessage messageName='previous' bundleName='tools'/> <%=iPrevAmount%></A>&nbsp;|
                      <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sNext%>'/>"><i18n:getMessage messageName='next' bundleName='tools'/> <%=iNextAmount%></A>&nbsp;
                      [ <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sFirst%>'/>"><i18n:getMessage messageName='first' bundleName='tools'/> </A>&nbsp;|
                      <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sLast%>'/>"><i18n:getMessage messageName='last' bundleName='tools'/></A> ]<br><br>
<%                  }
%>
                  </TD>
                </TR>
<%
                for(int i=0;i<groupPortals.size();i++)
                {
                  //CAF:  Note:  you need to put both the portalId and the userGroupId in this query string...
                  sUserGroupId = ((GroupPortal)groupPortals.get(i)).getGroupIdentifier();
                  sGroupPortalName = ((GroupPortal)groupPortals.get(i)).getDisplayName();
                  groupParams = "userGroupID=" + sUserGroupId + "&templateName=" + sGroupPortalName + "&" + checkboxParams;
                  args = new Object[] { cnvrtSC(sGroupPortalName), cnvrtSC(sUserGroupId) };
%>
                  <!-- START DETAIL ROW -->
                  <TR>
                    <TD class="row">&nbsp;</TD>
      
                    <!-- * START DETAIL -->
                    <TD class="row" align="left" valign="top" style="padding:2;">
                      &nbsp;&nbsp;&nbsp;&nbsp;
                      <a href="<wf:createWebflowURL namespace='admin_portal' event='link.group_portal_post_template' extraParams='<%=groupParams%>'/>">
                      <i18n:getMessage messageName='groupPortalDisplay' messageArgs='<%=args%>'/>                  
                      <%-- <%=cnvrtSC(sGroupPortalName)%> --%>
                      </a>
                    </TD>
                    <!-- * END DETAIL -->
    
                    <TD class="row">&nbsp;</TD>
                  </TR>
                  <!-- END DETAIL ROW -->
<%
                }
%>

                <TR>
                  <TD class="row">&nbsp;</TD>
                  <TD class="row" nowrap>
                    <BR>&nbsp;&nbsp;&nbsp;&nbsp;
<%                  if(bPrev && !bNext)
                    {
%>                    <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sPrevious%>'/>"><i18n:getMessage messageName='previous' bundleName='tools'/> <%=iPrevAmount%></A>&nbsp;|
                      <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sFirst%>'/>"><i18n:getMessage messageName='first' bundleName='tools'/> </A>
<%                  }
                    else if(bNext && ! bPrev)
                    {
%>                    <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sNext%>'/>"><i18n:getMessage messageName='next' bundleName='tools'/> <%=iNextAmount%></A>&nbsp;|
                      <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sLast%>'/>"><i18n:getMessage messageName='last' bundleName='tools'/> </A>
<%                  }
                    else if(bPrev && bNext)
                    {
%>                    <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sPrevious%>'/>"><i18n:getMessage messageName='previous' bundleName='tools'/> <%=iPrevAmount%></A>&nbsp;|
                      <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sNext%>'/>"><i18n:getMessage messageName='next' bundleName='tools'/> <%=iNextAmount%></A>&nbsp;
                      [ <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sFirst%>'/>"><i18n:getMessage messageName='first' bundleName='tools'/> </A>&nbsp;|
                      <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sLast%>'/>"><i18n:getMessage messageName='last' bundleName='tools'/></A> ]
<%                  }
%>
                  </TD>
                </TR>

                <!-- SPACER ROW -->
                <TR>
                  <TD class="spacerRow" colspan="<%=(numberOfLabels+2)%>">&nbsp;</TD>
                </TR>
                <TR>
                  <TD class="spacerRow" colspan="<%=(numberOfLabels+2)%>">&nbsp;</TD>
                </TR>
        
                <!-- START DETAIL ROW -->
                <TR>
                  <TD class="row">&nbsp;</TD>
                  <!-- * START DETAIL -->
                  <TD class="row" align="left" valign="top" colspan="3">
                    <A HREF="<wf:createWebflowURL namespace='admin_portal' event='link.group_portal_back_template' extraParams='<%=checkboxParams%>'/>"><img src="<wf:createResourceURL resource='<%=imagesPath + "back.gif"%>'/>" border="0" align="bottom"></A>
                  </TD>
                  <!-- * END DETAIL -->
                  <TD class="row">&nbsp;</TD>
                </TR>
                <!-- END DETAIL ROW -->
    
                <TR>
                  <TD class="spacerRow" colspan="<%=(numberOfLabels+2)%>">&nbsp;</TD>
                </TR>
                <TR>
                  <TD class="emptyRow" colspan="<%=(numberOfLabels+2)%>">&nbsp;</TD>
                </TR>
              </TABLE>
        
            </TD>
          </TR>
        </TABLE>

      </TD>
      <!-- end content area -->

      <TD align="center" valign="top" width="2%">
        <!-- spacer cell -->
        &nbsp;&nbsp;
      </TD>
    </TR>
  </TABLE>

</BODY>
</HTML>
