<%-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. --%>

<%-- ------------------------------------------------------------ --%>
<%-- page imports                                                 --%>
<%-- ------------------------------------------------------------ --%>
<%@ page import="com.bea.portal.model.PortalConstants"%>
<%@ page import="com.bea.portal.jsp.JspConstants"%>
<%@ page import="com.bea.p13n.usermgmt.UserAlreadyExistsException"%>
<%@ page import="java.util.List"%>
<%@ page import="java.util.ArrayList"%>

<%@ page errorPage="error.jsp" %>

<%-- ------------------------------------------------------------ --%>
<%-- taglibs                                                      --%>
<%-- ------------------------------------------------------------ --%>
<%@ taglib uri="webflow.tld" prefix="wf" %>
<%@ taglib uri="i18n.tld" prefix="i18n" %>
<%@ taglib uri="vum.tld" prefix="vum" %>

<jsp:useBean id="userBean" class="com.bea.jsptools.p13n.usermgmt.servlets.jsp.UserBean" scope="session" />
<jsp:setProperty name="userBean" property="*" />

<%-- ------------------------------------------------------------ --%>
<%-- i18n (internationalization) and skin setup                   --%>
<%-- ------------------------------------------------------------ --%>

<%@ include file="/tools/portal/i18n_setup.inc"%>

<% // Grab the html title string from the properties file %>
<i18n:getMessage messageName='pageTitle' id='pageTitle'/>


<%-- ------------------------------------------------------------ --%>
<%-- environment setup                                            --%>
<%-- ------------------------------------------------------------ --%>

<%-- ------------------------------------------------------------ --%>
<%-- DECLARE NavLocation VALUE                                   --%>
<%-- Used for the left_navbar highlighting                        --%>
<%-- ------------------------------------------------------------ --%>
  <wf:setProperty property='NavLocation' value='<%=JspConstants.USERS_NAV%>' scope='request'/>

<%
  // Make this page uncacheable so that session variables can be cleared.
  response.setHeader("Cache-Control","no-cache");  // HTTP 1.1
  response.setHeader("Pragma","no-cache");      // HTTP 1.0
  response.setDateHeader("Expires", 0);      // prevents caching at proxy
%>
  
  <!-- /* setup variables used in this page */ -->
  <wf:getProperty property='portalName' id='portalName' type='String'/>
  <wf:getProperty property='gpPortalIDCurrent' id='portalIdStr' type='String'/>
  <wf:getProperty property='groupPortalObj' id='currentGroupPortal' type='com.bea.portal.model.GroupPortal'/>

  <i18n:getMessage messageName='disallowedCharactersWithSpace' id='disallowedCharacters' bundleName='tools'/>
  <vum:getDefaultProfileType id='defaultProfileType' portalName='<%=portalName%>'/>
<%
  String userName = request.getParameter("userName");
  String password = request.getParameter("password");
  String verifyPassword = request.getParameter("verifyPassword");
  String profileType = request.getParameter("profileType");
  if ( profileType != null && profileType.trim().length() == 0 ) profileType = null;
  String newUsers = request.getParameter("newUsers");
  String statusMsg = null;

  if(userName != null)
  {
    boolean validPasswords = true;
    if(password.equals(""))
    {
%>  <i18n:getMessage messageName='noPassword' id='tempStatusMsg'/>
<%
      statusMsg = tempStatusMsg;
      validPasswords = false;
    }
    else if(!password.equals(verifyPassword))
    {
%>    <i18n:getMessage messageName='unmatchingPassword' id='tempStatusMsg'/>
<%
      statusMsg = tempStatusMsg;
      validPasswords = false;
    }
    else 
    {
      for (int i=0;i<disallowedCharacters.length();i++)
      {
        if(password.indexOf( disallowedCharacters.charAt(i) ) != -1)
        {
          Object[] disChars = new Object[] { disallowedCharacters };
%>        <i18n:getMessage messageName='invalidCharPassword' id='tempStatusMsg' messageArgs='<%=disChars%>'/>
<%
          statusMsg = tempStatusMsg;
          validPasswords = false;
        }
      }
    }
    boolean validUserName = true;
    if(userName.equals(""))
    {
%>  <i18n:getMessage messageName='noUserName' id='tempStatusMsg'/>
<%
      statusMsg = tempStatusMsg;
      validUserName = false;
    }
    else 
    {
      for (int i=0;i<disallowedCharacters.length();i++)
      {
        if(userName.indexOf( disallowedCharacters.charAt(i) ) != -1)
        {
          Object[] disChars = new Object[] { disallowedCharacters };
%>
        <i18n:getMessage messageName='invalidCharUserName' id='tempStatusMsg' messageArgs='<%=disChars%>'/>
<%
          statusMsg = tempStatusMsg;
          validUserName = false;
        }
      }
    }

    if(validPasswords && validUserName)
    {
        try{
%>
           <vum:createUser userName='<%=userName%>' password='<%=password%>' profileType='<%=profileType%>' groupPortal='<%=currentGroupPortal%>'/>

<%
           if(newUsers == null || newUsers.equals(""))
           {
             newUsers = userName;
           }
           else
           {
             newUsers = newUsers + "," + userName;
           }      
        }
        catch( JspTagException exc ){
%>    
            <i18n:getMessage messageName='userAlreadyExists' id='tempStatusMsg'/>
<%       
         statusMsg = tempStatusMsg;
         pageContext.setAttribute("errorMessage", statusMsg);           
        }
    }
    else
    {
      pageContext.setAttribute("errorMessage", statusMsg);
    }
  }
  
  List newUsersList = null;
  String tempUserName = null;
  String tempNewUsers = newUsers;
  boolean endOfString = false;
  
  newUsersList = new ArrayList();
  while(!endOfString && newUsers != null)
  {
    if(tempNewUsers.indexOf(",") > 0)
    {
      tempUserName = tempNewUsers.substring( 0, tempNewUsers.indexOf(",") );
      newUsersList.add(tempUserName);
      tempNewUsers = tempNewUsers.substring( tempNewUsers.indexOf(",") + 1, tempNewUsers.length() ); 
    }
    else
    {
      newUsersList.add(tempNewUsers);
      endOfString = true;
    }
  }

%>
<%-- ------------------------------------------------------------ --%>
<%-- begin rendering                                              --%>
<%-- ------------------------------------------------------------ --%>
<HTML>
<HEAD>
  <TITLE><%=pageTitle%></TITLE>
  <LINK REL=StyleSheet HREF="<wf:createResourceURL resource='<%=cssFile%>'/>" TYPE="text/css" MEDIA=screen>
  
  <%-- ------------------------------------------------------------ --%>
  <%-- begin JavaScript setup                                       --%>
  <%-- ------------------------------------------------------------ --%>
   
  <SCRIPT LANGUAGE="JavaScript">
    <!-- Begin hide from old browsers
      function submit(userName)
      {
        document.forms["newUsersForm"].elements["userName"].value = userName;
        this.document.newUsersForm.submit();
      }
    // End hide from old browsers -->
  </SCRIPT>
  <%-- ------------------------------------------------------------ --%>
  <%-- end JavaScript setup                                         --%>
  <%-- ------------------------------------------------------------ --%>

</HEAD>
<BODY leftmargin="0" rightmargin="0" marginwidth="0" marginheight="0" STYLE='BACKGROUND-IMAGE:url("<wf:createResourceURL resource='<%=imagesPath + "bg_subpage.gif"%>'/>"); BACKGROUND-REPEAT: no-repeat; BACKGROUND-POSITION:left top;'>

<%@ include file="/tools/util/admin_header.inc"%>
<!-- end top nav bar -->

  <!-- This is the uber table that contains two table data cells: one for the left nav, the other for the main page layout -->
  <TABLE border="0" cellspacing="0" cellpadding="0" width="100%" height="100%">
    <TR>
      <TD width="1%" align="left" valign="top" class="sidenav">
        <!-- include  table for left nav bar -->
        <jsp:include page="left_navbar.jsp"/>
      </TD>

      <TD align="center" valign="top" width="2%">
        <!-- spacer cell -->
        &nbsp;&nbsp;
      </TD>

      <!-- begin table for main content area -->
      <TD align="left" valign="top">
        <% // Include the error message display logic %>
        <%@ include file="/tools/util/error_message.inc"%>

        <SPAN class="pageheader"><i18n:getMessage messageName='templateHeadLabel'/></SPAN>
        <BR>
        <SPAN class="instructions"><i18n:getMessage messageName='templateSubheadLabel'/></SPAN>
        <BR><BR>
<%      // number of labels in category listing header section
        int numberOfLabels = 1;
%>
        <TABLE cellspacing="0" cellpadding="0" border="0" width="1%">
          <TR>  
            <TD>
              <TABLE cellspacing="0" cellpadding="0" border="0" width="100%">
                <TR>  
                  <TD align="left" valign="top" rowspan="2">
                    <!-- category listing left hand side -->
                    <jsp:include page="category_list_header_lhs.jsp"/>
                  </TD>
      
                  <!-- It may seem strange to put a td width of 1000 in here, but after much trial and error this is the only way Netscape will maintain the fixed border widths along with the liquid, stretchable layout of the table -->
                  <TD class="categoryHeadingBorderCell" colspan="<%=numberOfLabels%>" height="1px" width="1000"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
      
                  <TD align="left" valign="top" rowspan="2">
                    <!-- category listing right hand side -->
                    <jsp:include page="category_list_header_rhs.jsp"/>
                  </TD>
                </TR>
      
                <TR>
                  <!-- * START LABELS -->
                  <TD class="categoryHeadingCell" nowrap width="100%">&nbsp;</TD>
                  <!-- * END LABELS -->
                </TR>
      
                <!-- This creates the dark green line at the bottom of the green header -->
                <TR>
                  <TD class="categoryHeadingBorderCell" colspan="<%=(numberOfLabels+2)%>" height="1"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
                </TR>
                <!-- START DETAIL ROW -->
                <TR>
                  <TD class="row">&nbsp;</TD>
                  <TD class="row" nowrap>&nbsp;</TD>
                </TR>
              
                <!-- BEGIN DETAIL ROW -->
                <TR>
                  <TD class="row">&nbsp;</TD>
                  <TD class="row">
                    <wf:form namespace="admin_portal"  event="link.refresh" origin="create_user.jsp" hide="true" method="post" name="MainForm">  
                      <TABLE>
                        <TR>    
                          <TD class="row">
                            <i18n:getMessage messageName='userName'/>
                          </TD>
                          <TD class="row">
                            <INPUT TYPE="TEXT" NAME="userName">
                          </TD>
                        </TR>
                        <TR>
                          <TD class="row">
                            <i18n:getMessage messageName='password'/>
                          </TD>
                          <TD class="row">
                            <INPUT TYPE="PASSWORD" NAME="password">
                          </TD>
                        </TR>
                        <TR>
                          <TD class="row">
                            <i18n:getMessage messageName='verifyPassword'/>
                          </TD>
                          <TD class="row">
                            <INPUT TYPE="PASSWORD" NAME="verifyPassword">
                          </TD>
                        </TR>
<%
                        String[] profileTypes = userBean.getUnifiedProfileTypes();
                        if ( profileTypes != null && profileTypes.length > 0 )
                        {
%>
                          <TR> 
                            <TD class="row">
                              User Type:
                            </TD>
                            <TD class="row">
                              <SELECT name="profileType">
                                <OPTION value="">User
<%
                                for ( int i=0; i<profileTypes.length; i++ )
                                {
%>
                                  <OPTION value="<%= profileTypes[i] %>" <%if(defaultProfileType.equals(profileTypes[i])){%>selected<%}%>><%= profileTypes[i] %>
<%
                                }
%>
                              </SELECT>
                            </TD>
                          </TR>
<%
                        }
%>
                        <!-- SPACER ROW -->
                        <TR>
                          <TD class="spacerRow" colspan="<%=(numberOfLabels+2)%>">&nbsp;</TD>
                        </TR>
                        <TR>
                          <TD class="spacerRow" colspan="<%=(numberOfLabels+2)%>">&nbsp;</TD>
                        </TR>
                        <TR>  
                          <TD class="row" align="left" valign="bottom" nowrap width="1%">
                            &nbsp;&nbsp;&nbsp;
                            <A HREF="<wf:createWebflowURL namespace='admin_portal' event='link.back'/>"><IMG src="<wf:createResourceURL resource='<%=imagesPath + "back.gif"%>'/>" border="0" align="bottom"></A>
                            &nbsp;&nbsp;&nbsp;&nbsp;
                            <INPUT type="image" src="<wf:createResourceURL resource='<%=imagesPath + "create.gif"%>'/>" border="0">
                          </TD>
                        </TR>
                      </TABLE>
                      <INPUT TYPE="HIDDEN" NAME="newUsers" VALUE="<%=newUsers%>">
                    </wf:form>
                  </TD>
                </TR>  
                <!-- END DETAIL ROW -->
      
                <TR>
                  <TD class="row">&nbsp;</TD>
                  <TD class="row" nowrap>&nbsp;</TD>
                </TR>
      
                <TR>
                  <TD class="spacerRow" colspan="<%=(numberOfLabels+2)%>">&nbsp;</TD>
                </TR>
                <TR>
                  <TD class="emptyRow" colspan="<%=(numberOfLabels+2)%>">&nbsp;</TD>
                </TR>
              </TABLE>
      
      
              
              <TABLE cellspacing="0" cellpadding="0" border="0" width="95%">
                <TR>  
                  <TD align="left" valign="top" rowspan="2">
                    <!-- category listing left hand side -->
                    <jsp:include page="category_list_header_lhs.jsp"/>
                  </TD>
      
                  <!-- It may seem strange to put a td width of 1000 in here, but after much trial and error this is the only way Netscape will maintain the fixed border widths along with the liquid, stretchable layout of the table -->
                  <TD class="categoryHeadingBorderCell" colspan="<%=numberOfLabels%>" height="1px" width="1000"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
      
                  <TD align="left" valign="top" rowspan="2">
                    <!-- category listing right hand side -->
                    <jsp:include page="category_list_header_rhs.jsp"/>
                  </TD>
                </TR>
      
                <TR>
                  <!-- * START LABELS -->
                  <TD class="categoryHeadingCell" nowrap width="100%">
                    <i18n:getMessage messageName='newUsers'/>
                  </TD>
                  <!-- * END LABELS -->
                </TR>
      
                <!-- This creates the dark green line at the bottom of the green header -->
                <TR>
                  <TD class="categoryHeadingBorderCell" colspan="<%=(numberOfLabels+2)%>" height="1"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
                </TR>
                <!-- START DETAIL ROW -->
                <TR>
                  <TD class="row">&nbsp;</TD>
                  <TD class="row" nowrap>&nbsp;</TD>
                </TR>
              
                <!-- BEGIN DETAIL ROW -->
                <TR>
                  <TD class="row">&nbsp;</TD>
                  <TD class="row" nowrap>
                    <i18n:getMessage messageName='editUsers'/>
                  </TD>
                </TR>  
                <!-- END DETAIL ROW -->
      
                <TR>
                  <TD class="spacerRow" colspan="<%=(numberOfLabels+2)%>">&nbsp;</TD>
                </TR>
                <%@ page import="java.util.List"%>
                <%@ page import="java.util.ArrayList"%>
                
                <TR>
                  <TD class="row">&nbsp;</TD>
                  <TD>
                    <TABLE cellspacing="0" cellpadding="2" border="0">  
<%
                String newUserName = null;
                String extraParams = null;
                if ( (newUsersList != null ) && ( newUsersList.size() != 0) )
                {
                  for(int userCount=0;userCount<newUsersList.size();userCount++)
                  {
                    newUserName = (String)newUsersList.get(userCount);
%>
                    <TR>
                      <TD class="row" nowrap>
                        <a href="javascript:submit('<%=newUserName%>')"><%=newUserName%></a>
                      </TD>
                    </TR>
<%              }
%>
                  <wf:form namespace="admin_portal"  event="link.edit_user_attributes" origin="create_user.jsp" hide="true" method="post" name="newUsersForm">  
                    <INPUT TYPE="HIDDEN" NAME="userName" VALUE="">
                    <INPUT TYPE="HIDDEN" NAME="newUsers" VALUE="<%=newUsers%>">
                  </wf:form>
<%
                }
                else
                {
%>
                  <TR>
                    <TD class="row" nowrap>
                      <i18n:getMessage messageName='noNewUsers'/>
                    </TD>
                  </TR>
<%              }
%>
                    </TABLE>
                  </TD>
                </TR>
                <TR>
                  <TD class="spacerRow" colspan="<%=(numberOfLabels+2)%>">&nbsp;</TD>
                </TR>
                <TR>
                  <TD class="emptyRow" colspan="<%=(numberOfLabels+2)%>">&nbsp;</TD>
                </TR>
              </TABLE>
            </TD>
          </TR>
        </TABLE>
      </TD>
      <!-- end content area -->

      <TD align="center" valign="top" width="2%">
        <!-- spacer cell -->
        &nbsp;&nbsp;
      </TD>
    </TR>
  </TABLE>

</BODY>
</HTML>
