<%-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. --%>
<%@ page extends="com.bea.jsptools.common.servlets.jsp.ToolsJspBase"%>

<%-- ------------------------------------------------------------ --%>
<%-- page imports                                                 --%>
<%-- ------------------------------------------------------------ --%>
<%@ page import="com.bea.portal.model.GroupPortal"%>
<%@ page import="com.bea.portal.model.LayoutIdentifier"%>
<%@ page import="com.bea.portal.model.LayoutDefinition"%>
<%@ page import="com.bea.portal.model.PortalIdentifier"%>
<%@ page import="com.bea.portal.jsp.JspConstants"%>

<%@ page import="com.bea.p13n.util.debug.Debug"%>

<%@ page errorPage="error.jsp" %>

<%-- ------------------------------------------------------------ --%>
<%-- taglibs                                                      --%>
<%-- ------------------------------------------------------------ --%>
<%@ taglib uri="res.tld" prefix="res" %>
<%@ taglib uri="webflow.tld" prefix="wf" %>
<%@ taglib uri="i18n.tld" prefix="i18n" %>
<%@ taglib uri="weblogic.tld" prefix="wl" %>

<%-- ------------------------------------------------------------ --%>
<%-- i18n (internationalization) and layout setup                 --%>
<%-- ------------------------------------------------------------ --%>

<%@ include file="/tools/portal/i18n_setup.inc"%>

<%
    Debug debug = Debug.getInstance( __layout_display_names.class );
%>

<i18n:getMessage messageName='pageTitle' id='pageTitle'/>

<%-- ------------------------------------------------------------ --%>
<%-- environment setup                                            --%>
<%-- ------------------------------------------------------------ --%>

<%-- ------------------------------------------------------------ --%>
<%-- DECLARE NavLocation VALUE                                    --%>
<%-- Used for the left_navbar highlighting                        --%>
<%-- ------------------------------------------------------------ --%>

  <wf:setProperty property='NavLocation' value='<%=JspConstants.PAGES_LAYOUTS_PORTLETS_NAV%>' scope='request'/>
 
<%-- Get the Default Group Portal Display name to use on the page --%>

  <i18n:getMessage id='defaultGroupPortalName' messageName='defaultGroupPortalDisplayName' bundleName='tools'/>

  <wf:getProperty property="portalName" id="portalName" type="String"/>
  <wf:getProperty property="groupPortalObj" id="currentGroupPortal" type="GroupPortal"/>
  <wf:getProperty property="isDefaultGroup" id="isDefaultGroup" type="String"/>
  
  <wf:getProperty property="doUpdate" id="testVar" type="String"/>
<%
  String groupPortalName = currentGroupPortal.getDisplayName();
  
  if(( isDefaultGroup != null ) && ( isDefaultGroup.equals("true") ))
  {
    groupPortalName = defaultGroupPortalName;
  }
  
%>
<res:getLayouts id="layoutList" portalId="<%=currentGroupPortal.getPortalIdentifier()%>"/>

<%-- ------------------------------------------------------------ --%>
<%-- form processing                                              --%>
<%-- ------------------------------------------------------------ --%>

<!-- If the 'save' button was clicked, go ahead and process the input. -->
<wl:process name="doUpdate" value="true">

<%
  String statusMsg = "";
  boolean blankDisplayName = false;
  //If there is only one input field, then the user can hit the 'Enter' key and submit the form.  By doing this
  // our javascript 'submitForm' function won't be called.  Therefore, we need to cover that case.
  if(layoutList.size() == 1)
  {
      String displayName = request.getParameter("field0");
      displayName = displayName.trim();
      if(displayName.equals(""))
      {
%>
        <i18n:getMessage id='tempStatusMsg' messageName='blankNameMessage'/>
<%
        blankDisplayName = true;
        statusMsg = tempStatusMsg;
      }
      else
      {
%>
        <res:setLayoutDisplayName groupId="<%=currentGroupPortal %>" layoutName="<%=((LayoutIdentifier)layoutList.get(0)).getName()%>" displayName="<%=displayName%>" />
<%
      }

  }
  else
  {
    // TODO JHH - List iterator tag would be cleaner
    for (int i=0; i<layoutList.size(); i++) 
    {      
        String displayName = request.getParameter("hidden" + i);
        if ( debug.ON )
        {
            debug.out("Display name "+displayName);
        }
%>
        <res:setLayoutDisplayName groupId="<%=currentGroupPortal %>" layoutName="<%=((LayoutIdentifier)layoutList.get(i)).getName()%>" displayName="<%=displayName%>" />
<%
    }
  }
  if(blankDisplayName) 
  {
    pageContext.setAttribute("errorMessage", statusMsg);
  }
  else
  {
%>
    <%-- The following form and associated javascript allow for the "page forward" on a successful save --%>  
<%
    //We only want to forward if there have been no generated errors within the tags
    String logId = (String)pageContext.getAttribute("logId");
    if(logId == null)
    {
%>
      <SCRIPT LANGUAGE="JavaScript">
        window.location.replace("<wf:createWebflowURL namespace="admin_portal" origin="layout_display_names.jsp" event="link.back"/>");
      </SCRIPT>
<%
    }
  }
%>
</wl:process>

<%-- ------------------------------------------------------------ --%>
<%-- begin rendering                                              --%>
<%-- ------------------------------------------------------------ --%>
<html>
<head>
  <title><%=pageTitle%></title>
  <LINK REL=StyleSheet HREF="<wf:createResourceURL resource='<%=cssFile%>'/>" TYPE="text/css" MEDIA="screen">

<script language="JavaScript">

function submitForm() {

  var size = document.forms[0].elements["numberOfLayouts"].value;
	var validDisplayNames = true;
  for (var i=0; i<size; i++) 
  {
     var test = document.forms[0].elements["field" + i].value;
     if(test == "")
     {
         validDisplayNames = false;
     }
     document.forms[0].elements["hidden" + i].value = document.forms[0].elements["field" + i].value;
	}

	if(validDisplayNames)
  {
      this.document.forms[0].submit();
      return true;
  }
  else
  {
      alert("<i18n:getMessage messageName='blankNameMessage'/>");
  }
}

</script>

</head>
<BODY leftmargin="0" rightmargin="0" marginwidth="0" marginheight="0" STYLE='BACKGROUND-IMAGE:url("<wf:createResourceURL resource='<%=imagesPath + "bg_subpage.gif"%>'/>"); BACKGROUND-REPEAT: no-repeat; BACKGROUND-POSITION:left top;'>

<%@ include file="/tools/util/admin_header.inc"%>

<!-- end top nav bar -->

<!-- This is the uber table that contains two table data cells: one for the left nav, the other for the main page layout -->
<TABLE border="0" cellspacing="0" cellpadding="0" width="100%" height="100%">
<TR><TD align="left" valign="top" class="sidenav" width="1%">
<!-- include  table for left nav bar -->
<jsp:include page="left_navbar.jsp"/>
</TD>

<TD align="center" valign="top" width="2%">
  <!-- spacer cell -->
  &nbsp;&nbsp;
</TD>

<!-- begin table for main content area -->
<TD align="left" valign="top">
    <%-- Include the error message display logic --%>
    <%@ include file="/tools/util/error_message.inc"%>

<%
    // Creation of message arguments
    Object[] args = new Object[] { cnvrtSC(portalName), cnvrtSC(groupPortalName) };
%>
  <span class="pageheader"><i18n:getMessage messageName='portalDisplay' messageArgs='<%=args%>'/></span><BR>
  <span class="instructions"><i18n:getMessage messageName='portalDisplaySubHead'/></span><BR><BR>

  <!-- start Webflow/Pipeline enabled FORM -->
  <wf:form namespace="admin_portal"  event="link.refresh" origin="layout_display_names.jsp" hide="true" method="post">

  <%
    // number of labels in category listing header section
    int numberOfLabels = 2;
  %>

  <TABLE cellspacing="0" cellpadding="0" border="0" width="70%">
        <TR>
          <TD align="left" valign="top" rowspan="2">
            <!-- category listing left hand side -->
            <jsp:include page="category_list_header_lhs.jsp"/>
          </TD>
    
          <!-- It may seem strange to put a td width of 1000 in here, but after much trial and error this is the only way Netscape will maintain the fixed border widths along with the liquid, stretchable layout of the table -->
          <TD class="categoryHeadingBorderCell" colspan="<%=numberOfLabels%>" height="1px" width="1000"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
    
          <TD align="left" valign="top" rowspan="2">
            <!-- category listing right hand side -->
            <jsp:include page="category_list_header_rhs.jsp"/>
          </TD>
        </TR>
    
     <TR>
        <!-- * START LABELS -->
        <TD class="categoryHeadingCell" align="center" nowrap width="50%"><i18n:getMessage messageName='layoutLabel'/></TD>
        <TD class="categoryHeadingCell" align="center" nowrap width="50%"><i18n:getMessage messageName='displayNameLabel'/></TD>
        <!-- * END LABELS -->
     </TR>

    <!-- This creates the dark green line at the bottom of the green header -->

    <TR>
        <TD class="categoryHeadingBorderCell" colspan="<%=(numberOfLabels+2)%>" height="1"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
    </TR>
    
    <TR>
      <TD colspan="<%=(numberOfLabels+2)%>" nowrap>
        <TABLE cellspacing="0" cellpadding="2" border="0" WIDTH="100%">
        <!-- Loop through selected layouts, create row with id, display name for each -->
<% 
          int count = layoutList.size();
          for (int i=0; i<count; i++) 
          {
              LayoutIdentifier thisLayout = (LayoutIdentifier)layoutList.get(i);
  
              String classFormat = null;
              if((i%2) == 0)
              {
                classFormat = "row1";
              }
              else
              {
                classFormat = "row2";
              }
%>
        
              <TR>
                <TD class="<%= classFormat%>" align="center" valign="middle">
                  <%= thisLayout.getName()%>
                </TD>
                <TD class="<%= classFormat%>" align="center" valign="middle">  
                  <% String fieldName = "field" + i; %>
                  <res:getLayoutDisplayName id="layoutDisplayName" groupId="<%=currentGroupPortal %>" layoutName="<%=thisLayout.getName()%>" />
                  <INPUT type="text" name="<%= fieldName %>" value="<%=layoutDisplayName%>" maxlength="254">
                </TD>
              </TR>
        
<%
          }
%>
        </TABLE>
      </TD>
    </TR>
    
    <TR>
      <TD class="emptyRow" colspan="<%=( ( (numberOfLabels+2) * 2) + 2)%>"></TD>
    </TR>

    <TR>
      <TD colspan="<%=(numberOfLabels+2)%>">
        <a href="<wf:createWebflowURL namespace="admin_portal" origin="layout_display_names.jsp" event="link.back"/>"><img src="<wf:createResourceURL resource='<%=imagesPath + "back.gif"%>'/>" border="0" alt="<i18n:getMessage messageName='backLabel'/>"></a>
        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
        <a href="javascript:submitForm();"><img src="<wf:createResourceURL resource='<%=imagesPath + "save.gif"%>'/>" border="0" alt="<i18n:getMessage messageName='saveLabel'/>"></a>

      </TD>

      <TD></TD>

      <TD></TD>

    </TR>

  </TABLE>
  
  <!-- Create a hidden field for each display name -->
  <%
        for (int i=0; i<count; i++) 
        {
            String hiddenId = "hidden" + i;
    %>
          <input type="hidden" name="<%= hiddenId%>" value="">
    <%  } %>

  <!-- HIDDEN ELEMENTS HERE -->
  <input type="hidden" name="doUpdate" value="true">
  <input type="hidden" name="viewScope" value="group">
  <input type="hidden" name="portalName" value="<%=portalName%>">
  <input type="hidden" name="userId" value="">
  <input type="hidden" name="numberOfLayouts" VALUE="<%= layoutList.size() %>">
  

  </wf:form>

</TD>
<!-- end content area -->

<TD align="center" valign="top" width="2%">
  <!-- spacer cell -->
</TD>

</TR>
</TABLE>

</BODY>
</HTML>

