<%-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. --%>
<%@ page extends="com.bea.jsptools.common.servlets.jsp.ToolsJspBase"%>

<%-- ------------------------------------------------------------ --%>
<%-- page imports                                                 --%>
<%-- ------------------------------------------------------------ --%>
<%@ page import="com.bea.portal.admin.DelegatedAdminConstants"%>
<%@ page import="com.bea.portal.model.GroupPortal"%>
<%@ page import="java.lang.Boolean"%>
<%@ page import="com.bea.portal.entitlement.resource.PortalAdminTaskResourceConstants"%>
<%@ page import="com.bea.portal.entitlement.resource.PortalEntitlementResourceConstants"%>

<%@ page errorPage="error.jsp" %>

<%-- ------------------------------------------------------------ --%>
<%-- taglibs                                                      --%>
<%-- ------------------------------------------------------------ --%>
<%@ taglib uri="webflow.tld" prefix="wf" %>
<%@ taglib uri="i18n.tld" prefix="i18n" %>
<%@ taglib uri="dam.tld" prefix="dam" %>
<%@ taglib uri="res.tld" prefix="res" %>

<%-- ------------------------------------------------------------ --%>
<%-- i18n (internationalization) and skin setup                   --%>
<%-- ------------------------------------------------------------ --%>

<%@ include file="/tools/portal/i18n_setup.inc"%>

<%  // Grab the html title string from the properties file %>
<i18n:getMessage messageName='pageTitle' id='pageTitle'/>


<%-- ------------------------------------------------------------ --%>
<%-- environment setup                                            --%>
<%-- ------------------------------------------------------------ --%>

<%-- Need to check if the realm is writable or not, then set a session variable --%>
<dam:isWritableRealm id='isWritableRealm' />
<wf:setProperty property='isWritableRealm' value='<%=isWritableRealm%>' />
  
<%-- Get the Default Group Portal Display name to use on the page --%>
<i18n:getMessage id='defaultGroupPortalName' messageName='defaultGroupPortalDisplayName' bundleName='tools'/>

<%
  /* setup variables used in this page */
  String pageEvent = request.getParameter("event");
  String isDefaultFalse = "false";
  String isDefaultTrue = "true";
  String portalIdStr = "";
  String userGroupID = "";
  String groupPortalGroupId = "";
  String groupPortalName = "";
  boolean defaultScope = false;
  GroupPortal currentGroupPortal = null;
%>
  <wf:getProperty property="portalName" id="portalName" type="String"/>
  <wf:getProperty property="isDefaultGroup" id="isDefaultGroup" type="String"/>
<%
  if ( pageEvent.equals("link.edit_group_portal") || pageEvent.equals("link.save_to_edit") )
  {
    // We came here from the home page or have changed session variables. Set up session variables
    portalName = request.getParameter("portalName");
    portalIdStr = request.getParameter("portalID");
    userGroupID = request.getParameter("userGroupID");
%>   
    <res:getGroupPortal id="tempCurrentGroupPortal" portalID="<%=portalIdStr%>" userGroupID="<%=userGroupID%>"/>
    <wf:setProperty property="portalName" value='<%=portalName%>' />
    <wf:setProperty property="portalId" value='<%=portalIdStr%>' />
    <wf:setProperty property='groupPortalObj' value='<%=tempCurrentGroupPortal%>'/>
<%  currentGroupPortal = tempCurrentGroupPortal;
    groupPortalGroupId = currentGroupPortal.getGroupIdentifier();
    groupPortalName = currentGroupPortal.getDisplayName();

    // Check to see if we're editing the Default Group Portal or not
    if ( currentGroupPortal.isDefault() )
    {
      defaultScope = true;
      groupPortalName = defaultGroupPortalName;
%>
      <wf:setProperty property='isDefaultGroup' value='<%=isDefaultTrue%>' />
<%  }
    else
    {
%>
      <wf:setProperty property='isDefaultGroup' value='<%=isDefaultFalse%>' />
<%  }

  } 
  else
  {
    // We've been here before and the session should be populated already
%>
    <wf:getProperty property="groupPortalObj" id="tempCurrentGroupPortal" type="com.bea.portal.model.GroupPortal"/>
<%  currentGroupPortal = tempCurrentGroupPortal;
    groupPortalName = currentGroupPortal.getDisplayName();
    if ( isDefaultGroup.equals("true") )
    {
      defaultScope = true;
      groupPortalName = defaultGroupPortalName;
    }
  }

  boolean canSkinsGrant;
  boolean canPortalPagesGrant;
  boolean canPortletsGrant;
  boolean canUsersGrant;
  boolean canUsersDelegate;
  boolean canSkinsDelegate;
  boolean canPortalPagesDelegate;
  boolean canPortletsDelegate;
  boolean canPortalPagesEntitle;
  boolean canPortletsEntitle;
  if(!defaultScope)
  {
%>
    <%-- Set up variables to know what to display to the user --%>
    <dam:isGroupAdminAccessAllowed id="tempUsersGrant" groupPortal="<%=currentGroupPortal%>" resourceType='<%=PortalAdminTaskResourceConstants.RESOURCE_TYPE%>' adminTask='<%= PortalAdminTaskResourceConstants.MANAGE_USERS %>' capabilityKey='<%=PortalAdminTaskResourceConstants.MANAGEABLE%>'  userName="<%=request.getRemoteUser()%>"/>
    <dam:isGroupAdminAccessAllowed id="tempUsersDelegate" groupPortal="<%=currentGroupPortal%>" resourceType='<%=PortalAdminTaskResourceConstants.RESOURCE_TYPE%>' adminTask='<%= PortalAdminTaskResourceConstants.DELEGATE_MANAGE_USERS %>' capabilityKey='<%=PortalAdminTaskResourceConstants.DELEGATEABLE%>' userName="<%=request.getRemoteUser()%>"/>
    <dam:isGroupAdminAccessAllowed id="tempPortalPagesGrant" groupPortal="<%=currentGroupPortal%>" resourceType='<%=PortalAdminTaskResourceConstants.RESOURCE_TYPE%>' adminTask='<%= PortalAdminTaskResourceConstants.MANAGE_PORTAL_PAGES %>' capabilityKey='<%=PortalAdminTaskResourceConstants.MANAGEABLE%>' userName="<%=request.getRemoteUser()%>"/>
    <dam:isGroupAdminAccessAllowed id="tempPortalPagesDelegate" groupPortal="<%=currentGroupPortal%>" resourceType='<%=PortalAdminTaskResourceConstants.RESOURCE_TYPE%>' adminTask='<%= PortalAdminTaskResourceConstants.DELEGATE_MANAGE_PORTAL_PAGES %>' capabilityKey='<%=PortalAdminTaskResourceConstants.DELEGATEABLE%>' userName="<%=request.getRemoteUser()%>"/>
    <dam:isGroupAdminAccessAllowed id="tempPortalPagesEntitle" groupPortal="<%=currentGroupPortal%>" resourceType='<%=PortalEntitlementResourceConstants.RESOURCE_TYPE%>' adminTask='<%= PortalEntitlementResourceConstants.ENTITLE_PORTAL_PAGES %>' capabilityKey='<%=PortalEntitlementResourceConstants.ENTITLEABLE%>' userName="<%=request.getRemoteUser()%>"/>
    <dam:isGroupAdminAccessAllowed id="tempPortletsGrant" groupPortal="<%=currentGroupPortal%>" resourceType='<%=PortalAdminTaskResourceConstants.RESOURCE_TYPE%>' adminTask='<%= PortalAdminTaskResourceConstants.MANAGE_PORTLETS %>' capabilityKey='<%=PortalAdminTaskResourceConstants.MANAGEABLE%>' userName="<%=request.getRemoteUser()%>"/>
    <dam:isGroupAdminAccessAllowed id="tempPortletsDelegate" groupPortal="<%=currentGroupPortal%>" resourceType='<%=PortalAdminTaskResourceConstants.RESOURCE_TYPE%>' adminTask='<%= PortalAdminTaskResourceConstants.DELEGATE_MANAGE_PORTLETS %>' capabilityKey='<%=PortalAdminTaskResourceConstants.DELEGATEABLE%>' userName="<%=request.getRemoteUser()%>"/>
    <dam:isGroupAdminAccessAllowed id="tempPortletsEntitle" groupPortal="<%=currentGroupPortal%>" resourceType='<%=PortalEntitlementResourceConstants.RESOURCE_TYPE%>' adminTask='<%=PortalEntitlementResourceConstants.ENTITLE_PORTLETS %>' capabilityKey='<%=PortalEntitlementResourceConstants.ENTITLEABLE%>' userName="<%=request.getRemoteUser()%>"/>
    <dam:isGroupAdminAccessAllowed id="tempSkinsGrant" groupPortal="<%=currentGroupPortal%>" resourceType='<%=PortalAdminTaskResourceConstants.RESOURCE_TYPE%>' adminTask='<%= PortalAdminTaskResourceConstants.MANAGE_SKINS %>' capabilityKey='<%=PortalAdminTaskResourceConstants.MANAGEABLE%>' userName="<%=request.getRemoteUser()%>"/>
    <dam:isGroupAdminAccessAllowed id="tempSkinsDelegate" groupPortal="<%=currentGroupPortal%>" resourceType='<%=PortalAdminTaskResourceConstants.RESOURCE_TYPE%>' adminTask='<%= PortalAdminTaskResourceConstants.DELEGATE_MANAGE_SKINS %>' capabilityKey='<%=PortalAdminTaskResourceConstants.DELEGATEABLE%>' userName="<%=request.getRemoteUser()%>"/>
<%
    //Convert Boolean objects into primatives
    canUsersGrant = tempUsersGrant.booleanValue();
    canUsersDelegate = tempUsersDelegate.booleanValue();
    canPortalPagesGrant = tempPortalPagesGrant.booleanValue();
    canPortalPagesDelegate = tempPortalPagesDelegate.booleanValue();
    canPortalPagesEntitle = tempPortalPagesEntitle.booleanValue();
    canPortletsGrant = tempPortletsGrant.booleanValue();
    canPortletsDelegate = tempPortletsDelegate.booleanValue();
    canPortletsEntitle = tempPortletsEntitle.booleanValue();
    canSkinsGrant = tempSkinsGrant.booleanValue();
    canSkinsDelegate = tempSkinsDelegate.booleanValue();
  }
  else
  {
%>
    <%-- Set up variables to know what to display to the user --%>
    <dam:isPortalAdminAccessAllowed id="tempUsersGrant" portalIdentifier="<%=currentGroupPortal.getPortalIdentifier()%>" resourceType='<%=PortalAdminTaskResourceConstants.RESOURCE_TYPE%>' adminTask='<%= PortalAdminTaskResourceConstants.MANAGE_USERS %>' capabilityKey='<%=PortalAdminTaskResourceConstants.MANAGEABLE%>'  userName="<%=request.getRemoteUser()%>"/>
    <dam:isPortalAdminAccessAllowed id="tempUsersDelegate" portalIdentifier="<%=currentGroupPortal.getPortalIdentifier()%>" resourceType='<%=PortalAdminTaskResourceConstants.RESOURCE_TYPE%>' adminTask='<%= PortalAdminTaskResourceConstants.DELEGATE_MANAGE_USERS %>' capabilityKey='<%=PortalAdminTaskResourceConstants.DELEGATEABLE%>' userName="<%=request.getRemoteUser()%>"/>
    <dam:isPortalAdminAccessAllowed id="tempPortalPagesGrant" portalIdentifier="<%=currentGroupPortal.getPortalIdentifier()%>" resourceType='<%=PortalAdminTaskResourceConstants.RESOURCE_TYPE%>' adminTask='<%= PortalAdminTaskResourceConstants.MANAGE_PORTAL_PAGES %>' capabilityKey='<%=PortalAdminTaskResourceConstants.MANAGEABLE%>' userName="<%=request.getRemoteUser()%>"/>
    <dam:isPortalAdminAccessAllowed id="tempPortalPagesDelegate" portalIdentifier="<%=currentGroupPortal.getPortalIdentifier()%>" resourceType='<%=PortalAdminTaskResourceConstants.RESOURCE_TYPE%>' adminTask='<%= PortalAdminTaskResourceConstants.DELEGATE_MANAGE_PORTAL_PAGES %>' capabilityKey='<%=PortalAdminTaskResourceConstants.DELEGATEABLE%>' userName="<%=request.getRemoteUser()%>"/>
    <dam:isPortalAdminAccessAllowed id="tempPortalPagesEntitle" portalIdentifier="<%=currentGroupPortal.getPortalIdentifier()%>" resourceType='<%=PortalEntitlementResourceConstants.RESOURCE_TYPE%>' adminTask='<%= PortalEntitlementResourceConstants.ENTITLE_PORTAL_PAGES %>' capabilityKey='<%=PortalEntitlementResourceConstants.ENTITLEABLE%>' userName="<%=request.getRemoteUser()%>"/>
    <dam:isPortalAdminAccessAllowed id="tempPortletsGrant" portalIdentifier="<%=currentGroupPortal.getPortalIdentifier()%>" resourceType='<%=PortalAdminTaskResourceConstants.RESOURCE_TYPE%>' adminTask='<%= PortalAdminTaskResourceConstants.MANAGE_PORTLETS %>' capabilityKey='<%=PortalAdminTaskResourceConstants.MANAGEABLE%>' userName="<%=request.getRemoteUser()%>"/>
    <dam:isPortalAdminAccessAllowed id="tempPortletsDelegate" portalIdentifier="<%=currentGroupPortal.getPortalIdentifier()%>" resourceType='<%=PortalAdminTaskResourceConstants.RESOURCE_TYPE%>' adminTask='<%= PortalAdminTaskResourceConstants.DELEGATE_MANAGE_PORTLETS %>' capabilityKey='<%=PortalAdminTaskResourceConstants.DELEGATEABLE%>' userName="<%=request.getRemoteUser()%>"/>
    <dam:isPortalAdminAccessAllowed id="tempPortletsEntitle" portalIdentifier="<%=currentGroupPortal.getPortalIdentifier()%>" resourceType='<%=PortalEntitlementResourceConstants.RESOURCE_TYPE%>' adminTask='<%=PortalEntitlementResourceConstants.ENTITLE_PORTLETS %>' capabilityKey='<%=PortalEntitlementResourceConstants.ENTITLEABLE%>' userName="<%=request.getRemoteUser()%>"/>
    <dam:isPortalAdminAccessAllowed id="tempSkinsGrant" portalIdentifier="<%=currentGroupPortal.getPortalIdentifier()%>" resourceType='<%=PortalAdminTaskResourceConstants.RESOURCE_TYPE%>' adminTask='<%= PortalAdminTaskResourceConstants.MANAGE_SKINS %>' capabilityKey='<%=PortalAdminTaskResourceConstants.MANAGEABLE%>' userName="<%=request.getRemoteUser()%>"/>
    <dam:isPortalAdminAccessAllowed id="tempSkinsDelegate" portalIdentifier="<%=currentGroupPortal.getPortalIdentifier()%>" resourceType='<%=PortalAdminTaskResourceConstants.RESOURCE_TYPE%>' adminTask='<%= PortalAdminTaskResourceConstants.DELEGATE_MANAGE_SKINS %>' capabilityKey='<%=PortalAdminTaskResourceConstants.DELEGATEABLE%>' userName="<%=request.getRemoteUser()%>"/>
<%  
    //Convert Boolean objects into primatives
    canUsersGrant = tempUsersGrant.booleanValue();
    canUsersDelegate = tempUsersDelegate.booleanValue();
    canPortalPagesGrant = tempPortalPagesGrant.booleanValue();
    canPortalPagesDelegate = tempPortalPagesDelegate.booleanValue();
    canPortalPagesEntitle = tempPortalPagesEntitle.booleanValue();
    canPortletsGrant = tempPortletsGrant.booleanValue();
    canPortletsDelegate = tempPortletsDelegate.booleanValue();
    canPortletsEntitle = tempPortletsEntitle.booleanValue();
    canSkinsGrant = tempSkinsGrant.booleanValue();
    canSkinsDelegate = tempSkinsDelegate.booleanValue();
  }
%>

<%-- ------------------------------------------------------------ --%>
<%-- begin rendering                                              --%>
<%-- ------------------------------------------------------------ --%>
<HTML>
<HEAD>
  <TITLE><%=pageTitle%></TITLE>
  <LINK REL=StyleSheet HREF="<wf:createResourceURL resource='<%=cssFile%>'/>" TYPE="text/css" MEDIA="screen">
</HEAD>
<BODY leftmargin="0" rightmargin="0" marginwidth="0" marginheight="0" STYLE='BACKGROUND-IMAGE:url("<wf:createResourceURL resource='<%=imagesPath + "bg_subpage.gif"%>'/>"); BACKGROUND-REPEAT: no-repeat; BACKGROUND-POSITION:left top;'>

<%@ include file="/tools/util/admin_header.inc"%>
<!-- end top nav bar -->

<!-- This is the uber table that contains two table data cells: one for the left nav, the other for the main page layout -->
  <TABLE border="0" cellspacing="0" cellpadding="0" width="100%" height="100%">
    <TR>
      <TD align="left" valign="top" class="sidenav" width="1%">
        <!-- include  table for left nav bar -->
        <jsp:include page="left_navbar.jsp"/>
      </TD>
      <TD align="center" valign="top" width="2%">
        <!-- spacer cell -->
      </TD>

      <!-- begin table for main content area -->
      <TD align="left" valign="top">
      <% // Include the error message display logic %>
      <%@ include file="/tools/util/error_message.inc"%>
      
<%
      // Creation of message arguments
      Object[] args = new Object[] { cnvrtSC(portalName), cnvrtSC(groupPortalName) };
%>
      <SPAN class="pageheader"><i18n:getMessage messageName='portalDisplay' messageArgs='<%=args%>'/></SPAN><BR>
      <SPAN class="instructions"><i18n:getMessage messageName='portalDisplaySubHead'/></SPAN>
      <BR><BR>

<%
      // number of labels in category listing header section
      int numberOfLabels = 1;
%>
      <TABLE cellspacing="0" cellpadding="0" border="0" width="50%">
      
      <dam:canAdministerPortal id="isPortalAdmin" portalIdentifier="<%=currentGroupPortal.getPortalIdentifier()%>"/>

      <!-- Begining of Appearance Box -->
<%    if(canSkinsGrant || canPortalPagesGrant || canPortletsGrant)
      {
%>
        <TR>
          <TD align="left" valign="top" rowspan="2">
            <!-- category listing left hand side -->
            <jsp:include page="category_list_header_lhs.jsp"/>
          </TD>
    
          <!-- It may seem strange to put a td width of 1000 in here, but after much trial and error this is the only way Netscape will maintain the fixed border widths along with the liquid, stretchable layout of the table -->
          <TD class="categoryHeadingBorderCell" colspan="<%=numberOfLabels%>" height="1px" width="1000"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
    
          <TD align="left" valign="top" rowspan="2">
            <!-- category listing right hand side -->
            <jsp:include page="category_list_header_rhs.jsp"/>
          </TD>
        </TR>

        <TR>
          <!-- * START LABELS -->
          <TD class="categoryHeadingCell" nowrap width="100%"><i18n:getMessage messageName='appearance'/>
          </TD>
          <!-- * END LABELS -->
        </TR>
    
        <!-- This creates the dark green line at the bottom of the green header -->
        <TR>
          <TD class="categoryHeadingBorderCell" colspan="<%=(numberOfLabels+2)%>" height="1"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
        </TR>
    
<%      if(canPortalPagesGrant || canPortletsGrant)
        {
%>
          <!-- Begining of Manage Pages -->
          <!-- START DETAIL ROW -->
          <TR>
            <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
              <TD>
                <TABLE border="0" cellspacing="0" cellpadding="2">          
                  <TR>
                    <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
                
                    <!-- * START DETAIL -->
                    <TD class="row" align="left" valign="middle" nowrap>
                      <IMG src="<wf:createResourceURL resource='<%=imagesPath + "manage_layouts.gif"%>'/>" border="0" hspace="5"><a class="standardbiglink" href="<wf:createWebflowURL namespace='admin_portal' event='link.manage_portal_pages'/>"><i18n:getMessage messageName='managePages'/></a>
                    </TD>
                    <!-- * END DETAIL -->
                
                    <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
                  </TR>
                  <!-- END DETAIL ROW -->
                  <!-- START DETAIL ROW -->
                  <TR>
                    <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
                    <!-- * START DETAIL -->
                    <TD class="row" align="left" valign="top">
                      <BLOCKQUOTE><SPAN class="listText"><i18n:getMessage messageName='managePagesText'/></SPAN></BLOCKQUOTE>
                    </TD>
                    <!-- * END DETAIL -->
                    <TD class="row">&nbsp;</TD>
                  </TR>
                </TABLE>
              </TD>      
            <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
          </TR>
          <!-- END DETAIL ROW -->
          <!-- End of Manage Pages -->
<%      }
%>
    
<%      if(canSkinsGrant)
        {
%>
          <!-- Begining of Select Skins -->
          <!-- START DETAIL ROW -->
          <TR>
            <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
              <TD>
                <TABLE border="0" cellspacing="0" cellpadding="2">          
                  <TR>
                    <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
                    <!-- * START DETAIL -->
                    <TD class="row" align="left" valign="top" nowrap>
                      <IMG src="<wf:createResourceURL resource='<%=imagesPath + "select_skins.gif"%>'/>" border="0" hspace="5"><a class="standardbiglink" href="<wf:createWebflowURL namespace='admin_portal' event='link.select_skins'/>"><i18n:getMessage messageName='selectSkins'/></a>
                    </TD>
                    <!-- * END DETAIL -->
                    <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
                  </TR>
                  <!-- END DETAIL ROW -->
                  <!-- START DETAIL ROW -->
                  <TR>
                    <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
                    <!-- * START DETAIL -->
                    <TD class="row" align="left" valign="top">
                      <BLOCKQUOTE><SPAN class="listText"><i18n:getMessage messageName='selectSkinsText'/></SPAN></BLOCKQUOTE>
                    </TD>
                    <!-- * END DETAIL -->
                    <TD class="row">&nbsp;</TD>
                  </TR>
                </TABLE>
              </TD>      
            <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
          </TR>
          <!-- END DETAIL ROW -->
          <!-- End of Select Skins -->
<%      }
%>

<%
          if(isPortalAdmin.booleanValue())
          {
%>
  		
            <!-- Begining of Group Portal Attributes -->
            <!-- START DETAIL ROW -->
          <TR>
            <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
              <TD>
                <TABLE border="0" cellspacing="0" cellpadding="2">          
                  <TR>
                    <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
                
                    <!-- * START DETAIL -->
                    <TD class="row" align="left" valign="top" nowrap>
                      <IMG src="<wf:createResourceURL resource='<%=imagesPath + "edit_user_groups.gif"%>'/>" border="0" hspace="5"><a class="standardbiglink" href="<wf:createWebflowURL namespace='admin_portal' event='link.edit_group_portal'/>"><i18n:getMessage messageName='editGroupPortal'/></a>
                    </TD>
                    <!-- * END DETAIL -->
                
                    <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
                  </TR>
                  <!-- END DETAIL ROW -->
                  <!-- START DETAIL ROW -->
                  <TR>
                    <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
                    <!-- * START DETAIL -->
                    <TD class="row" align="left" valign="top">
                      <BLOCKQUOTE><SPAN class="listText"><i18n:getMessage messageName='userGroupAssocText'/></SPAN></BLOCKQUOTE>
                    </TD>
                    <!-- * END DETAIL -->
                    <TD class="row">&nbsp;</TD>
                  </TR>
                </TABLE>
              </TD>      
            <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
          </TR>
            <!-- END DETAIL ROW -->
            <!-- End of Group Portal Attributes -->
  
<%    }
%>
        
        <TR>
          <TD class="spacerRow" colspan="<%=(numberOfLabels+2)%>"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
        </TR>
        <TR>
          <TD class="emptyRow" colspan="<%=(numberOfLabels+2)%>">&nbsp;</TD>
        </TR>
<%    }
%>
      <!-- End of Appearance Box -->
      
      <!-- Begining of User Group Box -->
<%
      // Don't show this section if we're editing the default group portal nor if admin can't do user mgmt
      if (!defaultScope && canUsersGrant)
      {
%>
        <TR>
          <TD align="left" valign="top" rowspan="2">
            <!-- category listing left hand side -->
            <jsp:include page="category_list_header_lhs.jsp"/>
          </TD>
      
          <!-- It may seem strange to put a td width of 1000 in here, but after much trial and error this is the only way Netscape will maintain the fixed border widths along with the liquid, stretchable layout of the table -->
          <TD class="categoryHeadingBorderCell" colspan="<%=numberOfLabels%>" height="1px" width="1000"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
      
          <TD align="left" valign="top" rowspan="2">
            <!-- category listing right hand side -->
            <jsp:include page="category_list_header_rhs.jsp"/>
          </TD>
        </TR>
      
        <TR>
          <!-- * START LABELS -->
          <TD class="categoryHeadingCell" nowrap width="100%">
            <i18n:getMessage messageName='usersAndGroupHeader'/>
          </TD>
            <!-- * END LABELS -->
        </TR>
      
        <!-- This creates the dark green line at the bottom of the green header -->
        <TR>
          <TD class="categoryHeadingBorderCell" colspan="<%=(numberOfLabels+2)%>" height="1"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
        </TR>
      
        <!-- START DETAIL ROW -->
        <TR>
          <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
            <TD>
              <TABLE border="0" cellspacing="0" cellpadding="2">          
                <TR>
                  <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
                  <!-- * START DETAIL -->
                  <TD class="row" align="left" valign="top" nowrap>
                      <IMG src="<wf:createResourceURL resource='<%=imagesPath + "users.gif"%>'/>" border="0" hspace="5">
                      <A class="standardbiglink" HREF="<wf:createWebflowURL namespace='admin_portal' event='link.choose_user'/>"><i18n:getMessage messageName='editUsers'/></A>
                  </TD>
                  <!-- * END DETAIL -->
              
                  <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
                </TR>
                <!-- END DETAIL ROW -->
                <!-- START DETAIL ROW -->
                <TR>
                  <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
                  <!-- * START DETAIL -->
                  <TD class="row" align="left" valign="top">
                    <BLOCKQUOTE><SPAN class="listText"><i18n:getMessage messageName='editUsersText'/></SPAN></BLOCKQUOTE>
                  </TD>
                  <!-- * END DETAIL -->
                  <TD class="row">&nbsp;</TD>
                </TR>
              </TABLE>
            </TD>      
          <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
        </TR>
        <!-- END DETAIL ROW -->

        <!-- START DETAIL ROW -->
        <TR>
          <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
            <TD>
              <TABLE border="0" cellspacing="0" cellpadding="2">          
                <TR>
                  <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
                  <!-- * START DETAIL -->
                  <TD class="row" align="left" valign="top" nowrap>
                      <IMG src="<wf:createResourceURL resource='<%=imagesPath + "user_group.gif"%>'/>" border="0" hspace="5">
                      <A class="standardbiglink" HREF="<wf:createWebflowURL namespace='admin_portal' event='link.edit_user_group'/>"><i18n:getMessage messageName='editGroup'/></A>
                  </TD>
                  <!-- * END DETAIL -->
              
                  <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
                </TR>
                <!-- END DETAIL ROW -->
                <!-- START DETAIL ROW -->
                <TR>
                  <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
                  <!-- * START DETAIL -->
                  <TD class="row" align="left" valign="top">
                    <BLOCKQUOTE><SPAN class="listText"><i18n:getMessage messageName='editGroupText'/></SPAN></BLOCKQUOTE>
                  </TD>
                  <!-- * END DETAIL -->
                  <TD class="row">&nbsp;</TD>
                </TR>
              </TABLE>
            </TD>      
          <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
        </TR>
        <!-- END DETAIL ROW -->

        <TR>
          <TD class="spacerRow" colspan="<%=(numberOfLabels+2)%>"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
        </TR>
        <TR>
          <TD class="emptyRow" colspan="<%=(numberOfLabels+2)%>">&nbsp;</TD>
        </TR>
<%    }
%>
      <!-- End of User Group Box -->
  
      <!-- Begining of Delegated Admin Box -->
<%    if((canUsersDelegate || canSkinsDelegate || canPortalPagesDelegate || canPortletsDelegate) && !defaultScope)
      {
%>        
        <TR>
          <TD align="left" valign="top" rowspan="2">
            <!-- category listing left hand side -->
            <jsp:include page="category_list_header_lhs.jsp"/>
          </TD>
      
          <!-- It may seem strange to put a td width of 1000 in here, but after much trial and error this is the only way Netscape will maintain the fixed border widths along with the liquid, stretchable layout of the table -->
          <TD class="categoryHeadingBorderCell" colspan="<%=numberOfLabels%>" height="1px" width="1000"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
      
          <TD align="left" valign="top" rowspan="2">
            <!-- category listing right hand side -->
            <jsp:include page="category_list_header_rhs.jsp"/>
          </TD>
        </TR>
      
        <TR>
          <!-- * START LABELS -->
          <TD class="categoryHeadingCell" nowrap width="100%">
            <i18n:getMessage messageName='delegatedAdmin'/>
          </TD>
            <!-- * END LABELS -->
        </TR>
      
        <!-- This creates the dark green line at the bottom of the green header -->
        <TR>
          <TD class="categoryHeadingBorderCell" colspan="<%=(numberOfLabels+2)%>" height="1"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
        </TR>
      
        <!-- START DETAIL ROW -->
        <TR>
          <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
            <TD>
              <TABLE border="0" cellspacing="0" cellpadding="2">          
                <TR>
                  <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
              
                  <!-- * START DETAIL -->
                  <TD class="row" align="left" valign="top" nowrap>
                    <IMG src="<wf:createResourceURL resource='<%=imagesPath + "edit_delegated.gif"%>'/>" border="0" hspace="5">
                    <a class="standardbiglink" href="<wf:createWebflowURL namespace='admin_portal' event='link.browse_admin_edit'/>"><i18n:getMessage messageName='editDelAdminGA'/></a>
                  </TD>
                  <!-- * END DETAIL -->
              
                  <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
                </TR>
                <!-- END DETAIL ROW -->
                <!-- START DETAIL ROW -->
                <TR>
                  <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
                  <!-- * START DETAIL -->
                  <TD class="row" align="left" valign="top">
                    <BLOCKQUOTE><SPAN class="listText"><i18n:getMessage messageName='delegatedAdminText'/></SPAN></BLOCKQUOTE>
                  </TD>
                  <!-- * END DETAIL -->
                  <TD class="row">&nbsp;</TD>
                </TR>
              </TABLE>
            </TD>      
          <TD class="row"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
        </TR>
        <!-- END DETAIL ROW -->
      
        <TR>
          <TD class="spacerRow" colspan="<%=(numberOfLabels+2)%>"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
        </TR>
        <TR>
          <TD class="emptyRow" colspan="<%=(numberOfLabels+2)%>">&nbsp;</TD>
        </TR>
<%    }
%>
      <!-- End of Delegated Admin Box -->
  
    </TABLE>
  
    </TD>
    <!-- end content area -->
  
    <!-- spacer cell -->
    <TD align="center" valign="top" width="2%"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
  
  </TR>
  </TABLE>

</BODY>
</HTML>
