<%-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. --%>
<%@ page extends="com.bea.jsptools.common.servlets.jsp.ToolsJspBase"%>

<%-- ------------------------------------------------------------ --%>
<%-- page imports                                                 --%>
<%-- ------------------------------------------------------------ --%>
<%@ page import="com.bea.portal.model.GroupPortal"%>
<%@ page import="com.bea.portal.model.PortalIdentifier"%>
<%@ page import="com.bea.portal.entitlement.resource.PortalAdminTaskResourceConstants"%>
<%@ page import="java.lang.Integer"%>

<%@ page errorPage="error.jsp" %>

<%-- ------------------------------------------------------------ --%>
<%-- taglibs                                                      --%>
<%-- ------------------------------------------------------------ --%>
<%@ taglib uri="webflow.tld" prefix="wf" %>
<%@ taglib uri="i18n.tld" prefix="i18n" %>
<%@ taglib uri="dam.tld" prefix="dam" %>
<%@ taglib uri="res.tld" prefix="res" %>
                     
<%-- ------------------------------------------------------------ --%>
<%-- i18n (internationalization) and skin setup                   --%>
<%-- ------------------------------------------------------------ --%>

<%@ include file="/tools/portal/i18n_setup.inc"%>

<%--   Grab the html title string from the properties file --%>
<i18n:getMessage messageName='pageTitle' id='pageTitle'/>

<%-- ------------------------------------------------------------ --%>
<%-- environment setup                                            --%>
<%-- ------------------------------------------------------------ --%>
<%
  Object[] args = new Object[] { null };
  // Make this page uncacheable so that session variables can be cleared.
  response.setHeader("Cache-Control","no-cache");  // HTTP 1.1
  response.setHeader("Pragma","no-cache");      // HTTP 1.0
  response.setDateHeader("Expires", 0);      // prevents caching at proxy

  // Some access is limited to Portal Administrators. Set a boolean var for later use.
  boolean bPortalAdmin = false;
    
  // Get the list of deployed portal apps that this user is allowed to see
%>  
  <res:getPortals id="portals"/>
<%PortalIdentifier portalId = null;

  // Clear out Pipeline Session variables
  String emptyString = "";
%>  
  <wf:setProperty namespace="admin_portal" property='portalName' value='<%=emptyString%>' />
    
<%
  //Cover the case if we're submitting to ourself (in the case of a group portal delete
  String deleteUserGroupID = request.getParameter("userGroupID");
  String portalIDStr = request.getParameter("portalID");
  if(deleteUserGroupID != null && portalIDStr != null)
  {
%>
  <res:removeGroupPortal userGroupID="<%=deleteUserGroupID%>" portalID="<%=portalIDStr%>"/>
<%
  }
%>

<i18n:getMessage messageName='groupPortalDisplayLimit' id='groupPortalDisplayLimit' bundleName='tools'/>
<%
  //This is used for the number of group portals to display before the 'More' link is shown
  int GROUP_PORTAL_DISPLAY_LIMIT = Integer.parseInt(groupPortalDisplayLimit.trim());

  //Set these up for use in determining weither or not to shoe the edit portal admins link
  boolean canUsersDelegate = false;
  boolean canPortalPagesDelegate = false;
  boolean canPortletsDelegate = false;
  boolean canSkinsDelegate = false;
%>

<%-- ------------------------------------------------------------ --%>
<%-- begin rendering                                              --%>
<%-- ------------------------------------------------------------ --%>
<HTML>
<HEAD>
  <TITLE><%=pageTitle%></TITLE>
  <LINK REL=StyleSheet HREF="<wf:createResourceURL resource='<%=cssFile%>'/>" TYPE="text/css" MEDIA=screen>

  <%-- ------------------------------------------------------------ --%>
  <%-- begin JavaScript setup                                       --%>
  <%-- ------------------------------------------------------------ --%>

  <SCRIPT LANGUAGE="JavaScript">
    <!-- Begin hide from old browsers
    function deleteConfirmation(confirmDelete, formNumber) 
    {
      if(confirm(confirmDelete))
      {
         document.forms[formNumber].submit();
      }
    }

    // End hide from old browsers -->
  </SCRIPT>

  <%-- ------------------------------------------------------------ --%>
  <%-- end JavaScript setup                                         --%>
  <%-- ------------------------------------------------------------ --%>

</HEAD>
<BODY leftmargin="0" rightmargin="0" marginwidth="0" marginheight="0" STYLE='BACKGROUND-IMAGE:url("<wf:createResourceURL resource='<%=imagesPath + "bg.gif"%>'/>"); BACKGROUND-REPEAT: no-repeat; BACKGROUND-POSITION:left top;'>

<%@ include file="/tools/util/admin_header.inc"%>
<!-- end top nav bar -->

<!-- This is the uber table that contains two table data cells: one for the left nav, the other for the main page layout -->
  <TABLE border="0" cellspacing="0" cellpadding="0" width="100%" height="100%">
    <TR>
      <TD width="1%" align="left" valign="top" class="sidenav">
        <!-- include  table for left nav bar -->
        <jsp:include page="left_navbar_home.jsp"/>
      </TD>

      <TD align="center" valign="top" width="2%">
        <!-- spacer cell -->
        &nbsp;&nbsp;
      </TD>

      <!-- begin table for main content area -->
      <TD align="left" valign="top">
        <% // Include the error message display logic %>
        <%@ include file="/tools/util/error_message.inc"%>

        <SPAN class="pageheader"><i18n:getMessage messageName='availablePortals'/></SPAN>
        <BR>
    
<%  
        //Need to find out if the user is a portal admin for any of their associated portals.
        // To do this, we must iterate through each portal and check if they're a PA
        for(int counter=0;counter<portals.size();counter++)
        {
          portalId = (PortalIdentifier)portals.get(counter);
%>
          <dam:canAdministerPortal id="isPortalAdmin" portalIdentifier="<%=portalId%>"/>
<%
          if(isPortalAdmin.booleanValue())
          {
            bPortalAdmin =  true;
          }
        }
        if (bPortalAdmin)
        {
           // Creation of message arguments
%>
		   <wf:createResourceURL resource='<%=imagesPath + "delete.gif"%>' id='trashIcon'/>
<%
           args = new Object[] { trashIcon };
%>
          <SPAN class="instructions"><i18n:getMessage messageName='choosePortalForPA' messageArgs='<%=args%>'/></SPAN>
<%      }
        else
        {
%>      
          <SPAN class="instructions"><i18n:getMessage messageName='choosePortalForGA'/></SPAN>
<%      }
%>
        <BR><BR>
		
        <TABLE cellspacing="0" cellpadding="0" border="0" width="100%">
          <%--  This is a hack.  It was put in for the javascript submit form.  If there is only one form on
                the page, the numbering won't work.
          --%>
          <wf:form namespace="admin_portal" event="link.portal_home" origin="portal_home.jsp" hide="true" method="post" name="DeleteForm">
          </wf:form>				
<%
        // number of labels in category listing header section
        int numberOfLabels = 2;

        //We want to keep a counter of the group portals we display.  We use this for the delete form
        int groupPortalDisplayed = 0;

        //This is the overall counter for group portals displayed on the page, not for individual portals.
        for(int i=0;i<portals.size();i++)
        {
          portalId = (PortalIdentifier)portals.get(i);
%>
          <res:getGroupPortals id="groupPortals" portalIdentifier="<%=portalId%>"/>
          <res:getPortalDisplayName id="portalNameStr" portalIdentifier="<%=portalId%>"/>
          <dam:canAdministerPortal id="canCallerAdminister" portalIdentifier="<%=portalId%>"/>
<%
          bPortalAdmin =  canCallerAdminister.booleanValue();
          String portalParams = "portalName=" + portalNameStr + "&portalID=" + portalId.getId();

          //Need to create new list that we can modify
          List groupPortalsModifiable = new ArrayList(groupPortals);
 
          GroupPortal defaultGroupPortal = null;
          String defaultGroupParams = null;
          
          for(int j=0;j<groupPortalsModifiable.size();j++)
          {
            if(((GroupPortal)groupPortalsModifiable.get(j)).isDefault())
            {
              defaultGroupParams = portalParams + "&userGroupID=" + ((GroupPortal)groupPortalsModifiable.get(j)).getGroupIdentifier();
              defaultGroupPortal = (GroupPortal)groupPortalsModifiable.get(j);
              groupPortalsModifiable.remove(j);
              j=j-1;
            }
          }
%>
            <TR>
              <TD align="left" valign="top" rowspan="2">
                <!-- category listing left hand side -->
                <jsp:include page="category_list_header_lhs.jsp"/>
              </TD>

              <!-- It may seem strange to put a td width of 1000 in here, but after much trial and error this is the only way Netscape will maintain the fixed border widths along with the liquid, stretchable layout of the table -->
              <TD class="categoryHeadingBorderCell" colspan="<%=numberOfLabels%>" height="1px" width="1000"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>

              <TD align="left" valign="top" rowspan="2">
                <!-- category listing right hand side -->
                <jsp:include page="category_list_header_rhs.jsp"/>
              </TD>
            </TR>
  
            <TR>
              <!-- * START LABELS -->
              <TD class="categoryHeadingCell" colspan="<%=numberOfLabels%>" nowrap width=100%>
              <!-- START TABLE to make the links align -->
			        <TABLE cellspacing="0" cellpadding="0" border="0" width="100%">
               <tr>
                <td class="categoryHeadingCell" nowrap>
                  <%=cnvrtSC(portalNameStr)%>
                </td>
<%                
              if(bPortalAdmin)
              {
				String params = "portalName=" + portalNameStr + "&portalID="+portalId.getId()+"&userGroupID="+defaultGroupPortal.getGroupIdentifier();
%>
				<td align="right" nowrap>
<%
                    //We only want to show the edit portal admins link if the admin has delegate privledges
%>
                    <dam:isPortalAdminAccessAllowed id="tempUsersDelegate" portalIdentifier="<%=portalId%>" resourceType='<%=PortalAdminTaskResourceConstants.RESOURCE_TYPE%>' adminTask='<%= PortalAdminTaskResourceConstants.DELEGATE_MANAGE_USERS %>' capabilityKey='<%=PortalAdminTaskResourceConstants.DELEGATEABLE%>' userName="<%=request.getRemoteUser()%>"/>
                    <dam:isPortalAdminAccessAllowed id="tempPortalPagesDelegate" portalIdentifier="<%=portalId%>" resourceType='<%=PortalAdminTaskResourceConstants.RESOURCE_TYPE%>' adminTask='<%= PortalAdminTaskResourceConstants.DELEGATE_MANAGE_PORTAL_PAGES %>' capabilityKey='<%=PortalAdminTaskResourceConstants.DELEGATEABLE%>' userName="<%=request.getRemoteUser()%>"/>
                    <dam:isPortalAdminAccessAllowed id="tempPortletsDelegate" portalIdentifier="<%=portalId%>" resourceType='<%=PortalAdminTaskResourceConstants.RESOURCE_TYPE%>' adminTask='<%= PortalAdminTaskResourceConstants.DELEGATE_MANAGE_PORTLETS %>' capabilityKey='<%=PortalAdminTaskResourceConstants.DELEGATEABLE%>' userName="<%=request.getRemoteUser()%>"/>
                    <dam:isPortalAdminAccessAllowed id="tempSkinsDelegate" portalIdentifier="<%=portalId%>" resourceType='<%=PortalAdminTaskResourceConstants.RESOURCE_TYPE%>' adminTask='<%= PortalAdminTaskResourceConstants.DELEGATE_MANAGE_SKINS %>' capabilityKey='<%=PortalAdminTaskResourceConstants.DELEGATEABLE%>' userName="<%=request.getRemoteUser()%>"/>
<%  
                    //Convert Boolean objects into primatives
                    canUsersDelegate = tempUsersDelegate.booleanValue();
                    canPortalPagesDelegate = tempPortalPagesDelegate.booleanValue();
                    canPortletsDelegate = tempPortletsDelegate.booleanValue();
                    canSkinsDelegate = tempSkinsDelegate.booleanValue();
                    if(canUsersDelegate || canPortalPagesDelegate || canPortletsDelegate || canSkinsDelegate)
                    {
%>                  
                      <IMG src="<wf:createResourceURL resource='<%=imagesPath + "edit_delegated.gif"%>'/>" border="0">&nbsp;<a class="standardlink" href="<wf:createWebflowURL namespace='admin_portal' event='link.edit_portal_admin' extraParams='<%=params%>'/>"><i18n:getMessage messageName='editPortalAdmins'/></a>
                      &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<%                  }
%>
                    <!-- * Create New Portal -->
                    <IMG src="<wf:createResourceURL resource='<%=imagesPath + "create_new_ug.gif"%>'/>" alt="<i18n:getMessage messageName='createNewGroupPortal'/>" border="0" align="top">&nbsp;<a class="standardlink" href="<wf:createWebflowURL namespace='admin_portal' event='link.new_group_portal' extraParams='<%=portalParams%>'/>"><i18n:getMessage messageName='createNewGroupPortal'/></a>
                  </td>  
<%              }
%>
				        </tr>
              </table>
              <!-- END TABLE to make the links align -->
				
              </TD>
              <!-- * END LABELS -->
            </TR>
  
            <!-- This creates the dark green line at the bottom of the green header -->
            <TR>
              <TD class="categoryHeadingBorderCell" colspan="<%=(numberOfLabels+2)%>" height="1"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
            </TR>
			
<%          //Only show the default group portal to portal admins
            if(bPortalAdmin)
            {
				String params = "portalName=" + portalNameStr + "&portalID="+portalId.getId()+"&userGroupID="+defaultGroupPortal.getGroupIdentifier();
                args = new Object[] { cnvrtSC(defaultGroupPortal.getDisplayName()), cnvrtSC(defaultGroupPortal.getGroupIdentifier()) };
%>
            <!-- START DETAIL ROW -->
            <TR>
              <TD class="row">&nbsp;</TD>
  
              <!-- * START DETAIL -->
              <TD colspan="<%=numberOfLabels%>" class="row" align="left" valign="top">
                  <!-- * Default Group Portal -->
				<span class="instructions">  
                  <i18n:getMessage messageName='defaultGroupPortal' messageArgs='<%=args%>'/>
                </span>  
                <br>
              </TD>
              <!-- * END DETAIL -->
  
              <TD class="row">&nbsp;</TD>
            </TR>
            <!-- END DETAIL ROW -->

            <!-- START DETAIL ROW -->
            <TR>
                <TD class="row">&nbsp;</TD>
  
                <!-- * START DETAIL -->
                <TD colspan="<%=numberOfLabels%>" class="row" align="left" valign="top">
                
          			<!-- START table to make the group portals align -->
          			<TABLE cellspacing="0" cellpadding="2" border="0" width="100%">
            			<TR>
              				<TD width="100%" nowrap>&nbsp;&nbsp;
                               <a class="standardlink" href="<wf:createWebflowURL namespace='admin_portal' event='link.edit_group_portal' extraParams='<%=params%>'/>"><i18n:getMessage messageName='groupPortalDisplay' messageArgs='<%=args%>'/></a><br>&nbsp;
							 </TD>
						</TR>
					</TABLE>
              </TD>
              <!-- * END DETAIL -->
  
              <TD class="row">&nbsp;</TD>
            </TR>
            <!-- END DETAIL ROW -->
			
<%          }

            //Now, we want to sort the list and get the language so we can internationalize the sort.  This info 
            //  got set when we called <i18n:localize/>
            String language = (String)pageContext.findAttribute("LANGUAGE");
            //Need to pass in a language to the sort tag, so default to english
            if(language == null || language.compareTo("") == 0)
            {
              language = "en";
            }
%>
            <res:groupPortalListI18nSort id="groupPortalsLargeSorted" 
                                        groupPortalList="<%=groupPortalsModifiable%>" 
                                        language="<%=language%>"
            />
<%
            String sUserGroupId = null;
            String sGroupPortalName = null;
            String groupParams = null;
            //The second loop outputs the rest of the group portals to the list.
            //Only display a few group portals, then show the "more..." link if necessary.
            int kLimit = groupPortalsLargeSorted.size();
            boolean showMore = false;
  
            if ( kLimit>GROUP_PORTAL_DISPLAY_LIMIT )
            {
              kLimit = GROUP_PORTAL_DISPLAY_LIMIT;
              showMore = true;
            }
			
			// Creation of message arguments
            args = new Object[] { portalNameStr };
			
			// Only show the label for other group portals if some exist
            if ( groupPortalsModifiable.size() > 0)
			{
%>
            <!-- START DETAIL ROW -->
            <TR>
              <TD class="row">&nbsp;</TD>
  
              <!-- * START DETAIL -->
              <TD colspan="<%=numberOfLabels%>" class="row" align="left" valign="top">
                <span class="instructions">
<%               if (bPortalAdmin)
                 {
%>                  <i18n:getMessage messageName='otherGroupPortals' messageArgs='<%=args%>'/>
<%               } else {
%>                  <i18n:getMessage messageName='availableGroupPortals' messageArgs='<%=args%>'/>
<%               }
%>
                </span>  
                <br>
              </TD>
              <!-- * END DETAIL -->
  
              <TD class="row">&nbsp;</TD>
            </TR>
            <!-- END DETAIL ROW -->
<%			}
			
            for(int k=0;k<kLimit;k++)
            {
              sUserGroupId = ((GroupPortal)groupPortalsLargeSorted.get(k)).getGroupIdentifier();
              sGroupPortalName = ((GroupPortal)groupPortalsLargeSorted.get(k)).getDisplayName();
              groupParams = portalParams + "&userGroupID=" + sUserGroupId;
			  args = new Object[] { cnvrtSC(sGroupPortalName), cnvrtSC(sUserGroupId) };
%>
              <!-- START DETAIL ROW -->
              <TR>
                <TD class="row">&nbsp;</TD>
  
                <!-- * START DETAIL -->
                <TD colspan="<%=numberOfLabels%>" class="row" align="left" valign="top">
                
          				<!-- START table to make the trashcans align -->
          				<TABLE cellspacing="0" cellpadding="2" border="0" width="100%">
            				<tr>
              				<td width="50%" nowrap>&nbsp;&nbsp;
                        <a class="standardlink" href="<wf:createWebflowURL namespace='admin_portal' event='link.edit_group_portal' extraParams='<%=groupParams%>'/>">
                          <i18n:getMessage messageName='groupPortalDisplay' messageArgs='<%=args%>'/>                  
                        </a> 
              				</td>
              				<td width="50%">
              				  <wf:form namespace="admin_portal" event="link.portal_home" origin="portal_home.jsp" hide="true" method="post" name="DeleteForm">
                          <INPUT TYPE="HIDDEN" NAME="userGroupID" VALUE="<%=sUserGroupId%>">
                          <INPUT TYPE="HIDDEN" NAME="portalName" VALUE="<%=portalNameStr%>">
                          <INPUT TYPE="HIDDEN" NAME="portalID" VALUE="<%=portalId.getId()%>">
              				  </wf:form>				
<%        
                        //Increment the group portal count for the page
                        groupPortalDisplayed = groupPortalDisplayed + 1;
                        // Only show the delete icon for Portal Adminstrators
                        if(bPortalAdmin)
                        {
%>
                          &nbsp;&nbsp;&nbsp;&nbsp;
                          <i18n:getMessage id="confirmDelete" messageName='confirmDelete' messageArgs="<%=new Object[] {cnvrtSC(sGroupPortalName)}%>"/>
                          <a HREF="javascript:deleteConfirmation('<%=confirmDelete%>', <%=groupPortalDisplayed%>)"><img src="<wf:createResourceURL resource='<%=imagesPath + "delete.gif"%>'/>" alt="<i18n:getMessage messageName='altForDeleteGif'/>" border="0"></a>
<%
                        }
%>
                        &nbsp;&nbsp;&nbsp;
				              </td>
                    </tr>
                  </table>  
				          <!-- End table to make the trashcans align -->
				                
 
                </TD>
                <!-- * END DETAIL -->
  
                <TD class="row">&nbsp;</TD>
              </TR>
              <!-- END DETAIL ROW -->
<%
            }
  
            if (showMore)
            {
%>
              <!-- START DETAIL ROW -->
              <TR>
                <TD class="row">&nbsp;</TD>
          
                <!-- * START DETAIL -->
                <TD class="row" align="left" valign="top">
                  <BR>
                  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                  <a href="<wf:createWebflowURL namespace='admin_portal' origin='portal_home.jsp' event='link.portal_more' extraParams='<%=portalParams%>'/>"><i18n:getMessage messageName='more'/></a>
                  <br>
                </TD>
                <TD class="row" align="left" valign="top">&nbsp;</TD>
                <!-- * END DETAIL -->
  
                <TD class="row">&nbsp;</TD>
              </TR>
              <!-- END DETAIL ROW -->
<%          }
%>
        <TR>
          <TD class="spacerRow" colspan="<%=(numberOfLabels+2)%>">&nbsp;</TD>
        </TR>
        <TR>
          <TD class="emptyRow" colspan="<%=(numberOfLabels+2)%>">&nbsp;</TD>
        </TR>
<%
          } // end for portals.size()
%>
      </TABLE>
  
      </TD>
      <!-- end content area -->
  
      <TD align="center" valign="top" width="2%">
        <!-- spacer cell -->
        &nbsp;&nbsp;
      </TD>
  
    </TR>
  </TABLE>

</BODY>
</HTML>
