<%-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. --%>
<%@ page extends="com.bea.jsptools.common.servlets.jsp.ToolsJspBase"%>

<%-- ------------------------------------------------------------ --%>
<%-- page imports                                                 --%>
<%-- ------------------------------------------------------------ --%>
<%@ page import="com.bea.portal.manager.PortalFactory"%>
<%@ page import="com.bea.portal.model.GroupPortal"%>
<%@ page import="com.bea.portal.model.PortalIdentifier"%>
<%@ page import="com.bea.portal.entitlement.resource.PortalAdminTaskResourceConstants"%>

<%@ page import="java.text.Collator"%>

<%@ page errorPage="error.jsp" %>

<%-- ------------------------------------------------------------ --%>
<%-- taglibs                                                      --%>
<%-- ------------------------------------------------------------ --%>
<%@ taglib uri="webflow.tld" prefix="wf" %>
<%@ taglib uri="i18n.tld" prefix="i18n" %>
<%@ taglib uri="res.tld" prefix="res" %>
<%@ taglib uri="dam.tld" prefix="dam" %>

<%-- ------------------------------------------------------------ --%>
<%-- i18n (internationalization) and skin setup                   --%>
<%-- ------------------------------------------------------------ --%>

<%@ include file="/tools/portal/i18n_setup.inc"%>

<%-- Grab the html title string from the properties file --%>
<i18n:getMessage messageName='pageTitle' id='pageTitle'/>


<%-- ------------------------------------------------------------ --%>
<%-- environment setup                                            --%>
<%-- ------------------------------------------------------------ --%>
<%
  Object[] args = new Object[] { null };
  // Make this page uncacheable so that session variables can be cleared.
  response.setHeader("Cache-Control","no-cache");  // HTTP 1.1
  response.setHeader("Pragma","no-cache");      // HTTP 1.0
  response.setDateHeader("Expires", 0);      // prevents caching at proxy

  // Some access is limited to Portal Administrators. Set a boolean var for later use.
  boolean bPortalAdmin = false;
  
  PortalIdentifier portalId = null;
%>

<%-- TODO: consolidate vars ------------------------------------ --%>
<%
  String sIndex = request.getParameter("index");
  int iIndex = 0;
  if(sIndex != null && !sIndex.equals(""))
  {
    iIndex = Integer.parseInt(sIndex.trim());
  }
  if(iIndex < 0)
  {
    iIndex = 0;
  }

  String sGroupPortalCount = request.getParameter("group_portal_count");
  //If we're note posting to ourselves, check if there's a value in the pipeline
  if(sGroupPortalCount == null)
  {
%>
    <wf:getProperty property="group_portal_count" id="sGroupPortalCountTemp" type="String"/>
<%
     sGroupPortalCount = sGroupPortalCountTemp;
  }
%>
  <i18n:getMessage messageName='groupPortalsDisplayed' id='groupPortalsDisplayed' bundleName='tools'/>
<%
  //In this part, we get the string from the tools.properties that is then turned into the 'Displayed
  // Per Page' drop down box.  We also need to get the number that will be the default
  groupPortalsDisplayed = groupPortalsDisplayed + ",";
  ArrayList groupPortalsDisplayedList = new ArrayList();
  String newNumber = null;
  while(groupPortalsDisplayed.length()>0)
  {
    newNumber = groupPortalsDisplayed.substring( 0, groupPortalsDisplayed.indexOf(",") );
    groupPortalsDisplayedList.add( newNumber.trim() );
    groupPortalsDisplayed = groupPortalsDisplayed.substring(groupPortalsDisplayed.indexOf(",") + 1, groupPortalsDisplayed.length());
  }

%>
  <i18n:getMessage messageName='groupPortalsDisplayedDefault' id='groupPortalsDisplayedDefault' bundleName='tools'/>
<%
  int iGroupPortalCount = Integer.parseInt(groupPortalsDisplayedDefault);
  if(sGroupPortalCount != null && !sGroupPortalCount.equals(""))
  {
    iGroupPortalCount = Integer.parseInt(sGroupPortalCount.trim());
%>
    <wf:setProperty property='group_portal_count' value='<%=String.valueOf(iGroupPortalCount)%>' />
<%
  }
  if(iGroupPortalCount < 0)
  {
    iGroupPortalCount = 0;
  }
    
  /* setup variables used in this page */
  String portalName = request.getParameter("portalName");

  //Need to get ID from URL string and create portal.
  String portalIdStr = request.getParameter("portalID");
  //PortalIdentifier portalId = PortalFactory.createPortalIdentifier(portalIdStr);
  portalId = PortalFactory.createPortalIdentifier(portalIdStr);

  //Cover the case if we're submitting to ourself (in the case of a group portal delete
  String deleteUserGroupID = request.getParameter("userGroupID");
  String portalIDStr = request.getParameter("portalID");
  if(deleteUserGroupID != null && portalIDStr != null)
  {
%>
    <res:removeGroupPortal userGroupID="<%=deleteUserGroupID%>" portalID="<%=portalIDStr%>"/>
<%
  }

  //Now, we need to get the GroupPortals that are associated with this portal
%>
  <res:getGroupPortals id="groupPortalsLarge" portalIdentifier="<%=portalId%>"/>
  <dam:canAdministerPortal id="canCallerAdminister" portalIdentifier="<%=portalId%>"/>
<%          
  bPortalAdmin =  canCallerAdminister.booleanValue();
  //Create the extra Params to pass on the url
  String portalParams = "portalName=" + portalName + "&portalID=" + portalIdStr;

  String defaultGroupParams = null;
  List groupPortalsModifiable = new ArrayList(groupPortalsLarge);
  //The first loop picks out the default group portal and places it at the top of the output list.
  for(int j=0;j<groupPortalsModifiable.size();j++)
  {
    if(((GroupPortal)groupPortalsModifiable.get(j)).isDefault())
    {
      defaultGroupParams = portalParams + "&userGroupID=" + ((GroupPortal)groupPortalsModifiable.get(j)).getGroupIdentifier();
      groupPortalsModifiable.remove(j);
      j=j-1;
    }
  }
%>

  <%-- Narrow list down from search params --%>
<%String searchString = request.getParameter("SearchString");
  //Handle the case were nothing was entered, we return all
  if (searchString == null || searchString == "") 
  {
    searchString = "*";
  }
  //If something was entered, we have to return the start index to 0, since we don't know how many will
  // be in the return set
  String newSearch = request.getParameter("newSearch");
  if (newSearch != null)  
  {
    iIndex = 0;
  }
%>
  <res:groupPortalSearchList id="groupPortalsSearchNarrowed" groupPortalList="<%=groupPortalsModifiable%>" searchExp="<%=searchString%>" />
<%//Now, get the language so we can internationalize the sort.  This info got set when we called 
  //TODO: Shouldn't this tag be actually used?
  //  <i18n:localize/>
  String language = (String)pageContext.findAttribute("LANGUAGE");
  //Need to pass in a language to the sort tag, so default to english
  if(language.compareTo("") == 0 || language == null)
  {
    language = "en";
  }
%>
  <res:groupPortalListI18nSort id="groupPortalsLargeSorted" 
                              groupPortalList="<%=groupPortalsSearchNarrowed%>" 
                              language="<%=language%>"
  />

<%
  //Now we need to get a smaller sublist to display
  int iMaxCount = groupPortalsLargeSorted.size();
  int toIndex = iIndex+iGroupPortalCount;
  boolean groupPortalListIsEmpty = false;
  if(iMaxCount == 0)
  {
    groupPortalListIsEmpty = true;
  }
  if(iMaxCount < toIndex)
  {
    toIndex = iMaxCount;
  }
  List groupPortals = groupPortalsLargeSorted.subList(iIndex,toIndex);

  String sUserGroupId = null;
  String sGroupPortalName = null;
  String groupParams = null;

  //Set these up for use in determining weither or not to shoe the edit portal admins link
  boolean canUsersDelegate = false;
  boolean canPortalPagesDelegate = false;
  boolean canPortletsDelegate = false;
  boolean canSkinsDelegate = false;

  //Set up some variables to use later in the page
  String iNextAmount = null;
  String iPrevAmount = null;
  if( (iMaxCount - toIndex) < iGroupPortalCount )
  {
    iNextAmount = String.valueOf(iMaxCount - toIndex);
  }
  else
  {
    iNextAmount = String.valueOf(iGroupPortalCount);
  }
  if( iIndex < iGroupPortalCount )
  {
    iPrevAmount = "";
  }
  else
  {
    iPrevAmount = String.valueOf(iGroupPortalCount);
  }
%>


  <%-- END TODO: ------------------------------------------------- --%>


<%-- ------------------------------------------------------------ --%>
<%-- begin rendering                                              --%>
<%-- ------------------------------------------------------------ --%>
<HTML>
<HEAD>
  <TITLE><%=pageTitle%></TITLE>
  <LINK REL=StyleSheet HREF="<wf:createResourceURL resource='<%=cssFile%>'/>" TYPE="text/css" MEDIA=screen>
  
  <%-- ------------------------------------------------------------ --%>
  <%-- JavaScript setup                                             --%>
  <%-- ------------------------------------------------------------ --%>
  <SCRIPT LANGUAGE="JavaScript">
  <!-- Begin hide from old browsers
  function submit()
  {
    this.document.indexForm.submit();
  }
        
  function deleteConfirmation(confirmDelete, formNumber) 
  {
    if(confirm(confirmDelete))
    {
       document.forms[formNumber].submit();
    }
  }

  // End hide from old browsers -->
  </SCRIPT>


</HEAD>
<BODY leftmargin="0" rightmargin="0" marginwidth="0" marginheight="0" STYLE='BACKGROUND-IMAGE:url("<wf:createResourceURL resource='<%=imagesPath + "bg.gif"%>'/>"); BACKGROUND-REPEAT: no-repeat; BACKGROUND-POSITION:left top;'>

<%@ include file="/tools/util/admin_header.inc"%>
<!-- end top nav bar -->

<!-- This is the uber table that contains two table data cells: one for the left nav, the other for the main page layout -->
  <TABLE border="0" cellspacing="0" cellpadding="0" width="100%" height="100%">
    <TR>
      <TD width="1%" align="left" valign="top" class="sidenav">
        <!-- include  table for left nav bar -->
        <jsp:include page="left_navbar_home.jsp"/>
      </TD>

      <TD align="center" valign="top" width="2%">
        <!-- spacer cell -->
        &nbsp;&nbsp;
      </TD>

      <!-- begin table for main content area -->
      <TD align="left" valign="top">
        <% // Include the error message display logic %>
        <%@ include file="/tools/util/error_message.inc"%>

        <SPAN class="pageheader"><i18n:getMessage messageName='availableGroupPortals'/></SPAN>
        <BR>
<%        if (bPortalAdmin)
        {
           // Creation of message arguments
%>
		   <wf:createResourceURL resource='<%=imagesPath + "delete.gif"%>' id='trashIcon'/>
<%
           args = new Object[] { trashIcon };
%>
          <SPAN class="instructions"><i18n:getMessage messageName='choosePortalForPA' messageArgs='<%=args%>'/></SPAN>
<%      }
        else
        {
%>        <SPAN class="instructions"><i18n:getMessage messageName='choosePortalForGA'/></SPAN>
<%      }
%>
        <BR><BR>
<%      // number of labels in category listing header section
        int numberOfLabels = 1;

        //Build our parameter strings
        String portalInfo = "portalName=" + portalName + "&portalID=" + portalIdStr + "&SearchString=" + searchString;
        String sPrevious = portalInfo + "&index=" + (iIndex - iGroupPortalCount) + "&group_portal_count=" + iGroupPortalCount;
        String sNext = portalInfo + "&index=" + (iIndex + iGroupPortalCount) + "&group_portal_count=" + iGroupPortalCount;
        String sFirst = portalInfo + "&index=0" + "&group_portal_count=" + iGroupPortalCount;
        String sLast = portalInfo + "&index=" + (iMaxCount-iGroupPortalCount) + "&group_portal_count=" + iGroupPortalCount;
        boolean bPrev = false;
        boolean bNext = false;
        if(iIndex != 0)
        {
          bPrev = true;
        }
        if(iIndex + iGroupPortalCount < iMaxCount)
        {
          bNext = true;
        }
%>
        <TABLE cellspacing="0" cellpadding="0" border="0" width="95%">
          <TR>
            <TD align="left" valign="top" rowspan="2">
              <!-- category listing left hand side -->
              <jsp:include page="category_list_header_lhs.jsp"/>
            </TD>

            <!-- It may seem strange to put a td width of 1000 in here, but after much trial and error this is the only way Netscape will maintain the fixed border widths along with the liquid, stretchable layout of the table -->
            <TD class="categoryHeadingBorderCell" colspan="<%=numberOfLabels%>" height="1px" width="1000"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>

            <TD align="left" valign="top" rowspan="2">
              <!-- category listing right hand side -->
              <jsp:include page="category_list_header_rhs.jsp"/>
            </TD>
          </TR>

          <TR>
            <!-- * START LABELS -->
            <!-- * START LABELS -->
            <TD class="categoryHeadingCell" colspan="<%=numberOfLabels%>" nowrap>
              <!-- START TABLE to make the links align -->
              <TABLE cellspacing="0" cellpadding="0" border="0" width="100%">
               <tr>
                <TD class="categoryHeadingCell" nowrap>
                    <%=cnvrtSC(portalName)%>
                    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                </TD>
<%              if(bPortalAdmin)
                {
%>
                  <td align="right" nowrap>
                  <!-- * Default Portal -->
<%                
                    //We only want to show the edit portal admins link if the admin has delegate privledges
%>
                    <dam:isPortalAdminAccessAllowed id="tempUsersDelegate" portalIdentifier="<%=portalId%>" resourceType='<%=PortalAdminTaskResourceConstants.RESOURCE_TYPE%>' adminTask='<%= PortalAdminTaskResourceConstants.DELEGATE_MANAGE_USERS %>' capabilityKey='<%=PortalAdminTaskResourceConstants.DELEGATEABLE%>' userName="<%=request.getRemoteUser()%>"/>
                    <dam:isPortalAdminAccessAllowed id="tempPortalPagesDelegate" portalIdentifier="<%=portalId%>" resourceType='<%=PortalAdminTaskResourceConstants.RESOURCE_TYPE%>' adminTask='<%= PortalAdminTaskResourceConstants.DELEGATE_MANAGE_PORTAL_PAGES %>' capabilityKey='<%=PortalAdminTaskResourceConstants.DELEGATEABLE%>' userName="<%=request.getRemoteUser()%>"/>
                    <dam:isPortalAdminAccessAllowed id="tempPortletsDelegate" portalIdentifier="<%=portalId%>" resourceType='<%=PortalAdminTaskResourceConstants.RESOURCE_TYPE%>' adminTask='<%= PortalAdminTaskResourceConstants.DELEGATE_MANAGE_PORTLETS %>' capabilityKey='<%=PortalAdminTaskResourceConstants.DELEGATEABLE%>' userName="<%=request.getRemoteUser()%>"/>
                    <dam:isPortalAdminAccessAllowed id="tempSkinsDelegate" portalIdentifier="<%=portalId%>" resourceType='<%=PortalAdminTaskResourceConstants.RESOURCE_TYPE%>' adminTask='<%= PortalAdminTaskResourceConstants.DELEGATE_MANAGE_SKINS %>' capabilityKey='<%=PortalAdminTaskResourceConstants.DELEGATEABLE%>' userName="<%=request.getRemoteUser()%>"/>
<%  
                    //Convert Boolean objects into primatives
                    canUsersDelegate = tempUsersDelegate.booleanValue();
                    canPortalPagesDelegate = tempPortalPagesDelegate.booleanValue();
                    canPortletsDelegate = tempPortletsDelegate.booleanValue();
                    canSkinsDelegate = tempSkinsDelegate.booleanValue();
                    if(canUsersDelegate || canPortalPagesDelegate || canPortletsDelegate || canSkinsDelegate)
                    {
%>                  
                      <IMG src="<wf:createResourceURL resource='<%=imagesPath + "edit_delegated.gif"%>'/>" border="0">&nbsp;<a class="standardlink" href="<wf:createWebflowURL namespace='admin_portal' event='link.browse_admin_edit' extraParams='<%=portalParams%>'/>"><i18n:getMessage messageName='editPortalAdmins'/></a>

                      &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<%                  }
%>
                    <!-- * Create New Portal -->
                    <IMG src="<wf:createResourceURL resource='<%=imagesPath + "create_new_ug.gif"%>'/>" alt="<i18n:getMessage messageName='createNewGroupPortal'/>" border="0" align="top">&nbsp;<a class="standardlink" href="<wf:createWebflowURL namespace='admin_portal' event='link.new_group_portal' extraParams='<%=portalParams%>'/>"><i18n:getMessage messageName='createNewGroupPortal'/></a>
                  </td>  
<%              }
%>
                </tr>
              </table>
            </TD>
              <!-- END TABLE to make the links align -->
          </TR>

          <!-- This creates the dark green line at the bottom of the green header -->
          <TR>
            <TD class="categoryHeadingBorderCell" colspan="<%=(numberOfLabels+2)%>" height="1"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
          </TR>
          <!-- START DETAIL ROW -->
          <TR>
            <TD class="row">
              &nbsp;
            </TD>
            <TD class="row" nowrap>
              <!-- start Webflow/Pipeline enabled FORM -->
              <BR>
              <wf:form namespace="admin_portal"  event="link.refresh" origin="portal_more.jsp" hide="true" method="post" name="searchForm">
                <INPUT TYPE="TEXT" NAME="SearchString" VALUE="<%=searchString%>">
                &nbsp;
                <INPUT TYPE="IMAGE" SRC="<wf:createResourceURL resource='<%=imagesPath + "search.gif"%>'/>" ALT="<i18n:getMessage messageName='performGroupSearch'/>" border="0">
                <INPUT TYPE="HIDDEN" NAME="index" VALUE="<%=iIndex%>">
                <INPUT TYPE="HIDDEN" NAME="portalName" VALUE="<%=portalName%>">
                <INPUT TYPE="HIDDEN" NAME="portalID" VALUE="<%=portalIdStr%>">
                <INPUT TYPE="HIDDEN" NAME="newSearch" VALUE="true">
              </wf:form>
              <!-- start Webflow/Pipeline enabled FORM -->
              <wf:form namespace="admin_portal" event="link.refresh" origin="portal_more.jsp" hide="true" method="post" name="indexForm">
<%              if(groupPortalListIsEmpty)
                {
%>                <BR><i18n:getMessage messageName='noGroupPortals' bundleName='tools'/>
<%
                }
                else
                {
                  if((iIndex+1) == toIndex)
                  {
                    // Creation of message arguments
                    args = new Object[] { String.valueOf(toIndex), String.valueOf(iMaxCount) };
%>                  <BR><B><i18n:getMessage messageName='displayOneOfMany' messageArgs='<%=args%>' bundleName='tools'/></B>
<%
                  }
                  else
                  {
                    // Creation of message arguments
                    args = new Object[] { String.valueOf(iIndex + 1), String.valueOf(toIndex), String.valueOf(iMaxCount) };
%>                  <BR><B><i18n:getMessage messageName='displayOneThroughMany' messageArgs='<%=args%>' bundleName='tools'/></B>
<%                }
                }
%>
                &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                <i18n:getMessage messageName='displayedPerPage' bundleName='tools'/>
                <SELECT SIZE="1" NAME="group_portal_count" onChange="submit();">
<%                for(int j=0;j<groupPortalsDisplayedList.size();j++)
                  {
                    if(Integer.parseInt( (String)groupPortalsDisplayedList.get(j) )== iGroupPortalCount)
                    {
%>                    <OPTION SELECTED><%=groupPortalsDisplayedList.get(j)%>
<%                  }
                    else
                    {
%>                    <OPTION><%=groupPortalsDisplayedList.get(j)%>
<%                  }
                  }
%>
                </SELECT>
                <INPUT TYPE="HIDDEN" NAME="index" VALUE="<%=iIndex%>">
                <INPUT TYPE="HIDDEN" NAME="portalName" VALUE="<%=portalName%>">
                <INPUT TYPE="HIDDEN" NAME="portalID" VALUE="<%=portalIdStr%>">
                <INPUT TYPE="HIDDEN" NAME="SearchString" VALUE="<%=searchString%>">
              </wf:form>
              <br>&nbsp;&nbsp;&nbsp;&nbsp;
<%            if(bPrev && !bNext)
              {
%>              <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sPrevious%>'/>"><i18n:getMessage messageName='previous' bundleName='tools'/> <%=iPrevAmount%></A>&nbsp;|
                <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sFirst%>'/>"><i18n:getMessage messageName='first' bundleName='tools'/> </A><br><br>
<%            }
              else if(bNext && ! bPrev)
              {
%>              <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sNext%>'/>"><i18n:getMessage messageName='next' bundleName='tools'/> <%=iNextAmount%></A>&nbsp;|
                <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sLast%>'/>"><i18n:getMessage messageName='last' bundleName='tools'/> </A><br><br>
<%            }
              else if(bPrev && bNext)
              {
%>              <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sPrevious%>'/>"><i18n:getMessage messageName='previous' bundleName='tools'/> <%=iPrevAmount%></A>&nbsp;|
                <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sNext%>'/>"><i18n:getMessage messageName='next' bundleName='tools'/> <%=iNextAmount%></A>&nbsp;
                [ <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sFirst%>'/>"><i18n:getMessage messageName='first' bundleName='tools'/> </A>&nbsp;|
                <a href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sLast%>'/>"><i18n:getMessage messageName='last' bundleName='tools'/></A> ]<br><br>
<%            }
%>
            </TD>
          </TR>
<%
          for(int i=0;i<groupPortals.size();i++)
          {
            //CAF:  Note:  you need to put both the portalId and the userGroupId in this query string...
            sUserGroupId = ((GroupPortal)groupPortals.get(i)).getGroupIdentifier();
            sGroupPortalName = ((GroupPortal)groupPortals.get(i)).getDisplayName();
            groupParams = portalParams + "&userGroupID=" + sUserGroupId;
            args = new Object[] { cnvrtSC(sGroupPortalName), cnvrtSC(sUserGroupId) };
%>
            <!-- START DETAIL ROW -->
            <TR>
              <TD class="row">
              </TD>

              <!-- * START DETAIL -->
              <TD class="row" align="left" valign="top">
                <TABLE cellspacing="0" cellpadding="0" border="0" width="100%">
                  <tr>
                    <td width=50%>&nbsp;&nbsp;
                      <A href="<wf:createWebflowURL namespace='admin_portal' event='link.edit_group_portal' extraParams='<%=groupParams%>'/>">
                      <i18n:getMessage messageName='groupPortalDisplay' messageArgs='<%=args%>'/>                  
                      <%--<%=cnvrtSC(sGroupPortalName)%> --%>
                      </A>
                      <wf:form namespace="admin_portal" event="link.refresh" origin="portal_more.jsp" hide="true" method="post" name="DeleteForm">
                        <INPUT TYPE="HIDDEN" NAME="userGroupID" VALUE="<%=sUserGroupId%>">
                        <INPUT TYPE="HIDDEN" NAME="portalName" VALUE="<%=portalName%>">
                        <INPUT TYPE="HIDDEN" NAME="portalID" VALUE="<%=portalIdStr%>">
                        <INPUT TYPE="HIDDEN" NAME="SearchString" VALUE="<%=searchString%>">
                      </wf:form>
                    </td>
                    <td width=50%>
<%                      // Only show the delete icon for Portal Adminstrators
                      if(bPortalAdmin)
                      {
%>                        &nbsp;&nbsp;&nbsp;&nbsp;
                        <%-- We add 2 to the form number here because of the two forms that come before the delete form.
                             We also have to worry about the reletive form number instead of name specific form number
                             because of Netscape 4.7
                        --%>
                        <A HREF="javascript:deleteConfirmation('<%=cnvrtSC(sGroupPortalName)%>', <%=i+2%>)"><IMG src="<wf:createResourceURL resource='<%=imagesPath + "delete.gif"%>'/>" alt="<i18n:getMessage messageName='altForDeleteGif'/>" border="0"></A>
                        &nbsp;&nbsp;&nbsp;
<%
                      }
                      else
                      {
%>                        &nbsp; 
<%                      } 
%>         				
                    </td>
                  </TR>
                </TABLE>
              </TD>
              <!-- * END DETAIL -->

              <TD class="row">
              </TD>
            </TR>
            <!-- END DETAIL ROW -->
<%
          }
%>
          <TR>
            <TD class="row">
                &nbsp;
            </TD>
            <TD class="row" nowrap>
              <BR>
              &nbsp;&nbsp;&nbsp;&nbsp;
<%              if(bPrev && !bNext)
              {
%>                <A href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sPrevious%>'/>"><i18n:getMessage messageName='previous' bundleName='tools'/> <%=iPrevAmount%></A>&nbsp;|
                <A href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sFirst%>'/>"><i18n:getMessage messageName='first' bundleName='tools'/> </A>
<%              }
              else if(bNext && ! bPrev)
              {
%>                <A href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sNext%>'/>"><i18n:getMessage messageName='next' bundleName='tools'/> <%=iNextAmount%></A>&nbsp;|
                <A href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sLast%>'/>"><i18n:getMessage messageName='last' bundleName='tools'/> </A>
<%              }
              else if(bPrev && bNext)
              {
%>                <A href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sPrevious%>'/>"><i18n:getMessage messageName='previous' bundleName='tools'/> <%=iPrevAmount%></A>&nbsp;|
                <A href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sNext%>'/>"><i18n:getMessage messageName='next' bundleName='tools'/> <%=iNextAmount%></A>&nbsp;
                [ <A href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sFirst%>'/>"><i18n:getMessage messageName='first' bundleName='tools'/> </A>&nbsp;|
                <A href="<wf:createWebflowURL namespace='admin_portal' event='link.refresh' extraParams='<%=sLast%>'/>"><i18n:getMessage messageName='last' bundleName='tools'/></A> ]
<%              }
%>
              <br><br>&nbsp;&nbsp;&nbsp;&nbsp;
              <A HREF="<wf:createWebflowURL namespace='admin_portal' event='link.back_to_home'/>"><IMG src="<wf:createResourceURL resource='<%=imagesPath + "back.gif"%>'/>" border="0" align="bottom"></A>
            </TD>
          </TR>

          <TR>
            <TD class="spacerRow" colspan="<%=(numberOfLabels+2)%>">
                  &nbsp;
            </TD>
          </TR>
          <TR>
            <TD class="emptyRow" colspan="<%=(numberOfLabels+2)%>">
                  &nbsp;
            </TD>
          </TR>
        </TABLE>

      </TD>
      <!-- end content area -->

      <TD class="row" align="center" valign="top" width="2%">
        <!-- spacer cell -->
        &nbsp;&nbsp;
      </TD>

    </TR>
  </TABLE>
</BODY>
</HTML>
