<%-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. --%>
<%@ page extends="com.bea.jsptools.common.servlets.jsp.ToolsJspBase"%>

<%-- ------------------------------------------------------------ --%>
<%-- page imports                                                 --%>
<%-- ------------------------------------------------------------ --%>
<%@ page import="com.bea.portal.model.GroupPortal"%>
<%@ page import="com.bea.portal.model.LayoutIdentifier"%>
<%@ page import="com.bea.portal.model.PortalIdentifier"%>
<%@ page import="com.bea.portal.jsp.JspConstants"%>

<%@ page import="com.bea.p13n.util.debug.Debug"%>

<%@ page errorPage="error.jsp" %>

<%
    Debug debug = Debug.getInstance( __select_layouts.class );
%>

<%-- ------------------------------------------------------------ --%>
<%-- taglibs                                                      --%>
<%-- ------------------------------------------------------------ --%>
<%@ taglib uri="res.tld" prefix="res" %>
<%@ taglib uri="es.tld" prefix="es" %>
<%@ taglib uri="webflow.tld" prefix="wf" %>
<%@ taglib uri="i18n.tld" prefix="i18n" %>
<%@ taglib uri="weblogic.tld" prefix="wl" %>
           
<%@ include file="/tools/portal/i18n_setup.inc"%>

<%  // Grab the html title string from the properties file %>
<i18n:getMessage messageName='pageTitle' id='pageTitle'/>


<%-- ------------------------------------------------------------ --%>
<%-- environment setup                                            --%>
<%-- ------------------------------------------------------------ --%>
<% // Get messages for javascript functions %>
<i18n:getMessage id='selectOneMsgTemp' messageName='selectOne' bundleName='<%=jsPath+"tool_utils"%>'/>
<i18n:getMessage id='leaveOneMsgTemp' messageName='leaveOne' bundleName='<%=jsPath+"tool_utils"%>'/>
<%
   String selectOneMsg = selectOneMsgTemp;
   String leaveOneMsg = leaveOneMsgTemp;
%> 

<%-- ------------------------------------------------------------ --%>
<%-- DECLARE NavLocation VALUE                                    --%>
<%-- Used for the left_navbar highlighting                        --%>
<%-- ------------------------------------------------------------ --%>
  <wf:setProperty property='NavLocation' value='<%=JspConstants.PAGES_LAYOUTS_PORTLETS_NAV%>' scope='request'/>
 
<%-- Get the Default Group Portal Display name to use on the page --%>
<i18n:getMessage id='defaultGroupPortalName' messageName='defaultGroupPortalDisplayName' bundleName='tools'/>

  <wf:getProperty property="portalName" id="portalName" type="String"/>
  <wf:getProperty property="groupPortalObj" id="currentGroupPortal" type="com.bea.portal.model.GroupPortal"/>
  <wf:getProperty property="isDefaultGroup" id="isDefaultGroup" type="String"/>
  
<%

  // Setup some important page scope variables
  
  String groupPortalGroupId = currentGroupPortal.getGroupIdentifier();
  String groupPortalName = currentGroupPortal.getDisplayName();
  String targetPageName = request.getParameter("portalPageName");
  PortalIdentifier portalIdentifier = currentGroupPortal.getPortalIdentifier();

  if(( isDefaultGroup != null ) && ( isDefaultGroup.equals("true") ))
  {
    groupPortalName = defaultGroupPortalName;
  }
  
  LayoutIdentifier returnedLayout = null;
  try 
  {
%>

     <res:getDefaultLayout id="currentdefaultLayout" groupId="<%=currentGroupPortal %>" pageName="<%=targetPageName%>" />
  
<% 
     returnedLayout = currentdefaultLayout;
   } 
   catch (JspTagException e )
   {
   	// no layout is selected 
   }
        
    String defaultLayout = null;
  
    defaultLayout = request.getParameter("defaultLayoutName");
    if ( debug.ON )
    {
      debug.out( "request.getParameter(defaultLayoutName) = "+defaultLayout);
    }
    if ((defaultLayout == null) && (returnedLayout != null))
    {
      defaultLayout = returnedLayout.getName();
      if ( debug.ON )
      {
        debug.out( "Initial default = "+defaultLayout);
      }
    }

    List completeLayoutList = new ArrayList();
%>  

<!-- Get the web app context name -->
<res:getWebAppName portalIdentifier="<%=portalIdentifier%>" id="webappName"/>

<%-- ------------------------------------------------------------ --%>
<%-- form processing                                              --%>
<%-- ------------------------------------------------------------ --%>

<!-- ****** TODO: JH: form submit data processing -->

<!-- If the 'save' button was clicked, go ahead and process the input. -->
<wl:process name="doUpdate" value="true">

    <%
		//TODO:  Should we put this into taglib or leave it in JSP?  cleaner code vs flexibility
		ServletRequest req = pageContext.getRequest();
                
        if ( debug.ON )
        {
            debug.out( "wl:process req = "+req);
            java.util.Enumeration parameterNames = req.getParameterNames();
            while (parameterNames.hasMoreElements())
            {
                debug.out("wl:process parameterName = "+parameterNames.nextElement());
            }
            java.util.Map parameterMap = req.getParameterMap(); 
            java.util.Collection parameterValues = parameterMap.values();
            debug.out( "wl:process parameterValues.size() = "+parameterValues.size());
            java.util.Iterator parameterIter = parameterValues.iterator();
            while (parameterIter.hasNext())
            {
               debug.out( "wl:process parameterValue = "+parameterIter.next());
            }
        }
            
		String layoutNames = req.getParameter("layoutNames");
        //String defaultLayout = req.getParameter("defaultLayoutName");
        
        if ( debug.ON )
        {
            debug.out( "wl:process defaultLayout = "+defaultLayout);
        }
  
		int startIdx;
		int endIdx;
		String elem;
		List layoutNamesList = new ArrayList();

		startIdx = 0;
		endIdx = layoutNames.indexOf ('|', startIdx);

		while (endIdx > 0) {
			elem = layoutNames.substring (startIdx, endIdx);
            if ( debug.ON )
            {
                debug.out( "elem "+elem);
            }
			layoutNamesList.add(elem);
			startIdx = endIdx + 1;
			endIdx = layoutNames.indexOf ('|', startIdx);
		}
		elem = layoutNames.substring (startIdx, layoutNames.length());
		layoutNamesList.add(elem);
		
    %>
    <%
        if ( debug.ON )
        {
            debug.out( "wl:process targetPageName = "+targetPageName);
        }
    %>        
    <res:setAvailableLayouts groupId="<%=currentGroupPortal %>" pageName="<%=targetPageName%>" layoutNames="<%=layoutNamesList%>" />
    <res:setDefaultLayout groupId="<%=currentGroupPortal %>" pageName="<%=targetPageName%>" layoutName="<%=defaultLayout%>" />


    <%-- The following form and associated javascript allow for the "page forward" on a successful save --%>  
    <%
      //We only want to forward if there have been no generated errors within the tags
      String logId = (String)pageContext.getAttribute("logId");
      if(logId == null)
      {
    %>
         <SCRIPT LANGUAGE="JavaScript">
          window.location.replace("<wf:createWebflowURL namespace="admin_portal" origin="select_layouts.jsp" event="link.back"/>");
         </SCRIPT>
    <%}
    %>

</wl:process>



<%-- ------------------------------------------------------------ --%>
<%-- begin rendering                                              --%>
<%-- ------------------------------------------------------------ --%>
<html>
<head>
  <title><%=pageTitle%></title>
  <LINK REL=StyleSheet HREF="<wf:createResourceURL resource='<%=cssFile%>'/>" TYPE="text/css" MEDIA="screen">

<script language="JavaScript" src="<wf:createResourceURL resource='<%=jsPath+"tool_utils.js"%>'/>"></script>

<%
     if (debug.ON)
     {
         debug.out("jsPath = "+jsPath);
     }
%>
          
<script language="JavaScript">

function initDefaultLayout() {
	var selectObject = document.forms[0].elements["C1"];
    var index = -1;
    for (var i=0; i<selectObject.options.length; i++) {
        if (selectObject.options[i].text.indexOf("* ") == 0) {
            selectObject.options[i].text = selectObject.options[i].text.substr(2);
        }
        if ( selectObject.options[i].value == "<%= defaultLayout %>") {
            selectObject.options[i].text =
                "* " + selectObject.options[i].text;
            index = i;
        }
    }

    if ( index != -1 ) {
    	showDefaultLayout( selectObject.options[index].value );    
    }
}

function checkDefaultLayout()
{
    if ( this.document.forms[0].selectedPageNameText.value.indexOf("* ") == 0 )
    {
        alert( "<i18n:getMessage messageName='cannotMoveDefaultAlert'/>" );
        return true;
    }
    return false;
}

function showPreviewThumbnail(selectObject) {

    var val = selectObject.options[selectObject.selectedIndex].value;
    if (val && val != "spacer") {
        var src = "<%=webappName %>/framework/layouts/" + val + "/thumbnail.gif";
        var img = document.images["previewImage"];

        if (img != null) {
            img.src = src;
        }

    }
}

function setCurrentDefault(selectObjectId) {

	var selectObject = document.forms[0].elements[selectObjectId];
	var val = selectObject.options[selectObject.selectedIndex].value;

	if (val && val != "spacer") {
        
		for (var i=0; i<selectObject.options.length; i++) {
			if (selectObject.options[i].text.indexOf("* ") == 0) {
				selectObject.options[i].text = selectObject.options[i].text.substr(2);
			}
		}

		selectObject.options[selectObject.selectedIndex].text =
			"* " + selectObject.options[selectObject.selectedIndex].text;

        showDefaultLayout( selectObject.options[selectObject.selectedIndex].value );

        if ( this.document.forms[0].selectedPageNameText.value == selectObject.options[selectObject.selectedIndex].value ) {
            this.document.forms[0].selectedPageNameText.value = "* " +
                this.document.forms[0].selectedPageNameText.value;
        }
	}
}

function showDefaultLayout( defaultLayout ) {
    document.forms[0].elements["defaultLayoutName"].value = defaultLayout;

    var src = "<%=webappName%>/framework/layouts/" + defaultLayout + "/thumbnail.gif";
    var img = document.images["previewDefault"];

    if (img != null) {
        img.src = src;
    }
    //Show, in text, the selected default layout
    //For Netscape 4
    if(document.layers){
        //First, we want to hide all the layers
        for (var i=0; i<document.forms[0].C1.options.length; i++) {
          if (document.forms[0].C1.options[i].value != "spacer") {
            eval("document.layers."+document.forms[0].C1.options[i].value+".visibility = 'hide'");
          }
        }
        //Now, show the layer that was selected
        eval("document.layers."+defaultLayout+".visibility = 'show'");
    }
    else
    {
        var elem = document.getElementById("dynamicTextBlock");
        if (elem != null) 
        {
          elem.innerHTML = "<span class='fieldlabel'><i18n:getMessage messageName='defaultLayout'/></span><BR>"+ defaultLayout;
        }
    }

}

function doFormSubmit() {

	var txt = "";
	var selObj = document.forms[0].elements["C1"];

	// skip spacer at end of list
	for (var i=0; i<selObj.options.length-1; i++) {
		txt += selObj.options[i].value;
		if (i < selObj.options.length - 2) {
			txt += "|";
		}
	}

	document.forms[0].elements["layoutNames"].value = txt;

	this.document.forms[0].submit();
	return true;
}

</script>

</head>
<BODY onLoad="initDefaultLayout()" leftmargin="0" rightmargin="0" marginwidth="0" marginheight="0" STYLE='BACKGROUND-IMAGE:url("<wf:createResourceURL resource='<%=imagesPath + "bg_subpage.gif"%>'/>"); BACKGROUND-REPEAT: no-repeat; BACKGROUND-POSITION:left top;'>
 
 <%@ include file="/tools/util/admin_header.inc"%>

<!-- end top nav bar -->

<!-- This is the uber table that contains two table data cells: one for the left nav, the other for the main page layout -->
<TABLE border="0" cellspacing="0" cellpadding="0" width="100%" height="100%">
<TR><TD align="left" valign="top" class="sidenav" width="1%">
<!-- include  table for left nav bar -->
<jsp:include page="left_navbar.jsp"/>
</TD>


<TD align="center" valign="top" width="2%">
  <!-- spacer cell -->
  &nbsp;&nbsp;
</TD>

<!-- begin table for main content area -->
<TD align="left" valign="top">

  <%
    // Creation of message arguments
    Object[] args = new Object[] { cnvrtSC(targetPageName) };
  %>
  <span class="pageheader"><i18n:getMessage messageName='portalDisplay' messageArgs='<%=args%>'/></span><BR>
  <span class="instructions"><i18n:getMessage messageName='portalDisplaySubHead'/></span><BR><BR>

  <!-- start Webflow/Pipeline enabled FORM -->
  <wf:form namespace="admin_portal"  event="link.refresh" origin="select_layouts.jsp" hide="true" method="post">

      <!-- A couple of hidden fields to hold the values populated at form submittal -->  
      <!-- that are used in wl:process -->  
      <input type="hidden" name="layoutNames" value="">
      
      <input type="hidden" name="defaultLayoutName" value="<%=defaultLayout%>">
      
      <input type="hidden" name="portalPageName" value="<%=targetPageName%>"> 
      
      <!-- These hidden fields are used by the java script -->  
      <input type="hidden" name="selectedPageIndex" value="">
      <input type="hidden" name="selectedPageFormName" value="">
      <input type="hidden" name="selectedPageNameValue" value="">
      <input type="hidden" name="selectedPageNameText" value="">
      <input type="hidden" name="lastSelectedPageFormName" value="">
    
      <input type="hidden" name="doUpdate" value="true">

  <%
    // number of labels in category listing header section
    int numberOfLabels = 1;
  %>


  <TABLE cellspacing="0" cellpadding="0" border="0" width="100%">

    <TR>
      <TD align="left" valign="top">
              <!-- Begin Tab Table -->      
              <TABLE cellspacing="0" cellpadding="0" border="0" width="100%">
                <TR>
                  <!-- category listing left hand side -->
                  <TD align="left" valign="top" ROWSPAN="2"><jsp:include page="category_list_header_lhs.jsp"/></TD>
                  <!-- It may seem strange to put a td width of 1000 in here, but after much trial and error this is the only way Netscape will maintain the fixed border widths along with the liquid, stretchable layout of the table -->
                  <TD class="categoryHeadingBorderCell" colspan="<%=numberOfLabels%>" height="1px" width="1000"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
                  <!-- category listing right hand side -->
                  <TD align="left" valign="top" ROWSPAN="2"><jsp:include page="category_list_header_rhs.jsp"/></TD>
                </TR>
                <TR>
                  <!-- * START LABELS -->
                  <TD class="categoryHeadingCell" NOWRAP="true">
                    <i18n:getMessage messageName='availableItemsLabel'/>
                  </TD>
                  <!-- * END LABELS  -->
                </TR>
                <!-- This creates the dark green line at the bottom of the green header -->
                <TR>
                  <TD class="categoryHeadingBorderCell" colspan="3" height="1"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
                </TR>
              </TABLE>
              <!-- End Tab Table -->
      </TD>

      <TD width="50%">&nbsp;</TD>

      <TD align="left" valign="top">
              <!-- Begin Tab Table -->      
              <TABLE cellspacing="0" cellpadding="0" border="0" width="100%">
                <TR>
                  <!-- category listing left hand side -->
                  <TD align="left" valign="top" ROWSPAN="2"><jsp:include page="category_list_header_lhs.jsp"/></TD>
                  <!-- It may seem strange to put a td width of 1000 in here, but after much trial and error this is the only way Netscape will maintain the fixed border widths along with the liquid, stretchable layout of the table -->
                  <TD class="categoryHeadingBorderCell" colspan="<%=numberOfLabels%>" height="1px" width="1000"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
                  <!-- category listing right hand side -->
                  <TD align="left" valign="top" ROWSPAN="2"><jsp:include page="category_list_header_rhs.jsp"/></TD>
                </TR>
                <TR>
                  <!-- * START LABELS -->
                  <TD class="categoryHeadingCell" NOWRAP="true">
                    <i18n:getMessage messageName='selectedItemsLabel'/>
                  </TD>
                  <!-- * END LABELS  -->
                </TR>
                <!-- This creates the dark green line at the bottom of the green header -->
                <TR>
                  <TD class="categoryHeadingBorderCell" colspan="3" height="1"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
                </TR>
              </TABLE>
              <!-- End Tab Table -->
      </TD>

      <TD width="50%"></TD>
    </TR>
    <TR>
      <TD>
        <!--TODO JHH - provide a for each in list iterator and use here -->
        <res:getUnusedLayouts id="unusedLayoutsList" groupId="<%=currentGroupPortal%>" pageName="<%=targetPageName%>"/>
<%
			StringBuffer availNames = new StringBuffer();

            if (unusedLayoutsList != null && unusedLayoutsList.size() !=0 ) 
            {
              for (int i=0; i<unusedLayoutsList.size(); i++) 
              {
                if (unusedLayoutsList.get(i) != null) 
                {
                  String displayText = ((LayoutIdentifier)unusedLayoutsList.get(i)).getName();
				          availNames.append("<option value=\"" + displayText + "\">" + cnvrtSC(displayText) + "</option>"); 
%>
<%         
                  // Type (0=Page/1=PagePersonalization)
                  // Mandatory (M=mandatory/ O=optional) %>
                  <input type="hidden" name="<%=displayText+"T"%>" value="0">
                  <input type="hidden" name="<%=displayText+"M"%>" value="">
<%
                  completeLayoutList.add(displayText);
                }
              }
            }
%>

        <select multiple="true" name="C0" size="15" onChange="processSelection(this,this.name, this[selectedIndex].value, this[selectedIndex].text)"><%=availNames.toString()%><option value="spacer">----------------------------------------</option>
        </select>

       </TD>

      <TD align="center" valign="middle" width="50%">
        <!-- -->
        <table border="0">
             <TR>
                 <TD align="center" valign="top">
                  <a href="javascript:moveRight(<%=selectOneMsg%>);" onClick="moveRight(<%=selectOneMsg%>); return false;"><img src="<wf:createResourceURL resource='<%=imagesPath + "arrow_right_enabled.gif"%>'/>" border="0"></a>
                 </TD>
            </TR>
            <TR>
                 <TD align="center" valign="bottom">
                  <a href="javascript:moveLeft(<%=selectOneMsg%>, <%=leaveOneMsg%>);" onClick="if ( !checkDefaultLayout() ) {moveLeft(<%=selectOneMsg%>, <%=leaveOneMsg%>);} return false;"><img src="<wf:createResourceURL resource='<%=imagesPath + "arrow_left_enabled.gif"%>'/>" border="0"></a>
                 </TD>
             </TR>
        </table>
        <!-- -->
      </TD>
      <TD>
        <!--TODO JHH - provide a for each in list iterator and use here -->
        <res:getAvailableLayouts id="availableLayoutList" groupId="<%=currentGroupPortal%>" pageName="<%=targetPageName%>"/>
<%
        StringBuffer selectedNames = new StringBuffer();
        if (availableLayoutList != null)
        {
           for (int i=0; i<availableLayoutList.size(); i++)
           {
              if (availableLayoutList.get(i) != null)
              {
                  String displayText = ((LayoutIdentifier)availableLayoutList.get(i)).getName();
%>
  				        <res:getLayoutDisplayName id="layoutDisplayName" groupId="<%=currentGroupPortal %>" layoutName="<%=displayText%>" />
<%
                  selectedNames.append("<option value=\"" + displayText + "\">" + cnvrtSC(layoutDisplayName) + "</option>"); 
%>
<% 
                 // Type (0=Page/1=PagePersonalization)
                 // Mandatory (M=mandatory/ O=optional) %>
                 <input type="hidden" name="<%=displayText+"T"%>" value="1">
                 <input type="hidden" name="<%=displayText+"M"%>" value="0">
<%
                 completeLayoutList.add(displayText);
              }
            }
         }
%>
        <select multiple="true" name="C1" size="15" onChange="processSelectionWPrev(this,this.name, this[selectedIndex].value, this[selectedIndex].text)"><%=selectedNames.toString()%><option value="spacer">----------------------------------------</option>

        </select>
      </TD>

          <TD align="left" valign="top">
		  <!-- START THUMBNAIL PREVIEW --> 
            <table width="100%" border="0" cellspacing="0" cellpadding="5">
              <tr>
                <td><span class="fieldlabel"><i18n:getMessage messageName='selectionPreviewLabel'/></span></td>
              </tr>
              <tr>
                <td>
                 <img id="previewImage" name="previewImage" src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" border="0" supress="yes" width=76 height=50 >
				        </td>
              </tr>
              <tr>
                <td><span class="fieldlabel"><i18n:getMessage messageName='defaultPreviewLabel'/></span></td>
              </tr>
              <tr>
                <td>
                  <img id="previewDefault" name="previewDefault" src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" border="0" supress="yes" width=76 height=50 >
                </td>
              </tr>
            </table>
		<!-- END THUMBNAIL PREVIEW  -->
      </TD>
    </TR>


    <TR>
      <TD class="emptyRow" colspan="<%= ( (numberOfLabels) * 2)%>">&nbsp;</TD>
    </TR>
 
    <TR>
      <TD colspan="<%=(numberOfLabels)%>">
        <a href="<wf:createWebflowURL namespace="admin_portal" origin="select_layouts.jsp" event="link.back"/>"><img src="<wf:createResourceURL resource='<%=imagesPath + "back.gif"%>'/>" border="0" alt="<i18n:getMessage messageName='backLabel'/>"></a>
        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
        <a href="javascript:doFormSubmit();"><img src="<wf:createResourceURL resource='<%=imagesPath + "save.gif"%>'/>" border="0" alt="<i18n:getMessage messageName='saveLabel'/>"></a>
      </TD>

      <TD>&nbsp;</TD>

      <TD valign="top" colspan="<%=(numberOfLabels)%>">
        <TABLE border="0" cellspacing="0" cellpadding="2">
          <TR>
            <TD>
              <A HREF="javascript:setCurrentDefault('C1');"><IMG src="<wf:createResourceURL resource='<%=imagesPath + "set_as_default.gif"%>'/>" border="0"></A>
    		    </TD>
          </TR>
          <TR>
            <TD>
          		<!-- TODO JHH - show the initial default name. Currently this is only -->
          		<!-- shown after the user has clicked on the set defaults button -->
          		<span name="dynamicTextBlock" id="dynamicTextBlock"></span>
              <DIV id="nav4" STYLE="visibility:hidden;">
<%
                if (completeLayoutList != null) 
                {
                  String displayName = "";
                  for (int i=0; i<completeLayoutList.size(); i++) 
                  {
                    if (completeLayoutList.get(i) != null)
                    {
%>
                      <ILAYER ID="<%=completeLayoutList.get(i)%>" visibility="hide" class='fieldlabel' style="position:absolute;"><i18n:getMessage messageName='defaultLayout'/> <%=completeLayoutList.get(i)%></ILAYER>
<%
                    }
                  }
                }
%>
              </DIV>
            </TD>
          </TR>
        </TABLE>
      </TD>
      <TD></TD>
    </TR>
  </TABLE>
  
  </wf:form>

</TD>
<!-- end content area -->

<TD align="center" valign="top" width="2%">
  <!-- spacer cell -->
</TD>

</TR>
</TABLE>


</BODY>
</HTML>
