<%-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. --%>
<%@ page extends="com.bea.jsptools.common.servlets.jsp.ToolsJspBase"%>

<%@ page import="java.util.Vector"%>
<%@ page import="java.util.StringTokenizer"%>
<%@ page import="java.util.Iterator"%>
<%@ page import="com.bea.portal.model.GroupPortal"%>
<%@ page import="com.bea.portal.model.PortletPersonalization"%>
<%@ page import="com.bea.portal.model.PortalIdentifier"%>
<%@ page import="com.bea.portal.admin.AdminResourceConstants" %>
<%@ page import="com.bea.portal.render.servlets.jsp.taglib.PortalTagConstants" %>
<%@ page import="com.bea.portal.model.PortletIdentifier" %>
<%@ page import="com.bea.portal.model.PortletPersonalization" %>
<%@ page import="com.bea.portal.model.PlaceholderIdentifier" %>
<%@ page import="weblogic.servlet.internal.InternalRequestDispatcher" %>
<%@ page import="javax.servlet.http.HttpServletResponse" %>

<%@ page errorPage="error.jsp" %>


<%-- ------------------------------------------------------------ --%>
<%-- taglibs                                                      --%>
<%-- ------------------------------------------------------------ --%>
<%@ taglib uri="webflow.tld" prefix="wf" %>
<%@ taglib uri="weblogic.tld" prefix="wl" %>
<%@ taglib uri="res.tld" prefix="res" %>
<%@ taglib uri="vum.tld" prefix="vum" %>
<%@ taglib uri="i18n.tld" prefix="i18n" %>

<%@ include file="/tools/portal/i18n_setup.inc"%>

<%  // Grab the html title string from the properties file %>
<i18n:getMessage messageName='pageTitle' id='pageTitle'/>

<%-- ------------------------------------------------------------ --%>
<%-- DECLARE NavLocation VALUE                                    --%>
<%-- Used for the left_navbar highlighting                        --%>
<%-- ------------------------------------------------------------ --%>
<wf:setProperty property='NavLocation' value='<%=com.bea.portal.jsp.JspConstants.PAGES_LAYOUTS_PORTLETS_NAV%>' scope='request'/>

<%-- Get the Default Group Portal Display name to use on the page --%>
<i18n:getMessage id='defaultGroupPortalName' messageName='defaultGroupPortalDisplayName' bundleName='tools'/>

<%-- Get the portal properties --%>
<wf:getProperty property="portalName" id="portalName" type="String" />
<wf:getProperty property="portalId" id="portalId" type="String" />
<wf:getProperty property="groupPortalObj" id="currentGroupPortal" type="com.bea.portal.model.GroupPortal" />
<%
  /* setup variables used in this page */
  String targetPageName = request.getParameter("portalPageName");
  String groupPortalGroupId = currentGroupPortal.getGroupIdentifier();
  String groupPortalName = currentGroupPortal.getDisplayName();

  // get PortalIdentifier
  PortalIdentifier portalIdentifier = currentGroupPortal.getPortalIdentifier();

  if( currentGroupPortal.isDefault() )
  {
    groupPortalName = defaultGroupPortalName;
  }
%>

<res:getPage groupPortal="<%=currentGroupPortal%>" pageName="<%=targetPageName%>" id="pagePersonalization"/>
<res:getLayoutName pagePersonalization="<%=pagePersonalization%>" id="layoutName" />

<!-- Get the web app context name -->
<res:getWebAppName portalIdentifier="<%=portalIdentifier%>" id="webappName"/>

<%
  // create a URL that includes the webapp
  String layoutURL = webappName+"/framework/layouts/" + layoutName + "/template.jsp";
  request.setAttribute("layoutURL", layoutURL);
%>

<res:getPortletCategories id="categoriesAndPortlets" pagePersonalization="<%=pagePersonalization%>"/>
<%
  //We just get an iterator of the category names.  These are the fully qualified names.  We then put them
  // into a list so we can sort them
  Iterator tempIt = categoriesAndPortlets.keySet().iterator();
  List categoryList = new ArrayList();
  while(tempIt.hasNext())
  {
      categoryList.add(tempIt.next());
  }

  //Get the language to sort by
  String language = (String)pageContext.findAttribute("LANGUAGE");
  //Need to pass in a language to the sort tag, so default to english
  if(language.compareTo("") == 0 || language == null)
  {
    language = "en";
  }

%>
    <%-- This tag will sort out categories for us.  Since the categories have their fully qualified names in 
         this list, by sorting them, we'll also put them in hierarchical order 
    --%>
    <vum:stringListI18nSort id='categoryListSorted' list='<%=categoryList%>' language='<%=language%>'/>
<%
  List categoryDisplayList = new ArrayList();
  String token = "/";
  String categoryName = "";
  String fullyQualifiedCategoryName = "";
  HashMap displayNameMap = new HashMap();

  //Now, we're going to loop through our list, and get the category name's ready to display
  for(int catCount=0;catCount<categoryListSorted.size();catCount++)
  {
    String parentCategory = "";
    int tokenIndex = 0;
    int depthCounter = 0;
    categoryName = (String)categoryListSorted.get(catCount);
    fullyQualifiedCategoryName = categoryName;
    tokenIndex = categoryName.indexOf(token);
    //This loop  will pick off all the parent information from the category name and keep the final parent
    while(tokenIndex != -1)
    {
      parentCategory = categoryName.substring(0,tokenIndex);
      categoryName = categoryName.substring(tokenIndex + 1, categoryName.length());
      depthCounter = depthCounter + 1;
      tokenIndex = categoryName.indexOf(token);
    }
    //For each parent category we pulled off, we'll add two spaces to the front of the name
    for(int i=0;i<depthCounter;i++) 
    {
        categoryName = "&nbsp;&nbsp;" + categoryName;
    }
    categoryDisplayList.add(categoryName);
    displayNameMap.put(categoryName, fullyQualifiedCategoryName);
  }
  
  //Get the list of portlets that belong to no category
  List uncategorizedPortlets = (List)categoriesAndPortlets.get(AdminResourceConstants.ROOT_PORTLETS_DIRECTORY);
  
  //We'll use this boolean to determine if we display the 'Uncategorized' option in the 
  // portlet categories drop down
  boolean noUncategorizedPortlets = false;
  if(uncategorizedPortlets != null && uncategorizedPortlets.isEmpty())
  {
      noUncategorizedPortlets = true;
  }
%>

<!-- If the 'save' button was clicked, go ahead and process the input. -->
<wl:process name="doAction" value="save">
<%
    // the portlet positions string contains portlets in the following format :
    // portletName:placeholder:mandatory:visible,portletName:placeholder:mandatory:visible........
    // We create a vector object which contains each element of the format :
    // portletName:placeholder:mandatory:visible
    String portletPositions = (String)request.getParameter("portletPositions");
    Vector portletNames = new Vector();
    //Remove all of the *'s from the string
    String tempString = "";
    for (int i = 0; i < portletPositions.length(); i ++) 
    {
      if (portletPositions.charAt(i) != '*')
      {
        tempString += portletPositions.charAt(i);
      }
    }
    portletPositions = tempString;
    
    StringTokenizer st = new StringTokenizer(portletPositions, ",");

    while (st.hasMoreTokens()) 
    {
        portletNames.add(st.nextToken());
    }
%>
    <res:setAvailablePortlets groupId="<%= currentGroupPortal %>" pageName="<%= targetPageName %>" portletNames="<%= portletNames %>" />
    <!-- we need to call these tags one more time to make sure we haven't got anything cached -->
    <res:getPage groupPortal="<%=currentGroupPortal%>" pageName="<%=targetPageName%>" id="pagePersonalization"/>
    <res:getLayoutName pagePersonalization="<%=pagePersonalization%>" id="layoutName" />

    <%-- The following form and associated javascript allow for the "page forward" on a successful save --%>  
<%
      //We only want to forward if there have been no generated errors within the tags
      String logId = (String)pageContext.getAttribute("logId");
      if(logId == null)
      {
%>
         <SCRIPT LANGUAGE="JavaScript">
          window.location.replace("<wf:createWebflowURL namespace="admin_portal" origin="select_layouts.jsp" event="link.back"/>");
         </SCRIPT>
<%    }
%>


</wl:process>

<!-- This is where we start the page processing -->
<html>
<head>
  <title><%=pageTitle%></title>
  <LINK REL="StyleSheet" HREF="<wf:createResourceURL resource='<%=cssFile%>'/>" TYPE="text/css" MEDIA="screen">


  <!-- Get some constants that we'll use throughout the page from the i18n file -->
  <i18n:getMessage messageName='spacer' id='spacer'/>
  <i18n:getMessage messageName='all' id='all'/>
  
<script language="JavaScript">
    var visiblePortletArray = new Array();
    var allPortletArray = new Array();
    var listBoxArray = new Array();
    var selectedListBox = null;
    var NN4 = document.layers? true : false; // True if Netscape Navigator 4.x.
    var portletArray = new Array();
    var portletIdArray = new Array();
    portletIdArray[0] = "<%=all%>";
    var portletNameArray = new Array();
    portletNameArray[0] = "<%=all%>";
    var listBoxArray = new Array();
    var pagePortletsArray = new Array();
    var uncategorizedPortlets = new Array();

    if(NN4)
    {
        document.captureEvents(Event.CLICK); 
        document.onclick = handleClick; 
    }

//This function added in order to get Netscape to process the onClick events for the check boxes
function handleClick(event)
{
    var objectClicked = event.target.name;
    if(objectClicked == "mandatoryCheckbox")
    {
        changeMandatory();
    }
    else if(objectClicked == "entAndVisibleCheckbox")
    {
        changeEntAndVisible();
    }
}


    <%-- ----------------------------------------- --%>
    <%-- Retrieve placeable portlets for this page --%>
    <%-- ----------------------------------------- --%>
    <res:getPlaceablePortlets id="it" groupPortal="<%=currentGroupPortal%>" portalName="<%= portalId %>" pagePersonalization="<%= pagePersonalization %>" />
    <res:getPlaceablePortletsPerEntitlement id="listPerEnt" groupPortal="<%=currentGroupPortal%>" portalName="<%= portalId %>" pagePersonalization="<%= pagePersonalization %>" />
    <res:getAvailableOnlyPortletsTag id="availablePortletsIt" groupPortal="<%=currentGroupPortal%>" portalName="<%= portalId %>" pagePersonalization="<%= pagePersonalization %>" />

<%
    while(it.hasNext())
    {
          boolean available = false, visible = false, mandatory = false;
          PortletPersonalization pps = (PortletPersonalization)it.next();
          PlaceholderIdentifier pi = pps.getPlaceholderIdentifier();
          PortletIdentifier ppi = pps.getPortletIdentifier();
          String placeholderName = (pi == null) ? " " : pi.getName();

          if(pps.isAvailable() != null)
             available = pps.isAvailable().booleanValue();

          if(pps.isVisible() != null)
             visible = pps.isVisible().booleanValue();

          if(pps.isMandatory() != null)
             mandatory = pps.isMandatory().booleanValue();
          
          String displayName = pps.getDisplayName();
          if(listPerEnt.contains(pps))
          {
              if(visible)
              {
                  displayName = "*" + displayName;
              }
              else
              {
                  displayName = "*(" + displayName + ")";
              }
          }
%>
          // now add the portlet to an array
          var Portlet = new Array();
          populatePortlet(Portlet,'<%= ppi.getId() %>', '<%= displayName %>', '<%= placeholderName %>', <%= available %>, <%= visible %>, <%= mandatory %>);
          visiblePortletArray[visiblePortletArray.length] = Portlet;
          //Also start building array that will contain all of the portlets
          allPortletArray[allPortletArray.length] = Portlet;
<%
    }
    
    //This loop called just to fill in the missing spaces for the all portlets array
    while(availablePortletsIt.hasNext())
    {
          boolean available = false, visible = false, mandatory = false;
          PortletPersonalization pps = (PortletPersonalization)availablePortletsIt.next();
          PlaceholderIdentifier pi = pps.getPlaceholderIdentifier();
          PortletIdentifier ppi = pps.getPortletIdentifier();
          String placeholderName = (pi == null) ? " " : pi.getName();

          if(pps.isAvailable() != null)
             available = pps.isAvailable().booleanValue();

          if(pps.isVisible() != null)
             visible = pps.isVisible().booleanValue();

          if(pps.isMandatory() != null)
             mandatory = pps.isMandatory().booleanValue();
          
          String displayName = pps.getDisplayName();

%>
          // now add the portlet to an array
          var Portlet = new Array();
          populatePortlet(Portlet,'<%= ppi.getId() %>', '<%= displayName %>', '<%= placeholderName %>', <%= available %>, <%= visible %>, <%= mandatory %>);
          allPortletArray[allPortletArray.length] = Portlet;
<%
    }
    
    //Now, we need to get a list of portlets that are visible solely due to entitlements
    List portletsEntMandatory = new ArrayList();
    Iterator itPerEnt = listPerEnt.iterator();
    while(itPerEnt.hasNext())
    {
      PortletPersonalization ppsPerEnt = (PortletPersonalization)itPerEnt.next();
      PortletIdentifier ppiPerEnt = ppsPerEnt.getPortletIdentifier();
      portletsEntMandatory.add(ppiPerEnt.getId());
    }
%>

    //This will place all of the portlets that belong to this page into the pagePortletsArray
    populateArray(pagePortletsArray);

    //This function goes through the hashmap that contains the ctegory and associated portlet 
    // information and places the information into a two dimensional array in javascript. The 
    // pagePortletsArray array contains arrays that represent the category and portlet information.
    // These arrays contain the category taxonomy information in the first element, then the rest of 
    // the elements are the portlets that belong to the array.
    function populateArray(portlets)
    {
<%
          //Java code that will set up the loop to load the javascript array
          Iterator tempCategoryIt = categoriesAndPortlets.keySet().iterator();
          List categoryPortlets = new ArrayList();
          String categoryValue = "";
          String portletValue = "";
          while(tempCategoryIt.hasNext())
          {
              categoryValue = (String)tempCategoryIt.next();
              categoryPortlets = (List)categoriesAndPortlets.get(categoryValue);
              Iterator categoryPortletsIt = categoryPortlets.iterator();
%>
              var categoryAndPortlets = new Array();
              //Place the category information into the first element of the array
              categoryAndPortlets[0] = "<%=categoryValue%>";
<%
              //This java code actually loops through the portlets list and loads the javascript array
              while(categoryPortletsIt.hasNext())
              {
                  portletValue = (String)categoryPortletsIt.next();
%>
                  //Now, place the portlet information into the array
                  categoryAndPortlets[categoryAndPortlets.length] = "<%=portletValue%>";
<%
              }
%>
              //Load the category/portlets array into the master array
              portlets[portlets.length] = categoryAndPortlets;
<%
          }
%>
    }

function init()
{
    // let us find out all the elements in the form
    
    for(var i=0; i < document.DataForm.elements.length; i++)
    {
        var x = document.DataForm.elements[i];
        // since this is a listbox, we try to populate the portlets
        // into this list box
        if((x.type == "select-one" || x.type == "select-multiple"))
        {
            listBoxArray[listBoxArray.length] = x;
            populatePlaceholder(x);
        }
        
    }       
    
    // now try to find the portlets that have not been placed
    // and put them in the in each list box.
    storeUnplacedPortlets();

    //We won't have anything selected, so hide the attributes
    hideAttributes();

    //Now, build up our original portlet list
    buildPortletList();
    getUncategorizedPortlets();

}

function buildPortletList()
{
    // we store the portlet positions a comma separated way with the format :
    // portletName1:placeholder:mandatory:visible,portletName2:placeholer:mandatory:visible.......
    // this will help us quickly create an vector to pass on to the tag
    
    // iterate through the list box array and find the portlets present
    var portletList = "";
    for(var i=0; i <  listBoxArray.length; i++)
    {
        portletList = addPortlet(listBoxArray[i], portletList);
    }
    portletList = addPortlet(document.availablePortletsForm.availablePortlets, portletList);
    
    this.document.DataForm.portletPositions.value = portletList;
}

function addPortlet(listBox, portletList)
{
    var optionArray = listBox.options;
    if(optionArray.length > 1 && portletList != "")
    {
        portletList += ",";
    }

    for(var j=0; j <  optionArray.length-1; j++)
    {
         var portletName = optionArray[j].value;
         //While we're dealing with all of the portlets on the page, we'll also build up two 
         // arrays, one to hold the portlets that belong to the page and one that holds 
         // the portlets id's
         var Portlet = new Array();
         populatePortlet(Portlet, optionArray[j].value, optionArray[j].text, listBox.name );
         portletArray[portletArray.length] = Portlet;
         portletIdArray[portletIdArray.length] = optionArray[j].value;
         portletNameArray[portletNameArray.length] = stripOutName(optionArray[j].value);

         if(j == optionArray.length-2) 
         {
            portletList += stripOutName(portletName) + ":" + listBox.name;
         } else 
         {
            portletList += stripOutName(portletName) + ":" + listBox.name + ",";
         }
    }

    return portletList;
}

// submit the form and save portlet positions
function submitForm()
{
    updatePortletList();
    this.document.DataForm.submit();
}

function stripOutName(fullName)
{
    var stripFrom = fullName.lastIndexOf("/");
    return fullName.substring(stripFrom + 1, fullName.length);
}

function storeUnplacedPortlets()
{
    var totalPlaceholders = listBoxArray.length;
    var currentPlaceholder = 0;
    var unplacedPortlets = false;
    
    for(var i=0; i < visiblePortletArray.length; i++)
    {
        var portlet = visiblePortletArray[i];
        if(portlet.isPlaced == 0)
        {
            insertOption(listBoxArray[currentPlaceholder], portlet.name, portlet.id, false);
            listBoxArray[currentPlaceholder].selectedIndex = -1;

            portlet.isPlaced = 1;

            currentPlaceholder++;
            if(currentPlaceholder == totalPlaceholders) 
            {
               currentPlaceholder = 0;
            }
            unplacedPortlets = true;
        }
    }

    if(unplacedPortlets == true) 
    {
        alert('<i18n:getMessage messageName='unplacedPortlets'/>');
    }
}


// populate the matching portlets with this listbox
function populatePlaceholder(listBox)
{
    for(var i=0; i < visiblePortletArray.length; i++)
    {
        var portlet = visiblePortletArray[i];
        if(portlet.placeholder == listBox.name) 
        {
            portlet.isPlaced = 1;
            insertOption(listBox, portlet.name, portlet.id, false);
        }
    }
    listBox.selectedIndex = -1;
}

// insert a value into the options array, moving the spacer at the bottom
function insertOption(listBox, name, value, removeOld)
{
    var optionArray = listBox.options;
    var spacerText = optionArray[optionArray.length-1].text;
    var spacerVal  = optionArray[optionArray.length-1].value;
    
    eval("optionArray[optionArray.length-1].text = name");
    eval("optionArray[optionArray.length-1].value = value");
    
    eval("listBox.selectedIndex = optionArray.length-1");
    
    var option = new Option(spacerText, spacerVal);
    eval("listBox.options[optionArray.length]=option");      
    
    // remove the option from the origin
    if(selectedListBox != null && removeOld)
    {
        selectedListBox.options[selectedListBox.selectedIndex] = null;
        selectedListBox.selectedIndex = -1;
    }
}

// on selecting a placeholder - portlet, remove selections for other placeholders
function changePortletSelection(placeholder)
{
    //First, let's take focus away from the 'Available' select box if a portlet has been selected on the layout.
    if(placeholder.name != "availablePortlets")
    {
        document.availablePortletsForm.availablePortlets.selectedIndex = -1;
    }

    if(placeholder.selectedIndex != -1 && placeholder.options[placeholder.selectedIndex].value == "spacer")
    {
       placeholder.selectedIndex = -1;
       selectedListBox = null;
       hideAttributes();
    } else 
    {
       selectedListBox = placeholder;
    }

    // now set the selected index of all list boxes to -1        
    for(var i = 0; i < listBoxArray.length; i++)
    {
        if(listBoxArray[i].name != placeholder.name) 
        {
            listBoxArray[i].selectedIndex = -1;
        } 
        else if (placeholder.selectedIndex != -1) 
        {
            // iterate through the portlet array to find correct attributes
            for(var j=0; j<allPortletArray.length; j++)
            {
                var portlet = allPortletArray[j];
                var placeholderValue = "";
                if(NN4)
                {
                    placeholderValue = placeholder.options[placeholder.selectedIndex].value;
                }
                else
                {
                    placeholderValue = placeholder.options[placeholder.selectedIndex].value;
                }
                if(portlet.id == placeholderValue)
                {
                   var entPortlets = "<%=portletsEntMandatory%>";
                   var portletEntMandatory = false;
                   if(entPortlets.indexOf(portlet.id) != -1)
                   {
                       portletEntMandatory = true;
                   }
                   showAttributes(portletEntMandatory, portlet.visible, portlet.mandatory);
                }
            }

        }
    }
}

function populatePortlet(portlet, id, name, placeholder, available, visible, mandatory)
{
    portlet.id          = id;
    portlet.name        = name;
    portlet.placeholder = placeholder;
    portlet.isPlaced    = 0;   // whether this portlet is placed in a placeholder or not. 0 = false, 1 = true
                              // we use this variable to in the init tag when placing portlets in the listboxes.
    portlet.available   = available;
    portlet.visible     = visible;
    portlet.mandatory   = mandatory
} 

//
// Functions to move portlets around
//


// move a portlet to the right within placeholders
function moveRightInternal()
{
    if (noSelection())
    {
        alert("<i18n:getMessage messageName='selectPortletFirst'/>");
        return;
    }      

    // find the index of the current selected list box
    var index = selectedListBoxIndex();
    var portletId = selectedListBox.options[selectedListBox.selectedIndex].value;

    if(index != -1)
    {
        // find the index where you want to move the portlet
        index = (index == listBoxArray.length-1) ? 0 : index+1;
        
        var targetListBox = listBoxArray[index];
        var placeholderName = targetListBox.name;

        insertOption(targetListBox, selectedListBox.options[selectedListBox.selectedIndex].text, selectedListBox.options[selectedListBox.selectedIndex].value, true);

        selectedListBox = targetListBox;

        //This function updates the new placeholder info in the portlet info string
        changePlaceholder(stripOutName(portletId), placeholderName);
    }
}

// move a portlet to the left within placeholders
function moveLeftInternal()
{
    if (noSelection())
    {
        alert("<i18n:getMessage messageName='selectPortletFirst'/>");
        return;
    }      

    // find the index of the current selected list box
    var index = selectedListBoxIndex();
    var portletId = selectedListBox.options[selectedListBox.selectedIndex].value;

    if(index != -1)
    {
        // find the index where you want to move the portlet
        index = (index == 0) ? listBoxArray.length-1 : index-1;
        
        var targetListBox = listBoxArray[index];
        var placeholderName = targetListBox.name;

        insertOption(targetListBox, selectedListBox.options[selectedListBox.selectedIndex].text, selectedListBox.options[selectedListBox.selectedIndex].value, true);

        selectedListBox = targetListBox;      
        
        //This function updates the new placeholder info in the portlet info string
        changePlaceholder(stripOutName(portletId), placeholderName);
    }
}

function moveUp()
{
    if (noSelection())
    {
        alert("<i18n:getMessage messageName='selectPortletFirst'/>");
        return;
    }      

    // if we are already in the first postion, or have selected a portlet in the wrong box, 
    // do not do anything
    if(selectedListBox.selectedIndex == 0 || selectedListBox.name == "availablePortlets")
        return;

    // swap the value with the item before the current one.
    var currText = selectedListBox.options[selectedListBox.selectedIndex].text;
    var currVal  = selectedListBox.options[selectedListBox.selectedIndex].value;
    var swapVal = selectedListBox.options[selectedListBox.selectedIndex-1].value;

    selectedListBox.options[selectedListBox.selectedIndex].text = selectedListBox.options[selectedListBox.selectedIndex-1].text;

    selectedListBox.options[selectedListBox.selectedIndex].value = selectedListBox.options[selectedListBox.selectedIndex-1].value;

    selectedListBox.options[selectedListBox.selectedIndex-1].text=currText;
    selectedListBox.options[selectedListBox.selectedIndex-1].value=currVal;

    selectedListBox.selectedIndex--;

    //This function updates the new placement info in the portlet info string
    swapPortlets(stripOutName(currVal), stripOutName(swapVal));
}

function moveDown()
{
    if (noSelection())
    {
        alert("<i18n:getMessage messageName='selectPortletFirst'/>");
        return;
    }      

    // if we are already in the last postion, or have selected a portlet in the wrong box, 
    // do not do anything
    if(selectedListBox.selectedIndex == selectedListBox.length-2 || selectedListBox.name == "availablePortlets")
        return;

    // swap the value with the item before the current one.
    var currText = selectedListBox.options[selectedListBox.selectedIndex].text;
    var currVal  = selectedListBox.options[selectedListBox.selectedIndex].value;
    var swapVal = selectedListBox.options[selectedListBox.selectedIndex+1].value;

    selectedListBox.options[selectedListBox.selectedIndex].text = selectedListBox.options[selectedListBox.selectedIndex+1].text;

    selectedListBox.options[selectedListBox.selectedIndex].value = selectedListBox.options[selectedListBox.selectedIndex+1].value;

    selectedListBox.options[selectedListBox.selectedIndex+1].text=currText;
    selectedListBox.options[selectedListBox.selectedIndex+1].value=currVal;

    selectedListBox.selectedIndex++;

    //This function updates the new placement info in the portlet info string
    swapPortlets(stripOutName(currVal), stripOutName(swapVal));
}


function selectedListBoxIndex()
{
    if(selectedListBox == null)
        return -1;

    for(var i = 0; i < listBoxArray.length; i++)
    {
        if(listBoxArray[i].name == selectedListBox.name) 
        {
            return i;
        }
    }
    
    return -1;
}
    
function noSelection()
{      
    if (selectedListBox == null)
        return true;
    else if(selectedListBox.selectedIndex < 0)  // if not yet selected anything
        return true;    
    else 
        return false;
}

function hideAttributes()
{
    if(NN4)
    {
        // Begin Netscape 4 logic
        document.layers.attributesTitle.visibility = "hidden";
        document.layers.mandatory.visibility = "hidden";
        document.layers.entAndVisible.visibility = "hidden";
    }
    else
    {
        // Begin IE5+ and Netscape 6+ logic
        document.getElementById('attributesTitle').style.visibility = "hidden";
        document.getElementById('mandatory').style.visibility = "hidden";
        document.getElementById('entAndVisible').style.visibility = "hidden";

    }
}

//This function decides what to show, and then correctly marks the checkboxes
function showAttributes(showVisible, visibleVal, mandatoryVal)
{
    if(NN4)
    {
        // Begin Netscape 4 logic
        document.layers.attributesTitle.visibility = "show";
        document.layers.mandatory.visibility = "show";

        if(showVisible == true)
        {
            document.layers.entAndVisible.visibility = "show";
            if(visibleVal == true)
            {
                document.layers["entAndVisible"].document.forms["entAndVisibleForm"].elements["entAndVisibleCheckbox"].checked = true;
            }
            else
            {
                document.layers["entAndVisible"].document.forms["entAndVisibleForm"].elements["entAndVisibleCheckbox"].checked = false;
            }
        }
        else
        {
            document.layers.entAndVisible.visibility = "hidden";
        }

        if(mandatoryVal == true)
        {
            document.layers["mandatory"].document.forms["mandatoryForm"].elements["mandatoryCheckbox"].checked = true;
        }
        else
        {
            document.layers["mandatory"].document.forms["mandatoryForm"].elements["mandatoryCheckbox"].checked = false;
        }
    }
    else
    {
        // Begin IE5+ and Netscape 6+ logic
        document.getElementById('attributesTitle').style.visibility = "visible";
        document.getElementById('mandatory').style.visibility = "visible";

        if(showVisible == true)
        {
            document.getElementById('entAndVisible').style.visibility = "visible";
            if(visibleVal == true)
            {
                document.getElementById('entAndVisibleCheckbox').checked = true;
            }
            else
            {
                document.getElementById('entAndVisibleCheckbox').checked = false;
            }
        }
        else
        {
            document.getElementById('entAndVisible').style.visibility = "hidden";
        }

        if(mandatoryVal == true)
        {
            document.getElementById('mandatoryCheckbox').checked = true;
        }
        else
        {
            document.getElementById('mandatoryCheckbox').checked = false;
        }
    }
}

//This function is called solely to remove the focus from the 'layout' portion of the page
function removeFocus()
{
    //We start at 3 because the webflow form adds three elements at the begining of 
    // the form (origin, event, and namespace)
    //We end with -3 because we add three hidden elements onto the form
    for(i=3;i<document.DataForm.elements.length-3;i++)
    {
        var elementName = document.DataForm.elements[i].name;
        eval("document.DataForm."+elementName+".selectedIndex=-1");
    }
    hideAttributes();
    if(document.availablePortletsForm.availablePortlets.options.value == "spacer")
    {
       document.availablePortletsForm.availablePortlets.selectedIndex = -1;
    }
    changePortletSelection(document.availablePortletsForm.availablePortlets)

}

//This function moves portlets from the available list to the 'layout', or visible list
function makeVisible()
{
    var names = new Array();
    var values = new Array();
    var optionNumber = new Array();
    for(var i=0;i<document.availablePortletsForm.availablePortlets.length;i++)
    {
        if(document.availablePortletsForm.availablePortlets[i].selected== true)
        {
            names[names.length] = document.availablePortletsForm.availablePortlets[i].text;
            values[values.length] = document.availablePortletsForm.availablePortlets[i].value;
            optionNumber[optionNumber.length] = i;

        }
    }
    
    if (values.length > 0)
    {
        var elementName = document.DataForm.elements[3].name;
        var placeholder = eval("document.DataForm."+elementName);
        
        for(var j=0;j<values.length;j++)
        {
            var value = values[j];
            var name = names[j];
            
            addVisible(value);
            addSelection(name, value, placeholder);
            removeSelection(optionNumber[j]-j, document.availablePortletsForm.availablePortlets);
        
            //These functions update the new placeholder info in both the portlet info string and the 
            // master portlet array 
            changePlaceholder(stripOutName(value), placeholder.name);
            updatePortletArray(stripOutName(value), placeholder.name);
        }
    }
    
    
    //We're going to set the focus to the portlet we just moved over.  We need to subtract 2 
    // from the length.  One for 0 indexing and one for the spacer.
    document.DataForm.elements[3].selectedIndex = document.DataForm.elements[3].length - 2;
    document.DataForm.elements[3].focus();
    selectedListBox = document.DataForm.elements[3];

    //Now we need to find the portlet's attributes so we can show them
    var placeholderValue = document.DataForm.elements[3].options[document.DataForm.elements[3].selectedIndex].value;
    // iterate through the portlet array to find correct attributes
    for(var k=0; k<allPortletArray.length; k++)
    {
        var portlet = allPortletArray[k];
        var placeholderValue = placeholder.options[placeholder.selectedIndex].value;
        if(portlet.id == placeholderValue)
        {
           var entPortlets = "<%=portletsEntMandatory%>";
           var portletEntMandatory = false;
           if(entPortlets.indexOf(portlet.id) != -1)
           {
               portletEntMandatory = true;
           }
           showAttributes(portletEntMandatory, portlet.visible, portlet.mandatory);
        }
    }
}

//This function moves portlets from the 'layout', or visible list, to the available list.  By doing so, 
//we need to nullify all attributes
function makeAvailable()
{
    //We start at 3 because the webflow form adds three elements at the begining of 
    // the form (origin, event, and namespace)
    //We end with -3 because we add three hidden elements onto the form
    for(var i=3;i<document.DataForm.elements.length-3;i++)
    {
        var elementName = document.DataForm.elements[i].name;
        var selected = eval("document.DataForm."+elementName+".selectedIndex");
        var movePortlet = true;

        if (selected != -1)
        {
            var text = eval("document.DataForm."+elementName+".options[selected].text");
            var value = eval("document.DataForm."+elementName+".options[selected].value");
            if(!listContain("<%=portletsEntMandatory%>", value))
            {
                if(isMandatory(value))
                {
                    if(!confirm("<i18n:getMessage messageName='confimMove'/>"))
                    {
                        movePortlet = false;
                        removeFocus();
                    }
                }
                if(movePortlet)
                {
                    removeAttributes(value);
                    if(portletBelongToCategory(selectedListBox.options[selectedListBox.selectedIndex].value))
                    {
                        addSelection(text, value, document.availablePortletsForm.availablePortlets);
                    }
                    removeSelection(selected, eval("document.DataForm."+elementName));
                }
            }
            else
            {
                removeFocus();
                alert("<i18n:getMessage messageName='cantMovePortlet'/>");
            }
            
            //These functions update the new placeholder info in both the portlet info string and the 
            // master portlet array 
            changePlaceholder(stripOutName(value), document.availablePortletsForm.availablePortlets.name);
            updatePortletArray(stripOutName(value), document.availablePortletsForm.availablePortlets.name);
        }
    }

    //Don't show the attributes for 'Available' portlets
    hideAttributes();

}

//Removes the specified portlet from the specified select box
function removeSelection(selectedIndex, selectName)
{
    var length = selectName.length;

    for (var x=selectedIndex; x< length-1; x++)
    {
        var idx = x;
        idx++;
        eval("mValue=selectName.options[" + idx + "].value");
        eval("mText=selectName.options[" + idx + "].text");
    
        eval("selectName.options[" + x + "].value=" + "mValue");
        eval("selectName.options[" + x + "].text=" + "mText");
    
    }
    selectName.length = length - 1;
    selectName.selectedIndex = -1;
}

//Adds the specified portlet (with display name and value) to the specified select box
function addSelection(text, value, selectName)
{
    var length = selectName.length;
    eval("spacerText=selectName.options["+(length-1)+"].text");
    eval("spacerValue=selectName.options["+(length-1)+"].value");

    selectName.length=length + 1;
    eval("selectName.options["+(length-1)+"].text=text");
    eval("selectName.options["+(length-1)+"].value=value");
    eval("selectName.options["+length+"].text=spacerText");
    eval("selectName.options["+length+"].value=spacerValue");
}

//Helper function.  Used when the list was created in a scriptlet and the value is a javascript value
function listContain(list, value)
{
    if(list.indexOf(value) == -1)
    {
        return false;
    }
    else
    {
        return true;
    }
}

//Removes the attributes from a portlet
function removeAttributes(portletName)
{
    for(i=0;i<allPortletArray.length;i++)
    {
        var portlet = allPortletArray[i];
        if(portlet.id == portletName)
        {
            portlet.mandatory = false;
            portlet.visible = false;
        }
    }
}

//Makes the specified portlet visible attribute true
function addVisible(portletName)
{
    for(i=0;i<allPortletArray.length;i++)
    {
        var portlet = allPortletArray[i];
        if(portlet.id == portletName)
        {
            portlet.visible = true;
        }
    }
}

//Changes a portlets mandatory attribute once the checkedbox is checked
function changeMandatory()
{
    var isMandatory = true;
    if(NN4)
    {
        isMandatory = document.layers["mandatory"].document.forms["mandatoryForm"].elements["mandatoryCheckbox"].checked;
    }
    else
    {
        isMandatory = document.getElementById('mandatoryCheckbox').checked;
    }
    for(i=3;i<document.DataForm.elements.length-3;i++)
    {
        var elementName = document.DataForm.elements[i].name;
        var selected = eval("document.DataForm."+elementName+".selectedIndex");
        if (selected != -1)
        {
            var value = eval("document.DataForm."+elementName+".options[selected].value");
        }
    }
    for(var j=0; j<allPortletArray.length; j++)
    {
        var portlet = allPortletArray[j];
        if(portlet.id == value)
        {
           portlet.mandatory = isMandatory;
        }
    }

}

function isMandatory(value)
{
    var returnValue;
    for(var i=0; i<allPortletArray.length; i++)
    {
        var portlet = allPortletArray[i];
        if(portlet.id == value)
        {
           returnValue = portlet.mandatory;
           break;
        }
    }
    return returnValue;
}

//Changes a portlets visible attribute once the checkedbox is checked
function changeEntAndVisible()
{
    var isVisible = true;
    if(NN4)
    {
        isVisible = document.layers["entAndVisible"].document.forms["entAndVisibleForm"].elements["entAndVisibleCheckbox"].checked;
    }
    else
    {
        isVisible = document.getElementById('entAndVisibleCheckbox').checked;
    }
    for(i=3;i<document.DataForm.elements.length-3;i++)
    {
        var elementName = document.DataForm.elements[i].name;
        var selected = eval("document.DataForm."+elementName+".selectedIndex");
        if (selected != -1)
        {
            var value = eval("document.DataForm."+elementName+".options[selected].value");
            var display = eval("document.DataForm."+elementName+".options[selected].text");
            var index = selected;
            var selectedElement = elementName;
        }
    }
    for(var j=0; j<allPortletArray.length; j++)
    {
        var portlet = allPortletArray[j];
        if(portlet.id == value)
        {
           portlet.visible = isVisible;
        }
    }
    
    //First, we need to strip off any *'s and/or ()'s that we've added to the display name
    if(isVisible)
    {
        display = display.substring(2, display.length -1);
    }
    else
    {
        display = display.substring(1, display.length);
    }
    //Now, we're going to add back the appropriate combo of *'s and ()'s, depending on what the user chose
    if(isVisible)
    {
        var tempOption = new Option("*"+display, value);
    }
    else
    {
        var tempOption = new Option("*("+display+")", value);
    }
    eval("document.DataForm."+selectedElement+".options["+index+"] = tempOption");
    eval("document.DataForm."+selectedElement+".options["+index+"].selected = true");
}


function removeFromPortletList(portlet)
{
    var portletList = new String(this.document.DataForm.portletPositions.value);

    //First thing is to remove the portlet and old placeholder information.
    //We Start by getting the begining and ending indexes of the portlet/placeholder info
    var beginIndex = portletList.indexOf(portlet + ":");
    var endIndex = portletList.indexOf(",", beginIndex);

    //Only bother with the remove if the portlet is in the list
    if(beginIndex != -1)
    {
        //Now, get the substring of what we're going to remove.  We have to consider if the 
        // portlet/placeholder info is at the end of the list, there will be no comma to remove, 
        // otherwise we'll have to remove a comma with the other info.
        
        //We didn't find a comma after the string, therefore we're at the end of the list.
        if(endIndex == -1)
        {
            endIndex = portletList.length;
            //Because we're at the end of the list, we'll need to remove the previous comma.
            beginIndex = beginIndex - 1;
        }
        //Add one to remove the next comma
        else
        {
            endIndex = endIndex + 1;
        }
        var removeString = portletList.substring(beginIndex, endIndex);
        
        //Now, remove the string by doing a replace with nothing ("")
        portletList = portletList.replace(removeString, "");
    }

    //Now, reset our portlet positions variable
    this.document.DataForm.portletPositions.value = portletList;
}

//This function updates the master portlet info string when a portlet changes placeholders
function changePlaceholder(portlet, placeholder)
{
    //First, remove the portlet from the list, then get the updated list
    removeFromPortletList(portlet);
    var portletList = new String(this.document.DataForm.portletPositions.value);

    //Now, add in the new portlet/placeholder info
    //We need to find the last occurance of the placeholder we're working with and add the new
    // info right after that.  We use the ':' in the search so we are sure we find the placeholder 
    // name and not a substring of a portlet name, or other placeholder name.
    var lastPlaceholder = portletList.lastIndexOf(":" + placeholder);
    //We calculate the insert index by adding the length of the placeholder name, plus we add one 
    // for the ':' we use for the search
    var insertIndex = lastPlaceholder + placeholder.length + 1;

    //The case where we are moving a portlet to an empty placeholder.
    if(lastPlaceholder == -1)
    {
        //The case that there is only one portlet on the page.  If this is the case, we can just 
        // add the portlet/placeholder info
        if(portletList.length == 0)
        {
            portletList = portlet + ":" + placeholder;
        }
        //If there are other portlets, but none in the placeholder, we'll just add the info to 
        // the end of the list.
        else
        {
            portletList = portletList + "," + portlet + ":" + placeholder;
        }
    }
    //The case where there are other portlets in the placeholder
    else
    {
        //The case that we're adding to the end of the list
        if(portletList.indexOf(",", lastPlaceholder) == -1)
        {
            portletList = portletList + "," + portlet + ":" + placeholder;
        }
        //The case where we're adding in the middle of the list
        else
        {
            portletList = portletList.substring(0, insertIndex) + "," + portlet + ":" + placeholder + portletList.substring(insertIndex, portletList.length);
        }
    }

    //Now, reset our portlet positions variable
    this.document.DataForm.portletPositions.value = portletList;
}

//This function swaps two portlets within the master portlet info string.
function swapPortlets(firstPortlet, secondPortlet)
{
    var portletList = new String(this.document.DataForm.portletPositions.value);
    
    //First, we add a ':' onto our portlet strings.  We do this so we don't get the portlet 
    // names confused with any other substrings that might be equal to the portlet names
    firstPortlet = firstPortlet + ":";
    secondPortlet = secondPortlet + ":";

    //Next, we need to find our portlets in the portlet list
    var indexFirstPortlet = portletList.indexOf(firstPortlet);
    var indexSecondPortlet = portletList.indexOf(secondPortlet);

    //Now, we can swap the two portlet names.  We don't have to worry about placeholder info as 
    // both portlets will have to be in the same placeholder if they're switching order.
    //We have to consider which comes first in the list before we can swap.
    if(indexFirstPortlet < indexSecondPortlet)
    {
        portletList = portletList.substring(0, indexFirstPortlet) + secondPortlet + portletList.substring(indexFirstPortlet + firstPortlet.length, indexSecondPortlet) + firstPortlet + portletList.substring(indexSecondPortlet + secondPortlet.length, portletList.length);
    }
    else
    {
        portletList = portletList.substring(0, indexSecondPortlet) + firstPortlet + portletList.substring(indexSecondPortlet + secondPortlet.length, indexFirstPortlet) + secondPortlet + portletList.substring(indexFirstPortlet + firstPortlet.length, portletList.length);
    }
    //Now, reset our portlet positions variable
    this.document.DataForm.portletPositions.value = portletList;
}

function updatePortletList()
{
   var portletList = new String(this.document.DataForm.portletPositions.value);
   
   var mandatory = "";
   var visible = "";
   var tempPortletList = "";
   var portletName = "";
   var placeholder = "";
   
   var tokenIndex = portletList.indexOf(":");
   var separatorIndex = portletList.indexOf(",");

   while(tokenIndex != -1)
   {
       portletName = portletList.substring(0, tokenIndex);
       if(separatorIndex == -1)
       {
           placeholder = portletList.substring(tokenIndex+1, portletList.length);
           portletList = "";
       }
       else
       {
           placeholder = portletList.substring(tokenIndex+1, separatorIndex);
           portletList = portletList.substring(separatorIndex+1, portletList.length);
       }
       
       tokenIndex = portletList.indexOf(":");
       separatorIndex = portletList.indexOf(",");

       //We must pick out the portlets attributs from the portlet array so we can pass the 
       // information on, in case it was changed by the user
       for(k=0;k<allPortletArray.length;k++)
       {
           var portlet = allPortletArray[k];
           if(stripOutName(portlet.id) == portletName)
           {
               mandatory = portlet.mandatory;
               visible = portlet.visible;
               break;
           }
       }
       tempPortletList = tempPortletList + portletName + ":" + placeholder + ":" + mandatory + ":" + visible + ",";
   }

   portletList = tempPortletList.substring(0, tempPortletList.length-1);
   this.document.DataForm.portletPositions.value = portletList;
}

//This function determines if the portlet passed in belongs to the category that the 
// user has selected
function portletBelongToCategory(portletId)
{
    var returnValue = false;
    var categoriesExist = false;
    for(var elementCount=0;elementCount<document.CategoryForm.elements.length;elementCount++)
    {
      if(document.CategoryForm[elementCount].name == "portletCategories")
      {
        categoriesExist = true;
        break;
      }
    }
    
    if(categoriesExist)
    {
        var selectedCategory = document.CategoryForm.portletCategories.options[document.CategoryForm.portletCategories.selectedIndex].value;
    
        //If the selected category is the 'Show All' category, return true since every portlet 
        // falls under this category.
        if(selectedCategory == "<%=all%>") 
        {
            returnValue = true;
        }
        //Otherwise, we need to loop through our master array, find the array that contains the 
        // selected category, and then loop through that categories portlets.  We return true if we find it.
        else
        {
            for(var i=0;i<pagePortletsArray.length;i++)
            {
                if(pagePortletsArray[i][0] == selectedCategory)
                {
                    for(var j=1;j<pagePortletsArray[i].length;j++)
                    {
                        if(pagePortletsArray[i][j] == stripOutName(portletId))
                        {
                            returnValue = true;
                            break;
                        }
                    }
                }
            }
        }
    }
    else
    {
        returnValue = true;
    }
    
    return returnValue;
}

//This function updates placeholder info in the master portlet array
function updatePortletArray(portletId, placeholder)
{

    for(var i=0;i<portletArray.length;i++)
    {
        if(portletId == stripOutName(portletArray[i].id))
        {
            portletArray[i].placeholder = placeholder;
        }
    }

}

//This function takes in an array of portlets and then displays only those portlets in the 
// 'Available but not Visible' select box
function filterPortlets(portlets)
{
    //Clear out portlets from the select box
    var optionArray = document.availablePortletsForm.availablePortlets.options;
    var spacerText = optionArray[optionArray.length-1].text;
    var spacerVal  = optionArray[optionArray.length-1].value;

    optionArray.length= 1;
    optionArray[0].text = spacerText;
    optionArray[0].value = spacerVal;
    
    //load select box using insertOption and Portlet object.  we have to go through these loops 
    // to get the portlet ifo from the master portlet array
    for(var i=1;i<portlets.length;i++)
    {
        for(var j=0;j<portletArray.length;j++)
        {
            if(portlets[i] == stripOutName(portletArray[j].id))
            {
                if(portletArray[j].placeholder == "availablePortlets")
                {
                    insertOption(document.availablePortletsForm.availablePortlets, portletArray[j].name, portletArray[j].id, false);
                }
                break;
            }
        }
    }
}

//This functions loads the uncategorized array with portlets that belong to the 
// root portlet directory ("portlets").
function getUncategorizedPortlets()
{
    //We want this array to follow the same structure where the first element represents the 
    // category the rest of the elements (portlets) belong to.
    uncategorizedPortlets[0] = "<%=AdminResourceConstants.ROOT_PORTLETS_DIRECTORY%>";
<%
    //Java code to loop through the uncategorized portlets list
    if(uncategorizedPortlets != null)
    {
        Iterator uncategorizedPortletsIt = uncategorizedPortlets.iterator();
        while(uncategorizedPortletsIt.hasNext())
        {
%>
            uncategorizedPortlets[uncategorizedPortlets.length] = "<%=uncategorizedPortletsIt.next()%>";
<%
        }
    }
%>
}


//This function is called when the user selects a category from the drop down list.  It 
// determines what category was selected and then passes the correct array of portlets into 
// the filtering function
function selectCategory()
{
    var selectedCategory = document.CategoryForm.portletCategories.options[document.CategoryForm.portletCategories.selectedIndex].value;

    //If the spacer was chosen, then we'll just put them up to the "Show All" option
    if(selectedCategory == "<%=spacer%>")
    {
        document.CategoryForm.portletCategories.options.selectedIndex = 0;
        selectedCategory = "<%=all%>";
    }

    if(selectedCategory == "<%=all%>")
    {
        filterPortlets(portletNameArray);
    }
    else if(selectedCategory == "<%=AdminResourceConstants.ROOT_PORTLETS_DIRECTORY%>")
    {
        filterPortlets(uncategorizedPortlets);
    }
    else
    {
        for(i=0;i<pagePortletsArray.length;i++)
        {
            if(pagePortletsArray[i][0] == selectedCategory)
            {
                filterPortlets(pagePortletsArray[i]);
            }
        }
    }

    removeFocus();
}
</script>
</head>
<BODY BGCOLOR="white" onLoad="init()" leftmargin="0" rightmargin="0" marginwidth="0" marginheight="0" STYLE='BACKGROUND-IMAGE:url("<wf:createResourceURL resource='<%=imagesPath + "bg_subpage.gif"%>'/>"); BACKGROUND-REPEAT: no-repeat; BACKGROUND-POSITION:left top;'>

<%@ include file="/tools/util/admin_header.inc"%>

<!-- This is the user table that contains two table data cells: one for the left nav, the other for the main page layout -->
<TABLE border="0" cellspacing="0" cellpadding="0" width="95%" height="100%">
  <TR>
    <TD align="left" valign="top" class="sidenav" width="1%">
      <!-- include  table for left nav bar -->
      <jsp:include page="left_navbar.jsp"/>
    </TD>
    
    <TD align="center" valign="top" width="2%">
      <!-- spacer cell -->
      &nbsp;&nbsp;
    </TD>

    <!-- begin table cells for main content area -->
    <TD align="left" valign="top" width="95%">
<%
      // Creation of message arguments
      Object[] args = new Object[] { targetPageName };
%>
      <span class="pageheader"><i18n:getMessage messageName='portalDisplay' messageArgs='<%=args%>'/></span><BR>
      <span class="instructions"><i18n:getMessage messageName='portalDisplaySubHead'/></span>

      
<%
      // number of labels in category listing header section
      int numberOfLabels = 3;
%>

      <wf:form namespace="admin_portal"  event="link.refresh" origin="select_portlets.jsp" hide="true" method="post" name="CategoryForm">
<%
        //We do this check because we only want to show the drop down if there's more than one
        // category in our hashmap (if there's only one, that is the root directory and there 
        // are no 'real' categories)
        if(categoriesAndPortlets.size() > 1)
        {
%>
          <TABLE cellspacing="0" cellpadding="0" border="0" width="1%">
            <TR>
              <!-- Green Title Bar for the portlet categories select box -->
              <TD align="left" valign="top" WIDTH="1%">
                <TABLE cellspacing="0" cellpadding="0" border="0" width="100%">
                  <TR>
                    <!-- category listing left hand side -->
                    <TD align="left" valign="top" rowspan="2"><jsp:include page="category_list_header_lhs.jsp"/></TD>
                    <!-- It may seem strange to put a td width of 1000 in here, but after much trial and error this is the only way Netscape will maintain the fixed border widths along with the liquid, stretchable layout of the table -->
                    <TD class="categoryHeadingBorderCell" colspan="<%=numberOfLabels%>" height="1px" width="1000"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
                    <!-- category listing right hand side -->
                    <TD align="left" valign="top" rowspan="2"><jsp:include page="category_list_header_rhs.jsp"/></TD>
                  </TR>
                  <TR>
                    <!-- * START LABELS -->
                    <TD class="categoryHeadingCell" colspan="3" nowrap>
                      <i18n:getMessage messageName='portletCategories'/>
                    </TD>
                    <!-- * END LABELS  -->
                  </TR>
                  <!-- This creates the dark green line at the bottom of the green header -->
                  <TR>
                    <TD class="categoryHeadingBorderCell" colspan="<%=numberOfLabels + 2%>" height="1"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
                  </TR>
                </TABLE>
              </TD>
            </TR>
            <TR>
              <TD>
                  <select name="portletCategories" size="1" onChange='selectCategory()'>
                    <option value="<%=all%>" selected><i18n:getMessage messageName='showAll'/></option>
<%
                    if(!noUncategorizedPortlets)
                    {
%>
                      <option value="<%=AdminResourceConstants.ROOT_PORTLETS_DIRECTORY%>"><i18n:getMessage messageName='uncategorized'/></option>
<%                  
                    }
%>
                    <option value="<%=spacer%>">----------------------------------------</option>
<%                          
                    //We want to display all of the categories in the list, except for the 
                    // root category, which will be represented by the "Uncategorized" option
                    String category = null;
                    Iterator categoryIt = categoryDisplayList.iterator();
                    while(categoryIt.hasNext())
                    {
                      category = (String)categoryIt.next();
                      if(!displayNameMap.get(category).equals(AdminResourceConstants.ROOT_PORTLETS_DIRECTORY))
                      {
%>
                        <option value="<%=displayNameMap.get(category)%>"><%=category%></option>  
<%
                      }
                    }
%>
                  </select>
              </TD>
            </TR>
          </TABLE>      
<%
        }
%>
      </wf:form>
            
      <BR>
      
      <!-- Begin Tab Table -->      
      <TABLE cellspacing="0" cellpadding="0" border="0" width="100%">
        <TR>
      
          <!-- Green Title Bar for the available portlets select box -->
          <TD align="left" valign="top" WIDTH="1%">
            <TABLE cellspacing="0" cellpadding="0" border="0" width="100%">
              <TR>
                <!-- category listing left hand side -->
                <TD align="left" valign="top" rowspan="2"><jsp:include page="category_list_header_lhs.jsp"/></TD>
                <!-- It may seem strange to put a td width of 1000 in here, but after much trial and error this is the only way Netscape will maintain the fixed border widths along with the liquid, stretchable layout of the table -->
                <TD class="categoryHeadingBorderCell" colspan="<%=numberOfLabels%>" height="1px" width="1000"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
                <!-- category listing right hand side -->
                <TD align="left" valign="top" rowspan="2"><jsp:include page="category_list_header_rhs.jsp"/></TD>
              </TR>
              <TR>
                <!-- * START LABELS -->
                <TD class="categoryHeadingCell" colspan="3" nowrap>
                  <i18n:getMessage messageName='availablePortlets'/>
                </TD>
                <!-- * END LABELS  -->
              </TR>
              <!-- This creates the dark green line at the bottom of the green header -->
              <TR>
                <TD class="categoryHeadingBorderCell" colspan="<%=numberOfLabels + 2%>" height="1"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
              </TR>
            </TABLE>
          </TD>
            
          <!-- Center spacer column -->
          <TD width="5%">
            &nbsp;
          </TD>
          
          <!-- Green Title Bar for the place portlets tables -->
          <TD align="left" valign="top">
            <TABLE cellspacing="0" cellpadding="0" border="0" width="100%">
              <TR>
                <!-- category listing left hand side -->
                <TD align="left" valign="top" rowspan="2"><jsp:include page="category_list_header_lhs.jsp"/></TD>
                <!-- It may seem strange to put a td width of 1000 in here, but after much trial and error this is the only way Netscape will maintain the fixed border widths along with the liquid, stretchable layout of the table -->
                <TD class="categoryHeadingBorderCell" colspan="<%=numberOfLabels%>" height="1px" width="1000"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
                <!-- category listing right hand side -->
                <TD align="left" valign="top" rowspan="2"><jsp:include page="category_list_header_rhs.jsp"/></TD>
              </TR>
              <TR>
                <!-- * START LABELS -->
                <TD class="categoryHeadingCell" colspan="3" nowrap width=100%>
                  <i18n:getMessage messageName='placedItemsLabel'/>
                </TD>
                <!-- * END LABELS  -->
              </TR>
              <!-- This creates the dark green line at the bottom of the green header -->
              <TR>
                <TD class="categoryHeadingBorderCell" colspan="<%=numberOfLabels + 2%>" height="1"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
              </TR>
            </TABLE>
          </TD>
          
        </TR>
        <TR>
          <!-- Available portlets select box -->
          <TD VALIGN="top" WIDTH="1%">
            <res:getAvailableOnlyPortletsTag id="availablePortletsIt" groupPortal="<%=currentGroupPortal%>" portalName="<%= portalId %>" pagePersonalization="<%= pagePersonalization %>" />
<%
            StringBuffer availNames = new StringBuffer();

            while(availablePortletsIt.hasNext())
            {
              PortletPersonalization ppTemp = (PortletPersonalization)availablePortletsIt.next();
              PlaceholderIdentifier piTemp = ppTemp.getPlaceholderIdentifier();
              PortletIdentifier ppiTemp = ppTemp.getPortletIdentifier();
              String displayText = ppTemp.getDisplayName();
              String displayValue = ppiTemp.getId();
              availNames.append("<option value=\"" + displayValue + "\">" + cnvrtSC(displayText) + "</option>"); 
            }
%>
            <wf:form namespace="admin_portal" event="" origin="select_portlets.jsp" hide="true" method="post" name="availablePortletsForm">
              <select multiple="true" name="availablePortlets" size="17" onChange="removeFocus()"><%=availNames.toString()%><option value="spacer">----------------------------------------</option>
              </select>
            </wf:form>  
          </TD>
        
          <!-- Make available and Make visible arrow buttons -->
          <TD align="center" valign="middle" width="5%">
            <TABLE border="0">
              <TR>
                <TD align="center" valign="top">
                  <a href="javascript:makeVisible()"><img src="<wf:createResourceURL resource='<%=imagesPath + "arrow_right_enabled.gif"%>'/>" border="0"></a>
                </TD>
              </TR>
              <TR>
                <TD align="center" valign="bottom">
                  <a href="javascript:makeAvailable()"><img src="<wf:createResourceURL resource='<%=imagesPath + "arrow_left_enabled.gif"%>'/>" border="0"></a>
                </TD>
              </TR>
            </TABLE>
          </TD>

          <!-- The position portlets tables -->
          <TD VALIGN=top>    
            <!-- End Tab Table -->
            <wf:form namespace="admin_portal"  event="link.refresh" origin="select_portlets.jsp" hide="true" method="post" name="DataForm">
              <!-- we call the internal request dispatcher to execute the template.jsp for the webapp -->
<%
              String url = layoutURL + "?" + PortalTagConstants.RENDER_TOOLS_MODE + "=" + PortalTagConstants.ADMIN;
              InternalRequestDispatcher ird = new InternalRequestDispatcher(url);
              args = new Object[] { layoutURL, new Integer( ird.getStatus() ) };
              if(ird.getStatus() != HttpServletResponse.SC_OK)
              {
%>
                <i18n:getMessage messageName='layoutError' messageArgs='<%=args%>'/> 
<%
              } 
              else
              {
                out.print(ird.getContent());
              }
%>
              <input type="hidden" name="portalPageName" value="<%=targetPageName%>">
              <input type="hidden" name="doAction" value="save">
              <input type="hidden" name="portletPositions" value=" ">
            </wf:form>
          </TD>
        
        </TR>
        <TR>
          <TD colspan=2>
            <br><a href="<wf:createWebflowURL namespace='admin_portal' origin='select_portlets.jsp' event='link.back'/>"><img src="<wf:createResourceURL resource='<%=imagesPath + "back.gif"%>'/>" border="0" alt="<i18n:getMessage messageName='backLabel'/>"></a>
              &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="javascript:submitForm();"><img src="<wf:createResourceURL resource='<%=imagesPath + "save.gif"%>'/>" border="0" alt="<i18n:getMessage messageName='saveLabel'/>"></a>
          </TD>
          <TD>
            <TABLE border="0" cellspacing="2" cellpadding="0" width="100%">
              <TR> 
                <TD valign="top" align="left" width="33%" nowrap>
                  <TABLE border="0" cellspacing="2" cellpadding="0" width="100%">
                    <TR>
                      <TD align="RIGHT" nowrap><span class="fieldlabel"><i18n:getMessage messageName='moveSections'/></span>
                      </TD>
                      <TD>&nbsp;
                      </TD>
                      <TD>&nbsp;
                      </TD>
                    </TR>
                    <TR>
                      <TD>&nbsp;
                      </TD>
                      <TD ALIGN="CENTER" VALIGN="MIDDLE" nowrap><a href="javascript:moveUp();"><img src="<wf:createResourceURL resource='<%=imagesPath + "arrow_up_enabled.gif"%>'/>" border="0" align="top"></a>
                      </TD>
                      <TD ALIGN="LEFT" VALIGN="MIDDLE" nowrap>&nbsp<span class="instructions"><i18n:getMessage messageName='moveUpLabel'/></span>
                      </TD>
                    </TR>
                    <TR>
                      <TD>&nbsp;
                      </TD>
                      <TD ALIGN="CENTER" VALIGN="MIDDLE" nowrap><a href="javascript:moveDown();"><img src="<wf:createResourceURL resource='<%=imagesPath + "arrow_down_enabled.gif"%>'/>" border="0" align="top"></a>
                      </TD>
                      <TD ALIGN="LEFT" VALIGN="MIDDLE" nowrap>&nbsp<span class="instructions"><i18n:getMessage messageName='moveDownLabel'/></span>
                      </TD>
                    </TR>
                    <TR>
                      <TD ALIGN="RIGHT" VALIGN="MIDDLE" nowrap><span class="instructions"><i18n:getMessage messageName='movePreviousLabel'/></span>&nbsp;<a href="javascript:moveLeftInternal();"><img src="<wf:createResourceURL resource='<%=imagesPath + "arrow_left_enabled.gif"%>'/>" border="0" align="middle"></a>
                      </TD>
                      <TD>&nbsp;
                      </TD>
                      <TD ALIGN="LEFT" VALIGN="MIDDLE" nowrap><a  href="javascript:moveRightInternal()"><img src="<wf:createResourceURL resource='<%=imagesPath + "arrow_right_enabled.gif"%>'/>" border="0" align="middle"></a>&nbsp;<span class="instructions"><i18n:getMessage messageName='moveNextLabel'/></span>
                      </TD>
                    </TR>
                  </TABLE>
                </TD>
                
                <TD>&nbsp;&nbsp;&nbsp;
                </TD>
                
                <%-- This section represents the mandatory and visible attribute check boxes --%>
                <TD>
                  <TABLE>
                    <TR>
                      <TD>                
                        <div id="attributesTitle" style="position:relative; visibility:show;">
                          <span class="fieldlabel"><i18n:getMessage messageName='portletAttributes'/></span>
                        </div>
                      </TD>
                    </TR>                  
                    <TR>
                      <TD>                
                        <div id="mandatory" style="position:relative; visibility:show;">
                          <form name="mandatoryForm">
                            <input type="CHECKBOX" name="mandatoryCheckbox" id="mandatoryCheckbox" onClick="changeMandatory()"> <i18n:getMessage messageName='mandatory'/>
                          </form>
                        </div>
                      </TD>
                    </TR>                  
                    <TR>
                      <TD>                
                        <div id="entAndVisible" style="position:relative; visibility:show;" valign=top>
                          <form name="entAndVisibleForm">
                            <input type="CHECKBOX" name="entAndVisibleCheckbox" id="entAndVisibleCheckbox" onClick="changeEntAndVisible()"> <i18n:getMessage messageName='entitledAndVisible'/>
                          </form>
                        </div>
                      </TD>
                    </TR>
                  </TABLE>
                </TD>
                <%-- End checkbox section --%>
              </TR>
            </TABLE>
          </TD>
        </TR>
      </TABLE>
    </TD>    
    
  </TR>
</TABLE>

</body>
</html>