<%-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. --%>
<%@ page extends="com.bea.jsptools.common.servlets.jsp.ToolsJspBase"%>

<%-- ------------------------------------------------------------ --%>
<%-- page imports                                                 --%>
<%-- ------------------------------------------------------------ --%>
<%@ page import="com.bea.portal.model.GroupPortal"%>
<%@ page import="com.bea.portal.model.Page"%>
<%@ page import="com.bea.portal.model.PageIdentifier"%>
<%@ page import="com.bea.portal.model.MutablePagePersonalization"%>
<%@ page import="com.bea.portal.manager.internal.PagePersonalizationImpl"%>
<%@ page import="com.bea.portal.model.PagePersonalization"%>
<%@ page import="com.bea.portal.jsp.JspConstants"%>

<%@ page errorPage="error.jsp" %>

<%-- ------------------------------------------------------------ --%>
<%-- taglibs                                                      --%>
<%-- ------------------------------------------------------------ --%>
<%@ taglib uri="webflow.tld" prefix="wf" %>
<%@ taglib uri="i18n.tld" prefix="i18n" %>
<%@ taglib uri="res.tld" prefix="res" %>

<%-- ------------------------------------------------------------ --%>
<%-- i18n (internationalization) and skin setup                   --%>
<%-- ------------------------------------------------------------ --%>

<%@ include file="/tools/portal/i18n_setup.inc"%>

<%  // Grab the html title string from the properties file %>
<i18n:getMessage messageName='pageTitle' id='pageTitle'/> 

<%-- ------------------------------------------------------------ --%>
<%-- environment setup                                            --%>
<%-- ------------------------------------------------------------ --%>

<%-- ------------------------------------------------------------ --%>
<%-- DECLARE NavLocation VALUE                                    --%>
<%-- Used for the left_navbar highlighting                        --%>
<%-- ------------------------------------------------------------ --%>
  <wf:setProperty property='NavLocation' value='<%=JspConstants.PAGES_LAYOUTS_PORTLETS_NAV%>' scope='request'/>

<%-- Get the Default Group Portal Display name to use on the page --%>
<i18n:getMessage id='defaultGroupPortalName' messageName='defaultGroupPortalDisplayName' bundleName='tools'/>

<wf:getProperty property="portalName" id="portalName" type="String"/>
<wf:getProperty property="groupPortalObj" id="currentGroupPortal" type="com.bea.portal.model.GroupPortal"/>
<wf:getProperty property="isDefaultGroup" id="isDefaultGroup" type="String"/>

<%
  String groupPortalGroupId = currentGroupPortal.getGroupIdentifier();
  String groupPortalName = currentGroupPortal.getDisplayName();

  if(( isDefaultGroup != null ) && ( isDefaultGroup.equals("true") ))
  {
    groupPortalName = defaultGroupPortalName;
  }

  String origin = request.getParameter("origin");
  String originalOrigin = request.getParameter("originalOrigin");
  String event = "link.back." + origin;
  String saveEvent = "link.back." + originalOrigin;
  
  String[] selectedPages = request.getParameterValues("selectedPages");

  if (selectedPages == null) 
  {
%>
    <wf:getProperty property="selectedPages" id="selPages" type="String[]"/>  
<%  selectedPages = selPages;
  } 
  else 
  { 
%>
    <wf:setProperty property="selectedPages" value="<%= selectedPages %>"/>
<% 
    //Decode the values in the array for use on the page
    for(int i=0;i<selectedPages.length;i++)
    {
        //Because we can't encode selectPages through the createURLWEbflow tag, we don't want to decode it.
        if(origin.equals("manage_portal_pages.jsp"))
        {
            selectedPages[i] = selectedPages[i];
        }
        else
        {
            selectedPages[i] = selectedPages[i];
        }
    }
  }

%>
  <res:getHomePage id='currentHomePageId' groupId='<%=currentGroupPortal%>'/>
<%
  String currentHomePageName = currentHomePageId.getName();
  boolean editDefaultPage = false;
  //We're going to check the default home page against the first page in the selected list.  We can get away
  // with this because the user can't get into this page with a multi-select which includes the default, therefore
  // we know if the default has been selected, it'll be the first, and only, in the list
  if(currentHomePageName.equals(selectedPages[0]))
  {
    editDefaultPage = true;
  }
  
  String displayName = request.getParameter("displayName");
  String statusMsg = null;
  boolean available = false;
  boolean visible = false;
  boolean mandatory = false;
  boolean isEditable = false;
  boolean useGraphics = false;
  boolean availableMixed = false;
  boolean visibleMixed = false;
  boolean mandatoryMixed = false;
  if (request.getParameter("savemode") != null) 
  {
    boolean validDisplayName = true;
    // initialize values for the three attributes
    if(editDefaultPage)
    {
        available = true;
    }
    else
    {
        available = (request.getParameter("available") != null);
    }
    mandatory = (request.getParameter("mandatory") != null);
    if(editDefaultPage || mandatory)
    {
        visible = true;
    }
    else
    {
        visible = (request.getParameter("visible") != null);
    }
    isEditable = (request.getParameter("editable") != null);
    useGraphics = (request.getParameter("usegraphics") != null);
    // save settings back into persistence
%>
    <wf:getProperty property="mpages" id="mpages" type="java.util.List"/>
    <wf:getProperty property="displayNames" id="displayNames" type="String[]"/>  
<%
    if(displayName != null)
    {
      displayName = displayName.trim();
      if(displayName.equals(""))
      {
%>
          <i18n:getMessage id='tempStatusMsg' messageName='blankNameMessage'/>
<%          
          validDisplayName = false;
          statusMsg = tempStatusMsg;
          displayName = request.getParameter("displayNameBackup");
      }
      else
      {
%>
        <i18n:getMessage messageName='disallowedCharactersWithoutSpace' id='disallowedCharacters' bundleName='tools'/>
<%      
        for (int i=0;i<disallowedCharacters.length();i++)
        {
          int characterIndex = displayName.indexOf( disallowedCharacters.charAt(i) );
          if(characterIndex != -1)
          {
            Object[] disChars = new Object[] { disallowedCharacters };
%>
            <i18n:getMessage messageName='invalidCharDisplayName' id='tempStatusMsg' messageArgs='<%=disChars%>'/>
<%
            statusMsg = tempStatusMsg;
            validDisplayName = false;
            displayName = displayName.substring(0, characterIndex) + displayName.substring(characterIndex + 1);
            i = i-1;
          }
        }
      }
    }

    if(validDisplayName)
    {
      PagePersonalizationImpl mpage = null;
      
      for ( int i = 0; i < mpages.size(); i++ ) 
      {
        mpage = (PagePersonalizationImpl)mpages.get(i);
        mpage.setAvailable( new Boolean(available));
        mpage.setVisible( new Boolean(visible));
        mpage.setMandatory(new Boolean(mandatory));
        //We only want to set these if we're not doing a "multi-edit"
        if (selectedPages.length == 1)
        {
            mpage.setDisplayMutable(new Boolean(isEditable));
            mpage.setDisplayType( useGraphics ? Page.DISPLAY_TYPE_IMAGE : Page.DISPLAY_TYPE_TEXT );
            mpage.setDisplayName(displayName);
        }
      }
  
%>
      <%-- Note:  this isn't really the selected pages.  I'm not sure why the tag is called getSelectedPages --%>
      <res:getSelectedPages id="allPages" groupId="<%=currentGroupPortal%>"/>
  
      <%-- Let's also add in the unavailable pages, so we can also edit their attributes --%>
      <res:getAvailablePages id="availPages" groupId="<%=currentGroupPortal%>"/>
<%
      Iterator availPagesIt = availPages.iterator();
      while(availPagesIt.hasNext())
      {
          allPages.add( availPagesIt.next() );
      }
      
      Iterator iter = allPages.listIterator();
      PagePersonalization pagePers = null;
      
      List allNewPages = new ArrayList();
      
      boolean found = false;
      while ( iter.hasNext() ) 
      {
        found = false;
        pagePers = (PagePersonalization)iter.next();
        for ( int i = 0; i < mpages.size(); i++ ) 
        {
          mpage = (PagePersonalizationImpl)mpages.get(i);
          if ( pagePers.getIdentifier().equals( mpage.getIdentifier() ) ) 
          {
            allNewPages.add( mpage );
            found = true;
            break;
          }
        }
  
        if ( !found ) 
        {
            allNewPages.add( pagePers );
        }
      }
%>
      <res:setPersonalizedPages groupId="<%=currentGroupPortal%>" pageList="<%=allNewPages %>"/>
      <%-- The following form and associated javascript allow for the "page forward" on a successful save --%>  
  <%
      //We only want to forward if there have been no generated errors within the tags
      String logId = (String)pageContext.getAttribute("logId");
      if(logId == null)
      {
%>
        <SCRIPT LANGUAGE="JavaScript">
          window.location.replace("<wf:createWebflowURL namespace='admin_portal' event='<%=saveEvent%>'/>");
        </SCRIPT>
<%
      }
    }
    else
    {
      pageContext.setAttribute("errorMessage", statusMsg);
      origin = originalOrigin;
      event = "link.back." + origin;
    }
  }
  else 
  { 	// first time into this page, retrieve attributes values from first PagePersonalized object
%>    
    <res:getPersonalizedPages id="pp13n" groupId="<%=currentGroupPortal%>" pageNames="<%=selectedPages %>"/>
    <wf:setProperty	property="mpages" value='<%=pp13n%>'/>
<%
    String[] displayNames = new String[pp13n.size()];
    String tmpDisName = null;
    for ( int i = 0; i < pp13n.size(); i++ ){
        tmpDisName = ((PagePersonalizationImpl)pp13n.get(i)).getDisplayName();
        displayNames[i] = tmpDisName;
    }
%>  
    <wf:setProperty property="displayNames" value='<%=displayNames%>'/>
<%
      available = (((PagePersonalization)pp13n.get(0)).isAvailable() != null &&
                   ((PagePersonalization)pp13n.get(0)).isAvailable().booleanValue());
      visible = (((PagePersonalization)pp13n.get(0)).isVisible() != null &&
                     ((PagePersonalization)pp13n.get(0)).isVisible().booleanValue());
      mandatory = (((PagePersonalization)pp13n.get(0)).isMandatory() != null &&
                       ((PagePersonalization)pp13n.get(0)).isMandatory().booleanValue());
      displayName = ((PagePersonalization)pp13n.get(0)).getDisplayName();
      isEditable = (((PagePersonalization)pp13n.get(0)).isDisplayMutable() != null &&
                       ((PagePersonalization)pp13n.get(0)).isDisplayMutable().booleanValue());
    
    for(int i = 1;i<pp13n.size();i++)
    {
        if( available != (((PagePersonalization)pp13n.get(i)).isAvailable() != null && ((PagePersonalization)pp13n.get(i)).isAvailable().booleanValue()) )
        {
            availableMixed = true;
        }
        if( visible != (((PagePersonalization)pp13n.get(i)).isVisible() != null && ((PagePersonalization)pp13n.get(i)).isVisible().booleanValue()) )
        {
            visibleMixed = true;
        }
        if( mandatory != (((PagePersonalization)pp13n.get(i)).isMandatory() != null && ((PagePersonalization)pp13n.get(i)).isMandatory().booleanValue()) )
        {
            mandatoryMixed = true;
        }
    }

    if(((PagePersonalization)pp13n.get(0)).getDisplayType().equals(Page.DISPLAY_TYPE_TEXT))
       useGraphics = false;
    else
       useGraphics = true;

  }

  String availableChecked = "", visibleChecked = "", mandatoryChecked = "", graphicsChecked = "", editableChecked = "";
  
  if (available || availableMixed) availableChecked = "checked";
  if (visible || visibleMixed) visibleChecked = "checked";
  if (mandatory || mandatoryMixed) mandatoryChecked = "checked";
  if (useGraphics) graphicsChecked = "checked";
  if (isEditable) editableChecked = "checked";
  
%>
<%-- ------------------------------------------------------------ --%>
<%-- begin rendering                                              --%>
<%-- ------------------------------------------------------------ --%>
<html>

<head>
  <title><%=pageTitle%></title>
  <LINK REL=StyleSheet HREF="<wf:createResourceURL resource='<%=cssFile%>'/>" TYPE="text/css" MEDIA="screen">

<script language="JavaScript">

function submitForm()
{
    document.forms[0].submit();
}

function visibleMandatory()
{
    if(document.forms[0].mandatory.checked)
    {
        document.forms[0].visible.checked = true;
        document.forms[0].visible.disabled = true;
    }
    else
    {
        if(!<%=editDefaultPage%>)
        {
            document.forms[0].visible.disabled = false;
        }
    }
}

function checkVisible()
{
    //We only want to do this for Netscape4.  The 'disabled' will work for IE
    if(document.layers)
    {
        if(document.forms[0].mandatory.checked)
        {
            document.forms[0].visible.checked = true;
            alert("<i18n:getMessage messageName='mandatoryVisible'/>");
        }
    }
}

function isDefault()
{
    if(<%=editDefaultPage%>)
    {
        document.forms[0].available.checked = true;
        document.forms[0].available.disabled = true;
        document.forms[0].visible.checked = true;
        document.forms[0].visible.disabled = true;
    }
}

function checkDefault()
{
    //We only want to do this for Netscape4.  The 'disabled' will work for IE
    if(document.layers)
    {
        if(<%=editDefaultPage%>)
        {
            document.forms[0].available.checked = true;
            document.forms[0].visible.checked = true;
            alert("<i18n:getMessage messageName='defaultPageInstructions'/>");
        }
    }

}

</script>

</head>

<BODY onLoad="visibleMandatory();isDefault();" leftmargin="0" rightmargin="0" marginwidth="0" marginheight="0" STYLE='BACKGROUND-IMAGE:url("<wf:createResourceURL resource='<%=imagesPath + "bg_subpage.gif"%>'/>"); BACKGROUND-REPEAT: no-repeat; BACKGROUND-POSITION:left top;'>

<%@ include file="/tools/util/admin_header.inc"%>

<!-- end top nav bar -->

<!-- This is the uber table that contains two table data cells: one for the left nav, the other for the main page layout -->
<TABLE border="0" cellspacing="0" cellpadding="0" width="100%" height="100%">
<TR><TD align="left" valign="top" class="sidenav" width="1%">
<!-- include  table for left nav bar -->
<jsp:include page="left_navbar.jsp"/>
</TD>


<TD align="center" valign="top" width="2%">
  <!-- spacer cell -->
</TD>

<!-- begin table for main content area -->
<TD align="left" valign="top">
  <% // Include the error message display logic %>
  <%@ include file="/tools/util/error_message.inc"%>

<%
    // Creation of message arguments
      StringBuffer selectedPageNames = new StringBuffer();
      for ( int i = 0; i < selectedPages.length; i++ ) 
      {
            selectedPageNames.append( selectedPages[ i ] );
            if ( ( i + 1 ) != selectedPages.length )
            {
                selectedPageNames.append( ", " );
            }
      }
%>
      <i18n:getMessage messageName='selectedPages' messageArgs='<%=new Object[]{ selectedPageNames.toString() }%>' id='pname'/>
<%   
      Object[] args = new Object[] { selectedPageNames.toString() };
%>
  <span class="pageheader"><i18n:getMessage messageName='portalDisplay' messageArgs='<%=args%>'/></span><BR>
  <span class="instructions"><i18n:getMessage messageName='portalDisplaySubHead'/></span>
<%
  if(editDefaultPage)
  {
%>
    <span class="instructions"><i18n:getMessage messageName='defaultPageInstructions'/></span><BR>
<%
  }
%>
  <BR>
  
  <!-- start Webflow/Pipeline enabled FORM -->
  <wf:form namespace="admin_portal"  event="link.save" origin="set_page_attributes.jsp" hide="true" method="post" name="attrform">

  <TABLE cellspacing="5" cellpadding="5" border="0">
    <TR>
      <TD><i18n:getMessage messageName='available'/></TD>
      <TD><input type="checkbox" name="available" value="1" onClick="checkDefault();" <%= availableChecked %>></TD>
<%
      if (selectedPages.length != 1)
      {
        if(availableMixed)
        {
%>
          <TD class="listText"><i18n:getMessage messageName='mixedValues'/></TD>
<%
        }
        else if(availableChecked.equals("checked"))
        {
%>
          <TD class="listText"><i18n:getMessage messageName='initiallyOn'/></TD>
<%
        }
        else
        {
%>
          <TD class="listText"><i18n:getMessage messageName='initiallyOff'/></TD>
<%
        }
      }
%>
    </TR>
    <TR>
      <TD><i18n:getMessage messageName='visible'/></TD>
      <TD><input type="checkbox" name="visible" value="1" onClick="checkDefault();checkVisible();" <%= visibleChecked %>></TD>
<%
      if (selectedPages.length != 1)
      {
        if(visibleMixed)
        {
%>
          <TD class="listText"><i18n:getMessage messageName='mixedValues'/></TD>
<%
        }
        else if(visibleChecked.equals("checked"))
        {
%>
          <TD class="listText"><i18n:getMessage messageName='initiallyOn'/></TD>
<%
        }
        else
        {
%>
          <TD class="listText"><i18n:getMessage messageName='initiallyOff'/></TD>
<%
        }
      }
%>
    </TR>
    <TR>
      <TD><i18n:getMessage messageName='mandatory'/></TD>
      <TD><input type="checkbox" name="mandatory" value="1" onClick="visibleMandatory();" <%= mandatoryChecked %>></TD>
<%
      if (selectedPages.length != 1)
      {
        if(mandatoryMixed)
        {
%>
          <TD class="listText"><i18n:getMessage messageName='mixedValues'/></TD>
<%
        }
        else if(mandatoryChecked.equals("checked"))
        {
%>
          <TD class="listText"><i18n:getMessage messageName='initiallyOn'/></TD>
<%
        }
        else
        {
%>
          <TD class="listText"><i18n:getMessage messageName='initiallyOff'/></TD>
<%
        }
      }
%>
    </TR>
    <% if (selectedPages.length == 1) { %>
    <TR>
      <TD><i18n:getMessage messageName='displayName'/></TD>
      <TD><input type="text" name="displayName" value="<%= displayName %>" maxlength="254"></TD>
      <TD>&nbsp;</TD>
    </TR>    
    <TR>
      <TD><i18n:getMessage messageName='pageNameEditable'/></TD>
      <TD><input type="checkbox" name="editable" value="1" onClick="visibleMandatory();" <%= editableChecked %>></TD>
      <TD><i18n:getMessage messageName='pageNameEditable_desc'/></TD>
    </TR>    
    <TR>
      <TD><i18n:getMessage messageName='useGraphics'/></TD>
      <TD><input type="checkbox" name="usegraphics" value="1" onClick="visibleMandatory();" <%= graphicsChecked %>></TD>
      <TD><i18n:getMessage messageName='useGraphics_desc'/></TD>
    </TR>
    <% } %>
  </TABLE>
  <br><br>

<A HREF="<wf:createWebflowURL namespace='admin_portal' event='<%=event%>'/>"><IMG src="<wf:createResourceURL resource='<%=imagesPath + "back.gif"%>'/>" border="0" align="bottom"></A>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<A HREF="" onclick="submitForm(); return false;"><IMG src="<wf:createResourceURL resource='<%=imagesPath + "save.gif"%>'/>" border="0" align="bottom"></A>

<input type=hidden name=savemode value="savemode">
<input type=hidden name=originalOrigin value="<%=origin%>">
<input type=hidden name=displayNameBackup value="<%=displayName%>">
</wf:form>

</TD>
<!-- end content area -->

<TD align="center" valign="top" width="2%">
  <!-- spacer cell -->
</TD>

</TR>
</TABLE>
</BODY>
</HTML>
