<%-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. --%>
<%@ page extends="com.bea.jsptools.common.servlets.jsp.ToolsJspBase"%>

<%-- ------------------------------------------------------------ --%>
<%-- page imports                                                 --%>
<%-- ------------------------------------------------------------ --%>
<%@ page import="java.util.List"%>
<%@ page import="java.util.ArrayList"%>

<%@ page import="com.bea.portal.model.GroupPortal"%>
<%@ page import="com.bea.portal.model.Page"%>
<%@ page import="com.bea.portal.model.PageIdentifier"%>
<%@ page import="com.bea.portal.model.MutablePagePersonalization"%>
<%@ page import="com.bea.p13n.entitlements.common.Capability"%>
<%@ page import="com.bea.p13n.entitlements.common.EntitlementDefinition"%>
<%@ page import="com.bea.portal.entitlement.resource.PortletResourceConstants"%>
<%@ page import="com.bea.portal.entitlement.resource.PortalPageResourceConstants"%>
<%@ page import="com.bea.portal.entitlement.taxonomy.PortletTaxonomy"%>
<%@ page import="com.bea.portal.jsp.JspConstants"%>
<%@ page errorPage="error.jsp" %>

<%-- ------------------------------------------------------------ --%>
<%-- taglibs                                                      --%>
<%-- ------------------------------------------------------------ --%>
<%@ taglib uri="webflow.tld" prefix="wf" %>
<%@ taglib uri="i18n.tld" prefix="i18n" %>
<%@ taglib uri="res.tld" prefix="res" %>
<%@ taglib uri="ent.tld" prefix="ent" %>

<%-- ------------------------------------------------------------ --%>
<%-- i18n (internationalization) and skin setup                   --%>
<%-- ------------------------------------------------------------ --%>

<%@ include file="/tools/portal/i18n_setup.inc"%>

<%-- ------------------------------------------------------------ --%>
<%-- environment setup                                            --%>
<%-- ------------------------------------------------------------ --%>

<%-- ------------------------------------------------------------ --%>
<%-- DECLARE NavLocation VALUE                                    --%>
<%-- Used for the left_navbar highlighting                        --%>
<%-- ------------------------------------------------------------ --%>
  <wf:setProperty property='NavLocation' value='<%=JspConstants.PAGES_LAYOUTS_PORTLETS_NAV%>' scope='request'/>

<%-- Get the Default Group Portal Display name to use on the page --%>
<i18n:getMessage id='defaultGroupPortalName' messageName='defaultGroupPortalDisplayName' bundleName='tools'/>

<wf:getProperty property="portalName" id="portalName" type="String"/>
<wf:getProperty property="portalId" id="portalId" type="String"/>
<wf:getProperty property="groupPortalObj" id="currentGroupPortal" type="com.bea.portal.model.GroupPortal"/>
<wf:getProperty property="isDefaultGroup" id="isDefaultGroup" type="String"/>

<%
  String groupPortalGroupId = currentGroupPortal.getGroupIdentifier();
  String groupPortalName = currentGroupPortal.getDisplayName();

  if(( isDefaultGroup != null ) && ( isDefaultGroup.equals("true") ))
  {
    groupPortalName = defaultGroupPortalName;
  }
%>

<wf:getProperty property="selectedPage" id="selectedPage" type="String"/>
<%
  String[] selectedPortlets = request.getParameterValues("selectedPortlets");
  if (selectedPortlets == null) {
%>	
<wf:getProperty property="selectedPortlets" id="selPortlets" type="String[]"/>  
<% selectedPortlets = selPortlets;  
  }
  else { %>
<wf:setProperty property="selectedPortlets" value="<%= selectedPortlets %>"/>
<% }

  boolean singlePortletEdit = false;
  if( selectedPortlets.length == 1)
  {
      singlePortletEdit = true;
  }

  boolean[] attrs = new boolean[7];
  String[] checked = new String[7];

  List entDefList = null;
  if (request.getParameter("savemode") != null) 
  {	// updating the page entitlements
%>	
    <wf:getProperty property="selectedPortlets" id="selPortlets" type="String[]"/>  
<%  selectedPortlets = selPortlets;
    String [] roleParms = request.getParameterValues("roleName");
    String [] capParms = request.getParameterValues("capName");
    for (int i=0; i<selectedPortlets.length; i++) 
    {
  	  ArrayList edList = new ArrayList(roleParms.length);   
      PortletTaxonomy resourceTaxonomy = new PortletTaxonomy(portalId, currentGroupPortal.getGroupIdentifier(), selectedPage, selectedPortlets[i]);
%>
      <ent:addEntitlements roleNames="<%=roleParms%>" capabilityNames="<%=capParms%>" entitlementList="<%=edList%>" resourceName="<%=resourceTaxonomy.getIdentifier()%>" />
      <ent:setEntitlements resourceType="<%= PortletResourceConstants.RESOURCE_TYPE %>" entitlementList="<%=edList%>"  resourceTaxonomy="<%=resourceTaxonomy%>" id="success" />
<%
      entDefList = edList;
    }
    
    //The following form and associated javascript allow for the "page forward" on a successful save
    //We only want to forward if there have been no generated errors within the tags
    String logId = (String)pageContext.getAttribute("logId");
    if(logId == null)
    {
%>
      <SCRIPT LANGUAGE="JavaScript">
        window.location.replace("<wf:createWebflowURL namespace='admin_portal' event='link.back'/>");
      </SCRIPT>
<%  }
  } 
  else 
  { 	// first time enter the page
    PortletTaxonomy resourceTaxonomy = new PortletTaxonomy(portalId, currentGroupPortal.getGroupIdentifier(), selectedPage, selectedPortlets[0]);  
%>
    <ent:getEntitlements resourceTaxonomy="<%=resourceTaxonomy%>" resourceType="<%=PortletResourceConstants.RESOURCE_TYPE%>" id="edList"/>
    <wf:setProperty property="selectedPortlets" value="<%= selectedPortlets %>"/>
<%
    entDefList = edList;
  }
%>

<%-- ------------------------------------------------------------ --%>
<%-- begin rendering                                              --%>
<%-- ------------------------------------------------------------ --%>
<html>

<head>
  <%  // Grab the html title string from the properties file %>
  <i18n:getMessage messageName='pageTitle' id='pageTitle' messageArgs='<%=new Object[] { cnvrtSC(selectedPage) }%>'/> 

  <title><%=pageTitle%></title>
  <LINK REL=StyleSheet HREF="<wf:createResourceURL resource='<%=cssFile%>'/>" TYPE="text/css" MEDIA="screen">

<script language="JavaScript">

function submitForm() {
	document.forms[0].submit();
}

</script>

</head>

<BODY leftmargin="0" rightmargin="0" marginwidth="0" marginheight="0" STYLE='BACKGROUND-IMAGE:url("<wf:createResourceURL resource='<%=imagesPath + "bg_subpage.gif"%>'/>"); BACKGROUND-REPEAT: no-repeat; BACKGROUND-POSITION:left top;'>

<%@ include file="/tools/util/admin_header.inc"%>

<!-- end top nav bar -->

<!-- This is the uber table that contains two table data cells: one for the left nav, the other for the main page layout -->
<TABLE border="0" cellspacing="0" cellpadding="0" width="100%" height="100%">
  <TR>
    <TD align="left" valign="top" class="sidenav" width="1%">
      <!-- include  table for left nav bar -->
      <jsp:include page="left_navbar.jsp"/>
    </TD>


    <TD align="center" valign="top" width="2%">
      <!-- spacer cell -->
    </TD>
    
    <!-- begin table for main content area -->
    <TD align="left" valign="top">

<%
      // Creation of message arguments
      StringBuffer selectedPortletNames = new StringBuffer();
      for ( int i = 0; i < selectedPortlets.length; i++ )
      {
        selectedPortletNames.append( selectedPortlets[ i ] );
        if ( ( i + 1 ) != selectedPortlets.length )
        {
          selectedPortletNames.append( ", " );
        }
      }
    
      int numberOfLabels = 2;    
      Object[] args = new Object[] { cnvrtSC(selectedPage), cnvrtSC(selectedPortletNames.toString()) };
%>
      <span class="pageheader"><i18n:getMessage messageName='portalDisplay' messageArgs='<%=args%>'/></span><BR>
      <span class="instructions"><i18n:getMessage messageName='portalDisplaySubHead'/></span>
      <BR>
  
      <!-- start Webflow/Pipeline enabled FORM -->
      <wf:form namespace="admin_portal"  event="link.save" origin="set_portlet_entitlements.jsp" hide="true" method="post" name="attrform">
        <input type="hidden" name="capName" value="<%=PortletResourceConstants.VISIBLE%>"> 
        <input type="hidden" name="capName" value="<%=PortletResourceConstants.EDITABLE%>">   
        <input type="hidden" name="capName" value="<%=PortletResourceConstants.REMOVABLE%>"> 
    
        <TABLE cellspacing="0" cellpadding="0" border="0" width="100%">
          <TR>
            <TD class="emptyRow" colspan="<%=(numberOfLabels+2)%>"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
          </TR>
          <TR>
            <TD align="left" valign="top" rowspan="2">
              <!-- category listing left hand side -->
              <jsp:include page="category_list_header_lhs.jsp"/>
            </TD>
        
            <!-- It may seem strange to put a td width of 1000 in here, but after much trial and error this is the only way Netscape will maintain the fixed border widths along with the liquid, stretchable layout of the table -->
            <TD class="categoryHeadingBorderCell"  colspan="<%=numberOfLabels%> height="1px" width="1000"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
        
            <TD align="left" valign="top" rowspan="2">
              <!-- category listing right hand side -->
              <jsp:include page="category_list_header_rhs.jsp"/>
            </TD>
          </TR>
        
          <TR>
            <!-- * START LABELS                                                               -->
            <TD class="categoryHeadingCell" align="left" nowrap><i18n:getMessage messageName='entSegments'/><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
            <TD class="categoryHeadingCell" align="center" nowrap width="100%"><IMG src="<wf:createResourceURL resource='<%=imagesPath + "edit_delegated.gif"%>'/>" border="0" hspace=5><a class="standardbiglink" href="<wf:createWebflowURL namespace='admin_portal' event='link.set_portlet_ent_segments'/>"><i18n:getMessage messageName='link'/></a></TD>
            <!-- * END LABELS                                                                 -->
          </TR>
        
          <!-- This creates the dark green line at the bottom of the green header -->
          <TR>
            <TD class="categoryHeadingBorderCell"  colspan="<%=numberOfLabels+2%> height="1"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
          </TR>
              <!-- START DETAIL ROW -->
          <TR>
            <TD class="spacerRow" colspan="<%=(numberOfLabels+2)%>"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
          </TR>
          <TR>
            <TD class="row">&nbsp;</TD>
            <TD class="row" COLSPAN="2">
              <TABLE cellspacing="0" cellpadding="2" border="0" width="100%">
                <TR>
                  <TD>&nbsp;</TD>
                  <TD colspan="3" ALIGN="CENTER"><b><i18n:getMessage messageName='visible'/></b></TD>
                  <TD colspan="3" ALIGN="CENTER" class="row2"><b><i18n:getMessage messageName='editable'/></b></TD>      
                  <TD colspan="3" ALIGN="CENTER"><b><i18n:getMessage messageName='removable'/></b></TD>
                </TR>
                <TR>
                  <TD>&nbsp;</TD>
                  <TD align="center"><i18n:getMessage messageName='abstain'/></TD>
                  <TD align="center"><i18n:getMessage messageName='grant'/></TD>
                  <TD align="center"><i18n:getMessage messageName='deny'/></TD>
                  <TD class="row2" align="center"><i18n:getMessage messageName='abstain'/></TD>
                  <TD class="row2" align="center"><i18n:getMessage messageName='grant'/></TD>
                  <TD class="row2" align="center"><i18n:getMessage messageName='deny'/></TD>      
                  <TD align="center"><i18n:getMessage messageName='abstain'/></TD>
                  <TD align="center"><i18n:getMessage messageName='grant'/></TD>
                  <TD align="center"><i18n:getMessage messageName='deny'/></TD>            
                </TR>
<%
                Iterator entIt = entDefList.iterator();
                java.util.Hashtable capValues = new java.util.Hashtable();
            
                int rowFormat = 1;
                String classFormat = null;
                String classFormatFlip = null;
            
                while (entIt.hasNext())
                {
                  EntitlementDefinition anEntDef= (EntitlementDefinition) entIt.next();
                  String roleName = anEntDef.getRole().getName();
                  List capArray = anEntDef.getCapabilities();
                  String visible = PortletResourceConstants.VISIBLE;
                  String editable = PortletResourceConstants.EDITABLE;	   
                  String removable = PortletResourceConstants.REMOVABLE;
                  for (int j=0; j<capArray.size(); j++)
                  {
                    capValues.put(((Capability)capArray.get(j)).getName(), ((Capability)capArray.get(j)).getValue());
                  }
                  String vv = "", ev="", rv="";       
                  if(singlePortletEdit)
                  {
                    if (capValues.get(visible) != null) vv = (String)capValues.get(visible);
                    if (capValues.get(editable) != null) ev = (String)capValues.get(editable);
                    if (capValues.get(removable) != null) rv = (String)capValues.get(removable);
                  }
                  //If we're doing a "muti-edit" we want all of the entitlements to start off as GRANT
                  else
                  {
                    vv = (String)Capability.GRANT;
                    ev = (String)Capability.GRANT;
                    rv = (String)Capability.GRANT;
                  }
    
                  if((rowFormat%2) == 0)
                  {
                    classFormat = "row2";
                    classFormatFlip = "row1";
                  }
                  else
                  {
                    classFormat = "row1";
                    classFormatFlip = "row2";
                  }
    
                  rowFormat = rowFormat + 1;
%>
                  <TR>
                    <input type="hidden" name="roleName" value="<%=roleName%>">     
                    <TD class="<%=classFormat%>"><%=anEntDef.getRole().getName()%></TD>
                    <TD class="<%=classFormat%>" align="center">
                      <input type="radio" name="<%=roleName+"."+visible%>" value="<%=Capability.ABSTAIN%>" <% if (vv.equals(Capability.ABSTAIN)) out.print("checked"); %>>
                    </TD>
                    <TD class="<%=classFormat%>" align="center">
                      <input type="radio" name="<%=roleName+"."+visible%>" value="<%=Capability.GRANT%>" <% if (vv.equals(Capability.GRANT)) out.print("checked"); %>>
                    </TD>
                    <TD class="<%=classFormat%>" align="center">
                      <input type="radio" name="<%=roleName+"."+visible%>" value="<%=Capability.DENY%>" <% if (vv.equals(Capability.DENY)) out.print("checked"); %>>
                    </TD>
                    <TD class="<%=classFormatFlip%>" align="center"> 
                      <input type="radio" name="<%=roleName+"."+editable%>" value="<%=Capability.ABSTAIN%>" <% if (ev.equals(Capability.ABSTAIN)) out.print("checked"); %>>
                    </TD>
                    <TD class="<%=classFormatFlip%>" align="center"> 
                      <input type="radio" name="<%=roleName+"."+editable%>" value="<%=Capability.GRANT%>" <% if (ev.equals(Capability.GRANT)) out.print("checked"); %>>
                    </TD>
                    <TD class="<%=classFormatFlip%>" align="center"> 
                      <input type="radio" name="<%=roleName+"."+editable%>" value="<%=Capability.DENY%>" <% if (ev.equals(Capability.DENY)) out.print("checked"); %>>
                    </TD>
                    <TD class="<%=classFormat%>" align="center">
                      <input type="radio" name="<%=roleName+"."+removable%>" value="<%=Capability.ABSTAIN%>" <% if (rv.equals(Capability.ABSTAIN)) out.print("checked"); %>>
                    </TD>
                    <TD class="<%=classFormat%>" align="center">
                      <input type="radio" name="<%=roleName+"."+removable%>" value="<%=Capability.GRANT%>" <% if (rv.equals(Capability.GRANT)) out.print("checked"); %>>
                    </TD>
                    <TD class="<%=classFormat%>" align="center">
                      <input type="radio" name="<%=roleName+"."+removable%>" value="<%=Capability.DENY%>" <% if (rv.equals(Capability.DENY)) out.print("checked"); %>>
                    </TD>
                  </TR>
                  <TR>
<% 
                }
%>
    
              </TABLE>
            </TD>
          </TR>
          <TR>
            <TD class="spacerRow" colspan="<%=(numberOfLabels+2)%>"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
          </TR>
          <TR>
            <TD class="emptyRow" colspan="<%=(numberOfLabels+2)%>"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
          </TR>
    
        </TABLE>
        <br><br>
      
        <A HREF="<wf:createWebflowURL namespace='admin_portal' event='link.back'/>"><IMG src="<wf:createResourceURL resource='<%=imagesPath + "back.gif"%>'/>" border="0" align="bottom"></A>
        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
        <A HREF="" onclick="submitForm(); return false;"><IMG src="<wf:createResourceURL resource='<%=imagesPath + "save.gif"%>'/>" border="0" align="bottom"></A>
    
        <input type="hidden" name="savemode" value="savemode">
    
      </wf:form>

    </TD>
    <!-- end content area -->

    <TD align="center" valign="top" width="2%">
      <!-- spacer cell -->
    </TD>

  </TR>
</TABLE>
</BODY>
</HTML>
