<%-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. --%>
<%@ page extends="com.bea.jsptools.common.servlets.jsp.ToolsJspBase"%>

<%-- ------------------------------------------------------------ --%>
<%-- page imports                                                 --%>
<%-- ------------------------------------------------------------ --%>
<%@ page import="java.util.List"%>
<%@ page import="java.util.Iterator"%>

<%@ page import="com.bea.portal.model.PortalConstants"%>
<%@ page import="com.bea.portal.model.GroupPortal"%>
<%@ page import="com.bea.portal.model.Portal"%>
<%@ page import="com.bea.portal.model.Page"%>
<%@ page import="com.bea.portal.model.SkinDefinition"%>
<%@ page import="com.bea.portal.model.PagePersonalization"%>
<%@ page import="com.bea.portal.model.PortalIdentifier"%>
<%@ page import="com.bea.portal.manager.internal.InternalFactory"%>
<%@ page import="com.bea.portal.model.SkinIdentifier"%>
<%@ page import="com.bea.portal.jsp.JspConstants"%>

<%@ page errorPage="error.jsp" %>


<%-- ------------------------------------------------------------ --%>
<%-- taglibs                                                      --%>
<%-- ------------------------------------------------------------ --%>
<%@ taglib uri="util.tld" prefix="util" %>
<%@ taglib uri="res.tld" prefix="res" %>
<%@ taglib uri="es.tld" prefix="es" %>
<%@ taglib uri="webflow.tld" prefix="wf" %>
<%@ taglib uri="i18n.tld" prefix="i18n" %>
<%@ taglib uri="weblogic.tld" prefix="wl" %>

<%-- ------------------------------------------------------------ --%>
<%-- i18n (internationalization) and skin setup                   --%>
<%-- ------------------------------------------------------------ --%>

<%@ include file="/tools/portal/i18n_setup.inc"%>

<%  // Grab the html title sTRing from the properties file %>
<i18n:getMessage messageName='pageTitle' id='pageTitle'/>

<%-- ------------------------------------------------------------ --%>
<%-- environment setup                                            --%>
<%-- ------------------------------------------------------------ --%>

<%-- ------------------------------------------------------------ --%>
<%-- DECLARE NavLocation VALUE                                    --%>
<%-- Used for the left_navbar highlighting                        --%>
<%-- ------------------------------------------------------------ --%>
  <wf:setProperty property='NavLocation' value='<%=JspConstants.SKINS_NAV%>' scope='request'/>
 
<%-- Get the Default Group Portal Display name to use on the page --%>
<i18n:getMessage id='defaultGroupPortalName' messageName='defaultGroupPortalDisplayName' bundleName='tools'/>

  <wf:getProperty property="portalName" id="portalName" type="String"/>
  <wf:getProperty property="groupPortalObj" id="currentGroupPortal" type="com.bea.portal.model.GroupPortal"/>
  <wf:getProperty property="isDefaultGroup" id="isDefaultGroup" type="String"/>
  
  <wf:getProperty property="doUpdate" id="testVar" type="String"/>
<%
  String groupPortalGroupId = currentGroupPortal.getGroupIdentifier();
  String groupPortalName = currentGroupPortal.getDisplayName();
  SkinDefinition defaultSkin = null;
  SkinIdentifier skinIdentifier = null;

  if(( isDefaultGroup != null ) && ( isDefaultGroup.equals("true") ))
  {
    groupPortalName = defaultGroupPortalName;
  }
%>
  <res:getSelectedSkins id="selectedSkinList" groupId="<%=currentGroupPortal %>" />
  <i18n:getMessage messageName='disallowedCharacters' id='disallowedCharacters'/>

<%-- ------------------------------------------------------------ --%>
<%-- form processing                                              --%>
<%-- ------------------------------------------------------------ --%>

<!-- If the 'save' button was clicked, go ahead and process the input. -->
<wl:process name="doUpdate" value="true">
<%
  //If there is only one input field, then the user can hit the 'Enter' key and submit the form.  By doing this
  // our javascript 'submitForm' function won't be called.  Therefore, we need to cover that case.
  boolean blankDisplayName = false;
  boolean invalidDisplayName = false;
  String statusMsg = "";
  if(selectedSkinList.size() == 1)
  {
    SkinDefinition skinDef = (SkinDefinition) selectedSkinList.get(0);
    String displayName = request.getParameter("field0");
    displayName = displayName.trim();
    if(displayName.equals(""))
    {
%>
      <i18n:getMessage id='tempStatusMsg' messageName='blankNameMessage'/>
<%
      blankDisplayName = true;
      statusMsg = tempStatusMsg;
    }
    else
    {
      //This is the 'Valid Character' test
      for (int charCounter=0;charCounter<disallowedCharacters.length();charCounter++)
      {
        if(displayName.indexOf( disallowedCharacters.charAt(charCounter) ) != -1)
        {
%>
            <i18n:getMessage id='tempStatusMsg' messageName='invalidCharSkinName' messageArgs='<%=new Object[] {disallowedCharacters}%>'/>
<%
            invalidDisplayName = true;
            statusMsg = tempStatusMsg;
        }
      }

    }
    skinDef.setDisplayName(displayName);
  }
  else
  {
    for (int i=0; i<selectedSkinList.size(); i++) 
    {      
      SkinDefinition skinDef = (SkinDefinition) selectedSkinList.get(i);
      String displayName = request.getParameter("hidden" + i);
      skinDef.setDisplayName(displayName);
    }
  }
  if(blankDisplayName || invalidDisplayName) 
  {
    pageContext.setAttribute("errorMessage", statusMsg);
  }
  else
  {
%>
    <res:setSelectedSkinNames groupId="<%=currentGroupPortal %>" skinList="<%=((ArrayList)selectedSkinList) %>"  />
        
    <%-- The following form and associated javascript allow for the "page forward" on a successful save --%>  
<%
    //We only want to forward if there have been no generated errors within the tags
    String logId = (String)pageContext.getAttribute("logId");
    if(logId == null)
    {
%>
      <SCRIPT LANGUAGE="JavaScript">
        window.location.replace("<wf:createWebflowURL namespace="admin_portal" origin="skin_display_names.jsp" event="link.back"/>");
      </SCRIPT>
<%
    }
  }
%>
</wl:process>

<%-- ------------------------------------------------------------ --%>
<%-- begin rendering                                              --%>
<%-- ------------------------------------------------------------ --%>
<html>
<head>
  <title><%=pageTitle%></title>
  <LINK REL=StyleSheet HREF="<wf:createResourceURL resource='<%=cssFile%>'/>" TYPE="text/css" MEDIA="screen">

<script language="JavaScript" src="<wf:createResourceURL resource='<%=jsPath+"tool_utils.js"%>'/>"></script>

<script language="JavaScript">

function submitForm() 
{

  var size = document.forms[0].elements["numberOfSkins"].value;
  var validDisplayNames = true;
  var invalidDisplayName = false;
  var invalidChars = "<%=disallowedCharacters%>";
  for (var i=0; i<size; i++) 
  {
    var test = Trim(document.forms[0].elements["field" + i].value);
    if( test == "")
    {
       validDisplayNames = false;
    }
    //This is the 'Valid Character' test
    for (var charCounter=0;charCounter<invalidChars.length;charCounter++)
    {
      if(test.indexOf( invalidChars.charAt(charCounter) ) != -1)
      {
        validDisplayNames = false;
        invalidDisplayName = true;
      }
    }

    document.forms[0].elements["hidden" + i].value = test;
	}

	if(validDisplayNames && !invalidDisplayName)
  {
      this.document.forms[0].submit();
      return true;
  }
  else if(invalidDisplayName)
  {
<%
      Object[] disChars = new Object[] { disallowedCharacters };
%>
      alert("<i18n:getMessage messageName='invalidCharSkinName' messageArgs='<%=disChars%>'/>");
  }
  else
  {
      alert("<i18n:getMessage messageName='blankNameMessage'/>");
  }
}

  //Remove trailing blanks from our string.
  function RTrim(str)
  {
    // We don't want to trip JUST spaces, but also tabs,
    // line feeds, etc.  Add anything else you want to
    // "trim" here in Whitespace
    var whitespace = new String(" \t\n\r");
    var s = new String(str);
    
    if (whitespace.indexOf(s.charAt(s.length-1)) != -1) 
    {
        // We have a string with trailing blank(s)...
        var i = s.length - 1;       // Get length of string
    
        // Iterate from the far right of string until we
        // don't have any more whitespace...
        while (i >= 0 && whitespace.indexOf(s.charAt(i)) != -1)
            i--;
        
        // Get the substring from the front of the string to
        // where the last non-whitespace character is...
        s = s.substring(0, i+1);
    }
    return s;
  }
  
  //Remove leading blanks from our string.
  function LTrim(str)
  {
      var whitespace = new String(" \t\n\r");
      var s = new String(str);
      
      if (whitespace.indexOf(s.charAt(0)) != -1) 
      {
          // We have a string with leading blank(s)...
          var j=0, i = s.length;
      
          // Iterate from the far left of string until we
          // don't have any more whitespace...
          while (j < i && whitespace.indexOf(s.charAt(j)) != -1)
              j++;
      
          // Get the substring from the first non-whitespace
          // character to the end of the string...
          s = s.substring(j, i);
      }
      return s;
  }
  
  //Remove trailing and leading blanks from our string.
  function Trim(str)
  {
      return RTrim(LTrim(str));
  }

</script>

</head>
<BODY leftmargin="0" rightmargin="0" marginwidth="0" marginheight="0" STYLE='BACKGROUND-IMAGE:url("<wf:createResourceURL resource='<%=imagesPath + "bg_subpage.gif"%>'/>"); BACKGROUND-REPEAT: no-repeat; BACKGROUND-POSITION:left top;'>

<%@ include file="/tools/util/admin_header.inc"%>

<!-- end top nav bar -->

<!-- This is the uber table that contains two table data cells: one for the left nav, the other for the main page layout -->
  <TABLE border="0" cellspacing="0" cellpadding="0" width="100%" height="100%">
    <TR>
      <TD align="left" valign="top" class="sidenav" width="1%">
        <!-- include  table for left nav bar -->
        <jsp:include page="left_navbar.jsp"/>
      </TD>
      <TD align="center" valign="top" width="2%">
        <!-- spacer cell -->
        &nbsp;&nbsp;
      </TD>

      <!-- begin table for main content area -->
      <TD align="left" valign="top">
        <%-- Include the error message display logic --%>
        <%@ include file="/tools/util/error_message.inc"%>
<%
        // Creation of message arguments
        Object[] args = new Object[] { cnvrtSC(portalName), cnvrtSC(groupPortalName) };
%>
        <span class="pageheader"><i18n:getMessage messageName='portalDisplay' messageArgs='<%=args%>'/></span><BR>
        <span class="instructions"><i18n:getMessage messageName='portalDisplaySubHead'/></span>
        <BR><BR>

        <!-- start Webflow/Pipeline enabled FORM -->
        <wf:form namespace="admin_portal"  event="link.refresh" origin="skin_display_names.jsp" hide="true" method="post">
<%
          // number of labels in category listing header section
          int numberOfLabels = 2;
%>

          <TABLE cellspacing="0" cellpadding="0" border="0" width="70%">

            <TR>
              <TD align="left" valign="top" rowspan="2">
                <!-- category listing left hand side -->
                <jsp:include page="category_list_header_lhs.jsp"/>
              </TD>
        
              <!-- It may seem strange to put a td width of 1000 in here, but after much trial and error this is the only way Netscape will maintain the fixed border widths along with the liquid, stretchable layout of the table -->
              <TD class="categoryHeadingBorderCell" colspan="<%=numberOfLabels%>" height="1px" width="1000"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
        
              <TD align="left" valign="top" rowspan="2">
                <!-- category listing right hand side -->
                <jsp:include page="category_list_header_rhs.jsp"/>
              </TD>
            </TR>

            <TR>
              <!-- * START LABELS -->
              <TD class="categoryHeadingCell" align="center" nowrap width="50%"><i18n:getMessage messageName='skinLabel'/></TD>
              <TD class="categoryHeadingCell" align="center" nowrap width="50%"><i18n:getMessage messageName='displayNameLabel'/></TD>
              <!-- * END LABELS -->
            </TR>

            <!-- This creates the dark green line at the bottom of the green header -->

            <TR>
                <TD class="categoryHeadingBorderCell" colspan="<%=(numberOfLabels+2)%>" height="1"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
            </TR>
    
            <TR>
              <TD colspan="<%=(numberOfLabels+2)%>" nowrap>
                <TABLE cellspacing="0" cellpadding="2" border="0" WIDTH="100%">
                  <!-- Loop through selected skins, create row with id, display name for each -->
<% 
                  int count = selectedSkinList.size();
                  for (int i=0; i<count; i++) 
                  {
                    SkinDefinition thisSkin = (SkinDefinition) selectedSkinList.get(i);
      
                    String classFormat = null;
                    if((i%2) == 0)
                    {
                      classFormat = "row1";
                    }
                    else
                    {
                      classFormat = "row2";
                    }
%>
                    <TR>
                      <TD class="<%= classFormat%>" align="center" valign="middle" width="50%">
                        &nbsp;&nbsp;<%= thisSkin.getIdentifier().getName()%>
                      </TD>
                      <TD class="<%= classFormat%>" align="center" valign="middle" width="50%">  
                        <% String fieldName = "field" + i; %>
                        <INPUT type="text" name="<%= fieldName %>" value="<%= thisSkin.getDisplayName() %>" maxlength="254">
                      </TD>
                    </TR>
<%
                  }
%>
                </TABLE>
              </TD>
            </TR>

            <TR>
              <TD class="emptyRow">&nbsp;</TD>
            </TR>
        
            <TR>
              <TD colspan="<%=(numberOfLabels+2)%>">
                <a href="<wf:createWebflowURL namespace="admin_portal" origin="skin_display_names.jsp" event="link.back"/>"><IMG src="<wf:createResourceURL resource='<%=imagesPath + "back.gif"%>'/>" border="0" align="bottom"></a>
                &nbsp;&nbsp;
                <a href="javascript:submitForm();"><IMG src="<wf:createResourceURL resource='<%=imagesPath + "save.gif"%>'/>" border="0" align="bottom"></a>
              </TD>        
            </TR>

          </TABLE>
  
          <!-- Create a hidden field for each display name -->
<%
          for (int i=0; i<count; i++) 
          {
            String hiddenId = "hidden" + i;
%>
            <input type="hidden" name="<%= hiddenId%>" value="">
<%        } 
%>

          <!-- HIDDEN ELEMENTS HERE -->
          <input type="hidden" name="doUpdate" value="true">
          <input type="hidden" name="viewScope" value="group">
          <input type="hidden" name="portalName" value="<%=portalName%>">
          <input type="hidden" name="groupId" value="<%=groupPortalGroupId%>">
          <input type="hidden" name="userId" value="">
          <input type="hidden" name="selectedPageIndex" value="">
          <input type="hidden" name="selectedPageFormName" value="">
          <input type="hidden" name="selectedPageNameValue" value="">
          <input type="hidden" name="selectedPageNameText" value="">
          <input type="hidden" name="lastSelectedPageFormName" value="">
          <input type="hidden" name="numberOfSkins" VALUE="<%= selectedSkinList.size() %>">
        
        </wf:form>

      </TD>
      <!-- end content area -->

      <TD align="center" valign="top" width="2%">
        &nbsp;<!-- spacer cell -->
      </TD>

    </TR>
  </TABLE>

</BODY>
</HTML>

