<%-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. --%>
<%@ page extends="com.bea.jsptools.common.servlets.jsp.ToolsJspBase"%>

<%-- ------------------------------------------------------------ --%>
<%-- page imports                                                 --%>
<%-- ------------------------------------------------------------ --%>
<%@ page import="com.bea.portal.model.PortalConstants"%>
<%@ page import="com.bea.portal.jsp.JspConstants"%>
<%@ page import="com.bea.portal.model.GroupPortal"%>
<%@ page import="java.util.Hashtable"%>

<%@ page errorPage="error.jsp" %>

<%-- ------------------------------------------------------------ --%>
<%-- taglibs                                                      --%>
<%-- ------------------------------------------------------------ --%>
<%@ taglib uri="webflow.tld" prefix="wf" %>
<%@ taglib uri="i18n.tld" prefix="i18n" %>
<%@ taglib uri="res.tld" prefix="res" %>
<%@ taglib uri="vum.tld" prefix="vum" %>
<%@ taglib uri="es.tld" prefix="es" %>
<%@ taglib uri="um.tld" prefix="um" %>

<%-- ------------------------------------------------------------ --%>
<%-- i18n (internationalization) and skin setup                   --%>
<%-- ------------------------------------------------------------ --%>

<%@ include file="/tools/portal/i18n_setup.inc"%>

<% // Grab the html title string from the properties file %>
<i18n:getMessage messageName='pageTitle' id='pageTitle'/>


<%-- ------------------------------------------------------------ --%>
<%-- environment setup                                            --%>
<%-- ------------------------------------------------------------ --%>

<%-- ------------------------------------------------------------ --%>
<%-- DECLARE NavLocation VALUE                                   --%>
<%-- Used for the left_navbar highlighting                        --%>
<%-- ------------------------------------------------------------ --%>
  <wf:setProperty property='NavLocation' value='<%=JspConstants.USERS_NAV%>' scope='request'/>

<%
  // Make this page uncacheable so that session variables can be cleared.
  response.setHeader("Cache-Control","no-cache");  // HTTP 1.1
  response.setHeader("Pragma","no-cache");      // HTTP 1.0
  response.setDateHeader("Expires", 0);      // prevents caching at proxy
%>
  
  <!-- /* setup variables used in this page */ -->
  <wf:getProperty property='groupPortalObj' id='currentGroupPortal' type='GroupPortal'/>
  <wf:getProperty property='portalName' id='portalName' type='String'/>
  <wf:getProperty property='gpPortalIDCurrent' id='portalIdStr' type='String'/>
  <wf:getProperty property='isWritableRealm' id='isWritableRealmObj' type='Boolean'/>

<%
  //Set boolean on if we're dealing with a writable realm.  We can disable some links if it's false
  boolean isWritableRealm = isWritableRealmObj.booleanValue();

  String newUsers = request.getParameter("newUsers");
  
  //If we've gotten here with a list of users, we want it back into the request session, as well
  // as determine where the back button leads to
  String backButtonLink = "link.back_create_user";
  if(newUsers == null || newUsers.equals(""))
  {
    backButtonLink = "link.back_choose_user";
  }
  String userName = request.getParameter("userName");

%>

<%-- ------------------------------------------------------------ --%>
<%-- begin rendering                                              --%>
<%-- ------------------------------------------------------------ --%>
<HTML>
<HEAD>
  <TITLE><%=pageTitle%></TITLE>
  <LINK REL=StyleSheet HREF="<wf:createResourceURL resource='<%=cssFile%>'/>" TYPE="text/css" MEDIA=screen>
  
  <%-- ------------------------------------------------------------ --%>
  <%-- begin JavaScript setup                                       --%>
  <%-- ------------------------------------------------------------ --%>
   
  <SCRIPT LANGUAGE="JavaScript">
    <!-- Begin hide from old browsers
      function submitUserInfo()
      {
        this.document.userInfoForm.submit();
      }
      function submitBack()
      {
        this.document.backForm.submit();
      }
    // End hide from old browsers -->
  </SCRIPT>
  <%-- ------------------------------------------------------------ --%>
  <%-- end JavaScript setup                                         --%>
  <%-- ------------------------------------------------------------ --%>
  
</HEAD>
<BODY leftmargin="0" rightmargin="0" marginwidth="0" marginheight="0" STYLE='BACKGROUND-IMAGE:url("<wf:createResourceURL resource='<%=imagesPath + "bg_subpage.gif"%>'/>"); BACKGROUND-REPEAT: no-repeat; BACKGROUND-POSITION:left top;'>

<%@ include file="/tools/util/admin_header.inc"%>
<!-- end top nav bar -->

  <!-- This is the uber table that contains two table data cells: one for the left nav, the other for the main page layout -->
  <TABLE border="0" cellspacing="0" cellpadding="0" width="100%" height="100%">
    <TR>
      <TD width="1%" align="left" valign="top" class="sidenav">
        <!-- include  table for left nav bar -->
        <jsp:include page="left_navbar.jsp"/>
      </TD>

      <TD align="center" valign="top" width="2%">
        <!-- spacer cell -->
        &nbsp;&nbsp;&nbsp;&nbsp;
      </TD>

      <!-- begin table for main content area -->
      <TD align="left" valign="top" width="95%">
        <% // Include the error message display logic %>
        <%@ include file="/tools/util/error_message.inc"%>

<%      // Creation of message arguments
        Object[] args = new Object[] { cnvrtSC(userName) };
%>
        <SPAN class="pageheader"><i18n:getMessage messageName='templateHeadLabel' messageArgs='<%=args%>'/></SPAN>
        <BR>
        <SPAN class="instructions"><i18n:getMessage messageName='templateSubheadLabel'/></SPAN>
<%      if(!isWritableRealm)
        {
%>
          <BR><BR>
          <SPAN class="instructions"><i18n:getMessage messageName='noteForLDAP'/></SPAN>
<%      }
%>
        <BR><BR>
<%      // number of labels in category listing header section
        int numberOfLabels = 1;

        if(isWritableRealm)
        {
%>
          <TABLE cellspacing="0" cellpadding="0" border="0" width="100%">
            <TR>
              <TD align="left" valign="top" rowspan="2">
                <!-- category listing left hand side -->
                <jsp:include page="category_list_header_lhs.jsp"/>
              </TD>
  
              <!-- It may seem strange to put a td width of 1000 in here, but after much trial and error this is the only way Netscape will maintain the fixed border widths along with the liquid, stretchable layout of the table -->
              <TD class="categoryHeadingBorderCell" colspan="<%=numberOfLabels%>" height="1px" width="1000"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
  
              <TD align="left" valign="top" rowspan="2">
                <!-- category listing right hand side -->
                <jsp:include page="category_list_header_rhs.jsp"/>
              </TD>
            </TR>
  
            <TR>
              <!-- * START LABELS -->
              <TD class="categoryHeadingCell" nowrap width="100%">
                <i18n:getMessage messageName='userInformation'/>
              </TD>
              <!-- * END LABELS -->
            </TR>
  
            <!-- This creates the dark green line at the bottom of the green header -->
            <TR>
              <TD class="categoryHeadingBorderCell" colspan="<%=(numberOfLabels+2)%>" height="1"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
            </TR>
            <!-- START DETAIL ROW -->
            <TR>
              <TD class="row">&nbsp;</TD>
              <TD class="row" nowrap>&nbsp;</TD>
            </TR>
            <!-- START DETAIL ROW -->
            <TR>
              <TD class="row">&nbsp;</TD>
  
              <!-- * START DETAIL -->
              <TD class="row" align="left" valign="top">
                &nbsp;&nbsp;&nbsp;&nbsp;
                <i18n:getMessage messageName='userInfoDirections'/>
                <BR>
                &nbsp;&nbsp;&nbsp;&nbsp;
                <i18n:getMessage messageName='userName'/>
                &nbsp;&nbsp;&nbsp;&nbsp;
                <a href="javascript:submitUserInfo()"><%=cnvrtSC(userName)%></a>
                <wf:form namespace="admin_portal"  event="link.edit_user_information" origin="user_attributes.jsp" hide="true" method="post" name="userInfoForm">  
                  <INPUT TYPE="HIDDEN" NAME="userName" VALUE="<%=userName%>">
                  <INPUT TYPE="HIDDEN" NAME="newUsers" VALUE="<%=newUsers%>">
                </wf:form>
              </TD>
              <!-- * END DETAIL -->
  
              <TD class="row">&nbsp;</TD>
            </TR>
            <!-- END DETAIL ROW -->
  
            <!-- SPACER ROW -->
            <TR>
              <TD class="spacerRow" colspan="<%=(numberOfLabels+2)%>">&nbsp;</TD>
            </TR>
      
          </TABLE>
<%      }
%>
<BR>
        <TABLE cellspacing="0" cellpadding="0" border="0" width="100%">
          <TR>
            <TD align="left" valign="top" rowspan="2">
              <!-- category listing left hand side -->
              <jsp:include page="category_list_header_lhs.jsp"/>
            </TD>

            <!-- It may seem strange to put a td width of 1000 in here, but after much trial and error this is the only way Netscape will maintain the fixed border widths along with the liquid, stretchable layout of the table -->
            <TD class="categoryHeadingBorderCell" colspan="<%=numberOfLabels%>" height="1px" width="1000"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>

            <TD align="left" valign="top" rowspan="2">
              <!-- category listing right hand side -->
              <jsp:include page="category_list_header_rhs.jsp"/>
            </TD>
          </TR>

          <TR>
            <!-- * START LABELS -->
            <TD class="categoryHeadingCell" nowrap width=100%>
<%            args = new Object[] { cnvrtSC(userName) };
%>
              <i18n:getMessage messageName='propertyInformation' messageArgs='<%=args%>'/>
            </TD>
            <!-- * END LABELS -->
          </TR>

          <!-- This creates the dark green line at the bottom of the green header -->
          <TR>
            <TD class="categoryHeadingBorderCell" colspan="<%=(numberOfLabels+2)%>" height="1"><img src="<wf:createResourceURL resource='<%=imagesPath + "transparent.gif"%>'/>" width="1" height="1" border="0"></TD>
          </TR>
          <!-- START DETAIL ROW -->
          <TR>
            <TD class="row">&nbsp;</TD>

            <!-- * START DETAIL -->
            <TD class="row" align="left" valign="top">
<%

              /***********************************************************/
              // Variables we need to set up for the edit_properties.inc
                 String originPage = "user_attributes.jsp";
                 //This is for any values we pass around when the page gets refreshed
                 Hashtable hiddenValues = new Hashtable();
                 hiddenValues.put("userName", userName);
                 if(newUsers != null)
                 {
                   hiddenValues.put("newUsers", newUsers);
                 }
              /***********************************************************/
%>                            

              <%@ include file="/tools/portal/edit_properties.inc"%>

            </TD>
          </TR>
          <!-- END DETAIL ROW -->
            
          <!-- START DETAIL ROW -->
          <TR>
            <TD class="row">&nbsp;</TD>
            <!-- * START DETAIL -->
            <TD class="row" align="left" valign="top" colspan="3">
              <A HREF="javascript:submitBack()"><IMG src="<wf:createResourceURL resource='<%=imagesPath + "back.gif"%>'/>" border="0" align="bottom"></A>
              <wf:form namespace="admin_portal"  event="<%=backButtonLink%>" origin="user_attributes.jsp" hide="true" method="post" name="backForm">  
                <INPUT TYPE="HIDDEN" NAME="newUsers" VALUE="<%=newUsers%>">
              </wf:form>
            </TD>
            <!-- * END DETAIL -->
            <TD class="row">&nbsp;</TD>
          </TR>
          <!-- END DETAIL ROW -->
          <!-- SPACER ROW -->
          <TR>
            <TD class="spacerRow" colspan="<%=(numberOfLabels+2)%>">&nbsp;</TD>
          </TR>
          <TR>
            <TD class="spacerRow" colspan="<%=(numberOfLabels+2)%>">&nbsp;</TD>
          </TR>

        </TABLE>

        
      </TD>
      <!-- end content area -->

      <TD align="center" valign="top" width="2%">
        <!-- spacer cell -->
        &nbsp;&nbsp;&nbsp;&nbsp;
      </TD>
    </TR>
    
  </TABLE>

</BODY>
</HTML>
