<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<%----------------------------------------------------------
Clean up checklist

[x] - using header include for the header
[x] - page extends com.bea.jsptools.common.servlets.jsp.ToolsJspBase
[x] - finished button at top and bottom (if page requires it)
[x] - check color consistency
[x] - cnvrtSC()
[x] - check tool tips 
[x] - blank text fields when first loaded 
[x] - check text input size
[x] - page wrapped in transaction 
[x] - colon after textfield labels
[x] - monitor session tag
[x] - goto error page
[x] - check for TODOs
----------------------------------------------------------%>

<%@ page extends="com.bea.jsptools.common.servlets.jsp.ToolsJspBase"%>
<%@ taglib uri="weblogic.tld" prefix="wl" %>
<%@ taglib uri="webflow.tld" prefix="wf" %>
<%@ taglib uri="es.tld" prefix="es" %>
<%@ taglib uri="um.tld" prefix="um" %>

<%@ page import="com.bea.jsptools.p13n.common.servlets.jsp.JspUtilPages" %>
<%@ page import="com.bea.p13n.usermgmt.servlets.jsp.taglib.UserManagementTagConstants" %>

<jsp:useBean id="groupUserManagementBean" class="com.bea.jsptools.p13n.usermgmt.servlets.jsp.GroupUserManagementBean" scope="session" />
<%-- Check to ensure the admin user is logged in --%>
<% request.setAttribute(SERVICEMANAGER_CURRENT_PAGE, getJspName(pageContext));%>

<%
  String statusMsg = null;
%>

<%
   String groupName = request.getParameter("groupName");
   String[] userArray = null;
   String[] groupuserArray = null;
%>

<% String searchCriteria=request.getParameter("userName2Search"); %>


<!-- if the user pressed save, save the matching users in the group -->
<wl:process name="formSubmit" value="save">
    <% 
	// get all the entries in the group_users list box		
	String[] users = request.getParameterValues("group_users");       
        groupUserManagementBean.storeNewUsers(users);	

	// add the users the group by consolidating the two arrays.	
	groupUserManagementBean.consolidate(groupName);

        statusMsg = "Group membership has been updated.";
     %>
</wl:process>

<%
  int limit = UserManagementTagConstants.DEFAULT_USER_LIMIT;
%>

<!-- get all the users matching the search criteria  -->
<wl:process name="doSearch">

    <!-- get all the users for the group -->
    <es:notNull item="<%=groupName%>">
      <um:getUsernamesForGroup id="allUsers" groupName="<%=groupName %>" result="result" searchExp="<%= searchCriteria %>" userLimit="<%= limit %>" />

    <% if(result.intValue() == UserManagementTagConstants.USER_SEARCH_OK)
       {
           //statusMsg = "Search done.";
           groupuserArray = allUsers;

           // add the users in the bean 
           groupUserManagementBean.storeOriginalUsers(groupuserArray);
       } %>

    </es:notNull>


    <um:getUsernames id="allUsers"  result="result" searchExp="<%= searchCriteria %>" 
        userLimit="<%= limit %>" />

    <% if(result.intValue() == UserManagementTagConstants.USER_LIMIT_EXCEEDED)
       {
           statusMsg ="Search count exceeds limit."; 
           userArray = allUsers;
       } %>
 
    <% if(result.intValue() == UserManagementTagConstants.USER_SEARCH_OK)
       { 
           //statusMsg = "Search done.";
           userArray = allUsers;
           if ( userArray.length == limit )
           {
               statusMsg = "Search results were limited to " + limit +
                           " users. Please narrow your search and try again.";
           }
      
           // use the bean to remove duplicate users from the userArray by looking at the groupuserArray
           userArray = groupUserManagementBean.removeDuplicates(userArray, groupuserArray);
       } %>
  
    <% //if(result == UserManagementTagConstants.USER_SEARCH_FAILED)
       //{
       //    statusMsg = "General error occurred." ;
       //} 
    %>

    

</wl:process>

<html>
<head>
<title>User Management</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">



<SCRIPT LANGUAGE="JavaScript">

function submitSearchForm() {
   this.document.SearchForm.submit();
   return true;
}

function submitSaveForm() {
   // before we submit the form, we select all entries in the group_users
   // list box except the last one
   selectAllEntries(document.SaveForm.group_users);
   this.document.SaveForm.submit();
   return true;
}


// functions to move users around between the text boxes
// The users move from the first parameter select box to the
// second parameter select box
function moveUsers(leftListBox, rightListBox)
{

    // delete all the items that are selected
    var leftLength=leftListBox.length;

    // users which are to be removed from the left list box are stored in this array
    var removedUsersArray = new Array();

    // copy all the options which are to be deleted in a new option list.
    // we also store them as a string variable
    var j=0;
    for(var i=0; i<leftLength; i++) {
       if(leftListBox.options[i].selected == true && leftListBox.options[i].value != "spacer") {
           var username = leftListBox.options[i].text;
           removedUsersArray[j++]= username;
       }
    }

    if ( removedUsersArray.length == 0 )
    {
      alert( "You must select at least one user to move." );
      return;
    }

    // call a function to remove the usernames from the list
    removeUserNames(leftListBox, removedUsersArray);

    // add the users to the rightListBox if they do not exists already in it.
    addUserNames(rightListBox, removedUsersArray);
}


// function which selects all items in the list box
// except the last one, which is a spacer
function selectAllEntries(listObject)
{
  for(var i=0; i<listObject.length-1; i++)
  {
      listObject.options[i].selected = true;
  }

  // deselect the last entry
  listObject.options[listObject.length-1].selected = false;
}

// function to add usernames to the list box 
function addUserNames(listObject, addUsersArray)
{
   // get the spacer which is the last entry in the list object
   var spacerOptionText = listObject.options[ listObject.options.length - 1 ].text;

   for(var i=0; i < addUsersArray.length; i++) {
       var username = addUsersArray[i];

	// add the user in place of the spacer
        listObject.options[ listObject.options.length - 1 ] = new Option(username,username,false,false);
		
	// add the spacer at the end
	listObject.options[ listObject.options.length ] = new Option(spacerOptionText, "spacer", false, false);
   }

   // deselect the newly added users
   for(var i=0; i<listObject.length; i++)
   {
      listObject.options[i].selected = false;
   }

}

// function to remove users form a list
function removeUserNames(listObject, userNamesString)
{
   var i=0;

   while(i < listObject.length)
   {

	if(listObject.options[i] != null) {
           var username = listObject.options[i].text;
           for ( var j=0; j<userNamesString.length; j++ )
           {
              if ( username == userNamesString[j] )
              {
                 listObject.options[i] = null;
                 i=-1;
                 break; // break the for loop
              }
           }
        }
 	i++;
   }
}

//

</SCRIPT>


</head>


<body bgcolor="#FFFFFF" topmargin="0" leftmargin="0" marginwidth="0" marginheight="0">
<!-- Header  -->
<jsp:include page="<%=JspUtilPages.JSP_UTIL_HOME_HDR%>" />

<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr> 
    <td width="5%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="88%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="4%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="65" height="8"></td>
    <td width="3%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
  </tr>
  <tr> 
    <td width="5%" bgcolor="#006666"> 
      <div align="right"><img src="<wf:createResourceURL resource="/repository/images/um.gif"/>" width="30" height="24"></div>
    </td>
    <td width="88%" bgcolor="#006666"><font face="Verdana, Arial, Helvetica, sans-serif" size="3" color="#FFFFFF"><b>Group: 
      <%= groupName %> </b></font></td>
    <td width="4%" bgcolor="#006666"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="65" height="24" border="0"></td>
    <td width="3%" bgcolor="#FFFFFF"><img src="<wf:createResourceURL resource="/repository/images/curves_um1_1.gif"/>" width="30" height="24"></td>
  </tr>
  <tr> 
    <td width="5%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="88%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="4%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="65" height="8"></td>
    <td width="3%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
  </tr>
</table>
<% if(statusMsg != null) { %> <%@ include file="status.inc" %> <% } %>
<table border="0" cellspacing="0" cellpadding="0" width="100%">
  <tr> 
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td width="46%">&nbsp;</td>
    <td width="46%">&nbsp;</td>
  </tr>
  <tr> 
    <td width="2%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="20" height="8"></td>
    <td rowspan="2" width="6%"> <font face="Verdana, Arial, Helvetica, sans-serif" size="2"><img src="<wf:createResourceURL resource="/repository/images/icon_addremove.gif"/>" width="65" height="50"></font></td>
    <td bgcolor="#CCCCCC" width="76%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8">Add/Remove 
      Group Search Results</b></font></td>
    <td width="16%" bgcolor="#CCCCCC">&nbsp;</td>
  </tr>
  <tr> 
    <td width="2%">&nbsp;</td>
    <td width="76%">&nbsp;</td>
    <td width="16%">&nbsp;</td>
  </tr>
  <tr>
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td width="76%" colspan=2><font face="Verdana, Arial, Helvetica, sans-serif" size="2">Search
      for the user you want to add or remove from this group. The search results and 
      current group users will appear at the bottom of the page. To add a user, select
      the user name and click the right arrow. To remove a user, select the user name
      and click the left arrow. You must click the "save" button to commit any changes
      to the group before performing a new search or leaving this page.</font></td>
  </tr>
  <tr> 
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td width="76%">&nbsp;</td>
    <td width="16%">&nbsp;</td>
  </tr>
  <tr> 
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td width="30%"> 
    <form method="post" action="<wf:createWebflowURL event="link.group_add_remove_users"/>" name="SearchForm">

        <table width="100%" border="0" cellspacing="2" cellpadding="2">
          <tr> 
            <td width="30%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><nobr>Username:  
              </nobr></b></font></td>
            <td width="68"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"> 
              <input type="text" name="userName2Search" maxlength="50" value="<%= (searchCriteria == null) ? "" : searchCriteria %>">
              </font></td>
            <td width="2%">
	        <a href="javascript:submitSearchForm();" onClick="submitSearchForm(); return false;">
                <img src="<wf:createResourceURL resource="/repository/images/search_um1.gif"/>" width="65" border="0" height="40" alt="Perform User Search"></a></td>
          </tr>
        </table>
    <input type="hidden" name="<%=DESTINATION_TAG%>" value="<%=getRequestURI(request)%>">
    <input type="hidden" name="doSearch" value="search">
    <input type="hidden" name="groupName" value="<%= groupName %>">
    </form>
    </td>
    <!-- print the alphabetic characters -->
    <% String alphabets = "ABCDEFGHIJKLMNOPQRSTUVWXYZ_"; %>
    <td width="46%">
      <table border="0" cellspacing="4" cellpadding="4">
        <tr bgcolor="#006666"> 
	   
	   <!-- print all the characters -->
           <es:counter id="i" minCount="0" maxCount="26">
               <%-- parameters to be passed to the url --%>
               <% String params = "doSearch=search" + "&groupName=" + java.net.URLEncoder.encode(groupName) +
                                  "&userName2Search=" + alphabets.substring(i.intValue(),i.intValue()+1).toLowerCase() + "*"; %>

           <% // TODO: this is going to be an i18n issue

              // from the letter M, we print in a different row 
              if(i.intValue() == 13)
              { %>
                  </tr>
                  <tr bgcolor="#006666">                   
	       <% } %>

	       <td>
		   <div align="center">
		   <A HREF="<wf:createWebflowURL event="link.group_add_remove_users" extraParams="<%=params%>"/>"><font size="3" face="Verdana, Arial, Helvetica, sans-serif"><b><font color="#FFFFFF">
                   <%= alphabets.substring(i.intValue(),i.intValue()+1) %></font></b></font></a></div>
               </td>
           </es:counter>
	</tr>
        </table>
    </td>
  </tr>
  <tr> 
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td width="76%"> 
      <table border="0" cellspacing="4" cellpadding="0" align="right" width="15">
        <tr> 
          <td width="14">&nbsp;</td>
          <td width="14"> 
            <div align="right"></div>
          </td>
        </tr>
      </table>
    </td>
    <td width="16%">&nbsp;</td>
  </tr>
  <tr> 
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td width="76%" colspan=2 align="left">
        <form method="post" action="<wf:createWebflowURL event="link.group_add_remove_users"/>" name="SaveForm">
        <table border="0" cellspacing="4" cellpadding="0" width="4%">
          <tr> 
            <td width="4%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="30" height="5"></td>
            <td width="43%" align="left"> 
              <font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b>Search 
                Results: </b></font>
            </td>
            <td width="10%">&nbsp;</td>
            <td width="43%" align="left" nowrap><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b>Group 
              Search Results: </b></font></td>
          </tr>
          <tr> 
            <td width="4%">&nbsp;</td>
            <td width="43%"> 
              <div align="left"> 
                <select name="search_users" multiple size="10">
		  <!-- all the users go here -->
                  <es:notNull item="<%=userArray%>">
			<es:forEachInArray id="userName" array="<%=userArray%>" type="String" counterId="i">
			    <option><%= cnvrtSC(userName) %></option>
			</es:forEachInArray>
                  </es:notNull>
                  <option value="spacer">---------------------------------</option>
                </select>
              </div>
            </td>
            <td width="10%"> 
              <table width="100%" border="0" cellspacing="4" cellpadding="1">
                <tr> 
                  <td> 
                    <div align="center"><A HREF="javascript:moveUsers(document.SaveForm.search_users, document.SaveForm.group_users);" onClick="moveUsers(document.SaveForm.search_users, document.SaveForm.group_users); return false;"><img src="<wf:createResourceURL resource="/repository/images/arrow_right.gif"/>" border=0 width="24" height="24" alt="Add User(s)"></div>
                  </td>
                </tr>
                <tr> 
                  <td> 
                    <div align="center"><A HREF="javascript:moveUsers(document.SaveForm.group_users,document.SaveForm.search_users);" onClick="moveUsers(document.SaveForm.group_users,document.SaveForm.search_users); return false;"><img src="<wf:createResourceURL resource="/repository/images/arrow_left.gif"/>" border=0 width="24" height="24" alt="Remove User(s)"></a></div>
                  </td>
                </tr>
              </table>
            </td>
            <td width="43%" align="left"> 
              <select name="group_users" multiple size="10">
                  <es:notNull item="<%=groupuserArray%>">
			<es:forEachInArray id="userName" array="<%=groupuserArray%>" type="String" counterId="i">
			    <option><%= cnvrtSC(userName) %></option>
			</es:forEachInArray>
                  </es:notNull>
	        <option value="spacer">---------------------------------</option>
              </select>
            </td>
          </tr>
        </table>
    </td>
  </tr>
  <tr> 
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td width="46%">&nbsp;</td>
    <td width="46%">&nbsp;</td>
  </tr>
  <tr> 
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td width="46%" colspan=2> 
      <table width="30%" border="0" cellspacing="0" cellpadding="0" align="right">
        <tr> 
          <td>
           <% String params1 = "groupName=" + java.net.URLEncoder.encode(groupName); %>
           <a href="<wf:createWebflowURL event="link.group_scope_property" extraParams="<%=params1%>"/>"><img src="<wf:createResourceURL resource="/repository/images/back_um1.gif"/>" width="65" height="40" alt="Return to the Previous Page" border="0"></a>

	   <a href="javascript:submitSaveForm();" onClick="submitSaveForm(); return false;">
           <img src="<wf:createResourceURL resource="/repository/images/save_um1.gif"/>" width="65" border=0 height="40" alt="Save Changes"></a>

          </td>
        </tr>
      </table>
    </td>
  <input type="hidden" name="<%=DESTINATION_TAG%>" value="<%=getRequestURI(request)%>">
  <input type="hidden" name="formSubmit" value="save">
  <input type="hidden" name="doSearch" value="search"> <!-- do the search after save -->
  <input type="hidden" name="groupName" value="<%= groupName %>">
  <input type="hidden" name="userName2Search" value="<%= searchCriteria %>">
  </form>
  </tr>
</table>
<input type="hidden" name="<%=DESTINATION_TAG%>" value="<%=getRequestURI(request)%>">
<input type="hidden" name="formSubmit" value="formSubmit">
</form>

</body>

</html>



