<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<%----------------------------------------------------------
Clean up checklist

[x] - using header include for the header
[x] - page extends com.bea.jsptools.common.servlets.jsp.ToolsJspBase
[x] - finished button at top and bottom (if page requires it)
[x] - check color consistency
[x] - cnvrtSC()
[x] - check tool tips 
[x] - blank text fields when first loaded 
[x] - check text input size
[x] - page wrapped in transaction 
[x] - colon after textfield labels
[x] - monitor session tag
[x] - goto error page
[x] - check for TODOs
----------------------------------------------------------%>

<%@ page extends="com.bea.jsptools.common.servlets.jsp.ToolsJspBase"%>
<%@ taglib uri="weblogic.tld" prefix="wl" %>
<%@ taglib uri="webflow.tld" prefix="wf" %>
<%@ taglib uri="es.tld" prefix="es" %>
<%@ taglib uri="um.tld" prefix="um" %>

<%@ page import="com.bea.p13n.usermgmt.servlets.jsp.taglib.UserManagementTagConstants" %>
<%@ page import="com.bea.jsptools.p13n.common.servlets.jsp.JspUtilPages" %>

<jsp:useBean id="groupBean" class="com.bea.jsptools.p13n.usermgmt.servlets.jsp.GroupBean" scope="session" />
<jsp:setProperty name="groupBean" property="*" />

<% request.setAttribute(SERVICEMANAGER_CURRENT_PAGE, getJspName(pageContext));%>

<%
  String statusMsg = null;
%>

<%-- get the parent of the group to be created, if the user clicked on the + sign --%>
<% String parent = request.getParameter("parent"); %>

<wl:process name="formSubmit">
<%@ include file="/tools/util/startUserTransaction.inc" %>

  <%-- create the group --%>
  <% String group = request.getParameter("name"); %>
  <% if ( group != null ) group = group.trim(); %>
  <%int realResult = 0;%>

  <%-- do some quick validation on the name --%>
  <% statusMsg = cnvrtSC(groupBean.validate( group )); %>

  <es:isNull item="<%= statusMsg %>" >
    <%-- create the group which is a subgroup of a specified group --%>
    <es:isNull item="<%=parent%>">
       <um:createGroup groupName= "<%= group %>" result="result" />
       <% realResult = result.intValue(); %>	
    </es:isNull>

    <es:notNull item="<%=parent%>">
       <um:createGroup groupName= "<%= group %>" parentName="<%= parent %>" result="result" />
       <% realResult = result.intValue(); %>	
    </es:notNull>

    <%-- display an error message if there is an error message --%>
    <% if(realResult == UserManagementTagConstants.CREATE_GROUP_OK)
       {
	       statusMsg = "Group '" + cnvrtSC(group) + "' created successfully.";
       }
       else if(realResult == UserManagementTagConstants.CREATE_GROUP_FAILED)
       {
  	     statusMsg = "Cannot Create Group : " + cnvrtSC(group) + ", unknown error."; 
       }
       else if(realResult == UserManagementTagConstants.RESERVED_GROUP_NAME)
       {
	       statusMsg = "The group name '" + cnvrtSC(group) + "' is reserved"; 
       }
       else if(realResult == UserManagementTagConstants.GROUP_EXISTS)
       {
	       statusMsg = "Group '" + cnvrtSC(group) +"' Already exists, cannot create. "; 
       } %>
  </es:isNull>

<%@ include file="/tools/util/endUserTransaction.inc" %>
</wl:process>


<html>
<head>
<title>User Management</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<SCRIPT LANGUAGE="JavaScript">
function submitForm() {
   this.document.UserMgmtForm.submit();
   return true;
}
</SCRIPT>
</head>


<%@ include file="/tools/util/startUserTransaction.inc" %>

<body bgcolor="#FFFFFF" topmargin="0" leftmargin="0" marginwidth="0" marginheight="0">

<!-- Header  -->
<jsp:include page="<%=JspUtilPages.JSP_UTIL_HOME_HDR%>"/>

<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr> 
    <td width="3%" bgcolor="#000000"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></b></font></td>
    <td width="88%" bgcolor="#000000"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></b></font></td>
    <td width="6%" bgcolor="#000000"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/stopclear.gif"/>" width="65" height="8"></b></font></td>
    <td width="3%" bgcolor="#000000"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></b></font></td>
  </tr>
  <tr> 
    <td width="3%" bgcolor="#006666"><img src="<wf:createResourceURL resource="/repository/images/um.gif"/>" width="30" height="24"></td>
    <td width="88%" bgcolor="#006666"><font face="Verdana, Arial, Helvetica, sans-serif" size="3" color="#000000"><b><font color="#FFFFFF">Groups</font></b></font></td>
    <td width="6%" bgcolor="#006666"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/smiddleclear.gif"/>" width="65" height="24"></b></font></td>
    <td width="3%" bgcolor="#FFFFFF"><img src="<wf:createResourceURL resource="/repository/images/curves_um1_1.gif"/>" width="30" height="24"></td>
  </tr>
  <tr> 
    <td width="3%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></b></font></td>
    <td width="88%">
      <% if(statusMsg != null)
         { %> <%@ include file="status.inc" %><% } %></td>
    <td width="6%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/sbottomclear.gif"/>" width="65" height="8"></b></font></td>
    <td width="3%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></b></font></td>
  </tr>
</table>
<table border="0" cellspacing="0" cellpadding="0" width="100%">
  <tr> 
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td width="76%">&nbsp;</td>
    <td width="16%">&nbsp;</td>
  </tr>
  <tr> 
    <td width="2%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="20" height="8"></td>
    <td rowspan="2" width="6%"> <font face="Verdana, Arial, Helvetica, sans-serif" size="2"><img src="<wf:createResourceURL resource="/repository/images/icon_create.gif"/>" width="65" height="50"></font></td>
    <% String displayString = (parent == null) ? " below top level " : " below '" + parent + "'"; %>
    <td bgcolor="#CCCCCC" width="76%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8">Create New Group <%= displayString %></b></font></td>
    <td width="16%" bgcolor="#CCCCCC">&nbsp;</td>
  </tr>
  <tr> 
    <td width="2%">&nbsp;</td>
    <td width="76%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2">Enter 
      the appropriate information then click Create.</font></td>
    <td width="16%">&nbsp;</td>
  </tr>
  <tr>
    <!-- validation error display -->
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td width="76%">&nbsp;</td>
    <td width="16%">&nbsp;</td>
  </tr>

  <tr> 
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td width="76%"> 
      <form method="post" action="<wf:createWebflowURL event="link.group_create"/>" name="UserMgmtForm">
        <table width="100%" border="0" cellspacing="2" cellpadding="0">
          <tr> 
            <td width="19%"> 
              <div align="left"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b> 
                Group Name: </b></font></div>
            </td>
            <td width="30%"> <font face="Verdana, Arial, Helvetica, sans-serif"> 
              <input type="text" value="" name="name" size="20" maxlength="50">
              </font></td>
            <td colspan="2">&nbsp;</td>
          </tr>
          <tr> 
            <td width="19%">&nbsp;</td>
            <td width="30%" valign="bottom">&nbsp; </td>
            <td colspan="2"> 
              <table border="0" cellspacing="4" cellpadding="0" align="right">
                <tr> 
                  <td> 
                    <div align="right"><a href="<wf:createWebflowURL event="link.group_list"/>"><img src="<wf:createResourceURL resource="/repository/images/back_um1.gif"/>" width="65" height="40" alt="Return to the Previous Page" border="0"></a></div>
                  </td>
                  <td> 
                    <div align="right"><A HREF="javascript:submitForm();" onClick="submitForm(); return false;"><img src="<wf:createResourceURL resource="/repository/images/create_um1.gif"/>" width="65" height="40" alt="Create Group" border="0"></a></div>
                  </td>
                </tr>
              </table>
            </td>
          </tr>
        </table>

	<%-- if the parent field is not null, add it as a hidden input type --%>
	<es:notNull item="<%=parent%>">
	   <input type="hidden" name="parent" value="<%= parent%>" >
	</es:notNull>
        <input type="hidden" name="<%=DESTINATION_TAG%>" value="<%=getRequestURI(request)%>">
        <input type="hidden" name="formSubmit" value="formSubmit">
      </form>
    </td>
    <td width="16%">&nbsp;</td>
  </tr>
  <tr> 
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td width="76%" bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"></font></td>
    <td width="16%">&nbsp;</td>
  </tr>
</table>
</body>
<%@ include file="/tools/util/endUserTransaction.inc" %>
</html>
