<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<%----------------------------------------------------------
Clean up checklist

[x] - using header include for the header
[x] - page extends com.bea.jsptools.common.servlets.jsp.ToolsJspBase
[x] - finished button at top and bottom (if page requires it)
[x] - check color consistency
[x] - cnvrtSC()
[x] - check tool tips 
[x] - blank text fields when first loaded 
[x] - page wrapped in transaction 
[x] - colon after textfield labels
[x] - monitor session tag
[x] - goto error page
----------------------------------------------------------%>

<%@ page extends="com.bea.jsptools.p13n.usermgmt.servlets.jsp.JspHierarchyBase" %>
<%@ taglib uri="weblogic.tld" prefix="wl" %>
<%@ taglib uri="webflow.tld" prefix="wf" %>
<%@ taglib uri="es.tld" prefix="es" %>
<%@ taglib uri="um.tld" prefix="um" %>

<%@ page import="com.bea.p13n.appflow.webflow.WebflowJSPHelper"%>
<%@ page import="com.bea.jsptools.p13n.common.servlets.jsp.JspUtilPages" %>
<%@ page import="com.bea.jsptools.p13n.usermgmt.servlets.jsp.HierarchyManagementBean" %>
<%@ page import="com.bea.p13n.usermgmt.servlets.jsp.taglib.UserManagementTagConstants" %>

<jsp:useBean id="hierarchyManagementBean" class="com.bea.jsptools.p13n.usermgmt.servlets.jsp.HierarchyManagementBean" scope="session" />
<jsp:useBean id="accessBean" class="com.bea.jsptools.p13n.usermgmt.servlets.jsp.FunctionAccessBean" scope="session" />
<jsp:useBean id="groupBean" class="com.bea.jsptools.p13n.usermgmt.servlets.jsp.GroupBean" scope="session" />

<% request.setAttribute(SERVICEMANAGER_CURRENT_PAGE, getJspName(pageContext));%>

<% 
 // to print error status messages
 String statusMsg = null;

 // as of Flagstaff we no longer allow renaming groups
 boolean allowRenamingGroups = false;
%>

<%-- check the fact that the user might have clicked on the expand/collapse buttons --%>
<% String groupName = null; %>
<% groupName=request.getParameter("editgroupName"); %>

<wl:process name="hierarchyAction" value="expand">
<%@ include file="/tools/util/startUserTransaction.inc" %>
    <% hierarchyManagementBean.addGroupAsExpanded(request.getParameter("groupName")); %>
<%@ include file="/tools/util/endUserTransaction.inc" %>
</wl:process>

<wl:process name="hierarchyAction" value="collapse">
<%@ include file="/tools/util/startUserTransaction.inc" %>
    <% hierarchyManagementBean.removeGroupAsExpanded(request.getParameter("groupName")); %>
<%@ include file="/tools/util/endUserTransaction.inc" %>
</wl:process>

<!-- reset the tree first time when loaded -->
<wl:process name="reset">
     <% hierarchyManagementBean.reset(); %>
</wl:process>


<!-- for changing the name -->
<wl:process name="newGroupName">
<%--  we don't change group names anymore for Flagstaff
<%@ include file="/tools/util/startUserTransaction.inc" %>

  <%int realResult = 0;%>

  <% String newGroupName  = request.getParameter("newGroupName");  %>
  <% if ( newGroupName != null ) newGroupName = newGroupName.trim(); %>

  <% // do some quick validation on the name %>
  <% statusMsg = cnvrtSC(groupBean.validate( newGroupName )); %>

  <es:isNull item="<%= statusMsg %>" >

    <um:changeGroupName oldGroupName="<%=groupName %>" newGroupName="<%= newGroupName %>" result="result" />

    <% realResult = result.intValue(); %>	

    <% // display an error message if there is an error message %>
    <% if(realResult == UserManagementTagConstants.GROUP_CHANGE_OK)
       {
	       statusMsg = "Group " + cnvrtSC(newGroupName) + " changed successfully."; 
               groupName = newGroupName; 
       }
       else if(realResult == UserManagementTagConstants.GROUP_CHANGE_FAILED)
       {
	       statusMsg = "Cannot change group name. "; 
       } %>

   </es:isNull>
<%@ include file="/tools/util/endUserTransaction.inc" %>
--%>
</wl:process>


<!-- to change the parent -->
<wl:process name="changeParent">
<%@ include file="/tools/util/startUserTransaction.inc" %>

  <% String groupToAddTo = request.getParameter("parent"); %>
   
    <um:getParentGroupName groupName="<%=groupName%>" id="parentGroupName"/>

<% 
    if(groupToAddTo != null && groupToAddTo.length() > 0)
    { 
        // we're moving a child group to another group or we're moving a
        // top level group to be a child of another group   %> 

        <um:addGroupToGroup parentGroupName="<%= groupToAddTo %>" childGroupName="<%= groupName %>" result="result"/>

        <% //display an error message if there is an error message 
        if(result.intValue() == UserManagementTagConstants.ADD_GROUP_OK)
        {
            statusMsg = "Group " + cnvrtSC(groupName) + " moved successfully."; 
        }
        else if(result.intValue() == UserManagementTagConstants.ADD_GROUP_FAILED)
        {
            statusMsg = "Cannot add Group. "; 
        }   
    }
    else
    {  
        // we're moving a child group to be a top level group, so
        // just remove it from it's parent to achieve that  %>

        <um:removeGroupFromGroup parentGroupName="<%=parentGroupName%>" childGroupName="<%=groupName%>" result="result"/>

        <% //display an error message if there is an error message 
        if(result.intValue() == UserManagementTagConstants.REMOVE_GROUP_OK)
        {
            statusMsg = "Group " + cnvrtSC(groupName) + " moved successfully."; 
        }
        else if(result.intValue() == UserManagementTagConstants.REMOVE_GROUP_FAILED)
        {
            statusMsg = "Cannot add Group. "; 
        }   
    }  
%>



<%@ include file="/tools/util/endUserTransaction.inc" %>
</wl:process>

<html>
<head>
<title>User Management</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<SCRIPT LANGUAGE="JavaScript">
function submitForm() {
   this.document.UserMgmtForm.submit();
   return true;
}

function deleteSubGroup(subgroup)
{
   return (confirm("Are you sure you want to move group '" + subgroup + "' and all it's children"));
}

</SCRIPT>
</head>

<%@ include file="/tools/util/startUserTransaction.inc" %>

<body bgcolor="#FFFFFF"  vlink="#0000FF" link="#0000FF" topmargin="0" leftmargin="0" marginwidth="0" marginheight="0">
<!-- Header  -->
<jsp:include page="<%=JspUtilPages.JSP_UTIL_HOME_HDR%>"/>

<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr> 
    <td width="2%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="88%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="7%" bgcolor="#000000"><a href="<wf:createWebflowURL event="link.user_home"/>"><img src="<wf:createResourceURL resource="/repository/images/stopblack_um1.gif"/>" width="65" height="8" border="0" alt="Return to User Management Home"></a></td>
    <td width="3%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
  </tr>
  <tr> 
    <td width="2%" bgcolor="#006666"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#FFFFFF"><img src="<wf:createResourceURL resource="/repository/images/um.gif"/>" width="30" height="24" align="absmiddle"></font></td>
    <td width="88%" bgcolor="#006666"><font face="Verdana, Arial, Helvetica, sans-serif" size="3" color="#FFFFFF"><b><font color="#FFFFFF">Groups</font></b></font></td>
    <td width="7%" bgcolor="#006666"><a href="<wf:createWebflowURL event="link.user_home"/>"><img src="<wf:createResourceURL resource="/repository/images/sfinished_um1.gif"/>" width="65" height="24" border="0" alt="Return to User Management Home"></a></td>
    <td width="3%"><img src="<wf:createResourceURL resource="/repository/images/curves_um1_1.gif"/>" width="30" height="24"></td>
  </tr>
  <tr> 
    <td width="2%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="88%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="7%"><a href="<wf:createWebflowURL event="link.user_home"/>"><img src="<wf:createResourceURL resource="/repository/images/sbottom_um1.gif"/>" width="65" height="8" border="0" alt="Return to User Management Home"></a></td>
    <td width="3%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
  </tr>
  <tr> 
    <td width="2%">&nbsp;</td>
    <td width="88%">&nbsp;<% if(statusMsg != null) { %><%@ include file="status.inc" %><% } %></td>
    <td width="7%">&nbsp;</td>
    <td width="3%">&nbsp;</td>
  </tr>
</table>
<form method="post" action="<wf:createWebflowURL event="link.group_edit"/>" name="UserMgmtForm">
  <table width="100%" border="0" cellspacing="0" cellpadding="0">
    <% boolean isManageableRealm = accessBean.isManageableRealm(); 
       if( isManageableRealm) { %>
    <tr>
      <td width="3%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="30" height="5"></td>
      <td width="81%" bgcolor="#CCCCCC"><b><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8">Change 
        Group: <%=groupName%> </font></b></td>
      <td width="11%" bgcolor="#CCCCCC">&nbsp;</td>
    </tr>
       <% } %>
    <tr> 
      <td width="3%">&nbsp;</td>
      <%-- next line was <td width="81%"> --%>
      <td width="97%"> 
        <table width="100%" border="0" cellspacing="8" cellpadding="0">
          <tr> 

          <% String message = null;
             String imageSrc = WebflowJSPHelper.createStaticResourceURL(pageContext, "/repository/images/add.gif", false);
             String colWidth = "49%";

             if(isManageableRealm && allowRenamingGroups)
             {            
                 message = "Enter the new name of the group in the text box and click on the save button to rename the group. To move the group to a different level, traverse through the hierarchy below and click on the <img src=\"" + imageSrc + "\" width=\"20\" height=\"20\" align=\"absmiddle\"> image to move the group to that level.";
             }
             else
             {
                 message = "To move the group to a different level, traverse through the hierarchy below and click on the <img src=\"" + imageSrc + "\" width=\"20\" height=\"20\" align=\"absmiddle\"> image to move the group to that level.";
                 colWidth = "100%";
             }
            %>

            <td width=<%=colWidth%> valign="top"><font face="Verdana, Arial, Helvetica, sans-serif" size="2">
              <%=message%></font></td>

            <% if(allowRenamingGroups) { %>
            <td width="51%"> 
              <table width="100%" border="0" cellspacing="2" cellpadding="0">
                <tr valign="center"> 
                  <td width="30%" nowrap valign="center"> 
                    <div align="right"><b><font face="Verdana, Arial, Helvetica, sans-serif" size="2">Original 
                      Name: </font></b></div>
                  </td>
                  <td width="47%" valign="center"> 
                    <div align="left"><b><%= cnvrtSC(groupName) %></b></div>
                  </td>
                </tr>
                <tr valign="center"> 
                  <td width="30%">&nbsp;</td>
                  <td width="47%">&nbsp;</td>
                </tr>
                <tr valign="top"> 
                  <td width="30%" nowrap valign="center"> 
                    <div align="right"><b><font face="Verdana, Arial, Helvetica, sans-serif" size="2">New 
                      Name: </font></b></div>
                  </td>
                  <td width="47%" valign="center"> 
                    <div align="left"><b> 
                      <input type="text" name="newGroupName" size="20" maxlength="50" value="" > 
                      </b></div>
                  </td>
                  <td width="23%" rowspan="2"><b><A HREF="javascript:submitForm();" onClick="submitForm(); return false;"><img src="<wf:createResourceURL resource="/repository/images/save_um1.gif"/>" border=0 width="65" height="40" alt="Save Group Name Change"></a></b></td>
                </tr>
                <tr valign="top"> 
                  <td width="30%">&nbsp;</td>
                  <td width="47%">&nbsp;</td>
                </tr>
              </table>
            </td>
            <% } %>
          </tr>
        </table>
      </td>
      <%-- <td width="11%">&nbsp;</td> --%>
    </tr>
    <tr> 
      <td width="3%">&nbsp;</td>
      <td width="81%" bgcolor="#ffffff">&nbsp;</td>
      <td width="11%" bgcolor="#ffffff">&nbsp;</td>
    </tr>
    <tr> 
      <td width="3%">&nbsp;</td>
      <td width="81%" bgcolor="#CCCCCC"><b><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8">Group 
        Hierarchy </font></b></td>
      <td width="11%" bgcolor="#CCCCCC">&nbsp;</td>
    </tr>
    <tr> 
      <td width="3%">&nbsp;</td>
      <td width="81%"> 
        <table width="100%" border="0" cellspacing="2" cellpadding="2">
          <tr> 
            <td colspan="3"><b><font face="Verdana, Arial, Helvetica, sans-serif" size="3">Top Level Groups</font></b></td>
          </tr>

	  <% String groupNames[] = getTopLevelGroupNames(); %>
	  <% hierarchyManagementBean.setDisplayType(HierarchyManagementBean.EDIT); %>
	  
	  <%-- Store the groupName in the bean so that we do not display the + sign for that group --%>
	  <% hierarchyManagementBean.setCurrentGroupName(groupName); %>
	  
	  <% boolean isTopLevelGroup = false; %>
	  <es:forEachInArray id="currgroupName" array="<%=groupNames%>" type="String" counterId="i">
		<%= printSubGroups(currgroupName.toString(), i.intValue(), hierarchyManagementBean, response, request, pageContext) %>
        <% if(currgroupName.toString().equalsIgnoreCase(groupName))
           {   
		       isTopLevelGroup = true;
           } %>
	  </es:forEachInArray>

	 <!-- print the + at the end if the group is not a top level group -->
     <% if(!isTopLevelGroup)
        {
            String params = "changeParent=true" + 
                            "&editgroupName=" + 
                            java.net.URLEncoder.encode(groupName); %>
    	    <tr>
	    <td width="3%">&nbsp;</td>
	    <td width="3%" height="17"><a href="<wf:createWebflowURL event="link.group_edit" extraParams="<%=params%>"/>">
	    <img src="<wf:createResourceURL resource="/repository/images/add.gif"/>"
	       width=20 height=20 alt="Move Group to Top Level" border=0></a></td>
	     <td height="17" width="94%"><font face="Verdana, Arial, Helvetica, sans-serif" color="#0000FF" size=2>Move group to top level</font></td>
	    <td height="17" width="94%">&nbsp;</td>
	    </tr>
     <% } %>

        </table>
      </td>
      <td width="11%">&nbsp;</td>
    </tr>
    <tr> 
      <td width="3%">&nbsp;</td>
      <td align="right" width="81%"> 
        <table border="0" cellspacing="4" cellpadding="0" align="right">
          <tr> 
            <td>
              <% String params1 = "groupName=" + java.net.URLEncoder.encode(groupName); %>
              <a href="<wf:createWebflowURL event="link.group_scope_property" extraParams="<%=params1%>"/>"><img src="<wf:createResourceURL resource="/repository/images/back_um1.gif"/>" width="65" height="40" alt="Return to the Previous Page" border="0"></a></td>
            <td>
              <a href="<wf:createWebflowURL event="link.user_home"/>"><img src="<wf:createResourceURL resource="/repository/images/finished_um1.gif"/>" width="65" height="40" alt="Return to User Management Home" border="0"></a></td>
          </tr>
        </table>
      </td>
      <td width="11%">&nbsp;</td>
    </tr>
    <tr> 
      <td width="3%">&nbsp;</td>
      <td width="81%">&nbsp;</td>
      <td width="11%">&nbsp;</td>
    </tr>
  </table>
  <input type="hidden" name="<%=DESTINATION_TAG%>" value="<%=getRequestURI(request)%>">
  <input type="hidden" name="editgroupName" value="<%= groupName%>">
</form>

<%@ include file="/tools/util/endUserTransaction.inc" %>
</body>
</html>
