<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<%--
Clean up checklist

[x] - using header include for the header
[x] - page extends com.bea.jsptools.common.servlets.jsp.ToolsJspBase
[x] - finished button at top and bottom
[x] - check color consistency
[x] - cnvrtSC()
[x] - check tool tips 
[x] - blank text fields when first loaded 
[x] - page wrapped in transaction 
[x] - colon after textfield labels
[x] - monitor session tag
[x] - goto error page
--%>

<%@ page extends="com.bea.jsptools.common.servlets.jsp.ToolsJspBase"%>
<%@ taglib uri="weblogic.tld" prefix="wl" %>
<%@ taglib uri="webflow.tld" prefix="wf" %>
<%@ taglib uri="es.tld" prefix="es" %>
<%@ taglib uri="um.tld" prefix="um" %>
<%@ page import="java.net.URLEncoder" %>

<%@ page import="com.bea.jsptools.p13n.common.servlets.jsp.JspUtilPages" %>
<%@ page import="com.bea.p13n.property.PropertyDefinition" %>
<%@ page import="com.bea.p13n.property.PropertySet" %>
<%@ page import="com.bea.p13n.usermgmt.servlets.jsp.taglib.UserManagementTagConstants" %>

<jsp:useBean id="propertyBean" class="com.bea.jsptools.p13n.usermgmt.servlets.jsp.PropertyBean" scope="request" />
<jsp:useBean id="propertySetBean" class="com.bea.jsptools.p13n.usermgmt.servlets.jsp.PropertySetBean" scope="request" />
<jsp:useBean id="accessBean" class="com.bea.jsptools.p13n.usermgmt.servlets.jsp.FunctionAccessBean" scope="session" />
<jsp:setProperty name="propertySetBean" property="*" />

<% request.setAttribute(SERVICEMANAGER_CURRENT_PAGE, getJspName(pageContext));%>

<%
  // initialization parameters
  final String USER_TYPE = "USER";

  boolean isManageableRealm = accessBean.isManageableRealm();
  String statusMsg = null;
  String groupName = request.getParameter("groupName"); 
  String params = "groupName="+ URLEncoder.encode(groupName); 
  String params1 = "editgroupName="+ URLEncoder.encode(groupName) + "&reset=true";
  String scopeName = null;
  String[] groupuserArray = null;
  propertySetBean.setSchemaGroupName(USER_TYPE);
  PropertySet propertySet = null;
%>

<% request.setAttribute(SERVICEMANAGER_CURRENT_PAGE, getJspName(pageContext));%>

<%-- get the profile for the group --%>
<um:getProfile profileKey="<%= groupName %>" groupOnly="true" scope="session" />

<!-- if the user has selected a property set from the drop down box -->
<wl:process name="groupPropertySets">
<%@ include file="/tools/util/startUserTransaction.inc" %>
    <%
      scopeName = request.getParameter("groupPropertySets");
      setSessionValue( "CURRENT_PROPERTY_SET", scopeName, request );
      if ( propertySetBean.DEFAULT_PROPERTY_SET.equals( scopeName ) )
        scopeName = null;
      propertySetBean.setScopeName(scopeName);
      propertySet = propertySetBean.getPropertySet();
    %>
<%@ include file="/tools/util/endUserTransaction.inc" %>
</wl:process>

<wl:process notname="groupPropertySets">
    <%
      scopeName = (String)getSessionValue( "CURRENT_PROPERTY_SET", request );
      if ( propertySetBean.DEFAULT_PROPERTY_SET.equals( scopeName ) )
        scopeName = null;
      propertySetBean.setScopeName(scopeName);

      propertySet = propertySetBean.getPropertySet();

      // not sure the following will ever happen, but just in case
      if(propertySet == null)
      {
          removeSessionValue("CURRENT_PROPERTY_SET", request);
          propertySetBean.setScopeName(null);
          scopeName = null;
      }
    %>
</wl:process>

<!-- remove a property value to restore the default -->
<wl:process name="restoreDefault">
<%@ include file="/tools/util/startUserTransaction.inc" %>

  <%
    String propertyName = request.getParameter( "propertyName" );
  %>
  <um:removeProperty propertySet="<%= scopeName %>"
      propertyName="<%= propertyName %>"/>

<%@ include file="/tools/util/endUserTransaction.inc" %>
</wl:process>

<!-- get all the property sets present in the system -->
<%
  String[] allPropertySets = propertySetBean.getPropertySetNames(USER_TYPE);
     if ( scopeName == null ) scopeName = "";
%>

<html>
<head>
<title>User Management</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>

<SCRIPT LANGUAGE="JavaScript">
function submitForm() {
   this.document.UserMgmtForm.submit();
   return true;
}
</SCRIPT>

<%@ include file="/tools/util/startUserTransaction.inc" %>
<body bgcolor="#FFFFFF" topmargin="0" leftmargin="0" marginwidth="0" marginheight="0">
<!-- Header  -->
<jsp:include page="<%=JspUtilPages.JSP_UTIL_HOME_HDR%>"/>
<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr> 
    <td width="3%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="8" height="8"></td>
    <td width="60%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="30%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="4%" bgcolor="#000000"><a href="<wf:createWebflowURL event="link.user_home"/>"><img src="<wf:createResourceURL resource="/repository/images/stopblack_um1.gif"/>" width="65" height="8" border="0" alt="Return to User Management Home"></a></td>
    <td width="3%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="8" height="8"></td>
  </tr>
  <tr> 
    <td width="3%" bgcolor="#006666"> 
      <div align="right"><img src="<wf:createResourceURL resource="/repository/images/um.gif"/>" width="30" height="24"></div>
    </td>
    <td width="90%" colspan="2" bgcolor="#006666"><font face="Verdana, Arial, Helvetica, sans-serif" size="3" color="#FFFFFF"><b>Groups: <%= cnvrtSC(groupName) %></b></font></td>
    <td width="4%" bgcolor="#006666"><a href="<wf:createWebflowURL event="link.user_home"/>"><img src="<wf:createResourceURL resource="/repository/images/sfinished_um1.gif"/>" width="65" height="24" border="0" alt="Return to User Management Home"></a></td>
    <td width="3%" bgcolor="#FFFFFF"><img src="<wf:createResourceURL resource="/repository/images/curves_um1_1.gif"/>" width="30" height="24"></td>
  </tr>
  <tr> 
    <td width="3%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="90%" colspan="2"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="4%"><a href="<wf:createWebflowURL event="link.user_home"/>"><img src="<wf:createResourceURL resource="/repository/images/sbottom_um1.gif"/>" width="65" height="8" border="0" alt="Return to User Management Home"></a></td>
    <td width="3%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
  </tr>
</table>
<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <form method="post" action="<wf:createWebflowURL event="link.group_scope_property"/>" name="UserMgmtForm">
      <td width="3%">&nbsp;</td>
      <td width="44%" valign="middle"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><b>Select a property set to view for this group: </b></font><select name="groupPropertySets" size="1">
	   <%-- We no longer support editing DEFAULT_PROPERTY_SETs in the admin tools --%>
	   <%-- <option value="<%= propertySetBean.DEFAULT_PROPERTY_SET %>"><%= cnvrtSC(propertySetBean.DEFAULT_PROPERTY_SET) %> </option> --%>
	      <es:forEachInArray id="currPropertySet" array="<%=allPropertySets%>" type="String" counterId="i">
	        <option <%= currPropertySet.toString().equalsIgnoreCase(scopeName) ? "selected" : ""  %> value="<%= cnvrtSC(currPropertySet.toString()) %>"><%= cnvrtSC(currPropertySet.toString()) %></option></es:forEachInArray>
        </select>
      </td>
      <td width="37%">
        <A HREF="javascript:submitForm();" onClick="submitForm(); return false;"><img src="<wf:createResourceURL resource="/repository/images/search_um1.gif"/>" border=0 width="65" height="40" alt="Find the Property Set"></a>
      </td>
      <td width="4%">&nbsp;</td>
      <td width="3%">&nbsp;</td>
      <input type="hidden" name="<%=DESTINATION_TAG%>" value="<%=getRequestURI(request)%>">    
      <input type="hidden" name="groupName" value="<%= groupName %>">    
      <input type="hidden" name="formSubmit" value="formSubmit">
    </form>
  </tr>
</table>
<p>
<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr> 
    <td width="3%" bgcolor="#006666">&nbsp;</td>
    <td width="1%" bgcolor="#006666">&nbsp;</td>
    <td width="86%" bgcolor="#006666"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><font color="#FFFFFF">Group Name Information</font></b></font></td>
    <td width="7%" bgcolor="#006666"> 
      <% if(!groupName.equals("everyone") &&
            !groupName.equals("Administrator")) { %>
        <div align="center"><a href="<wf:createWebflowURL event="link.group_edit" extraParams="<%=params1%>"/>"><img src="<wf:createResourceURL resource="/repository/images/edit_red.gif"/>" width="50" height="20" border="0" alt="Edit Group Information"></a></div>
      <% } else { %>
        &nbsp;
      <% } %>
    </td>
    <td width="3%"  bgcolor="#006666" height="19"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="24" height="8"></b></font></td>

  </tr>
  <tr> 
    <td width="3%" bgcolor="#006666">&nbsp;</td>
    <td width="1%" bgcolor="#FFFFFF">&nbsp;</td>
    <td width="86%" bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000">Group 
      Name: <%= cnvrtSC(groupName) %> </font></td>
    <td width="7%" bgcolor="#FFFFFF">&nbsp;</td>
    <td width="3%" bgcolor="#FFFFFF">&nbsp;</td>
  </tr>
  <tr> 
    <td width="3%" bgcolor="#006666">&nbsp;</td>
    <td width="1%" bgcolor="#FFFFFF">&nbsp;</td>
    <td width="86%" bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"> 
     </font></td>
    <td width="7%" bgcolor="#FFFFFF">&nbsp;</td>
    <td width="3%" bgcolor="#FFFFFF">&nbsp;</td>
  </tr>
   <tr> 
    <td width="3%" bgcolor="#006666"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="30" height="8"></b></font></td>
    <td width="1%" bgcolor="#006666"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#FFFFFF"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="10" height="20" align="absmiddle"></b></font></td>
    <td width="86%" bgcolor="#006666"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#FFFFFF"><b>Properties</b></font></td>
    <td width="7%" bgcolor="#006666">&nbsp;</td>
    <td width="3%" bgcolor="#006666">&nbsp;</td>
  </tr>

  <!-- the properties go here -->

  <%-- get properties for the current propertyset --%>

  <% 
/*
     String schemaGroupName = propertySetBean.getSchemaGroupName();
     if ( schemaGroupName == null ) schemaGroupName = "";

     Map unsortedProperties = (schema != null) ? schema.getAllPropertyMetaData() : null;

     if ( unsortedProperties == null )
     {
       unsortedProperties = propertySetBean.getDefaultScopedPropertiesForGroup( groupName );
     }

     Map properties = new TreeMap( unsortedProperties );

     if ( properties != null && properties.size() > 0 ) {
       
         Iterator iter = properties.keySet().iterator();
	 while( iter.hasNext() ) {

        Object object = iter.next();
        PropertyMetaData pmd = (PropertyMetaData)properties.get(object);
	    String propertyName = (String)object; 
        String propertyInfo = "(" + propertyBean.getTypeForDisplay(pmd) + ", " +  
                              propertyBean.getSelectionOptionForDisplay(pmd) + ", " + propertyBean.getCategoryForDisplay(pmd) + ")";
	    PropertyMetaData property = (PropertyMetaData)properties.get( propertyName );
	    request.setAttribute( "PropertyName", propertyName ); 
	    request.setAttribute( "PropertyMetaData", property );
	    request.setAttribute( "scopeName", scopeName );

	    String renderer = propertyBean.getGroupUserPropertyEditor( property );
	           params = "scopeName=" + URLEncoder.encode(scopeName) +
	                    "&schemaGroupName=" + URLEncoder.encode(schemaGroupName) +
			    "&propertyName=" + URLEncoder.encode(propertyName) +
			    "&groupName=" + URLEncoder.encode(groupName);

               */

    Map map = null;

    if(propertySet != null)
    {
        map = propertySet.getPropertyDefinitions();
    }

    if(map != null && map.size() > 0) 
    {
        // put the properties in sorted order
        TreeMap properties = new TreeMap(map);
        String propertySetName = propertySet.getName();

        Iterator iter = properties.keySet().iterator();
    
        while(iter.hasNext())
        {
            Object object = iter.next();
            String propertyName = (String)object; 
            PropertyDefinition property = 
                (PropertyDefinition)properties.get(propertyName);

            StringBuffer propertyInfo = new StringBuffer();
            propertyInfo.append("(");
            // [Boolean, Date/Time, Integer, Text, Floating-Point Number,
            //  User-Defined, Unknown]
            propertyInfo.append(propertyBean.getTypeForDisplay(property));
            propertyInfo.append(", ");
            // [Multiple, Single]
            propertyInfo.append(propertyBean.getSelectionOptionForDisplay(property));
            propertyInfo.append(", ");
            // [Restricted, Unrestricted]
            propertyInfo.append(propertyBean.getCategoryForDisplay(property));
            propertyInfo.append(")");

            request.setAttribute("scopeName",    propertySetName);
            request.setAttribute("PropertyName", propertyName); 
            request.setAttribute("Property",     property);

            String renderer = propertyBean.getGroupUserPropertyEditor(property);

            StringBuffer paramsBuff = new StringBuffer();
            paramsBuff.append("scopeName=");
            paramsBuff.append(URLEncoder.encode(propertySetName));
            paramsBuff.append("&schemaGroupName=");
            paramsBuff.append(URLEncoder.encode(USER_TYPE));
            paramsBuff.append("&propertyName=");
            paramsBuff.append(URLEncoder.encode(propertyName));
            paramsBuff.append("&groupName=");
            paramsBuff.append(URLEncoder.encode(groupName));
            params = paramsBuff.toString();
  %>
  
      <tr> 
        <td bgcolor="#006666" width="3%" height="19">&nbsp;</td>
        <td bgcolor="#999999" width="1%" height="19">&nbsp;</td>
        <td bgcolor="#999999" width="86%" height="19">
          <table width="100%" border="0" cellspacing="0" cellpadding="0">
          <tr> 
            <td><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#FFFFFF"><b><%= cnvrtSC(propertyName) %></b> <%= propertyInfo.toString() %></font></td>
            <%String eventParam = "link."+renderer;
              eventParam = eventParam.substring(0, eventParam.indexOf(".jsp"));%>
            <td><div align="right"><a href="<wf:createWebflowURL event="<%=eventParam%>" extraParams="<%=paramsBuff.toString()%>"/>"><img src="<wf:createResourceURL resource="/repository/images/edit_black.gif"/>" width="50" height="20" border="0" alt="Edit This Property"></a></div></td>
          </tr>
          </table>
        </td>
        <td width="7%" bgcolor="#999999" height="19"> 
          <%String groupScopePropertyParam = "restoreDefault=true&" + params;%>
          <div align="center"><a href="<wf:createWebflowURL event="link.group_scope_property" extraParams = "<%=groupScopePropertyParam%>"/>"><img src="<wf:createResourceURL resource="/repository/images/reset_black.gif"/>" width="50" height="20" border="0" alt="Restore Default Value"></a></div>
        </td>
        <td bgcolor="#999999" width="3%" height="19">&nbsp;</td>
      </tr>

      <tr> 
        <td width="3%" bgcolor="#006666">&nbsp;</td>
        <td width="1%">&nbsp;</td>
        <td width="86%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><%= cnvrtSC(property.getDescription()) %></font></td>
        <td width="7%">&nbsp;</td>
        <td width="3%">&nbsp;</td>
      </tr>

      <tr> 
        <td width="3%" bgcolor="#006666">&nbsp;</td>
        <td width="1%">&nbsp;</td>
        <td width="86%"> 
          <% renderer = propertyBean.getGroupUserPropertyRenderer( property ); %>
          <es:notNull item="<%=renderer%>">
            <% // why was this going to catalog?
               //String renderParam = "/tools/catalog/" + renderer;%>
            <%String renderParam = "/tools/usermgmt/" + renderer;%>
            <jsp:include page="<%=renderParam%>"/>
          </es:notNull>
        </td>
        <td width="7%">&nbsp;</td>
        <td width="3%">&nbsp;</td>
      </tr>

      <tr> 
        <td bgcolor="#006666" width="3%">&nbsp;</td>
        <td width="1%">&nbsp;</td>
        <td width="86%">&nbsp;</td>
        <td width="7%" bgcolor="#FFFFFF">&nbsp;</td>
        <td width="3%" bgcolor="#FFFFFF">&nbsp;</td>
      </tr>

  <%
        } // END  while(iter.hasNext())
    } // END  if(map != null && map.size() > 0) 
  %>
  <!-- end of block where all properties are displayed for a particular propertyset -->

  <tr> 
    <td width="3%" bgcolor="#006666">&nbsp;</td>
    <td width="1%"><font size="2">&nbsp;</font></td>
    <td width="86%">&nbsp; </td>
    <td width="7%">&nbsp;</td>
    <td width="3%">&nbsp;</td>
  </tr>

<% if(isManageableRealm && 
      !groupName.equals("everyone") &&
      !groupName.equals("Administrator")) { %>
  <tr> 
    <td width="3%" bgcolor="#006666">&nbsp;</td>
    <td width="1%" bgcolor="#006666">&nbsp;</td>
    <td width="86%" bgcolor="#006666"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="FFFFFFF"><b>Add/Remove Users From Group</b></font></td>
    <td width="7%" bgcolor="#006666">
      <div align="center"><a href="<wf:createWebflowURL event="link.group_add_remove_users" extraParams="<%=params%>"/>"><img src="<wf:createResourceURL resource="/repository/images/addremove.gif"/>" width="50" height="20" border="0" alt="Add/Remove Users"></a></div>
    </td>
    <td width="3%"  bgcolor="#006666">&nbsp;</td>
  </tr>
<% } %>

  <tr>
    <td width="3%" bgcolor="#FFFFFF">&nbsp;</td>
    <td width="1%">&nbsp;</td>
    <td width="86%">&nbsp;</td>
    <td width="7%">
      <div align="right"><a href="<wf:createWebflowURL event="link.user_home"/>"><img src="<wf:createResourceURL resource="/repository/images/finished_um1.gif"/>" width="65" height="40" alt="Return to User Management Home" border="0"></a></div>
    </td>
    <td width="3%">&nbsp;</td>
  </tr>
</table>
</body>
<%@ include file="/tools/util/endUserTransaction.inc" %>
</html>
