<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<%--
Clean up checklist

[x] - using header include for the header
[x] - page extends com.bea.jsptools.common.servlets.jsp.ToolsJspBase
[x] - finished button at top and bottom
[x] - check color consistency
[x] - cnvrtSC()
[x] - check tool tips 
[x] - blank text fields when first loaded 
[x] - page wrapped in transaction 
[x] - colon after textfield labels
[x] - monitor session tag
[x] - goto error page
--%>

<%@ page extends="com.bea.jsptools.p13n.usermgmt.servlets.jsp.JspHierarchyBase" %>

<%@ taglib uri="weblogic.tld" prefix="wl" %>
<%@ taglib uri="webflow.tld" prefix="wf" %>
<%@ taglib uri="es.tld" prefix="es" %>
<%@ taglib uri="um.tld" prefix="um" %>

<%@ page import="com.bea.jsptools.p13n.common.servlets.jsp.JspUtilPages" %>
<%@ page import="com.bea.jsptools.p13n.usermgmt.servlets.jsp.HierarchyManagementBean" %>
<%@ page import="com.bea.p13n.usermgmt.servlets.jsp.taglib.UserManagementTagConstants" %>
<%@ page import="com.bea.p13n.appflow.webflow.WebflowJSPHelper" %>

<% request.setAttribute(SERVICEMANAGER_CURRENT_PAGE, getJspName(pageContext));%>

<jsp:useBean id="hierarchyManagementBean" class="com.bea.jsptools.p13n.usermgmt.servlets.jsp.HierarchyManagementBean" scope="session" />
<jsp:useBean id="accessBean" class="com.bea.jsptools.p13n.usermgmt.servlets.jsp.FunctionAccessBean" scope="session" />

<% 
 // to print error status messages
 String statusMsg = null;
%>

<%-- check the fact that the user might have clicked on the expand/collapse buttons --%>
<% String groupName = null; %>
<% groupName=request.getParameter("groupName"); %>

<wl:process name="hierarchyAction" value="expand">
<%@ include file="/tools/util/startUserTransaction.inc" %>
    <% hierarchyManagementBean.addGroupAsExpanded(groupName); %>
<%@ include file="/tools/util/endUserTransaction.inc" %>
</wl:process>

<wl:process name="hierarchyAction" value="collapse">
<%@ include file="/tools/util/startUserTransaction.inc" %>
    <% hierarchyManagementBean.removeGroupAsExpanded(groupName); %>
<%@ include file="/tools/util/endUserTransaction.inc" %>
</wl:process>

<!-- reset the tree if no action is taken -->
<es:isNull item="<%=groupName%>">
     <% hierarchyManagementBean.reset(); %>
     <% hierarchyManagementBean.setSearchGroup(null); %>
</es:isNull>


<!-- for the search results -->
<wl:process name="group">
<%@ include file="/tools/util/startUserTransaction.inc" %>
   <%	
	String group2Search = request.getParameter("group");	
	if( hierarchyManagementBean.search(group2Search) == false ) {
	   statusMsg = "Group '" + cnvrtSC(group2Search) + "' not found, please try again.";
	}
   %>
<%@ include file="/tools/util/endUserTransaction.inc" %>
</wl:process>


<!-- if the user has deleted a group -->
<wl:process name="deleteGroup">
<%@ include file="/tools/util/startUserTransaction.inc" %>
	<% String group2delete =  request.getParameter("deleteGroup"); %>
	<um:removeGroup result="result" groupName="<%= group2delete %>" />
	
    <% if(result.intValue() == UserManagementTagConstants.REMOVE_GROUP_FAILED)
       { 
           statusMsg = "Cannot remove group: " + cnvrtSC(request.getParameter("deleteGroup")); 
       }
       else
       {
           statusMsg = "Group '" + cnvrtSC(request.getParameter("deleteGroup")) + "' successfully deleted.";
       }
    %>
<%@ include file="/tools/util/endUserTransaction.inc" %>
</wl:process>

<html>
<head>
<title>User Management</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<SCRIPT LANGUAGE="JavaScript">
function submitForm() {
   this.document.UserMgmtForm.submit();
   return true;
}

function deleteSubGroup(subgroup)
{
   return (confirm("Are you sure you want to delete group '" + subgroup + "'?"));
}

</SCRIPT>
</head>

<%@ include file="/tools/util/startUserTransaction.inc" %>
<body bgcolor="#FFFFFF"  vlink="#0000FF" link="#0000FF" topmargin="0" leftmargin="0" marginwidth="0" marginheight="0">

<!-- Header  -->
<jsp:include page="<%=JspUtilPages.JSP_UTIL_HOME_HDR%>"/>

<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr> 
    <td width="2%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="88%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="7%" bgcolor="#000000"><a href="<wf:createWebflowURL event="link.user_home"/>"><img src="<wf:createResourceURL resource="/repository/images/stopblack_um1.gif"/>" width="65" height="8" border="0" alt="Return to User Management Home"></a></td>
    <td width="3%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
  </tr>
  <tr> 
    <td width="2%" bgcolor="#006666"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#FFFFFF"><img src="<wf:createResourceURL resource="/repository/images/um.gif"/>" width="30" height="24" align="absmiddle"></font></td>
    <td width="88%" bgcolor="#006666"><font face="Verdana, Arial, Helvetica, sans-serif" size="3" color="#FFFFFF"><b><font color="#FFFFFF">Groups</font></b></font></td>
    <td width="7%" bgcolor="#006666"><a href="<wf:createWebflowURL event="link.user_home"/>"><img src="<wf:createResourceURL resource="/repository/images/sfinished_um1.gif"/>" width="65" height="24" border="0" alt="Return to User Management Home"></a></td>
    <td width="3%"><img src="<wf:createResourceURL resource="/repository/images/curves_um1_1.gif"/>" width="30" height="24"></td>
  </tr>
  <tr> 
    <td width="2%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="88%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="7%"><a href="<wf:createWebflowURL event="link.user_home"/>"><img src="<wf:createResourceURL resource="/repository/images/sbottom_um1.gif"/>" width="65" height="8" border="0" alt="Return to User Management Home"></a></td>
    <td width="3%"></td>
  </tr>
  <tr> 
    <td width="2%">&nbsp;</td>
    <td width="88%">&nbsp;<% if(statusMsg != null) { %><%@ include file="/tools/usermgmt/status.inc" %><% } %></td>
    <td width="7%">&nbsp;</td>
    <td width="3%">&nbsp;</td>
  </tr>
</table>
<form method="post" action="<wf:createWebflowURL event="link.group_search"/>" name="UserMgmtForm">
  <table width="100%" border="0" cellspacing="0" cellpadding="0">
    <tr> 
      <td width="3%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="30" height="5"></td>
      <td width="81%" bgcolor="#CCCCCC"><b><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8">Search 
        for Groups </font></b></td>
      <td width="11%" bgcolor="#CCCCCC">&nbsp;</td>
    </tr>
    <tr> 
      <td width="3%">&nbsp;</td>
      <td width="81%"> 
        <table width="100%" border="0" cellspacing="8" cellpadding="0">
          <tr> 
          <% boolean isManageableRealm = accessBean.isManageableRealm();
             String message = null;
             
             if(isManageableRealm)
             {
                 StringBuffer xImg = new StringBuffer();

                 xImg.append("<img src=\"");
                 xImg.append(WebflowJSPHelper.createStaticResourceURL(pageContext, "/repository/images/x.gif", false));
                 xImg.append("\" width=\"15\" height=\"15\" align=\"absmiddle\">");

                 message = "Click through the group hierarchy to find a group, or search for the group by name. Once found, you can click the group title link to edit it, or click " + xImg + " to delete the group.";
             }
             else
             {
                 message = "Click through the group hierarchy to find a group, or search for the group by name. Once found, you can click the group title link to edit it.";
             }
          %>
            <td width="49%" valign="top"><font face="Verdana, Arial, Helvetica, sans-serif" size="2">
              <%= message %></font></td>
            <td width="51%"> 
              <table width="100%" border="0" cellspacing="0" cellpadding="0">
                <tr valign="top"> 
                  <td width="30%" nowrap valign="middle"> 
                    <div align="right"><b><font face="Verdana, Arial, Helvetica, sans-serif" size="2">Group Name: </font></b></div>
                  </td>
                  <td width="47%"> 
                    <div align="center"><b> 
                      <input type="text" name="group" size="20" maxlength="50" value="">
                      </b></div>
                  </td>
                  <td width="23%" rowspan="2"><b><A HREF="javascript:submitForm();" onClick="submitForm(); return false;"><img src="<wf:createResourceURL resource="/repository/images/search_um1.gif"/>" border=0 width="65" height="40" alt="Get Search Results"></a></b></td>
                </tr>
                <tr valign="top"> 
                  <td width="30%">&nbsp;</td>
                  <td width="47%">&nbsp;</td>
                </tr>
              </table>
            </td>
          </tr>
        </table>
      </td>
      <td width="11%">&nbsp;</td>
    </tr>
    <tr> 
      <td width="3%">&nbsp;</td>
      <td width="81%" bgcolor="#ffffff">&nbsp;</td>
      <td width="11%" bgcolor="#ffffff">&nbsp;</td>
    </tr>
    <tr> 
      <td width="3%">&nbsp;</td>
      <td width="81%" bgcolor="#CCCCCC"><b><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8">Group 
        Hierarchy </font></b></td>
      <td width="11%" bgcolor="#CCCCCC">&nbsp;</td>
    </tr>
    <tr> 
      <td width="3%">&nbsp;</td>
      <td width="81%"> 
        <table width="100%" border="0" cellspacing="2" cellpadding="2">
          <tr> 
            <td colspan="3"><b><font face="Verdana, Arial, Helvetica, sans-serif" size="3">Top 
              Level Groups</font></b></td>
          </tr>

	  <% String groupNames[] = getTopLevelGroupNames(); %>
	  <% hierarchyManagementBean.setDisplayType(HierarchyManagementBean.SEARCH); %>

	  <es:forEachInArray id="currgroupName" array="<%=groupNames%>" type="String" counterId="i">
		<%= printSubGroups(currgroupName.toString(), i.intValue(), hierarchyManagementBean, response, request, pageContext) %>
	  </es:forEachInArray>

        </table>
      </td>
      <td width="11%">&nbsp;</td>
    </tr>
    <tr> 
      <td width="3%">&nbsp;</td>
      <td width="81%"> 
        <table border="0" cellspacing="4" cellpadding="0" align="right">
          <tr> 
            <td><a href="<wf:createWebflowURL event="link.user_home"/>"><img src="<wf:createResourceURL resource="/repository/images/finished_um1.gif"/>" width="65" height="40" alt="Return to User Management Home" border="0"></a></td>
          </tr>
        </table>
      </td>
      <td width="11%">&nbsp;</td>
    </tr>
    <tr> 
      <td width="3%">&nbsp;</td>
      <td width="81%">&nbsp;</td>
      <td width="11%">&nbsp;</td>
    </tr>
  </table>
  <input type="hidden" name="<%=DESTINATION_TAG%>" value="<%=getRequestURI(request)%>">
</form>
</body>
<%@ include file="/tools/util/endUserTransaction.inc" %>
</html>
