<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<%----------------------------------------------------------
Clean up checklist

[x] - using header include for the header
[x] - page extends com.bea.jsptools.common.servlets.jsp.ToolsJspBase
[x] - finished button at top and bottom (if page requires it)
[x] - check color consistency
[x] - cnvrtSC()
[x] - check tool tips 
[x] - blank text fields when first loaded 
[x] - check text input size
[x] - page wrapped in transaction 
[x] - colon after textfield labels
[x] - monitor session tag
[x] - goto error page
[x] - check for TODOs
----------------------------------------------------------%>

<%-- edit property for multiple/unrestricted: allow user to add a new   --%>
<%-- valid value, delete existing valid values, and set default values. --%>

<%@ page extends="com.bea.jsptools.common.servlets.jsp.ToolsJspBase"%>
<%@ taglib uri="weblogic.tld" prefix="wl" %>
<%@ taglib uri="webflow.tld" prefix="wf" %>
<%@ taglib uri="es.tld" prefix="es" %>
<%@ taglib uri="um.tld" prefix="um" %>
<%@ page import="com.bea.jsptools.p13n.common.servlets.jsp.JspUtilPages" %>
<%@ page import="com.bea.jsptools.p13n.usermgmt.servlets.jsp.UserManagementJspPages" %>
<%@ page import="com.bea.p13n.property.PropertyDefinition" %>
<%@ page import="java.net.URLEncoder" %>
<%@ page import="java.util.*" %>

<jsp:useBean id="propertyBean" class="com.bea.jsptools.p13n.usermgmt.servlets.jsp.PropertyBean" scope="session" />
<jsp:setProperty name="propertyBean" property="*" />

<% request.setAttribute(SERVICEMANAGER_CURRENT_PAGE, getJspName(pageContext));%>

<% String userName = request.getParameter("userName"); %>
<% String groupName = request.getParameter("groupName"); %>
<% String varName =  (userName != null) ? "userName" : "groupName"; %>
<% String varValue =  (userName != null) ? userName : groupName; %>

<% PropertyDefinition property = propertyBean.getPropertyObject(); %>
<% 
  // get the meta data from the default scope if we have to
/* don't have to worry about default properties as of Flagstaff
  if ( property == null )
  {
    if ( varName.equals( "userName" ) )
    {
      property = propertyBean.getDefaultPropertyMetaDataForUser( varValue );
    }
    else
    {
      property = propertyBean.getDefaultPropertyMetaDataForGroup( varValue );
    }
  }
*/
%>
<% propertyBean.setPropertyMetaData(property); %>
<% String propertyName = propertyBean.getPropertyName(); %>
<% String propertyType = propertyBean.getTypeForDisplay( property ); %>
<% String scopeName = propertyBean.getScopeName(); %>
<% if ( scopeName == null ) scopeName = ""; %>
<% String schemaGroupName = propertyBean.getSchemaGroupName(); %>
<% String valueEditor = propertyBean.getPropertyValueEditor( property ); %>
<% String statusMsg = null; %>
<% String returnPage = (userName == null) ? UserManagementJspPages.GROUP_SCOPE_PROPERTY_JSP : UserManagementJspPages.USER_SCOPE_PROPERTY_JSP; %>
<% Collection currentPropertyValueCopy = null; %>


<wl:process name="newValueSubmit">

  <% 

       Object valueObject = propertyBean.getAsObject(request.getParameter("customValue"));
  
       // add that valueObject to the currentPropertyValue collection
       currentPropertyValueCopy = propertyBean.getCurrentPropertyValue();

       // if currentPropertyValueCopy is null, we need to initialize it
       currentPropertyValueCopy = (currentPropertyValueCopy == null) ? new ArrayList() : currentPropertyValueCopy;

       currentPropertyValueCopy.add(valueObject);
  %>

  <%-- set the property if valueObject is not null  --%>
  <es:notNull item="<%=valueObject%>">
    <um:setProperty propertySet="<%=scopeName %>" propertyName="<%= propertyName %>" value="<%= currentPropertyValueCopy %>" />
    <% statusMsg = "Property '"+ cnvrtSC(valueObject.toString()) + "' set correctly."; %>
  </es:notNull>

  <es:isNull item="<%=valueObject%>">
    <% statusMsg = "Please enter valid values."; %>
  </es:isNull>

</wl:process>

<wl:process name="removeValue">
  <%-- remove the value from the property --%>
  <% 
      Object removeObject = propertyBean.getAsObject(request.getParameter("removeValue"));
      currentPropertyValueCopy = propertyBean.getCurrentPropertyValue();

      if(currentPropertyValueCopy.remove(removeObject))
            statusMsg = "Property '"+ cnvrtSC(removeObject.toString()) + "' Removed.";
      else
            statusMsg = "Cannot remove Property '"+ cnvrtSC(removeObject.toString()) + "'";
  %>
 <um:setProperty propertySet="<%=scopeName %>" propertyName="<%= propertyName %>" value="<%= currentPropertyValueCopy %>" />

</wl:process>

<um:getProperty id="currentPropertyValue" propertySet="<%= scopeName %>" propertyName="<%= propertyName %>" />

<es:isNull item="<%=currentPropertyValue%>">
    <% currentPropertyValue = property.getDefaultValue(); %>
</es:isNull>

<% propertyBean.setCurrentPropertyValue((Collection)currentPropertyValue); %>
<html>
<head>
<title>Property Set Management</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<SCRIPT LANGUAGE="JavaScript">
function submitValueForm() {
   this.document.ValueForm.submit();
   return true;
}

function confirmValueDelete(typeName)
{
   return (confirm("Are you sure you want to delete '" + typeName + "'?"));
}

</SCRIPT>
</head>
<%@ include file="/tools/util/startUserTransaction.inc" %>

<body bgcolor="#FFFFFF" topmargin="0" leftmargin="0" marginwidth="0" marginheight="0">
<!-- Header  -->
<jsp:include page="<%=JspUtilPages.JSP_UTIL_HOME_HDR%>"/>

<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr> 
    <td width="3%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="88%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="5%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="65" height="8"></td>
    <td width="4%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
  </tr>
  <tr> 
    <td width="3%" bgcolor="#006666"> 
      <div align="right"><img src="<wf:createResourceURL resource="/repository/images/psm.gif"/>" width="30" height="24"></div>
    </td>
    <td width="88%" bgcolor="#006666"><font face="Verdana, Arial, Helvetica, sans-serif" size="3" color="#FFFFFF"><b>
      Property Set: <%= cnvrtSC(scopeName.equals("") ? "<Default>" : scopeName) %></b></font></td>
    <td width="5%" bgcolor="#006666"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="65" height="24" border="0"></td>
    <td width="4%" bgcolor="#FFFFFF"><img src="<wf:createResourceURL resource="/repository/images/curves_um1_1.gif"/>" width="30" height="24"></td>
  </tr>
  <tr> 
    <td width="3%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="88%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="5%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="65" height="8"></td>
    <td width="4%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
  </tr>
  <tr> 
    <td width="3%">&nbsp;</td>
    <td width="88%"><font face="Verdana, Arial, Helvetica, sans-serif" size="3" color="#CC0000"><b>
      Property: <%= cnvrtSC(propertyName) %> (Type: <%= propertyType %>, Multiple, Unrestricted)</b></font></td>
    <td width="5%">&nbsp;</td>
    <td width="4%">&nbsp;</td>
  </tr>
</table>

<table border="0" cellspacing="0" cellpadding="0" width="100%">
  <tr> 
    <td width="1%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td width="82%"><es:notNull item="<%=statusMsg%>"><%@ include file="/tools/usermgmt/status.inc" %></es:notNull></td>
    <td width="11%">&nbsp;</td>
  </tr>
  <tr> 
    <td width="1%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="20" height="8"></td>
    <td rowspan="3" valign="top" width="6%" align="right"> <font face="Verdana, Arial, Helvetica, sans-serif" size="2"><img src="<wf:createResourceURL resource="/repository/images/icon_edit.gif"/>" width="65" height="50"></font></td>
    <td bgcolor="#CCCCCC" width="82%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8">Edit 
      Property Values</b></font></td>
    <td width="11%">&nbsp;</td>
  </tr>
  <tr> 
    <td width="1%">&nbsp;</td>
    <td width="82%" bgcolor="#666666"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#FFFFFF"><b>Create 
      New Values</b></font></td>
    <td width="11%">&nbsp;</td>
  </tr>
  <tr> 
    <td width="1%">&nbsp;</td>
    <td width="82%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2">To 
      add a new value to this property, enter the value then click create. 
      New values will display in the list below.</font></td>
    <td width="11%">&nbsp;</td>
  </tr>
  <tr>
    <td width="1%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td width="82%">&nbsp;</td>
    <td width="11%">&nbsp;</td>
  </tr>
  <tr> 
    <td width="1%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td width="82%"> 
      <form method="post" action="<wf:createWebflowURL event="link.groupuser_property_edit_mu"/>" name="ValueForm">
        <table width="100%" border="0" cellspacing="2" cellpadding="0">
          <tr> 
            <td width="21%" nowrap><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b>New 
              Value: </b></font></td>
            <td width="34%"> 
              <% request.setAttribute( "Property", property ); %>
              <% request.setAttribute( "PropertyValue", "" ); %>
              <% request.setAttribute( "FieldName", "customValue" ); %>
              <jsp:include page="<%= valueEditor %>"/>
            </td>
            <td width="45%"> 
              <table border="0" cellspacing="4" cellpadding="0" align="right">
                <tr> 
                  <td> 
                    <div align="right"><a href="javascript:submitValueForm();" onClick="submitValueForm(); return false;"><img src="<wf:createResourceURL resource="/repository/images/create_um1.gif"/>" width="65" height="40" alt="Create Value" border="0"></a></div>
                  </td>
                </tr>
              </table>
            </td>
          </tr>
        </table>

        <input type="hidden" name="propertyName" value="<%=propertyName%>">
        <input type="hidden" name="scopeName" value="<%=scopeName%>">
        <input type="hidden" name="schemaGroupName" value="<%=schemaGroupName%>">
        <input type="hidden" name="<%=DESTINATION_TAG%>" value="<%=getRequestURI(request)%>">
        <input type="hidden" name="newValueSubmit" value="newValueSubmit">
        <input type="hidden" name="<%= varName %>" value="<%=  varValue %>">

      </form>
    </td>
    <td width="11%">&nbsp;</td>
  </tr>
  <tr> 
    <td width="1%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td width="82%" bgcolor="#666666"> 
      <div align="left"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#FFFFFF"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8">Values</b></font></div>
    </td>
    <td width="11%">&nbsp;</td>
  </tr>
  <tr> 
    <td width="1%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td width="82%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2">Following is a list of the default value(s) for this Property.
      To remove a value from this property, click its associated delete icon. When you are done, click Back.</font></td>
    <td width="11%">&nbsp;</td>
  </tr>

  <%-- display all default values --%>
  <%
    Collection defaults = propertyBean.getAsCollection( currentPropertyValue );
  %>
  <es:notNull item="<%=defaults%>">
    <%
      Object[] arr = defaults.toArray();
      int defaultCount = arr.length;
      int rows = defaultCount / 2;
      if ( defaultCount % 2 == 1 ) rows++;
      int rowCount = 1;
      int count = 0;
      boolean secondCol = false;
    %>
    <tr> 
      <td width="1%">&nbsp;</td>
      <td width="6%">&nbsp;</td>
      <td width="82%"> 
        <table width="100%" border="0" cellpadding="0" cellspacing="4">
          <tr> 
            <td width="45%" valign="top"> 
              <table width="100%" border="1" cellpadding="2" cellspacing="0" bgcolor="#cccccc" bordercolor="#ffffff">
              <% String urlTail = "&scopeName=" + URLEncoder.encode(scopeName) + "&propertyName=" + URLEncoder.encode(propertyName) + "&schemaGroupName=" + URLEncoder.encode(schemaGroupName); %>
              <es:forEachInArray id="valueObject" array="<%= arr %>" type="Object">
                <% String formattedValue = propertyBean.formatPropertyValue( property, valueObject ); %>
                <% count++; %>
                <% String bgcolor = (rowCount % 2 == 1 ? "#cccccc" : "#ffffff"); %>
                <tr bgcolor="<%= bgcolor %>"> 
                  <td><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><%= cnvrtSC(valueObject.toString()) %></font></td>
		  <% String params =  "removeValue=" + URLEncoder.encode(formattedValue) + urlTail + "&" + varName + "=" + URLEncoder.encode(varValue); %>
                  <td width="4%"><a href="<wf:createWebflowURL event="link.groupuser_property_edit_mu" extraParams="<%=params%>"/>" onClick="return confirmValueDelete('<%= formattedValue %>');"><img src="<wf:createResourceURL resource="/repository/images/x.gif"/>" width="15" height="15" border="0" alt="Remove Value"></a></td>
                </tr>
                <% if ( rowCount++ >= rows && !secondCol ) { %>
                  <%-- end the first column and start the next --%>
                  <% rowCount = 1; secondCol = true; %>
                      </table>
                   </td>
                  <td>&nbsp;</td>
                  <td width="45%" valign="top"> 
                    <table width="100%" border="1" cellpadding="2" cellspacing="0" bgcolor="#cccccc" bordercolor="#ffffff">
                <% } %>
              </es:forEachInArray>
              </table>
            </td>
          </tr>
        </table>
      </td>
      <td width="11%">&nbsp;</td>
    </tr>
  </es:notNull>
  <tr>
    <td width="1%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td width="82%">&nbsp;</td>
    <td width="11%">&nbsp;</td>
  </tr>
  <tr> 
    <td width="1%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td width="82%" align="right">
      <table width="10%" border="0" cellpadding="0" align="right">
        <tr> 
        <% String params  = varName +  "=" + URLEncoder.encode(varValue) + 
                            "&groupPropertySets=" + URLEncoder.encode(scopeName) +
                            "&formSubmit=formSubmit";
           returnPage = "link." + returnPage;
           returnPage = returnPage.substring(0, returnPage.indexOf(".jsp"));
        %>

        <td><a href="<wf:createWebflowURL event="<%=returnPage%>" extraParams="<%=params%>"/>"><img src="<wf:createResourceURL resource="/repository/images/back_um1.gif"/>" width="65" height="40" border="0" alt="Return to the Previous Page"></a></td>
        </tr>
      </table>
    <td width="11%">&nbsp;</td>
  </tr>
  </table>
</body>
<%@ include file="/tools/util/endUserTransaction.inc" %>
</html>

