<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<%----------------------------------------------------------
Clean up checklist

[x] - using header include for the header
[x] - page extends com.bea.jsptools.common.servlets.jsp.ToolsJspBase
[x] - finished button at top and bottom (if page requires it)
[x] - check color consistency
[x] - cnvrtSC()
[x] - check tool tips 
[x] - blank text fields when first loaded 
[x] - check text input size
[x] - page wrapped in transaction 
[x] - colon after textfield labels
[x] - monitor session tag
[x] - goto error page
[x] - check for TODOs
----------------------------------------------------------%>

<%@ page extends="com.bea.jsptools.common.servlets.jsp.ToolsJspBase"%>
<%@ taglib uri="weblogic.tld" prefix="wl" %>
<%@ taglib uri="webflow.tld" prefix="wf" %>
<%@ taglib uri="es.tld" prefix="es" %>
<%@ taglib uri="um.tld" prefix="um" %>
<%@ page import="com.bea.jsptools.p13n.common.servlets.jsp.JspUtilPages" %>
<%@ page import="com.bea.jsptools.p13n.usermgmt.servlets.jsp.UserManagementJspPages" %>
<%@ page import="com.bea.p13n.property.PropertyDefinition" %>
<%@ page import="java.net.URLEncoder" %>
<%@ page import="java.util.*" %>

<jsp:useBean id="propertyBean" class="com.bea.jsptools.p13n.usermgmt.servlets.jsp.PropertyBean" scope="request" />
<jsp:setProperty name="propertyBean" property="*" />

<% request.setAttribute(SERVICEMANAGER_CURRENT_PAGE, getJspName(pageContext));%>

<% String statusMsg = null; %>

<% PropertyDefinition property = propertyBean.getPropertyObject(); %>
<% propertyBean.setPropertyMetaData(property); %>
<% String propertyName = propertyBean.getPropertyName(); %>
<% String propertyType = propertyBean.getTypeForDisplay( property ); %>
<% String scopeName = propertyBean.getScopeName(); %>
<% String schemaGroupName = propertyBean.getSchemaGroupName(); %>
<% String valueEditor = propertyBean.getPropertyValueEditor( property ); %>
<% String userName = request.getParameter("userName"); %>
<% String groupName = request.getParameter("groupName"); %>
<% String varName =  (userName != null) ? "userName" : "groupName"; %>
<% String varValue =  (userName != null) ? userName : groupName; %>
<% String returnPage = (userName == null) ? UserManagementJspPages.GROUP_SCOPE_PROPERTY_JSP : UserManagementJspPages.USER_SCOPE_PROPERTY_JSP; %>

<wl:process name="setDefaultSubmit">

  <% Object valueObject = propertyBean.getAsObject(request.getParameter("customValue")); %>

  <%-- set the property --%>
  <um:setProperty propertySet="<%=scopeName %>" propertyName="<%= propertyName %>" value="<%= valueObject %>" />
  <% statusMsg = "Property set correctly."; %>

</wl:process>

<um:getProperty id="currentPropertyValue" propertySet="<%= scopeName %>" propertyName="<%= propertyName %>" />

<es:isNull item="<%=currentPropertyValue%>">
    <% currentPropertyValue = property.getDefaultValue(); %>
</es:isNull>


<html>
<head>
<title>Property Set Management</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<SCRIPT LANGUAGE="JavaScript">
function submitValueForm() {
   this.document.ValueForm.submit();
   return true;
}

function submitDefaultsForm() {
   this.document.DefaultsForm.submit();
   return true;
}

</SCRIPT>
</head>

<%@ include file="/tools/util/startUserTransaction.inc" %>
<body bgcolor="#FFFFFF" topmargin="0" leftmargin="0" marginwidth="0" marginheight="0">
<!-- Header  -->
<jsp:include page="<%=JspUtilPages.JSP_UTIL_HOME_HDR%>"/>

<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr> 
    <td width="4%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="88%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="5%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="65" height="8"></td>
    <td width="3%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
  </tr>
  <tr> 
    <td width="4%" bgcolor="#006666"> 
      <div align="right"><img src="<wf:createResourceURL resource="/repository/images/psm.gif"/>" width="30" height="24"></div>
    </td>
    <td width="88%" bgcolor="#006666"><font face="Verdana, Arial, Helvetica, sans-serif" size="3" color="#FFFFFF"><b>Property Set: <%= cnvrtSC(scopeName) %></b></font></td>
    <td width="5%" bgcolor="#006666"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="65" height="24" border="0"></td>
    <td width="3%" bgcolor="#006666"><img src="<wf:createResourceURL resource="/repository/images/curves_um1_1.gif"/>" width="30" height="24"></td>
  </tr>
  <tr> 
    <td width="4%" height="7"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="88%" height="7"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="5%" height="7"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="65" height="8"></td>
    <td width="3%" height="7"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
  </tr>
  <tr>
    <td width="4%">&nbsp;</td>
    <td width="88%"><font face="Verdana, Arial, Helvetica, sans-serif" size="3" color="#CC0000"><b>
Property: <%= cnvrtSC(propertyName) %> (Type: <%= propertyType %>, Single, Restricted)</b></font></td>
    <td width="5%">&nbsp;</td>
    <td width="3%">&nbsp;</td>
  </tr>
</table>

<table border="0" cellspacing="0" cellpadding="0" width="100%">
  <tr> 
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td width="83%"><es:notNull item="<%=statusMsg%>"><%@ include file="/tools/usermgmt/status.inc" %></es:notNull></td>
    <td width="9%">&nbsp;</td>
  </tr>
  <tr> 
    <td width="2%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="20" height="8"></td>
    <td rowspan="3" width="6%" valign="top" align="right"> <font face="Verdana, Arial, Helvetica, sans-serif" size="2"><img src="<wf:createResourceURL resource="/repository/images/icon_edit.gif"/>" width="65" height="50"></font></td>
    <td bgcolor="#CCCCCC" width="83%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8">Edit 
      Property Values</b></font></td>
    <td width="9%">&nbsp;</td>
  </tr>

  <tr> 
    <td width="2%">&nbsp;</td>
    <td width="83%">&nbsp;</td>
    <td width="9%">&nbsp;</td>
  </tr>
  <tr> 
    <td width="2%">&nbsp;</td>
    <td width="83%">&nbsp;</td>
    <td width="9%">&nbsp;</td>
  </tr>

  <tr> 
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td width="83%" bgcolor="#666666"> 
      <div align="left"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#FFFFFF"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8">Values</b></font></div>
    </td>
    <td width="9%">&nbsp;</td>
  </tr>
  <tr> 
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td width="83%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2">Select 
      the value you want to set as default. When you are done, click Save.</font></td>
    <td width="9%">&nbsp;</td>
  </tr>
      
  <%-- get a list of restricted values, and defaults to display --%>
  <%
    Collection valids = property.getRestrictedValues();
    Collection defaults = propertyBean.getAsCollection( currentPropertyValue );

    // workaround because PropertyDefinition isn't returning true & false for booleans
    if(property.getType() == PropertyDefinition.BOOLEAN)
    {
		if(valids == null || valids.size() < 2)
        {
            valids = new ArrayList();
            valids.add(Boolean.TRUE);
            valids.add(Boolean.FALSE);
        }
        if(defaults == null || defaults.size() < 1)
        {
            defaults = new ArrayList();
            defaults.add(Boolean.FALSE);
        }
    }
  %>
  <es:notNull item="<%=valids%>">
    <%
      Object[] arr = valids.toArray();
      int validCount = arr.length;
      int rows = validCount / 2;
      if ( validCount % 2 == 1 ) rows++;
      int rowCount = 1;
      int count = 0;
      boolean secondCol = false;
    %>
    <tr> 
      <td width="2%">&nbsp;</td>
      <td width="6%">&nbsp;</td>
      <td width="83%"> 
        <form method="post" action="<wf:createWebflowURL event="link.groupuser_property_edit_sr"/>" name="DefaultsForm">
        <table width="100%" border="0" cellpadding="0" cellspacing="4">
          <tr> 
            <td width="45%" valign="top"> 
              <table width="100%" border="1" cellpadding="2" cellspacing="0" bgcolor="#cccccc" bordercolor="#ffffff">
              <% String urlTail = "&scopeName=" + URLEncoder.encode(scopeName) + "&propertyName=" + URLEncoder.encode(propertyName) + "&schemaGroupName=" + URLEncoder.encode(schemaGroupName); %>
              <es:forEachInArray id="valueObject" array="<%= arr %>" type="Object">
                <% String formattedObject = propertyBean.formatPropertyValue( property, valueObject ); %>
                <% count++; %>
                <% String bgcolor = (rowCount % 2 == 1 ? "#cccccc" : "#ffffff"); %>
                <tr bgcolor="<%= bgcolor %>"> 
                  <td width="4%"> 
                    <input type="radio" name="customValue" value="<%= formattedObject %>" <% if ( defaults.contains( valueObject ) ) { %>CHECKED<% } %>>
                  </td>
                  <td><font face="Verdana, Arial, Helvetica, sans-serif" size="2"> <%= cnvrtSC(valueObject.toString()) %></font></td>
                </tr>
                <% if ( rowCount++ >= rows && !secondCol ) { %>
                  <%-- end the first column and start the next --%>
                  <% rowCount = 1; secondCol = true; %>
                      </table>
                   </td>
                  <td>&nbsp;</td>
                  <td width="45%" valign="top"> 
                    <table width="100%" border="1" cellpadding="2" cellspacing="0" bgcolor="#cccccc" bordercolor="#ffffff">
                <% } %>
              </es:forEachInArray>
              </table>
            </td>
          </tr>
        </table>

      <input type="hidden" name="propertyName" value="<%=propertyName%>">
      <input type="hidden" name="scopeName" value="<%=scopeName%>">
      <input type="hidden" name="schemaGroupName" value="<%=schemaGroupName%>">
      <input type="hidden" name="<%=DESTINATION_TAG%>" value="<%=getRequestURI(request)%>">
      <input type="hidden" name="setDefaultSubmit" value="setDefaultSubmit">
      <input type="hidden" name="<%= varName %>" value="<%= varValue%>">

      </form>
      </td>
      <td width="9%">&nbsp;</td>
    </tr>
  </es:notNull>

    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td width="83%" align="right">
        <table width="10%" border="0" cellpadding="0" align="right">
          <tr> 
            <td>
            <% 
	    String params  =  varName + "=" + URLEncoder.encode(varValue) + 
	                      "&groupPropertySets=" + URLEncoder.encode(scopeName) +
		              "&formSubmit=formSubmit";
            returnPage = "link." + returnPage;
            returnPage = returnPage.substring(0, returnPage.indexOf(".jsp"));
	    %>
	    <a href="<wf:createWebflowURL event="<%=returnPage%>" extraParams="<%=params%>"/>">
            <img src="<wf:createResourceURL resource="/repository/images/back_um1.gif"/>" width="65" height="40" border="0" alt="Return to the Previous Page"></a></td>
            <td><A HREF="javascript:submitDefaultsForm();" onClick="submitDefaultsForm(); return false;"><img src="<wf:createResourceURL resource="/repository/images/save_um1.gif"/>" width="65" height="40" alt="Save Changes" border="0"></a></td>
          </tr>
        </table>
        <p>&nbsp;</p>
      </form>
    </td>
    <td width="9%">&nbsp;</td>
  </tr>
  <tr> 
    <td width="2%">&nbsp;</td>
    <td width="6%">&nbsp;</td>
    <td width="83%">&nbsp; </td>
    <td width="9%">&nbsp;</td>
  </tr>
</table>
</body>
<%@ include file="/tools/util/endUserTransaction.inc" %>
</html>

