<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<%----------------------------------------------------------
Clean up checklist

[x] - using header include for the header
[x] - page extends com.bea.jsptools.common.servlets.jsp.ToolsJspBase
[x] - finished button at top and bottom (if page requires it)
[x] - check color consistency
[x] - cnvrtSC()
[x] - check tool tips 
[x] - blank text fields when first loaded 
[x] - check text input size
[x] - page wrapped in transaction 
[x] - colon after textfield labels
[x] - monitor session tag
[x] - goto error page
[x] - check for TODOs
----------------------------------------------------------%>

<%@ page extends="com.bea.jsptools.common.servlets.jsp.ToolsJspBase"%>
<%@ taglib uri="weblogic.tld" prefix="wl" %>
<%@ taglib uri="webflow.tld" prefix="wf" %>
<%@ taglib uri="es.tld" prefix="es" %>
<%@ taglib uri="um.tld" prefix="um" %>
<%@ page import="com.bea.jsptools.p13n.common.servlets.jsp.JspUtilPages" %>
<%@ page import="com.bea.jsptools.p13n.usermgmt.servlets.jsp.UserManagementJspPages" %>
<%@ page import="com.bea.p13n.property.PropertyDefinition" %>
<%@ page import="java.net.URLEncoder" %>

<jsp:useBean id="propertyBean" class="com.bea.jsptools.p13n.usermgmt.servlets.jsp.PropertyBean" scope="request" />
<jsp:setProperty name="propertyBean" property="*" />

<% request.setAttribute(SERVICEMANAGER_CURRENT_PAGE, getJspName(pageContext));%>

<% String userName = request.getParameter("userName"); %>
<% String groupName = request.getParameter("groupName"); %>
<% String varName =  (userName != null) ? "userName" : "groupName"; %>
<% String varValue =  (userName != null) ? userName : groupName; %>

<% PropertyDefinition property = propertyBean.getPropertyObject(); %>

<% 
  // get the meta data from the default scope if we have to
/* don't have to worry about default properties as of Flagstaff
  if ( property == null )
  {
    if ( varName.equals( "userName" ) )
    {
      property = propertyBean.getDefaultPropertyMetaDataForUser( varValue );
    }
    else
    {
      property = propertyBean.getDefaultPropertyMetaDataForGroup( varValue );
    }
  }
*/
%>
<% propertyBean.setPropertyMetaData(property); %>
<% String propertyName = propertyBean.getPropertyName(); %>
<% String propertyType = propertyBean.getTypeForDisplay( property ); %>
<% String scopeName = propertyBean.getScopeName(); %>
<% String renderer = propertyBean.getPropertyValueEditor( property ); %>
<% String statusMsg = null; %>
<% String returnPage = (userName == null) ? UserManagementJspPages.GROUP_SCOPE_PROPERTY_JSP : UserManagementJspPages.USER_SCOPE_PROPERTY_JSP; %>

<wl:process name="formSubmit">

  <% Object valueObject = propertyBean.getAsObject(request.getParameter("customValue"));%>

  <%-- set the property if valueObject is not null  --%>
  <es:notNull item="<%=valueObject%>">
    <um:setProperty propertySet="<%=scopeName %>" propertyName="<%= propertyName %>" value="<%= valueObject %>" />
    <% statusMsg = "Property set correctly."; %>
  </es:notNull>

  <es:isNull item="<%=valueObject%>">
    <% statusMsg = "Please enter valid values."; %>
  </es:isNull>

</wl:process>

<um:getProperty id="currentPropertyValue" propertySet="<%= scopeName %>" propertyName="<%= propertyName %>" />

<% if ( scopeName == null ) scopeName = ""; %>

<html>
<head>
<title>Property Set Management</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<SCRIPT LANGUAGE="JavaScript">
function submitForm() {
   this.document.UserMgmtForm.submit();
   return true;
}
</SCRIPT>
</head>
<%@ include file="/tools/util/startUserTransaction.inc" %>

<body bgcolor="#FFFFFF" topmargin="0" leftmargin="0" marginwidth="0" marginheight="0">
<!-- Header  -->
<jsp:include page="<%=JspUtilPages.JSP_UTIL_HOME_HDR%>"/>

<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr> 
    <td width="4%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="93%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="3%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="65" height="8"></td>
    <td width="0%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
  </tr>
  <tr> 
    <td width="4%" bgcolor="#006666" height="23"> 
      <div align="right"><img src="<wf:createResourceURL resource="/repository/images/psm.gif"/>" width="30" height="24"></div>
    </td>
    <td width="93%" bgcolor="#006666" height="23"><font face="Verdana, Arial, Helvetica, sans-serif" size="3" color="#FFFFFF"><b>Property Set: <%= cnvrtSC(scopeName.equals("") ? "<Default>" : scopeName) %></b></font></td>
    <td width="3%" bgcolor="#006666" height="23"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="65" height="24" border="0"></td>
    <td width="0%" bgcolor="#FFFFFF" height="23"><img src="<wf:createResourceURL resource="/repository/images/curves_um1_1.gif"/>" width="30" height="24"></td>
  </tr>
  <tr> 
    <td width="4%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="93%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="3%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="65" height="8"></td>
    <td width="0%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
  </tr>
  <tr>
    <td width="4%">&nbsp;</td>
    <td width="93%"><font face="Verdana, Arial, Helvetica, sans-serif" size="3" color="#CC0000"><b>Property: 
      <%= cnvrtSC(propertyBean.getPropertyName()) %> (Type: <%= propertyType %>, Single, Unrestricted)</b></font></td>
    <td width="3%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="65" height="8"></td>
    <td width="0%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
  </tr>
</table>
<table border="0" cellspacing="0" cellpadding="0" width="100%">
  <tr> 
    <td width="2%">&nbsp;</td>
    <td width="7%">&nbsp;</td>
    <td width="82%"><es:notNull item="<%=statusMsg%>"><%@ include file="/tools/usermgmt/status.inc" %></es:notNull></td>
    <td width="9%">&nbsp;</td>
  </tr>
  <tr> 
    <td width="2%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="20" height="8"></td>
    <td rowspan="3" width="7%" align="right" valign="top"> <font face="Verdana, Arial, Helvetica, sans-serif" size="2"><img src="<wf:createResourceURL resource="/repository/images/icon_edit.gif"/>" width="65" height="50"></font></td>
    <td bgcolor="#CCCCCC" width="82%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="5">Edit 
      Property Values</b></font></td>
    <td width="9%">&nbsp;</td>
  </tr>
    <tr>
      <td width="2%">&nbsp;</td>
      <td width="82%">&nbsp;</td>
      <td width="9%">&nbsp;</td>
    </tr>
  <tr> 
    <td width="2%">&nbsp;</td>
    <td width="82%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2">Enter 
      changes to the property value and click Save.</font></td>
    <td width="9%">&nbsp;</td>
  </tr>
  <tr> 
    <td width="2%">&nbsp;</td>
    <td width="7%">&nbsp;</td>
    <td width="82%"> 
      <form method="post" action="<wf:createWebflowURL event="link.groupuser_property_edit_su"/>" name="UserMgmtForm">
        <table width="100%" border="0" cellspacing="2" cellpadding="2">
        <% if ( property.getDefaultValue() != null ) { %>
	  <tr>
            <td width="20%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><nobr>Default
              Value:&nbsp;</nobr></b></font></td>
            <td width="80%">
	        <table>
		  <tr>
		      <td width="5%" align="right">
		          <img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="10" height="15">
		      </td>
		      <td width="95%" align="left">
		      <font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000">
		         <%= cnvrtSC(propertyBean.formatPropertyValue( property,  property.getDefaultValue() )) %>
	              </font>
		      </td>
		  </tr>
		</table>
            </td>
	  </tr>
          <% } %>

          <tr> 
            <td width="20%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><b><nobr>New
              Value:&nbsp;</nobr></b></font> </td>
            <td width="80%">
              <% request.setAttribute( "Property", property ); %>
              <% request.setAttribute( "PropertyValue", currentPropertyValue ); %>
              <% request.setAttribute( "FieldName", "customValue" ); %>
              <% request.setAttribute( "FormName", "UserMgmtForm" ); %>
              <jsp:include page="<%= renderer%>"/>
            </td>
          </tr>
        </table>
        <table border="0" cellspacing="4" cellpadding="0" align="right">
          <tr> 
            <td> 
              <div align="right">
	          <% 
		      String params =  varName + "=" + URLEncoder.encode(varValue) + 
		                       "&groupPropertySets=" + URLEncoder.encode(scopeName) +
				       "&formSubmit=formSubmit";
                      String eventParams = "link."+returnPage;
                      eventParams = eventParams.substring(0, eventParams.indexOf(".jsp"));
		  %>
	          <a href="<wf:createWebflowURL event="<%=eventParams%>" extraParams="<%=params%>"/>">
	       <img src="<wf:createResourceURL resource="/repository/images/back_um1.gif"/>" width="65" height="40" border="0" alt="Return to the Previous Page"></a></div>
            </td>
            <td><a HREF="javascript:submitForm();" onClick="submitForm(); return false;"><img src="<wf:createResourceURL resource="/repository/images/save_um1.gif"/>" width="65" height="40" alt="Save Changes" border="0"></a></td>
          </tr>
        </table>

        <input type="hidden" name="scopeName" value="<%= propertyBean.getScopeName() %>">
        <input type="hidden" name="schemaGroupName" value="<%= propertyBean.getSchemaGroupName() %>">
        <input type="hidden" name="propertyName" value="<%= propertyName %>">
        <input type="hidden" name="<%=DESTINATION_TAG%>" value="<%=getRequestURI(request)%>">
        <input type="hidden" name="formSubmit" value="formSubmit">
        <input type="hidden" name="<%= varName %>" value="<%= varValue %>">

        <p>&nbsp;</p>
      </form>
    </td>
    <td width="9%">&nbsp;</td>
  </tr>
  <tr> 
    <td width="2%">&nbsp;</td>
    <td width="7%">&nbsp;</td>
    <td width="82%">&nbsp; </td>
    <td width="9%">&nbsp;</td>
  </tr>
</table>
</body>
<%@ include file="/tools/util/endUserTransaction.inc" %>
</html>

