<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<%----------------------------------------------------------
Clean up checklist

[x] - using header include for the header
[x] - page extends com.bea.jsptools.common.servlets.jsp.ToolsJspBase
[x] - finished button at top and bottom (if page requires it)
[x] - check color consistency
[x] - cnvrtSC()
[x] - check tool tips 
[x] - blank text fields when first loaded 
[x] - check text input size
[x] - page wrapped in transaction 
[x] - colon after textfield labels
[x] - monitor session tag
[x] - goto error page
[x] - check for TODOs
----------------------------------------------------------%>

<%@ page extends="com.bea.jsptools.common.servlets.jsp.ToolsJspBase"%>
<%@ taglib uri="weblogic.tld" prefix="wl" %>
<%@ taglib uri="webflow.tld" prefix="wf" %>
<%@ taglib uri="es.tld" prefix="es" %>
<%@ taglib uri="um.tld" prefix="um" %>

<%@ page import="com.bea.p13n.appflow.webflow.WebflowJSPHelper" %>
<%@ page import="com.bea.p13n.property.PropertyDefinition" %>
<%@ page import="com.bea.p13n.property.PropertySet" %>
<%@ page import="com.bea.jsptools.p13n.common.servlets.jsp.JspUtilPages" %>
<%@ page import="java.net.URLEncoder" %>

<jsp:useBean id="propertyBean" class="com.bea.jsptools.p13n.usermgmt.servlets.jsp.PropertyBean" scope="request" />
<jsp:useBean id="propertySetBean" class="com.bea.jsptools.p13n.usermgmt.servlets.jsp.PropertySetBean" scope="request" />
<jsp:setProperty name="propertySetBean" property="*" />
<jsp:useBean id="accessBean" class="com.bea.jsptools.p13n.usermgmt.servlets.jsp.FunctionAccessBean" scope="session" />

<% request.setAttribute(SERVICEMANAGER_CURRENT_PAGE, getJspName(pageContext));%>

<%
  // initialization of variables

  // TODO - are there constants for these things anywhere now, or are they
  // only in the deployment descriptors?
  final String schemaGroupName = "USER";

  boolean isManageableRealm = accessBean.isManageableRealm();
  String userName = request.getParameter("userName");
  String scopeName = null;
  propertySetBean.setSchemaGroupName(schemaGroupName);
  PropertySet propertySet = null;
%>

<!-- get the profile for the group -->
<um:getProfile profileKey="<%= userName %>" scope="session" />

<!-- if the user has selected a property set from the drop down box -->
<wl:process name="groupPropertySets">
<%@ include file="/tools/util/startUserTransaction.inc" %>
    <%
      scopeName = request.getParameter("groupPropertySets");
      setSessionValue( "CURRENT_PROPERTY_SET", scopeName, request );
      if ( propertySetBean.DEFAULT_PROPERTY_SET.equals( scopeName ) )
        scopeName = null;
      propertySetBean.setScopeName(scopeName);
      propertySet = propertySetBean.getPropertySet();
    %>
<%@ include file="/tools/util/endUserTransaction.inc" %>
</wl:process>

<wl:process notname="groupPropertySets">
    <%
      scopeName = (String)getSessionValue( "CURRENT_PROPERTY_SET", request );
      if ( propertySetBean.DEFAULT_PROPERTY_SET.equals( scopeName ) )
        scopeName = null;
      propertySetBean.setScopeName(scopeName);

      propertySet = propertySetBean.getPropertySet();

      // not sure the following will ever happen, but just in case
      if(propertySet == null)
      {
          removeSessionValue("CURRENT_PROPERTY_SET", request);
          propertySetBean.setScopeName(null);
          scopeName = null;
      }
    %>
</wl:process>

<!-- remove a property value to restore the default -->
<wl:process name="restoreDefault">
<%@ include file="/tools/util/startUserTransaction.inc" %>

  <%
    String propertyName = request.getParameter( "propertyName" );
  %>
  <um:removeProperty propertySet="<%= scopeName %>"
      propertyName="<%= propertyName %>"/>

<%@ include file="/tools/util/endUserTransaction.inc" %>
</wl:process>

<!-- get all the property sets present in the system -->
<%
  String[] allPropertySets = propertySetBean.getPropertySetNames(schemaGroupName);
  if ( scopeName == null ) scopeName = "";
%>

<html>
<head>
<title>User Management</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<SCRIPT LANGUAGE="JavaScript">
function submitForm() {
   this.document.UserMgmtForm.submit();
   return true;
}
</SCRIPT>
</head>

<body bgcolor="#FFFFFF" topmargin="0" leftmargin="0" marginwidth="0" marginheight="0">
<%@ include file="/tools/util/startUserTransaction.inc" %>
<!-- Header  -->
<jsp:include page="<%=JspUtilPages.JSP_UTIL_HOME_HDR%>"/>

<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr> 
    <td width="3%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width=8 height=8></td>
    <td width="60%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width=5 height=8></td>
    <td width="30%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width=5 height=8></td>
    <td width="4%" bgcolor="#000000"><a href="<wf:createWebflowURL event="link.user_home"/>"><img src="<wf:createResourceURL resource="/repository/images/stopblack_um1.gif"/>" width="65" height="8" border="0" alt="Return to User Management Home"></a></td>
    <td width="3%" bgcolor="#000000"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width=8 height=8></td>
  </tr>

  <tr> 
    <td width="3%" bgcolor="#006666"> 
      <div align="right"><img src="<wf:createResourceURL resource="/repository/images/um.gif"/>" width="30" height="24"></div>
    </td>
    <td width="90%" colspan=2 bgcolor="#006666"><font face="Verdana, Arial, Helvetica, sans-serif" size="3" color="#FFFFFF"><b>Users: <%= cnvrtSC(userName) %></b></font></td>
    <td width="4%" bgcolor="#006666"><a href="<wf:createWebflowURL event="link.user_home"/>"><img src="<wf:createResourceURL resource="/repository/images/sfinished_um1.gif"/>" width="65" height="24" border="0" alt="Return to User Management Home"></a></td>
    <td width="3%" bgcolor="#FFFFFF"><img src="<wf:createResourceURL resource="/repository/images/curves_um1_1.gif"/>" width="30" height="24"></td>
  </tr>
  <tr> 
    <td width="3%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="90%" colspan=2><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="4%"><a href="<wf:createWebflowURL event="link.user_home"/>"><img src="<wf:createResourceURL resource="/repository/images/sbottom_um1.gif"/>" width="65" height="8" border="0" alt="Return to User Management Home"></a></td>
    <td width="3%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
  </tr>
</table>
<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <form method="post" action="<wf:createWebflowURL event="link.user_scope_property"/>" name="UserMgmtForm">
    <td width="3%">&nbsp;</td>
    <td width="44%" valign="middle"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><b>Select a property set to view for this user :</b></font>
       <select name="groupPropertySets" size="1">
	   <%-- We no longer support editing DEFAULT_PROPERTY_SETs in the admin tools --%>
	   <%-- <option value="<%= propertySetBean.DEFAULT_PROPERTY_SET %>"><%= cnvrtSC(propertySetBean.DEFAULT_PROPERTY_SET) %> </option> --%>
	   <es:forEachInArray id="currPropertySet" array="<%=allPropertySets%>" type="String" counterId="i">
	        <option <%= currPropertySet.equalsIgnoreCase(scopeName) ? "selected" : ""  %> value="<%= cnvrtSC(currPropertySet) %>"><%= cnvrtSC(currPropertySet) %></option>
	   </es:forEachInArray>
       </select>
    </td>
    <td width="37%">
       <A HREF="javascript:submitForm();" onClick="submitForm(); return false;"><img src="<wf:createResourceURL resource="/repository/images/search_um1.gif"/>" border=0 width="65" height="40" alt="Find the Property Set"></a>
    </td>

    <td width="4%">&nbsp;</td>
    <td width="3%">&nbsp;</td>
        <input type="hidden" name="<%=DESTINATION_TAG%>" value="<%=getRequestURI(request)%>">    
        <input type="hidden" name="userName" value="<%= userName %>">
        <input type="hidden" name="formSubmit" value="formSubmit">
    </form>
  </tr>
</table>
<p>
<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr height="20"> 
    <td height="20" width="3%" bgcolor="#006666">&nbsp;</td>
    <td height="20" width="1%" bgcolor="#006666">&nbsp;</td>
    <td height="20" width="86%" bgcolor="#006666"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#FFFFFF"><b>
        User Information</b></font></td>
    <td height="20" width="7%" bgcolor="#006666"> 
      <% if(isManageableRealm) { %>
        <% String editInfoParams = "userName="+URLEncoder.encode(userName);%>
      <div align="center"><a href="<wf:createWebflowURL event="link.user_edit_info" extraParams="<%=editInfoParams%>"/>"><img src="<wf:createResourceURL resource="/repository/images/edit_red.gif"/>" width="50" height="20" border="0" alt="Edit User Information"></a></div>
      <% } else { %>
      <div align="center"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="50" height="20" border="0"></div>
      <% } %>
    </td>
    <td height="20" width="3%" bgcolor="#006666"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><b><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="24" height="8"></b></font></td>
  </tr>

  <tr> 
    <td width="3%" bgcolor="#006666">&nbsp;</td>
    <td width="1%" bgcolor="#FFFFFF">&nbsp;</td>
    <td width="86%" bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000">Username:&nbsp;<%= cnvrtSC(userName) %> </font></td>
    <td width="7%" bgcolor="#FFFFFF">&nbsp;</td>
    <td width="3%" bgcolor="#FFFFFF">&nbsp;</td>
  </tr>

  <tr> 
    <td width="3%" bgcolor="#006666">&nbsp;</td>
    <td width="1%" bgcolor="#FFFFFF">&nbsp;</td>
    <td width="86%" bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000">&nbsp;</font></td>
    <td width="7%" bgcolor="#FFFFFF">&nbsp;</td>
    <td width="3%" bgcolor="#FFFFFF">&nbsp;</td>
  </tr>

  <tr height="20"> 
    <td height="20" width="3%" bgcolor="#006666"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="30" height="8"></td>
    <td height="20" width="1%" bgcolor="#006666"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="10" height="8"></td>
    <td height="20" width="86%" bgcolor="#006666"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#FFFFFF"><b>Properties</b></font></td>
    <td height="20" width="7%" bgcolor="#006666"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="3" height="8"></td>
    <td height="20" width="3%" bgcolor="#006666"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="3" height="8"></td>
  </tr>

  <!-- the properties go here -->

  <%-- get properties for the current propertyset --%>

  <% 
    /*
     String schemaGroupName = propertySetBean.getSchemaGroupName();
     if ( schemaGroupName == null ) schemaGroupName = "";

     Map unsortedProperties = (schema != null) ? schema.getAllPropertyMetaData() : null;

     if ( unsortedProperties == null && scopeName.equals( "" ))
     {
       unsortedProperties = propertySetBean.getDefaultScopedPropertiesForUser( userName );
     }

     // put the properties in sorted order
     Map properties = new TreeMap( unsortedProperties );

     if ( properties != null && properties.size() > 0 ) {
       
         Iterator iter = properties.keySet().iterator();
	 while( iter.hasNext() ) {

        Object object = iter.next();
	    String propertyName = (String)object; 
	    PropertyMetaData property = (PropertyMetaData)properties.get( propertyName );
        String propertyInfo = "(" + propertyBean.getTypeForDisplay(property) + ", " +  
                              propertyBean.getSelectionOptionForDisplay(property) + ", " + propertyBean.getCategoryForDisplay(property) + ")";
	    request.setAttribute( "PropertyName", propertyName ); 
	    request.setAttribute( "PropertyMetaData", property );
	    request.setAttribute( "scopeName", scopeName );

	    String renderer = propertyBean.getGroupUserPropertyEditor( property );
	    String params = "scopeName=" + URLEncoder.encode(scopeName) +
	                    "&schemaGroupName=" + URLEncoder.encode(schemaGroupName) +
   			    "&propertyName=" + URLEncoder.encode(propertyName) +
			    "&userName=" + URLEncoder.encode(userName);
        */

    Map map = null;

    if(propertySet != null)
    {
        map = propertySet.getPropertyDefinitions();
    }

    if(map != null && map.size() > 0) 
    {
        // put the properties in sorted order
        TreeMap properties = new TreeMap(map);
        String propertySetName = propertySet.getName();

        Iterator iter = properties.keySet().iterator();
    
        while(iter.hasNext())
        {
            Object object = iter.next();
            String propertyName = (String)object; 
            PropertyDefinition property = 
                (PropertyDefinition)properties.get(propertyName);

            StringBuffer propertyInfo = new StringBuffer();
            propertyInfo.append("(");
            // [Boolean, Date/Time, Integer, Text, Floating-Point Number,
            //  User-Defined, Unknown]
            propertyInfo.append(propertyBean.getTypeForDisplay(property));
            propertyInfo.append(", ");
            // [Multiple, Single]
            propertyInfo.append(propertyBean.getSelectionOptionForDisplay(property));
            propertyInfo.append(", ");
            // [Restricted, Unrestricted]
            propertyInfo.append(propertyBean.getCategoryForDisplay(property));
            propertyInfo.append(")");

            request.setAttribute("scopeName",    propertySetName);
            request.setAttribute("PropertyName", propertyName); 
            request.setAttribute("Property",     property);

            String renderer = propertyBean.getGroupUserPropertyEditor(property);

            StringBuffer params = new StringBuffer();
            params.append("scopeName=");
            params.append(URLEncoder.encode(propertySetName));
            params.append("&schemaGroupName=");
            params.append(URLEncoder.encode(schemaGroupName));
            params.append("&propertyName=");
            params.append(URLEncoder.encode(propertyName));
            params.append("&userName=");
            params.append(URLEncoder.encode(userName));
  %>
  
      <tr> 
        <td bgcolor="#006666" width="3%" height="19">&nbsp;</td>
        <td bgcolor="#999999" width="1%" height="19">&nbsp;</td>
        <td bgcolor="#999999" width="86%" height="19">
          <table width="100%" border="0" cellspacing="0" cellpadding="0">
          <tr> 
            <td><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#FFFFFF"><b><%= propertyName %></b> <%= propertyInfo.toString() %></font></td>
            <%String eventLink = "link."+renderer;
              eventLink = eventLink.substring(0, eventLink.indexOf(".jsp"));%>
            <td><div align="right"><a href="<wf:createWebflowURL event="<%=eventLink%>" extraParams="<%=params.toString()%>"/>"><img src="<wf:createResourceURL resource="/repository/images/edit_black.gif"/>" width="50" height="20" border="0" alt="Edit This Property"></a></div></td>

          </tr>
          </table>
        </td>
        <td width="7%" bgcolor="#999999" height="19"> 
            <%String userScopeParams = "restoreDefault=true&" + params.toString();%>
          <div align="center"><a href="<wf:createWebflowURL event="link.user_scope_property" extraParams="<%=userScopeParams%>"/>"><img src="<wf:createResourceURL resource="/repository/images/reset_black.gif"/>" width="50" height="20" border="0" alt="Restore Default Value"></a></div>
        </td>
        <td bgcolor="#999999" width="3%" height="19">&nbsp;</td>
      </tr>

      <tr> 
        <td width="3%" bgcolor="#006666">&nbsp;</td>
        <td width="1%">&nbsp;</td>
        <td width="86%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><%= cnvrtSC(property.getDescription()) %></font></td>
        <td width="7%">&nbsp;</td>
        <td width="3%">&nbsp;</td>
      </tr>

      <tr> 
        <td width="3%" bgcolor="#006666">&nbsp;</td>
        <td width="1%">&nbsp;</td>
        <td width="86%"> 
          <% renderer = propertyBean.getGroupUserPropertyRenderer( property ); 
            String includePage = "/tools/usermgmt/" + renderer;%>
          <es:notNull item="<%=renderer%>">
            <jsp:include page="<%=includePage%>"/>
          </es:notNull>
        </td>
        <td width="7%">&nbsp;</td>
        <td width="3%">&nbsp;</td>
      </tr>

      <tr> 
        <td bgcolor="#006666" width="3%">&nbsp;</td>
        <td width="1%">&nbsp;</td>
        <td width="86%">&nbsp;</td>
        <td width="7%" bgcolor="#FFFFFF">&nbsp;</td>
        <td width="3%" bgcolor="#FFFFFF">&nbsp;</td>
      </tr>

  <%

        } // END  while(iter.hasNext())
    } // END  if(map != null && map.size() > 0) 
  %>
  <!-- end of block where all properties are displayed for a particular propertyset -->


  <tr> 
    <td width="3%" bgcolor="#006666">&nbsp;</td>
    <td width="1%"><font size="2">&nbsp;</font></td>
    <td width="86%">&nbsp; </td>
    <td width="7%" bgcolor="#FFFFFF">&nbsp;</td>
    <td width="3%" bgcolor="#FFFFFF">&nbsp;</td>
  </tr>

  <tr bgcolor="#006666"> 
    <td width="3%">&nbsp;</td>
    <td width="1%">&nbsp;</td>
    <td width="86%"><font face="Verdana, Arial, Helvetica, sans-serif" color="#FFFFFF" size="2"><b>Groups</b></font></td>
    <td width="7%" bgcolor="#006666">&nbsp;</td>
    <td width="3%" bgcolor="#006666">&nbsp;</td>
  </tr>

  <!-- get all the groups this user belongs to -->
  <um:getGroupNamesForUser id="groups" username="<%= userName %>" />

  <tr> 
    <td width="3%" bgcolor="#006666">&nbsp;</td>
    <td width="1%">&nbsp;</td>
    <td width="86%"><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="2">
      <img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="8" height="1" border="0"> 
        <ul type="disc">
          <es:forEachInArray id="currGroup" array="<%=groups%>" type="String" counterId="i" >
            <li><%= cnvrtSC(currGroup) %>
          </es:forEachInArray>
        </ul>
    </font></td>
    <td width="7%" bgcolor="#FFFFFF">&nbsp;</td>
    <td width="3%" bgcolor="#FFFFFF">&nbsp;</td>
  </tr>

  <tr> 
    <td width="3%" bgcolor="#FFFFFF">&nbsp;</td>
    <td width="1%">&nbsp;</td>
    <td width="86%">&nbsp;</td>
    <td width="7%"><a href="<wf:createWebflowURL event="link.user_home"/>"><img src="<wf:createResourceURL resource="/repository/images/finished_um1.gif"/>" width="65" height="40" alt="Return to User Management Home" border="0"></a></td>
    <td width="3%" bgcolor="#FFFFFF">&nbsp;</td>
  </tr>

  <tr> 
    <td width="3%" bgcolor="#FFFFFF">&nbsp;</td>
    <td width="1%">&nbsp;</td>
    <td width="86%">&nbsp;</td>
    <td width="7%" bgcolor="#FFFFFF">&nbsp;</td>
    <td width="3%" bgcolor="#FFFFFF">&nbsp;</td>
  </tr>

</table>
<%@ include file="/tools/util/endUserTransaction.inc" %>
</body>
</html>
