<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<%----------------------------------------------------------
Clean up checklist

[x] - using header include for the header
[x] - page extends com.bea.jsptools.common.servlets.jsp.ToolsJspBase
[x] - finished button at top and bottom (if page requires it)
[x] - check color consistency
[x] - cnvrtSC()
[x] - check tool tips 
[x] - blank text fields when first loaded 
[x] - check text input size
[x] - page wrapped in transaction 
[x] - colon after textfield labels
[x] - monitor session tag
[x] - goto error page
[x] - check for TODOs
----------------------------------------------------------%>

<%@ page extends="com.bea.jsptools.common.servlets.jsp.ToolsJspBase"%>
<%@ taglib uri="weblogic.tld" prefix="wl" %>
<%@ taglib uri="webflow.tld" prefix="wf" %>
<%@ taglib uri="es.tld" prefix="es" %>
<%@ taglib uri="um.tld" prefix="um" %>
<%@ page import="com.bea.jsptools.p13n.common.servlets.jsp.JspUtilPages" %>
<%@ page import="com.bea.p13n.usermgmt.servlets.jsp.taglib.UserManagementTagConstants"%>

<jsp:useBean id="accessBean" class="com.bea.jsptools.p13n.usermgmt.servlets.jsp.FunctionAccessBean" scope="session" />

<% request.setAttribute(SERVICEMANAGER_CURRENT_PAGE, getJspName(pageContext));%>

<%
 boolean isManageableRealm = accessBean.isManageableRealm();
 String statusMsg = null;
 String[] userArray = null;
 String searchFor = null;
 String resultString=null ;
 String params=null;
 String userName=null;
%>

<wl:process name="deleteUser">
<%@ include file="/tools/util/startUserTransaction.inc" %>

  <% 
    String deleteUserName = request.getParameter("deleteUser");
  %>
 
  <um:removeUser username= "<%= deleteUserName %>" result="removeResult" />
    <%-- display an remove error message if there is an error message --%>
    <% if(removeResult.intValue() == UserManagementTagConstants.REMOVE_USER_FAILED)
       {
           statusMsg = "Cannot remove User :" +  cnvrtSC(deleteUserName);
       }
       else if(removeResult.intValue() == UserManagementTagConstants.REMOVE_USER_OK)
       {
           statusMsg = "User '" +  cnvrtSC(deleteUserName)  + "' successfully removed.";
       } %>

<%@ include file="/tools/util/endUserTransaction.inc" %>
</wl:process>


<wl:process name="searchFor">
<%@ include file="/tools/util/startUserTransaction.inc" %>
<% 
   searchFor = request.getParameter("searchFor"); 
   int limit = UserManagementTagConstants.DEFAULT_USER_LIMIT;
%>
       <um:getUsernames id="allUsers"  
                        result="result" 
                        searchExp="<%= searchFor %>" 
                        userLimit="<%= limit %>" />

<%     if(allUsers.length == 0)
       {
           statusMsg = "No match found for string : " + cnvrtSC(searchFor);
       }

       if(result.intValue() == UserManagementTagConstants.USER_LIMIT_EXCEEDED)
       {
           statusMsg ="Matching user count exceeds limit. Please narrow your search."; 
       }
       else if(result.intValue() == UserManagementTagConstants.USER_SEARCH_OK && allUsers.length > 0)
       {
           userArray = allUsers;

           if ( userArray.length == limit )
           {
               statusMsg = "Results were limited to " + limit +
                           " users. Please narrow your search and try again.";
           }
       }
       else if(result.intValue() == UserManagementTagConstants.USER_SEARCH_FAILED)
       {
           statusMsg = "System Error. User Search Failed" ;
       } %>

<%@ include file="/tools/util/endUserTransaction.inc" %>
</wl:process>


<html>
<head>
<title>User Management</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<SCRIPT LANGUAGE="JavaScript">
function submitForm() {
   this.document.UserMgmtForm.submit();
   return true;
}

function deleteUser(userName)
{
   return (confirm("Are you sure you want to delete user '" + userName + "'"));
}

</SCRIPT>
</head>

<%@ include file="/tools/util/startUserTransaction.inc" %>

<body bgcolor="#FFFFFF" topmargin="0" leftmargin="0" marginwidth="0" marginheight="0">

<!-- Header  -->
<jsp:include page="<%=JspUtilPages.JSP_UTIL_HOME_HDR%>"/>

<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr bgcolor="#000000"> 
    <td width="3%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="90%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="3%"><img src="<wf:createResourceURL resource="/repository/images/stopclear.gif"/>" width="65" height="8"></td>
    <td width="4%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
  </tr>
  <tr> 
    <td width="3%" bgcolor="#006666" height="14"><img src="<wf:createResourceURL resource="/repository/images/um.gif"/>" width="30" height="24"></td>
    <td width="90%" bgcolor="#006666" height="14"><font face="Verdana, Arial, Helvetica, sans-serif" size="3" color="#000000"><b><font color="#FFFFFF">Users</font></b></font></td>
    <td width="3%" bgcolor="#006666" height="14"><img src="<wf:createResourceURL resource="/repository/images/smiddleclear.gif"/>" width="65" height="24"></td>
    <td width="4%" height="14"><img src="<wf:createResourceURL resource="/repository/images/curves_um1_1.gif"/>" width="30" height="24"></td>
  </tr>
  <tr> 
    <td width="3%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="90%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
    <td width="3%"><img src="<wf:createResourceURL resource="/repository/images/sbottomclear.gif"/>" width="65" height="8"></td>
    <td width="4%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></td>
  </tr>
  <tr> 
    <td width="3%">&nbsp; </td>
    <td width="90%">&nbsp;</td>
    <td width="3%">&nbsp;</td>
    <td width="4%">&nbsp;</td>
  </tr>
</table>
<table border="0" cellspacing="0" cellpadding="2" width="100%" >
  <tr> 
    <td width="2%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="20" height="8"></font></td>
    <td bgcolor="#CCCCCC" width="39%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"><b>Search 
      for a User</b></font></td>
      <td width="7%"> 
        <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#CC0000"><b>Or</b></font></div>
      </td>
      <td bgcolor="#CCCCCC" width="41%">
        <font face="Verdana, Arial, Helvetica, sans-serif" size="2"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"></font><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><b>See 
        a List of All Users that Start with...</b></font>
      </td>
      <td width="11%" bgcolor="#CCCCCC">&nbsp;</td>
  </tr>
  <tr> 
    <td width="2%">&nbsp;</td>
    <td width="39%"> 
      <form method="post" action="<wf:createWebflowURL event="link.user_search"/>" name="UserMgmtForm">
       <table width="100%" border="0" cellspacing="0" cellpadding="2">
          <tr> 
            <td colspan="3"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000">Enter 
              a user name then click Search.</font></td>
          </tr>
          <tr> 
            <td width="25%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><b><nobr>Username:&nbsp;</nobr></b></font></td>
            <td width="54%"> 
              <input type="text" name="searchFor" size="15" maxlength="50" value="">
            </td>
            <td width="21%"><a href="javascript:submitForm();" onClick="submitForm(); return false;"><img src="<wf:createResourceURL resource="/repository/images/search_um1.gif"/>" width="65" height="40" alt="Get Search Results" border="0"></td>
          </tr>
        </table>
      
    </td>
    <td width="7%"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="40" height="8"></font></td>
    <td valign="top" width="41%"> 
      <table border="0" cellspacing="4" cellpadding="4">
        <tr bgcolor="#006666"> 
          <td> 
            <div align="center"><A HREF="<wf:createWebflowURL event="link.user_search" extraParams="searchFor=a*"/>"><font size="3" face="Verdana, Arial, Helvetica, sans-serif"><b><font color="#FFFFFF">A</font></b></font></a></div>
          </td>
          <td> 
            <div align="center"><A HREF="<wf:createWebflowURL event="link.user_search" extraParams="searchFor=b*"/>"><font size="3" face="Verdana, Arial, Helvetica, sans-serif"><b><font color="#FFFFFF">B</font></b></font></a></td></div>
          </td>
          <td> 
            <div align="center"><A HREF="<wf:createWebflowURL event="link.user_search" extraParams="searchFor=c*"/>"><font size="3" face="Verdana, Arial, Helvetica, sans-serif"><b> 
              <font color="#FFFFFF">C</font></b></font></a></div>
          </td>
          <td> 
            <div align="center"><A HREF="<wf:createWebflowURL event="link.user_search" extraParams="searchFor=d*"/>"><font size="3" face="Verdana, Arial, Helvetica, sans-serif"><b><font color="#FFFFFF">D</font></b></font></a></div>
          </td>
          <td> 
            <div align="center"><A HREF="<wf:createWebflowURL event="link.user_search" extraParams="searchFor=e*"/>"><font size="3" face="Verdana, Arial, Helvetica, sans-serif"><b><font color="#FFFFFF">E</font></b></font></a></div>
          </td>
          <td> 
            <div align="center"><A HREF="<wf:createWebflowURL event="link.user_search" extraParams="searchFor=f*"/>"><font size="3" face="Verdana, Arial, Helvetica, sans-serif"><b><font color="#FFFFFF">F</font></b></font></a></div>
          </td>
          <td> 
            <div align="center"><A HREF="<wf:createWebflowURL event="link.user_search" extraParams="searchFor=g*"/>"><font size="3" face="Verdana, Arial, Helvetica, sans-serif"><b><font color="#FFFFFF">G</font></b></font></a></div>
          </td>
          <td> 
            <div align="center"><A HREF="<wf:createWebflowURL event="link.user_search" extraParams="searchFor=h*"/>"><font size="3" face="Verdana, Arial, Helvetica, sans-serif"><b><font color="#FFFFFF">H</font></b></font></a></div>
          </td>
          <td> 
            <div align="center"><A HREF="<wf:createWebflowURL event="link.user_search" extraParams="searchFor=i*"/>"><font size="3" face="Verdana, Arial, Helvetica, sans-serif"><b><font color="#FFFFFF">I</font></b></font></a></div>
          </td>
          <td> 
            <div align="center"><A HREF="<wf:createWebflowURL event="link.user_search" extraParams="searchFor=j*"/>"><font size="3" face="Verdana, Arial, Helvetica, sans-serif"><b><font color="#FFFFFF">J</font></b></font></a></div>
          </td>
          <td> 
            <div align="center"><A HREF="<wf:createWebflowURL event="link.user_search" extraParams="searchFor=k*"/>"><font size="3" face="Verdana, Arial, Helvetica, sans-serif"><b><font color="#FFFFFF">K</font></b></font></a></div>
          </td>
          <td> 
            <div align="center"><A HREF="<wf:createWebflowURL event="link.user_search" extraParams="searchFor=l*"/>"><font size="3" face="Verdana, Arial, Helvetica, sans-serif"><b><font color="#FFFFFF">L</font></b></font></a></div>
          </td>
          <td> 
            <div align="center"><A HREF="<wf:createWebflowURL event="link.user_search" extraParams="searchFor=m*"/>"><font size="3" face="Verdana, Arial, Helvetica, sans-serif"><b><font color="#FFFFFF">M</font></b></font></a></div>
          </td>
        </tr>
        <tr bgcolor="#006666"> 
          <td> 
            <div align="center"><A HREF="<wf:createWebflowURL event="link.user_search" extraParams="searchFor=n*"/>"><font size="3" face="Verdana, Arial, Helvetica, sans-serif"><b><font color="#FFFFFF">N</font></b></font></a></div>
          </td>
          <td> 
            <div align="center"><A HREF="<wf:createWebflowURL event="link.user_search" extraParams="searchFor=o*"/>"><font size="3" face="Verdana, Arial, Helvetica, sans-serif"><b><font color="#FFFFFF">O</font></b></font></a></div>
          </td>
          <td> 
            <div align="center"><A HREF="<wf:createWebflowURL event="link.user_search" extraParams="searchFor=p*"/>"><font size="3" face="Verdana, Arial, Helvetica, sans-serif"><b><font color="#FFFFFF">P</font></b></font></a></div>
          </td>
          <td> 
            <div align="center"><A HREF="<wf:createWebflowURL event="link.user_search" extraParams="searchFor=q*"/>"><font size="3" face="Verdana, Arial, Helvetica, sans-serif"><b><font color="#FFFFFF">Q</font></b></font></a></div>
          </td>
          <td> 
            <div align="center"><A HREF="<wf:createWebflowURL event="link.user_search" extraParams="searchFor=r*"/>"><font size="3" face="Verdana, Arial, Helvetica, sans-serif"><b><font color="#FFFFFF">R</font></b></font></a></div>
          </td>
          <td> 
            <div align="center"><A HREF="<wf:createWebflowURL event="link.user_search" extraParams="searchFor=s*"/>"><font size="3" face="Verdana, Arial, Helvetica, sans-serif"><b><font color="#FFFFFF">S</font></b></font></a></div>
          </td>
          <td> 
            <div align="center"><A HREF="<wf:createWebflowURL event="link.user_search" extraParams="searchFor=t*"/>"><font size="3" face="Verdana, Arial, Helvetica, sans-serif"><b><font color="#FFFFFF">T</font></b></font></a></div>
          </td>
          <td> 
            <div align="center"><A HREF="<wf:createWebflowURL event="link.user_search" extraParams="searchFor=u*"/>"><font size="3" face="Verdana, Arial, Helvetica, sans-serif"><b><font color="#FFFFFF">U</font></b></font></a></div>
          </td>
          <td> 
            <div align="center"><A HREF="<wf:createWebflowURL event="link.user_search" extraParams="searchFor=v*"/>"><font size="3" face="Verdana, Arial, Helvetica, sans-serif"><b><font color="#FFFFFF">V</font></b></font></a></div>
          </td>
          <td> 
            <div align="center"><A HREF="<wf:createWebflowURL event="link.user_search" extraParams="searchFor=w*"/>"><font size="3" face="Verdana, Arial, Helvetica, sans-serif"><b><font color="#FFFFFF">W</font></b></font></a></div>
          </td>
          <td> 
            <div align="center"><A HREF="<wf:createWebflowURL event="link.user_search" extraParams="searchFor=x*"/>"><font size="3" face="Verdana, Arial, Helvetica, sans-serif"><b><font color="#FFFFFF">X</font></b></font></a></div>
          </td>
          <td> 
            <div align="center"><A HREF="<wf:createWebflowURL event="link.user_search" extraParams="searchFor=y*"/>"><font size="3" face="Verdana, Arial, Helvetica, sans-serif"><b><font color="#FFFFFF">Y</font></b></font></a></div>
          </td>
          <td> 
            <div align="center"><A HREF="<wf:createWebflowURL event="link.user_search" extraParams="searchFor=z*"/>"><font size="3" face="Verdana, Arial, Helvetica, sans-serif"><b><font color="#FFFFFF">Z</font></b></font></a></div>
          </td>
        </tr>
      </table>
    </td>
    <td width="11%">&nbsp;</td>
  </tr>
  <tr> 

    <td width="2%">&nbsp;</td>
    <td width="39%">&nbsp;<% if(statusMsg != null) { %><%@ include file="status.inc" %><% } %></td>
    <td width="7%">&nbsp;</td></td>
    <td valign="top" width="41%"> 
      <div align="right"><a href="<wf:createWebflowURL event="link.user_home" /> "><img src="<wf:createResourceURL resource="/repository/images/back_um1.gif"/>" width="65" height="40" alt="Return to the Previous Page" border="0"></a></div>
    </td>
    <td width="11%"></td>
  </tr>


<%-- If search result returns users then then user list should be displayed --%>

<% if(userArray != null && userArray.length > 0)
   { %>
 
 <tr> 
    <td width="2%">&nbsp;</td>
    <td width="41%">&nbsp;</td>
    <td width="4%">&nbsp;</td>
    <td valign="top" width="48%"> 
      <div align="right"></div>
    </td>
    <td width="5%">&nbsp;</td>
  </tr>
  <tr> 
    <td width="2%">&nbsp;</td>
    <td bgcolor="#CCCCCC" width="41%"><img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>" width="5" height="8"><font face="Verdana, Arial, Helvetica, sans-serif" size="2"><b>Search Results</b></font></td>
    <td bgcolor="#CCCCCC" width="4%">&nbsp;</td>
    <td bgcolor="#CCCCCC" width="48%">&nbsp;</td>
    <td width="5%" bgcolor="#CCCCCC">&nbsp;</td>
  </tr>
  <tr> 
    <td height="18" width="2%">&nbsp;</td>
    <td height="18" colspan="3"><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000">Click 
      a title link to edit a user.
      <% if(isManageableRealm)
         { %>
         You can delete a user by clicking its associated  Delete icon.
      <% } %>
      </font></td>
    <td height="18" width="5%">&nbsp;</td>
  </tr>
  <tr> 
    <td width="2%">&nbsp;</td>
    <td width="41%"><font face="Verdana, Arial, Helvetica, sans-serif" size="3" color="#CC0000"><b>

  <%-- If user submits query from input box then query string should be displayed as it is
      otherwise it should display first character only. --%>
 <%
   if(searchFor.length() > 1)
    {
     if(!(searchFor.charAt(1) == '*') )
      resultString = "Result for " + "\"" + searchFor + "\"";      
     else
      resultString = "Result for " + "\"" + searchFor.toUpperCase().charAt(0) + "\"";
    }
   else
    resultString = "Result for " + "\"" + searchFor + "\"";      
 %>

 <%= resultString %>
</b></font></td>
    <td width="4%">&nbsp;</td>
    <td width="48%">&nbsp;</td>
    <td width="5%">&nbsp;</td>
  </tr>
  <tr> 
    <td width="2%">&nbsp;</td>
     <td width="1%">
 </table>      
 
<table width=100% border="0" cellspacing="0" cellpadding="1" bgcolor="#ffffff">
 
 <td width="3%"></td>
 <td width="97%">
 <table width="100%" border="0" cellspacing="0" cellpadding="1" bgcolor="#ffffff">
       
            <tr bgcolor="#ffffff">
	       <td height="15" width="35%">&nbsp; </td>
               <td height="15" width="10%">&nbsp;</td>
	       <td height="15" width="10%">&nbsp;</td>
	       <td height="15" width="35%">&nbsp;</td>
               <td height="15" width="10%">&nbsp;</td> 
	    </tr>
          
         <tr>
          
   <%-- Displays all the users on given query --%>

      <%-- es:counter id="i" minCount="0" maxCount="<%= userArray.length %>" --%>
      <% int userArrayLength = userArray.length;
         for(int i = 0; i < userArrayLength; i++)
         { %>
             
             <% if(i%4==0)
                { %>
               <tr bgcolor="cccccc">
             <% } %>

   <%-- Displays Odd numbered user here --%>      
            <% userName ="userName="+ userArray[i]; %>  
            <td width="35%" height="15"><b><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><a href="<wf:createWebflowURL event="link.user_scope_property" extraParams="<%=userName%>"/>" ><%= cnvrtSC(userArray[i]) %> </a></font></b>
           </td>
           
             <% params = "deleteUser="+userArray[i] + "&" + "searchFor="+searchFor ; %>
           
            <td width="10%" height="15">
              <% if(isManageableRealm) { %>
                <a href="<wf:createWebflowURL event="link.user_search" extraParams="<%=params%>"/>" onClick="return deleteUser('<%= userArray[i] %>')"; >
                <img src="<wf:createResourceURL resource="/repository/images/x.gif"/>"  width="15" height="15" align="right" valign="top" alt="Delete this Property" border="0"></a>
              <% } else { %>
                <img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>"  width="15" height="15" align="right" valign="top" border="0"></a>
              <% } %>
            </td>
            
   <%-- space between usernames in one row. --%>
  
            <td width="10%" height="15" bgcolor="#ffffff" >&nbsp;</td>      

   <%-- Displays Even numbered user here --%>      

           <% if(i+1 < userArray.length)
              {
                  userName ="userName="+ userArray[i+1];%>  

            <td width="35%" height="15"><b><font face="Verdana, Arial, Helvetica, sans-serif" size="2" color="#000000"><a href="<wf:createWebflowURL event="link.user_scope_property" extraParams="<%=userName%>"/>" ><%= cnvrtSC(userArray[i+1]) %><a></font></b>
             </td>
             
            <td width="10%" height="15" >
            <% params = "deleteUser="+userArray[i+1] + "&" + "searchFor="+searchFor; %>
              <% if(isManageableRealm) { %>
                <a href="<wf:createWebflowURL event="link.user_search" extraParams="<%=params%>"/>" onClick="return deleteUser('<%= userArray[i+1] %>')" >
                <img src="<wf:createResourceURL resource="/repository/images/x.gif"/>" width="15" height="15" align="right" valign="top" alt="Delete this Property" border="0"></a>
              <% } else { %>
                <img src="<wf:createResourceURL resource="/repository/images/clear.gif"/>"  width="15" height="15" align="right" valign="top" border="0"></a>
              <% } %>
            </td>
             
              <% i=i+1; %>
            
           <% } %>

       </tr>
       
         <% } // END for(int i = 0; i < userArrayLength; i++) %>
         <%-- /es:counter --%>
       </table>
    <td>
    
  
    <td width="5%">&nbsp;</td>
   </table> 
<table width=100% border="0" cellspacing="0" cellpadding="1" bgcolor="#ffffff">
  
  <td width="5%">&nbsp;</td>
  <tr> 
    <td width="2%">&nbsp;</td>
    <td width="41%">&nbsp;</td>
    <td width="4%"d>&nbsp;</td>
    <td width="50%">&nbsp;</td>
    <td width="4%">&nbsp;</td>
  </tr>
  <tr> 
    <td width="2%">&nbsp;</td>
    <td width="41%">&nbsp;</td>
    <td width="4%">&nbsp;</td>
    <td width="50%"> 
      <div align="right"><a href="<wf:createWebflowURL event="link.user_home"/>"><img src="<wf:createResourceURL resource="/repository/images/finished_um1.gif"/>" width="65" height="40" alt="Return to User Management Home" border="0"></a></div></td>
    <td width="4%">&nbsp;</td>
  </tr>
   
 </table>
<% } %>
</table>
<input type="hidden" name="<%=DESTINATION_TAG%>" value="<%=getRequestURI(request)%>">
<input type="hidden" name="formSubmit" value="formSubmit">
 
</form>
</body>
<%@ include file="/tools/util/endUserTransaction.inc" %>
</html>