<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<%@ taglib uri='extension_taglib.tld' prefix='wlcx' %>
<%@ taglib uri="weblogic-tags.tld" prefix="wl" %>

<%@ page import="com.bea.p13n.mbeans.*" %>
<%@ page import="com.bea.p13n.management.*" %>
<%@ page import="com.bea.console.extensions.PropertiesHelper" %>
<%@ page import="weblogic.management.configuration.ApplicationConfigurationMBean" %>
<%@ page import='weblogic.management.console.extensibility.Catalog' %>
<%@ page errorPage="error.jsp" %>

<%@ include file="includes/applicationName.inc" %>
<%
Vector statusMsg = new Vector();
Catalog catalog = Catalog.Factory.getCatalog(pageContext);
AdServiceMBean mBean = (AdServiceMBean) ApplicationHelper.getServiceConfigurationAdminMBean( "AdService", null, appName );
String[] serviceNames;
%>

<wl:process name='isSubmitted'>
<%
    String newDisplayFlushSize = request.getParameter( "displayFlushSize" );
    String newRendering = request.getParameter( "rendering" );
    String newEventTracker = request.getParameter( "eventTracker" );
    String newAdClickThruURI = request.getParameter( "adClickThruURI" );
    String newShowDocURI = request.getParameter( "showDocURI" );
    Integer iDisplayFlushSize = null;
    try
    {
        iDisplayFlushSize = new Integer(newDisplayFlushSize);
    }
    catch (NumberFormatException e)
    {
        statusMsg.addElement(catalog.getText("adService.msg.InvalidDisplayFlushSize"));
    }
    if (statusMsg.size() == 0)
    {
        // Save off current good values.
        int displayFlushSize = mBean.getDisplayFlushSize();
        String rendering = mBean.getRendering();
        String eventTracker = mBean.getEventTracker();
        String adClickThruURI = mBean.getAdClickThruURI();
        String showDocURI = mBean.getShowDocURI();
        try
        {
            mBean.setDisplayFlushSize(iDisplayFlushSize.intValue());
            mBean.setRendering(newRendering);
            mBean.setEventTracker(newEventTracker);
            mBean.setAdClickThruURI(newAdClickThruURI);
            mBean.setShowDocURI(newShowDocURI);
        }
        catch (java.lang.reflect.UndeclaredThrowableException e)
        {
            Throwable ee = e.getUndeclaredThrowable();
            if (ee instanceof javax.management.InvalidAttributeValueException)
            {
                statusMsg.addElement(ee.getLocalizedMessage());
            }
        }
        if (statusMsg.size() == 0) 
            {
            ApplicationConfigurationMBean appConfigMBean = (ApplicationConfigurationMBean) ApplicationHelper.getApplicationConfigurationAdminMBean( appName );
            appConfigMBean.persist();
            statusMsg.addElement(catalog.getText("default.msg.Success"));
        }
        else
        {
            // Reset to last known good values.
            mBean.setDisplayFlushSize(displayFlushSize);
            mBean.setRendering(rendering);
            mBean.setEventTracker(eventTracker);
            mBean.setAdClickThruURI(adClickThruURI);
            mBean.setShowDocURI(showDocURI);
        }
    }
%>
</wl:process>

<wl:process name='isProviderSubmitted'>
<%
    String provider = request.getParameter("provider");
    String newContentProvider = request.getParameter("contentProvider");
    String newPropertiesString = request.getParameter("properties");
    
    PropertiesHelper ph = new PropertiesHelper();
    ph.setPropertiesString(newPropertiesString);
    ph.String2Properties();
    Properties newProperties = ph.getProperties();
    if (statusMsg.size() == 0)
    {
        AdContentProviderMBean providerBean = (AdContentProviderMBean) ApplicationHelper.getChildServiceConfigurationMBean( "AdContentProvider", provider, mBean);
        // Save current good values
        String contentProvider = providerBean.getProvider();
        Properties properties = providerBean.getProperties();
        try
        {
            providerBean.setProvider(newContentProvider);
            providerBean.setProperties(newProperties);
        }
        catch (java.lang.reflect.UndeclaredThrowableException e)
        {
            Throwable ee = e.getUndeclaredThrowable();
            if (ee instanceof javax.management.InvalidAttributeValueException)
            {
                statusMsg.addElement(ee.getLocalizedMessage());
            }
        }
        if (statusMsg.size() == 0) 
        {
            ApplicationConfigurationMBean appConfigMBean = (ApplicationConfigurationMBean) ApplicationHelper.getApplicationConfigurationAdminMBean( appName );
            appConfigMBean.persist();
            statusMsg.addElement(catalog.getText("default.msg.Success"));
        }
        else
        {
            // Restore last known good values.
            providerBean.setProvider(contentProvider);
            providerBean.setProperties(properties);
        }
    }
%>
</wl:process>

<%
int displayFlushSize = mBean.getDisplayFlushSize();
String rendering = mBean.getRendering();
String eventTracker = mBean.getEventTracker();
String adClickThruURI = mBean.getAdClickThruURI();
String showDocURI = mBean.getShowDocURI();
String helpRollover = catalog.getText("help.rollover");
String pageHeader = catalog.getText("adService.label.PageHeader");
String nonDynamic = catalog.getText("default.label.nondynamic");
%>

<HTML>
<HEAD>
    <%@ include file="includes/Meta.inc" %>
    <wlcx:stylesheet/> 
</HEAD>

<BODY>
<%@ include file="includes/pageHeader.inc" %>
<DIV class='content'>
<BR><BR><BR>
<wlcx:dialog>
    <wlcx:tab name='tab1' labelid='adService.label.tab1'>
        <FORM ACTION="adConsole.jsp<%=appURL %>" METHOD="POST">
            <TABLE WIDTH='100%' CELLSPACING='10' BORDER='0'>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><a href="javascript:errorWindow = window.open('/console/common/nondynamic.jsp', '_blank','resizable=yes,scrollbars=yes,menubar=no,toolbar=no,width=600,height=175'); errorWindow.focus();"><img border='0' src='/console/images/nondynamic.gif' title="<%=nonDynamic %>"></a><A HREF="p13nConsoleHelp.jsp?topic=adConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='adService.label.DisplayFlushSize' /></SPAN></TD>
                    <TD ALIGN="LEFT" VALIGN="TOP" WIDTH="100%"><INPUT TYPE="text" name="displayFlushSize" VALUE="<%=displayFlushSize %>" Size="3" Maxlength="10"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><a href="javascript:errorWindow = window.open('/console/common/nondynamic.jsp', '_blank','resizable=yes,scrollbars=yes,menubar=no,toolbar=no,width=600,height=175'); errorWindow.focus();"><img border='0' src='/console/images/nondynamic.gif' title="<%=nonDynamic %>"></a><A HREF="p13nConsoleHelp.jsp?topic=adConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD VALIGN="TOP" NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='adService.label.Rendering' /></SPAN></TD>
                    <TD VALIGN="TOP"><INPUT TYPE="text" name="rendering" VALUE="<%=rendering %>" Size="40"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><a href="javascript:errorWindow = window.open('/console/common/nondynamic.jsp', '_blank','resizable=yes,scrollbars=yes,menubar=no,toolbar=no,width=600,height=175'); errorWindow.focus();"><img border='0' src='/console/images/nondynamic.gif' title="<%=nonDynamic %>"></a><A HREF="p13nConsoleHelp.jsp?topic=adConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD VALIGN="TOP" NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='adService.label.EventTracker' /></SPAN></TD>
                    <TD VALIGN="TOP"><INPUT TYPE="text" name="eventTracker" VALUE="<%=eventTracker %>" Size="40"</TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><a href="javascript:errorWindow = window.open('/console/common/nondynamic.jsp', '_blank','resizable=yes,scrollbars=yes,menubar=no,toolbar=no,width=600,height=175'); errorWindow.focus();"><img border='0' src='/console/images/nondynamic.gif' title="<%=nonDynamic %>"></a><A HREF="p13nConsoleHelp.jsp?topic=adConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD VALIGN="TOP"><SPAN Class="dialog-label"><wlcx:text textid='adService.label.AdClickThruURI' /></SPAN></TD>
                    <TD VALIGN="TOP"><INPUT type="text" name="adClickThruURI" VALUE="<%=adClickThruURI %>" Size="40"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><a href="javascript:errorWindow = window.open('/console/common/nondynamic.jsp', '_blank','resizable=yes,scrollbars=yes,menubar=no,toolbar=no,width=600,height=175'); errorWindow.focus();"><img border='0' src='/console/images/nondynamic.gif' title="<%=nonDynamic %>"></a><A HREF="p13nConsoleHelp.jsp?topic=adConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD VALIGN="TOP" NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='adService.label.ShowDocURI' /></SPAN></TD>
                    <TD VALIGN="TOP"><INPUT type="text" name="showDocURI" VALUE="<%=showDocURI %>" Size="40"></TD>
                </TR>
                <TR>
                    <TD COLSPAN="3" ALIGN="RIGHT">
                        <INPUT Name="isSubmitted" TYPE="HIDDEN" VALUE="subitForm">
                        <INPUT TYPE="Submit" VALUE="<wlcx:text textid='default.label.Submit' />">
                    </TD>
                </TR>
            </TABLE>
        </FORM>
    </wlcx:tab>
    <wlcx:tab name='tab2' labelid='adService.label.tab2'>
<%
        Set providerMBeans = ApplicationHelper.queryChildServiceConfigurationMBeans( "AdContentProvider", mBean );
        Iterator i = providerMBeans.iterator();
        while (i.hasNext())
        {
            AdContentProviderMBean myBean = (AdContentProviderMBean) i.next();
            String providerName = myBean.getName();
            String contentProvider = myBean.getProvider();
            Properties properties = myBean.getProperties();
            
            PropertiesHelper ph = new PropertiesHelper();
            ph.setProperties(properties);
            ph.Properties2String();
            String propertiesString = ph.getPropertiesString();
%>
            <wlcx:tab name='<%=providerName %>' label='<%=providerName %>'>
                <FORM ACTION="adConsole.jsp<%=appURL %>&tab=tab2.<%=providerName %>" METHOD="POST">
                <TABLE WIDTH='100%' CELLSPACING='10' BORDER='0'>
                    <TR>
                        <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=adConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                        <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='adService.label.ContentProvider' /></SPAN></TD>
                        <TD WIDTH="100%"><INPUT type="text" Name="contentProvider" VALUE="<%=contentProvider %>" Size="40"></TD>
                    </TR>
                    <TR>
                        <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=adConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                        <TD VALIGN="TOP"><SPAN Class="dialog-label"><wlcx:text textid='adService.label.Properties' /></SPAN><br><wlcx:text textid='adService.label.PropertiesHelp' /></TD>
                        <TD>
                            <TEXTAREA name="properties" ROWS="4" COLS="40"><%=propertiesString %></TEXTAREA>
                        </TD>
                    </TR>
                    <TR>
                        <TD COLSPAN="3" ALIGN="RIGHT">
                            <INPUT Name="provider" TYPE="HIDDEN" VALUE="<%=providerName %>">
                            <INPUT Name="isProviderSubmitted" TYPE="HIDDEN" VALUE="subitForm">
                            <INPUT TYPE="Submit" VALUE="<wlcx:text textid='default.label.Submit' />">
                        </TD>
                    </TR>
                </TABLE>
                </FORM>
            </wlcx:tab>          
<%
        }
%>
    </wlcx:tab>
</wlcx:dialog>
</DIV>
<%@ include file="includes/statusMsg.inc" %>
</BODY>
</HTML>
