<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<%@ taglib uri='extension_taglib.tld' prefix='wlcx' %>
<%@ taglib uri="weblogic-tags.tld" prefix="wl" %>
<%@ page import="com.bea.p13n.mbeans.*" %>
<%@ page import="com.bea.p13n.management.*" %>
<%@ page import="weblogic.management.configuration.ApplicationConfigurationMBean" %>
<%@ page import='weblogic.management.console.extensibility.Catalog' %>
<%@ page errorPage="error.jsp" %>

<%@ include file="includes/applicationName.inc" %>

<%
Catalog catalog = Catalog.Factory.getCatalog(pageContext);
String CRLF = System.getProperty("line.separator");
Vector statusMsg = new Vector();
BehaviorTrackingMBean mBean = (BehaviorTrackingMBean) ApplicationHelper.getServiceConfigurationAdminMBean( "BehaviorTracking", null, appName );
%>

<wl:process name='isSubmitted'>
<%
    String newDataSourceJndiName = request.getParameter("dataSourceJndiName");
    String newMaxBufferSize = request.getParameter("maxBufferSize");
    String newSweepInterval = request.getParameter("sweepInterval");
    String newSweepMaxTime = request.getParameter("sweepMaxTime");
    String newPersistedEventTypesStr = request.getParameter("persistedEventTypes");
    Integer iMaxBufferSize = null;
    Integer iSweepInterval = null;
    Integer iSweepMaxTime = null;
    StringTokenizer toker = new StringTokenizer(newPersistedEventTypesStr, CRLF);
    String[] newPersistedEventTypes = new String[toker.countTokens()];
    int index = 0;
    while (toker.hasMoreTokens())
    {
        newPersistedEventTypes[index++] = toker.nextToken().trim();
    }
    if (newDataSourceJndiName == null || newDataSourceJndiName.length() == 0)
    {
        statusMsg.addElement(catalog.getText("behaviorService.msg.InvalidDataSourceJndiName"));
    }
    try
    {
        iMaxBufferSize = new Integer(newMaxBufferSize);
    }
    catch (NumberFormatException e)
    {
        statusMsg.addElement(catalog.getText("behaviorService.msg.InvalidMaxBufferSize"));
    }
    try
    {
        iSweepInterval = new Integer(newSweepInterval);
    }
    catch (NumberFormatException e)
    {
        statusMsg.addElement(catalog.getText("behaviorService.msg.InvalidSweepInterval"));
    }
    try
    {
        iSweepMaxTime = new Integer(newSweepMaxTime);
    }
    catch (NumberFormatException e)
    {
        statusMsg.addElement(catalog.getText("behaviorService.msg.InvalidSweepMaxTime"));
    }
    if (statusMsg.size() == 0) 
    {
        // Save off current good values.
        String dataSourceJndiName = mBean.getDataSourceJndiName();
        int maxBufferSize = mBean.getMaxBufferSize();
        int sweepInterval = mBean.getSweepInterval();
        int sweepMaxTime = mBean.getSweepMaxTime();
        String[] persistedEventTypes = mBean.getPersistedEventTypes();
        try
        {
            mBean.setDataSourceJndiName(newDataSourceJndiName);
            mBean.setMaxBufferSize(iMaxBufferSize.intValue());
            mBean.setSweepInterval(iSweepInterval.intValue());
            mBean.setSweepMaxTime(iSweepMaxTime.intValue());
            mBean.setPersistedEventTypes(newPersistedEventTypes);
        }
        catch (java.lang.reflect.UndeclaredThrowableException e)
        {
            Throwable ee = e.getUndeclaredThrowable();
            if (ee instanceof javax.management.InvalidAttributeValueException)
            {
                statusMsg.addElement(ee.getLocalizedMessage());
            }
        }
        if (statusMsg.size() == 0) 
        {
            ApplicationConfigurationMBean appConfigMBean = (ApplicationConfigurationMBean) ApplicationHelper.getApplicationConfigurationAdminMBean( appName );
            appConfigMBean.persist();
            statusMsg.addElement(catalog.getText("default.msg.Success"));
        }
        else
        {
            // Restore last known good values.
            mBean.setDataSourceJndiName(dataSourceJndiName);
            mBean.setMaxBufferSize(maxBufferSize);
            mBean.setSweepInterval(sweepInterval);
            mBean.setSweepMaxTime(sweepMaxTime);
            mBean.setPersistedEventTypes(persistedEventTypes);
        }
    }
%>
</wl:process>

<%
String dataSourceJndiName = mBean.getDataSourceJndiName();
int maxBufferSize = mBean.getMaxBufferSize();
int sweepInterval = mBean.getSweepInterval();
int sweepMaxTime = mBean.getSweepMaxTime();
String[] persistedEventTypes = mBean.getPersistedEventTypes();
String persistedEventTypesStr = "";
for (int i = 0; i < persistedEventTypes.length; i++) 
{
    persistedEventTypesStr = persistedEventTypesStr + persistedEventTypes[i] + CRLF;
}
String helpRollover = catalog.getText("help.rollover");
String pageHeader = catalog.getText("behaviorService.label.PageHeader");
%>

<HTML>
<HEAD>
    <%@ include file="includes/Meta.inc" %>
    <wlcx:stylesheet/> 
</HEAD>

<BODY>
<%@ include file="includes/pageHeader.inc" %>
<DIV class='content'>
<BR><BR><BR>
<wlcx:dialog>
    <wlcx:tab name='tab1' labelid='behaviorService.label.tab1'>
        <FORM ACTION="behaviorConsole.jsp<%=appURL %>" METHOD="POST">
            <TABLE WIDTH='100%' CELLSPACING='10' BORDER='0'>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=behaviorConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='behaviorService.label.DataSourceJndiName' /></SPAN></TD>
                    <TD WIDTH='100%' ><INPUT Name="dataSourceJndiName" Type="Text" SIZE="40" VALUE="<%=dataSourceJndiName %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=behaviorConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD><SPAN Class="dialog-label"><wlcx:text textid='behaviorService.label.MaxBufferSize' /></SPAN></TD>
                    <TD><INPUT NAME="maxBufferSize" Type="Text" SIZE="3" VALUE="<%=maxBufferSize %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=behaviorConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD><SPAN Class="dialog-label"><wlcx:text textid='behaviorService.label.SweepInterval' /></SPAN></TD>
                    <TD><INPUT NAME="sweepInterval" Type="Text" SIZE="3" VALUE="<%=sweepInterval %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=behaviorConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD><SPAN Class="dialog-label"><wlcx:text textid='behaviorService.label.SweepMaxTime' /></SPAN></TD>
                    <TD><INPUT NAME="sweepMaxTime" Type="Text" SIZE="3" VALUE="<%=sweepMaxTime %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=behaviorConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD VALIGN="TOP"><SPAN Class="dialog-label"><wlcx:text textid='behaviorService.label.PersistedEventTypes' /></SPAN></TD>
                    <TD><TEXTAREA NAME="persistedEventTypes" ROWS="4" COLS="40"><%=persistedEventTypesStr %></TEXTAREA></TD>
                </TR>
                <TR>
                    <TD COLSPAN="3" ALIGN="RIGHT">
                        <INPUT Name="isSubmitted" TYPE="HIDDEN" VALUE="SubitForm">
                        <INPUT TYPE="Submit" VALUE="<%=catalog.getText("default.label.Submit")%>">
                    </TD>
                </TR>
            </TABLE>
        </FORM>
    </wlcx:tab>
</wlcx:dialog>
</DIV>
<%@ include file="includes/statusMsg.inc" %>
</BODY>
</HTML>
