<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<%@ taglib uri='extension_taglib.tld' prefix='wlcx' %>
<%@ taglib uri="weblogic-tags.tld" prefix="wl" %>

<%@ page import="com.bea.campaign.mbeans.*" %>
<%@ page import="com.bea.p13n.management.*" %>
<%@ page import="weblogic.management.configuration.ApplicationConfigurationMBean" %>
<%@ page import='weblogic.management.console.extensibility.Catalog' %>
<%@ page errorPage="error.jsp" %>

<%@ include file="includes/applicationName.inc" %>
<%
Vector statusMsg = new Vector();
Catalog catalog = Catalog.Factory.getCatalog(pageContext);
CampaignServiceMBean mBean = (CampaignServiceMBean) ApplicationHelper.getServiceConfigurationAdminMBean( "CampaignService", null, appName );
MailActionMBean actionMBean = null;
CampaignEventListenerMBean eventMBean = null;
String CRLF = System.getProperty("line.separator");
String helpRollover = catalog.getText("help.rollover");
String pageHeader = catalog.getText("campaignService.label.PageHeader");
%>

<wl:process name='tab' value='tab2'>
<%
    actionMBean = (MailActionMBean) ApplicationHelper.getChildServiceConfigurationMBean( "MailAction", mBean);
%>
</wl:process>

<wl:process name='tab' value='tab3'>
<%
    eventMBean = (CampaignEventListenerMBean) ApplicationHelper.getChildServiceConfigurationMBean( "CampaignEventListener", mBean);
%>
</wl:process>

<wl:process name='isCampaignSubmitted'>
<%
    String newGoalCheckTime = request.getParameter("goalCheckTime");
    String newEmailBrowseBaseDir = request.getParameter("emailBrowseBaseDir");
    String newEmailURIExtensionsStr = request.getParameter("emailURIExtensions");
    Long iGoalCheckTime = null;
    try
    {
        iGoalCheckTime = new Long(newGoalCheckTime);
    }
    catch (NumberFormatException e)
    {
        statusMsg.addElement(catalog.getText("campaignService.msg.InvalidGoalCheckTime"));
    }
    if (statusMsg.size() == 0)
    {
        StringTokenizer toker = new StringTokenizer(newEmailURIExtensionsStr, CRLF);
        String[] newEmailURIExtensions = new String[toker.countTokens()];
        int index = 0;
        String attr = null;
        while (toker.hasMoreTokens())
        {
            newEmailURIExtensions[index++] = toker.nextToken().trim();
        }

        // Save off current good values.
        long goalCheckTime = mBean.getGoalCheckTime();
        String emailBrowseBaseDir = mBean.getEmailBrowseBaseDir();
        String[] emailURIExtensions = mBean.getEmailURIExtensions();

        try
        {
            mBean.setGoalCheckTime(iGoalCheckTime.longValue());
            mBean.setEmailBrowseBaseDir(newEmailBrowseBaseDir);
            mBean.setEmailURIExtensions(newEmailURIExtensions);
        }
        catch (java.lang.reflect.UndeclaredThrowableException e)
        {
            Throwable ee = e.getUndeclaredThrowable();
            if (ee instanceof javax.management.InvalidAttributeValueException)
            {
                statusMsg.addElement(ee.getLocalizedMessage());
            }
        }
        if (statusMsg.size() == 0) 
        {
            ApplicationConfigurationMBean appConfigMBean = (ApplicationConfigurationMBean) ApplicationHelper.getApplicationConfigurationAdminMBean(appName);
            appConfigMBean.persist();
            statusMsg.addElement(catalog.getText("default.msg.Success"));
        }
        else
        {
            // Restore last known good values.
            mBean.setGoalCheckTime(goalCheckTime);
            mBean.setEmailBrowseBaseDir(emailBrowseBaseDir);
            mBean.setEmailURIExtensions(emailURIExtensions);

        }
    }
%>
</wl:process>

<wl:process name='isEventSubmitted'>
<%
    String newCampaignServiceJNDIName = request.getParameter("campaignServiceJNDIName");
    if (statusMsg.size() == 0)
    {
        // Save off current good values.
        String campaignServiceJNDIName = eventMBean.getCampaignServiceJNDIName();

        try
        {
            eventMBean.setCampaignServiceJNDIName(newCampaignServiceJNDIName);
        }
        catch (java.lang.reflect.UndeclaredThrowableException e)
        {
            Throwable ee = e.getUndeclaredThrowable();
            if (ee instanceof javax.management.InvalidAttributeValueException)
           {
                statusMsg.addElement(ee.getLocalizedMessage());
            }
        }
        if (statusMsg.size() == 0) 
        {
            ApplicationConfigurationMBean appConfigMBean = (ApplicationConfigurationMBean) ApplicationHelper.getApplicationConfigurationAdminMBean( appName );
            appConfigMBean.persist();
            statusMsg.addElement(catalog.getText("default.msg.Success"));
        }
        else
        {
            // Restore last known good values.
            eventMBean.setCampaignServiceJNDIName(campaignServiceJNDIName);

        }
    }
%>
</wl:process>

<wl:process name='isActionSubmitted'>
<%
    String newDefaultFromAddress = request.getParameter("defaultFromAddress");
    String newEmailPropertyName = request.getParameter("emailPropertyName");
    String newEmailPropertySet = request.getParameter("emailPropertySet");
    String newOptInPropertyName = request.getParameter("optInPropertyName");
    String newOptInPropertySet = request.getParameter("optInPropertySet");
    if (statusMsg.size() == 0)
    {
        // Save off current good values.
        String defaultFromAddress = actionMBean.getDefaultFromAddress();
        String emailPropertyName = actionMBean.getEmailPropertyName();
        String emailPropertySet = actionMBean.getEmailPropertySet();
        String optInPropertyName = actionMBean.getOptInPropertyName();
        String optInPropertySet = actionMBean.getOptInPropertySet();

        try
        {
            actionMBean.setDefaultFromAddress(newDefaultFromAddress);
            actionMBean.setEmailPropertyName(newEmailPropertyName);
            actionMBean.setEmailPropertySet(newEmailPropertySet);
            actionMBean.setOptInPropertyName(newOptInPropertyName);
            actionMBean.setOptInPropertySet(newOptInPropertySet);
        }
        catch (java.lang.reflect.UndeclaredThrowableException e)
        {
            Throwable ee = e.getUndeclaredThrowable();
            if (ee instanceof javax.management.InvalidAttributeValueException)
            {
                statusMsg.addElement(ee.getLocalizedMessage());
            }
        }
        if (statusMsg.size() == 0) 
        {
            ApplicationConfigurationMBean appConfigMBean = (ApplicationConfigurationMBean) ApplicationHelper.getApplicationConfigurationAdminMBean( appName );
            appConfigMBean.persist();
            statusMsg.addElement(catalog.getText("default.msg.Success"));
        }
        else
        {
            // Restore last known good values.
            actionMBean.setDefaultFromAddress(defaultFromAddress);
            actionMBean.setEmailPropertyName(emailPropertyName);
            actionMBean.setEmailPropertySet(emailPropertySet);
            actionMBean.setOptInPropertyName(optInPropertyName);
            actionMBean.setOptInPropertySet(optInPropertySet);
        }
    }
%>
</wl:process>

<HTML>
<HEAD>
    <%@ include file="includes/Meta.inc" %>
    <wlcx:stylesheet/> 
</HEAD>

<BODY>
<%@ include file="includes/pageHeader.inc" %>
<DIV class='content'>
<BR><BR><BR>
<wlcx:dialog>
    <wlcx:tab name='tab1' labelid='campaignService.label.tab1'>
<%
        long goalCheckTime = mBean.getGoalCheckTime();
        String emailBrowseBaseDir = mBean.getEmailBrowseBaseDir();
        String[] emailURIExtensions = mBean.getEmailURIExtensions();
        String emailURIExtensionsStr = "";
        for (int i = 0; i < emailURIExtensions.length; i++) 
        {
            emailURIExtensionsStr = emailURIExtensionsStr + emailURIExtensions[i] + CRLF;
        }
%>
        <FORM ACTION="campaignConsole.jsp<%=appURL %>" METHOD="POST">
            <TABLE WIDTH='100%' CELLSPACING='10' BORDER='0'>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=campaignConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD ALIGN="LEFT" NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='campaignService.label.GoalCheckTime' /></SPAN></TD>
                    <TD ALIGN="LEFT" WIDTH="100%"><INPUT TYPE="text" name="goalCheckTime" VALUE="<%=goalCheckTime %>" Size="6" Maxlength="10"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=campaignConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD><SPAN Class="dialog-label"><wlcx:text textid='campaignService.label.EmailBrowseBaseDir' /></SPAN></TD>
                    <TD><INPUT TYPE="text" name="emailBrowseBaseDir" VALUE="<%=emailBrowseBaseDir %>" Size="40"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=campaignConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD VALIGN="TOP"><SPAN Class="dialog-label"><wlcx:text textid='campaignService.label.EmailURIExtensions' /></SPAN></TD>
                    <TD VALIGN="TOP"><TEXTAREA name="emailURIExtensions" ROWS="4" COLS="20"><%=emailURIExtensionsStr %></TEXTAREA></TD>
                </TR>
                <TR>
                    <TD COLSPAN="3" ALIGN="RIGHT">
                        <INPUT Name="isCampaignSubmitted" TYPE="HIDDEN" VALUE="subitForm">
                        <INPUT TYPE="Submit" VALUE="<wlcx:text textid='default.label.Submit' />">
                    </TD>
                </TR>
            </TABLE>
        </FORM>
    </wlcx:tab>
    <wlcx:tab name='tab2' labelid='campaignService.label.tab2'>
<%
        String defaultFromAddress = actionMBean.getDefaultFromAddress();
        String emailPropertyName = actionMBean.getEmailPropertyName();
        String emailPropertySet = actionMBean.getEmailPropertySet();
        String optInPropertyName = actionMBean.getOptInPropertyName();
        String optInPropertySet = actionMBean.getOptInPropertySet();
%>
        <FORM ACTION="campaignConsole.jsp<%=appURL %>&tab=tab2" METHOD="POST">
            <TABLE WIDTH='100%' CELLSPACING='10' BORDER='0'>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=campaignConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD VALIGN="TOP" NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='campaignService.label.DefaultFromAddress' /></SPAN></TD>
                    <TD WIDTH="100%" VALIGN="TOP"><INPUT type="text" Name="defaultFromAddress" VALUE="<%=defaultFromAddress %>" Size="40"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=campaignConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD VALIGN="TOP" NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='campaignService.label.EmailPropertyName' /></SPAN></TD>
                    <TD WIDTH="100%" VALIGN="TOP"><INPUT type="text" Name="emailPropertyName" VALUE="<%=emailPropertyName %>" Size="40"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=campaignConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD VALIGN="TOP"><SPAN Class="dialog-label"><wlcx:text textid='campaignService.label.EmailPropertySet' /></SPAN></TD>
                    <TD WIDTH="100%" VALIGN="TOP"><INPUT type="text" Name="emailPropertySet" VALUE="<%=emailPropertySet %>" Size="40"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=campaignConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD VALIGN="TOP"><SPAN Class="dialog-label"><wlcx:text textid='campaignService.label.OptInPropertyName' /></SPAN></TD>
                    <TD WIDTH="100%" VALIGN="TOP"><INPUT type="text" Name="optInPropertyName" VALUE="<%=optInPropertyName %>" Size="40"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=campaignConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD VALIGN="TOP"><SPAN Class="dialog-label"><wlcx:text textid='campaignService.label.OptInPropertySet' /></SPAN></TD>
                    <TD WIDTH="100%" VALIGN="TOP"><INPUT type="text" Name="optInPropertySet" VALUE="<%=optInPropertySet %>" Size="40"></TD>
                </TR>
                <TR>
                    <TD COLSPAN="3" ALIGN="RIGHT">
                        <INPUT Name="isActionSubmitted" TYPE="HIDDEN" VALUE="subitForm">
                        <INPUT TYPE="Submit" VALUE="<wlcx:text textid='default.label.Submit' />">
                    </TD>
                </TR>
            </TABLE>
        </FORM>
    </wlcx:tab>          
    <wlcx:tab name='tab3' labelid='campaignService.label.tab3'>
<%
        String campaignServiceJNDIName = eventMBean.getCampaignServiceJNDIName();
%>
        <FORM ACTION="campaignConsole.jsp<%=appURL %>&tab=tab3" METHOD="POST">
            <TABLE WIDTH='100%' CELLSPACING='10' BORDER='0'>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=campaignConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='campaignService.label.CampaignServiceJNDIName' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT type="text" Name="campaignServiceJNDIName" VALUE="<%=campaignServiceJNDIName %>" Size="40"></TD>
                </TR>
                <TR>
                    <TD COLSPAN="3" ALIGN="RIGHT">
                        <INPUT Name="isEventSubmitted" TYPE="HIDDEN" VALUE="subitForm">
                        <INPUT TYPE="Submit" VALUE="<wlcx:text textid='default.label.Submit' />">
                    </TD>
                </TR>
            </TABLE>
        </FORM>
    </wlcx:tab>          
</wlcx:dialog>
</DIV>
<%@ include file="includes/statusMsg.inc" %>
</BODY>
</HTML>
