<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<%@ taglib uri='extension_taglib.tld' prefix='wlcx' %>
<%@ taglib uri="weblogic-tags.tld" prefix="wl" %>

<%@ page import="com.bea.p13n.mbeans.*" %>
<%@ page import='com.bea.p13n.cache.Cache' %>
<%@ page import='com.bea.p13n.cache.CacheFactory' %>
<%@ page import="com.bea.p13n.management.*" %>
<%@ page import='com.bea.console.extensions.ConsoleMBeanAdminHelper' %>
<%@ page import='com.bea.console.extensions.DeploymentManager' %>
<%@ page import="weblogic.management.configuration.ApplicationConfigurationMBean" %>
<%@ page import='weblogic.management.console.extensibility.Catalog' %>
<%@ page import='weblogic.management.info.ExtendedAttributeInfo' %>
<%@ page errorPage="error.jsp" %>

<%@ include file="includes/applicationName.inc" %>
<%
String cacheName = request.getParameter("cache");
Vector statusMsg = new Vector();
Catalog catalog = Catalog.Factory.getCatalog(pageContext);
long hitCount = 0;
long missCount = 0;
int hitRate = 0;
%>

<wl:process name='isSubmitted'>
<%
    String newName = request.getParameter("newCacheName");
    String newEnabled = request.getParameter( "enabled" );
    String newTimeToLive = request.getParameter( "timeToLive" );
    String newMaxEntries = request.getParameter( "maxEntries");
    boolean bNewEnabled = (newEnabled != null);
    Long iTimeToLive = null;
    Integer iMaxEntries = null;

    try
    {
        iTimeToLive = new Long(newTimeToLive);
    }
    catch (NumberFormatException e)
    {
        statusMsg.addElement(catalog.getText("cacheService.msg.InvalidTTL"));
    }
    try
    {
        iMaxEntries = new Integer(newMaxEntries);
    }
    catch (NumberFormatException e)
    {
        statusMsg.addElement(catalog.getText("cacheService.msg.InvalidMaxEntries"));
    }
    if (statusMsg.size() == 0)
    {
        try
        {
            ConsoleMBeanAdminHelper adminHelper = 
                DeploymentManager.getInstance().getAdminHelper(appName);
            CacheMBean mBean = (CacheMBean) 
                adminHelper.createChildServiceConfigMBean("CacheManager", "CacheManager",
                                                          "Cache", newName);
            mBean.setName(newName);
            mBean.setEnabled(bNewEnabled);
            mBean.setTimeToLive(iTimeToLive.longValue());
            mBean.setMaxEntries(iMaxEntries.intValue());
        }
        catch (java.lang.reflect.UndeclaredThrowableException e)
        {
            Throwable ee = e.getUndeclaredThrowable();
            if (ee instanceof javax.management.InvalidAttributeValueException)
            {
                statusMsg.addElement(ee.getLocalizedMessage());
            }
        }
        if (statusMsg.size() == 0)
        {
            ApplicationConfigurationMBean appConfigMBean = 
                (ApplicationConfigurationMBean) ApplicationHelper.getApplicationConfigurationAdminMBean( appName );
            appConfigMBean.persist();
            statusMsg.addElement(catalog.getText("cacheService.msg.Success"));
        }
        else
        {
            statusMsg.addElement(catalog.getText("cacheService.msg.FailedCreate"));    
        }

        // Update deployed MBeans
        DeploymentManager.getInstance().updateDeployedMBeans(appName);
%>
        <!-- Ask the nav tree to update itself -->
        <jsp:include page='reloadnav.jsp' />
<%
    }
%>
    
</wl:process>

<%
int maxEntries = 100;
long timeToLive = 3600000;
boolean enabled = true;
String cacheDisplayName = catalog.getText("cacheService.label.NewCache");
String helpRollover = catalog.getText("help.rollover");
String pageHeader = catalog.getText("cacheService.label.PageHeader");
%>

<HTML>
<HEAD>
    <%@ include file="includes/Meta.inc" %>
    <wlcx:stylesheet/> 
</HEAD>

<BODY>
<%@ include file="includes/pageHeader.inc" %>
<DIV class='content'>
<BR><BR><BR>
<wlcx:dialog>
    <wlcx:tab name='main' label='<%=cacheDisplayName %>'>
    <wlcx:tab name='tab1' labelid='cacheService.label.tab1'>
        <FORM ACTION="createCacheConsole.jsp<%=appURL %>&cache=<%=cacheDisplayName %>" METHOD="POST">
            <TABLE WIDTH='100%' CELLSPACING='10' BORDER='0'>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=cacheConsoleConfig.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='cacheService.label.CacheName' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT Name="newCacheName" Type="Text" SIZE="30" VALUE="MyNewCache"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=cacheConsoleConfig.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='cacheService.label.Enabled' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT Name="enabled" Type="Checkbox" <% if(enabled) {%>CHECKED<%}%>></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=cacheConsoleConfig.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='cacheService.label.TTL' /></SPAN></TD>
                    <TD><INPUT Name="timeToLive" Type="Text" SIZE="6" VALUE="<%=timeToLive %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=cacheConsoleConfig.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='cacheService.label.MaxEntries' /></SPAN></TD>
                    <TD><INPUT Name="maxEntries" Type="Text" SIZE="6" VALUE="<%=maxEntries %>"></TD>
                </TR>
                <TR>
                    <TD COLSPAN="3" ALIGN="RIGHT">
                        <INPUT Name="isSubmitted" TYPE="HIDDEN" VALUE="subitForm">
                        <INPUT TYPE="Submit" VALUE="<wlcx:text textid='cacheService.label.SubmitConfig' />">
                    </TD>
                </TR>
            </TABLE>
        </FORM>
    </wlcx:tab>
    <wlcx:tab name='tab2' labelid='cacheService.label.tab2'>
        <FORM ACTION="cacheConsole.jsp<%=appURL %>&cache=<%=cacheName %>&tab=main.tab2" METHOD="POST">
            <TABLE WIDTH='100%' CELLSPACING='10' BORDER='0'>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=cacheConsoleAdmin.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='cacheService.label.Flush' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT Name="flushAll" Type="Checkbox"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=cacheConsoleAdmin.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='cacheService.label.Key' /></SPAN></TD>
                    <TD NOWRAP><INPUT Name="key" Type="Text" SIZE="20" VALUE=""></TD>
                </TR>
                <TR>
                    <TD COLSPAN="3" ALIGN="RIGHT">
                        <INPUT Name="flush" TYPE="HIDDEN" VALUE="flush">
                        <INPUT TYPE="Submit" VALUE="<wlcx:text textid='cacheService.label.SubmitFlush' />">
                    </TD>
                </TR>
            </TABLE>
        </FORM>
    </wlcx:tab> 

    </wlcx:tab>
</wlcx:dialog>
</DIV>
<%@ include file="includes/statusMsg.inc" %>
</BODY>
</HTML>
