<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<%@ taglib uri='extension_taglib.tld' prefix='wlcx' %>
<%@ taglib uri="weblogic-tags.tld" prefix="wl" %>

<%@ page import="com.bea.p13n.mbeans.*" %>
<%@ page import="com.bea.p13n.management.*" %>
<%@ page import="weblogic.management.configuration.ApplicationConfigurationMBean" %>
<%@ page import='weblogic.management.console.extensibility.Catalog' %>
<%@ page errorPage="error.jsp" %>

<%@ include file="includes/applicationName.inc" %>

<%
Catalog catalog = Catalog.Factory.getCatalog(pageContext);
Vector statusMsg = new Vector();
DocumentManagerMBean mBean = (DocumentManagerMBean) ApplicationHelper.getServiceConfigurationAdminMBean( "DocumentManager", null, appName );
%>

<wl:process name='isSubmitted'>
<%
    String newDocumentConnectionPoolName = request.getParameter("documentConnectionPoolName");
    String newPropertyCase = request.getParameter("propertyCase");
    String newMetadataCaching = request.getParameter("metadataCaching");
    String newMetadataCacheName = request.getParameter("metadataCacheName");
    String newUserIdInCacheKey = request.getParameter("userIdInCacheKey");
    String newContentCaching = request.getParameter("contentCaching");
    String newContentCacheName = request.getParameter("contentCacheName");
    String newMaxCachedContentSize = request.getParameter("maxCachedContentSize");
    boolean bMetadataCaching = (newMetadataCaching != null);
    boolean bUserIdInCacheKey = (newUserIdInCacheKey != null);
    boolean bContentCaching = (newContentCaching != null);
    Integer iMaxCachedContentSize = null;
    try
    {
        iMaxCachedContentSize = new Integer(newMaxCachedContentSize);
    }
    catch (NumberFormatException e)
    {
        statusMsg.addElement(catalog.getText("documentService.msg.InvalidMaxCachedContentSize"));
    }
    if (statusMsg.size() == 0) 
    {
        // Save off current good values.
        String documentConnectionPoolName = mBean.getDocumentConnectionPoolName();
        String propertyCase = mBean.getPropertyCase();
        boolean metadataCaching = mBean.isMetadataCaching();
        String metadataCacheName = mBean.getMetadataCacheName();
        boolean userIdInCacheKey = mBean.isUserIdInCacheKey();
        boolean contentCaching = mBean.isContentCaching();
        String contentCacheName = mBean.getContentCacheName();
        int maxCachedContentSize = mBean.getMaxCachedContentSize();

        try
        {
            mBean.setDocumentConnectionPoolName(newDocumentConnectionPoolName);
            mBean.setPropertyCase(newPropertyCase);
            mBean.setMetadataCaching(bMetadataCaching);
            mBean.setMetadataCacheName(newMetadataCacheName);
            mBean.setUserIdInCacheKey(bUserIdInCacheKey);
            mBean.setContentCaching(bContentCaching);
            mBean.setContentCacheName(newContentCacheName);
            mBean.setMaxCachedContentSize(iMaxCachedContentSize.intValue());
        }
        catch (java.lang.reflect.UndeclaredThrowableException e)
        {
            Throwable ee = e.getUndeclaredThrowable();
            if (ee instanceof javax.management.InvalidAttributeValueException)
            {
                statusMsg.addElement(ee.getLocalizedMessage());
            }
        }
        if (statusMsg.size() == 0) 
        {
            ApplicationConfigurationMBean appConfigMBean = (ApplicationConfigurationMBean) ApplicationHelper.getApplicationConfigurationAdminMBean(appName);
            appConfigMBean.persist();
            statusMsg.addElement(catalog.getText("default.msg.Success"));
        }
        else
        {
            // Restore last known good values.
            mBean.setDocumentConnectionPoolName(documentConnectionPoolName);
            mBean.setPropertyCase(propertyCase);
            mBean.setMetadataCaching(metadataCaching);
            mBean.setMetadataCacheName(metadataCacheName);
            mBean.setUserIdInCacheKey(userIdInCacheKey);
            mBean.setContentCaching(contentCaching);
            mBean.setContentCacheName(contentCacheName);
            mBean.setMaxCachedContentSize(maxCachedContentSize);
        }
    }
%>
</wl:process>

<%
String documentConnectionPoolName = mBean.getDocumentConnectionPoolName();
String propertyCase = mBean.getPropertyCase();
boolean metadataCaching = mBean.isMetadataCaching();
String metadataCacheName = mBean.getMetadataCacheName();
boolean userIdInCacheKey = mBean.isUserIdInCacheKey();
boolean contentCaching = mBean.isContentCaching();
String contentCacheName = mBean.getContentCacheName();
int maxCachedContentSize = mBean.getMaxCachedContentSize();
String helpRollover = catalog.getText("help.rollover");
String pageHeader = catalog.getText("documentService.label.PageHeader");
%>

<HTML>
<HEAD>
    <%@ include file="includes/Meta.inc" %>
    <wlcx:stylesheet/> 
</HEAD>

<BODY>
<%@ include file="includes/pageHeader.inc" %>
<DIV class='content'>
<BR><BR><BR>
<wlcx:dialog>
    <wlcx:tab name='tab1' labelid='entitlementsService.label.tab1'>
        <FORM ACTION="documentConsole.jsp<%=appURL %>" METHOD="POST">
            <TABLE WIDTH='100%' CELLSPACING='10' BORDER='0'>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=documentConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='documentService.label.DocumentConnectionPoolName' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT Name="documentConnectionPoolName" Type="Text" SIZE="40" VALUE="<%=documentConnectionPoolName %>">
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=documentConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD><SPAN Class="dialog-label"><wlcx:text textid='documentService.label.PropertyCase' /></SPAN></TD>
                    <TD>
                        <SELECT Name="propertyCase"> 
                            <OPTION VALUE="none" <% if (propertyCase == null || propertyCase.compareTo("none") == 0) { %>SELECTED<% } %>><wlcx:text textid='documentService.label.CaseNone' />
                            <OPTION VALUE="upper" <% if (propertyCase != null && propertyCase.compareTo("upper") == 0) { %>SELECTED<% } %>><wlcx:text textid='documentService.label.CaseUpper' />
                            <OPTION VALUE="lower" <% if (propertyCase != null && propertyCase.compareTo("lower") == 0 ) { %>SELECTED<% } %>><wlcx:text textid='documentService.label.CaseLower' />
                        </SELECT>
                    </TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=documentConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD><SPAN Class="dialog-label"><wlcx:text textid='documentService.label.MetadataCaching' /></SPAN></TD>
                    <TD><INPUT Name="metadataCaching" Type="Checkbox" <% if(metadataCaching) {%>CHECKED<%}%>></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=documentConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD><SPAN Class="dialog-label"><wlcx:text textid='documentService.label.MetadataCacheName' /></SPAN></TD>
                    <TD><INPUT Name="metadataCacheName" Type="Text" SIZE="40" VALUE="<%=metadataCacheName %>">
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=documentConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD><SPAN Class="dialog-label"><wlcx:text textid='documentService.label.UserIdInCacheKey' /></SPAN></TD>
                    <TD><INPUT Name="userIdInCacheKey" Type="Checkbox" <% if(userIdInCacheKey) {%>CHECKED<%}%>></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=documentConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD><SPAN Class="dialog-label"><wlcx:text textid='documentService.label.ContentCaching' /></SPAN></TD>
                    <TD><INPUT Name="contentCaching" Type="Checkbox" <% if(contentCaching) {%>CHECKED<%}%>></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=documentConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD><SPAN Class="dialog-label"><wlcx:text textid='documentService.label.ContentCacheName' /></SPAN></TD>
                    <TD><INPUT Name="contentCacheName" Type="Text" SIZE="40" VALUE="<%=contentCacheName %>">
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=documentConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD><SPAN Class="dialog-label"><wlcx:text textid='documentService.label.MaxCachedContentSize' /></SPAN></TD>
                    <TD><INPUT Name="maxCachedContentSize" Type="Text" SIZE="6" VALUE="<%=maxCachedContentSize %>">
                </TR>
                <TR>
                    <TD COLSPAN="3" ALIGN="RIGHT">
                        <INPUT Name="isSubmitted" TYPE="HIDDEN" VALUE="SubitForm">
                        <INPUT TYPE="Submit" VALUE="<%=catalog.getText("default.label.Submit")%>">
                    </TD>
                </TR>
            </TABLE>
        </FORM>
    </wlcx:tab>
</wlcx:dialog>
</DIV>
<%@ include file="includes/statusMsg.inc" %>
</BODY>
</HTML>
