<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<%@ taglib uri='extension_taglib.tld' prefix='wlcx' %>
<%@ taglib uri="weblogic-tags.tld" prefix="wl" %>

<%@ page import="com.bea.p13n.mbeans.*" %>
<%@ page import="com.bea.p13n.management.*" %>
<%@ page import="com.bea.console.extensions.PropertiesHelper" %>
<%@ page import="weblogic.management.configuration.ApplicationConfigurationMBean" %>
<%@ page import='weblogic.management.console.extensibility.Catalog' %>
<%@ page errorPage="error.jsp" %>

<%@ include file="includes/applicationName.inc" %>

<%
Catalog catalog = Catalog.Factory.getCatalog(pageContext);
Vector statusMsg = new Vector();
DocumentConnectionPoolMBean mBean = (DocumentConnectionPoolMBean) ApplicationHelper.getServiceConfigurationAdminMBean( "DocumentConnectionPool", null, appName );
%>

<wl:process name='isSubmitted'>
<%
    String newDriverName = request.getParameter("driverName");
    String newCapacityIncrement = request.getParameter("capacityIncrement");
    String newInitialCapacity = request.getParameter("initialCapacity");
    String newMaxCapacity = request.getParameter("maxCapacity");
    String newPropertiesStr = request.getParameter("properties");
    String newURL = request.getParameter("url");
    String newShrinkingEnabled = request.getParameter("shrinkingEnabled");
    String newLoginTimeout = request.getParameter("loginTimeout");
    boolean bNewShrinkingEnabled = (newShrinkingEnabled != null);
    Integer iCapacityIncrement = null;
    Integer iInitialCapacity = null;
    Integer iMaxCapacity = null;
    Integer iLoginTimeout = null;
    PropertiesHelper ph = new PropertiesHelper();
    ph.setPropertiesString(newPropertiesStr);
    ph.String2Properties();
    Properties newProperties = ph.getProperties();
    boolean restart = (request.getParameter("restart") != null);
    try
    {
        iCapacityIncrement = new Integer(newCapacityIncrement);
    }                                      
    catch (NumberFormatException e)
    {
        statusMsg.addElement(catalog.getText("documentPoolService.msg.InvalidCapacityIncrement"));
    }
    try
    {
        iInitialCapacity = new Integer(newInitialCapacity);
    }                                      
    catch (NumberFormatException e)
    {
        statusMsg.addElement(catalog.getText("documentPoolService.msg.InvalidInitialCapacity"));
    }
    try
    {
        iMaxCapacity = new Integer(newMaxCapacity);
    }                                      
    catch (NumberFormatException e)
    {
        statusMsg.addElement(catalog.getText("documentPoolService.msg.InvalidMaxCapacity"));
    }
    try
    {
        iLoginTimeout = new Integer(newLoginTimeout);
    }                                      
    catch (NumberFormatException e)
    {
        statusMsg.addElement(catalog.getText("documentPoolService.msg.InvalidLoginTimeout"));
    }
    if (statusMsg.size() == 0) 
    {
        // Save current good values.
        String driverName = mBean.getDriverName();
        int initialCapacity = mBean.getInitialCapacity();
        int maxCapacity = mBean.getMaxCapacity();
        int capacityIncrement = mBean.getCapacityIncrement();
        int loginTimeout = mBean.getLoginTimeout();
        String URL = mBean.getURL();
        Properties properties = mBean.getProperties();
        boolean shrinkingEnabled = mBean.isShrinkingEnabled();
        
        try
        {
            mBean.setDriverName(newDriverName);
            mBean.setInitialCapacity(iInitialCapacity.intValue());
            mBean.setMaxCapacity(iMaxCapacity.intValue());
            mBean.setCapacityIncrement(iCapacityIncrement.intValue());
            mBean.setLoginTimeout(iLoginTimeout.intValue());
            mBean.setURL(newURL);
            mBean.setProperties(newProperties);
            mBean.setShrinkingEnabled(bNewShrinkingEnabled);
        }
        catch (java.lang.reflect.UndeclaredThrowableException e)
        {
            Throwable ee = e.getUndeclaredThrowable();
            if (ee instanceof javax.management.InvalidAttributeValueException)
            {
                statusMsg.addElement(ee.getLocalizedMessage());
            }
        }
        if (statusMsg.size() == 0) 
        {
            ApplicationConfigurationMBean appConfigMBean = (ApplicationConfigurationMBean) ApplicationHelper.getApplicationConfigurationAdminMBean(appName);
            appConfigMBean.persist();
            statusMsg.addElement(catalog.getText("default.msg.Success"));
            if (restart) 
            {
                mBean.restart();
                statusMsg.addElement(catalog.getText("documentPoolService.msg.Restarted"));
            }
        }
        else
        {
            // Restore last known good values.
            mBean.setDriverName(driverName);
            mBean.setInitialCapacity(initialCapacity);
            mBean.setMaxCapacity(maxCapacity);
            mBean.setCapacityIncrement(capacityIncrement);
            mBean.setLoginTimeout(loginTimeout);
            mBean.setURL(URL);
            mBean.setProperties(properties);
            mBean.setShrinkingEnabled(shrinkingEnabled);

        }
    }
%>
</wl:process>

<%
String driverName = mBean.getDriverName();
int initialCapacity = mBean.getInitialCapacity();
int maxCapacity = mBean.getMaxCapacity();
int capacityIncrement = mBean.getCapacityIncrement();
int loginTimeout = mBean.getLoginTimeout();
String URL = mBean.getURL();
Properties properties = mBean.getProperties();
boolean shrinkingEnabled = mBean.isShrinkingEnabled();
String helpRollover = catalog.getText("help.rollover");
PropertiesHelper ph = new PropertiesHelper();
ph.setProperties(properties);
ph.Properties2String();
String propertiesStr = ph.getPropertiesString();
String pageHeader = catalog.getText("documentPoolService.label.PageHeader");
%>

<HTML>
<HEAD>
    <%@ include file="includes/Meta.inc" %>
    <wlcx:stylesheet/> 
</HEAD>

<BODY>
<%@ include file="includes/pageHeader.inc" %>
<DIV class='content'>
<BR><BR><BR>
<wlcx:dialog>
    <wlcx:tab name='tab1' labelid='documentPoolService.label.tab1'>
        <FORM ACTION="documentPoolConsole.jsp<%=appURL %>" METHOD="POST">
            <TABLE WIDTH='100%' CELLSPACING='10' BORDER='0'>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=documentPoolConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='documentPoolService.label.DriverName' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT Name="driverName" Type="Text" SIZE="40" VALUE="<%=driverName %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=documentPoolConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='documentPoolService.label.InitialCapacity' /></SPAN></TD>
                    <TD><INPUT Name="initialCapacity" Type="Text" SIZE="4" VALUE="<%=initialCapacity %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=documentPoolConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='documentPoolService.label.CapacityIncrement' /></SPAN></TD>
                    <TD><INPUT Name="capacityIncrement" Type="Text" SIZE="4" VALUE="<%=capacityIncrement %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=documentPoolConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='documentPoolService.label.MaxCapacity' /></SPAN></TD>
                    <TD><INPUT Name="maxCapacity" Type="Text" SIZE="4" VALUE="<%=maxCapacity %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=documentPoolConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='documentPoolService.label.ShrinkingEnabled' /></SPAN></TD>
                    <TD><INPUT Name="shrinkingEnabled" Type="Checkbox"<% if(shrinkingEnabled) {%>CHECKED<%}%>></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=documentPoolConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='documentPoolService.label.LoginTimeout' /></SPAN></TD>
                    <TD><INPUT Name="loginTimeout" Type="Text" SIZE="4" VALUE="<%=loginTimeout %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=documentPoolConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='documentPoolService.label.URL' /></SPAN></TD>
                    <TD><INPUT Name="url" Type="Text" SIZE="40" VALUE="<%=URL %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=documentPoolConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD VALIGN="TOP"><SPAN Class="dialog-label"><wlcx:text textid='documentPoolService.label.Properties' /></SPAN><br><wlcx:text textid='documentPoolService.label.PropertiesHelp' /></TD>
                    <TD>
                       <TEXTAREA name="properties" ROWS="4" COLS="40" WRAP="OFF"><%=propertiesStr %></TEXTAREA>
                    </TD>
                </TR>
                <TR>
                    <TD COLSPAN="3" ALIGN="RIGHT">
                        <INPUT Name="isSubmitted" TYPE="HIDDEN" VALUE="SubitForm">
                        <INPUT TYPE="Submit" VALUE="<%=catalog.getText("default.label.Submit")%>" name="Submit">
                        <INPUT Type="Submit" VALUE="<%=catalog.getText("documentPoolService.label.Restart")%>" Name="restart">
                    </TD>
                </TR>
                <TR>
                    <TD COLSPAN="3" ALIGN="CENTER">
                        <wlcx:text textid='documentPoolService.msg.Restart' />
                    </TD>
                </TR>
            </TABLE>
        </FORM>
    </wlcx:tab>
</wlcx:dialog>
</DIV>
<%@ include file="includes/statusMsg.inc" %>
</BODY>
</HTML>
