<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<%@ taglib uri='extension_taglib.tld' prefix='wlcx' %>
<%@ taglib uri="weblogic-tags.tld" prefix="wl" %>

<%@ page import="com.bea.p13n.mbeans.*" %>
<%@ page import="com.bea.p13n.management.*" %>
<%@ page import="weblogic.management.configuration.ApplicationConfigurationMBean" %>
<%@ page import='weblogic.management.console.extensibility.Catalog' %>
<%@ page errorPage="error.jsp" %>

<%@ include file="includes/applicationName.inc" %>

<%
Catalog catalog = Catalog.Factory.getCatalog(pageContext);
Vector statusMsg = new Vector();
EventServiceMBean mBean = (EventServiceMBean) ApplicationHelper.getServiceConfigurationAdminMBean( "EventService", null, appName );
%>
<wl:process name='tab' value='tab1.tab3'>
<%
    try
    {
        EventServiceMBean asyncBean = (EventServiceMBean) ApplicationHelper.getChildServiceConfigurationMBean( "AsynchronousEventService", mBean);
        mBean = asyncBean;
    }
    catch (javax.management.InstanceNotFoundException e)
    {
        mBean = null;
    }
%>
</wl:process>

<wl:process name='submit'>
<%
    String addListener = request.getParameter("addListener");
    String removeListener = request.getParameter("removeListener");
    if (addListener != null && addListener.length() > 0) 
    {
        mBean.addListener(addListener);
    }
    else if (removeListener != null && removeListener.length() > 0)
    {
        mBean.removeListener(removeListener);
    }
    if (statusMsg.size() == 0) 
    {
        ApplicationConfigurationMBean appConfigMBean = (ApplicationConfigurationMBean) ApplicationHelper.getApplicationConfigurationAdminMBean( appName );
        appConfigMBean.persist();
        statusMsg.addElement(catalog.getText("default.msg.Success"));
    }
%>
</wl:process>

<%
String[] listeners;
if (mBean != null) 
{
    listeners = mBean.getListeners();
}
else 
{
    listeners = new String[0];
}
String helpRollover = catalog.getText("help.rollover");
String pageHeader = catalog.getText("eventService.label.PageHeader");
%>

<HTML>
<HEAD>
    <%@ include file="includes/Meta.inc" %>
    <wlcx:stylesheet/> 
</HEAD>

<BODY>
<%@ include file="includes/pageHeader.inc" %>
<DIV class='content'>
<BR><BR><BR>
<wlcx:dialog>
    <wlcx:tab name='tab1' labelid='eventService.label.tab1'>
        <wlcx:tab name='tab2' labelid='eventService.label.tab2'>
            <FORM ACTION="eventConsole.jsp<%=appURL %>" METHOD="POST">
                <TABLE WIDTH="100%" CELLSPACING="10" BORDER="0">
                    <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=eventConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                        <TD NOWRAP VALIGN="TOP"><SPAN Class="dialog-label"><wlcx:text textid='eventService.label.Listeners' /></SPAN></TD>
                        <TD WIDTH="100%" VALIGN="TOP">
<%
                            if (listeners.length > 0)
                            {
%>
                                <SELECT NAME="removeListener" SIZE="4">
                                    <wl:repeat id="aListener" set="<%=listeners %>">
                                        <OPTION VALUE="<%=aListener %>"><%=aListener %>
                                    </wl:repeat>
                                </SELECT>
                            </TD>
                            <TD VALIGN="TOP">
                                <INPUT type="submit" NAME="submit" VALUE="<%=catalog.getText("eventService.label.Remove")%>">
                            </TD>
<%
                            }
                            else
                            {
%>
                                <wlcx:text textid='eventService.msg.NoListeners' />
                            </TD>
                            <TD>&nbsp;</TD>
<%
                            }
%>
                    </TR>
                    <TR>
                        <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=eventConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                        <TD VALIGN="TOP"><SPAN Class="dialog-label"><wlcx:text textid='eventService.label.AddListener' /></SPAN></TD>
                        <TD VALIGN="TOP"><INPUT NAME="addListener" Type="Text" SIZE="45" VALUE=""></TD>
                        <TD VALIGN="TOP">
                            <INPUT type="submit" NAME="submit" VALUE="<%=catalog.getText("eventService.label.Add")%>">
                        </TD>
                    </TR>
                    <TR>
                        <TD>&nbsp;</TD>
                        <TD COLSPAN="3">
                            <wlcx:text textid='eventService.label.AddCaution' />
                        </TD>
                    </TR>
                </TABLE>
            </FORM>
        </wlcx:tab>
        <wlcx:tab name='tab3' labelid='eventService.label.tab3'>
<%
            if (mBean != null)
            {
%>
                <FORM ACTION="eventConsole.jsp<%=appURL %>&tab=tab1.tab3" METHOD="POST">
                    <TABLE WIDTH="100%" CELLSPACING="10" BORDER="0">
                        <TR>
                            <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=eventConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                            <TD NOWRAP VALIGN="TOP"><SPAN Class="dialog-label"><wlcx:text textid='eventService.label.Listeners' /></SPAN></TD>
                            <TD WIDTH="100%" VALIGN="TOP">
<%
                                if (listeners.length > 0)
                                {
%>
                                    <SELECT NAME="removeListener" SIZE="4">
                                        <wl:repeat id="aListener" set="<%=listeners %>">
                                            <OPTION VALUE="<%=aListener %>"><%=aListener %>
                                        </wl:repeat>
                                    </SELECT>
                                </TD>
                                <TD VALIGN="TOP">
                                    <INPUT type="submit" NAME="submit" VALUE="<%=catalog.getText("eventService.label.Remove")%>">
                                </TD>
<%
                                }
                                else
                                {
%>
                                    <wlcx:text textid='eventService.msg.NoListeners' />
                                </TD>
                                <TD>&nbsp;</TD>
<%
                                }
%>
                        </TR>
                        <TR>
                            <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=eventConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                            <TD VALIGN="TOP"><SPAN Class="dialog-label"><wlcx:text textid='eventService.label.AddListener' /></SPAN></TD>
                            <TD VALIGN="TOP"><INPUT NAME="addListener" Type="Text" SIZE="45" VALUE=""></TD>
                            <TD VALIGN="TOP">
                                <INPUT type="submit" NAME="submit" VALUE="<%=catalog.getText("eventService.label.Add")%>">
                            </TD>
                        </TR>
                        <TR>
                            <TD>&nbsp;</TD>
                            <TD COLSPAN="3">
                                <wlcx:text textid='eventService.label.AddCaution' />
                            </TD>
                        </TR>
                    </TABLE>
                </FORM>
<%
            }
            else
            {
%>
                <TABLE WIDTH="100%" CELLSPACING="10" BORDER="0">
                    <TR>
                        <TD NOWRAP>
                            <SPAN Class="dialog-label"><wlcx:text textid='eventService.msg.NoAsyncListeners' /></SPAN>
                        </TD>
                        <TD>&nbsp;</TD>
                        <TD>&nbsp;</TD>
                        <TD WIDTH="100%">&nbsp;</TD>
                    </TR>
                </TABLE>
<%
            }
%>
        </wlcx:tab>
    </wlcx:tab>
</wlcx:dialog>
</DIV>
<%@ include file="includes/statusMsg.inc" %>
</BODY>
</HTML>
