<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<%@ taglib uri='extension_taglib.tld' prefix='wlcx' %>
<%@ taglib uri="weblogic-tags.tld" prefix="wl" %>

<%@ page import="com.bea.p13n.mbeans.*" %>
<%@ page import="com.bea.p13n.management.*" %>
<%@ page import="weblogic.management.configuration.ApplicationConfigurationMBean" %>
<%@ page import='weblogic.management.console.extensibility.Catalog' %>
<%@ page errorPage="error.jsp" %>

<%@ include file="includes/applicationName.inc" %>

<%
Catalog catalog = Catalog.Factory.getCatalog(pageContext);
Vector statusMsg = new Vector();
MailServiceMBean mBean = (MailServiceMBean) ApplicationHelper.getServiceConfigurationAdminMBean( "MailService", null, appName );
%>

<wl:process name='isSubmitted'>
<%
    String newSMTPHost = request.getParameter( "SMTPHost" );
    if (newSMTPHost == null || newSMTPHost.length() == 0)
    {
        statusMsg.addElement(catalog.getText("mailService.msg.InvalidSMTPHost"));
    }
    if (statusMsg.size() == 0) 
    {
        // Save off current good values.
        String SMTPHost = mBean.getSMTPHost();

        try
        {
            mBean.setSMTPHost(newSMTPHost);
        }
        catch (java.lang.reflect.UndeclaredThrowableException e)
        {
            Throwable ee = e.getUndeclaredThrowable();
            if (ee instanceof javax.management.InvalidAttributeValueException)
            {
                statusMsg.addElement(ee.getLocalizedMessage());
            }
        }
        if (statusMsg.size() == 0) 
        {
            ApplicationConfigurationMBean appConfigMBean = (ApplicationConfigurationMBean) ApplicationHelper.getApplicationConfigurationAdminMBean( appName );
            appConfigMBean.persist();
            statusMsg.addElement(catalog.getText("mailService.msg.Success"));
        }
        else
        {
            // Restore last known good values
            mBean.setSMTPHost(SMTPHost);
        }
    }
%>
</wl:process>

<%
String SMTPHost = mBean.getSMTPHost();
String helpRollover = catalog.getText("help.rollover");
String pageHeader = catalog.getText("mailService.label.PageHeader");
%>

<HTML>
<HEAD>
    <%@ include file="includes/Meta.inc" %>
    <wlcx:stylesheet/> 
</HEAD>

<BODY>
<%@ include file="includes/pageHeader.inc" %>
<DIV class='content'>
<BR><BR><BR>
<wlcx:dialog>
    <wlcx:tab name='tab1' labelid='mailService.label.tab1'>
        <FORM ACTION="mailConsole.jsp<%=appURL %>" METHOD="POST">
            <TABLE WIDTH="100%" CELLSPACING="10" BORDER="0">
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=mailConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='mailService.label.SMTPHost' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT Name="SMTPHost" Type="Text" SIZE="30" VALUE="<%=SMTPHost %>"></TD>
                </TR>
                <TR>
                    <TD COLSPAN="3" ALIGN="RIGHT">
                        <INPUT Name="isSubmitted" TYPE="HIDDEN" VALUE="SubitForm">
                        <INPUT TYPE="Submit" VALUE="<%=catalog.getText("mailService.label.SubmitButton")%>">
                    </TD>
                </TR>
            </TABLE>
        </FORM>
    </wlcx:tab>
</wlcx:dialog>
</DIV>
<%@ include file="includes/statusMsg.inc" %>
</BODY>
</HTML>
