<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<%@ taglib uri='extension_taglib.tld' prefix='wlcx' %>
<%@ taglib uri='wlcxx-taglib.tld' prefix='wlcxx' %>
<%@ taglib uri='weblogic-tags.tld' prefix='wl' %>

<%@ page errorPage="error.jsp" %>
  
<%@ page import="com.bea.console.extensions.ConsoleMBean" %>
<%@ page import="com.bea.console.extensions.ConsoleMBeanHelper" %>
<%@ page import='com.bea.console.extensions.ConsoleMBeanAdminHelper' %>
<%@ page import='com.bea.console.extensions.DeploymentManager' %>
<%@ page import="weblogic.management.configuration.ApplicationConfigurationMBean" %>
<%@ page import='weblogic.management.console.actions.Action' %>
<%@ page import='weblogic.management.console.actions.mbean.ConfigureServicesAction' %>
<%@ page import='weblogic.management.console.actions.mbean.DoConfigureServicesAction' %>
<%@ page import='weblogic.management.console.helpers.Helpers' %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="java.util.List" %>
<%@ page import="java.util.Set" %>

<%@ include file="includes/applicationName.inc" %>

<%
    ConsoleMBeanAdminHelper adminHelper = 
        DeploymentManager.getInstance().getAdminHelper(appName);
    ApplicationConfigurationMBean appConfigMBean = adminHelper.getAppConfigMBean();
%>

<!-------------- User requested add/delete services -->
<wl:process name='isSubmitted'>
<%
    try
    {
        ArrayList requestedServices = new ArrayList();
        ArrayList toUnregister = new ArrayList();
        List deployable =
            DeploymentManager.getInstance().getDeployableMBeans(appName);
        for (int i=0; i<deployable.size(); i++)
        {
            ConsoleMBean cmb = (ConsoleMBean)deployable.get(i);
            String mbeanName = cmb.getMBeanName();
            boolean isOn = (request.getParameter(mbeanName) != null);
            // Deploy
            if (isOn && !cmb.isDeployed())
            {
                requestedServices.add(cmb);
            }
            // Undeploy
            else if (!isOn && cmb.isDeployed())
            {
                toUnregister.add(cmb);
            }
        }
        // Do it
        adminHelper.createServiceConfigMBeans(requestedServices);
        adminHelper.unregisterServiceConfigMBeans(toUnregister);

        // Update application-config.xml file
        appConfigMBean.persist();

        // Update deployed MBeans
        DeploymentManager.getInstance().updateDeployedMBeans(appName);
    }
    catch (Exception e)
    {
        e.printStackTrace();
    }
%>
    
<!-- Let them know they need to redeploy the application -->
    <jsp:include page='redeployApp.jsp' />

<!-- Ask the nav tree to update itself -->
    <jsp:include page='reloadnav.jsp' />

</wl:process>

<!---------------------- User modified targets -->
<wl:process name='weblogic.console.submit_form'>
    
    <!-- Ask the nav tree to update itself -->
    <jsp:include page='reloadnav.jsp' />
    <!-- Let them know they need to redeploy the application -->
    <jsp:include page='redeployApp.jsp' />
</wl:process>

<!------------ Begin HTML ------------------>
<wlcxx:html>
<wlcxx:head>
    <%@ include file="includes/Meta.inc" %>
    <wlcx:stylesheet/> 
</wlcxx:head>
<wlcxx:body>
<BR><BR><BR>  
  
                      
<%
    ConfigureServicesAction action = (ConfigureServicesAction)Helpers.action(pageContext);
    String furl = Helpers.url(pageContext).getUrl(action);
%>

<wlcxx:page>   
<wlcx:dialog>

    <!------------ Table of choices for service configuration -->
    <wlcx:tab name='tab1' labelid='Service Configuration'>
        <FORM ACTION='<%=furl%>' METHOD="POST">
            <TABLE WIDTH='80%' CELLSPACING='10' BORDER='10'>
<%
        List deployableMBeans = 
            DeploymentManager.getInstance().getDeployableMBeans(appName);
        for (int i=0; i<deployableMBeans.size(); i++)
        {
            ConsoleMBean cmb = (ConsoleMBean)deployableMBeans.get(i);
            String mbeanName = cmb.getMBeanName();
            String serviceDesc = 
                ((cmb.getDisplayName() != null) ? cmb.getDisplayName() : mbeanName);
            boolean isDeployed = cmb.isDeployed();
%>
            <TR>
                <TD ALIGN="CENTER" VALIGN="TOP" NOWRAP></TD>
                <TD><SPAN Class="dialog-label"><wlcx:text text="<%=serviceDesc %>" /></SPAN></TD>
                <TD><INPUT Name="<%=mbeanName %>" Type="Checkbox" <% if(isDeployed) {%>CHECKED<%}%> ></TD>
            </TR>
<%

        }
%>
            <TR>
                <TD>
                <INPUT Name="isSubmitted" TYPE="HIDDEN" VALUE="SubmitForm">
                <INPUT TYPE="Submit" VALUE="Submit">
                </TD>
            </TR>

            </TABLE>
          </FORM>
    </wlcx:tab>
    
    <!-----------------------  Targets --> 
    <wlcx:tab name='tab2' labelid='Targets' >
    
      <!-- Servers -->
      <wlcx:tab name='servers' labelid='Servers'>
        <wlcxx:standard-form 
            submitAction='<%=new DoConfigureServicesAction(appConfigMBean, appName)%>'
            bean='<%=appConfigMBean%>' 
            beanClass='weblogic.management.configuration.ApplicationConfigurationMBean' >
          <wlcxx:control attribute='Targets-Server' />
        </wlcxx:standard-form>
      </wlcx:tab>
            
      <!-- Clusters -->
      <wlcx:tab name='clusters' labelid='Cluster'>
        <wlcxx:standard-form 
            submitAction='<%=new DoConfigureServicesAction(appConfigMBean, appName)%>'
            bean='<%=appConfigMBean%>'
            beanClass='weblogic.management.configuration.ApplicationConfigurationMBean' >
          <wlcxx:control attribute='Targets-Cluster' />
        </wlcxx:standard-form>
      </wlcx:tab>
    
    </wlcx:tab>
    
</wlcx:dialog>

</wlcxx:page>       
</wlcxx:body>
</wlcxx:html>

