<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<%@ taglib uri='extension_taglib.tld' prefix='wlcx' %>
<%@ taglib uri="weblogic-tags.tld" prefix="wl" %>

<%@ page import="com.bea.commerce.mbeans.*" %>
<%@ page import="com.bea.p13n.management.*" %>
<%@ page import="weblogic.management.configuration.ApplicationConfigurationMBean" %>
<%@ page import='weblogic.management.console.extensibility.Catalog' %>
<%@ page errorPage="error.jsp" %>

<%@ include file="includes/applicationName.inc" %>

<%
Catalog catalog = Catalog.Factory.getCatalog(pageContext);
Vector statusMsg = new Vector();
PaymentServiceClientMBean mBean = (PaymentServiceClientMBean) ApplicationHelper.getServiceConfigurationAdminMBean( "PaymentServiceClient", null, appName );
%>

<wl:process name='isSubmitted'>
<%
    String newDeferAuthorization = request.getParameter("deferAuthorization");
    String newPaymentWebServiceWSDL = request.getParameter("paymentWebServiceWSDL");
    String newPaymentModel = request.getParameter("paymentModel");
    if (newDeferAuthorization == null)
    {
        newDeferAuthorization = "false";
    }
    else
    {
        newDeferAuthorization = "true";
    }
    if (statusMsg.size() == 0) 
    {
        // Save off current good values.
        String deferAuthorization = mBean.getDeferAuthorization();
        String paymentWebServiceWSDL = mBean.getPaymentWebServiceWSDL();
        String paymentModel = mBean.getPaymentModel();

        try
        {
            mBean.setDeferAuthorization(newDeferAuthorization);
            mBean.setPaymentWebServiceWSDL(newPaymentWebServiceWSDL);
            mBean.setPaymentModel(newPaymentModel);
        }
        catch (java.lang.reflect.UndeclaredThrowableException e)
        {
            Throwable ee = e.getUndeclaredThrowable();
            if (ee instanceof javax.management.InvalidAttributeValueException)
            {
                statusMsg.addElement(ee.getLocalizedMessage());
            }
        }
        if (statusMsg.size() == 0) 
        {
            ApplicationConfigurationMBean appConfigMBean = (ApplicationConfigurationMBean) ApplicationHelper.getApplicationConfigurationAdminMBean(appName);
            appConfigMBean.persist();
            statusMsg.addElement(catalog.getText("default.msg.Success"));
        }
        else
        {
            // Restore last known good values.
            mBean.setDeferAuthorization(deferAuthorization);
            mBean.setPaymentWebServiceWSDL(paymentWebServiceWSDL);
            mBean.setPaymentModel(paymentModel);
        }
    }
%>
</wl:process>

<%
String deferAuthorization = mBean.getDeferAuthorization();
String paymentWebServiceWSDL = mBean.getPaymentWebServiceWSDL();
String paymentModel = mBean.getPaymentModel();
String helpRollover = catalog.getText("help.rollover");
String pageHeader = catalog.getText("paymentService.label.PageHeader");
%>

<HTML>
<HEAD>
    <%@ include file="includes/Meta.inc" %>
    <wlcx:stylesheet/> 
</HEAD>

<BODY>
<%@ include file="includes/pageHeader.inc" %>
<DIV class='content'>
<BR><BR><BR>
<wlcx:dialog>
    <wlcx:tab name='tab1' labelid='paymentService.label.tab1'>
        <FORM ACTION="paymentConsole.jsp<%=appURL %>" METHOD="POST">
            <TABLE WIDTH="100%" CELLSPACING="10" BORDER="0">
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=paymentConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='paymentService.label.DeferAuthorization' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT Name="deferAuthorization" Type="Checkbox" <% if (deferAuthorization.compareTo("true") == 0) {%>CHECKED<%}%>></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=paymentConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='paymentService.label.PaymentWebServiceWSDL' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT Name="paymentWebServiceWSDL" Value="<%=paymentWebServiceWSDL %>" Size="40"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=paymentConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='paymentService.label.PaymentModel' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT Name="paymentModel" Value="<%=paymentModel %>" Size="40"></TD>
                </TR>
                <TR>
                    <TD COLSPAN="3" ALIGN="RIGHT">
                        <INPUT Name="isSubmitted" TYPE="HIDDEN" VALUE="SubitForm">
                        <INPUT TYPE="Submit" VALUE="<%=catalog.getText("default.label.Submit")%>">
                    </TD>
                </TR>
            </TABLE>
        </FORM>
    </wlcx:tab>
</wlcx:dialog>
</DIV>
<%@ include file="includes/statusMsg.inc" %>
</BODY>
</HTML>
