<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<%@ taglib uri='extension_taglib.tld' prefix='wlcx' %>
<%@ taglib uri="weblogic-tags.tld" prefix="wl" %>

<%@ page import="com.bea.campaign.mbeans.*" %>
<%@ page import="com.bea.p13n.management.*" %>
<%@ page import="weblogic.management.configuration.ApplicationConfigurationMBean" %>
<%@ page import='weblogic.management.console.extensibility.Catalog' %>
<%@ page errorPage="error.jsp" %>

<%@ include file="includes/applicationName.inc" %>

<%
Catalog catalog = Catalog.Factory.getCatalog(pageContext);
String CRLF = System.getProperty("line.separator");
Vector statusMsg = new Vector();
ScenarioServiceMBean mBean = (ScenarioServiceMBean) ApplicationHelper.getServiceConfigurationAdminMBean( "ScenarioService", null, appName );
%>

<wl:process name='isSubmitted'>
<%
    String newRequestAttrNames = request.getParameter( "requestAttrNames" );
    String newSessionAttrNames = request.getParameter( "sessionAttrNames" );
    String newPrependURLsWith = request.getParameter( "prependURLsWith" );

    if (statusMsg.size() == 0) 
    {
        // Save off current good values.
        String[] requestAttrNames = mBean.getRulesRequestAttrNames();
        String[] sessionAttrNames = mBean.getRulesSessionAttrNames();
        String prependURLsWith = mBean.getPrependRulesURIsWith();

        StringTokenizer toker = new StringTokenizer(newRequestAttrNames, CRLF);
        String[] newRequestAttrNamesStr = new String[toker.countTokens()];
        int index = 0;
        String attr = null;
        while (toker.hasMoreTokens())
        {
            newRequestAttrNamesStr[index++] = toker.nextToken().trim();
        }
        toker = new StringTokenizer(newSessionAttrNames, CRLF);
        String[] newSessionAttrNamesStr = new String[toker.countTokens()];
        index = 0;
        attr = null;
        while (toker.hasMoreTokens())
        {
            newSessionAttrNamesStr[index++] = toker.nextToken().trim();
        }
        try
        {
            mBean.setRulesRequestAttrNames(newRequestAttrNamesStr);
            mBean.setRulesSessionAttrNames(newSessionAttrNamesStr);
            mBean.setPrependRulesURIsWith(newPrependURLsWith);
        }
        catch (java.lang.reflect.UndeclaredThrowableException e)
        {
            Throwable ee = e.getUndeclaredThrowable();
            if (ee instanceof javax.management.InvalidAttributeValueException)
            {
                statusMsg.addElement(ee.getLocalizedMessage());
            }
        }
        if (statusMsg.size() == 0)
        {
            ApplicationConfigurationMBean appConfigMBean = (ApplicationConfigurationMBean) ApplicationHelper.getApplicationConfigurationAdminMBean( appName );
            appConfigMBean.persist();
            statusMsg.addElement(catalog.getText("default.msg.Success"));
        }
        else
        {
            // Restore last known good values.
            mBean.setRulesRequestAttrNames(requestAttrNames);
            mBean.setRulesSessionAttrNames(sessionAttrNames);
            mBean.setPrependRulesURIsWith(prependURLsWith);
        }
    }
%>
</wl:process>

<%
String[] requestAttrNames = mBean.getRulesRequestAttrNames();
String[] sessionAttrNames = mBean.getRulesSessionAttrNames();
String prependURLsWith = mBean.getPrependRulesURIsWith();
String requestAttrNamesStr = "";
String sessionAttrNamesStr = "";
for (int i = 0; i < requestAttrNames.length; i++) 
{
    requestAttrNamesStr = requestAttrNamesStr + requestAttrNames[i] + CRLF;
}
for (int i = 0; i < sessionAttrNames.length; i++) 
{
    sessionAttrNamesStr = sessionAttrNamesStr+ sessionAttrNames[i] + CRLF;
}
String helpRollover = catalog.getText("help.rollover");
String pageHeader = catalog.getText("scenarioService.label.PageHeader");
%>

<HTML>
<HEAD>
    <%@ include file="includes/Meta.inc" %>
    <wlcx:stylesheet/> 
</HEAD>

<BODY>
<%@ include file="includes/pageHeader.inc" %>
<DIV class='content'>
<BR><BR><BR>
<wlcx:dialog>
    <wlcx:tab name='tab1' labelid='scenarioService.label.tab1'>
        <FORM ACTION="scenarioConsole.jsp<%=appURL %>" METHOD="POST">
            <TABLE WIDTH="100%" CELLSPACING="10" BORDER="0">
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=scenarioConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP VALIGN="TOP"><SPAN Class="dialog-label"><wlcx:text textid='scenarioService.label.RequestAttrNames' /></SPAN></TD>
                    <TD WIDTH="100%"><TEXTAREA Name="requestAttrNames" Rows="4" Cols="40"><%=requestAttrNamesStr %></TEXTAREA></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=scenarioConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD VALIGN="TOP" NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='scenarioService.label.SessionAttrNames' /></SPAN></TD>
                    <TD><TEXTAREA Name="sessionAttrNames" Rows="4" Cols="40"><%=sessionAttrNamesStr %></TEXTAREA></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=scenarioConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='scenarioService.label.PrependURLsWith' /></SPAN></TD>
                    <TD><INPUT NAME="prependURLsWith" Type="Text" SIZE="40" VALUE="<%=prependURLsWith %>"></TD>
                </TR>
                <TR>
                    <TD COLSPAN="3" ALIGN="RIGHT">
                        <INPUT Name="isSubmitted" TYPE="HIDDEN" VALUE="SubitForm">
                        <INPUT TYPE="Submit" VALUE="<%=catalog.getText("default.label.Submit")%>">
                    </TD>
                </TR>
            </TABLE>
        </FORM>
    </wlcx:tab>
</wlcx:dialog>
</DIV>
<%@ include file="includes/statusMsg.inc" %>
</BODY>
</HTML>
