<!-- Copyright (c) 2000-2002  BEA Systems, Inc. All Rights Reserved. -->

<%@ taglib uri='extension_taglib.tld' prefix='wlcx' %>
<%@ taglib uri="weblogic-tags.tld" prefix="wl" %>

<%@ page import="com.bea.commerce.mbeans.*" %>
<%@ page import="com.bea.p13n.management.*" %>
<%@ page import="weblogic.management.configuration.ApplicationConfigurationMBean" %>
<%@ page import='weblogic.management.console.extensibility.Catalog' %>
<%@ page errorPage="error.jsp" %>

<%@ include file="includes/applicationName.inc" %>

<%
Catalog catalog = Catalog.Factory.getCatalog(pageContext);
Vector statusMsg = new Vector();
TaxServiceClientMBean mBean = (TaxServiceClientMBean) ApplicationHelper.getServiceConfigurationAdminMBean( "TaxServiceClient", null, appName );
%>

<wl:process name='isSubmitted'>
<%
    String newTaxCalculatorJNDIName = request.getParameter( "taxCalculatorJNDIName" );
    String newTaxCalculatorWSDL = request.getParameter("taxCalculatorWSDL");
    String newCurrency = request.getParameter("currency");
    String newProvince = request.getParameter("province");
    String newCity = request.getParameter("city");
    String newPostalCode = request.getParameter("postalCode");
    String newLocationCode = request.getParameter("locationCode");
    String newCountryCode = request.getParameter("countryCode");
    String newOriginProvince = request.getParameter("originProvince");
    String newOriginCity = request.getParameter("originCity");
    String newOriginPostalCode = request.getParameter("originPostalCode");
    String newOriginLocationCode = request.getParameter("originLocationCode");
    String newOriginCountryCode = request.getParameter("originCountryCode");
    String newTitlePassage = request.getParameter("titlePassage");
    String newCompanyID = request.getParameter("companyID");
    String newBusinessLocationCode = request.getParameter("businessLocationCode");
    String newTaxType = request.getParameter("taxType");
    String newAVSReturnList = request.getParameter("avsReturnList");
    String newSellerRegNumber = request.getParameter("sellerRegNumber");
    String newTaxDebug = request.getParameter("taxDebug");

    if (statusMsg.size() == 0) 
    {
        // Save off current good values.
        String taxCalculatorJNDIName = mBean.getTaxCalculatorJNDIName();
        String taxCalculatorWSDL = mBean.getTaxCalculatorWSDL();
        String currency = mBean.getCurrency();
        String province = mBean.getShipFromProvince();
        String city = mBean.getShipFromCity();
        String postalCode = mBean.getShipFromPostalCode();
        String locationCode = mBean.getShipFromLocationCode();
        String countryCode = mBean.getShipFromCountryCode();
        String originProvince = mBean.getOrderOriginProvince();
        String originCity = mBean.getOrderOriginCity();
        String originPostalCode = mBean.getOrderOriginPostalCode();
        String originLocationCode = mBean.getOrderOriginLocationCode();
        String originCountryCode = mBean.getOrderOriginCountryCode();
        String titlePassage = mBean.getTitlePassageLocation();
        String companyID = mBean.getCompanyID();
        String businessLocationCode = mBean.getBusinessLocationCode( );
        String taxType = mBean.getTaxType();
        String avsReturnList = mBean.getAVSReturnListOnZipFailure();
        String sellerRegNumber = mBean.getSellerRegistrationNumber();
        String taxDebug = mBean.getTaxDebug();

        try
        {
            mBean.setTaxCalculatorJNDIName(newTaxCalculatorJNDIName);
            mBean.setTaxCalculatorWSDL(newTaxCalculatorWSDL);
            mBean.setCurrency(newCurrency);
            mBean.setShipFromProvince(newProvince);
            mBean.setShipFromCity(newCity);
            mBean.setShipFromPostalCode(newPostalCode);
            mBean.setShipFromLocationCode(newLocationCode);
            mBean.setShipFromCountryCode(newCountryCode);
            mBean.setOrderOriginProvince(newOriginProvince);
            mBean.setOrderOriginCity(newOriginCity);
            mBean.setOrderOriginPostalCode(newOriginPostalCode);
            mBean.setOrderOriginLocationCode(newOriginLocationCode);
            mBean.setOrderOriginCountryCode(newOriginCountryCode);
            mBean.setTitlePassageLocation(newTitlePassage);
            mBean.setCompanyID(newCompanyID);
            mBean.setBusinessLocationCode(newBusinessLocationCode );
            mBean.setTaxType(newTaxType);
            mBean.setAVSReturnListOnZipFailure(newAVSReturnList);
            mBean.setSellerRegistrationNumber(newSellerRegNumber);
            mBean.setTaxDebug(newTaxDebug);
        }
        catch (java.lang.reflect.UndeclaredThrowableException e)
        {
            Throwable ee = e.getUndeclaredThrowable();
            if (ee instanceof javax.management.InvalidAttributeValueException)
            {
                statusMsg.addElement(ee.getLocalizedMessage());
            }
        }
        if (statusMsg.size() == 0) 
        {
            ApplicationConfigurationMBean appConfigMBean = (ApplicationConfigurationMBean) ApplicationHelper.getApplicationConfigurationAdminMBean(appName);
            appConfigMBean.persist();
            statusMsg.addElement(catalog.getText("default.msg.Success"));
        }
        else
        {
            // Restore last known good values.
            mBean.setTaxCalculatorJNDIName(taxCalculatorJNDIName);
            mBean.setTaxCalculatorWSDL(taxCalculatorWSDL);
            mBean.setCurrency(currency);
            mBean.setShipFromProvince(province);
            mBean.setShipFromCity(city);
            mBean.setShipFromPostalCode(postalCode);
            mBean.setShipFromLocationCode(locationCode);
            mBean.setShipFromCountryCode(countryCode);
            mBean.setOrderOriginProvince(originProvince);
            mBean.setOrderOriginCity(originCity);
            mBean.setOrderOriginPostalCode(originPostalCode);
            mBean.setOrderOriginLocationCode(originLocationCode);
            mBean.setOrderOriginCountryCode(originCountryCode);
            mBean.setTitlePassageLocation(titlePassage);
            mBean.setCompanyID(companyID);
            mBean.setBusinessLocationCode(businessLocationCode );
            mBean.setTaxType(taxType);
            mBean.setAVSReturnListOnZipFailure(avsReturnList);
            mBean.setSellerRegistrationNumber(sellerRegNumber);
            mBean.setTaxDebug(taxDebug);

        }
    }
%>
</wl:process>

<%
String taxCalculatorJNDIName = mBean.getTaxCalculatorJNDIName();
String taxCalculatorWSDL = mBean.getTaxCalculatorWSDL();
String currency = mBean.getCurrency();
String province = mBean.getShipFromProvince();
String city = mBean.getShipFromCity();
String postalCode = mBean.getShipFromPostalCode();
String locationCode = mBean.getShipFromLocationCode();
String countryCode = mBean.getShipFromCountryCode();
String originProvince = mBean.getOrderOriginProvince();
String originCity = mBean.getOrderOriginCity();
String originPostalCode = mBean.getOrderOriginPostalCode();
String originLocationCode = mBean.getOrderOriginLocationCode();
String originCountryCode = mBean.getOrderOriginCountryCode();
String titlePassage = mBean.getTitlePassageLocation();
String companyID = mBean.getCompanyID();
String businessLocationCode = mBean.getBusinessLocationCode( );
String taxType = mBean.getTaxType();
String avsReturnList = mBean.getAVSReturnListOnZipFailure();
String sellerRegNumber = mBean.getSellerRegistrationNumber();
String taxDebug = mBean.getTaxDebug();
String helpRollover = catalog.getText("help.rollover");
String pageHeader = catalog.getText("taxService.label.PageHeader");
%>

<HTML>
<HEAD>
    <%@ include file="includes/Meta.inc" %>
    <wlcx:stylesheet/> 
</HEAD>

<BODY>
<%@ include file="includes/pageHeader.inc" %>
<DIV class='content'>
<BR><BR><BR>
<wlcx:dialog>
    <wlcx:tab name='tab1' labelid='taxService.label.tab1'>
        <FORM ACTION="taxConsole.jsp<%=appURL %>" METHOD="POST">
            <TABLE WIDTH="100%" CELLSPACING="10" BORDER="0">
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=taxConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='taxService.label.TaxCalculatorJNDIName' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT Name="taxCalculatorJNDIName" Type="Text" SIZE="40" VALUE="<%=taxCalculatorJNDIName %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=taxConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='taxService.label.TaxCalculatorWSDL' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT Name="taxCalculatorWSDL" Type="Text" SIZE="40" VALUE="<%=taxCalculatorWSDL %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=taxConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='taxService.label.Currency' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT Name="currency" Type="Text" SIZE="3" VALUE="<%=currency %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=taxConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='taxService.label.Province' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT Name="province" Type="Text" SIZE="2" VALUE="<%=province %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=taxConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='taxService.label.City' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT Name="city" Type="Text" SIZE="40" VALUE="<%=city %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=taxConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='taxService.label.PostalCode' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT Name="postalCode" Type="Text" SIZE="10" VALUE="<%=postalCode %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=taxConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='taxService.label.LocationCode' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT Name="locationCode" Type="Text" SIZE="2" VALUE="<%=locationCode %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=taxConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='taxService.label.CountryCode' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT Name="countryCode" Type="Text" SIZE="3" VALUE="<%=countryCode %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=taxConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='taxService.label.OriginProvince' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT Name="originProvince" Type="Text" SIZE="2" VALUE="<%=originProvince %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=taxConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='taxService.label.OriginCity' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT Name="originCity" Type="Text" SIZE="40" VALUE="<%=originCity %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=taxConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='taxService.label.OriginPostalCode' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT Name="originPostalCode" Type="Text" SIZE="10" VALUE="<%=originPostalCode %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=taxConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='taxService.label.OriginLocationCode' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT Name="originLocationCode" Type="Text" SIZE="2" VALUE="<%=locationCode %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=taxConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='taxService.label.OriginCountryCode' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT Name="originCountryCode" Type="Text" SIZE="3" VALUE="<%=originCountryCode %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=taxConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='taxService.label.TitlePassage' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT Name="titlePassage" Type="Text" SIZE="10" VALUE="<%=titlePassage %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=taxConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='taxService.label.CompanyID' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT Name="companyID" Type="Text" SIZE="20" VALUE="<%=companyID %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=taxConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='taxService.label.BusinessLocationCode' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT Name="businessLocationCode" Type="Text" SIZE="40" VALUE="<%=businessLocationCode %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=taxConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='taxService.label.TaxType' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT Name="taxType" Type="Text" SIZE="10" VALUE="<%=taxType %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=taxConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='taxService.label.AVSReturnList' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT Name="avsReturnList" Type="Text" SIZE="40" VALUE="<%=avsReturnList %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=taxConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='taxService.label.SellerRegNumber' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT Name="sellerRegNumber" Type="Text" SIZE="40" VALUE="<%=sellerRegNumber %>"></TD>
                </TR>
                <TR>
                    <TD ALIGN="LEFT" VALIGN="TOP" NOWRAP><IMG WIDTH="16" HEIGHT="16" SRC="/console/images/tree_spacer.gif" BORDER="0"/><A HREF="p13nConsoleHelp.jsp?topic=taxConsole.help" target="_help"><IMG SRC="images/help_little.gif" BORDER=0 ALT="<%=helpRollover %>"></A></TD>
                    <TD NOWRAP><SPAN Class="dialog-label"><wlcx:text textid='taxService.label.TaxDebug' /></SPAN></TD>
                    <TD WIDTH="100%"><INPUT Name="taxDebug" Type="Text" SIZE="10" VALUE="<%=taxDebug %>"></TD>
                </TR>
                <TR>
                    <TD COLSPAN="3" ALIGN="RIGHT">
                        <INPUT Name="isSubmitted" TYPE="HIDDEN" VALUE="SubitForm">
                        <INPUT TYPE="Submit" VALUE="<%=catalog.getText("default.label.Submit")%>">
                    </TD>
                </TR>
            </TABLE>
        </FORM>
    </wlcx:tab>
</wlcx:dialog>
</DIV>
<%@ include file="includes/statusMsg.inc" %>
</BODY>
</HTML>
