@echo off
REM create_db.cmd
REM (c) 2001- BEA Systems, Inc.  All rights reserved.
REM
REM Script to run table creation and load bootstrap sample and required data for Weblogic Portal
REM
REM ##############################################################################
REM ##############################################################################

SETLOCAL

SET DEBUG=0
if %DEBUG% EQU 0 ( @echo off ) ELSE @echo on

REM ----------------------create_db.cmd-------------------------
set DOMAIN_NAME=demoDomain

set DB_SETTINGS=.\db_settings.properties
FOR /F "eol=# tokens=1,2 delims==" %%i in (%DB_SETTINGS%) do  (
    if %%i == domain_name SET propDomain=%%j
)
FOR /F "eol=# tokens=1,2 delims==" %%i in (%DB_SETTINGS%) do  (
    if %%i == database SET DATABASE=%%j
)

if NOT %DOMAIN_NAME% == %propDomain% (
    echo The create_db.cmd for the %DOMAIN_NAME% domain is being run using the db_settings.properties for the %propDomain% domain. This is an error.
    set ABORT=1
    goto :FINALIZE
)

IF NOT EXIST "..\..\..\portal\bin\win32\set-environment.bat" (
    echo Unable to find the ..\..\..\portal\bin\win32\set-environment.bat file
    set ABORT=1
    goto :FINALIZE
)
CALL "..\..\..\portal\bin\win32\set-environment.bat"

if %DEBUG% EQU 0 ( @echo off ) ELSE @echo on

set WL_PORTAL_HOME=%WL_COMMERCE_HOME%

FOR /F "eol=# tokens=1,2 delims==" %%i in (%DB_SETTINGS%) do  (
    if %%i == host SET HOST=%%j
)
FOR /F "eol=# tokens=1,2 delims==" %%i in (%DB_SETTINGS%) do  (
    if %%i == port SET PORT=%%j
)
FOR /F "eol=# tokens=1,2 delims==" %%i in (%DB_SETTINGS%) do  (
    if %%i == db_name SET DB_NAME=%%j
)

REM *** PointBase start Logic
if "%DATABASE%" == "POINTBASE" ( 
    "%JDK_HOME%\bin\java" -classpath "%CLASSPATH%;%WL_PORTAL_HOME%\lib\p13n\ejb\p13n_util.jar" com.bea.p13n.db.internal.PointBasePing -host %HOST% -port %PORT% -database %DB_NAME%
    IF ERRORLEVEL 1 ( 
        echo ************************* Starting PointBase
REM "START" command will not accept paths with spaces in quotes UNLESS you
REM also use the optional window-title argument!
        START /min "PointBase(R) Server" "%WL_PORTAL_HOME%\bin\win32\startPBServer.bat" db_settings.properties
    )
) 

CALL "%WL_PORTAL_HOME%\db\create_db_common.cmd" %DB_SETTINGS%

CALL .\create_wli.cmd

PUSHD .\sqlScripts
CALL reloadInventory.cmd
CALL reloadUC1.cmd
CALL reloadUC2.cmd
CALL updateSequenceTable.cmd
POPD

:FINALIZE
if "%DATABASE%" == "POINTBASE" ( 
   CALL "%WL_COMMERCE_HOME%\bin\win32\stopPBServer.bat" db_settings.properties 
) 
GOTO :EOF

:EOF

ENDLOCAL
echo 
echo 
echo *****************************************************
echo You have now re-created your database please 
echo start your server and run these scripts in the
echo following order to complete the database re-createion.
echo 
echo 'e2eSetupAppView.cmd'    		 - Sets up the Application View
echo 'e2eImportWorkflows.cmd' 		 - Imports the WLI Workflows
echo 'loadads.bat'	      		 - Imports the Ad metadata
echo 'loaddocs.bat'	      		 - Imports the Document metadata
echo '.\beaApps\e2eApp-project\sync.cmd' - Synchronizes the EBCC files
echo 
echo ***************************************

PAUSE