--       Copyright (c) 2000-2002 BEA Systems, Inc.
--       All rights reserved
--
--       THIS IS UNPUBLISHED PROPRIETARY
--       SOURCE CODE OF BEA Systems, Inc.
--       The copyright notice above does not
--       evidence any actual or intended
--       publication of such source code.

-- $Id: //depot/WLI_Avalanche/samples/e2e/dbscripts/pointbase/E2E_SCHEMA.sql#1 $

-- E2E Sample Table
DROP TABLE E2E_LINEITEM;
DROP TABLE E2E_PURCHASEORDER;
DROP table E2E_ADDRESS;
DROP table E2E_CONTACT;
DROP table E2E_SUPPLIER;
DROP TABLE E2E_PRODUCT_PART;;
DROP TABLE E2E_INVENTORY;
DROP TABLE WLI_ORDER;
DROP TABLE WLI_ORDER_LINE;

CREATE TABLE E2E_PURCHASEORDER(
	PONUMBER varchar (128) NOT NULL unique,
	POCREATIONDATE varchar(128) NOT NULL ,
	SONUMBER varchar (128),
	SOCREATIONDATE varchar(128),
	BUYERNAME varchar (128) NOT NULL ,
	SUPPLIERNAME varchar (128) NOT NULL,
	BILLINGACCOUNTID varchar (128),
	SHIPPINGPROVIDER varchar (128),
	TRACKINGID varchar (128),
	SHIPMENTNOTE varchar (128),
	FINANCETERM varchar (128), 
	TAXINFORMATION varchar (128), 
	FINANCENOTE varchar (128), 
	STATUS varchar (128) NOT NULL ,
	TOTALAMOUNT float ); 


CREATE TABLE E2E_LINEITEM(
	PONUMBER varchar (128) NOT NULL  references E2E_PURCHASEORDER(PONUMBER),
	SONUMBER varchar (128),
	LINENUMBER varchar (85) NOT NULL,  
	PARTID varchar (128) NOT NULL,
	PARTDESCRIPTION varchar (128) ,
	QUANTITY int NOT NULL,
	UNITPRICE float NOT NULL,
	UNITCURRENCY varchar(128) NOT NULL,
	DELIVERYDATE varchar (128) NOT NULL,
	NOTE varchar (128) );

CREATE UNIQUE INDEX E2E_LineItemIndex on E2E_LINEITEM(PONUMBER, LINENUMBER, PARTID);


create table E2E_ADDRESS(
	PURPOSE varchar (128) NOT NULL,
	STREET1 varchar (128),  
	STREET2 varchar (128),  
	STREET3 varchar (128), 
	CITY varchar (128),  
	STATE varchar (128),  
	ZIPCODE varchar (128) );


create table E2E_CONTACT(
	COMPANY varchar (128) NOT NULL,
	CONTACTNAME varchar (128),  
	CONTACTPHONE varchar (128),  
	CONTACTEMAIL varchar (128), 
	CONTACTFAX varchar (128),  
	STREET1 varchar (128),  
	STREET2 varchar (128),  
	STREET3 varchar (128), 
	CITY varchar (128),  
	STATE varchar (128),  
	ZIPCODE varchar (128) );


create table E2E_SUPPLIER(
	SUPPLIERNAME varchar (64) NOT NULL,
	CATEGORY varchar (8),  
	SUPPLYITEMID varchar (64) );

INSERT INTO E2E_SUPPLIER (SUPPLIERNAME, CATEGORY, SUPPLYITEMID)
       VALUES ('Midwest Metals', '1', 'DPM3961');
INSERT INTO E2E_SUPPLIER (SUPPLIERNAME, CATEGORY, SUPPLYITEMID)
       VALUES ('E2E_SupplierOne', '2', 'DPM3961');
INSERT INTO E2E_SUPPLIER (SUPPLIERNAME, CATEGORY, SUPPLYITEMID)
       VALUES ('E2E_SupplierTwo', '2', 'DPM3961');

COMMIT;




CREATE TABLE E2E_PRODUCT_PART (
       PRODUCT_SKU          VARCHAR(40) NOT NULL,
       PART_SKU             VARCHAR(40) NOT NULL
);                                               

ALTER TABLE E2E_PRODUCT_PART
   ADD CONSTRAINT PK_PROD_PARTP
   PRIMARY KEY (PRODUCT_SKU, PART_SKU)
;


CREATE TABLE E2E_INVENTORY (
       SKU                  VARCHAR(40) NOT NULL,
       UNIT_TYPE            VARCHAR(7) NOT NULL,
       DESCRIPTION          VARCHAR(100) NULL,
       QTY_IN_STOCK         NUMERIC NULL,
       MAX_QTY_STOCKED      NUMERIC NULL,
       MIN_QTY_STOCKED      NUMERIC NULL,
       STANDARD_IMAGE_URL   VARCHAR(50) NULL,
       WIDE_IMAGE_URL 	    VARCHAR(50) NULL
);

ALTER TABLE E2E_INVENTORY
    ADD CONSTRAINT PK_INVENTORY 
    PRIMARY KEY (SKU)
;

CREATE UNIQUE INDEX IX1_INVENTORY ON E2E_INVENTORY
(
       UNIT_TYPE                      ,
       SKU                            
);

-- ALTER TABLE E2E_INVENTORY
--    ADD CONSTRAINT CC1_PRODUCT_PART
--    CHECK (  UNIT_TYPE in ( "PRODUCT", "PART"))
-- ;

ALTER TABLE E2E_PRODUCT_PART
       ADD  CONSTRAINT FK2_PRODUCT_PART
              FOREIGN KEY (PART_SKU)
                             REFERENCES E2E_INVENTORY (SKU)  
;

ALTER TABLE E2E_PRODUCT_PART
       ADD  CONSTRAINT FK1_PRODUCT_PART
              FOREIGN KEY (PRODUCT_SKU)
                             REFERENCES E2E_INVENTORY (SKU) 
;

CREATE TABLE WLI_ORDER (
    ORDER_ID VARCHAR(20) NOT NULL,
    ORDER_DATE VARCHAR2(128) NULL,
    CUSTOMER_ID VARCHAR(20) NULL,
    TRANSACTION_ID VARCHAR(25) NULL,
    STATUS VARCHAR(20) NULL,    
    SHIPPING_METHOD VARCHAR(40) NULL,
    SHIPPING_AMOUNT NUMERIC(16, 4) NULL,
    SHIPPING_CURRENCY VARCHAR(10) NULL,
    PRICE_AMOUNT NUMERIC(16, 4) NULL,
    PRICE_CURRENCY VARCHAR(10) NULL,
    SHIPPING_GEOCODE VARCHAR(2) NULL,
    SHIPPING_STREET1 VARCHAR(30) NULL,
    SHIPPING_STREET2 VARCHAR(30) NULL,
    SHIPPING_CITY VARCHAR(30) NULL,
    SHIPPING_STATE VARCHAR(40) NULL,
    SHIPPING_COUNTRY VARCHAR(40) NULL,
    SHIPPING_POBOX VARCHAR(30) NULL,
    SHIPPING_COUNTY VARCHAR(50) NULL,
    SHIPPING_POSTAL_CODE VARCHAR(10) NULL,
    SHIPPING_POSTAL_CODE_TYPE VARCHAR(10) NULL,
    SPECIAL_INSTRUCTIONS VARCHAR(254) NULL,
    SPLITTING_PREFERENCE VARCHAR(254) NULL,
    ORDER_SUBTOTAL NUMERIC(16, 4) NULL)
;
CREATE TABLE WLI_ORDER_LINE (
    ORDER_LINE_ID NUMERIC(15) NOT NULL,
    QUANTITY NUMERIC(16, 4) NULL,
    PRODUCT_ID VARCHAR(40) NULL,
    TAX_AMOUNT NUMERIC(16, 4) NULL,
    TAX_CURRENCY VARCHAR(10) NULL,
    SHIPPING_AMOUNT NUMERIC(16, 4) NULL,
    SHIPPING_CURRENCY VARCHAR(10) NULL,
    UNIT_PRICE_AMOUNT NUMERIC(16, 4) NULL,
    UNIT_PRICE_CURRENCY VARCHAR(10) NULL,
    MSRP_AMOUNT NUMERIC(16, 4) NULL,
    MSRP_CURRENCY VARCHAR(10) NULL,
    DESCRIPTION VARCHAR(254) NULL,
    ORDER_ID VARCHAR(20) NULL,
    TOTAL_LINE_AMOUNT NUMERIC(16, 4) NULL)
;

Insert into E2E_INVENTORY values ('pixlens1000','PART','Lens',14675,40000,15000, null, null)
;
Insert into E2E_INVENTORY values ('pixshut1000','PART','Shutter',38692,40000,15000, null, null)
;
Insert into E2E_INVENTORY values ('pixflas1000','PART','Flash',24150,40000,15000, null, null)
;
Insert into E2E_INVENTORY values ('pixchip1000','PART','Chip',35211,20000,10000, null, null)
;
Insert into E2E_INVENTORY values ('prolens5000','PART','Lens',4050,5000,1000, null, null)
;
Insert into E2E_INVENTORY values ('prosshut5000','PART','Shutter',3987,5000,1000, null, null)
;
Insert into E2E_INVENTORY values ('proflas5000','PART','Flash',2500,5000,1000, null, null)
;
Insert into E2E_INVENTORY values ('prochip5000','PART','Chip',830,5000,1000, null, null)
;
Insert into E2E_INVENTORY values ('camsens3000','PART','Imaging Sensor',18555,20000,10000, null, null)
;
Insert into E2E_INVENTORY values ('camlcds3000','PART','LCD Screen',9873,20000,10000, null, null)
;
Insert into E2E_INVENTORY values ('cammike3000','PART','Microphone',17433,20000,10000, null, null)
;
Insert into E2E_INVENTORY values ('cammmcd3000','PART','Multi Media Card',16801,20000,10000, null, null)
;
Insert into E2E_INVENTORY values ('950flextele','PART','Zoom Adjuster',842,5000,1000, null, null)
;
Insert into E2E_INVENTORY values ('862flextele','PART','Lens',4269,5000,1000, null, null)
;
Insert into E2E_INVENTORY values ('735flextele','PART','Cylinder',3688,5000,1000, null, null)
;
Insert into E2E_INVENTORY values ('607flextele','PART','Hood',4480,5000,1000, null, null)
;
Insert into E2E_INVENTORY values ('pix1000','PRODUCT','AviPix 1000 Digital Camera',7500,20000,10000, 'purch_process_step1_avi1000.gif', 'purch_process_step2_avipix1000.gif')
;
Insert into E2E_INVENTORY values ('pro5000','PRODUCT','AviPro 5000 Digital Camera',0,2000,500, null, null)
;
Insert into E2E_INVENTORY values ('cam3000','PRODUCT','AviCam 3000 Digital Camcorder',9067,10000,5000, null, null)
;
Insert into E2E_INVENTORY values ('cam1000','PRODUCT','AviCam 1000 Digital Camcorder',15083,20000,15000, null, null)
;
Insert into E2E_INVENTORY values ('cam5000','PRODUCT','AviCam 5000 Digital Camcorder',39366,40000,20000, null, null)
;
Insert into E2E_INVENTORY values ('connectusb','PRODUCT','USB Connector',38097,40000,3000, null, null)
;
Insert into E2E_INVENTORY values ('flexflash','PRODUCT','Flash',28955,40000,15000, null, null)
;
Insert into E2E_INVENTORY values ('flextele','PRODUCT','Lens',20289,25000,15000, null, null)
;
Insert into E2E_INVENTORY values ('flexwide','PRODUCT','Lens',37930,40000,15000, null, null)
;
Insert into E2E_INVENTORY values ('pack120','PRODUCT','AviPack 120',35416,40000,25000, null, null)
;
Insert into E2E_INVENTORY values ('pack50','PRODUCT','AviPack 50',21480,40000,15000, null, null)
;
Insert into E2E_INVENTORY values ('pack90','PRODUCT','AviPack 90',37513,40000,15000, null, null)
;
Insert into E2E_INVENTORY values ('pix3000','PRODUCT','AviPix 3000 Digital Camera',20564,25000,15000, 'purch_process_step1_avi3000.gif', 'purch_process_step2_avipix3000.gif' )
;
Insert into E2E_INVENTORY values ('pix5000','PRODUCT','AviPix 5000 Digital Camera',18811,40000,15000, 'purch_process_step1_avi5000.gif', 'purch_process_step2_avipix5000.gif' )
;
Insert into E2E_INVENTORY values ('print200','PRODUCT','AviPrint 200 Printer',23202,40000,15000, null, null)
;
Insert into E2E_INVENTORY values ('pro1000','PRODUCT','AviPro 1000 Digital Camera',28359,40000,24000, null, null)
;
Insert into E2E_INVENTORY values ('pro3000','PRODUCT','AviPro 3000 Digital Camera',15412,18000,15000, null, null)
;
Insert into E2E_INVENTORY values ('ram128','PRODUCT','AviRam 128 Memory Card',24718,40000,15000, null, null)
;
Insert into E2E_INVENTORY values ('pixlens3000','PART','Lens',13500,32000,12000, null, null)
;
Insert into E2E_INVENTORY values ('pixshut3000','PART','Shutter',30950,32000,12000, null, null)
;
Insert into E2E_INVENTORY values ('pixflas3000','PART','Flash',26750,35000,14000, null, null)
;
Insert into E2E_INVENTORY values ('pixchip3000','PART','Chip',18002,20000,11000, null, null)
;
Insert into E2E_INVENTORY values ('pixlens5000','PART','Lens',8000,17500,3000, null, null)
;
Insert into E2E_INVENTORY values ('pixshut5000','PART','Shutter',5500,10000,2500, null, null)
;
Insert into E2E_INVENTORY values ('pixchip5000','PART','Chip',8553,9750,1500, null, null)
;
Insert into E2E_PRODUCT_PART values ('pix3000','pixlens3000')
;
Insert into E2E_PRODUCT_PART values ('pix3000','pixshut3000')
;
Insert into E2E_PRODUCT_PART values ('pix3000','pixflas3000')
;
Insert into E2E_PRODUCT_PART values ('pix3000','pixchip3000')
;
Insert into E2E_PRODUCT_PART values ('pix5000','pixlens5000')
;
Insert into E2E_PRODUCT_PART values ('pix5000','pixshut5000')
;
Insert into E2E_PRODUCT_PART values ('pix5000','pixchip5000')
;
Insert into E2E_PRODUCT_PART values ('pix1000','pixlens1000')
;
Insert into E2E_PRODUCT_PART values ('pix1000','pixshut1000')
;
Insert into E2E_PRODUCT_PART values ('pix1000','pixflas1000')
;
Insert into E2E_PRODUCT_PART values ('pix1000','pixchip1000')
;
Insert into E2E_PRODUCT_PART values ('pro5000','prolens5000')
;
Insert into E2E_PRODUCT_PART values ('pro5000','prosshut5000')
;
Insert into E2E_PRODUCT_PART values ('pro5000','proflas5000')
;
Insert into E2E_PRODUCT_PART values ('pro5000','prochip5000')
;
Insert into E2E_PRODUCT_PART values ('cam3000','camsens3000')
;
Insert into E2E_PRODUCT_PART values ('cam3000','camlcds3000')
;
Insert into E2E_PRODUCT_PART values ('cam3000','cammike3000')
;
Insert into E2E_PRODUCT_PART values ('cam3000','cammmcd3000')
;
Insert into E2E_PRODUCT_PART values ('flextele','950flextele')
;
Insert into E2E_PRODUCT_PART values ('flextele','862flextele')
;
Insert into E2E_PRODUCT_PART values ('flextele','735flextele')
;
Insert into E2E_PRODUCT_PART values ('flextele','607flextele')
;

COMMIT;

