DROP TABLE DATA_SYNC_APPLICATION;

DROP TABLE DATA_SYNC_ITEM;

DROP TABLE DATA_SYNC_SCHEMA_URI;

DROP TABLE DATA_SYNC_VERSION;


CREATE TABLE DATA_SYNC_APPLICATION (
    APPLICATION_ID NUMERIC(15) NOT NULL,
    APPLICATION_NAME VARCHAR(100) NOT NULL,
    CREATION_DATE TIMESTAMP DEFAULT CURRENT_TIMESTAMP  NOT NULL,
    MODIFIED_DATE TIMESTAMP DEFAULT CURRENT_TIMESTAMP  NOT NULL)
;
CREATE TABLE DATA_SYNC_ITEM (
    DATA_SYNC_ITEM_ID NUMERIC(15) NOT NULL,
    APPLICATION_ID NUMERIC(15) NOT NULL,
    SCHEMA_URI_ID NUMERIC(15) NOT NULL,
    VERSION_MAJOR NUMERIC(15) NOT NULL,
    VERSION_MINOR NUMERIC(15) NOT NULL,
    ITEM_CHECKSUM NUMERIC(15) NOT NULL,
    ITEM_URI VARCHAR(254) NOT NULL,
    CREATION_DATE TIMESTAMP DEFAULT CURRENT_TIMESTAMP  NOT NULL,
    MODIFIED_DATE TIMESTAMP DEFAULT CURRENT_TIMESTAMP  NOT NULL,
    XML_CREATION_DATE TIMESTAMP NOT NULL,
    XML_MODIFIED_DATE TIMESTAMP NOT NULL,
    XML_DEFINITION CLOB(500K) NOT NULL,
    ITEM_AUTHOR VARCHAR(200) NULL,
    ITEM_NAME VARCHAR(100) NULL,
    ITEM_DESCRIPTION VARCHAR(254) NULL)
;
CREATE TABLE DATA_SYNC_SCHEMA_URI (
    SCHEMA_URI_ID NUMERIC(15) NOT NULL,
    SCHEMA_URI VARCHAR(254) NOT NULL,
    CREATION_DATE TIMESTAMP DEFAULT CURRENT_TIMESTAMP  NOT NULL,
    MODIFIED_DATE TIMESTAMP DEFAULT CURRENT_TIMESTAMP  NOT NULL)
;
CREATE TABLE DATA_SYNC_VERSION (
    VERSION_MAJOR NUMERIC(15) NOT NULL,
    VERSION_MINOR NUMERIC(15) NOT NULL,
    CREATION_DATE TIMESTAMP DEFAULT CURRENT_TIMESTAMP  NOT NULL,
    MODIFIED_DATE TIMESTAMP DEFAULT CURRENT_TIMESTAMP  NOT NULL,
    BUILD_NUMBER NUMERIC(15) NULL,
    VERSION_DESCRIPTION VARCHAR(30) NULL)
;


ALTER TABLE DATA_SYNC_APPLICATION
   ADD CONSTRAINT PK_SYNC_APP
   PRIMARY KEY (
      APPLICATION_ID
   )
;
ALTER TABLE DATA_SYNC_ITEM
   ADD CONSTRAINT PK_SYNC_ITEM
   PRIMARY KEY (
      DATA_SYNC_ITEM_ID
   )
;
ALTER TABLE DATA_SYNC_SCHEMA_URI
   ADD CONSTRAINT PK_SCHEMA_URI
   PRIMARY KEY (
      SCHEMA_URI_ID
   )
;
ALTER TABLE DATA_SYNC_VERSION
   ADD CONSTRAINT PK_SYNC_VERSION
   PRIMARY KEY (
      VERSION_MAJOR,
   VERSION_MINOR
   )
;
