@echo off
setlocal

CALL "..\..\..\portal\bin\win32\set-environment.bat"
SET WLP_HOME=%BEA_HOME%\weblogic700\portal
set WLS_USER=system
set WLS_PW=weblogic
set WLS_PROD_MODE=false

if not "%BEA_HOME%" == "" goto continue
echo Please define BEA_HOME in your environment...
exit

:continue

rem PLEASE DOCUMENT YOUR USAGE OF COMMAND LINE PARAMETERS
rem         (any order, case insensitive)
rem nodebug
rem special
rem drt
rem production
rem nolog
rem nopointbase
rem

rem Parse Command Line Parameters
rem

rem set default parameter values
rem
set debugFlag=true
set specialFlag=false
set drtFlag=false
set productionFlag=false
set loggingFlag=true
set pointbaseFlag=true
set profileFlag=false


FOR %%p IN (%*) DO CALL :SET_PARAM %%p
GOTO :CMD_LINE_DONE
    :SET_PARAM
    if /i "%1" == "nodebug" set debugFlag=false
    if /i "%1" == "special" set specialFlag=true
    if /i "%1" == "drt" set drtFlag=true
    if /i "%1" == "production" set productionFlag=true
    if /i "%1" == "nolog" set loggingFlag=false
    if /i "%1" == "nopointbase" set pointbaseFlag=false
    if /i "%1" == "profile" set profileFlag=true
    GOTO :EOF
:CMD_LINE_DONE


REM ###########################################################################
REM (c) 2002 BEA SYSTEMS INC. All rights reserved
REM
REM BEA WebLogic Platform startup script.
REM This script can also install/uninstall a Portal Window Service. Use the
REM -installService or -uninstallService command-line arguments.
REM ###########################################################################



REM ###########################################################################
REM Set the WebLogic server name
REM ###########################################################################
SET SERVER_NAME=
IF "%SERVER_NAME%"=="" SET SERVER_NAME=e2eServer

REM ###########################################################################
REM Set the WebLogic Admin Server URL, if this is a managed node.
REM Otherwise, leave this blank
REM ###########################################################################
set ADMIN_URL=

REM ###########################################################################
REM Set the database type
REM Valid values are: POINTBASE, ORACLE_THIN, MSSQL, SYBASE_JCONNECT, DB2_TYPE2
REM Set set-environment.bat for more details
REM ###########################################################################
SET DATABASE=POINTBASE

REM Try to get it from the db_settings.properties file
IF not exist .\db_settings.properties goto _setenv
SET DB_SETTINGS=.\db_settings.properties
FOR /F "eol=# tokens=1,2 delims==" %%i in (%DB_SETTINGS%) do  (
    if %%i == database SET DATABASE=%%j
)
:_setenv

REM ###########################################################################
REM Set the environment
REM See set-environment.bat for more details on the available parameters
REM ###########################################################################
CALL "%WLP_HOME%\bin\win32\set-environment.bat"


REM ###########################################################################
REM Set any additional CLASSPATH information
REM ###########################################################################

REM This includes configuration for WebLogic Workshop support
SET CLASSPATH=%WEBLOGIC_HOME%\lib\JDIProxy.jar;%WEBLOGIC_HOME%\lib\xalan.jar;%WEBLOGIC_HOME%\lib\xerces.jar;%WEBLOGIC_HOME%\lib\knex.jar;%WEBLOGIC_HOME%\..\common\lib\log4j.jar;%WEBLOGIC_HOME%\lib\webservices.jar;%CLASSPATH%

REM This includes configuration for WebLogic Portal support
SET CLASSPATH=%CLASSPATH%;%P13N_DIR%\lib\commerce_system.jar;%P13N_DIR%\lib\campaign_system.jar

REM This includes configuration for WebLogic Integration support
SET CLASSPATH=%CLASSPATH%;.\beaApps\e2eApp\data;%WEBLOGIC_HOME%\..\samples\platform\demoDomain\beaApps\e2eApp\e2e-system.jar
SET CLASSPATH=%CLASSPATH%;%WEBLOGIC_HOME%\..\integration\lib\wlicommon.jar;%WEBLOGIC_HOME%\..\integration\lib\wlai-mbean.jar;%WEBLOGIC_HOME%\..\integration\lib\wlai-server.jar;%WEBLOGIC_HOME%\..\integration\lib\wlai-client.jar;%WEBLOGIC_HOME%\..\integration\lib\wliserver.jar;%SVRCP%;%WEBLOGIC_HOME%\..\integration\lib\e2eUtils-wli.jar

set ARDIR=%WEBLOGIC_HOME%\lib

REM
REM Export a special class path so we can generate the client proxy JAR files
REM
set CLASSPATH=%CLASSPATH%;%ARDIR%\ant\ant.jar;%JDK_HOME%\jre\lib\rt.jar
set CLASSPATH=%CLASSPATH%;%ARDIR%\webserviceclient.jar;%ARDIR%\webserviceclient+ssl.jar

REM ##############################################################
REM Set the root demo domain dir as part of your classpath as well (for Pointbase Classes)
REM ##############################################################
SET CLASSPATH=.\;%CLASSPATH%

REM ###########################################################################
REM Start WebLogic with the above parameters.
REM See startWebLogic.cmd for more details on the available parameters.
REM ###########################################################################
set MEM_ARGS=-Xms128m -Xmx128m -XX:MaxPermSize=128m
set JAVA_OPTIONS=-Dcommerce.properties="%WLP_HOME%\weblogiccommerce.properties" -Dlog4j.configuration="file:knexLogCfg.xml"
set JAVA_OPTIONS=%JAVA_OPTIONS% -De2eSample.b2b.path.data=".\beaApps\e2eApp\data"
set JAVA_OPTIONS=%JAVA_OPTIONS% -Dlog4j.configuration=file:%WEBLOGIC_HOME%\..\common\lib\workshopLogCfg.xml -Dweblogic.security.SSL.ignoreHostnameVerify=true -Dweblogic.jws.ProductionMode=%productionFlag% -Dweblogic.jws.logging=%loggingFlag% -Dweblogic.security.SSL.trustedCAKeyStore="./cacerts" -Dweblogic.SystemDataStoreConfigDirectory="%WEBLOGIC_HOME%\lib"
set JAVA_VM=-hotspot

if not "%debugFlag%" == "true" goto skipDebug1
    set JAVA_DEBUG=-Xdebug -Xnoagent -Xrunjdwp:transport=dt_socket,address=8453,server=y,suspend=n -Djava.compiler=NONE
    if not "%specialFlag%" == "true" goto skipDebug1
        set JAVA_DEBUG=-Xdebug -Xnoagent -Xrunjdwp:transport=dt_socket,address=8453,server=y,suspend=n
        if not "%drtFlag%" == "true" goto skipDebug1
            set JAVA_DEBUG=-Xdebug -Xnoagent -Xrunjdwp:transport=dt_socket,address=8453,server=y,suspend=n -Dknex.BrowserDebugOnly=true
:skipDebug1


if "%1" == "-installService" goto _installService
if "%1" == "-uninstallService" goto _uninstallService


set PRE_CLASSPATH=%WEBLOGIC_HOME%\..\common\lib\log4j.jar;%ARDIR%\knex.jar;%ARDIR%\JDIProxy.jar

@echo ----------------------
@echo STARTING THE DEBUGGER 
@echo ----------------------
@REM 
@REM START THE DEBUGGER
@REM
if "%specialFlag%" == "true" goto skipDebug2
    if not "%debugFlag%" == "true" goto skipDebug2
        start "WebLogic Workshop Debugger..." /MIN %JDK_HOME%\bin\java -classpath %PRE_CLASSPATH%;%WEBLOGIC_HOME%\lib\weblogic.jar;%JDK_HOME%\lib\tools.jar JDIProxy.DbgMain
:skipDebug2


:_startWebLogic
call ".\startWebLogic.cmd"
goto _the_end

:_installService
call "%P13N_DIR%\bin\win32\installWebLogicService.cmd"
goto _the_end

:_uninstallService
call "%P13N_DIR%\bin\win32\uninstallWebLogicService.cmd"
goto _the_end

:_the_end
pause
ENDLOCAL
