package examples.e2e.i18n.logging;

import weblogic.logging.MessageLogger;
import weblogic.logging.Loggable;
import java.util.MissingResourceException;
 
/** 
 * Copyright (c) 2002 by BEA Systems, Inc. All Rights Reserved.
 * @exclude
 */
public class E2ESampleLogger
{
  /**
   * failed trying to obtain an InventoryProvider EJB
   * @exclude
   *
   * messageid:  999001
   * severity:   error
   */
  public static String failedAccessingInventoryEJB(Throwable arg0)  {
    Object [] args = { arg0 };
    MessageLogger.log(
	"999001",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999001";
  }




  /**
   * failed calling an InventoryProvider EJB
   * @exclude
   *
   * messageid:  999002
   * severity:   error
   */
  public static String failedCallingInventoryEJB(Throwable arg0)  {
    Object [] args = { arg0 };
    MessageLogger.log(
	"999002",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999002";
  }




  /**
   * failed trying to obtain a PurchaseManager EJB
   * @exclude
   *
   * messageid:  999003
   * severity:   error
   */
  public static String failedAccessingPurchaseEJB(Throwable arg0)  {
    Object [] args = { arg0 };
    MessageLogger.log(
	"999003",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999003";
  }




  /**
   * failed calling a PurchaseManager EJB
   * @exclude
   *
   * messageid:  999004
   * severity:   error
   */
  public static String failedCallingPurchaseEJB(Throwable arg0)  {
    Object [] args = { arg0 };
    MessageLogger.log(
	"999004",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999004";
  }




  /**
   * the InventoryProvider returned no products[ {0} ] for product id list[ {1} ]
   * @exclude
   *
   * messageid:  999005
   * severity:   warning
   */
  public static String noProductsReturned(String arg0, String arg1)  {
    Object [] args = { arg0, arg1 };
    MessageLogger.log(
	"999005",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999005";
  }




  /**
   * a ProcessingException was encountered in response to the following input[ {1} ]
   * @exclude
   *
   * messageid:  999006
   * severity:   error
   */
  public static String processorProcessingException(Throwable arg0, String arg1)  {
    Object [] args = { arg0, arg1 };
    MessageLogger.log(
	"999006",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999006";
  }




  /**
   * a RuntimeException was encountered in response to the following input[ {1} ]
   * @exclude
   *
   * messageid:  999007
   * severity:   error
   */
  public static String processorRuntimeException(Throwable arg0, String arg1)  {
    Object [] args = { arg0, arg1 };
    MessageLogger.log(
	"999007",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999007";
  }




  /**
   * an invalid product id[ {0} ] was encountered in the request
   * @exclude
   *
   * messageid:  999008
   * severity:   error
   */
  public static String invalidProductId(String arg0)  {
    Object [] args = { arg0 };
    MessageLogger.log(
	"999008",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999008";
  }




  /**
   * the product id[ {0} ] delivered with the request was not found in the list of products[ {1} ]
   * @exclude
   *
   * messageid:  999009
   * severity:   error
   */
  public static String productIdNotFound(String arg0, String arg1)  {
    Object [] args = { arg0, arg1 };
    MessageLogger.log(
	"999009",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999009";
  }




  /**
   * a product was expected in the session for this application state[ {0} ]
   * @exclude
   *
   * messageid:  999010
   * severity:   error
   */
  public static String noProductInSession(String arg0)  {
    Object [] args = { arg0 };
    MessageLogger.log(
	"999010",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999010";
  }




  /**
   * the InventoryProvider returned no parts[ {0} ] for product id[ {1} ]
   * @exclude
   *
   * messageid:  999011
   * severity:   warning
   */
  public static String noPartsReturned(String arg0, String arg1)  {
    Object [] args = { arg0, arg1 };
    MessageLogger.log(
	"999011",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999011";
  }




  /**
   * the QPA timeout has been set to [ {0} ] seconds
   * @exclude
   *
   * messageid:  999012
   * severity:   info
   */
  public static String qpaTimeoutInfo(long arg0)  {
    Object [] args = { new Long(arg0) };
    MessageLogger.log(
	"999012",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999012";
  }




  /**
   * the session data[ product id( {0} ), part id( {1} ) ] is invalid for entering a QPA
   * @exclude
   *
   * messageid:  999013
   * severity:   error
   */
  public static String partSelectedIllegalState(String arg0, String arg1)  {
    Object [] args = { arg0, arg1 };
    MessageLogger.log(
	"999013",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999013";
  }




  /**
   * the part id[ {0} ] delivered with the request was not found in the list of parts[ {1} ]
   * @exclude
   *
   * messageid:  999014
   * severity:   error
   */
  public static String partIdNotFound(String arg0, String arg1)  {
    Object [] args = { arg0, arg1 };
    MessageLogger.log(
	"999014",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999014";
  }




  /**
   * the part id did not exist in the session when submitting the QPA
   * @exclude
   *
   * messageid:  999015
   * severity:   error
   */
  public static String submitQpaIllegalState()  {
    Object [] args = {  };
    MessageLogger.log(
	"999015",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999015";
  }




  /**
   * the current portlet event[ {1} ] is invalid for a session in this state[ {0} ]
   * @exclude
   *
   * messageid:  999016
   * severity:   error
   */
  public static String invalidStateInQuoteProcessor(String arg0, String arg1)  {
    Object [] args = { arg0, arg1 };
    MessageLogger.log(
	"999016",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999016";
  }




  /**
   * the quote id[ {0} ] is invalid
   * @exclude
   *
   * messageid:  999017
   * severity:   error
   */
  public static String invalidQuoteId(String arg0)  {
    Object [] args = { arg0 };
    MessageLogger.log(
	"999017",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999017";
  }




  /**
   * no quotes existed in the session when this request event[ {1} ] was encountered in this session state[ {0} ]
   * @exclude
   *
   * messageid:  999018
   * severity:   error
   */
  public static String quotesDoNotExist(String arg0, String arg1)  {
    Object [] args = { arg0, arg1 };
    MessageLogger.log(
	"999018",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999018";
  }




  /**
   * the quote id[ {0} ] was not found in the list of quotes[ {1} ]
   * @exclude
   *
   * messageid:  999019
   * severity:   error
   */
  public static String quoteNotFound(String arg0, String arg1)  {
    Object [] args = { arg0, arg1 };
    MessageLogger.log(
	"999019",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999019";
  }




  /**
   * no quotes have been received since the QPA was submitted at {0}
   * @exclude
   *
   * messageid:  999020
   * severity:   error
   */
  public static String quoteTimedOut(String arg0)  {
    Object [] args = { arg0 };
    MessageLogger.log(
	"999020",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999020";
  }




  /**
   * the purchase order timeout has been set to [ {0} ] seconds
   * @exclude
   *
   * messageid:  999021
   * severity:   info
   */
  public static String poTimeoutInfo(long arg0)  {
    Object [] args = { new Long(arg0) };
    MessageLogger.log(
	"999021",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999021";
  }




  /**
   * no quote existed in the session during the handling of this event[ {0} ]
   * @exclude
   *
   * messageid:  999022
   * severity:   error
   */
  public static String submitPoNoQuote(String arg0)  {
    Object [] args = { arg0 };
    MessageLogger.log(
	"999022",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999022";
  }




  /**
   * failed parsing static purchase orders[ {0} ]
   * @exclude
   *
   * messageid:  999023
   * severity:   error
   */
  public static String staticPOParsingException(Throwable arg0)  {
    Object [] args = { arg0 };
    MessageLogger.log(
	"999023",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999023";
  }




  /**
   * failed parsing the current purchase order[ {0} ]
   * @exclude
   *
   * messageid:  999024
   * severity:   error
   */
  public static String dynamicPOParsingException(Throwable arg0)  {
    Object [] args = { arg0 };
    MessageLogger.log(
	"999024",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999024";
  }




  /**
   * failed parsing quotes[ {0} ]
   * @exclude
   *
   * messageid:  999025
   * severity:   error
   */
  public static String quoteParsingException(Throwable arg0)  {
    Object [] args = { arg0 };
    MessageLogger.log(
	"999025",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999025";
  }




  /**
   * ecountered exception trying to obtain the value of the system property [ {1} ] to determine the data location for the B2B portal
   * @exclude
   *
   * messageid:  999026
   * severity:   error
   */
  public static String exceptionDeterminingDataLocation(Throwable arg0, String arg1)  {
    Object [] args = { arg0, arg1 };
    MessageLogger.log(
	"999026",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999026";
  }




  /**
   * the path to the XML data may not be null, set the system property[ {0} ] appropriately
   * @exclude
   *
   * messageid:  999027
   * severity:   error
   */
  public static String nullDataLocation(String arg0)  {
    Object [] args = { arg0 };
    MessageLogger.log(
	"999027",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999027";
  }




  /**
   * unable to delete file[ {0} ], for unknown reason
   * @exclude
   *
   * messageid:  999028
   * severity:   warning
   */
  public static String deleteFailureUnknown(String arg0)  {
    Object [] args = { arg0 };
    MessageLogger.log(
	"999028",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999028";
  }




  /**
   * unable to delete file[ {0} ]
   * @exclude
   *
   * messageid:  999029
   * severity:   warning
   */
  public static String deleteFailureException(String arg0, Throwable arg1)  {
    Object [] args = { arg0, arg1 };
    MessageLogger.log(
	"999029",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999029";
  }




  /**
   * unable to perform delete, the path specified[ {0} ] does not refer to a file
   * @exclude
   *
   * messageid:  999030
   * severity:   warning
   */
  public static String deleteNotAFile(String arg0)  {
    Object [] args = { arg0 };
    MessageLogger.log(
	"999030",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999030";
  }




  /**
   * the path to the data files is configured to be [ {0} ]
   * @exclude
   *
   * messageid:  999031
   * severity:   info
   */
  public static String dataLocationInfo(String arg0)  {
    Object [] args = { arg0 };
    MessageLogger.log(
	"999031",
	args,
	"examples.e2e.i18n.logging.E2ESampleLogLocalizer");
    return "999031";
  }





}
